#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, t;
    cin >> n >> t;
    vll a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    ll steps = 0;
    while(true)
    {
        steps++;
        vll newA(n);
        newA[0] = a[0];
        newA[n - 1] = a[n - 1];

        for(int i = 1; i < n - 1; i++)
        {
            multiset<ll> st;
            st.insert(a[i - 1]);
            st.insert(a[i]);
            st.insert(a[i + 1]);

            st.erase(st.begin());
            newA[i] = *st.begin();
        }
        if(a == newA)
            break;
        a = newA;
    }
    steps--;
    cout << steps << endl;
    if(t == 0)
        return 0;
    for(int i = 0; i < a.size(); i++)
        cout << a[i] << " ";
    return 0;
}