#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int median(int a, int b, int c)
{
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	if (a > b)
		swap(a, b);

	return b;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, t = 0;
	cin >> n >> t;
	vector <int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	int years = 0;
	while (true)
	{
		vector <int> b(n);
		b[0] = a[0];
		b.back() = a.back();

		bool swapped = false;
		for (int i = 1; i < n - 1; ++i)
		{
			b[i] = median(a[i - 1], a[i], a[i + 1]);
			if (a[i] != b[i])
				swapped = true;
		}

		if (!swapped)
			break;
		swap(a, b);
		++years;
	}

	cout << years << '\n';
	if (t)
		for (int x : a)
			cout << x << ' ';

	return 0;
}