#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 2e5+10;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    string s; cin >> s;
    vector <int> pref(n);
    vector <int> zer;
    For (i, n) {
        int ws = (i ? pref[i-1] : 0LL);
        pref[i] = ws;
        if (s[i] == ')')
            pref[i]--;
        else
            pref[i]++;
        if (!pref[i]) zer.push_back(i);
    }
    if (pref[n-1]) {
        cout << "-1\n"; return 0;
    }
    int idx = 0;
    int ans = 0;
    while (idx < n) {
        if (pref[idx] >= 0) {idx++; continue;}
        int ni = *lower_bound(zer.begin(), zer.end(), idx);
        ans += ni - idx+1;
        idx = ni+1;
    }
    cout << ans << endl;
}
