#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n;

const int MAX_N = 5e5 + 10;


int median(int a, int b, int c) {
    vector<int> v = {a, b, c};
    sort(v.begin(), v.end());
    return v[1];
}


int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    int t;
    cin >> t;
    vector<int> a(n);
    vector<int> newA(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = 0;
    bool ch = true;
    while (ch) {
        ch = false;
        newA[0] = a[0];
        newA[n - 1] = a[n - 1];
        for (int i = 1; i < n - 1; i++) {
            newA[i] = median(a[i - 1], a[i], a[i + 1]);
        }
        for (int i = 0; i < n; i++) {
            if (a[i] != newA[i]) {
                ch = true;
            }
        }
        a.swap(newA);
        if (ch) {
            ans++;
        }
    }
    cout << ans << '\n';
    if (t == 1) {
        for (int i = 0; i < n; i++) {
            cout << newA[i] << " ";
        }
        cout << "\n";
    }

    return 0;
}