#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

int middle(int a, int b, int c) {
	if ((a >= b && a <= c) || (a >= c && a <= b)) return a;
	if ((b >= a && b <= c) || (b >= c && b <= a)) return b;
	return c;
}

int main() {
	int n, t;
	cin >> n >> t;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector <int> b = a;
	unordered_set <int> s;
	for (int i = 1; i < n - 1; i++) 
		if (a[i] != middle(a[i - 1], a[i], a[i + 1]))
			s.insert(i);
	int cnt = 0;
	while (!s.empty()) {
		for (int pos : s) 
			b[pos] = middle(a[pos - 1], a[pos], a[pos + 1]);
		unordered_set <int> x;
		for (int pos : s)
			a[pos] = b[pos];
		for (int pos : s) {
			if (pos - 1 > 0 && a[pos - 1] != middle(a[pos - 1], a[pos], a[pos - 2]))
				x.insert(pos - 1);
			if (pos + 1 < n - 1 && a[pos + 1] != middle(a[pos], a[pos + 1], a[pos + 2]))
				x.insert(pos + 1);
		}
		swap(s, x);
		cnt++;
	}
	cout << cnt << endl;
	if (t == 1) for (int i = 0; i < n; i++) cout << a[i] << " ";
	return 0;
}