//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, t;
vector<int> a, b;

void solve() {
    cin >> n >> t;
    a.resize(n);
    b.resize(n);

    for (auto &i: a) cin >> i;

    if (n == 1) {
        cout << 0 nl;
        if (t) {
            for (auto &i: a) cout << i sq;
            cout nl;
        }
        return;
    }

    if (n == 2) {
        cout << (a[0] > a[1] ? 1 : 0) nl;
        sort(a.begin(), a.end());
        if (t) {
            for (auto &i: a) cout << i sq;
            cout nl;
        }
        return;
    }

    bool flag = true;
    int ans = 0;

    int l = 1, r = n - 2;

    while(flag) {
        flag = false;
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        multiset<int> s = {a[l - 1], a[l], a[l + 1]};
        int l2 = 1e9, r2 = -1;

        //cout << "l, r" sp l sp r nl;

        for (int i = l; i <= r; ++i) {
            b[i] = *(++s.begin());
            s.erase(s.find(a[i - 1]));
            s.insert(a[i + 2]);
            if (b[i] != a[i]) {
                flag = true;
                l2 = min(l2, i);
                r2 = max(r2, i);
            }
        }

        ans += flag;
        swap(a, b);
        if (flag) {
            l = l2, r = r2;
        }
    }

    cout << ans nl;
    if (t) {
        for (auto &i: a) {
            cout << i sq;
        } cout nl;
    }
}
