#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <iostream>
//#include <set>
//#include <map>
#include <vector>
//#include <unordered_set>
//#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
//#include <queue>
//#include <utility>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

size_t const ALLOC_MEM_CNT = 216 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_CNT];
size_t ALLOC_POS = ALLOC_MEM_CNT;

using ll = long long;
#define all(c) c.begin(),c.end()

int clamp(int a, int b, int c) {
    vector<int> t = {a, b, c};
    sort(all(t));
    return t[1];
}

// using xll = __int128;
void _tmain([[maybe_unused]] int test_id) {
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    for (int &x : a) { cin >> x; }
    int cnt = 0;
    vector<int> f;
    for (int i = 1; i < n - 1; ++i) {
        f.push_back(i);
    }
    while (true) {
        vector<int> b(n);
        b = a;
        vector<int> nf;
        for (int i: f) {
            b[i] = clamp(a[i - 1], a[i], a[i + 1]);
            if (b[i] != a[i]) {
                nf.push_back(i);
            }
        }
        if (nf.size()) {
            ++cnt;
            a = b;
           // prev = nf;
            f = nf;
        } else {
            break;
        }
    }
    cout << cnt << "\n";
    if (t) {
        for (int x : a) {
            cout << x << " ";
        }
        cout << "\n";
    }
}