#include <bits/stdc++.h>

using namespace std;

#define int long long
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i,n,m) for(int i = n; i<m; ++i)
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define sc second
#define fr first

struct pol_has
{
    const int P1 = 31, P2 = 53, MOD1 = 1e9 + 7, MOD2 = 1e9 + 53;
    vector <int> st1, st2, has1, has2;
    pol_has(string s)
    {
        int n = s.size();
        st1.resize(n, 1), st2.resize(n, 1), has1.resize(n, 0), has2.resize(n, 1);
        FOR(i, 1, n + 1) st1[i] = (st1[i - 1] * P1) % MOD1;
        FOR(i, 1, n + 1) st2[i] = (st2[i - 1] * P2) % MOD2;

        FOR(i, 1, n + 1) has1[i] = ((has1[i - 1] * P1) % MOD1 + s[i-1] - 'a' + 1 + MOD1) %MOD1;
        FOR(i, 1, n + 1) has2[i] = ((has2[i - 1] * P2) % MOD2 + s[i-1] - 'a' + 1 + MOD2) %MOD2;
    }
    int get_has(int l, int r)
    {
        int a = (has1[r + 1] - (has1[l] * st1[r - l + 1]) % MOD1 + 10 * MOD1)%MOD1;
        int b = (has2[r + 1] - (has2[l] * st2[r - l + 1]) % MOD2 + 10 * MOD2)%MOD2;
        return a * MOD2 + b;
    }
};

vector <int> z_func(string s)
{
    int n = s.size();
    vector <int> z(n);
    for(int i = 1, l = 0, r = 0; i<n; ++i)
    {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[z[i]] == s[i + z[i]])
            ++z[i];
        if (i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

struct node
{
    int l,r;
    int mx;
    int ch = 0;
};

vector <node> tree;

void push(int v)
{
    if (tree[v].l != tree[v].r)
    {
        tree[v * 2].ch += tree[v].ch;
        tree[v * 2 + 1].ch += tree[v].ch;
    }
    tree[v].mx += tree[v].ch;
    tree[v].ch = 0;
}

void build(int v, int l, int r)
{
    tree[v].l = l, tree[v].r = r;
    if (l == r)
    {
        //tree[v].mx =
    }
    int mid = (l + r)/2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);
    tree[v].mx = max(tree[v * 2].mx, tree[v * 2 + 1].mx);
}

int get_max(int v, int l, int r)
{
    if (tree[v].l > r || tree[v].r < l) return -1e9;
    if (tree[v].l >= l || tree[v].r <= r) return tree[v].mx;
    return max(get_max(v * 2, l, r), get_max(v * 2 + 1, l, r));
}

void upd(int v, int l, int r, int val)
{
    push(v);
    if (tree[v].l > r || tree[v].r < l) return;
    if (tree[v].l >= l || tree[v].r <= r) return;
    {
        tree[v].ch += val;
        push(v);
        return;
    }
    upd(v * 2, l, r, val);
    upd(v * 2 + 1, l, r, val);
    tree[v].mx = max(tree[v * 2].mx, tree[v * 2 + 1].mx);
}

int med(int a, int b, int c)
{
    if (a > b) swap(a,b);
    if (b > c) swap(b,c);
    if (a > b) swap(a, b);
    return b;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t = 1;
    while(t--)
    {
        int n,k;
        cin >> n >> k;
        vector <int> vec(n);
        loop(i,n) cin >> vec[i];
        for(int ans = 0; ans <= 1e4; ++ans)
        {
            int ch = 0;
            vector <int> pob(n);
            pob[0] = vec[0], pob.back() = vec.back();
            FOR(i, 1, n - 1) {
                pob[i] = med(vec[i - 1], vec[i], vec[i + 1]);
                if (pob[i] != vec[i]) ++ch;
            }
            //loop(i, n) cout << pob[i] << ' ';
            //cout << endl;
            if (ch == 0)
            {
                cout  << ans << endl;
                if (k == 1)
                    loop(i, n) cout << pob[i] << ' ';

                return 0;
            }
            swap(vec, pob);
        }
    }
}
