#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int med(int a, int b, int c) {
    return a + b + c - min({a, b, c}) - max({a, b, c});
}

int main() {
    int n, t;
    cin >> n >> t;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (line.size() == 1) {
        if (t == 0)
            cout << 0 << endl;
        else
            cout << 0 << endl << line[0] << endl;
    }

    bool chan = true;
    int c = 0;
    while (chan) {
        chan = false;
        vector <int> new_line = line;
        for (int i = 1; i < n - 1; i++) {
            new_line[i] = med(line[i - 1], line[i], line[i + 1]);
            if (new_line[i] != line[i])
                chan = true;
        }
        if (chan)
            c++;
        line = new_line;
    }
    cout << c << endl;
    if (t == 1) {
        for (int i : line)
            cout << i << " ";
        cout << endl;
    }
    return 0;
}
