#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 5e5 + 5;

mt19937 mt(313);
int rng(int l, int r)
{
    return mt() % (r - l + 1) + l;
}

int median(vector <int> &t)
{
    assert(t.size() == 3);
    sort(t.begin(), t.end());
    return t[1];
}

bool proceed(vector <int> &v)
{
    int n = (int)v.size();
    vector <int> new_v(n);
    new_v[0] = v[0], new_v[n - 1] = v[n - 1];

    bool finished = true;
    for(int i = 1; i < n - 1; i++)
    {
        vector <int> temp(3);
        temp[0] = v[i - 1]; temp[1] = v[i]; temp[2] = v[i + 1];
        new_v[i] = median(temp);
        if(new_v[i] != v[i])
            finished = false;
    }

    v = new_v;
    return (!finished);
}

int n, type;
vector <int> v;

void gen_test()
{
    n = rng(20, 30);
    n = (int)(5e5);
    v.resize(n);
    for(int i = 0; i < n; i++)
        v[i] = rng(1, (int)1e9);
}

int solve()
{
    int ans = 0;
    while(proceed(v))
        ans++;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

//    for(int it = 1; it <= 20; it++)
//    {
//        gen_test();
//        cerr << solve() << endl;
//    }

    cin >> n >> type;
    v.resize(n);
    for(int i = 0; i < n; i++)
        cin >> v[i];

    cout << solve() << endl;
    if(type == 1)
    {
        for(int x: v)
            cout << x << ' ';
        cout << endl;
    }

    return 0;
}
