#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

inline int get(int a, int b, int c) {
  int d[3];
  d[0] = a, d[1] = b, d[2] = c;
  sort(d, d + 3);
  return d[1];
}

mt19937 gen;
void run() {
  gen.seed(time(0));
  int n, t;
  cin >> n >> t;
  vector<int> a(n);
 /* for(int &x : a) {
    x = gen() % 20;
  }*/
  for(int &x : a) cin >> x;
  int ans = 0;
  vector<int> cur(n - 2);
  vector<int> nw(n);
  iota(all(cur), 1);
  while (!cur.empty()) {
    ++ans;
    for(int i = 0; i < size(cur);) {
      int x = cur[i];
      nw[x] = get(a[x - 1], a[x], a[x + 1]);
      if (nw[x] == a[x]) {
        swap(cur.back(), cur[i]);
        cur.pop_back();
      } else {
        i++;
      }
    }
    for(int x : cur) {
      a[x] = nw[x];
    }
  }
  cout << ans - 1 << '\n';
  if (t) {
    for(int x : a) {
      cout << x << ' ';
    }
  }
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  run();
}
