#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


vector<int> a;


bool sim(int l, int r) {
    vector<int> nv(r - l - 2);
    for (int i = l + 1; i < r - 1; ++i) {
        vector<int> vs = { a[i - 1], a[i], a[i + 1] };
        sort(vs.begin(), vs.end());

        nv[i - l - 1] = vs[1];
    }

    bool res = false;
    for (int i = l + 1; i < r - 1; ++i) {
        if (a[i] != nv[i - l - 1]) {
            res = true;
        }

        a[i] = nv[i - l - 1];
    }

    return res;
}


int solve(int l, int r) {
    if (r - l < 3) {
        return 0;
    }

    /*
    int maxv = 0;
    for (int i = l; i < r; ++i) {
        if (a[i] > maxv) {
            maxv = a[i];
        }
    }
    */

    for (int i = l; i < r - 1; ++i) {
        if (a[i] == a[i + 1]) {
            return max(solve(l, i + 1), solve(i + 1, r));
        }
    }

    if (!sim(l, r)) {
        return 0;
    }

    return 1 + solve(l, r);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, t;
    cin >> n >> t;

    a.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cout << solve(0, n) << '\n';

    if (t == 1) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
    }

    return 0;
}
