#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5e5 + 5;

int a[maxn];
int nw[maxn];
int n, t;

inline int median(int x, int y, int z) {
    if (x <= y && x <= z)
        return min(y, z);
    else if (y <= x && y <= z)
        return min(x, z);
    else
        return min(x, y);
}

int res[maxn];
int c2;

inline void proc2(int l, int r) {
    int cc = (r - l) / 2;
    for (int i = l; i <= (l + r) / 2; i++)
        res[i] = a[l];
    for (int i = (l + r) / 2 + 1; i <= r; i++)
        res[i] = a[r];
    c2 = max(c2, cc);
}

void source_pz2() {
    int st = 1;
    for (int i = 2; i <= n + 1; i++) {
        if (i == n + 1 || a[i] == a[i - 1]) {
            proc2(st, i - 1);

            st = i;
        }
    }
    cout << c2 << "\n";
    if (t) {
        for (int i = 1; i <= n; i++) {
            cout << res[i] << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    cin >> n >> t;
    bool pz2 = true;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pz2 &= (a[i] <= 2);
    }
    if (pz2) {
        source_pz2();
        return 0;
    }
    ll c = 0;
    while (true) {
        for (int i = 2; i < n; i++) {
            nw[i] = median(a[i - 1], a[i], a[i + 1]);
        }
        bool changed = false;
        for (int i = 2; i < n; i++) {
            if (a[i] != nw[i]) {
                changed = true;
                a[i] = nw[i];
            }
        }
        /*for (int i = 1; i <= n; i++) {
            cerr << a[i] << " ";
        }
        cerr << "\n";*/
        if (!changed)
            break;
        c++;
    }
    cout << c << "\n";
    if (t) {
        for (int i = 1; i <= n; i++) {
            cout << a[i] << " ";
        }
    }
    return 0;
}
