#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0); 
}

//#define int ll

inline void solve() {
	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int cnt = -1;
	while (1) {
		vector<int> new_a(n);
		new_a[0] = a[0];
		new_a.back() = a.back();
		for (int i = 1; i + 1 < n; i++) {
			int q = a[i - 1], w = a[i], e = a[i + 1];
			new_a[i] = q + w + e - max(max(q, w), e) - min(min(q, w), e);
		}
		cnt++;
		if (a == new_a) {
			break;
		}
		a = new_a;
	}
	cout << cnt << nl;
	if (t) {
		for (auto t : a) {
			cout << t << ' ';
		}
	}
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}