#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);

const int N = 500'000;

int n, t;

vector<int> a, b;

int median(int& a, int& b, int& c) {
    if (a <= b && a >= c)
        return a;
    if (a <= c && a >= b)
        return a;
    if (b <= a && b >= c)
        return b;
    if (b <= c && b >= a)
        return b;
    if (c <= b && c >= a)
        return c;
    if (c <= a && c >= b)
        return c;
}

bool f() {
    b[0] = a[0];
    b.back() = a.back();
    for (int i = 1; i < n - 1; i++) {
        b[i] = median(a[i - 1], a[i], a[i + 1]);
    }
    swap(a, b);
    return a == b;
}

void solve1() {
    int cnt = 0;
    while (!f()) {
        cnt++;
    }
    cout << cnt << endl;
    if (t) {
        for (auto i : a)
            cout << i << " ";
    }
    exit(0);
}

vector<int> upd_s2;

bool get_upd2() {
    for (int i = 1; i < n - 1; i++) {
        if (a[i] == a[i - 1]) {
            continue;
        }
        if (a[i] == a[i + 1]) {
            continue;
        }
        if (a[i] <= a[i + 1] && a[i] >= a[i - 1]) {
            continue;
        }
        if (a[i] <= a[i - 1] && a[i] >= a[i + 1]) {
            continue;
        }
        upd_s2.push_back(i);
    }
    return !upd_s2.empty();
}

void solve2() {
    b = a;
    get_upd2();
    vector<int> up;
    int cnt = 0;
    while (!upd_s2.empty()) {
        vector<pair<int, int>> v;
        //b = a;
        cnt++;
        up.clear();
        for (auto i : upd_s2) {
            b[i] = median(a[i - 1], a[i], a[i + 1]);
            v.emplace_back(i, b[i]);
        }
        for (auto p : v) {
            a[p.first] = p.second;
        }
        //swap(a, b);
        for (auto i : upd_s2) {
            itn j = i;
            bool f = true;
            if (j == 0)
                f = false;
            if (j == n - 1)
                f = false;
            if (f && a[j] == a[j - 1])
                f = false;
            if (f && a[j] == a[j + 1])
                f = false;
            if (f && a[j] <= a[j + 1] && a[j] >= a[j - 1])
                f = false;
            if (f && a[j] <= a[j - 1] && a[j] >= a[j = 1])
                f = false;
            if(f)
                up.push_back(j);
            f = true;
            j--;
            if (j == 0)
                f = false;
            if (j == n - 1)
                f = false;
            if (f && a[j] == a[j - 1])
                f = false;
            if (f && a[j] == a[j + 1])
                f = false;
            if (f && a[j] <= a[j + 1] && a[j] >= a[j - 1])
                f = false;
            if (f && a[j] <= a[j - 1] && a[j] >= a[j = 1])
                f = false;
            if (f)
                up.push_back(j);
            f = true;
            j += 2;
            if (j == 0)
                f = false;
            if (j == n - 1)
                f = false;
            if (f && a[j] == a[j - 1])
                f = false;
            if (f && a[j] == a[j + 1])
                f = false;
            if (f && a[j] <= a[j + 1] && a[j] >= a[j - 1])
                f = false;
            if (f && a[j] <= a[j - 1] && a[j] >= a[j = 1])
                f = false;
            if (f)
                up.push_back(j);
        }
        swap(up, upd_s2);
    }
    cout << cnt << endl;
    if (t) {
        for (auto i : a)
            cout << i << " ";
    }
    exit(0);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
    ///--------------------------------------------------------///
    cin >> n >> t;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    //if (n <= 1000)
    //    solve1();
    solve2();
    ///--------------------------------------------------------///
}