#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <string>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

int n, a[500000];
bool t;

void stupid_solve_for_a_2()
{
	vector <pair <int, int>> v;
	for(int i = 0; i < n; i++)
		if (a[i] != a[i + 1])
		{
			int l = i, r = i;
			while (r + 2 < n && a[r + 1] != a[r + 2])
				r++;
			v.pb(mp(l, r));
			i = r;
		}
		else
			while (i + 1 < n && a[i + 1] == a[i])
				i++;
	int ans = 0;
	for (auto p : v)
	{
		int l = p.first, r = p.second, res = 0;
		while (l <= r)
		{
			a[l] = a[l - 1];
			a[r] = a[r + 1];
			res++;
			l++;
			r--;
		}
		if (l == r)
		{
			assert(a[l - 1] == a[r + 1]);
			a[l] = a[l - 1];
		}
		ans = max(ans, res);
	}
	cout << ans << '\n';
	if (t)
		for (int i = 1; i < n - 1; i++)
			cout << a[i] << ' ';
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> t;
	bool ch = true;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		ch &= (a[i] <= 2);
	}
	a[0] = a[1];
	a[n + 1] = a[n];
	n += 2;
	if (ch)
		stupid_solve_for_a_2();
	return 0;
}
