#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

int n, t;
vector<int> ar;

void solve1()
{
	vector<int> ar2(n, 0);
	int ans = 0;
	while (true)
	{
		int cnt = 0;
		vector<int> ar3;
		ar2[0] = ar[0];
		ar2[n - 1] = ar[n - 1];
		for (int i = 1; i < n - 1; ++i)
		{
			ar3 = {ar[i - 1], ar[i], ar[i + 1]};
			sort(ar3.begin(), ar3.end());
			if (ar[i] != ar3[1])
				cnt = 1;
			ar2[i] = ar3[1];
		}
		ar = ar2;
		if (cnt == 0)
			break;
		ans++;
	}
	cout << ans << endl;
	if (t == 1)
	{
	for (int i = 0; i < ar.size(); ++i)
		cout << ar[i] << " ";
	}
}

void solve2()
{
	int l = 0;
	int i = 1;
	vector<int> ar2(n, 0);
	int ans = 0;
	while (l != n)
	{
		int perp = 0;
		while (i != n - 1 && ar[i] != ar[i - 1])
		{
			++i;
		}
		int r = i;
		ar2[r] = ar[r];
		if (i == n - 1)
			perp = 1;
		if (ar[i] == ar[i - 1])
			r = i - 1;
		ans += (r - l) / 2;
		if (ar[l] == ar[r])
		{
			for (int j = l; j <= r; ++j)
			{
				ar2[j] = ar[l];
			}
		}
		else
		{
			int j1 = l;
			int j2 = r;
			while (j2 > j1)
			{
				ar2[j2] = ar[r];
				ar2[j1] = ar[l];
				j2--;
				j1++;
			}
			if (j2 == j1)
			{
				ar2[j2] += ((r - l) / 2 - 1);
				if (ar2[j2] % 2 == 0)
					ar2[j2] = 2;
				else
					ar2[j2] = 1;
			}
		}
		l = i;
		i++;
		if (perp == 1)
			break;
	}
	cout << ans << endl;
	if (t == 1)
	{
		for (int i = 0; i < n; ++i)
			cout << ar2[i] << " ";
	}
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> n >> t;
	ar = vector<int>(n, 0);
	int per = 0;
	for (int i = 0; i < n; ++i){
		cin >> ar[i];
		if (ar[i] > 2)
			per = 1;
	}
	if (per == 1)
		solve1();
	else
		solve2();
}