#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int median(int a, int b, int c) {
	vector <int> arr = { a, b, c };
	sort(arr.begin(), arr.end());
	return arr[1];
}

void solve() {
	int n, t;
	cin >> n >> t;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	vector <int> changed(n);
	for (int i = 0; i < n; ++i) changed[i] = i;
	int ans = 0;
	while (1) {
		vector <int> changed2, val;

		for (auto& i : changed) {
			for (int j = max(i - 2, 0ll); j + 2 < n && j <= i; ++j) {
				if (a[j + 1] != median(a[j], a[j + 1], a[j + 2])) {
					changed2.push_back(j + 1);
					val.push_back(median(a[j], a[j + 1], a[j + 2]));
				}
			}
		}
		if (changed2.size() == 0) {
			cout << ans << "\n";
			if (t == 1) {
				for (auto& i : a) cout << i << " ";
			}
			return;
		}
		else {
			++ans;
			changed = changed2;
			for (int i = 0; i < changed.size(); ++i) {
				a[changed[i]] = val[i];
			}
			
		}
	}
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}