#include<bits/stdc++.h>



typedef int  ll;
typedef long double ld;

using namespace std;


#define pll pair<ll,ll >
#define se second
#define fi first
#define sz(x) (x).size()
#define sqr(x) (x)*(x)
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define endln '\n'


const ll MaxN = 5e5 + 100;
const ll Inf = 1e9;
const ll eps = 1e-3;



ll At[MaxN];
ll N, t;


ll Tree[MaxN * 4];

void add(ll l, ll r, ll x, ll a, ll id) {
    if (l == r) {
        Tree[id] += a;
    }
    else {
        ll mid = (l + r) / 2;
        if (x <= mid) add(l, mid, x, a, id * 2 + 1);
        else add(mid + 1, r, x, a, id * 2 + 2);
        Tree[id] = Tree[id * 2 + 1]+ Tree[id * 2 + 2];
    }

}

ll find(ll l, ll r, ll x, ll id) {
    if (l == r) return l;
    else {
        ll mid = (l + r) / 2;
        if (Tree[id * 2 + 1] >= x) return find(l, mid, x, id * 2 + 1);
        else return find(mid + 1, r, x - Tree[id * 2 + 1], id * 2 + 2);
    }

}
ll MaxA = 0;

vector<ll> Ch(ll x) {

    memset(Tree, 0, sizeof(Tree[0]) * MaxA * 5);
    vector<ll > Bt(N);
    Bt[0] = At[0];
    Bt[N - 1] = At[N - 1];
    if (N > 2) {
        add(0, MaxA, At[0], x, 0);
        add(0, MaxA, At[1], 1, 0);
        ll j = 2;
        for (int i = 0; i < x; i++) {
            add(0, MaxA, At[j], 1, 0);
            if (j != N - 1) j++;
        }
        Bt[1] = find(0, MaxA, x+1, 0);
        for (int i = 2; i < N - 1; i++) {
            add(0, MaxA, At[max(0, i - x-1)], -1, 0);
            add(0, MaxA, At[min(N - 1, i + x)], 1, 0);
            Bt[i] = find(0, MaxA, x +1, 0);
        }

    }


    return Bt;

}

int main()
{

#ifdef LOCAL
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#else

#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> N >> t;
    for (int i = 0; i < N; i++) {
        cin >> At[i];
        MaxA = max(MaxA, At[i]);
    }
    MaxA += 5;
    vector<ll > Bt(N);
    Bt[0] = At[0];
    Bt[N - 1] = At[N - 1];
    bool f = 1;
    for (int i = 1; i < N - 1; i++) {
        vector<ll > Ct;
        Ct.pb(At[i - 1]);
        Ct.pb(At[i + 1]);
        Ct.pb(At[i]);
        sort(all(Ct));
        Bt[i] = Ct[1];
        if (Bt[i] != At[i]) f = 0;
    }

    if (f) {
        cout << 0 << endln;
        if (t) {
            for (ll a : Bt) {
                cout << a << ' ';
            }
        }
        return 0;
    }

    ll l = 1;
    ll r = N;
    while (r- l != 1) {
        ll mid = (l + r) / 2;
        if (Ch(mid) == Ch(mid + 1))
            r = mid;
        else l = mid + 1;

    }
    if(Ch(l) != Ch(r)) l = r;

    cout << l << endln;
    if (t) {
        for (ll a : Ch(l)) {
            cout << a << ' ';
        }
    }



    return 0;
}
