#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXN = 2e5 * 4 + 1;
int tree[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }
    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void change(int v, int cl, int cr, int ind, int val)
{
    if (cl > ind || cr < ind)
        return;
    if (cl == cr)
    {
        tree[v] = val;
        return;
    }
    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, ind, val);
    change(2 * v + 1, cm + 1, cr, ind, val);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int cl, int cr, int l, int r)
{
    if (cl >= l && cr <= r)
        return tree[v];
    if (cl > r || l > cr)
        return 0;
    int cm = (cl + cr) / 2;
    return query(2 * v, cl, cm, l, r) + query(2 * v + 1, cm + 1, cr, l, r);
}

signed main()
{
    hello();

    int n, t;
    cin >> n >> t;
    vector <int> seq(n);
    for (int i = 0; i < n; ++i)
        cin >> seq[i];
    int res = 0;
    if (n <= 1000)
    {
        while (true)
        {
            bool flag = 0;
            vector <int> nseq(n);
            nseq[0] = seq[0];
            nseq.back() = seq.back();
            for (int i = 1; i < n - 1; ++i)
            {
                vector <int> tmp = {seq[i - 1], seq[i], seq[i + 1]};
                sort(tmp.B(), tmp.E());
                nseq[i] = tmp[1];
                if (seq[i] != nseq[i])
                    flag = 1;
            }
            if (!flag)
                break;
            seq = nseq;
            ++res;
        }
    }
    else
    {
        int last = 0;
        for (int i = 0; i < n; ++i)
        {
            if (!(i == n - 1 || i != n - 1 && seq[i] == seq[i + 1]))
                continue;
            if (last == i)
            {
                last = i + 1;
                continue;
            }
            int pt = i - 1;

            res = max(res, ((i - 1) - last) / 2 + ((i - 1) - last) % 2);
            ++last;
            while (last <= pt)
            {
                seq[last] = seq[last - 1];
                seq[pt] = seq[pt + 1];
                --pt;
                ++last;
            }
            last = i + 1;
        }
    }
    cout << res << endl;
    if (t)
        show(seq);
}
