#define _GLIBCXX_DEBUG


#include <bits/stdc++.h>


#define ll long long


#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl


using namespace std;

const ll inf = 1e9;
const ll mod = 1e9 + 7;
const double eps = 1e-7;

const int maxn = 5e5;

int a[maxn];
int b[maxn];


bool was[maxn];
int dist[maxn];

int mediana(ll a, ll b, ll c) {
    ll mx = max({a, b, c});
    ll mn = min({a, b, c});
    return a + b + c - mx - mn;
}


int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, t;
    cin >> n >> t;
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    if (n <= 1000) {
        int k;
        for (k = 0; k <= n; ++k) {
            a[0] = b[0];
            a[n - 1] = b[n - 1];
            bool eq = true;
            for (int i = 1; i < n - 1; ++i) {
                a[i] = mediana(b[i - 1], b[i], b[i + 1]);
                if (a[i] != b[i]) eq = false;
            }
            memcpy(b, a, sizeof(int) * n);
            if (eq) {
                break;
            }
        }
        cout << k << "\n";
        if (t != 0) {
            for (int i = 0; i < n; ++i) {
                cout << b[i] << " ";
            }
        }
        return 0;
    }
    queue<int> bfs;
    for (int i = 1; i < n - 1; ++i) {
        if (b[i] == b[i - 1] || b[i] == b[i + 1]) {
            was[i] = true;
            a[i] = b[i];
            bfs.push(i);
        }
    }
    a[n - 1] = b[n - 1];
    a[0] = b[0];
    was[0] = true;
    was[n - 1] = true;
    bfs.push(0);
    bfs.push(n - 1);
    while (!bfs.empty()) {
        int v = bfs.front();
        bfs.pop();
        if (v != 0 && !was[v - 1]) {
            was[v - 1] = true;
            a[v - 1] = a[v];
            bfs.push(v - 1);
            dist[v - 1] = dist[v] + 1;
        }
        if (v != n - 1 && !was[v + 1]) {
            was[v + 1] = true;
            a[v + 1] = a[v];
            bfs.push(v + 1);
            dist[v + 1] = dist[v] + 1;
        }
    }
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        mx = max(mx, dist[i]);
    }
    cout << mx << "\n";
    if (t != 0) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
    }
}