//#pragma optimize("O3")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma optimize("unswitch-loops")
#pragma target("avx,avx2,sse,sse2,ssse3,sse4,popcnt")
#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(5e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, t;
int a[2][MAX];

inline int median(int a, int b, int c);

signed main() {
    boot_up();

    while (cin >> n >> t) {
        solve();
    }
}

void solve() {
    for (int i = 0; i < n; ++i) {
        cin >> a[0][i];
    }

    int c = 0;
    int layer = 0;
    while (true) {
        int other = layer ^ 1;
        a[layer ^ 1][0] = a[layer][0];
        a[layer ^ 1][n - 1] = a[layer][n - 1];
        for (int i = 1; i < n - 1; ++i) {
            a[other][i] = median(a[layer][i - 1], a[layer][i], a[layer][i + 1]);
        }

        bool flag = true;
        for (int i = 0; i < n; ++i) {
            if (a[layer][i] != a[other][i]) {
                flag = false;
                break;
            }
        }

        if (flag) {
            break;
        }

        ++c;
        layer ^= 1;
    }

    cout << c << '\n';
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << a[layer][i] << ' ';
        }
        cout << '\n';
    }
}

inline int median(int a, int b, int c) {
    vector<int> chto = {a, b, c};
    sort(all(chto));

    return chto[1];
}