#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, t; cin >> n >> t;

	if (n <= 1000) {
		vector <int> a(n); FR(i, n) cin >> a[i];
		vector <int> b(n); b[0] = a[0], b[n - 1] = a[n - 1];

		int ans = 0;
		bool ch = 1;
		while (ch) {

			ans++;
			ch = 0;

			FOR(i, 1, n - 1) {

				b[i] = a[i];
				if (a[i] > a[i - 1] && a[i] > a[i + 1]) ch = 1, b[i] = max(a[i - 1], a[i + 1]);
				if (a[i] < a[i - 1] && a[i] < a[i + 1]) ch = 1, b[i] = min(a[i - 1], a[i + 1]);

			}

			FR(i, n) a[i] = b[i];
		}

		cout << ans - 1 << '\n';
		if (t == 1) FR(i, n) cout << a[i] << ' ';
	}
	else {
	
		vector <int> a(n + 2); FR(i, n) cin >> a[i];
		a[n] = a[n + 1] = a[n - 1];

		int ans = 0;
		int tans = 0;
		int st = 0;

		FOR(i, 1, n + 1) {

			if (a[i] == a[i - 1] && st != 0) {

				ans = max(ans, tans);
				tans = 0;
				st = 0;

			}
			else if (a[i] == a[i - 1]) st = 0;
			else {

				if (st == 0) if (a[i] == 2) st = 1;
				else st = -1;


				if (st == 1) if (a[i] > a[i - 1] && a[i] > a[i + 1]) tans++;
				if (st == -1) if (a[i] < a[i - 1] && a[i] < a[i + 1]) tans++;

			}

		}

		vector <int> na(n + 1); FR(i, n) na[i] = a[i];
		auto chenge = [&](int f, int s) {

			if (a[f] == a[s]) FOR(i, f, s + 1) na[i] = a[f];
			else {

				int fn = f + 1, sn = s - 1;
				while (fn < sn) {

					na[fn] = a[f];
					na[sn] = a[s];

					fn++, sn--;

				}

			}

		};

		int lastq = 0;
		bool p = 0;
		FOR(i, 1, n + 1) {

			if (a[i] == a[i - 1] && p) chenge(lastq, i - 1), p = 0;
			else if (a[i] != a[i - 1] && !p) lastq = i - 1, p = 1;


		}

		if (t == 0) cout << ans;
		else
		{

			cout << ans << '\n';
			FR(i, n) cout << na[i] << ' ';

		}

	}
	return 0;
} 