#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 10;

int a[2][MAX_N];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> a[0][i];
	}
	int ans = 0;
	int from = 0, to = 1;
	a[to][0] = a[from][0];
	a[to][n - 1] = a[from][n - 1];
	while (1) {
		bool finished = 1;
		int q[3];
		for (int i = 1; i < n - 1; ++i) {
			q[0] = a[from][i - 1];
			q[1] = a[from][i];
			q[2] = a[from][i + 1];
			nth_element(q, q + 1, q + 3);
			a[to][i] = q[1];
			if (a[from][i] != a[to][i])
				finished = 0;
		}
		if (finished)
			break;
		++ans;
		from = to;
		to = 1 - to;
	}
	cout << ans << "\n";
	if (t) {
		for (int i = 0; i < n; ++i)
			cout << a[to][i] << " ";
	}
	return 0;
}