#include <bits/stdc++.h>
using namespace std;

const int MAXN = 500001;

int ans = 0;

int median(int a, int b, int c) {
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	if (a > b)
		swap(a, b);
	return b;
}

void solve(int *arr, int n, int d = 0) {
	ans = max(ans, d);
	bool good = 1;
	for (int i = 1; i + 1 < n; i++) {
		if (arr[i] != median(arr[i - 1], arr[i], arr[i + 1])) {
			good = 0;
		}
	}
	if (good)
		return;
	for (int i = 0; i < n - 1; i++) {
		if (arr[i] == arr[i + 1]) {
			solve(arr, i + 1, d);
			solve(arr + i + 1, n - (i + 1), d);
			return;
		}
	}
	int last = arr[0];
	for (int i = 1; i < n - 1; i++) {
		int nw = median(last, arr[i], arr[i + 1]);
		last = arr[i];
		arr[i] = nw;
	}
	solve(arr, n, d + 1);
}

int n;
int arr[MAXN];

int main() {
	cin >> n;
	int t;
	cin >> t;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	solve(arr, n);
	cout << ans << endl;
	if (t) {
		for (int i = 0; i < n; i++) {
			cout << arr[i] << " ";
		}
		cout << endl;
	}
}


