#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    int n, t;
    cin >> n >> t;
    vi a(n);
    forn(i, n) cin >> a[i];
    if (n <= 1000) {
        int ans = 0;
        while (true) {
            vi a1(n);
            a1[0] = a[0], a1[n - 1] = a[n - 1];
            bool flag = 0;
            forn1(i, n - 1) {
                int x = a[i - 1], y = a[i], z = a[i + 1];
                int mx = max(x, max(y, z));
                int mn = min(x, min(y, z));
                int md = x + y + z - mx - mn;
                a1[i] = md;
                if (a1[i] != a[i]) flag = 1;
            }
            if (!flag) break;
            a = a1;
            ans++;
        }
        cout << ans << '\n';
        if (t) {
            forn(i, n) cout << a[i] << ' ';
            cout << '\n';
        }
    }
    int l = -1;
    int ans = 0;
    forn1(i, n - 1) {
        if (a[i] == a[i - 1] || a[i] == a[i + 1]) {
            if (l == -1) continue;
            int r = i - 1;
            ans = max(ans, (r - l + 1) >> 1);
            if (a[l - 1] == a[r + 1]) {
                for (int j = l; j <= r; ++j) a[j] = a[l - 1];
            } else {
                int len = r - l + 1;
                for (int j = l; j <= r; ++j) {
                    if (j - l < len / 2) a[j] = a[l - 1]; else a[j] = a[r + 1];
                }
            }
            l = -1;
            continue;
        }
        if (l == -1) l = i;
    }
    if (l != -1) {
        int r = n - 2;
        ans = max(ans, (r - l + 1) >> 1);
        if (a[l - 1] == a[r + 1]) {
            for (int j = l; j <= r; ++j) a[j] = a[l - 1];
        } else {
            int len = r - l + 1;
            for (int j = l; j <= r; ++j) {
                if (j - l < len / 2) a[j] = a[l - 1]; else a[j] = a[r + 1];
            }
        }

    }
    cout << ans << '\n';
    if (t) {
        forn(i, n) cout << a[i] << ' ';
        cout << '\n';
    }
    return 0;
}