//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx")
//#pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

int n, t;
vector<int> a;

void read() {
	cin >> n >> t;
	a.resize(n);
	for (auto &i : a) {
		cin >> i;
	}
}

int solve(int l, int r) {
	int ans = (r - l) / 2;
	if (a[l] == a[r]) {
		for (int i = l; i <= r; i++) {
			a[i] = a[l];
		}
	}
	else {
		for (int i = 1; l + i < r - i; i++) {
			a[l + i] = a[l];
			a[r - i] = a[r]; 
		}
	}
	return ans;
}

int ans;

void run() {
	ans = 0;
	for (int i = 0; i < n - 1; i++) {
		int j = i + 1;
		while (j < n - 1 && a[j] != a[j - 1]) j++;
		chkmax(ans, solve(i, j));
		i = j - 1;
	}
}

void write() {
	cout << ans << endl;
	if (t) {
		for (auto i : a) {
			cout << i << " ";
		}
		cout << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}