#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


int med(int a, int b, int c) {
    vector<int> e = {a, b, c};
    sort(e.begin(), e.end());
    return e[1];
}

void solve1(int *a, int n, int t) {
    int b[n];
    b[0] = a[0];
    b[n - 1] = a[n - 1];
    int ans = 0;
    while (true) {
        bool flag = false;
        for (int i = 1; i < n - 1; ++i) {
            int nw = med(a[i - 1], a[i], a[i + 1]);
            if (nw != a[i]) {
                flag = true;
            }
            b[i] = nw;
        }
        if (!flag) {
            break;
        }
        ans++;
        for (int i = 0; i < n; ++i) {
            a[i] = b[i];
        }
    }
    cout << ans << "\n";
    if (t == 1) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
    }
}

void solve2(int *a, int n, int t) {
    int tmp[n];
    tmp[0] = 0;
    tmp[n - 1] = 0;
    for (int i = 1; i < n - 1; ++i) {
        int nw = med(a[i - 1], a[i], a[i + 1]);
        if (nw != a[i]) {
            tmp[i] = 1;
        } else {
            tmp[i] = 0;
        }
    }
    int last = 0;
    int mx = 0;
    set<int> zer;
    for (int i = 0; i < n; ++i) {
        last += tmp[i];
        mx = max(mx, last);
        if (tmp[i] == 0) {
            last = 0;
            zer.insert(i);
        }
    }
    cout << (mx + 1) / 2 << "\n";
    if (t == 1) {
        for (int i = 0; i < n; ++i) {
            if (tmp[i] == 0) {
                cout << a[i] << " ";
            } else {
                auto it = zer.upper_bound(i);
                int x = *it;
                it--;
                if (x - i > i - *it) {
                    x = *it;
                }
                cout << a[x] << " ";
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n <= 1000) {
        solve1(a, n, t);
    } else {
        solve2(a, n, t);
    }

    return 0;
}