#include <iostream>
#include <list>
#define endl '\n'

using namespace std;

const int MAXN = 5e5;
int n;
int a[MAXN+10], b[MAXN+10];
bool t;
long long days = 0;

void input()
{
    cin>>n>>t;
    for (int i=0; i<n; i++)
    {
        cin>>a[i];
    }
}

void printArray(const int a[], const int n)
{
    for (int i=0; i<n; i++)
    {
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void printList(const list<int> &l)
{
    auto id = l.begin();
    while (id != l.end())
    {
        cout<<*id<<' ';
        id++;
    }
    cout<<endl;
}

void output()
{
    cout<<days<<endl;
    if (t) printArray(a, n);
}

void fillList(list<int> &l)
{
   for (int i=1; i<n-1; i++)
   {
       l.push_back(i);
   }
}

int median(int a, int b, int c)
{
    if (a > b) swap(a, b);
    if (a > c) swap(a, c);
    if (b > c) swap(b, c);
    return b;
}

void solve()
{
    days = -1;
    bool p = 1;

    list<int> l;
    fillList(l);

    if (n <= 3)
    {
        if (days == 3)
        {
            int med = median(a[0], a[1], a[2]);
            if (med != a[1])
            {
                days = 1;
                a[1] = med;
            }
            else days = 0;
        }
        else
        {
            days = 0;
        }
        return;
    }

    while (p)
    {
        p = 0;

        if (l.size() == 1)
        {
            auto id = l.begin();
            int med = median(a[*id-1], a[*id], a[*id+1]);
            if (a[*id] != med)
            {
                p = 1;
                a[*id] = med;
            }
        }
        else
        {
            auto o_id = l.begin();
            auto id = l.begin(); id++;

            int o_med = median(a[*o_id-1], a[*o_id], a[*o_id+1]);

            while (id != l.end())
            {
                int med = median(a[*id-1], a[*id], a[*id+1]);
                if (a[*o_id] != o_med)
                {
                    p = 1;
                    a[*o_id] = o_med;
                }
                else l.erase(o_id);
                o_id = id;
                id++;
                o_med = med;
            }
            if (a[*o_id] != o_med)
            {
                p = 1;
                a[*o_id] = o_med;
            }
            else l.erase(o_id);
        }

        days++;
        /*cout<<days<<endl;
        printArray(a, n);
        printList(l);
        cout.flush();*/
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
5 1
1 2 1 2 1

6 1
1 3 2 5 4 6

6 0
1 1 2 2 1 1
*/


