#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n, t;
	cin >> n >> t;
	
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	if (n <= 1000)
	{
		int ans = 0;
		vector<int> b(n);
		b[0] = a[0];
		b[n - 1] = a[n - 1];
		while (1)
		{
			for (int i = 1; i < n - 1; i++)
			{
				vector<int> tmp(3);
				tmp[0] = a[i];
				tmp[1] = a[i - 1];
				tmp[2] = a[i + 1];
				sort(all(tmp));
				b[i] = tmp[1];
			}
			if (a == b) break;
			ans++;
			a = b;
		}
		cout << ans << '\n';
		if (t == 1) for (auto i : a) cout << i << " ";
	
		return 0;
	}
	vector<int> stable;
	stable.push_back(0);
	for (int i = 1; i < n - 1; i++)
	{
		if ((a[i] <= a[i - 1] && a[i + 1] <= a[i]) || (a[i] >= a[i - 1] && a[i + 1] >= a[i])) stable.push_back(i);
	}
	stable.push_back(n - 1);
	int ans = 0;
	vector<int> next(3);
	next[1] = 2;
	next[2] = 1;
	for (int i = 0; i + 1 < stable.size(); i++)
	{
		int now = a[stable[i]];
		int len = (stable[i + 1] - stable[i] - 1);
		for (int j = 0; j <= (len + 1) / 2; j++)
		{
			a[stable[i] + j] = a[stable[i]];
			a[stable[i + 1] - j] = a[stable[i + 1]];
		}
		ans = max(ans, (stable[i + 1] - stable[i]) / 2);
	}
	cout << ans << '\n';
	if (t == 1) for (auto i : a) cout << i << " ";
	return 0;
}