#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;

ll n, t;

void solve1() {
    vector <ll> a[2];
    ll x = 0;
    for (ll i = 0; i < 2; ++i) {
        a[i].resize(n);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> a[x][i];
    }
    a[x ^ 1][0] = a[x][0];
    a[x ^ 1][n - 1] = a[x][n - 1];
    bool change = true;
    ll cnt = 0;
    while (change) {
        change = false;
        for (ll i = 1; i < n - 1; ++i) {
            vector <ll> t = {a[x][i - 1], a[x][i], a[x][i + 1]};
            sort(t.begin(), t.end());
            a[x ^ 1][i] = t[1];
            if (a[x][i] != a[x ^ 1][i]) {
                change = true;
            }
        }
        if (change) {
            x ^= 1;
            ++cnt;
        }
    }
    cout << cnt << endl;
    if (t) {
        for (ll i : a[x]) {
            cout << i << ' ';
        }
    }
}

void solve2() {
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <bool> can(n, true);
    can[0] = can[n - 1] = false;
    for (ll i = 1; i < n - 1; ++i) {
        if (a[i] == a[i - 1] || a[i] == a[i + 1]) {
            can[i] = false;
        }
    }
    vector <pll> b;
    ll l = 0, r = 0;
    for (ll i = 1; i < n; ++i) {
        if (can[i]) {
            if (!can[l]) {
                l = i;
            }
            r = i + 1;
        } else {
            if (r > l) {
                b.push_back({l, r});
            }
            l = i;
        }
    }
    ll mx = 0;
    for (auto i : b) {
        l = i.first, r = i.second;
        mx = max(mx, r - l);
        if ((r - l) & 1) {
            for (ll j = l; j < r; ++j) {
                a[j] = a[l - 1];
            }
        } else {
            for (ll j = l; j < r; ++j) {
                a[j] = (j - (l - 1) < r - j ? a[l - 1] : a[r]);
            }
        }
    }
    cout << (mx + 1) / 2 << endl;
    if (t) {
        for (ll i : a) {
            cout << i << ' ';
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> t;
    if (n <= 1000) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}

/**
7 1
1 1 2 1 2 1 2

7 1
1 1 2 1 2 1 1

**/
