#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, t; cin >> n >> t;
	vector <int> a(n); FR(i, n) cin >> a[i];

	vector <int> c; c.push_back(0);
	FOR(i, 1, n - 1) {
	
		if (a[i] >= a[i - 1] && a[i] <= a[i + 1]) c.push_back(i);
		else if (a[i] <= a[i - 1] && a[i] >= a[i + 1]) c.push_back(i);

	}
	c.push_back(n - 1);

	int ans = 0;
	FR(i, c.size() - 1) {
	
		ans = max(ans, (c[i + 1] - c[i]) / 2);

	}

	cout << ans;

	return 0;
}