#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 17);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

void Small(int n, int t) {
	vector <int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	int k = 0;
	while (true) {
		//for (auto i : v)
		//	cout << i << " ";
		cout << endl;
		vector <int> t(n);
		t[0] = v[0];
		t.back() = v.back();
		for (int i = 1; i + 1 < v.size(); i++) {
			vector <int> q = { v[i - 1], v[i], v[i + 1] };
			sort(q.begin(), q.end());
			t[i] = q[1];
		}
		if (t != v) {
			v = t, k++;
		}
		else break;
	}
	cout << k << endl;
	if (t == 1) {
		for (auto i : v)
			cout << i << " ";
	}
}

vector <int> ending;
int ans = 0;

void SolveInSegment(int l, int r) {
	ans = max(ans, (r - l - 1) / 2);
}

void Solve() {
	int n, t;
	cin >> n >> t;
	if (n <= 1000) {
		Small(n, t);
		return;
	}
	vector <int> v(n);
	ending = v;
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int st = 0;
	while (st + 1 < n) {
		int i = st;
		while (i + 1 < n) {
			if (v[st + 1] > v[st]) {
				if ((i - st) % 2 == 0 && v[i + 1] > v[i])
					i++;
				else if ((i - st) % 2 == 1 && v[i + 1] < v[i])
					i++;
				else break;
			}
			else if (v[st + 1] < v[st]) {
				if ((i - st) % 2 == 0 && v[i + 1] < v[i])
					i++;
				else if ((i - st) % 2 == 1 && v[i + 1] > v[i])
					i++;
				else break;
			}
			else break;
		}
		SolveInSegment(st, i);
		st = i;
	}
	cout << ans;
	if (t) {
		for (auto i : ending)
			cout << i << " ";
	}
}

int main() {
	IOOptimize();
	Solve();
}