// much thanks for giving problems from atcoder.jp

//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

// Attack!!! Not defend

int n;
vector<int> a;
vector<pii> b;

const int N = (1 << 19);

struct Node {
	bool l, r;
	int cl, cr;
	int tl, tr;
	int mx;
};

Node T[2 * N + 1];

void update(int i) {
	int tl = T[i].tl, tr = T[i].tr;
	if (tl + 1 != tr) {
		int m = (tl + tr) / 2;
		int mid = max(T[i * 2 + 1].cr, T[i * 2 + 2].cl);	
		T[i].cl = T[i * 2 + 1].cl; T[i].cr = T[i * 2 + 2].cr;
		T[i].l = T[i * 2 + 1].l; T[i].r = T[i * 2 + 2].r;
		if (T[i * 2 + 1].r != T[i * 2 + 2].l) {
			mid = T[i * 2 + 1].cr + T[i * 2 + 2].cl;

			if (m - tl == T[i * 2 + 1].cl) {
				T[i].cl = mid;
			}
			if (tr - m == T[i * 2 + 2].cr) {
				T[i].cr = mid;
			}
		}
		T[i].mx = max(max(T[i].cr, T[i].cl), mid);
	}
}

void change(int i, int val) {
	if (i == n - 1) change(i + 1, val);
	i += N - 1;
	T[i].l = T[i].r = val;
	T[i].cl = T[i].cr = T[i].mx = 1;
	while (i) {
		i = (i - 1) / 2;
		update(i);
	}
}

void init(int i, int tl, int tr) {
	T[i].tl = tl, T[i].tr = tr;
	if (tl + 1 == tr) {
		T[i].l = 0, T[i].r = 0;
		T[i].cl = T[i].cr = T[i].mx = 1;
	} else {
		int m = (tl + tr) / 2;
		init(i * 2 + 1, tl, m);
		init(i * 2 + 2, m, tr);
		update(i);
	}
}

void run() {
	int _;
	cin >> n >> _; a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		b.emplace_back(a[i], i);
	}
	// cout << a << endl;
	init(0, 0, N);
	sort(b.begin(), b.end());
	int it = 0;
	int rez = 0;
	while (it < le(b)) {
		while (it + 1 < le(b) && b[it + 1].x == b[it].x) {
			change(b[it].y, 1);
			it++;
		}
		change(b[it].y, 1);
		it++;
		rez = max(rez, T[0].mx);
	}
	cout << (rez - 1) / 2 << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}