#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;

int n, t;
int a[N];
int b[N];

bool simulate()
{
    b[0] = a[0];
    b[n - 1] = a[n - 1];

    bool rval = false;

    for (int i = 1; i < n - 1; ++i)
    {
        vector<int> tmp;

        tmp.push_back(a[i]);
        tmp.push_back(a[i - 1]);
        tmp.push_back(a[i + 1]);
        sort(tmp.begin(), tmp.end());
        b[i] = tmp[1];

        if (b[i] != a[i])
            rval = true;
    }

    for (int i = 0; i < n; ++i)
        a[i] = b[i];

    return rval;
}

int32_t main()
{
    cin >> n >> t;

    for (int i = 0; i < n; ++i)
        cin >> a[i];

    int cnt = 0;

    if (n <= 1e3)
    {
        while (simulate())
            ++cnt;

        cout << cnt << endl;

        if (t)
            for (int i = 0; i < n; ++i)
                cout << a[i] << " \n"[i + 1 == n];

        return 0;
    }

    int l = 0;
    int p = a[0];
    int ans = 0;

    for (int i = 0; i < n; ++i)
        if (a[i] == p)
        {
            if (i - l + 1 >= 3)
            {
                int j = i;

                if ((i - l + 1) % 2 == 0)
                    --j;

                ans = max(ans, (j - l) / 2);

                for (int z = l; z <= j; ++z)
                    b[z] = a[l];
            }

            l = i;
            p = a[i];
        }
        else
        {
            p = a[i];
        }

        if (n - l >= 3)
        {
            int j = n - 1;

            if ((j - l + 1) % 2 == 0)
                --j;

            ans = max(ans, (j - l) / 2);

            for (int z = l; z <= j; ++z)
                b[z] = a[l];
        }

        cout << ans << endl;

        if (t)
            for (int i = 0; i < n; ++i)
                if (b[i])
                    cout << b[i] << " ";
                else
                    cout << a[i] << " ";

        cout << endl;
}