#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int MAXN = 500005;

int n, t, a[MAXN], b[MAXN];
bool st2 = 1;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> t;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        if (a[i] > 2) st2 = 0;
    }
}

void SolveST2()
{
    int lp = 1;
    int mc = 0;
    vector<int> ans;
    for (int i = 1; i <= n; ++ i)
    {
        if (i == n or a[i] == a[i + 1])
        {
            if (lp == i - 1)
            {
                ans.push_back(a[lp]);
                ans.push_back(a[i]);
                lp = i + 1;
                continue;
            }
            if (a[lp] != a[i])
            {
                mc = max(mc, (i - lp) / 2);
                for (int j = 0; j <= (i - lp) / 2; ++ j)
                {
                    ans.push_back(a[lp]);
                }
                for (int j = 0; j <= (i - lp) / 2; ++ j)
                {
                    ans.push_back(a[i]);
                }
            }
            else
            {
                mc = max(mc, (i - lp) / 2);
                for (int j = lp; j <= i; ++ j) ans.push_back(a[i]);
            }
            lp = i + 1;
        }
    }

    cout << mc << endl;
    if (t == 1)
    {
        for (int i = 0; i < n; ++ i)
        {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
}

int main()
{
    Init();

    if (st2)
    {
        SolveST2();
        return 0;
    }

    int c = 0;
    while (true)
    {
        bool fl = 0;

        b[1] = a[1];
        for (int i = 2; i < n; ++ i)
        {
            int tmp[3];
            tmp[0] = a[i - 1];
            tmp[1] = a[i];
            tmp[2] = a[i + 1];
            sort(tmp, tmp + 3);
            b[i] = tmp[1];

            if (a[i] != b[i]) fl = 1;
        }
        b[n] = a[n];

        if (fl == 0) break;
        else c++;

        for (int i = 1; i <= n; ++ i)
        {
            a[i] = b[i];
        }
    }

    cout << c << endl;
    if (t == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cout << a[i] << ' ';
        }
        cout << endl;
    }
    return 0;
}
