#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> n >> t;
	vector <ll> a(n);
	for (auto& x : a) {
		cin >> x;
	}
	ll c = 0;
	bool updated = true;
	while (updated) {
		updated = false;
		vector <ll> newa(n);
		for (int i = 1; i < n - 1; ++i) {
			ll x = a[i - 1], y = a[i], z = a[i + 1];
			if (x > y) {
				swap(x, y);
			}
			if (y > z) {
				swap(y, z);
			}
			if (x > y) {
				swap(x, y);
			}
			if (y != a[i]) {
				updated = true;
			}
			newa[i] = y;
		}
		newa[0] = a[0];
		newa.back() = a.back();
		if (updated) {
			++c;
			a.swap(newa);
		}
	}
	cout << c << '\n';
	if (t) {
		for (auto& x : a) {
			cout << x << ' ';
		}
	}
	return 0;
}