#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

ll dp[20][500000];

void precalc(ll v, vector<vector<ll>> &nodes, vector<ll> &d, vector<ll> &p, ll was) {
    for (auto i : nodes[v]) {
        if (i != was) {
            d[i] = d[v] + 1;
            p[i] = v;
            precalc(i, nodes, d, p, v);
        }
    }
}

ll lca(ll a, ll b, vector<ll> &d) {
    if (d[a] < d[b])
        swap(a, b);
    for (int st = 19; st >= 0; --st) {
        if (d[dp[st][a]] >= d[b])
            a = dp[st][a];
    }
    if (a == b)
        return a;
    for (int st = 19; st >= 0; --st) {
        if (dp[st][a] != dp[st][b]) {
            a = dp[st][a], b = dp[st][b];
        }
    }
    return dp[0][a];
}

void get_dirs(ll v, ll fin, vector<ll> &dir, bool &up, bool &down) {
    if (v == fin)
        return;
    if (dir[v] == 0) {
        down = true;
    } else if (dir[v] == 1)
        up = true;
    get_dirs(dp[0][v], fin, dir, up, down);
}

void make_dir(ll v, ll fin, vector<ll> &dir, bool up, bool down) {
//    cout << v << ' ' << fin << ' ' << dp[0][v] << '\n';
    if (v == fin)
        return;
    if (up) {
        dir[v] = 1;
    } else {
        dir[v] = 0;
    }
    make_dir(dp[0][v], fin, dir, up, down);
}

void make_cost(ll v, vector<vector<ll>> &nodes, vector<ll> &dir, vector<ll> &c) {
    if (dir[v] == 1) {
        c[dp[0][v]] = max(c[dp[0][v]], c[v] + 1);
        make_cost(dp[0][v], nodes, dir, c);
    }
    for (auto i : nodes[v]) {
        if (i != dp[0][v]) {
            if (dir[i] == 0) {
                c[i] = max(c[i], c[v] + 1);
                make_cost(i, nodes, dir, c);
            }
        }
    }
}

signed main() {
    ll n, t;
    cin >> n >> t;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n <= 1000) {
        ll c = 0;
        while (true) {
            bool ch = false;
            vector<ll> b(n);
            b[0] = a[0], b[n - 1] = a[n - 1];
            for (int i = 1; i < n - 1; ++i) {
                vector<ll> t = {a[i - 1], a[i], a[i + 1]};
                sort(t.begin(), t.end());
                b[i] = t[1];
                if (b[i] != a[i])
                    ch = true;
            }
            swap(a, b);
            if(ch)
                ++c;
            else
                break;
        }
        cout << c << '\n';
        if(t == 1) {
            for(auto i : a) {
                cout << i << ' ';
            }
        }
    }
}