#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 10;

int input[MAX_N];

int a[2][MAX_N];

vector<pair<int, int>> cuts;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i)
		cin >> input[i];
	int adding = 0;
	for (int i = 0; i < n; ++i)
		a[0][i] = input[i];
	int from = 0, to = 1;
	a[to][0] = a[from][0];
	a[to][n - 1] = a[from][n - 1];
	bool finished = 1;
	while (clock() < 1.9 * CLOCKS_PER_SEC && adding < n + 10) {
		finished = 1;
		int q[3];
		for (int i = 1; i < n - 1; ++i) {
			q[0] = a[from][i - 1];
			q[1] = a[from][i];
			q[2] = a[from][i + 1];
			nth_element(q, q + 1, q + 3);
			a[to][i] = q[1];
			if (a[from][i] != a[to][i])
				finished = 0;
		}
		if (finished)
			break;
		++adding;
		from = to;
		to = 1 - to;
	}
	if (!finished)
		to = from;
	for (int i = 0; i < n; ++i)
		input[i] = a[to][i];
	char prev = 0;
	int last = -1;
	for (int i = 1; i < n - 1; ++i) {
		char curr = 0;
		if (input[i - 1] < input[i] && input[i] > input[i + 1])
			curr = 1;
		if (input[i - 1] > input[i] && input[i] < input[i + 1])
			curr = 2;
		if (curr) {
			if (last == -1)
				last = i;
		} else {
			if (prev) {
				cuts.push_back({last, i});
				last = -1;
			}
		}
		prev = curr;
	}
	if (prev)
		cuts.push_back({last, n - 1});
	int ans = 0;
	for (auto u : cuts) {
		if ((u.y - u.x) % 2) {
			fill(input + u.x, input + u.y, input[u.x - 1]);
		} else {
			for (int i = u.x; i < u.y; ++i) {
				if (i - u.x < u.y - i - 1) {
					input[i] = input[u.x - 1];
				} else {
					input[i] = input[u.y];
				}
			}
		}
		ans = max(ans, (u.y - u.x + 1) / 2);
	}
	cout << ans + adding << "\n";
	if (t) {
		for (int i = 0; i < n; ++i)
			cout << input[i] << " ";
	}
	return 0;
}