#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

const int INF = 1e9 + 1;

int med(int x, int y, int z) {
    if (x <= y && y <= z) {
        return y;
    }
    if (z <= y && y <= x) {
        return y;
    }
    if (z <= x && x <= y) {
        return x;
    }
    if (y <= x && x <= z) {
        return x;
    }
    return z;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    vector <int> a(n);
    bool second_group = true;
    for (auto &c : a) {
        cin >> c;
        if (c > 2) {
            second_group = false;
        }
    }
    if (second_group) {
        vector <pair<int, int>> block;
        block.push_back({0, 1});
        for (int i = 1; i < n; i++) {
            if (a[i - 1] == a[i]) {
                block.back().second++;
            } else {
                block.push_back({i, 1});
            }
        }
        /*
        cout << block.size() << endl;
        for (auto &c : block) {
            cout << c.first << " " << c.second << endl;
        }
        */
        vector <pair<int, int>> ind;
        vector <int> in(n, 1);
        for (auto &c : block) {
            if (c.second > 1) {
                ind.push_back(make_pair(c.first, c.first + c.second - 1));
                continue;
            }
            if (c.first == 0 || c.first == n - 1) {
                ind.push_back(make_pair(c.first, c.first));
                continue;
            }
            in[c.first] = 0;
        }
        /*
        cout << ind.size() << endl;
        for (auto c : ind) {
            cout << c.first << " " << c.second << endl;
        }
        for (auto &c : in) {
            cout << c << " ";
        }
        cout << endl;
        */
        vector <int> b = a;
        int ans = 0;
        int left = 0;
        int right = 0;
        for (int i = 0; i < n; i++) {
            if (in[i]) {
                continue;
            }
            while (left + 1 < ind.size() && ind[left + 1].second < i) {
                left++;
            }
            while (ind[right].first < i) {
                right++;
            }
            //cout << i << " " << ind[left].second << " " << ind[right].first << endl;
            if (i - ind[left].second > ind[right].first - i) {
                ans = max(ans, ind[right].first - i);
                b[i] = a[ind[right].first];
            } else {
                ans = max(ans, i - ind[left].second);
                b[i] = a[ind[left].second];
            }
        }
        if (t == 0) {
            cout << ans;
        } else {
            cout << ans << "\n";
            for (auto &c : b) {
                cout << c << " ";
            }
        }
        return 0;
    }
    if (n <= 1000) {
        int ans = 0;
        while (1) {
            vector <int> b = a;
            bool f = false;
            for (int i = 1; i < n - 1; i++) {
                if (med(a[i - 1], a[i], a[i + 1]) != a[i]) {
                    f = true;
                    b[i] = med(a[i - 1], a[i], a[i + 1]);
                }
            }
            if (f == false) {
                break;
            }
            a = b;
            ans++;
        }
        if (t == 0) {
            cout << ans;
        } else {
            cout << ans << "\n";
            for (auto &c : a) {
                cout << c << " ";
            }
        }
    }

    return 0;
}
