#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <cassert>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef pair <int, int> pii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,avx,popcnt,ssse3,mmx,tune=native")

const int N = 5e5 + 5;

inline int median(int a, int b, int c)
{
    return a + b + c - min(min(a, b), c) - max(max(a, b), c);
}

int a[2][N];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, t;
    cin >> n >> t;
    for (int i = 0; i < n; ++i)
        cin >> a[0][i];
    bool change = true;
    int iter = 0;
    a[1][0] = a[0][0];
    a[1][n - 1] = a[0][n - 1];
    while (change)
    {
        change = false;
        for (int i = 1; i < n - 1; ++i)
        {
            int tmp = median(a[iter & 1][i - 1], a[iter & 1][i], a[iter & 1][i + 1]);
            if (a[iter & 1][i] != tmp)
            {
                a[(iter & 1) ^ 1][i] = tmp;
                change = true;
            }
            else
            {
                a[(iter & 1) ^ 1][i] = tmp;
            }
        }
        ++iter;
    }
    --iter;
    assert(iter <= n);
    cout << iter << endl;
    if (t)
        for (int i = 0; i < n; ++i)
            cout << a[iter & 1][i] << ' ';
    return 0;
}
