#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 5e5 + 15;
int n, t, b[N], a[N], c[N];
int ans;

inline int med(int a, int b, int c) {
    vector <int> v = {a, b, c};
    sort(v.begin(), v.end());
    return v[1];
}

inline void input() {
    cin >> n >> t;
    for(int i = 1; i <= n; ++i)
        cin >> a[i];
}

bool stb[N];
int cnt[2][N];

void solve() {
    for(int i = 1; i <= n; ++i)
        b[i] = a[i];
    while(1) {
        bool flag = false;
        for(int i = 1; i <= n; ++i)
            c[i] = b[i];
        for(int i = 2; i < n; ++i) {
            int x = med(c[i-1], c[i], c[i+1]);
            b[i] = x;
            if(x != c[i])
                flag = true;
        }
        if(!flag)
            break;
        ++ans;
    }
    cout << ans << endl;
    if(t == 1)
        for(int i = 1; i <= n; ++i) {
            cout << b[i] << ' ';
        }
}

void solve2() {
    for(int i = 1; i <= n; ++i)
        b[i] = a[i];
    for(int i = 2; i < n; ++i) {
        stb[i] = (med(a[i-1], a[i], a[i+1]) == a[i]);
    }
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= 2; ++j)
            cnt[j][i] += cnt[j][i-1] + (a[i] == j);
    stb[1] = stb[n] = 1;
    for(int i = 1; i <= n; ++i) {
        if(stb[i])
            continue;
        if(stb[i-1]) {
            int j = i;
            while(j + 1 <= n && !stb[j + 1])
                ++j;
            Max(ans, (j - i + 2) / 2);
            for(int k = i; k <= j; ++k) {
                if(k < i + cnt[a[i-1]][j] - cnt[a[i-1]][i-1])
                    b[k] = a[i-1];
                else
                    b[k] = a[j+1];
            }
//            cout << i << ' ' << j << endl;
        }
    }
    cout << ans << endl;
    if(t == 1)
        for(int i = 1; i <= n; ++i)
            cout << b[i] << ' ';
}


main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    int tt = 1;
    while(tt--) {
        input();
        if(n <= 1000)
            solve();
        else
            solve2();
    }
    return 0;
}
