#include <bits/stdc++.h>
#define int long long
#define double long double
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse2,sse3,ssse3")
using namespace std;

int pairs(int x) {
    return (x * (x - 1)) >> 1;
}

vector<int> z(string s) {
    int n = s.length();
    vector<int> kek(n);
    kek[0] = n;
    int l = 0;
    int r = 0;
    for (int i = 1; i < n; i++) {
        if (i <= r) {
            kek[i] = min(kek[i - l], r - i + 1);
        }
        while (i + kek[i] < n && s[kek[i]] == s[i + kek[i]]) {
            kek[i]++;
        }
        if (i > r) {
            l = i;
            r = i + kek[i] - 1;
        }
    }
    return kek;
}

int median(int a, int b, int c) {
    vector<int> vec(3);
    vec[0] = a;
    vec[1] = b;
    vec[2] = c;
    sort(vec.begin(), vec.end());
    return vec[1];
}

pair<int, vector<int>> result(vector<int> kek) {
    int cnt = 0;
    while (true) {
        bool change = false;
        vector<int> lol(kek.size());
        lol[0] = kek[0];
        lol[lol.size() - 1] = kek[kek.size() - 1];
        for (int i = 1; i < lol.size() - 1; i++) {
            int x = median(kek[i - 1], kek[i], kek[i + 1]);
            if (x != kek[i]) {
                change = true;
            }
            lol[i] = x;
        }
        kek = lol;
        if (change) {
            cnt++;
        } else {
            break;
        }
        /* for (int x : kek) {
            cout << x << ' ';
        }
        cout << '\n'; */
    }
    return {cnt, kek};
}

vector<int> gen(int n, int x) {
    vector<int> kek(n);
    for (int i = 0; i < n; i++) {
        kek[i] = rand() % x + 1;
    }
    return kek;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    vector<int> kek(n);
    for (int i = 0; i < n; i++) {
        cin >> kek[i];
    }
    // pair<int, vector<int>> pr = result(kek);
    int ans = 0;
    int last = kek[0];
    int l = 0;
    int status = last;
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        int x;
        if (i == n) {
            x = kek[n - 1];
        } else {
            x = kek[i];
        }
        if (x != last) {
            last = kek[i];
            if (x != status) {
                cnt++;
            }
        } else if (cnt == 0) {
            l++;
        } else if (x == status) {
            ans = max(ans, cnt);
            while (l < i) {
                kek[l] = x;
                l++;
            }
            cnt = 0;
        } else {
            ans = max(ans, cnt - 1);
            for (int j = l; j < l + cnt; j++) {
                kek[j] = status;
            }
            l += cnt;
            for (int j = l; j < l + cnt; j++) {
                kek[j] = 3 - status;
            }
            l += cnt;
            status = 3 - status;
            cnt = 0;
        }
    }
    cout << ans << '\n';
    if (t == 1) {
        for (int i = 0; i < n; i++) {
            cout << kek[i] << ' ';
        }
        cout << '\n';
    }
    /* cout << pr.first << '\n';
    if (t == 1) {
        for (int i = 0; i < n; i++) {
            cout << pr.second[i] << ' ';
        }
    }
    cout << '\n'; */
    fflush(stdout);
    return 0;
}
