#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int median(int a, int b, int c) {
	vector <int> arr = { a, b, c };
	sort(arr.begin(), arr.end());
	return arr[1];
}

void solve() {
	int n, t;
	cin >> n >> t;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	vector <pair <int, int>> seg;
	for (int i = 1; i + 1 < n; ++i) {
		if (a[i] != a[i - 1]) {
			seg.push_back({ i, i });
			for (int j = i; j + 1 < n; ++j) {
				if (a[j] != a[j + 1]) {
					seg.back().second = j;
				}
				else break;
			}
			i = seg.back().second;
			if (seg.back().first == seg.back().second) seg.pop_back();
		}
	}
	int ans = 0;
	vector <int> an = a;
	for (auto& i : seg) {
		for (int j = i.first; j <= i.second; ++j) {
			int dist = min(j - i.first, i.second - j);
			if (dist % 2 == 0) an[j] = (a[j] == 1 ? 2 : 1);
		}
		ans = max(ans, (i.second - i.first + 2) / 2);
	}
	cout << ans << "\n";
	if (t == 1) {
		for (auto& i : an) cout << i << " ";
	}
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}