#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

int ans = 0;
int n;
vector<int> a;
vector<int> can;

bool ok(int x) {
    if (x == 0 || x == n - 1) return true;
    return min(a[x - 1], a[x + 1]) <= a[x] && a[x] <= max(a[x - 1], a[x + 1]);
}

bool solve() {
    int last = 0;
    vector<int> can2;
    for (int i = 0; i < sz(can); i++) {
        int j = can[i];
        int add;
        if (i == 0 || (i > 0 && can[i - 1] + 1 != can[i])) {
            last = a[j - 1];
        }
        if (min(a[j], a[j + 1]) <= last && last <= max(a[j], a[j + 1])) {
            add = last;
        } else {
            add = a[j + 1];
        }
        last = a[j];
        a[j] = add;
        if (!ok(j - 1)) {
            can2.emplace_back(j - 1);
        }
        if (i + 1 < sz(can) && can[i + 1] > j + 1) {
            if (!ok(j)) {
                can2.emplace_back(j);
            }
        }
        if (i + 1 < sz(can) && can[i + 1] > j + 2) {
            if (!ok(j)) {
                can2.emplace_back(j);
            }
        }
    }
    swap(can, can2);
    return sz(can);
}

void rec(int l, int r) {
    ans = max(ans, (r - l + 1 + 1) / 2);
    if (a[l - 1] == a[r + 1]) {
        for (int i = l; i <= r; i++) {
            a[i] = a[l - 1];
        }
    } else {
        int j = l;
        for (int i = l; i <= r; i++) {
            if (a[i] == a[l - 1]) {
                swap(a[i], a[j]);
                j++;
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> n >> t;
    if (n <= 1000) {
        a.resize(n);
        for (auto &el : a) cin >> el;
        for (int i = 0; i < n; i++) {
            if (!ok(i)) {
                can.emplace_back(i);
            }
        }
        int cnt = 0;
        if (sz(can)) cnt++;
        while (solve()) {
            cnt++;
        }
        cout << cnt << "\n";
        if (t) {
            for (auto &el : a) {
                cout << el << " ";
            }
        }
        return 0;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int j = 1;
    for (; j < n; j++) {
        while (j < n && a[j] == a[j - 1]) j++;
        if (j >= n) continue;
        int i = j;
        while (j + 1 < n && a[j] != a[j + 1]) j++;
        j--;
        if (i > j) {
            j++;
            continue;
        }
        rec(i, j);
        j++;
    }
    cout << ans << "\n";
    if (t) {
        for (auto &el : a) {
            cout << el << " ";
        }
        cout << "\n";
    }
    return 0;
}