#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int median(int a, int b, int c) {
	vector <int> arr = { a, b, c };
	sort(arr.begin(), arr.end());
	return arr[1];
}

void solve() {
	int n, t;
	cin >> n >> t;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	int second_subtask = 1;
	for (int i = 0; i < n; ++i) {
		if (a[i] > 2) second_subtask = 0;
	}
	if (second_subtask) {
		vector <pair <int, int>> seg;
		for (int i = 1; i + 1 < n; ++i) {
			if (a[i] != a[i - 1] && a[i] != a[i + 1]) {
				seg.push_back({ i, i });
				for (int j = i; j + 1 < n; ++j) {
					if (a[j] != a[j + 1]) {
						seg.back().second = j;
					}
					else break;
				}
				i = seg.back().second;
				//if (seg.back().first == seg.back().second) seg.pop_back();
			}
		}
		int ans = 0;
		vector <int> an = a;
		for (auto& i : seg) {
			for (int j = i.first; j <= i.second; ++j) {
				int dist = min(j - i.first, i.second - j);
				if (dist % 2 == 0) an[j] = (a[j] == 1 ? 2 : 1);
			}
			ans = max(ans, (i.second - i.first + 2) / 2);
		}
		cout << ans << "\n";
		if (t == 1) {
			for (auto& i : an) cout << i << " ";
		}
	}
	else {
		for (auto& i : a) cin >> i;
		vector <int> changed(n);
		for (int i = 0; i < n; ++i) changed[i] = i;
		int ans = 0;
		while (1) {
			vector <int> changed2, val;

			for (auto& i : changed) {
				for (int j = max(i - 2, 0ll); j + 2 < n && j <= i; ++j) {
					if (a[j + 1] != median(a[j], a[j + 1], a[j + 2])) {
						changed2.push_back(j + 1);
						val.push_back(median(a[j], a[j + 1], a[j + 2]));
					}
				}
			}

			changed2.clear();
			val.clear();
			for (int j = 0; j + 2 < n; ++j) {
				if (a[j + 1] != median(a[j], a[j + 1], a[j + 2])) {
					changed2.push_back(j + 1);
					val.push_back(median(a[j], a[j + 1], a[j + 2]));
				}
			}

			if (changed2.size() == 0) {
				cout << ans << "\n";
				if (t == 1) {
					for (auto& i : a) cout << i << " ";
				}
				return;
			}
			else {
				++ans;
				changed = changed2;
				for (int i = 0; i < changed.size(); ++i) {
					a[changed[i]] = val[i];
				}

			}
		}
	}
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}