#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;
typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector <int> v(n);
    int mx = 0;
    for(int i = 0; i < n; ++i) {
        cin >> v[i];
        mx = max(mx, v[i]);
    }

    if(mx <= 2) {
        int c = 0;
        vector <int> cher(n, 1);
        cher[0] = 0;
        cher[n - 1] = 0;
        for(int i = 1; i < n - 1; ++i) {
            if(v[i] == v[i - 1] || v[i] == v[i + 1]) cher[i] = 0;
        }
//        for(auto i : cher) cout << i << ' '; cout << '\n';
        vector <int> cnt = {1};
        for(int i = 1; i < n; ++i) {
            if(cher[i] == cher[i - 1]) {
                cnt.back()++;
            } else {
                cnt.push_back(1);
            }
        }
        assert(cnt.size() % 2 == 1);
//        for(auto i : cnt) cout << i << ' '; cout << '\n';
        for(int i = 1; i < cnt.size(); i += 2) {
            c = max(c, (cnt[i] + 1) / 2);
        }
        cout << c << '\n';
        if(t == 0) return;
        /*int now_color = v[0];
        for(int i = 0; i < cnt.size(); ++i) {
            for(int j = 0; j < cnt[i]; ++j) {
                cout << now_color << '\n';
            }
        }*/
        for(int i = 1; i < cnt.size(); i += 2) {
            cnt[i - 1] += cnt[i] / 2;
            cnt[i + 1] += (cnt[i] + 1) / 2;
            cnt[i] %= 2;
        }
        int now_color = v[0];
        for(int i = 0; i < cnt.size(); ++i) {
            if(i % 2 == 0) {
                for(int j = 0; j < cnt[i]; ++j) {
                    cout << now_color << ' ';
                }
            } else {
                if(cnt[i] == 0) {
                    now_color = 3 - now_color;
                }
            }
        }
        cout << '\n';
        return;
    }

    int c = 0;
    while(true) {
        vector <int> nv = v;
        for(int i = 1; i < n - 1; ++i) {
            int a = min(min(v[i - 1], v[i]), v[i + 1]);
            int b = max(max(v[i - 1], v[i]), v[i + 1]);
            nv[i] = v[i - 1] ^ v[i] ^ v[i + 1] ^ a ^ b;
            /*if(v[i] <= min(v[i - 1], v[i] + 1)) {
                nv[i] = min(v[i - 1], v[i + 1]);
            } else if(v[i] >= max(v[i - 1], v[i + 1])) {
                nv[i] = max(v[i - 1], v[i + 1]);
            } else {
                nv[i] = v[i];
            }*/
        }
        if(nv == v) break;
        c++;
        v.swap(nv);
    }
    cout << c << '\n';
    if(t == 1) {
        for(auto i : v) cout << i << ' '; cout << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    solve();
    return 0;
}