#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//#define int ll

vector<int> a;
int ans = 0;

void calc(int l, int r) {
	int q = 0;
	if (a[l] == a[r]) {
		q = (r - l) / 2;
		for (int i = l + 1; i < r; i++) {
			a[i] = a[l];
		}
	}
	else {
		q = (r - l - 1) / 2;
		if (a[l] == 1) {
			sort(a.begin() + l, a.begin() + r);
		}
		else {
			sort(a.begin() + l, a.begin() + r);
			reverse(a.begin() + l, a.begin() + r);
		}
	}
	ans = max(ans, q);
}

inline void solve() {
	int n, t;
	cin >> n >> t;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (*max_element(all(a)) == 2) {
		int l = 0;
		for (int i = 1; i < n; i++) {
			if (a[i] == a[i - 1]) {
				calc(l, i - 1);
				l = i;
			}
		}
		calc(l, n - 1);
	}
	else {
		ans = -1;
		while (1) {
			vector<int> new_a(n);
			new_a[0] = a[0];
			new_a[n - 1] = a[n - 1];
			for (int i = 1; i + 1 < n; i++) {
				int q = a[i - 1], w = a[i], e = a[i + 1];
				new_a[i] = q + w + e - max(max(q, w), e) - min(min(q, w), e);
			}
			ans++;
			if (a == new_a) {
				break;
			}
			a = new_a;
		}
	}
	cout << ans << nl;
	if (t) {
		for (auto t : a) {
			cout << t << ' ';
		}
	}
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}