#include <bits/stdc++.h>
#define int long long
using namespace std;

struct Stupid {
    vector<int> a;
    int n;

    Stupid(vector<int> a): a(a) {
        n = a.size();
    }

    int get_bi(int i) {
        vector<int> v = {a[i-1], a[i], a[i+1]};
        sort(v.begin(), v.end());
        return v[1];
    }

    int upd() {
        vector<int> b = a;

        for(int i = 1; i < n-1; ++i) {
            b[i] = get_bi(i);
        }

        int flag = (a!=b);
        a = b;
        return flag;
    }

    pair<int, vector<int>> solve() {
        int res = 0;

        while(upd()) res++;

        return {res, a};
    }
};

struct Solver {
    vector<int> a;
    int n;

    Solver(vector<int> a): a(a) {
        n = a.size();
    }

    int get_bi(int i) {
        vector<int> v = {a[i-1], a[i], a[i+1]};
        sort(v.begin(), v.end());
        return v[1];
    }

    int upd() {
        vector<int> b = a;

        for(int i = 1; i < n-1; ++i) {
            b[i] = get_bi(i);
        }

        int flag = (a!=b);
        a = b;
        return flag;
    }

    pair<int, vector<int>> solve_2() {
        vector<int> b = a;
        int res = 0;

        vector<int> c;
        c.push_back(0);
        c.push_back(n-1);

        for(int i = 1; i < n-1; ++i)
            if((a[i] == a[i-1]) || (a[i] == a[i+1]))
                c.push_back(i);

        sort(c.begin(), c.end());

        for(int i = 1; i < n-1; ++i) {
            if((a[i] == a[i-1]) || (a[i] == a[i+1]))
                continue;

            auto p = lower_bound(c.begin(), c.end(), i);
            auto pp = p;
            pp--;

            int prv = *pp, nxt = *p;

            if(abs(prv-i) < abs(nxt-i)) {
                res = max(res, abs(prv-i));
                b[i] = a[prv];
            } else {
                res = max(res, abs(nxt-i));
                b[i] = a[nxt];
            }
        }

        return {res, b};
    }

    int group_2() {
        for(int i : a)
            if(i > 2) return 0;
        return 1;
    }

    pair<int, vector<int>> solve() {
        if(a.size() > 1000) return solve_2();

        int res = 0, flag = 1;
        for(int i = 0; n*i <= 4e7; ++i) {
            if(!upd()) {
                flag = 0;
                break;
            }
            res++;
        }

        if(flag) {
            pair<int, vector<int>> ans = solve_2();
            ans.first += res;
            return ans;
        }

        return {res, a};
    }
};

vector<int> get_a(int n, int m) {
    vector<int> a(n, 0);
    for(int i = 0; i < n; ++i)
        a[i] = rand() % m;

    return a;
}

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 1000 : 1);
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n, t;
            cin >> n >> t;

            vector<int> a(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> a[i];

            Solver solver(a);
            pair<int, vector<int>> res = solver.solve();
            cout << res.first << "\n";

            if(t) {
                for(int i : res.second)
                    cout << i << " ";
                cout << "\n";
            }

        } else {
            int n = 20;
            vector<int> a = get_a(n, 2);

            Stupid stupid(a);
            Solver solver(a);

            pair<int, vector<int>> tres = stupid.solve();
            pair<int, vector<int>> res = solver.solve();

            if(res != tres) {
                cout << "MDA: " << res.first << " " << tres.first << "\n";

                cout << "A: ";
                for(int i : a) cout << i << " ";
                cout << "\n";

                cout << "R: ";
                for(int i : res.second) cout << i << " ";
                cout << "\n";

                cout << "T: ";
                for(int i : tres.second) cout << i << " ";
                cout << "\n";

                cout << "\n";
            }
        }
    }

    return 0;
}
