#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 500010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

int a[MX];
int b[MX];

int mid(int x, int y, int z) {
    vi arr = {x, y, z};
    sort(all(arr));
    return arr[1];
}

int main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    bool alltwo = true;
    fi(0, n) {
        cin >> a[i];
        if (a[i] > 2)
            alltwo = false;
    }
    if (alltwo) {
        fi(0, n)
            b[i] = a[i];
        int mx = 0;
        int l = 0;
        int r = -1;
        while (l < n) {
            r = l + 1;
            while (r < n && a[r] != a[r - 1]) {
                ++r;
            }
            --r;
            if (a[r] == a[l]) {
                mx = max(mx, (r - l + 1) / 2);
                fill(b + l, b + r + 1, a[l]);
            } else {
                int cnt = (r - l + 1) / 2 -1;
                mx = max(mx, cnt);
                fill(b + l, b + l + cnt + 1, a[l]);
                fill(b + l + cnt + 1, b + r + 1, a[r]);
            }
            l = r + 1;
        }
        cout << mx << '\n';
        if (t) {
            fi(0, n)
                cout << b[i] << ' ';
        }
    } else {
        bool change = true;
        int cnt = -1;
        while (change) {
            ++cnt;
            change = false;
            memcpy(b, a, sizeof(int) * n);
            fi(1, n - 1) {
                int  m = mid(b[i - 1], b[i], b[i + 1]);
                if (a[i] != m) {
                    change = true;
                    a[i] = m;
                }
            }
        }
        cout << cnt << '\n';
        if (t) {
            fi(0, n)
                cout << a[i] << ' ';
        }
    }
}