#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 1e6 + 234;
const int M = 1e9 + 7;

int a[N];

int b[N];

int n, t;

int med(int x, int y, int z) {
    if (x < y) {
        swap(x, y);
    }
    if (y < z) {
        swap(y, z);
    }
    if (x < y) {
        swap(x, y);
    }
    return y;
}

void solve() {
    int uk = 0;
    int cnt;
    int cur;
    int ans = 0;
    int was;
    while (uk < n) {
        was = uk;
        cnt = 0;
        while (uk + 1 < n && a[uk + 1] != a[uk]) {
            ++uk;
            ++cnt;
        }
        if (!cnt) {
            ++uk;
            continue;
        }
        if (cnt % 2 == 0) {
            cur = cnt / 2;
            ans = max(ans, cur);
            for (int i = was; i <= uk; ++i) {
                a[i] = a[was];
            }
            ++uk;
        } else {
            cur = cnt / 2;
            ans = max(ans, cur);
            int mid = (cnt / 2);
            for (int i = was; i <= mid; ++i) {
                a[i] = a[was];
            }
            for (int i = mid + 1; i <= uk; ++i) {
                a[i] = a[uk];
            }
            ++uk;
        }
    }
    cout << ans << '\n';
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> t;
    bool run = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] < 1 || a[i] > 2) {
            run = 0;
        }
    }
    if (run) {
        solve();
        return 0;
    }
    run = 1;
    int ans = 0;
    while (run) {
        run = 0;
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        for (int i = 1; i + 1 < n; ++i) {
            b[i] = med(a[i - 1], a[i], a[i + 1]);
        }
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                run = 1;
            }
            a[i] = b[i];
        }
        ans += run;
    }
    cout << ans << '\n';
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
    }
    return 0;
}
