#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n, t;
vector <int> a;

int me(int a, int b, int c) {
    vector <int> x = {a, b, c};
    sort(x.begin(), x.end());
    return x[1];
}

void solve1() {
    int cnt = 0;
    while (true) {
        auto na = a;
        for (int i = 1; i < n - 1; i++)
            na[i] = me(a[i - 1], a[i], a[i + 1]);
        if (na == a)
            break;
        cnt++;
        a = na;
    }

    cout << cnt << '\n';
    if (t) {
        for (int x: a)
            cout << x << ' ';
    }

    exit(0);
}

void solve2() {

    int cheb = -1, chee = -1;
    auto na = a;
    int ans = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] != a[i - 1]) {
            if (cheb == -1) {
                cheb = i - 1;
                chee = i;
            }
            else
                chee++;
        }
        else {
            if (chee == -1)
                continue;
            ans += (chee - cheb) / 2;
            if ((chee - cheb) % 2 == 1) {
                for (int j = cheb; j <= cheb + (chee - cheb) / 2; j++)
                    na[j] = a[cheb];
                for (int j = cheb + (chee - cheb) / 2 + 1; j <= chee; j++)
                    na[j] = a[chee];

            }
            else {
                for (int j = cheb; j <= chee; j++)
                    na[j] = a[cheb];
            }
            chee = -1;
            cheb = -1;
        }
    }

    if (chee != -1) {
        ans += (chee - cheb) / 2;
        if ((chee - cheb) % 2 == 1) {
            for (int j = cheb; j <= cheb + (chee - cheb) / 2; j++)
                na[j] = a[cheb];
            for (int j = cheb + (chee - cheb) / 2 + 1; j <= chee; j++)
                na[j] = a[chee];

        }
        else {
            for (int j = cheb; j <= chee; j++)
                na[j] = a[cheb];
        }
    }

    cout << ans << '\n';
    if (t) {
        for (int x: na)
            cout << x << ' ';
    }

    exit(0);

}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> t;
    a.assign(n, 0);
    bool fl = true;
    for (int& x: a) {
        cin >> x;
        if (x != 1 && x != 2)
            fl = false;
    }
    if (fl && t == 0)
        solve2();
    if (n <= 1000)
        solve1();


    return 0;
}
