//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "  ";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll med(ll x, ll y, ll z)
{
    vector<ll> A;
    A.push_back(x);
    A.push_back(y);
    A.push_back(z);
    sort(all(A));
    return A[1];
}

vector<ll> grand()
{
    vector<ll> ans(11);
    for (int i = 0; i < 11; i++)
    {
        ans[i] = rand() % 10 + 1;
    }
    return ans;
}

void print(vector<ll> A)
{
    for (int i = 0; i < A.size(); i++)
        cout << A[i] << " ";
    cout << "\n";
}

bool to(vector<ll> &A)
{
    vector<ll> B = A;
    bool yk = false;
    for (int i = 1; i < int(A.size()) - 1; i++)
    {
        B[i] = med(A[i - 1], A[i], A[i + 1]);
        if (B[i] != A[i])
            yk = true;
    }
    A = B;
    return yk;
}

void print(vector<pair<ll, ll> > A)
{
    for (int i = 0; i < A.size(); i++)
    {
        cout << "{" << A[i].first << " " << A[i].second << "} ";
    }
    cout << "\n";
}

/**
14 1
0 1 0 1 0 0 1 1 0 1 0 1 0 0
*/

int main()
{
    fast();
    ll n, t;
    cin >> n >> t;
    vector<ll> A1(n);
    ll mx = -1;
    for (int i = 0; i < n; i++)
    {
        cin >> A1[i];
        A1[i]--;
        mx = max(mx, A1[i]);
    }
    vector<pair<ll, ll> > A;
    A.push_back({A1[0], 1});
    for (int i = 1; i < n; i++)
    {
        if (A.back().first == A1[i])
        {
            A.back().second++;
        }
        else
        {
            A.push_back({A1[i], 1});
        }
    }
    //print(A);
    vector<pair<ll, ll> > B;
    if (A.size() == 1)
    {
        cout << "0\n";
        if (t == 1)
        for (int i = 0; i < A[0].second; i++)
            cout << A[0].first + 1 << " ";
        return 0;
    }
    ll k = 0;
    if (mx <= 1)
    {
        A[0].second++;
        if (A.size() != 1)
            A.back().second++;
        ll Lb = 0;
        ll Rb = 0;
        while (true)
        {
            ll sum = A[Lb].second;
            Rb = Lb + 1;
            while (Rb < int(A.size()))
            {
                if (A[Rb].second > 1)
                    break;
                sum += A[Rb].second;
                Rb++;
            }
            if (Rb >= int(A.size()))
            {
                B.push_back(A.back());
                break;
            }
            //cout << "Lb = " << Lb << "  Rb = " << Rb << "\n";
            ll K = sum - A[Lb].second;
            //cout << "K =  "<< K << "\n";
            ///k += (K + 1) / 2;
            k = max(k, (K + 1) / 2);
            if (Lb == Rb)
                break;
            if (A[Lb].first == A[Rb].first)
            {
                B.push_back({A[Lb].first, sum});
                Lb = Rb;
                continue;
            }
            else
            {
                B.push_back({A[Lb].first, A[Lb].second + K / 2});
                B.push_back({A[Rb].first, K / 2});
                Lb = Rb;
            }
        }
        cout << k << "\n";
        if (t == 1)
        {
            for (int i = 0; i < B.size(); i++)
            {
                ll kol = B[i].second;
                if (i == 0 || i == B.size() - 1)
                    kol--;
                ll a = B[i].first;
                while (kol--)
                    cout << a + 1 << " ";
            }
        }
        return 0;
    }

    while (true)
    {
        if (A.size() == 1)
            break;
        B.clear();
        B.push_back(A[0]);
        bool yk = false;
        for (int i = 1; i < int(A.size()) - 1; i++)
        {
            if (A[i].second > 1)
            {
                if (B.back().first == A[i].first)
                    B.back().second += A[i].second;
                else
                    B.push_back(A[i]);
                continue;
            }
            ll me = med(A[i - 1].first, A[i].first, A[i + 1].first);
            if (me != A[i].first)
                yk = true;
            if (me == B.back().first)
            {
                B.back().second++;
                continue;
            }
            B.push_back({me, 1});
        }
        if (A.back().first == B.back().first)
            B.back().second += A.back().second;
        else
            B.push_back(A.back());
        A.clear();

        A = B;
        if (!yk)
            break;
        k++;
    }
    cout << k << "\n";
    if (t == 1)
    {
        for (int i = 0; i < A.size(); i++)
        {
            ll kol = A[i].second;
            ll a = A[i].first;
            while (kol--)
                cout << a + 1 << " ";
        }
    }
}
