#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

int n;

int mid(int a, int b, int c) {
	vector <int> asd = { a, b, c };
	sort(asd.begin(), asd.end());
	return asd[1];
}

int EasyMod(vector <int>& val) {
	int ans = 0;
	while (true) {
		vector <int> rofl(n);
		rofl[0] = val[0], rofl.back() = val.back();
		ans++;
		for (int i = 1; i < n - 1; i++) {
			int cur = mid(val[i - 1], val[i], val[i + 1]);
			rofl[i] = cur;
		}
		if (rofl == val) break;
		else val = rofl;
	}

	return ans - 1;
}

int main() {
	
	fstream cin("input.txt");
	ofstream cout("output.txt");

	int t; cin >> n >> t;
	vector <int> val(n);

	for (int i = 0; i < n; i++)
		cin >> val[i];

	if (n <= 1000) {
		cout << EasyMod(val) << endl;
		for (int i = 0; i < n; i++)
			cout << val[i] << ' ';
		return 0;
	}

	vector <int> rofl(n);
	rofl.back() = val.back();

	int pos = 0, Max = -1;
	for (int i = pos; i < n - 1; i++)
		if (val[i] == val[i + 1] || i == n - 2) {
			rofl[pos] = val[pos];
			int add = 0;
			if (i == n - 2 && val[i] != val[i + 1]) add++;
			rofl[i] = val[i + 1];
			Max = max(Max, (i - pos + add) / 2);
			if (val[pos] == val[i + 1])
				for (int c = pos; c <= i; c++)
					rofl[c] = val[pos];
			else if (val[pos] == 1) {
				int cnt = (i - pos) / 2;
				for (int c = pos + 1; c <= pos + cnt; c++)
					rofl[c] = 1;
				for (int c = pos + cnt + 1; c <= i; c++)
					rofl[c] = 2;
			}
			else {
				int cnt = (i - pos) / 2;
				for (int c = pos + 1; c <= pos + cnt; c++)
					rofl[c] = 2;
				for (int c = pos + cnt + 1; c <= i; c++)
					rofl[c] = 1;
			}
			pos = i + 1;
		}
	
	cout << Max << endl;
	for (int i = 0; i < n; i++)
		cout << rofl[i] << ' ';

}

