#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T, class U> using ordered_map = tree<T, U, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int median(int a, int b, int c) {
    if (a <= b) {
        if (b <= c) {
            return b;
        } else if (c >= a) {
            return c;
        } else {
            return a;
        }
    } else {
        if (c >= a) {
            return a;
        } else if (c >= b) {
            return c;
        } else {
            return b;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    bool run = true;
    int it = 0;
    vector<pair<int, int>> seg = {{1, n - 2}};
    vector<int> b(n);
    while (!seg.empty()) {
        vector<pair<int, int>> new_seg;
        for (auto &[l, r] : seg) {
            int nl = -1, nr = -1;
            for (int i = l; i <= r; i++) {
                b[i] = median(a[i - 1], a[i], a[i + 1]);
                if (b[i] == a[i]) {
                    if (nl != -1) {
                        new_seg.emplace_back(nl, i - 1);
                        nl = -1;
                    }
                } else {
                    if (nl == -1) {
                        nl = i;
                    }
                }
            }
            if (nl != -1) {
                new_seg.emplace_back(nl, r);
            }
        }
        for (auto &[l, r] : seg) {
            for (int i = l; i <= r; i++) {
                a[i] = b[i];
            }
        }
        int sum = 0;
        for (auto &[l, r] : new_seg) {
            sum += (r - l) / 2;
        }
        cout << sum;
        return 0;
        swap(seg, new_seg);
        it++;
    }
    assert(it - 1 <= n);
    if (t) {
        cout << it - 1 << '\n';
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    } else {
        cout << it - 1;
    }
    return 0;
}