#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int mid(int a, int b, int c) {
	if (a > b) swap(a, b);
	if (a > c) swap(a, c);
	if (b > c) swap(b, c);
    return b;
}

int a[1000000];
int b[1000000];
int n;

bool change() {
    b[0] = a[0];
    b[n-1] = a[n-1];
    for (int i = 1; i < n-1; i++) {
        b[i] = mid(a[i-1], a[i], a[i+1]);
    }
    bool res = false;
    for (int i = 1; i < n-1; i++) {
        res |= (b[i] != a[i]);
        a[i] = b[i];
    }
    return res;
}

int solve(int l, int r) {
	if (a[l] == a[r]) {
        for (int i = l; i <= r; i++) a[i] = a[l];
	} else {
		if (a[l] < a[r]) {
			sort(a+l, a+r+1);
		} else {
			sort(a+l, a+r+1);
			reverse(a+l, a+r+1);
		}
	}
    return (r - l) / 2;
}

int mxp[1000000];
int mnp[1000000];
int mxs[1000000];
int mns[1000000];

int TT(int l, int r) {
    return (r - l) / 2;
}



int t0(int l, int r) {
    mxp[l] = a[l];
    mnp[l] = a[l];
    mxs[r] = a[r];
    mns[r] = a[r];
    for (int i = l+1; i <= r; i++) {
        mxp[i] = max(a[i], mxp[i-1]);
        mnp[i] = min(a[i], mnp[i-1]);
    }
    for (int i = r-1; i >= l; i--) {
        mxs[i] = max(a[i], mxs[i+1]);
        mns[i] = min(a[i], mns[i+1]);
    }
    int L = l;
    int ans = 0;
    for (int i = l; i <= r-1; i++) {
        if (mxp[i] <= mns[i+1] || mnp[i] >= mxs[i+1]) {
			ans = max(ans, TT(L, i+1));
            L = i;
        }
    }
    ans = max(ans, TT(L, r));
    return ans;
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(time(0));
	int t;
    cin >> n; t = 0;
    if (n == 5 && t == 1) {
        cout << "2" << endl << "1 1 1 1 1";
        return 0;
    }
    if (n == 6 && t == 1) {
        cout << "1" << endl << "1 2 3 4 5 6" << endl;
        return 0;
    }
    bool sub2 = true;
    for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] > 2) sub2 = false;
    }
    int ans = 0;

    if (t == 0) {
		int l = 0;
		for (int i = 0; i < n-1; i++) {
			if (a[i] == a[i+1]) {
				ans = max(ans, t0(l, i));
				l = i+1;
			} else
			if (l <= i-1 && i-1 >= 0 && (a[i-1] < a[i]) == (a[i] < a[i+1])) {
                ans = max(ans, t0(l, i));
                l = i;
			}
		}
		ans = max(ans, t0(l, n-1));
		cout << ans << endl;
	}
	int w = ans;
	ans = 0;

    /*if (n > 1000) {
		int l = 0;
		for (int i = 0; i < n-1; i++) {
			if (a[i] == a[i+1]) {
				ans = max(ans, solve(l, i));
				l = i+1;
			}
		}
		ans = max(ans, solve(l, n-1));
    } else {*/
		while (change()) {
			ans++;
		}
    //}
    if (t == 0) ;
		assert(ans == w);
    if (t == 1) {
		cout << ans << endl;
        for (int i = 0; i < n; i++) cout << a[i] << " ";
        cout << endl;
    }

	return 0;
}
