#include<bits/stdc++.h>
using namespace std;
const int nmax=1e6+42;
int n,t,inp[nmax];

vector<int> to_check;

int L_BORDER,R_BORDER;

int median(int pos)
{
    if(pos==L_BORDER||pos==R_BORDER)return inp[pos];

    int arr[3]={inp[pos-1],inp[pos],inp[pos+1]};
    sort(arr,arr+3);
    return arr[1];
}
int get_med(int a,int b,int c)
{
    int w[3]={a,b,c};
    sort(w,w+3);
    return w[1];
}
int get_after_two_turns(int pos)
{
    if(pos==L_BORDER||pos==R_BORDER)return inp[pos];
    return get_med(median(pos-1),median(pos),median(pos+1));
}
bool special(int i)
{
    if(i==1||i==n)return 0;
    if(inp[i-1]>inp[i]&&inp[i]<inp[i+1])return 1;
    if(inp[i-1]<inp[i]&&inp[i]>inp[i+1])return 1;
    return 0;
}

bool added[nmax];

bool on[nmax];

int help[nmax];
bool make_move(int l,int r)
{
    bool make=0;
    for(int i=l+1;i<r;i++)
        if(special(i)){help[i]=median(i);make=1;}
        else help[i]=inp[i];

    for(int i=l+1;i<r;i++)
        inp[i]=help[i];
    return make;
}

bool check_two(int i)
{
    if(i==L_BORDER||i==R_BORDER)return 0;
    if(inp[i]!=get_after_two_turns(i))return 1;
    return 0;
}

bool added_to_new[nmax];
int solve(int l,int r)
{
    L_BORDER=l;
    R_BORDER=r;

    if(R_BORDER-L_BORDER<=1000)
    {
        int t=0;
        while(make_move(L_BORDER,R_BORDER))t++;
        return t;
    }
    //cout<<"L_BORDER= "<<L_BORDER<<" R_BORDER= "<<R_BORDER<<endl;

    int turns=0;

    vector<int> different_after_two_moves={};
    for(int i=L_BORDER+1;i<R_BORDER;i++)
        if(check_two(i))different_after_two_moves.push_back(i);

    while(different_after_two_moves.size())
    {
        turns+=2;

        bool over_done=1;

        for(auto k:different_after_two_moves)
        {
            if(get_after_two_turns(k)!=median(k)||get_after_two_turns(k-1)!=median(k-1)||get_after_two_turns(k+1)!=median(k+1))over_done=0;
            /*
            cout<<k<<" -> "<<get_after_two_turns(k)<<" "<<median(k)<<endl;
            cout<<k<<" -> "<<get_after_two_turns(k-1)<<" "<<median(k-1)<<endl;
            cout<<k<<" -> "<<get_after_two_turns(k+1)<<" "<<median(k+1)<<endl;
            */
            help[k]=get_after_two_turns(k);
        }

        turns=turns-over_done;
        //cout<<"turns= "<<turns<<" "<<over_done<<endl;

        for(auto k:different_after_two_moves)
            inp[k]=help[k];

        //cout<<"inp: ";for(int i=1;i<=n;i++)cout<<inp[i]<<" ";cout<<endl;
        //for(int i=1;i<=n;i++)cout<<i<<" -> "<<


        vector<int> new_different_after_two_moves={};
        for(auto k:different_after_two_moves)
        {
            for(int i=k-3;i<=k+3;i++)
                if(L_BORDER<i&&i<R_BORDER&&added_to_new[i]==0)
                {
                    if(check_two(i))
                    {
                        added_to_new[i]=1;
                        new_different_after_two_moves.push_back(i);
                    }
                }
        }

        different_after_two_moves=new_different_after_two_moves;
    }

    if(make_move(L_BORDER,R_BORDER))turns++;

    return turns;
}
int main()
{
    scanf("%i%i",&n,&t);
    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    L_BORDER=1;
    R_BORDER=n;

    int lst=-1;
    for(int i=2;i<n;i++)
        if(special(i))
            on[i]=1;

    int turns=0;
    for(int l=2;l<n;l++)
        if(on[l])
        {
            int r=l;
            while(on[r+1])r++;

            turns=max(turns,solve(l-1,r+1));
            l=r;
        }

    printf("%i\n",turns);
    if(t)
    {
        for(int i=1;i<=n;i++)
        {
            printf("%i",inp[i]);
            if(i==n)printf("\n");
            else printf(" ");
        }
    }
    return 0;
}
/*
5 1
1 2 1 2 1

6 1
1 3 2 5 4 6

6 0
1 1 2 2 1 1

8 1
6 7 8 9 2 3 4 5

11 1
1 2 1 2 1 2 1 2 1 2 1

11 1
1 2 1 2 1 2 1 2 1 2 2

4 1
1 2 2 1

5 1
2 8 5 1 10

10 1
4 1 11 13 12 14 7 13 6 6

20 1
12 2 5 12 9 9 2 7 14 9 7 14 2 7 13 3 8 2 15 8
2
12 5 5 9 9 9 7 7 9 9 9 7 7 7 7 7 8 8 8 8

*/
