#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;

vector<int> shift(vector<int> &a) {
    int n = a.size();
    vector<int> b(n);
    b[0] = a[0];
    b[n - 1] = a[n - 1];
    for (int i = 1; i < n - 1; ++i) {
        vector<int> mbo;
        mbo.pb(a[i]);
        mbo.pb(a[i - 1]);
        mbo.pb(a[i + 1]);
        sort(all(mbo));
        b[i] = mbo[1];
    }
    return b;
}

//12 1
//1 1 2 1 1 2 1 2 1 1 2 1

void solve() {
    int n, t;
    cin >> n;
    cin >> t;
    vector<int> a(n);
    bool flag = true;
    rep(i, n) {
        cin >> a[i];
        if (a[i] > 2) flag = false;
    }
    int ans = 0;
    if (!flag) {
        while (true) {
            vector<int> b = shift(a);
            if (a == b) break;
            ans++;
            a = b;
        }
        cout << ans << endl;
        for (int x : a) {
            cout << x << ' ';
        }
    }
    else {
        vector<int> res(n);
        res[0] = a[0];
        res[n - 1] = a[n - 1];
        for (int i = 0; i < n - 1;) {
            if (a[i] == a[i + 1]) {
                res[i] = a[i];
                i++;
            }
            else {
                int r = i + 1;
                while (r + 1 < n && a[r] != a[r + 1]) {
                    r++;
                }
                if ((r - i + 1) % 2 != 0) {
                    for (int j = i; j <= r; ++j) res[j] = a[i];
                    ans = max(ans, (r - i + 1) / 2);
                }
                else {
                    vector<int> mbo;
                    for (int j = i; j <= r; ++j) mbo.pb(a[j]);
                    sort(all(mbo));
                    if (a[i] == 2) reverse(all(mbo));
                    int it = 0;
                    for (int j = i; j <= r; ++j) {
                        res[j] = mbo[it];
                        it++;
                    }
                    ans = max(ans, (r - i + 1) / 2 - 1);
                }
                i = r + 1;
            }
            
        }
        cout << ans << endl;
        if (t == 0) return;
        for (int x : res) {
            cout << x << ' ';
        }
    }
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}