#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

const int N = 5e5 + 5;
int a[N], b[N];
int ans = 0;
int n, t;

void solve12() {
	int last = 1;

	for (int i = 2; i <= n; i++) {
		if (a[i] == a[i + 1]) {
			if (i != last) {
				if (a[last] == a[i]) {
					for (int j = last + 1; j < i; j++) {
						a[j] = a[i];
					}
					ans = max(ans, (i - last) / 2);
				}
				else {
					ans = max(ans, (i - last - 1) / 2);
					for (int j = last + 1, k = i - 1; j < k; j++, k--) {
						a[j] = a[last];
						a[k] = a[i];
					}
				}
			}
			last = i + 1;
		}
	}
}

void solve_slow() {
	bool work = true;
	while (work) {
		work = false;
		for (int i = 1; i <= n; i++) {
			if (a[i - 1] > a[i] && a[i + 1] > a[i]) {
				b[i] = min(a[i + 1], a[i - 1]);
				work = true;
			}
			else if (a[i - 1] < a[i] && a[i + 1] < a[i]) {
				b[i] = max(a[i - 1], a[i + 1]);
				work = true;
			}
			else {
				b[i] = a[i];
			}
		}
		for (int i = 1; i <= n; i++)
			a[i] = b[i];
		if (work)
			ans++;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	
	cin >> n >> t;


	bool simple = true;

	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		if (a[i] > 2)
			simple = false;
	}

	// cout << simple << "\n";

	a[0] = a[1];
	a[n + 1] = a[n];

	if (simple)
		solve12();
	else
		solve_slow();
	
		

	cout << ans << "\n";

	if (t == 1) {
		for (int i = 1; i <= n; i++) {
			cout << a[i] << " ";
		}
	}

	return 0;
}