#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

ll operator "" iq (ull x)
{
    return x + 35ll;
}
ll operator "" iq (ld x)
{
    return x + 35ll;
}
mt19937 mt(300iq);
int n;
vector <int> a;
vector <int> tmp;
vector <int> x;
int median(int a, int b, int c)
{
    x = {a, b, c};
    sort(all(x));
    return x[1];
}
int c_max = 0;
int checkrev(int l, int r)
{
    int kek = 1;
    for (int i = r - 1; i >= l; --i)
        kek = kek && (a[i] >= a[i + 1]);
    return kek;
}
int check(int l, int r)
{
    int kek = 1;
    for (int i = l + 1; i <= r; ++i)
        kek = kek && (a[i - 1] <= a[i]);
    return kek;
}
void solve(int l, int r, int tmpl, int tmpr, int c = 0)
{
    if (l > r)
        return;
    tmp[l] = tmpl, tmp[r] = tmpr;
hype:;
    int i = l + 1, j = r - 1;
    int pos = -1;
    while (i + 1 <= r && j - 1 >= l)
    {
        tmp[i] = median(a[i - 1], a[i], a[i + 1]);
        tmp[j] = median(a[j - 1], a[j], a[j + 1]);
        if (tmp[i] == tmp[i - 1])
        {
            pos = i - 1;
            break;
        }
        if (tmp[j] == tmp[j + 1])
        {
            pos = j;
            break;
        }
        ++i, --j;
    }
    if (pos == -1)
    {
        int flag = 0;
        for (int k = l; k <= r; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        if (!check(l, r) && !checkrev(l, r))
        {
            ++c;
            goto hype;
        }
        c_max = max(c_max, c + flag);
        return;
    }
    if (pos == i - 1) // in left part
    {
        int flag = 0;
        for (int k = l; k < pos; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        flag = flag || (a[pos] != tmp[pos]) || (a[pos + 1] != tmp[pos + 1]);
        solve(l, pos, a[l], tmp[pos], c + flag);
        solve(pos + 1, r, tmp[pos + 1], tmpr, c);
    }
    else // in right part
    {
        int flag = 0;
        for (int k = pos + 2; k <= r; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        flag = flag || (a[pos] != tmp[pos]) || (a[pos + 1] != tmp[pos + 1]);
        solve(l, pos, tmpl, tmp[pos], c);
        solve(pos + 1, r, tmp[pos + 1], a[r], c + flag);
    }
}

signed main()
{
    Start();
    int t;
    cin >> n >> t;
    a.resize(n), tmp.resize(n);
    cin >> a;
    solve(0, n - 1, a[0], a[n - 1]);
    cout << c_max << endl;
    if (t)
        cout << a;
    return 0;
}

/*

#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

int n;
vector <int> a;
vector <int> tmp;
int c_max = 0;
int checkrev(int l, int r)
{
    int kek = 1;
    for (int i = r - 1; i >= l; --i)
        kek = kek && (a[i] >= a[i + 1]);
    return kek;
}
int check(int l, int r)
{
    int kek = 1;
    for (int i = l + 1; i <= r; ++i)
        kek = kek && (a[i - 1] <= a[i]);
    return kek;
}
void solve(int l, int r, int tmpl, int tmpr, int c = 0)
{
    if (l > r)
        return;
    dbg("--"), dbg(a), dbg(tmp), dbg((pair{l,r})), dbg(tmpl), dbg("--");
    tmp[l] = tmpl, tmp[r] = tmpr;
hype:;
    int i = l + 1, j = r - 1;
    int pos = -1;
    while (i <= j && i + 1 <= r && j - 1 >= l)
    {
        tmp[i] = median(a[i - 1], a[i], a[i + 1]);
        tmp[j] = median(a[j - 1], a[j], a[j + 1]);
        if (tmp[i] == tmp[i - 1])
        {
            pos = i - 1;
            break;
        }
        if (tmp[j] == tmp[j + 1])
        {
            pos = j;
            break;
        }
        ++i, --j;
    }
    if (pos == -1)
    {
        int flag = 0;
        for (int k = l; k <= r; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        if (!check(l, r) && !checkrev(l, r))
        {
            ++c;
            goto hype;
        }
        c_max = max(c_max, c + flag);
        return;
    }
    if (pos == i - 1) // in left part
    {
        int flag = 0;
        for (int k = l; k < pos; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        flag = flag || (a[pos] != tmp[pos]) || (a[pos + 1] != tmp[pos + 1]);
        dbg(a), dbg(tmp), dbg((pair{l,r})), dbg(pos);
        solve(l, pos, a[l], tmp[pos], c + flag);
        solve(pos + 1, r, tmp[pos + 1], tmpr, c);
    }
    else // in right part
    {
        int flag = 0;
        for (int k = pos + 2; k <= r; ++k)
        {
            if (a[k] != tmp[k])
                a[k] = tmp[k], flag = 1;
        }
        flag = flag || (a[pos] != tmp[pos]) || (a[pos + 1] != tmp[pos + 1]);
        dbg("--"), dbg(a), dbg(tmp), dbg((pair{l,r})), dbg(pos), dbg(tmpl), dbg("--");
        solve(l, pos, tmpl, tmp[pos], c);
        solve(pos + 1, r, tmp[pos + 1], a[r], c + flag);
    }
}
vector <int> x;
int median(int a, int b, int c)
{
    x = {a, b, c};
    sort(all(x));
    return x[1];
}
signed main()
{
    Start();
    int n, type;
    cin >> n >> type;
    vector <int> a(n);
    cin >> a;
    vector <int> b = a;
    int c = 0;
    while (true)
    {
        b = a;
        for (int i = 1; i + 1 < n; ++i)
        {
            b[i] = median(a[i - 1], a[i], a[i + 1]);
        }
        int flag = 0;
        for (int i = 0; i < n; ++i)
            if (a[i] != b[i])
                a[i] = b[i], flag = 1;
        if (!flag)
            break;
        dbg(a);
        ++c;
    }
    cout << c << endl;
    if (type)
        cout << a;
    return 0;
}

   */
