#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int int64_t
#define pii pair<int, int>
#define double long double
#define S second
#define F first
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> orset;
// RRR() < exp(-(big - small) / t)

int n, t, ans;
vector<int> ar;

int mid(int i){
    if(i == 0 || i == n-1)
        return ar[i];
    vector<int> lol = {ar[i], ar[i-1], ar[i+1]};
    sort(lol.begin(), lol.end());
    return lol[1];
}

void solve(int l, int r, int c){
    if(l > r) return;
//    cout << l << " " << r << endl;
    bool f = false;
    int put = mid(l);
    for(int i = l+1; i <= r; i ++){
        int nw = mid(i);
        if(ar[i-1] != put) f = true;
        ar[i-1] = put;
        put = nw;
    }
    if(ar[r] != put) f = true;
    ar[r] = put;
    if(!f){
        return;
    }
    ans = max(ans, c);

    int ll = l, rr = r;
    while(ll < rr){
        while(ll == 0 || ar[ll] == ar[ll-1])
            ll ++;
        while(rr == n-1 || ar[rr] == ar[rr+1])
            rr --;
        solve(ll, rr, c + 1);
        break;
    }
}

int32_t main(){
    ios_base :: sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> t;
    ar.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> ar[i];
    solve(0, n-1, 1);
    cout << ans << endl;
    if(t){
        for(int x: ar)
            cout << x << " ";
    }
}
