#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")
#endif
using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

inline __attribute__((always_inline)) int min(int a, int b, int c) {
    if (a <= b && a <= c) return a;
    return b <= c ? b : c;
}
inline __attribute__((always_inline)) int max(int a, int b, int c) {
    if (a >= b && a >= c) return a;
    return b >= c ? b : c;
}
pair<int, vector<int>> model(int n, vector<int> a) {
    int i = 0;
    auto b = a;
    for (; ; i++) {
        bool ok = 0;
        for (int j = 1; j < n - 1; j++) {
            b[j] = a[j - 1] + a[j] + a[j + 1] - min(a[j - 1],  a[j], a[j + 1]) - max(a[j - 1], a[j], a[j + 1]);
            if (b[j] != a[j]) ok = 1;
        }
        if (!ok) break;
        a = b;
    }
    return {i, b};
}
pair<int, vector<int>> only2(int n, vector<int> a) {
    int ans = 0;
    int l = 0;
    for (int i = 1; i < n; ++i) {
        if (a[i - 1] == a[i]) {
            l = i;
            continue;
        }
        if (i == n - 1 || a[i] == a[i + 1]) {
            uax(ans, (i - l) / 2);
            if (a[l] == a[i])
                for (int j = l + 1; j < i; ++j) a[j] = a[l];
            else {
                for (int j = l + 1; j < i; ++j)
                    if (j - l < i - j) a[j] = a[l];
                    else a[j] = a[i];
            }
        }
    }
    return {ans, a};
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, t;
    cin >> n >> t;
    int mx = 0;
    vector<int> a(n);
    forn(i, n) {
        cin >> a[i];
        uax(mx, a[i]);
    }
    pair<int, vector<int>> p;
    if (mx <= 2) p = only2(n, a);
    else p = model(n, a);
    cout << p.x << el;
    if (t == 1)
        forn(i, n) cout << p.y[i] << ' ';
    return 0;
}