#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5e5 + 5;

int a[maxn];
int n, T;

inline int median(int x, int y, int z) {
    if (x <= y && x <= z)
        return min(y, z);
    else if (y <= x && y <= z)
        return min(x, z);
    else
        return min(x, y);
}


int mres[maxn];
void do_mres() {
    for (int i = 1; i <= n; i++)
        cerr << a[i] << " ";
    cerr << "\n";
    mres[1] = a[1];
    mres[n] = a[n];
    for (int i = 2; i < n; i++) {
        mres[i] = median(mres[i - 1], a[i], a[i + 1]);
    }
    for (int i = 1; i <= n; i++)
        cerr << mres[i] << " ";
    cerr << "\n";
}

multiset <int> St[2];

bool good() {
    if (St[0].empty() || St[1].empty())
        return true;
    multiset <int> :: iterator it1 = St[0].end(), it2 = St[1].end();
    it1--;
    it2--;
    return (*it2 < *St[0].begin() || *it1 < *St[1].begin());
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    cin >> n >> T;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int l = 1;
    int res = 0;
    for (int r = 1; r <= n; r++) {
        St[r % 2].insert(a[r]);
        while (!good()) {
            St[l % 2].erase(St[l % 2].find(a[l]));
            l++;
        }
        //cerr << l << " " << r << "\n";
        res = max(res, (r - l) / 2);
    }
    cout << res << "\n";
    return 0;
}
