#include <bits/stdc++.h>

#define ll long long

using namespace std;
ll m = 1e9 + 7;

ll hash1(ll i, ll j, vector<ll> &h, vector<ll> &p) {
    if (i != 0) {
        return (h[j] - (h[i - 1] * p[j - i + 1] + m) % m + m) % m;
    } else {
        return h[j];
    }
}

bool is_palin(ll i, ll j, vector<ll> &h, ll n, vector<ll> &p, vector<ll> &h1, vector<ll> &p1) {
    if (hash1(i, j, h, p) == hash1(n - 1 - j, n - 1 - i, h1, p1)) {
        return true;
    } else {
        return false;
    }
}

pair<ll, ll> dfs(ll i, vector<ll> &col, ll p, vector<ll> &col1, ll prev, vector<ll> &a) {
    if (col[i] == i || col1[i] == 1) {
        ll t = a[i];
        if (col1[i] == 1) {
            p -= 1;
            t = prev;
        }
        return {p, t};
    } else {
        col1[i] = 1;
        return dfs(col[i], col, p + 1, col1, a[i], a);
    }
}

int main() {
    ll n, t;
    cin >> n >> t;
    vector<ll> col(n), a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    col[0] = 0;
    col[n - 1] = n - 1;
    for (ll i = 1; i < n - 1; ++i) {
        if (a[i] >= a[i - 1] && a[i] <= a[i + 1] || a[i] >= a[i + 1] && a[i] <= a[i - 1]) {
            col[i] = i;
        } else {
            if ((a[i - 1] >= a[i] && a[i - 1] <= a[i + 1] || a[i - 1] <= a[i] && a[i - 1] >= a[i + 1]) &&
                ((a[i + 1] >= a[i] && a[i + 1] <= a[i - 1] || a[i + 1] <= a[i] && a[i + 1] >= a[i - 1]))) {
                if (col[i - 1] == i - 1) {
                    col[i] = i - 1;
                } else {
                    col[i] = i + 1;
                }
            } else if (((a[i - 1] >= a[i] && a[i - 1] <= a[i + 1] || a[i - 1] <= a[i] && a[i - 1] >= a[i + 1]))) {
                col[i] = i - 1;
            } else {
                col[i] = i + 1;
            }
        }
    }
    ll cont = 0;
    vector<ll> ans(n);
    for (ll i = 0; i < n; ++i) {
        vector<ll> col1(n);
        pair<ll, ll> q = dfs(i, col, 0, col1, a[i], a);
        cont = max(cont, q.first);
        ans[i] = q.second;
    }
    cout << cont << endl;
    if (t == 1) {
        for (ll i = 0; i < n; ++i) {
            cout << ans[i] << " ";
        }
    }
    return 0;
}