#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

using namespace std;

void go(int n, int t, vector<int>& a) {
    vector<pair<int, int>> b;
    for (int i = 0; i < n; i++) {
        int j = i + 1;
        while (j < n && a[j] != a[j - 1]) j++;
        if (j - i > 1) b.pb({ i, j - 1 });
        i = j;
    }
    int ans = 0;
    for (auto& p : b) {
        int l = p.first;
        int r = p.second;
        if ((r - l + 1) % 2) {
            ans = max((r - l + 1) / 2, ans);
            for (int i = l; i <= r; i++) a[i] = a[l];
        }
        else {
            ans = max((r - l) / 2, ans);
            for (int i = l; i <= (l + r) / 2; i++) {
                a[i] = a[l];
            }
            for (int i = (l + r) / 2 + 1; i <= r; i++) {
                a[i] = a[r];
            }
        }
    }
    cout << ans << '\n';
    if(t) for (int i : a) cout << i << " ";
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    bool good = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 2) good = false;
    }
    if (good) {
        go(n, t, a);
        return;
    }

    vector<int> nw = a;
    int ans = 0;
    while (true) {
        bool good = true;
        for (int i = 1; i < n - 1; i++) {
            vector<int> b = { a[i - 1], a[i], a[i + 1] };
            sort(all(b));
            if (a[i] != b[1]) good = false;
            nw[i] = b[1];
        }
        swap(nw, a);
        if (good) break;
        ans++;
    }
    cout << ans << '\n';
    if (t) {
        for (int i : a) cout << i << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/