#include <iostream>
#include <cstring>
#include <cassert>

using namespace std;

const int N = 5e5 + 7;
int a[N], b[N];
bool ok[N];

int lazy(int n, int t) {
    memset(ok, 0, sizeof(ok));
    ok[0] = ok[n - 1] = 1;
    int last = -1;
    int ans = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1] || a[i] == a[i + 1]) ok[i] = 1;
        if (ok[i]) {
            if (last != -1) {
                int len = i - last;
                ans = max(ans, (len + 1) / 2);
                if (a[last - 1] == a[i]) {
                    for (int j = last; j < i; j++) a[j] = a[i];
                } else {
                    int l = last, r = i - 1;
                    while (l < r) {
                        a[l] = a[l - 1];
                        a[r] = a[r + 1];
                        r--;
                        l++;
                    }
                }
            }
            last = -1;
        } else {
            if (last == -1) last = i;
        }
    }
    cout << ans << endl;
    if (t == 1) for (int i = 0; i < n; i++) cout << a[i] << ' ';
    cout << endl;
    return 0;
}

int main() {
    int n, t;
    cin >> n >> t;
    bool flag = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 2) flag = 0;
    }
    if (flag) return lazy(n, t);
    int c = 0;
    while (1) {
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        bool flag = 0;
        for (int i = 1; i < n - 1; i++) {
            if (a[i] > max(a[i - 1], a[i + 1])) b[i] = max(a[i - 1], a[i + 1]), flag = 1;
            else if (a[i] < min(a[i - 1], a[i + 1])) b[i] = min(a[i - 1], a[i + 1]), flag = 1;
            else b[i] = a[i];
        }
        //for (int i = 0; i < n; i++) cout << b[i] << ' ';
        //cout << endl;
        if (!flag) break;
        c++;
        memcpy(a, b, sizeof(a));
    }
    cout << c << endl;
    assert(2 * c <= n);
    if (t) {
        for (int i = 0; i < n; i++) cout << b[i] << ' ';
    }
    cout << endl;
    return 0;
}
