#pragma optimize("O3")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma optimize("unswitch-loops")
#pragma target("avx,avx2,sse,sse2,ssse3,sse4,popcnt")
#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(5e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;     

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, t;
vector<int> a;

inline int median(int a, int b, int c);

signed main() {
    boot_up();

    while (cin >> n >> t) {
        solve();
    }
}

void solve() {
    init(a, n);
    bool flag = true;
    int c = 0;
    for (auto & it : a) {
        cin >> it;

        if (it > 2) {
            flag = false;
        }
    }

    if (flag && n > 1) {
        vector<pair<int, int>> segs;
        int last = 0;
        for (int i = 1; i < n; ++i) {
            if (a[i] == a[i - 1]) {
                if (i - 1 - last + 1 > 1) {
                    segs.emplace_back(last, i - 1);
                }
                last = i;
            }
        }

        if (n - 1 - last + 1 > 1) {
            segs.emplace_back(last, n - 1);
        }

        for (const auto & [l, r] : segs) {
            int length = r - l + 1;

            if (length % 2) {
                for (int i = l + 1; i <= r - 1; ++i) {
                    a[i] = a[l];
                }
                int curr_c = length / 2;
                chkmax(c, curr_c);
            }
            else {
                int curr_c = length / 2 - 1;
                chkmax(c, curr_c);
                for (int i = l + 1; i <= l + length / 2 - 1; ++i) {
                    a[i] = a[l];
                }
                for (int i = l + length / 2; i <= r - 1; ++i) {
                    a[i] = a[r];
                }
            }
        }
    }
    else {
        while (1) {
            vector<int> b = a;
            for (int i = 1; i < n - 1; ++i) {
                b[i] = median(a[i - 1], a[i], a[i + 1]);
            }

            if (b == a) {
                break;
            }

            a = b;
            ++c;
        }
    }

    cout << c << '\n';
    if (t) {
        info(a);
    }
}

inline int median(int a, int b, int c) {
    vector<int> chto = {a, b, c};
    sort(all(chto));

    return chto[1];
}