#ifdef DEBUG
    #define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long

int median(int a, int b, int c) {
    vector<int> tmp = {a, b, c};
    sort(all(tmp));
    return tmp[1];
}

bool check(vector<int> &a) {
    int n = a.size();
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] != a[i + 1])
            return 0;
    }
    return 1;
}


signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    int n, t;
    cin >> n >> t;
    vector<int> a(n), b(n);
    for (int &i : a)
        cin >> i;

    if (n <= 1) {
        int it = 0;
        while (a != b) {
            it++;
            b = a;
            for (int i = 1; i < n - 1; ++i) {
                a[i] = median(b[i - 1], b[i], b[i + 1]);
            }
        }

        cout << it - 1 << '\n';
        if (t) {
            for (int i : a)
                cout << i << ' ';
        }
    } else {
        assert(t == 0);
        vector<int> fix;
        for (int i = 1; i < n - 1; ++i) {
            if (a[i - 1] > a[i] && a[i + 1] > a[i])
                fix.emplace_back(1);
            if (a[i - 1] < a[i] && a[i + 1] < a[i])
                fix.emplace_back(2);
        }
        a = fix;
        n = fix.size();
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        int pr = 0;
        vector<int> nxt(n);
        for (int i = 1; i < n - 1; ++i) {
            if (a[i + 1] == a[i] || a[i - 1] == a[i]) {
                b[i] = a[i];
                nxt[pr] = i;
                pr = i;
            }
        }
        nxt[pr] = n - 1;

        int cur = 0;
        int ans = 0;
        while (cur < n - 1) {
            ans = max((cur + nxt[cur]) / 2 - cur, ans);
            for (int j = cur; j <= (cur + nxt[cur]) / 2; ++j)
                b[j] = b[cur];
            for (int j = nxt[cur]; j > (cur + nxt[cur]) / 2; --j)
                b[j] = b[nxt[cur]];
            cur = nxt[cur];
        }
        cout << ans << '\n';
        if (t) {
            for (int i : b)
                cout << i << ' ';
        }
    }
    return 0;
}
