//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

int ans = 0, n;
vector<int> a, b;

void solve() {
	b[0] = a[0];
	b[n - 1] = a[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		b[i] = a[i - 1] + a[i] + a[i + 1] - min({a[i - 1], a[i], a[i + 1]}) - max({a[i - 1], a[i], a[i + 1]});
	}
	if (a == b) return;
	++ans;
	swap(a, b);
	solve();
}

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int t;
	cin >> n >> t;
	a.resize(n);
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		mx = max(mx, a[i]);
	}
	if (mx <= 2) {
		vector<int> res(n);
		vector<int> prev(n);
		vector<int> next(n);
		if (a[0] == 1) prev[0] = 1;
		if (a[n - 1] == 1) next[n - 1] = n - 2;
		--a[0];
		for (int i = 1; i < n; ++i) {
			--a[i];
			if (a[i] == 1) {
				prev[i] = prev[i - 1];
			} else {
				prev[i] = i + 1;
			}
		}
		for (int i = n - 2; i >= 0; --i) {
			if (a[i] == 1) {
				next[i] = next[i + 1];
			} else {
				next[i] = i - 1;
			}
		}
		int cnt = 1, ans = 0;
		for (int i = 1; i < n; ++i) {
			if (a[i] != a[i - 1]) {
				++cnt;
			} else {
				if (cnt <= 2)  {
					cnt = 1;
					continue;
				}
				ans = max(ans, (cnt - 1) / 2);
				int l = i - cnt, r = i - 1;
				cnt = 1;
				if (a[l] == 0) ++l;
				if (a[r] == 0) --r;
				int m = (l + r) / 2;
				if (prev[l] != l || l == 0) {
					for (int j = prev[l]; j <= m; ++j) res[j] = 1;
				}
				if (next[r] != r || r == n - 1) {
					for (int j = m; j <= next[r]; ++j) res[j] = 1;
				}
			}
		}
		if (cnt > 1) {
			ans = max(ans, (cnt - 1) / 2);
			int l = n - cnt, r = n - 1;
			cnt = 1;
			if (a[l] == 0) ++l;
			if (a[r] == 0) --r;
			int m = (l + r) / 2;
			if (prev[l] != l || l == 0) {
				for (int j = prev[l]; j <= m; ++j) res[j] = 1;
			}
			if (next[r] != r || r == n - 1) {
				for (int j = m; j <= next[r]; ++j) res[j] = 1;
			}
		}
		cout << ans << '\n';
		if (t) for (auto now : res) cout << now + 1 << ' ';
	} else {
		b.resize(n);
		solve();
		cout << ans << '\n';
		if (t) {
			for (auto now : a) {
				cout << now << ' ';
			}
		}
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}