#include<bits/stdc++.h>
using namespace std;
#define app push_back
#define all(a) a.begin(), a.end()
#define f first
#define s second
#define bp builtin_popcount
#define ll long long
#define ii pair <int, int>
#define mp make_pair
const int N = 5e5 + 7;
vector <int> c;
int n, type, a[N], ans[N], op[N], l[N], r[N], m[N];
vector <int> mem[N], memr[N], pos[N];

bool used[N];
int dl[N], dr[N], par[N], cnt[N];
void clear_dsu() {
    memset(used, 0, sizeof used);
    for (int i = 0; i < n; ++i) {
        par[i] = i;
        dl[i] = dr[i] = i;
        cnt[i] = 1;
    }   
}   

int root(int u) {
    if (par[u] == u)
        return u;
    else
        return par[u] = root(par[u]);
}   
void merge(int u, int v) {
    u = root(u);
    v = root(v);
    if (u == v)
        return;
    if (cnt[v] < cnt[u])
        swap(u, v);
    dl[v] = min(dl[v], dl[u]);
    dr[v] = max(dr[v], dr[u]);
    cnt[v] += cnt[u];
    par[u] = v;
}   
int getl(int i) {
    return dl[root(i)];
}   
int getr(int i) {
    return dr[root(i)];
}   

int ql[N][2], qr[N][2];
void solve() {
    for (int i = 0; i < n; ++i) {
        if (l[i] < r[i] - 1) {
            m[i] = (l[i] + r[i]) >> 1;
        }   
    }      
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            ql[i][j] = n;
            qr[i][j] = -1;
        }   
    }   
    for (int i = 0; i < N; ++i) {
        mem[i].clear();
        memr[i].clear();
    }
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] <= m[i]) 
            mem[m[i]].app(i);
        if (a[i + 1] <= m[i])
            memr[m[i]].app(i + 1);
    }
    clear_dsu();
    for (int x = 0; x < c.size(); ++x) {
        for (int i : pos[x]) {
            used[i] = 1;
            if (i - 2 >= 0 && used[i - 2])
                merge(i - 2, i);
            if (i + 2 < n && used[i + 2])
                merge(i + 2, i);                    
        }   
        for (int i : mem[x]) {
            ql[i][0] = getl(i);
            qr[i][0] = getr(i);
        }   
        for (int i : memr[x]) {
            ql[i - 1][1] = getl(i);
            qr[i - 1][1] = getr(i);
        }   
    }   

    for (int i = 0; i < N; ++i) {
        mem[i].clear();
        memr[i].clear();
    }
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] > m[i])
            mem[m[i] + 1].app(i);
        if (a[i + 1] > m[i])
            memr[m[i] + 1].app(i + 1);
    }
    clear_dsu();
    for (int x = c.size() - 1; x >= 0; --x) {
        for (int i : pos[x]) {
            used[i] = 1;
            if (i - 2 >= 0 && used[i - 2]) 
                merge(i - 2, i);
            if (i + 2 < n && used[i + 2])
                merge(i + 2, i);                    
        }   
        for (int i : mem[x]) {
            ql[i][0] = getl(i);
            qr[i][0] = getr(i);
        }   
        for (int i : memr[x]) {
            ql[i - 1][1] = getl(i);
            qr[i - 1][1] = getr(i);
        }           
    }   
    for (int i = 1; i < n - 1; ++i) {
        if (l[i] == r[i] - 1)
            continue;        
        if (a[i] <= m[i] && min(a[i - 1], a[i + 1]) <= m[i]) {
            r[i] = m[i];
            continue;
        }   
        if (a[i] > m[i] && max(a[i - 1], a[i + 1]) > m[i]) {
            l[i] = m[i];
            continue;
        }   
        int l1 = max(ql[i][0], ql[i][1]) - 1;
        int r1 = min(qr[i][0], qr[i][1]) + 1;
        l1 = max(l1, 0);
        r1 = min(r1, n - 1);        
        if ((r1 - l1 + 1) % 2 == 0) {
            int mid = (l1 + r1) >> 1;
            int p;
            if (i <= mid)
                p = l1;
            else
                p = r1;
            if (a[p] <= m[i])
                r[i] = m[i];
            else
                l[i] = m[i];
        }   
        else {
            if (a[l1] <= m[i] && a[r1] <= m[i])
                r[i] = m[i];
            else if (a[l1] > m[i] && a[r1] > m[i])
                l[i] = m[i];
            else {
                int cnt = (r1 - l1) / 2 - 1;
                cnt &= 1;
                bool start = a[i] <= m[i];
                if (start ^ cnt)
                    l[i] = m[i];
                else
                    r[i] = m[i];
            }   
        }   
    }   
}   
void solve1(int m[N]) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            ql[i][j] = n;
            qr[i][j] = -1;
        }   
    }   
    for (int i = 0; i < N; ++i) {
        mem[i].clear();
        memr[i].clear();
    }
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] <= m[i]) 
            mem[m[i]].app(i);
        if (a[i + 1] <= m[i])
            memr[m[i]].app(i + 1);
    }
    clear_dsu();
    for (int x = 0; x < c.size(); ++x) {
        for (int i : pos[x]) {
            used[i] = 1;
            if (i - 2 >= 0 && used[i - 2])
                merge(i - 2, i);
            if (i + 2 < n && used[i + 2])
                merge(i + 2, i);                    
        }   
        for (int i : mem[x]) {
            ql[i][0] = getl(i);
            qr[i][0] = getr(i);
        }   
        for (int i : memr[x]) {
            ql[i - 1][1] = getl(i);
            qr[i - 1][1] = getr(i);
        }   
    }   

    for (int i = 0; i < N; ++i) {
        mem[i].clear();
        memr[i].clear();
    }
    for (int i = 1; i < n - 1; ++i) {
        if (a[i] > m[i])
            mem[m[i] + 1].app(i);
        if (a[i + 1] > m[i])
            memr[m[i] + 1].app(i + 1);
    }
    clear_dsu();
    for (int x = c.size() - 1; x >= 0; --x) {
        for (int i : pos[x]) {
            used[i] = 1;
            if (i - 2 >= 0 && used[i - 2]) 
                merge(i - 2, i);
            if (i + 2 < n && used[i + 2])
                merge(i + 2, i);                    
        }   
        for (int i : mem[x]) {
            ql[i][0] = getl(i);
            qr[i][0] = getr(i);
        }   
        for (int i : memr[x]) {
            ql[i - 1][1] = getl(i);
            qr[i - 1][1] = getr(i);
        }           
    }   
    for (int i = 1; i < n - 1; ++i) {        
        if (a[i] <= m[i] && min(a[i - 1], a[i + 1]) <= m[i]) {
            r[i] = m[i];
            continue;
        }           
        if (a[i] > m[i] && max(a[i - 1], a[i + 1]) > m[i]) {
            l[i] = m[i];
            continue;
        }   
        int l1 = max(ql[i][0], ql[i][1]) - 1;
        int r1 = min(qr[i][0], qr[i][1]) + 1;
        l1 = max(l1, 0);
        r1 = min(r1, n - 1);
        if ((r1 - l1 + 1) % 2 == 0) {
            int mid = (l1 + r1) >> 1;
            int p;
            if (i <= mid)
                op[i] = max(op[i], i - l1);                
            else
                op[i] = max(op[i], r1 - i);                
        }   
        else {
            if (a[l1] <= m[i] && a[r1] <= m[i]) 
                op[i] = max(op[i], min(i - l1, r1 - i));
            else if (a[l1] > m[i] && a[r1] > m[i])
                op[i] = max(op[i], min(i - l1, r1 - i));
            else {
                int cnt = (r1 - l1) / 2 - 1;
                op[i] = max(op[i], cnt);
            }   
        }
    }   
}   
signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    cin >> n >> type;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        c.app(a[i]);
    }
    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    for (int i = 0; i < n; ++i) {
        a[i] = lower_bound(all(c), a[i]) - c.begin();
        pos[a[i]].app(i);
    }
    ans[0] = a[0];
    ans[n - 1] = a[n - 1];
    for (int i = 1; i < n - 1; ++i) {
        l[i] = -1;
        r[i] = c.size();
    }   
    while (1) {
        solve();
        bool all = 1;
        for (int i = 1; i + 1 < n; ++i) 
            all &= l[i] == r[i] - 1;
        if (all)
            break;
    }   
    for (int i = 1; i < n - 1; ++i)
        ans[i] = r[i];    
    solve1(l);
    solve1(r);    
    int mx = 0;
    for (int i = 0; i < n; ++i)
        mx = max(mx, op[i]);
    cout << mx << '\n';
    if (type) {
        for (int i = 0; i < n; ++i)
            cout << c[ans[i]] << ' ';
        cout << '\n';
    }   
}   