#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

bool good(int a, int b, int c) {
    if (a <= b && b <= c) {
        return true;
    }
    if (a >= b && b >= c) {
        return true;
    }
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int t = input();
    vector<int> arr(n);
    for (int &i : arr) {
        i = input();
    }
//    if (n < 1002) {
//        int cnt = 0;
//        for (int c = 0; c < n / 2 + 1; ++c) {
//            bool same = true;
//            vector<int> b = arr;
//            for (int i = 1; i < n - 1; ++i) {
//                if (arr[i - 1] < arr[i] && arr[i + 1] < arr[i]) {
//                    same = false;
//                    b[i] = max(arr[i - 1], arr[i + 1]);
//                }
//                if (arr[i - 1] > arr[i] && arr[i + 1] > arr[i]) {
//                    same = false;
//                    b[i] = min(arr[i - 1], arr[i + 1]);
//                }
//            }
//            if (same) {
//                cout << c << endl;
//                if (t) {
//                    for (int i = 0; i < n; ++i) {
//                        cout << arr[i] << ' ';
//                    }
//                    cout << endl;
//                }
//                return 0;
//            }
//            arr = move(b);
//        }
//    }

    int cnt = 0, c = 0;
    for (; c < 201; ++c) {
        bool same = true;
        vector<int> b = arr;
        for (int i = 1; i < n - 1; ++i) {
            if (arr[i - 1] < arr[i] && arr[i + 1] < arr[i]) {
                same = false;
                b[i] = max(arr[i - 1], arr[i + 1]);
            }
            if (arr[i - 1] > arr[i] && arr[i + 1] > arr[i]) {
                same = false;
                b[i] = min(arr[i - 1], arr[i + 1]);
            }
        }
        if (same) {
            cout << c << endl;
            if (t) {
                for (int i = 0; i < n; ++i) {
                    cout << arr[i] << ' ';
                }
                cout << endl;
            }
            return 0;
        }
        arr = move(b);
    }

    int ls = 1, ans = 0;
    vector<pii> cur;
    for (int i = 1; i < n; ++i) {
        if (i == n - 1 ||
        good(arr[i - 1], arr[i], arr[i + 1])) {
            cur.emplace_back(ls - 1, i);
            ls = i;
        }
    }
    int cc = 0;
    for (auto[l, r] : cur) {
        if (l == r) {
            continue;
        }
        int m = (r + l) / 2;
        for (int i = l + 1; i <= m; ++i) {
            arr[i] = arr[l];
        }
        for (int i = m + 1; i < r; ++i) {
            arr[i] = arr[r];
        }
        cc = max(cc, (r - l) / 2);
    }
    cout << c + cc << endl;
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << arr[i] << ' ';
        }
        cout << endl;
    }
}
