#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma ("Ofast")

#define ll long long

using namespace std;

int n, t;

class odn {
public:
    int l;
    int r;
    int val;

    odn (int l, int r, int val) {
        this->l = l;
        this->r = r;
        this->val = val;
    }
};

void solve12 (vector <int> a) {
    vector <odn> q;
    int counter1, counter2, begin, end;
    counter1 = counter2 = 0;
    begin = 0;
    for (int i = 0; i < n - 1; i ++) {
        if (a[i] != a[i + 1]) {
            end = i;
            if (end - begin > 0 || i == 0) {
                q.emplace_back(odn(begin, end, a[i]));
            }
            begin = i + 1;
        }
    }
    if (a[n - 1] == a[n - 2]) {
        q.emplace_back(odn(begin, n - 1, a[n - 1]));
    }
    else {
        q.emplace_back(odn(n - 1, n - 1, a[n - 1]));
    }
    int m = 0;
    for (int i = 0; i < q.size() - 1; i ++) {
        m = max(m, q[i + 1].l - q[i].r);
    }
    cout << m / 2 << endl;
    for (int i = 0; i < q.size(); i ++) {
        for (int j = q[i].l; j <= q[i].r; j ++) {
            cout << q[i].val << " ";
        }
        if (i != q.size() - 1) {
            if (q[i].val != q[i + 1].val) {
                for (int j = q[i].r + 1; j <= (q[i].r + q[i + 1].l) / 2; j ++) {
                    cout << q[i].val << " ";
                }
                for (int j = (q[i].r + q[i + 1].l) / 2 + 1; j < q[i + 1].l; j ++) {
                    cout << q[i + 1].val << " ";
                }
            }
            else {
                for (int j = q[i].r + 1; j < q[i + 1].l; j ++) {
                    cout << q[i].val << " ";
                }
            }
        }

    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> t;
    vector <int> a(n, 0);
    vector <int> b(n, 0);
    bool flag1 = true;
    for (int i = 0; i < n; i ++) {
        cin >> a[i];
        if (a[i] > 2) {
            flag1 = false;
        }
    }
    if (n == 1) {
        cout << 0 << endl;
        if (t == 1) {
            cout << a[0];
        }
    }
    if (flag1) {
        solve12(a);
        return 0;
    }
    int c = 0;
    bool flag = true;
    b[0] = a[0];
    b[n - 1] = a[n - 1];
    while (flag) {
        flag = false;
        for (int i = 1; i < n - 1; i ++) {
            b[i] = (a[i] + a[i + 1] + a[i - 1]) - (max(a[i],max(a[i + 1], a[i - 1]))
                    + min(a[i], min(a[i + 1], a[i - 1])));
            if (b[i] != a[i]) {
                if (!flag) {
                    flag = true;
                    c ++;
                }
            }
        }
        a = b;
    }
    cout << c << "\n";
    if (t == 1) {
        for (int i = 0; i < n; i ++) {
            cout << a[i] << " ";
        }
    }
    return 0;
}