#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
int n, t, a[mx], _a[mx], res;

int check() {
	_a[0] = a[0];
	_a[n - 1] = a[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		vector<int> cur = {a[i - 1], a[i], a[i + 1]};
		sort(all(cur));
		_a[i] = cur[1];
	}
	for (int i = 0; i < n; ++i) {
		if (_a[i] != a[i]) {
			res++;
			swap(a, _a);
			return 1;
		}
	}
	return 0;
}

int ans, ch[mx];

void apply_seg(int l, int r) {
	chkmax(ans, (r - l) / 2 + 1);
	for (int i = l; i <= r; ++i) {
		if (i - l < r - i) {
			a[i] = a[l - 1];
		}
		if (i - l > r - i) {
			a[i] = a[r + 1];
		}
	}
}

void ultrasolve() {
	for (int i = 1; i < n - 1; ++i) {
		if (a[i - 1] != a[i] && a[i] != a[i + 1]) {
			ch[i] = 1;
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (ch[i]) {
			cnt++;
		} else {
			if (cnt) {
				apply_seg(i - cnt, i - 1);
				cnt = 0;
			}
		}
	}
	cout << ans << endl;
	for (int i = 0; i < n; ++i) {
		cout << a[i] << " ";
	}
	cout << endl;
}

signed main() {
	fast_io();
	cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (*max_element(a, a + n) <= 2) {
		ultrasolve();
		exit(0);
	}
	while (check()) {}
	cout << res << endl;
	if (t) {
		for (int i = 0; i < n; ++i) {
			cout << a[i] << " ";
		}
		cout << endl;
	}
}
