#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define int long long

using namespace std;

void solve1(int n, int is, vector<int> & a){
    int ans = 0;
    bool t = true;
    while (t){
        t = false;
        vector<int> a1(n);
        a1[0] = a[0];
        a1[n - 1] = a[n - 1];
        for (int i = 1; i < n - 1; i++){
            vector<int> sup = {a[i - 1], a[i], a[i + 1]};
            sort(sup.begin(), sup.end());
            if (sup[1] != a[i]){
                t = true;
            }
            a1[i] = sup[1];
        }
        a = a1;
        ans++;
    }
    ans--;
    cout << ans << endl;
    if (is){
        for (auto i : a){
            cout << i << ' ';
        }
        cout << endl;
    }
}

void solve2(int n, int is, vector<int> & a){
    int last = 0;
    int mx = 0;
    int len = 0;
    vector<int> ans(n);
    ans[0] = a[0];
    for (int i = 1; i < n; i++){
        if (a[i] == a[i - 1] || i == n - 1){
            if (len == 1){
                len = 0;
            }
            if (len != 0){
                for (int j = last + 1; j <= last + (len / 2) + 1; j++){
                    ans[j] = a[last];
                }
                for (int j = last + len / 2 + 1; j <= i - 1; j++){
                    ans[j] = a[i];
                }
            }
            ans[i] = a[i];
            last = i;
            mx = max(mx, len);
            len = 0;
        }else{
            len++;
        }
    }
    if (len != -1){
        for (int j = last + 1; j <= last + (len / 2) + 1; j++){
            ans[j] = a[last];
        }
        for (int j = last + len / 2 + 1; j <= n - 1; j++){
            ans[j] = a[n - 1];
        }
    }
    cout << (mx + 1) / 2 << endl;
    if (is){
        for (auto i : ans){
            cout << i << ' ';
        }
        cout << endl;
    }
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n, is;
    cin >> n >> is;
    vector<int> a(n);
    int group = 2;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        if (a[i] > 2){
            group = 1;
        }
    }
    if (group == 1){
        solve1(n, is, a);
    }else{
        solve2(n, is, a);
    }
    return 0;
}
