#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <set>

using namespace std;

int med(int a, int b, int c){
    if((a >= b && a <= c) || (a >= c && a <= b)){
        return a;
    }
    if((b >= a && b <= c) || (b >= c && b <= a)){
        return b;
    }
    return c;
}

int main() {
    int n; cin >> n;
    int t; cin >> t;
    if(n <= 5000) {
        vector<vector<int>> a(n, vector<int>(2));
        for(int i = 0; i < n; i++){
            cin >> a[i][0];
        }
        int cnt = 0;
        while(true){
            cnt++;
            a[0][cnt%2] = a[0][(cnt + 1)%2];
            a[n - 1][cnt%2] = a[n - 1][(cnt + 1)%2];
            int ch = 0;
            for(int i = 1; i < n - 1; i++){
                a[i][cnt%2] = med(a[i][(cnt + 1)%2], a[i - 1][(cnt + 1)%2], a[i + 1][(cnt + 1)%2]);
                if(a[i][cnt%2] != a[i][(cnt + 1)%2]){
                    ch++;
                }
            }
            if(ch == 0){
                break;
            }
        }
        cout << cnt - 1 << endl;
        if(t == 1){
            for(int i = 0; i < n; i++){
                cout << a[i][cnt%2] << " ";
            }
        }
    }
    else {
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        int prev = 0;
        int ans = 0;
        int is = false;
        for (int i = 1; i <= n; i++) {
            if (i == n || a[i - 1] == a[i]) {
                if ((i - prev) % 2 == 0) {
                    ans = max(ans, (i - prev) / 2 - 1);
                    for (int j = prev; j <= (i - 1 + prev) / 2; j++) {
                        a[j] = a[prev];
                    }
                    for (int j = (i - 1 + prev) / 2 + 1; j < i; j++) {
                        a[j] = a[i - 1];
                    }
                } else {
                    ans = max(ans, (i - prev) / 2);
                    for (int j = prev; j < i; j++) {
                        a[j] = a[i - 1];
                    }
                }
                prev = i;
            }
        }
        cout << ans << endl;
        if (t == 1) {
            for (int i = 0; i < n; i++) {
                cout << a[i] << " ";
            }
        }
    }
    return 0;
}