#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <unordered_set>
#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;
const int N = 500001;
vi a(N, 0);
vi b(N, 0);
int n;
bool check(int i) {
	if (i == 0 || i == n - 1) return false;
	if (a[i] == a[i - 1] || a[i] == a[i + 1]) return false;
	return (a[i - 1] < a[i]) ^ (a[i] < a[i + 1]);
}
int gt(int i) {
	if (a[i] > a[i - 1] && a[i] > a[i + 1]) return max(a[i - 1], a[i + 1]);
	else return min(a[i - 1], a[i + 1]);
}
unordered_set<int> st;
int aa[N];
int gt(int l, int r) {
	vi vec;
	for (int i = l; i <= r; ++i) vec.push_back(aa[i]);
	sort(all(vec));
	return vec[l + r >> 1];
}
bool checkk(int c) {
	for (int i = 0; i < n; ++i) {
		int mn = (i, n - i - 1);
		mn = min(mn, c);
		if (gt(i - c, i + c) != a[i]) return false;
	}
	return true;
}
void solve() {
	cin >> n;
	int t; cin >> t;
	fr(i, n) cin >> a[i];
	fr(i, n) aa[i] = a[i];
	fr(i, n) st.insert(i);
	int cc = 0;
	while (!st.empty()) {
		vi tmp;
		for (auto it : st) if (!check(it)) {
			tmp.push_back(it);
			b[it] = a[it];
		}
		for (auto it : tmp) st.erase(it);
		if (!st.empty()) ++cc;
		for (auto it : st) {
			b[it] = gt(it);
		}
		swap(a, b);
		//if (cc > 100) break;
	}
	checkk(cc);
	cout << cc << "\n";
	if (t) fr(i, n) cout << a[i] << " ";
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

}