#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)1e6;

int n, t, a[N];
bool is_good[N];

void solve1() {
    int prev_ = 0;
    vector <int> seg;
    seg.push_back(1);
    for (int i = 1; i < n; ++i) {
        if (a[i] == a[i - 1]) {
            ++seg.back();
        } else {
            seg.push_back(1);
        }
    }
    int ind = 0;
    int c = a[0];
    int i = 0;
    int ans = 0;
    while (i < seg.size() - 1) {
        int elem = seg[i];
        if (!i || elem > 1) {
            c = 3 - c;
            ind += elem;
            ++i;
            continue;
        }
        int it = i;
        while (it < seg.size() - 1 && seg[it] == 1) {
            ++it;
        }
        int cur = (it - i + 1) / 2;
        ans = max(ans, cur);
        if (i % 2 == it % 2) {
            rep(cur, j) {
                a[i + j] = 3 - c;
            }
            rep(cur, j) {
                a[i + cur + j] = c;
            }
        } else {
            rep(it - i, j) {
                a[i + j] = 3 - c;
            }
        }
        i = it;
        c = 3 - c;
        ind += elem;
    }
    printf("%d\n", ans);
    if (t == 1) {
        rep(n, i) {
            printf("%d ", a[i]);
        }
    }
}

void solve0() {
    int ans = 0;
    bool f = true;
    do {
        ++ans;
        vector <int> b(n);
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        for (int i = 1; i < n - 1; ++i) {
            vector <int> cur;
            cur.push_back(a[i - 1]);
            cur.push_back(a[i]);
            cur.push_back(a[i + 1]);
            sort(allv(cur));
            b[i] = cur[1];
        }
        f = false;
        rep(n, i) {
            if (a[i] != b[i]) {
                a[i] = b[i];
                f = true;
            }
        }
    } while (f);
    printf("%d\n", ans - 1);
    if (t) {
        rep(n, i) {
            printf("%d ", a[i]);
        }
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d", &n, &t);
    int mx = 0;
    rep(n, i) {
        scanf("%d", &a[i]);
        mx = max(mx, a[i]);
    }
    if (mx <= 2) {
        solve1();
    } else {
        solve0();
    }
    return 0;
}