#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define int long long

using namespace std;

void solve1(int n, int is, vector<int> & a){
    int ans = 0;
    bool t = true;
    while (t){
        t = false;
        vector<int> a1(n);
        a1[0] = a[0];
        a1[n - 1] = a[n - 1];
        for (int i = 1; i < n - 1; i++){
            vector<int> sup = {a[i - 1], a[i], a[i + 1]};
            sort(sup.begin(), sup.end());
            if (sup[1] != a[i]){
                t = true;
            }
            a1[i] = sup[1];
        }
        a = a1;
        ans++;
    }
    ans--;
    cout << ans << endl;
    if (is){
        for (auto i : a){
            cout << i << ' ';
        }
        cout << endl;
    }
}

void solve2(int n, int is, vector<int> & a){
    int last = 0;
    int mx = 0;
    int len = 0;
    vector<int> ans(n);
    vector<pair<int, int> > c;
    c.push_back({a[0], 1});
    for (int i = 1; i < n; i++){
        if (a[i] != a[i - 1]){
            c.push_back({a[i], 1});
        }else{
            c[c.size() - 1].second++;
        }
    }
    vector<int> t;
    t.push_back(c[0].second);
    t.push_back(0);
    for (int i = 1; i < n; i++){
        if (i == n - 1 || c[i].second >= 2){
            t.push_back(c[i].second);
            t.push_back(0);
        }else{
            t[t.size() - 1]++;
        }
    }
    t.pop_back();
    /*for (auto i : t){
        cout << i << ' ';
    }
    cout << endl;
    for (auto i : a){
        cout << i << ' ';
    }
    cout << endl;*/
    int now = 0;
    int p = 0;
    while (now < n){
        if (p % 2 == 0){
            for (int i = 0; i < t[p]; i++){
                ans[now] = a[now];
                now++;
            }
        }else{
            mx = max(mx, t[p]);
            int last = a[now - 1];
            int nx = a[now + t[p]];
            for (int i = 0; i < t[p] / 2; i++){
                ans[now] = last;
                //cout << ans[now] << ' ';
                now++;
            }
            for (int i = t[p] / 2; i < t[p]; i++){
                ans[now] = nx;
                now++;
            }
        }
        p++;
    }
    cout << (mx + 1) / 2 << endl;
    if (is){
        for (auto i : ans){
            cout << i << ' ';
        }
        cout << endl;
    }
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n, is;
    cin >> n >> is;
    vector<int> a(n);
    int group = 2;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        if (a[i] > 2){
            group = 1;
        }
    }
    if (group == 1){
        solve1(n, is, a);
    }else{
        solve2(n, is, a);
    }
    return 0;
}
