#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int n;
string s;

bool pal(int l, int r) {
	for (int i = l; i <= r; ++i) {
		if (s[i] != s[r - (i - l)]) {
			return false;
		}
	}
	return true;
}

void solve() {
	
	cin >> n >> s;
	int ans = 0;
	for (int len = 1; len <= n; ++len) {
		for (int i = 0; i + 2 * len - 1 < n; ++i) {
			if (pal(i, i + len - 1) && pal(i + len, i + 2 * len - 1)) {
				++ans;
			}
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}