#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii pair<int, int>
#define int ll
#define vi vector<int>
#define pb push_back
using namespace std;

const int mod = 1e9 + 7;
const int p = 141;
const int maxn = 5e5 + 50;
int powp[maxn];
int pref[maxn];
int suf[maxn];

int get(int l, int r, int *pref) {
    return ((pref[r + 1] - pref[l] * powp[r - l + 1]) % mod + mod) % mod;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int n;
    cin >> n;
    string s;
    cin >> s;
    powp[0] = 1;
    for (int i = 0; i < n; ++i) {
        powp[i + 1] = powp[i] * p % mod;
        pref[i + 1] = (pref[i] * p + s[i]) % mod;
    }
    for (int i = 0; i < n; ++i) {
        suf[i + 1] = (suf[i] * p + s[n - i - 1]) % mod;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; j += 2) {
            bool ok1 = 0, ok2 = 0;
            int mid = (i + j) / 2;
            ok1 = get(i, mid, pref) == get(n - mid - 1, n - i - 1, suf);
            ok2 = get(mid + 1, j, pref) == get(n - j - 1, n - mid - 2, suf);
            if (ok1 && ok2)
                ans++;
        }
    }
    cout << ans << endl;
    return 0;
}
