#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int mod = 1e9 + 7;
const int pri = 997;
const ld PI = acos(-1);
const int N = 5e3 + 5;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}

int is[N][N];
int h[N];
int hs[N];
int pw[N];
int n;
string s;
int get_h (int l, int r) {
	return (mod + (ll)h[r] - (h[l-1] * (ll)pw[r - l + 1] % mod)) % mod; 
}

int get_hs (int l, int r) {
	return (mod + (ll)hs[l] - (hs[r+1] * (ll)pw[r-l+1] % mod)) % mod; 
}

int main () {
	randomizer3000 ();
	cin >> n >> s;
	s = '#' + s;
	pw[0] = 1;
	for (int i = 1; i <= n; i ++) {
		pw[i] = pw[i-1] * (ll)pri % mod;
		h[i] = h[i-1] * (ll)pri % mod;
		h[i] += s[i];
		if (h[i] >= mod) h[i] -= mod;
	}
	for (int i = n; i >= 1; i--) {
		hs[i] = hs[i+1] * (ll)pri % mod;
		hs[i] += s[i];
		if (hs[i] >= mod) hs[i] -= mod;
	}

	for (int i = 1; i <= n; i ++) {
		for (int j = i; j <= n; j ++) {
		//	cout << i << ' ' << j << ' ' << get_h(i, j) << ' ' << get_hs(i, j) << '\n'; 
			is[i][j] = (get_h(i, j) == get_hs(i, j));
		}
	}

	int ans = 0;
	for (int i = 1; i <= n; i ++) {
		for (int j = i+1; j <= n; j += 2) {
			int len = (j - i + 1);
			len /= 2;
			if (is[j-len+1][j] && is[i][j-len]) ++ans;
		}
	}	
	cout << ans << '\n';
}
