#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = (int)5007;
string S;
int n;
int dp[MAXN][MAXN];
ll answ = 0;
void solve() {
	cin >> n >> S;
	for(int l = n - 1; l >= 0; --l) for(int r = l; r < n; ++r) {
		if(l == r) {
			dp[l][r] = 1;
		} else if(r - l == 1) {
			dp[l][r] = S[l] == S[r];
		} else if(S[l] == S[r]) {
			dp[l][r] = dp[l + 1][r - 1];
		}
	}
	for(int k = 1; 2 * k <= n; ++k) {
		for(int i = 0; i < n - 2 * k + 1; ++i) {
			if(dp[i][i + k - 1] && dp[i + k][i + 2 * k - 1]) {
				++answ;
			}
		}
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	solve();
	return 0;
}
