#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    string s;
    cin >> n >> s;
    const int k = 31, mod = 1'000'000'007;
    vector<unsigned long long> pow_k(n);
    pow_k[0] = 1;
    for(int i = 1; i<n; i++)
        pow_k[i] = (pow_k[i-1]*k)%mod;
    vector<unsigned long long> pr(n+1), sf(n+1);
    pr[0] = 0;
    for(int i = 0; i<n; i++)
        pr[i+1] = (pr[i]*k+(s[i]-'a'+1))%mod;
    sf[n] = 0;
    for(int i = n-1; i>=0; i--)
        sf[i] = (sf[i+1]*k+(s[i]-'a'+1))%mod;
    long long ans = 0;
    for(int i = 0; i<n; i++){
        for(int j = i+1; j<n; j += 2){
            int ln = j+1-i;
            unsigned long long hash1 = (pr[j+1]-((pr[i+ln/2]*pow_k[ln/2])%mod)+mod)%mod;
            unsigned long long hash2 = (sf[i+ln/2]-((sf[j+1]*pow_k[ln/2])%mod)+mod)%mod;
            if(hash1!=hash2)
                continue;
            hash1 = (pr[i+ln/2]-((pr[i]*pow_k[ln/2])%mod)+mod)%mod;
            hash2 = (sf[i]-((sf[i+ln/2]*pow_k[ln/2])%mod)+mod)%mod;
            if(hash1!=hash2)
                continue;
            ans++;
        }
    }
    cout << ans;

    return 0;
}
