#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
ull q = 157;
vector <ull> qp;
vector<ull> calc_hash(string& s) {
    s = '-' + s;
    if (s.size() > qp.size())qp.assign(s.size(), 1);
    vector<ull>h(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        h[i] = h[i - 1] * q + s[i] - 'a';
        qp[i] = qp[i - 1] * q;
    }
    return h;
}
ull get_hash(int l, int r, vector<ull>& h) {
    return h[r] - h[l - 1] * qp[r - l + 1];
}
bool palindrom(int l, int r, vector<ull>& h, vector<ull>& rh) {
    //cout << "checkin: " << l << " " << r << " and " << h.size() - r  << " " << h.size() - l << "\n";
    ull h1 = get_hash(l, r, h);
    ull h2 = get_hash(h.size() - r, h.size() - l , rh);
    return h1 == h2;
}
int main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int n; cin >> n;
    string s;
    cin >> s;
    string rs = s;
    reverse(all(rs));
    auto h = calc_hash(s), rh = calc_hash(rs);
    int cnt = 0;
    for (int i = 1; i < s.size(); ++i) {
        for (int len = 1; 2 * len + i - 1 < s.size(); len++) {
            if (palindrom(i, i + len - 1, h, rh) && palindrom(i + len, i + 2 * len - 1, h, rh)) {
                ++cnt;
            }
        }
    }
    cout << cnt;
    return 0;
}
/*
abacac


*/