#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;
const int P = 47;

vi h, rh, p(N);

int hashh(int l, int r) {
	return (h[r] - h[l] * p[r - l] % MOD + MOD) % MOD;
}

int rev_hash(int l, int r) {
	return (rh[l] - rh[r] * p[r - l] % MOD + MOD) % MOD;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	p[0] = 1;
	for (int i = 1; i < N; ++i)
		p[i] = p[i - 1] * P % MOD;

	int n;
	cin >> n;
	string s;
	cin >> s;
	h.resize(n + 1);
	rh.resize(n + 1);
	for (int i = 0; i < n; ++i)
		h[i + 1] = (h[i] * P + s[i]) % MOD;
	for (int i = n - 1; i >= 0; --i)
		rh[i] = (rh[i + 1] * P + s[i]) % MOD;
	int ans = n - 1;
	for (int len = 2; len <= n / 2; ++len) {
		for (int i = 0; i <= n - 2 * len; ++i) {
			if (hashh(i, i + len) == rev_hash(i, i + len) && hashh(i + len, i + 2 * len) == rev_hash(i + len, i + 2 * len))
				++ans;
		}
	}
	cout << ans;

	return 0;
}