#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mod = 1e9 + 7;
const ll p = 228 + 239 + 57;
const int maxn = 5e5 + 5;

string s;
ll h1[maxn], h2[maxn];
ll ppow[maxn];

inline bool ispal(int l, int r) {
    ll t1 = h1[r] - h1[l - 1] * ppow[r - l + 1];
    ll t2 = h2[l] - h2[r + 1] * ppow[r - l + 1];
    return (t1 - t2) % mod == 0;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int n;
    cin >> n;
    ppow[0] = 1;
    for (int i = 1; i <= n + 2; i++) {
        ppow[i] = (ppow[i - 1] * p) % mod;
    }
    cin >> s;
    s = " " + s;
    for (int i = 1; i <= n; i++) {
        h1[i] = (h1[i - 1] * p + s[i]) % mod;
    }
    for (int i = n; i >= 1; i--) {
        h2[i] = (h2[i + 1] * p + s[i]) % mod;
    }
    //bool t = ispal(1, 1);
    //cerr << t << "\n";
    ll res = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j += 2) {
            if (ispal(i, (i + j) / 2) && ispal((i + j) / 2 + 1, j)) {
                res++;
            }
        }
    }
    cout << res;
    return 0;
}
