#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//comments
/*
	1) N^2
*/

bool palindrom(string& s)
{
	int p1 = 0, p2 = s.size() - 1;
	while (p1 < p2)
	{
		if (s[p1] != s[p2])
			return false;
		++p1; --p2;
	}
	return true;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	string s;
	cin >> s;
	int ans = 0;
	for (int k = 2; k <= n; k += 2)
	{
		for (int i = 0; i <= n - k; ++i)
		{
			string temp = s.substr(i, k);
			string s1 = temp.substr(0, k / 2);
			reverse(all(temp));
			string s2 = temp.substr(0, k / 2);
			if (palindrom(s1) && palindrom(s2))
				++ans;
		}
	}
	cout << ans;
	return 0;
}