#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    int n;
    string s;

    vector<vector<ll> > h;
    vector<ll> p;

    ll add(ll a, ll b) {
        a += b;
        while (a < 0) {
            a += MOD;
        }
        while (a >= MOD) {
            a -= MOD;
        }
        return a;
    }

    ll mul(ll a, ll b) {
        a *= b;
        a %= MOD;
        return a;
    }

    ll get(int l, int r, int id) {
        return add(h[id][r], -((l) ? h[id][l - 1] : 0));
    }

    bool eq(int l, int r, int id, int l1, int r1, int id1) {
        if (l > l1) {
            swap(l, l1);
            swap(r, r1);
            swap(id, id1);
        }
//        cout << "L = " << LEFT << " R = " << RIGHT << "\n";
        return mul(get(l, r, id), p[l1 - l]) == get(l1, r1, id1);
    }

    void precalc() {
        h.resize(2, vector<ll> (n));
        p.resize(n);
        p[0] = 1;
        for (int i = 1; i < n; i++) {
            p[i] = mul(p[i - 1], P);
        }
        int tmp = 0;
        h[tmp][0] = s[0];
        for (int i = 1; i < n; i++) {
            h[tmp][i] = add(mul(p[i], s[i]), h[tmp][i - 1]);
        }
        tmp++;
        h[tmp][0] = s.back();
        for (int i = 1; i < n; i++) {
            h[tmp][i] = add(mul(p[i], s[n - i - 1]), h[tmp][i - 1]);
        }
    }

    void solve() {
        cin >> n >> s;
        precalc();
        ll ans = 0;
        for (int len = 1; len <= n; len++) {
            for (int l = 0; l < n; l++) {
                int r = l + len - 1;
                int l1 = r + 1;
                int r1 = l1 + len - 1;
                if (r1 >= n) {
                    break;
                }
//                cout << l << " " << r << " " << l1 << " " << r1 << "\n";
                int rl = n - r - 1;
                int rr = n - l - 1;
                int rl1 = n - r1 - 1;
                int rr1 = n - l1 - 1;
////                cout << rl << " " << rr << " " << rl1 << " " << rr1 << "\n";
                ans += (eq(l, r, 0, rl, rr, 1) &&  eq(l1, r1, 0, rl1, rr1, 1));
            }
        }
        cout << ans;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
