#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 5007;

int dp[MAXN][MAXN];

string s;

int cnt_dp(int l, int r) {
    if (dp[l][r] != -1) {
        return dp[l][r];
    }
    return dp[l][r] = (s[l] == s[r - 1] && cnt_dp(l + 1, r - 1));
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    int n;
    cin >> n >> s;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = -1;
        }
    }
    for (int i = 0; i < n; ++i) {
        dp[i][i + 1] = true;
        dp[i][i] = true;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            cnt_dp(i, j);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 2; j <= n; j += 2) {
            int m = (i + j) / 2;
            if (dp[i][m] && dp[m][j]) {
                ++ans;
            }
        }
    }
    cout << ans;
    return 0;
}