#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
#define endl '\n'
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ldb;
typedef double db;

const int MOD = 1e9 + 123;
const int BASE = 137;

inline int mult(int a, int b) {
    return ((ll)a * b) % MOD;
}

inline int sum(int a, int b) {
    return (a + b) % MOD;
}

inline int sub(int a, int b) {
    return (a - b + MOD) % MOD;
}

int h[500001], hrev[500001];
int bpow[500001];

inline int get_hash(int h[], int i, int len) {
    return sub(h[i + len], mult(h[i], bpow[len]));
}


signed main() {
    fastream;
    int n;
    cin >> n;
    string s;
    cin >> s;
    bpow[0] = 1;
    for (int i = 0; i < n; i++) {
        bpow[i + 1] = mult(bpow[i], BASE);
    }
    for (int i = 0; i < n; i++) {
        h[i + 1] = sum(mult(h[i], BASE), s[i] - 'a' + 1);
        hrev[i + 1] = sum(mult(hrev[i], BASE), s[n - i - 1] - 'a' + 1);
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int l = 2; i - l >= -1; l += 2) {
            int med = l >> 1;
            /*cout << get_hash(h, i - l + 1, med) << ' ' << get_hash(hrev, n - (i - med) - 1, med) << ' ';
            cout << get_hash(h, i - med + 1, med) << ' ' << get_hash(hrev, n - i - 1, med) << endl;*/
            if (get_hash(h, i - l + 1, med) == get_hash(hrev, n - (i - med) - 1, med) &&
                get_hash(h, i - med + 1, med) == get_hash(hrev, n - i - 1, med)) {
                cnt++;
            }
        }
    }
    cout << cnt;
}