#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using ord = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
void solve();

signed main() {
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}

const int N = 5e5 + 5;
const ll mod = 1e9 + 9;
const ll p = 31;
string s;
int n, z1[N], z2[N];
ll pw[N], hsh[N];

ll get(int l, int r) {
    return (mod + hsh[r] - hsh[l - 1]) % mod;
}

bool get(int l1, int r1, int l2, int r2) {
    ll g1 = get(l1, r1), g2 = get(l2, r2);
    g1 = (g1 * pw[l2]) % mod;
    g2 = (g2 * pw[l1]) % mod;
    return g1 == g2;
}

void solve() {
    cin >> n;
    cin >> s;
    s = '#' + s;
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = pw[i - 1] * p % mod;
    }
    for (int i = 1; i <= n; ++i) {
        hsh[i] = (hsh[i - 1] + (s[i] - 'a' + 1) * pw[i] % mod) % mod;
    }
    for (int i = 1; i <= n; ++i) {
        int lef = 0, rig = min(i - 1, n - i) + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            int l1 = i - mid, r1 = i - 1, l2 = i + 1, r2 = i + mid;
            if (get(l1, r1, l2, r2)) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        z1[i] = lef;
    }
    for (int i = 1; i <= n; ++i) {
        int lef = 0, rig = min(i, n - i) + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            int l1 = i - (mid - 1), r1 = i, l2 = i + 1, r2 = i + mid;
            if (get(l1, r1, l2, r2)) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        z2[i] = lef;
    }
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; j += 2) {
            int len = (j - i + 1) / 2;
            int l1 = i, r1 = i + len - 1, l2 = j - (len - 1), r2 = j;
            if (len % 2 == 0) {
                int mid1 = (l1 + r1) / 2;
                int mid2 = (l2 + r2) / 2;
                if ((z2[mid1] >= len / 2) && (z2[mid2] >= len / 2)) {
                    ++ans;
     //               cout << i << ' ' << j << '\n';
                }
            } else {
                int mid1 = (l1 + r1) / 2;
                int mid2 = (l2 + r2) / 2;
                if ((z1[mid1] >= len / 2) && (z1[mid2] >= len / 2)) {
                    ++ans;
       //             cout << i << ' ' << j << '\n';
                }
            }
        }
    }
    cout << ans;
}
//find_by_order
//order_of_key


