#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;
const ll P = 337;

ll get_hash(int l, int r, const vector<ll> &h, const vector<ll> &pp) {
    return ((h[r] - h[l] * pp[r - l]) % MOD + MOD) % MOD;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    ll ans = 0;
    vector<ll> h(n + 1), pp(n + 1);
    h[0] = 0;
    pp[0] = 1;
    for (int i = 0; i < n; i++) {
        h[i + 1] = (h[i] * P + s[i] - 'a') % MOD;
        pp[i + 1] = (pp[i] * P) % MOD;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j += 2) {
            int m = (i + j) / 2;
            if ((m - i) % 2) {
                int mm = (i + m) / 2, mmm = (m + j) / 2;
                if (get_hash(i - 1, mm, h, pp) == get_hash(mm, m, h, pp) && get_hash(m, mmm, h, pp) == get_hash(mmm, j, h, pp)) {
                    ans++;
                }
            } else {
                int mm = (i + m) / 2, mmm = (m + j) / 2;
                if (get_hash(i - 1, mm - 1, h, pp) == get_hash(mm, m, h, pp) && get_hash(m, mmm, h, pp) == get_hash(mmm + 1, j, h, pp)) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
