#include<iostream>
#include<vector>
#include<string>
using namespace std;
#define int unsigned long long
int max(int a, int b)
{
	if (a > b)
	{
		return a;
	}
	return b;
}
vector <int> hash1, hash2, hash3, hash4;
vector <int> pow1, pow2;
const int const1 = 1e9 + 7;
const int const2 = 1e9 + 37;
int n;
pair <int, int> get_hash(int l, int r)
{
	if (l == 0)
	{
		return { hash1[r], hash2[r] };
	}
	else
	{
		return { hash1[r] - hash1[l - 1] * pow1[r - l + 1], hash2[r] - hash2[l - 1] * pow2[r - l + 1] };
	}
}
pair <int, int> get_hash1(int l, int r)
{
	if (r == n - 1)
	{
		return { hash3[l], hash4[l] };
	}
	else
	{
		return { hash3[l] - hash3[r + 1] * pow1[r - l + 1], hash4[l] - hash4[r + 1] * pow2[r - l + 1] };
	}
}
signed main()
{
	//ios_base::sync_with_stdio(false);
	//cin.tie(NULL);
	//cout.tie(NULL);
	cin >> n;
	string s;
	cin >> s;
	hash1.resize(n);
	hash2.resize(n);
	hash3.resize(n);
	hash4.resize(n);
	pow1.resize(n + 1);
	pow2.resize(n + 1);
	pow1[0] = pow2[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		pow1[i] = pow1[i - 1] * 27;
		pow2[i] = pow2[i - 1] * 27;
	}
	for (int i = 0; i < n; i++)
	{
		if (i == 0)
		{
			hash1[i] = s[i] - 'a' + 1;
			hash2[i] = s[i] - 'a' + 1;
		}
		else
		{
			hash1[i] = (hash1[i - 1] * 27 + s[i] - 'a' + 1);
			hash2[i] = (hash2[i - 1] * 27 + s[i] - 'a' + 1);
		}
	}
	for (int i = n - 1; i >= 0; i--)
	{
		if (i == n - 1)
		{
            hash3[i] = s[i] - 'a' + 1;
			hash4[i] = s[i] - 'a' + 1;
		}
		else
		{
			hash3[i] = (hash3[i + 1] * 27 + s[i] - 'a' + 1);
			hash4[i] = (hash4[i + 1] * 27 + s[i] - 'a' + 1);
		}
		if(i == 0)
        {
		    break;
        }
	}
	vector <int> pal1(n), pal2(n);
	for (int i = 0; i < n; i++)
	{
		int l = 0, r = min(i, n - i) + 1;
		while (r - l > 1)
		{
			int midd = (r + l) / 2;
			if (get_hash(i - midd, i - 1) == get_hash1(i, i + midd - 1))
			{
				l = midd;
			}
			else
			{
				r = midd;
			}
		}
		pal1[i] = l;
		l = 0, r = min(i + 1, n - i) + 1;
		while (r - l > 1)
		{
			int midd = (r + l) / 2;
			if (get_hash(i - midd + 1, i) == get_hash1(i, i + midd - 1))
			{
				l = midd;
			}
			else
			{
				r = midd;
			}
		}
		pal2[i] = l;
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 1; j <= pal1[i]; j++)
		{
			if (i + 2 * j < n && pal1[i + 2 * j] >= j)
			{
				ans++;
			}
		}
		for (int j = 1; j <= pal2[i]; j++)
		{
			if (i + 2 * j - 1 < n && pal2[i + 2 * j - 1] >= j)
			{
				ans++;
			}
		}
	}
	cout << ans;
	return 0;
}