#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 1e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	string s;
	cin >> s;
	map<int, vector<int> > rlen;
	for (int i = 0; i < n; ++i) {
		for (int len = 1; i - len / 2 >= 0 && i + len / 2 < n && s[i - len / 2] == s[i + len / 2]; len += 2) {
			if (rlen.find(i + len / 2) == rlen.end()) rlen[i + len / 2] = {};
			rlen[i + len / 2].push_back(len);
		}
	}
	for (int i = 0; i < n-1; ++i) {
		for (int len = 2; i - len / 2 + 1 >= 0 && i + len / 2 < n && s[i - len / 2 + 1] == s[i + len / 2]; len += 2) {
			if (rlen.find(i + len / 2) == rlen.end()) rlen[i + len / 2] = {};
			rlen[i + len / 2].push_back(len);
		}
	}
	ll ans = 0;
	for (auto &i : rlen) {
		sort(i.sc.begin(), i.sc.end());
		for (int j : i.sc) {
			if (rlen.find(i.fs - j) != rlen.end() && binary_search(rlen[i.fs - j].begin(), rlen[i.fs - j].end(), j)) {
				ans++;
			}
		}
	}
	cout << ans;
	

	return 0;
}