#include<bits/stdc++.h>                      

using namespace std;

const int N = 5002;

struct Fenw {
	int f[N];

	Fenw() {
		fill(f, f + N, 0);
	}

	void add(int pos) {
		f[pos]++;
	}

	int sum(int l, int r) {
		int ans = 0;
		for (int i = l; i < r; i++) ans += f[i];
		return ans;
	}
};

int dp[N][N];
        
string s;

int calc(int l, int len) {
	if (len == 0) return 1;
	if (len == 1) return 1;
	if (dp[l][len] == -1) {
		if (s[l] == s[l + len - 1]) {
			dp[l][len] = calc(l + 1, len - 2);
		} else {
			dp[l][len] = 0;
		}
	}
	return dp[l][len];
}

void init(int n) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			dp[i][j] = -1;
		}
	}
}


int pal(int l, int r) {
	if (l < 0 || r > (int)s.size()) return 0;
	return calc(l, r - l);
}

int solve_f(int n) {
	init(n);
	vector<int> mid(n, -1);
	for (int i = 0; i < n; i++) {
		for (int lp = n / 2 + 1; lp >= 0; lp--) {
			if (pal(i - lp, i + lp + 1)) {
				mid[i] = lp;
				break;
			}
		}   
	}
	int ans = 0;
	/*vector<int> ind(n);
	iota(ind.begin(), ind.end(), 0);
	sort(ind.rbegin(), ind.rend(), [&](int i, int j) {
		return mid[i] >= mid[j];
	});*/
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (abs(i - j) % 2 == 0) continue;
			if (i + mid[i] + 1 >= j - mid[j]) ans++;
		}
	}
	return ans;
}              

int solve_s(int n) {
	init(n);
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int len = 2; i + 2 * len <= n; len += 2) {
			ans += (calc(i, len) & calc(i + len, len));
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	        
	int n;
	cin >> n;
	cin >> s;
	cout << solve_f(n) + solve_s(n) << endl;
}                        