#include <bits/stdc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n;
    cin >> n;
    string s;
    cin >> s;

    bool is_pal[n + 1][n + 1];
    for (int i = 0; i < n; ++i) {
        is_pal[i][i + 1] = true;
        is_pal[i][i] = true;
    }
    
    for (int len = 2; len < n; ++len) {
        for (int i = 0; i < n - len + 1; ++i) {
            is_pal[i][i + len] = ((s[i] == s[i + len - 1]) && (is_pal[i + 1][i + len - 1]));
        }
    }
    
    int res = 0;
    for (int r = 1; r <= n; ++r) {
        for (int l = 0; l < r; ++l) {
            int sz = (r - l);
            if (sz % 2) {
                continue;
            }
            
            int m = (l + r) / 2;
            res += (is_pal[l][m] && is_pal[m][r]);
        }
    }
    
    cout << res;

}