#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <queue>
#include <deque>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string.h>
#include <time.h>
#include <random>
#include <assert.h>
#include <string>

using namespace std;

typedef long long ll;
#define ff first
#define ss second
#define mp make_pair
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define vpii vector<pii>
#define make_unique(x) sort(x.begin(),x.end()); x.resize(unique(x.begin(),x.end()) - x.begin());
#define sz(x) ((int)x.size())
#define pb push_back
#define eb emplace_back

inline int nxt() {
	static int buf_nxt;
	cin >> buf_nxt;
	return buf_nxt;
}

inline ll nxtll() {
	static ll buf_nxt_ll;
	cin >> buf_nxt_ll;
	return buf_nxt_ll;
}
#define N (500000)
#define BASE (73)
#define MOD ((ll)1000000000 + 97)

string s;
int n;

int h[N];
int rh[N];
int base_step[N];

int get_hash(int l, int r) {
	r++;
	return (h[r] - h[l] * base_step[r - l] + (ll)MOD * MOD) % MOD;
}

int get_rhash(int nl, int nr) {
	int r = n - nl - 1;
	int l = n - nr - 1;
	r++;
	return (rh[r] - rh[l] * base_step[r - l] + (ll)MOD * MOD) % MOD;
}

int get_even_palindrome(int ind) {
	if (s[ind] != s[ind + 1]) {
		return 0;
	}
	int L = 1, R = n + 1;
	while (R - L > 1) {
		int len = (L + R) / 2;
		int l = ind - len + 1;
		int r = ind + len;
		if (l < 0 || r >= n) R = len;
		else {
			if (get_hash(l, ind) == get_rhash(ind + 1, r)) {
				L = len;
			}
			else {
				R = len;
			}
		}
	}
	/*int l = ind;
	int r = ind + 1;
	while (l - 1 >= 0 && r + 1 < s.size() && s[l - 1] == s[r + 1]) {
		l--;
		r++;
	}*/
	return L;
}

int get_odd_palindrome(int ind) {
	int L = 1, R = n + 1;
	while (R - L > 1) {
		int len = (L + R) / 2;
		int l = ind - len + 1;
		int r = ind + len - 1;
		if (l < 0 || r >= n) R = len;
		else {
			if (get_hash(l, ind) == get_rhash(ind, r)) {
				L = len;
			}
			else {
				R = len;
			}
		}
	}
	return L;
}

void hash_precalc() {
	base_step[0] = 1;
	for (int i = 1; i < N; i++) {
		base_step[i] = ((ll)base_step[i - 1] * BASE) % MOD;
	}
	for (int i = 0; i < n; i++) {
		h[i + 1] = ((ll)h[i] * BASE + s[i] - 'a' + 1) % MOD;
	}
	string q = s;
	reverse(q.begin(), q.end());
	for (int i = 0; i < n; i++) {
		rh[i + 1] = ((ll)rh[i] * BASE + q[i] - 'a' + 1) % MOD;
	}
}

void solution() {
	n = nxt();
	cin >> s;
	hash_precalc();
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int x = get_odd_palindrome(i);
			int y = get_odd_palindrome(j);
			if (2  * min(x,y) >= j - i + 1 && (j - i + 1) % 2 == 0) {
				ans++;
				//cout << i << " " << j << endl;
			}
		}
	}
	for (int i = 0; i + 1 < n; i++) {
		for (int j = i + 2; j + 1 < n; j++) {
			int x = get_even_palindrome(i);
			int y = get_even_palindrome(j);
			if (2 * min(x, y) >= j - (i + 1) + 1 && (j - i) % 2 == 0) {
				ans++;
			}
		}
	}
	cout << ans;
}

void stupid() {
}
	
void gen() {

}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	srand(239);
	solution();
	return 0;
}