#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 5e5 + 5; 
int n;
string s;
int even[MAXN];
int odd[MAXN];

void find_pals() {
    int mx = -1, ps = 0;
    for (int i = 0; i < n; ++i) {
        if (mx > i) {
            even[i] = min(mx - i, even[ps - (i - ps)]);
        }
        while (i + even[i] + 1 < n && s[i + even[i] + 1] == s[i - even[i]]) {
            even[i]++;
        }
        if (i + even[i] > mx) {
            mx = i + even[i];
            ps = i;
        }
    }

    mx = -1, ps = 0;
    for (int i = 0; i < n; ++i) {
        if (mx > i) {
            odd[i] = min(mx - i + 1, odd[ps - (i - ps)]);
        }
        while (i + odd[i] < n && s[i + odd[i]] == s[i - odd[i]]) {
            odd[i]++;
        }
        if (i + odd[i] - 1 > mx) {
            mx = i + odd[i] - 1;
            ps = i;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    cin >> s;
    find_pals();
    
    // rep(i, n) {
    //     cout << even[i] << ' ';
    // }
    // cout << endl;
    // rep(i, n) {
    //     cout << odd[i] << ' ';
    // }
    // cout << endl;

    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 2; j < n; j += 2) {
            int d = (j - i) / 2;
            if (even[i] >= d && even[j] >= d) {
                res++;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; j += 2) {
            int d = (j - i + 1) / 2;
            if (odd[i] >= d && odd[j] >= d) {
                res++;
            }
        }
    }

    cout << res << endl;
}
