#include <bits/stdc++.h>
#define int long long
using namespace std;
int powmod(int a, int b, int mod) {
if (b==0) return 1;
int k=powmod(a,b/2,mod);
if (b&1) return (((k*k)%mod)*a)%mod;
else return (k*k)%mod;

}

int inv(int a, int mod) {
return powmod(a,mod-2,mod);
}

int prime(int p) {
if (p==1) return 0;
for (int i=2;i*i<=p;i++) if (p%i==0) return i;
return 1;
}
int pref[500001];
int suf[500001];
int pows[1000000];
int p=37;
int mod=1000000009;
int a;
string s;

int check(int l, int r) {
int hash1=pref[r]-(l==0?0:pref[l-1])+mod;
hash1%=mod;
hash1*=pows[999999-l];
hash1%=mod;
int hash2=suf[l]-(r==(a-1)?0:suf[r+1])+mod;
hash2%=mod;
hash2*=pows[999999-(a-1-r)];
hash2%=mod;
//cout<<l<<" "<<r<<" "<<hash1<<" "<<hash2<<"\n";
if (hash1==hash2) return 1; else return 0;
}

void solve () {
cin>>a;
cin>>s;




pows[0]=1;
for (int i=1;i<1000000;i++) pows[i]=(pows[i-1]*p)%mod;
pref[0]=(s[0]-'a'+1);
for (int i=1;i<a;i++) {
    pref[i]=pref[i-1]+(s[i]-'a'+1)*pows[i]; pref[i]%=mod;

}
suf[a-1]=s[a-1]-'a'+1;
for (int i=a-2;i>=0;i--) {
    suf[i]=suf[i+1]+(s[i]-'a'+1)*pows[(a-1-i)];
}
int ans=0;
for (int i=0;i<a;i++) {
    for (int j=1;2*j+i<=a;j++) {
        // i..i+j-1  i+j..i+2j-1
        if (check(i,i+j-1) && check(i+j,i+2*j-1)) ans++;
    }
}
cout<<ans;
}

signed main() {
 ios_base::sync_with_stdio(0);
 cin.tie(0);
 cout.tie(0);
int q=1;
// cin>>q;
    for (int i=0;i<q;i++) solve();
}
