#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 5e5 + 100;
vector<int> add[MAXN];
vector<pii> ask[MAXN];
int can[MAXN], t[MAXN];

void upd(int pos) {
	for (int i = pos + 1; i < MAXN; i += i & -i) {
		t[i]++;
	}
}

int get(int r) {
	int res = 0;
	for (int i = r + 1; i >= 1; i -= i & -i) {
		res += t[i];
	}
	return res;
}

int get(int l, int r) {
	if (l > r) {
		return 0;
	}
	return get(r) - get(l - 1);
}

ll solve(string s) {
	int n = s.length();
	ll ans = 0;
	fill(can, can + n, 0);
	int l = 0, r = 0;
	for (int i = 1; i < n; ++i) {
		if (i <= r) {
			int m = (r + l) / 2;
			can[i] = max(0, min(can[m - (i - m)], min(i - l, r - i)));
		}
		while (i - (can[i] + 1) >= 0 && i + (can[i] + 1) < n && s[i - (can[i] + 1)] == s[i + (can[i] + 1)]) {
			can[i]++;
		}
		if (i + can[i] > r) {
			l = i - can[i];
			r = i + can[i];
		}
	}
	vector<int> xs;
	for (int i = 1; i < n; i += 2) {
		xs.push_back(2 * can[i] - i + 1);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());
	int sz = xs.size();
	for (int i = 1; i < n; i += 2) {
		int pos = lower_bound(all(xs), 2 * can[i] - i + 1) - xs.begin();
		add[pos].push_back(i);
	}
	for (int i = 0; i < n; i += 2) {
		int pos = lower_bound(all(xs), -i) - xs.begin();
		if (pos != sz) {
			ask[pos].push_back({i + 1, min(n - 1, i + 1 + 2 * can[i])});
		}
	}
	for (int i = sz - 1; i >= 0; --i) {
		for (int pos : add[i]) {
			upd(pos);
		}
		for (pii p : ask[i]) {
			ans += get(p.first, p.second);
		}
	}
	xs.clear();
	memset(t, 0, sizeof(t));
	for (int i = 0; i < sz; ++i) {
		add[i].clear();
		ask[i].clear();
	}
	for (int i = 0; i < n; i += 2) {
		xs.push_back(2 * can[i] - i + 1);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());
	sz = xs.size();
	for (int i = 0; i < n; i += 2) {
		int pos = lower_bound(all(xs), 2 * can[i] - i + 1) - xs.begin();
		add[pos].push_back(i);
	}
	for (int i = 1; i < n; i += 2) {
		int pos = lower_bound(all(xs), -i) - xs.begin();
		if (pos != sz) {
			ask[pos].push_back({i + 1, min(n - 1, i + 1 + 2 * can[i])});
		}
	}
	for (int i = sz - 1; i >= 0; --i) {
		for (int pos : add[i]) {
			upd(pos);
		}
		for (pii p : ask[i]) {
			ans += get(p.first, p.second);
		}
	}
	xs.clear();
	memset(t, 0, sizeof(t));
	for (int i = 0; i < sz; ++i) {
		add[i].clear();
		ask[i].clear();
	}
	fill(can, can + n, -1);
	l = 0, r = 0;
	for (int i = 1; i < n; ++i) {
		if (i <= r) {
			int m = (r + l) / 2 + 1;
			can[i] = max(-1, min(can[m - (i - m)], min(i - l - 1, r - i)));
		}
		while (i - (can[i] + 2) >= 0 && i + (can[i] + 1) < n && s[i - (can[i] + 2)] == s[i + (can[i] + 1)]) {
			can[i]++;
		}
		if (i + can[i] > r) {
			l = i - can[i] - 1;
			r = i + can[i];
		}
	}
	for (int i = 0; i < n; i += 2) {
		xs.push_back(2 * can[i] - i + 2);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());
	sz = xs.size();
	for (int i = 0; i < n; i += 2) {
		int pos = lower_bound(all(xs), 2 * can[i] - i + 2) - xs.begin();
		add[pos].push_back(i);
	}
	for (int i = 0; i < n; i += 2) {
		int pos = lower_bound(all(xs), -i) - xs.begin();
		if (pos != sz) {
			ask[pos].push_back({i + 2, min(n - 1, i + 2 + 2 * can[i])});
		}
	}
	for (int i = sz - 1; i >= 0; --i) {
		for (int pos : add[i]) {
			upd(pos);
		}
		for (pii p : ask[i]) {
			ans += get(p.first, p.second);
		}
	}
	xs.clear();
	memset(t, 0, sizeof(t));
	for (int i = 0; i < sz; ++i) {
		add[i].clear();
		ask[i].clear();
	}
	for (int i = 1; i < n; i += 2) {
		xs.push_back(2 * can[i] - i + 2);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());
	sz = xs.size();
	for (int i = 1; i < n; i += 2) {
		int pos = lower_bound(all(xs), 2 * can[i] - i + 2) - xs.begin();
		add[pos].push_back(i);
	}
	for (int i = 1; i < n; i += 2) {
		int pos = lower_bound(all(xs), -i) - xs.begin();
		if (pos != sz) {
			ask[pos].push_back({i + 2, min(n - 1, i + 2 + 2 * can[i])});
		}
	}
	for (int i = sz - 1; i >= 0; --i) {
		for (int pos : add[i]) {
			upd(pos);
		}
		for (pii p : ask[i]) {
			ans += get(p.first, p.second);
		}
	}
	xs.clear();
	memset(t, 0, sizeof(t));
	for (int i = 0; i < sz; ++i) {
		add[i].clear();
		ask[i].clear();
	}
	return ans;
}

signed main() {
	FAST_IO();
	int n;
	string s;
	cin >> n >> s;
	ll ans = solve(s);
	cout << ans << '\n';
}