#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<fstream>
///#pragma GCC optimize("Ofast")
#define int long long
#define all(a) a.begin(), a.end()
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int P = 57;
int MOD = 2286661337;
vector<int> pw;
vector<int> pw1;
vector<int> h;
vector<int> h1;

int n;
string s;

int f_p(int x, int q) {/// x ^ q
    if (q == 1) {
        return x;
    }
    if (q == 0) {
        return 1;
    }
    if (q % 2 == 0) {
        return f_p((x * x) % MOD, q / 2);
    }
    return (x * f_p(x, q - 1)) % MOD;
}

void init() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    cin >> n;
    cin >> s;
    ///n = s.size();

    pw.resize(n + 10);
    pw[0] = 1;
    for (int i = 1; i < n + 10; ++i) {
        pw[i] = (pw[i - 1] * P) % MOD;
    }

    h.resize(n + 1);
    h[0] = 0;
    for (int i = 1; i <= n; ++i) {
        h[i] = (h[i - 1] * P + (s[i - 1] - 'a')) % MOD;
    }

    h1.resize(n + 1);
    h1[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        h1[i] = (h1[i + 1] * P + (s[i] - 'a')) % MOD;
    }

    pw1.resize(n + 10);
    pw1[0] = 1;
    pw1[1] = f_p(P, MOD - 2);
    for (int i = 2; i < n + 10; ++i) {
        pw1[i] = (pw1[i - 1] * pw1[1]) % MOD;
    }
    ///cin.close(); cout.close();
}

int get(int l, int r) {
    return (h[r] - (h[l - 1] * pw[r - l + 1]) % MOD + MOD) % MOD;
    //return (((h[r] - h[l - 1] + MOD) % MOD) * pw1[l - 1]) % MOD;
}

int get1(int l, int r) {

    return (h1[l] - (h1[r + 1] * pw[r - l + 1]) % MOD + MOD) % MOD;
    //return (((h[r] - h[l - 1] + MOD) % MOD) * pw1[l - 1]) % MOD;
}

bool check(int l, int r) {
    ///cout << "-------\n";
    ///cout << l << " " << r << endl;
    ///cout << get(l, r) << endl;
    ///cout << get1(l - 1, r - 1) << endl;
    return (get(l, r) == get1(l - 1, r - 1));
}

signed main() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    init();
/*
    for (int i = 0; i < n; ++i) {
        cout << h[i] << endl;
    }
*/
    int ans = 0;
    for (int l = 0; l < n; ++l) {
        for (int len = 1; len <= n / 2; ++len) {
            int l1 = l + 1;
            int r1 = l1 + len - 1;
            int l2 = r1 + 1;
            int r2 = l2 + len - 1;
            ///cout << "------------\n";
            ///cout << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
            ///cout << get(l1, r1) << endl;
            ///cout << get1(l2, r2) << endl;
            //cout << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
            if (r2 <= n && check(l1, r1) && check(l2, r2)) {
                ///cout << " -> " << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
                ans++;
            }
        }
    }
    cout << ans;

/*
    while (true) {

        int l, r;
        cin >> l >> r;
        cout << get(l, r);

        int l1, r1, l2, r2;
        cin >> l1 >> r1;
        cin >> l2 >> r2;
        cout << get(l1, r1) << endl;
        cout << get(l2, r2) << endl;
        cout << (get(l1, r1) == get(l2, r2)) << endl;

    }
*/
    ///cin.close(); cout.close();
    return 0;
}
