#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define fi first
#define se second
using namespace std;
float __starttime;
const ll modd = 228228227;
struct hesh{
    vector<ll> h, p;
    ll pp, mod;
    hesh(){};
    hesh(string &s, ll _pp, ll _mod) {
        pp = _pp;
        mod = _mod;
        h.resize(s.size() + 1, 0);
        p.resize(s.size() + 1, 1);
        for (int i = 1; i <= s.size(); ++i) {
            h[i] = (h[i - 1] * pp + s[i - 1]) % mod;
            p[i] = (p[i - 1] * pp) % mod;
        }
    }
    ll get(int l, int r) {
        return (h[r] - h[l - 1] * p[r - l + 1] + mod * mod) % mod;
    }
    ll getback(int l, int r) {
        return get(h.size() - r, h.size() - l);
    }
};
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    __starttime = clock();
    int n;
    cin >> n;
    string s;
    cin >> s;
    hesh fr(s, 67, modd);
    reverse(s.begin(), s.end());
    hesh bw(s, 67, modd);
    int ans = 0;
    for (int len = 2; len <= s.size(); len += 2) {
        for (int i = 0; i < s.size(); ++i) {
            int l1 = i + 1;
            int r1 = l1 + len / 2 - 1;
            int l2 = r1 + 1;
            int r2 = l2 + len / 2 - 1;
            //cout << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
            if (r2 > s.size())
                break;
            if (fr.get(l1, r1) == bw.getback(l1, r1) && fr.get(l2, r2) == bw.getback(l2, r2))
                ++ans;
        }
    }
    cout << ans << endl;
    cerr << endl << (clock() - __starttime) / CLOCKS_PER_SEC << endl;
    return 0;
}
