#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 500005;
int n;
string s;
int dp[maxN];
int dq[maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> s;
    for (int i = 0; i < n; ++i)
    {
        dp[i] = 1;
        while (i - dp[i] >= 0 && i + dp[i] < n && s[i - dp[i]] == s[i + dp[i]])
        {
            ++dp[i];
        }
    }
    for (int i = 1; i < n; ++i)
    {
        dq[i] = 0;
        while (i - 1 - dq[i] >= 0 && i + dq[i] < n && s[i - 1 - dq[i]] == s[i + dq[i]])
        {
            ++dq[i];
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int d = 1; i - d >= 0 && i + d - 1 < n; ++d)
        {
            if (~d & 1)
            {
                ans += dq[i - d / 2] >= d / 2 && dq[i + d / 2] >= d / 2;
            }
            else
            {
                ans += dp[i - d / 2 - 1] >= d / 2 + 1 && dp[i + d / 2] >= d / 2 + 1;
            }
        }
    }
    cout << ans << '\n';

    return 0;
}

