#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N = 1e6 + 100;
string s, t;
int n, r[N];

struct fnw {
    vector<int> fen[N];
    void clear() {
        fill_n(fen, N, vector<int>());
    }
    void add(int i, int v) {
        for (; i < N; i |= i + 1) {
            fen[i].push_back(v);
        }
    }
    void build() {
        for (int i = 0; i < N; ++i) {
            sort(all(fen[i]));
        }
    }
    int query(int i, int v) {
        int x = 0;
        i = min(i, N - 1);
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            x += int(upper_bound(all(fen[i]), v) - fen[i].begin());
        }
        return x;
    }
} f[2];

main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> s;
    //cerr << n << " " << s << endl;
    for (int i = 0; i < n; ++i) {
        r[i] = 0;
        while (i - r[i] >= 0 && i + r[i] < n && s[i - r[i]] == s[i + r[i]]) {
            ++r[i];
        }
        --r[i];
    }
    f[0].clear(), f[1].clear();
    for (int i = 0; i < n; ++i) {
        f[i % 2].add(i, i - 2 * r[i]);
    }
    f[0].build(), f[1].build();
    long long answer = 0;
    for (int i = 0; i < n; ++i) {
        answer += max(0, f[(i + 1) % 2].query(2 * r[i] + i + 1, i + 1) - f[(i + 1) % 2].query(i, i + 1));
    }
    for (int i = 0; i < n; ++i) {
        r[i] = 0;
        while (i - r[i] >= 0 && i + r[i] + 1 < n && s[i - r[i]] == s[i + r[i] + 1]) {
            ++r[i];
        }
        --r[i];
    }
    f[0].clear(), f[1].clear();
    for (int i = 0; i < n; ++i) {
        f[i % 2].add(i, i - 2 * r[i]);
    }
    f[0].build(), f[1].build();
    for (int i = 0; i < n; ++i) {
        answer += max(0, f[i % 2].query(2 * r[i] + i + 2, i + 2) - f[i % 2].query(i + 1, i + 2));
    }
    cout << answer << "\n";
}

