#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const unsigned long long m = 239;
unsigned long long h1[5003], h2[5003];
unsigned long long p[5003];
int n;

unsigned long long get1(int l, int r) {
	return (h1[r] - h1[l - 1] * p[r - l + 1]);
}

unsigned long long get2(int l, int r) {
	l = n - l + 1;
	r = n - r + 1;
	swap(l, r);
	return (h2[r] - h2[l - 1] * p[r - l + 1]);
}

int main() {
	cin >> n;
	string s;
	cin >> s;
	h1[0] = 0;
	p[0] = 1;
	for (int i = 0; i < n; ++i) {
		h1[i + 1] = h1[i] * m + s[i];
		p[i + 1] = p[i] * m;
	}
	h2[0] = 0;
	for (int i = 0; i < n; ++i) {
		h2[i + 1] = h2[i] * m + s[n - i - 1];
	}

	long long sum = 0;
	for (int i = 1; i < n; ++i) {
		int l, r;
		l = i;
		r = i + 1;
		while (l > 0 && r <= n) {
			if (get1(l, i) == get2(l, i) && get1(i + 1, r) == get2(i + 1, r))
				++sum;
			//cerr << l << ' ' << r << '\n';
			--l;
			++r;
		}
	}
	cout << sum;
	return 0;
}
