#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

vector <int> get(vector <int> &a) {
	int n = len(a);
	vector <int> p(n, 1);
	int l = 0, r = 0;
	for (int i = 1; i < n - 1; i++) {
		int d = 1;
		if (i <= r)
			d = min(p[r - i + l], r - i + 1);
		while (i + d < n && i - d >= 0 && a[i + d] == a[i - d])
			d++;
		p[i] = d;
		if (i + d > r) {
			l = i - d + 1;
			r = i + d - 1;
		}
	}
	return p;
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n;
	cin >> n;
	string b;
	cin >> b;

	vector <int> a(n);
	for (int i = 0; i < n; i++)
		a[i] = b[i] - 'a';

	auto p = get(a);
	ll ans = 0;
	bool flag = 0;
	for (int i = 0; i < n; ++i) {
		flag = 1;
		for (int j = i + 1; j < n && flag; j += 2) {
			int len1 = p[i] - 1;
			int len2 = p[j] - 1;
			int d = j - i - 1;
			if ((len1 * 2 >= d) && (len2 * 2 >= d))
				ans++;
			if (!(len1 * 2 >= d))
				flag = 0;
		}
	}

	vector <int> nw(1, 100);
	for (int i = 0; i < n; ++i) {
		nw.push_back(a[i]);
		nw.push_back(100);
	}

	a = nw;
	p = get(nw);
	n = len(nw);
	for (int i = 0; i < n; i += 2) {
		flag = 1;
		for (int j = i + 4; j < n && flag; j += 4) {
			int len1 = (p[i] - 1) / 2;
			int len2 = (p[j] - 1) / 2;
			int d = (j - i) / 2;
			if ((len1 * 2 >= d) && (len2 * 2 >= d))
				ans++;
			if (!(len1 * 2 >= d))
				flag = 0;
		}
	}

	cout << ans;

	return 0;
}