#include <bits/stdc++.h>

#define ft first
#define sc second
#define int ll
#define len(v) (int)v.size()
#define pb push_back

using namespace std;
typedef long long ll;

int n;
vector<int> hsh;
vector<int> hshr;
vector<int> step;
int p = 239;
int mod = 1e9 + 7;

int get(int l, int r) {
	int ans = (hsh[r + 1] - (hsh[l] * step[r - l + 1]) % mod + mod) % mod;
	return ans;
}

int getr(int l, int r) {
	int ans = (hshr[r + 1] - (hshr[l] * step[r - l + 1]) % mod + mod) % mod;
	return ans;
}

bool check(int l, int r) {
	int hsh1 = get(l, r);
	int hsh2 = getr(n - 1 - r, n - 1 - l);
	if(hsh1 == hsh2) 
		return 1;
	return 0;
}

struct DO {
	vector<int> tree;
	int N;
	DO(int n) {
		N = 1;
		while(N < (n + 1)) 
			N *= 2;
		tree = vector<int> (2 * N, 0);
	}
	void upds(int v) {
		if(v == 0) 
			return;
		tree[v] = tree[2 * v] + tree[2 * v + 1];
		upds(v / 2);
	}
	int sum(int v, int l, int r, int vl, int vr) {
		if(vr <= l || r <= vl) 
			return 0;
		if(vl <= l && r <= vr) 
			return tree[v];
		int m = (l + r) / 2;
		return sum(v * 2, l, m, vl, vr) + sum(v * 2 + 1, m, r, vl, vr);
	}
	int get(int l, int r) {
		if(l > r) 
			return 0;
		return sum(1, 0, N, l, r + 1);
	}
	void upd(int v, int val) {
		tree[N + v] = val;
		upds((N + v) / 2);
	}
};

signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	string s;
	cin >> s;
	auto sr = s;
	reverse(sr.begin(), sr.end());
	int ans = 0;
	hsh = vector<int> (n + 1, 0);
	hshr = vector<int> (n + 1, 0);
	step = vector<int> (n + 1, 1);
	for (int i = 0; i < n; i++) {
		hsh[i + 1] = (hsh[i] * p + s[i]) % mod;
		hshr[i + 1] = (hshr[i] * p + sr[i]) % mod;
		step[i + 1] = (step[i] * p) % mod;
	}

	
	vector<int> max(n + 1, 1);
	for (int i = 0; i < n; i++) {
		int l = 1, r = min(i, n - 1 - i) + 2;
		while(r - l > 1) {
			int mid = (l + r) / 2;
			if(check(i - mid + 1, i + mid - 1)) 
				l = mid;
			else
				r = mid;
		}
		// cout << i << " " << l << endl;
		max[i] = l;
	}

	DO nech(n);
	DO ch(n);
	vector<vector<pair<int, int>>> scan(n + 1);
	for (int i = 0; i < n; i++) {
		scan[i + 1].pb({i, 1});
		scan[min(n, i + 2 * max[i])].pb({i, 0});
	}

	for (int i = 0; i < n; i++) {
		for (auto x : scan[i]) {
			if(x.ft % 2 == 0) 
				ch.upd(x.ft, x.sc);
			else
				nech.upd(x.ft, x.sc);
		}
		int l = i - 2 * max[i] + 1LL, r = i - 1;
		if(l < 0) 
			l = 0;
		if(r % 2 == 0) {
			ans += ch.get(l, r); 
		}
		else {
			ans += nech.get(l, r);
		}
		// for (int j = 1; j <= max[i]; j++) {
		// 	int pos = i - 2 * j + 1;
		// 	if(pos < 0) 
		// 		break;
		// 	if(max[pos] >= j) 
		// 		ans++;
		// }
	}
	// cout << endl;
	max = vector<int> (n + 1, 0);
	for (int i = 0; i < n - 1; i++) {
		int l = 0, r = min(i + 1, n - 1 - i) + 1;
		while(r - l > 1) {
			int mid = (l + r) / 2;
			if(check(i - mid + 1, i + mid))
				l = mid;
			else
				r = mid;
		}
		// cout << i << " " << l << endl;
		max[i] = l;
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = 1; j <= max[i]; j++) {
			int pos = i - 2 * j;
			if(pos < 0) 
				break;
			if(max[pos] >= j)
				ans++;
		}
	}
	cout << ans << endl;
}	
