#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

const int q = 1e9 + 7;
const int p = 179;
int n;
vector<int> h, deg, h2;

int get_hash(int l, int r) {
    return (h[r] - (deg[r - l + 1] * h[l - 1]) % q + q) % q;
}

int get_hash2(int l, int r) {
    l = n - l + 1;
    r = n - r + 1;
    swap(l, r);
    return (h2[r] - (deg[r - l + 1] * h2[l - 1]) % q + q) % q;
}

bool palindrom(int l, int r) {
    return get_hash(l, (l + r) / 2) == get_hash2((l + r + 1) / 2, r);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n;
    string s;
    cin >> s;
    h.resize(n + 1);
    deg.resize(n + 1);
    deg[0] = 1;
    for (int i = 0; i < n; i++) {
        h[i + 1] = ((p * h[i]) % q + s[i]) % q;
        // cout << h[i + 1] << " ";
        deg[i + 1] = (p * deg[i]) % q;
    }
    // cout << "\n";
    reverse(all(s));
    h2.resize(n + 1);
    for (int i = 0; i < n; i++) {
        h2[i + 1] = ((p * h2[i]) % q + s[i]) % q;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = i; j + j - i + 1 <= n; j++) {
            int len = j - i + 1;
            // cout << "q = " << i << " " << j << " " << palindrom(i, j) << " " << get_hash(i, (i + j) / 2) << " " << get_hash2((i + j + 1) / 2, j) <<  "\n";
            // cout << i << " " << j << " " << j + 1 << " " << j + len << "\n";
            // cout << get_hash(i, j) << " " << get_hash(j + 1, j + len) << "\n";
            if (palindrom(i, j) && palindrom(j + 1, j + len)) {
                ans++;
                // cout << i << " " << j << "\n";
            }
        }
    }
    cout << ans << "\n";


    return 0;
}