#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
#define MP make_pair
#define PB push_back
#define MT make_tuple
#define RS resize
#define F(i, a, b) for(int i = int(a); i <= int(b); i++)
#define f(i, a, b) for(int i = int(a); i >= int(b); i--)

vi d1, d2;

bool pal(int l, int r){
	int le = r-l+1;
	if(le % 2){
		int m = l + (le/2);
		return d1[m] > (le/2);
	}
	int m = l + le/2 - 1;
	return d2[m] >= (le/2);
}

bool query(int l, int r){
	if((r - l + 1 ) % 2)
		return 0;
	int m = (l + r)/2;
	return (pal(l, m) && pal(m+1, r));
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	string s;
	cin >> n >> s;
	d1.RS(n, 0), d2.RS(n, 0);
	for(int i = 0, l = 0, r = -1, k; i < n; ++i){
		if(i > r)
			k = 1;
		else
			k = min(d1[i - l], r - i + l);
		while(i + k < n && i - k >= 0 && s[i-k] == s[i+k])
			k++;
		d1[i] = k;
		//cerr << d1[i] << ' ';
		if(i + k - 1 > r)
			l = i - k + 1, r = i + k - 1;
	}
	//cerr << endl;
	for(int i = 0, l = 0, r = -1, k; i < n; ++i){
		if(i > r)
			k = 0;
		else
			k = min(d2[i - l + 1], r - i + l);
		while(i + k + 1 < n && i - k >= 0 && s[i+k+1] == s[i-k])
			++k;
		d2[i] = k;
		//cerr << d2[i] << ' ';
		if(i + k > r)
			l = i - k + 1, r = i + k;
	}
	ll ans = 0;
	F(l, 0, n-1)
		F(r, l, n-1)
			ans += query(l, r);
	cout << ans;
	return 0;
}