#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define _ <<' '<<

using namespace std;

mt19937 gen(time(0));

const int N = 1e5 + 7;
const int M = 1e9 + 7;
const int sz = 2*N + 9;

struct fenwik{
    int t[sz];

    fenwik(){memset(t, 0, sizeof(t));}

    void upd(int p, int x){p += N;
        for (; p < sz; p += p&-p) t[p] += x;
    }

    int q(int p){p += N;
        int res = 0;
        for (; p; p -= p&-p) res += t[p];
        return res;
    }

    int q(int l, int r){
//    cerr << l << ' ' << r << endl;
        return q(r) - q(l - 1);
    }

    int Q(int x){
        return q(x, N + 2);
    }
}t[2], T[2];

int n;
string s;
vector<pair<int,int> > add[N], del[N];
vector<pair<int,int> > add2[N], del2[N];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    cin >> s;
    vector<int> len1(n), len2(n);
    for (int i = 0; i < n; i++){
        while (i - len1[i] >= 0 && i + len1[i] < n && s[i - len1[i]] == s[i + len1[i]]) len1[i]++;
        while (i - len2[i] >= 0 && i + 1 + len2[i] < n && s[i - len2[i]] == s[i + 1 + len2[i]]) len2[i]++;
    }
    vector<int> dp1 = len1;
    vector<int> dp2 = len2;
    for (int i = 0; i < n; i++) dp1[i] -= (i/2);
    for (int i = 0; i < n; i++) dp2[i] -= (i/2);
    int res = 0;
    for (int i = 0; i < n; i++){
        del[i].pb( {(i + 1)%2, 1 - (i + 1)/2} );
        add[min(n - 1, i + len1[i]*2 - 1)].pb( {(i + 1)%2, 1 - (i + 1)/2} );
    }

    for (int i = 0; i < n; i++){
        t[i%2].upd(dp1[i], 1);
        for (auto it : del[i]) res -= t[it.F].Q(it.S);
        for (auto it : add[i]) res += t[it.F].Q(it.S);
    }

//    for (int j = i + 1; j < n && j < i + len1[i]*2; j += 2) if (dp1[j] >= 1 - (i + 1)/2) res++;

    for (int i = 0; i < n; i++)
    for (int j = i + 2; j < n && j < i + len2[i]*2 + 1; j += 2) if (dp2[j] >= 1 - (i + 1)/2) res++;
    cout << res;
    return 0;
}
