import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import static java.lang.Math.*;

public class D {
    static BufferedReader in;
    static StringTokenizer st;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int n = nextInt();
        fn();
        String s = st.nextToken();
        int np[] = fk(s, n);
        int cp[] = fs(s, n);
        long ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j += 2) {
                if (np[i] < (j - i + 1) / 2) break;
                if (np[j] >= (j - i + 1) / 2) ans++;
            }
        }
        for (int i = 0; i < n - 1; i++) {
            for (int j = i + 2; j < n - 1; j+=2) {
                if (cp[i] < (j - i) / 2)break;
                if(cp[j]>=(j-i)/2)ans++;
            }
        }
        System.out.println(ans);
    }

    private static int[] fs(String s, int n) {
        int pp[] = new int[n - 1];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n - 1; i++) {
            if (i < r) {
                pp[i] = min(pp[2 * tp - i], r - i);
            }
            while (i - pp[i] >= 0 && i + pp[i] + 1 < n) {
                if (s.charAt(i - pp[i]) == s.charAt(i + pp[i] + 1)) pp[i]++;
                else break;
            }
            if (pp[i] + i > r) {
                r = pp[i] + i;
                tp = i;
            }
        }
        return pp;
    }

    private static int[] fk(String s, int n) {
        int np[] = new int[n];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n; i++) {
            np[i] = 1;
            if (i <= r) {
                np[i] = min(np[2 * tp - i], r - i + 1);
            }
            while (i - np[i] >= 0 && i + np[i] < n) {
                if (s.charAt(i - np[i]) == s.charAt(i + np[i])) np[i]++;
                else break;
            }
            if (np[i] + i - 1 > r) {
                r = np[i] + i - 1;
                tp = i;
            }
        }
        return np;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
