#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)

const ll MOD = 2286661337;
const ll p = 179;
vector<ll> h, hr, p_pow;

ll get_hash_front(int l, int r) {
	if (l == 0) {
		return h[r];
	}
	else {
		return ((h[r] - h[l - 1] * p_pow[r - l + 1]) % MOD + MOD) % MOD;
	}
}

ll get_hash_rev(int l, int r) {
	if (l == 0) {
		return hr[r];
	}
	else {
		return ((hr[r] - hr[l - 1] * p_pow[r - l + 1]) % MOD + MOD) % MOD;
	}
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	h.resize(n);
	hr.resize(n);
	p_pow.resize(n + 1);
	string s;
	cin >> s;
	string sr = s;
	reverse(sr.begin(), sr.end());
	p_pow[0] = 1;
	for (ll i = 1; i < n + 1; i++) {
		p_pow[i] = (p_pow[i - 1] * p) % MOD;
	}
	h[0] = s[0] - 'a';
	hr[0] = sr[0] - 'a';
	for (int i = 1; i < n; i++) {
		h[i] = (h[i - 1] * p + s[i] - 'a') % MOD;
		hr[i] = (hr[i - 1] * p + sr[i] - 'a') % MOD;
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if ((i - j) % 2 == 0)continue;
			int len = (i - j + 1) / 2;
			//cout << j << " " << i << "\n";
			if (get_hash_front(j, j + len - 1) == get_hash_rev(n - len - j, n - 1 - j) && 
				get_hash_front(j + len, i) == get_hash_rev(n - i - 1, n - i - 2 + len)) {
				ans++;
			}
		}
	}
	cout << ans;
}