#include <bits/stdc++.h>
#define int long long
#define double long double
#define l first
#define r second
#define pb push_back
#define pi pair<int, int>
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 1e6 + 3, mod = 1e9 + 7, K = 31;

int pf[maxn], sf[maxn], pw[maxn];
int a[maxn];
vector<pi> qr[maxn];

int mx = 0;

bool is_palyndrome(int l, int r) {
    return ((pf[r] - pw[r - l] * pf[l]) % mod + mod) % mod == ((sf[l] - pw[r - l] * sf[r]) % mod + mod) % mod;
}

int t[4][maxn];

void inc(int i, int r, int vl) {
    if (r == 0) return;
    for (; r < maxn; r += (r & -r))
        t[i][r] += vl;
}

int sum(int i, int r) {
    int ans = 0;
    for (; r > 0; r -= (r & -r))
        ans += t[i][r];
    return ans;
}

int sum(int i, int l, int r) {
    if (l == 0) ++l;
    return sum(i, r) - sum(i, l - 1);
}

signed main() {
    pw[0] = 1;
    for (int i = 1; i < maxn; i++)
        pw[i] = (pw[i - 1] * K) % mod;
    int x; cin >> x;
    string s; cin >> s;
    string t = "";
    for (int i = 0; i < s.size() - 1; i++) {
        t += s[i]; t += "{";
    }
    t += s[s.size() - 1];
    s = t;
    int n = s.size();
    for (int i = 0; i < n; i++)
        pf[i + 1] = (pf[i] * K + s[i] - 'a' + 1) % mod;
    for (int i = n - 1; i >= 0; i--)
        sf[i] = (sf[i + 1] * K + s[i] - 'a' + 1) % mod;
    for (int i = 0; i < n; i++) {
        int l = 0, r = min(i, n - i - 1) + 1;
        while (r - l > 1) {
            int md = (l + r) / 2;
            if (is_palyndrome(i - md, i + md + 1))
                l = md;
            else
                r = md;
        }
        a[i] = l + ((l % 2 == 0) ^ (i % 2));
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (i <= 2 * a[i]) continue;
        int ci = (i % 2 ? (i % 4) : (i % 4 == 2 ? 0 : 2));
        qr[i - 2 * a[i] - 1].pb({i / 2, ci});
    }
    for (int i = 0; i < n; i++) {
        int ci = (i % 2 ? (i % 4) : (i % 4 == 2 ? 0 : 2));
        ans += sum(ci, i / 2, maxn);
        for (auto gg : qr[i])
            ans -= sum(gg.r, gg.l, maxn);
        inc(i % 4, a[i] + i / 2, 1);
    }
    cout << ans;
    return 0;
}
