#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 500010;

int n;
string s;
int ans;
int a[N], b[N];
int tree1[4 * N];
int tree2[4 * N];

int Get1(int l, int r, int L = 0, int R = n, int V = 0)
{
    if (r <= L || R <= l) return 0;
    if (l <= L && R <= r)
    {
        return tree1[V];
    }
    int M = (L + R) / 2;
    return Get1(l, r, L, M, 2 * V + 1) + Get1(l, r, M, R, 2 * V + 2);
}

void Add1(int p, int L = 0, int R = n, int V = 0)
{
    tree1[V]++;
    if (L + 1 == R)
    {
        return;
    }
    int M = (L + R) / 2;
    if (p < M)
    {
        Add1(p, L, M, 2 * V + 1);
    }
    else
    {
        Add1(p, M, R, 2 * V + 2);
    }
}

int Get2(int l, int r, int L = 0, int R = n, int V = 0)
{
    if (r <= L || R <= l) return 0;
    if (l <= L && R <= r)
    {
        return tree2[V];
    }
    int M = (L + R) / 2;
    return Get2(l, r, L, M, 2 * V + 1) + Get2(l, r, M, R, 2 * V + 2);
}

void Add2(int p, int L = 0, int R = n, int V = 0)
{
    tree2[V]++;
    if (L + 1 == R)
    {
        return;
    }
    int M = (L + R) / 2;
    if (p < M)
    {
        Add2(p, L, M, 2 * V + 1);
    }
    else
    {
        Add2(p, M, R, 2 * V + 2);
    }
}

void solve(vector<int> a)
{
    vector<pair<int, int> > b;
    for (int i = 0; i < a.size(); i++) b.push_back({a[i], i});
    sort(all(b));
    reverse(all(b));
    int res = 0;
    for (int i = 0; i < b.size(); i++)
    {
        int l = max(0LL, b[i].second - b[i].first);
        int r = min((long long)b.size(), b[i].second + b[i].first + 1);
        res += Get1(l, r);
        Add1(b[i].second);
    }
    ans += res;
    fill(tree1, tree1 + 4 * N, 0);
}

signed main()
{
    cin >> n;
    cin >> s;
    for (int i = 1; i < s.size(); i++)
    {
        while (i - a[i] - 1 >= 0 && i + a[i] < s.size() && s[i - a[i] - 1] == s[i + a[i]]) a[i]++;
    }
    for (int i = 0; i < s.size(); i++)
    {
        while (i - b[i] - 1 >= 0 && i + b[i] + 1 < s.size() && s[i - b[i] - 1] == s[i + b[i] + 1]) b[i]++;
    }
    vector<int> x;
    vector<int> y;
    for (int i = 1; i < s.size(); i += 2) x.push_back(a[i]);
    for (int i = 2; i < s.size(); i += 2) y.push_back(a[i]);
    solve(x);
    solve(y);
    //cout << ans << "\n";

    vector<pair<int, int> > z;
    for (int i = 0; i < s.size(); i++) z.push_back({b[i], i});
    sort(all(z));
    reverse(all(z));

    for (int i = 0; i < z.size(); i++)
    {
        if (z[i].second % 2 == 0)
        {
            int l = max(0LL, z[i].second - 2 * z[i].first - 1);
            int r = min((long long)s.size(), z[i].second + 2 * z[i].first + 2);
            //cout << "0 " << z[i].second << " " << l << " " << r << endl;
            ans += Get1(l, r);
            //cout << Get1(l, r) << endl;
            Add2(z[i].second);
        }
        else
        {
            int l = max(0LL, z[i].second - 2 * z[i].first - 1);
            int r = min((long long)s.size(), z[i].second + 2 * z[i].first + 2);
            //cout << "1 " << z[i].second << " " << l << " " << r << endl;
            ans += Get2(l, r);
            //cout << Get2(l, r) << endl;
            Add1(z[i].second);
        }
    }
    cout << ans << "\n";
}

/*
8
aaabbaaa
*/
