#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n;
string s;
vector <vector <bool> > dp;
vector <int> ends, begs;
int ans = 0;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> s;
    dp.assign(n, vector <bool>(n + 1, false));

    for (int i = 0; i < n; i++)
        dp[i][i] = dp[i][i + 1] = true;

    for (int len = 2; len <= n; len++) {
        for (int l = 0; l <= n - len; l++) {
            int r = l + len;
            dp[l][r] = (dp[l + 1][r - 1] && s[l] == s[r - 1]);
        }
    }

    for (int i = 0; i < n; i++)
        for (int len = 1; i - len >= 0 && i + len <= n; len++)
            ans += (dp[i - len][i] && dp[i][i + len]);

    cout << ans;

    return 0;
}
