#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;
typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <int> manaker1(const string& s) {
    int n = (int) s.size();
    vector <int> ans(n, 1);
    int L = -1, R = -1;
    for(int i = 1; i < n; ++i) {
        if(i >= L && i <= R) {
            ans[i] = min(R - i + 1, ans[L + R - i]);
        }
        while(i + ans[i] < n && i - ans[i] >= 0 && s[i + ans[i]] == s[i - ans[i]]) ans[i]++;
        if(i + ans[i] - 1 > R) {
            R = i + ans[i] - 1;
            L = i - ans[i] + 1;
        }
    }
    return ans;
}

vector <int> manaker0(const string& s) {
    int n = (int) s.size();
    vector <int> ans(n, 0);
    int L = -1, R = -1;
    for(int i = 1; i < n; ++i) {
        if(i >= L && i <= R) {
            ans[i] = min(R - i + 1, ans[L + R - i + 1]);
        }
        while(i + ans[i] < n && i - 1 - ans[i] >= 0 && s[i + ans[i]] == s[i - 1 - ans[i]]) ans[i]++;
        if(i + ans[i] - 1 >= R) {
            R = i + ans[i] - 1;
            L = i - ans[i];
        }
    }
    return ans;
}

bool pal(const string& s) {
    string s2 = s;
    reverse(all(s2));
    return s == s2;
}

bool is2_pal(int a, int b, const string& s) {
    if((b - a + 1) % 2 == 1) return false;
    int len = (b - a + 1) / 2;
    string s1 = "";
    for(int i = 0; i < len; ++i) {
        s1 += s[a + i];
    }
    string s2 = "";
    for(int i = 0; i < len; ++i) {
        s2 += s[a + len + i];
    }
    return pal(s1) && pal(s2);
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector <int> m1 = manaker1(s);
//    for(auto i : m1) cout << i << ' '; cout << '\n';
    vector <int> m0 = manaker0(s);
//    for(auto i : m0) cout << i << ' '; cout << '\n';
    int ans = 0;
    /*for(int i = 0; i < n; ++i) {
        for(int j = 1; j <= m1[i]; ++j) {
            if(i - 2 * j + 1 >= 0 && m1[i - 2 * j + 1] >= j) ans++;
        }
    }*/

//    cout << ans << '\n';

    /*for(int i = 1; i < n; ++i) {
        for(int j = 1; j <= m0[i]; ++j) {
            if(i - 2 * j >= 0 && m0[i - 2 * j] >= j) ans++;
        }
    }*/

    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j) {
            if( (j - i + 1) % 2 == 1) continue;
            int len = (j - i + 1) / 2;
            if(len % 2 == 1) {
                if(m1[i + len / 2] >= len / 2 + 1 && m1[j - len / 2] >= len/2 + 1) ans++;
            } else {
                if(m0[i + len / 2 + 1] >= len / 2 && m0[j - len / 2 + 1] >= len / 2) ans++;
//                if(is2_pal(i, j, s)) ans++;
            }
        }
    }


    /*for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j) {
            if(is2_pal(i, j, s)) ans++;
        }
    }*/


    cout << ans << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    solve();
    return 0;
}