#include <bits/stdc++.h>

#define ll long long
#define ld double
#define pb push_back
#define ft first
#define sd second



using namespace std;

const ll p = 31;
const ll mod = (ll)1e9+7;

vector <ll> st(600000);

bool palyndrome(string &s,vector <ll> &h1,vector <ll> &h2, ll l, ll r) {

    ll n = (s.size());
    ll z1 = l+1;
    ll z2 = n-r;

    ll hash1 = h1[r];

    if (l > 0) {
        hash1 -= h1[l-1];
        hash1 += 2*mod;
        hash1 %= mod;
    }

    ll hash2 = h2[l];

    if (r+1 < n) {
        hash2 -= h2[r+1];
        hash2 += 2*mod;
        hash2 %= mod;
    }

    if (z1 < z2) {
        hash1 *= st[z2-z1];
        hash1 %= mod;
    }
    else {
        hash2 *= st[z1-z2];
        hash2 %= mod;
    }

    if (hash1 == hash2)
        return 1;

    return 0;
}

int main() {

    ll n;
    string s;

    cin >> n;

    cin >> s;

    st[0] = 1;
    vector <ll> h1(n),h2(n);

    for (ll i = 1; i <= n; i++) {
        st[i] = st[i-1] * p;
        st[i] %= mod;
    }

    h1[0] = (s[0]-'a'+1) * p;
    for (ll i = 1; i < n; i++) {
        h1[i] = h1[i-1] + (s[i]-'a'+1) * st[i+1];
        h1[i] %= mod;
    }

    h2[n-1] = (s[n-1]-'a'+1) * p;
    ll c = 1;
    for (ll i = n-2; i >= 0; i--) {
        c++;
        h2[i] = h2[i+1] + (s[i]-'a'+1) * st[c];
        h2[i] %= mod;
    }
    ll ans = 0;


    for (ll i = 0; i < n; i++) {
        for (ll j = i+1; j < n; j += 2) {
            ll m = (i+j)/2;

            if (palyndrome(s,h1,h2,i,m) && palyndrome(s,h1,h2,m+1,j)) {
                ans++;
            }
        }
    }

    cout << ans;
    return 0;
}
