#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

const int N = 2e6 + 5;
int a[N], b[N];
vector<pair<int, int>> qr[N];
int n;

ll ans = 0;

int t[N];

void upd(int x, int y) {
	for (; x < N; x |= x + 1)
		t[x] += y;
}

int que(int x) {
	if (x < 0)
		return 0;
	int s = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1)
		s += t[x];
	return s;
}

void solve(int p, int a[N], int fl = 0) {
	fill(t, t + N, 0);

	for (int i = 0; i < n; i++) {
		if ((i & 1) == p && a[i] != -1) {
			upd(2 * a[i] + i + 1, 1);
		}

		for (auto q : qr[i]) {
			// cout << i << " " << que(N - 1) - que(q.first - 1) << " " << q.second << "\n";
			ans += (que(N - 1) - que(q.first - 1)) * q.second;
		}
	}

}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string s;
	cin >> n >> s;

	for (int i = 0, l = -1, r = -1; i < n; i++) {
		int x = 1;

		if (i <= r) {
			x = min(r - i + 1, a[l + r - i]);
		}

		while (i - x >= 0 && i + x < n &&
			s[i - x] == s[i + x]) {
			x++;
		}

		a[i] = x;

		if (i + x - 1 > r) {
			r = i + x - 1;
			l = i - x + 1;
		}
	}

	for (int i = 0, l = -1, r = -1; i < n - 1; i++) {
		if (s[i] == s[i + 1]) {
			int x = 1;

			if (i < r) {
				x = min(r - i, b[l + r - i - 1]);
			}

			while (i - x >= 0 && i + x + 1 < n &&
				s[i - x] == s[i + x + 1]) {
				x++;
			}

			b[i] = x;

			if (i + x > r) {
				r = i + x;
				l = i - x + 1;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		a[i]--;
		b[i]--;
	}

	for (int k = 0; k < 2; k++) {
		for (int i = 0; i < n; i++) {
			qr[i].clear();
		}
		for (int i = k; i < n; i += 2) {
			int x = max(0, i - 2 * a[i] - 1);

			// cout << i << " " << x << " " << i - 1 << "\n";

			// cout << x - 1 << " " << i - 1 << "\n";

			if (x > 0) {
				qr[x - 1].push_back({i, -1});
			}
			if (i > 0) {
				qr[i - 1].push_back({i, 1});
			}
		}
		solve(k ^ 1, a);
	}



	for (int k = 0; k < 2; k++) {
		for (int i = 0; i < n; i++) {
			qr[i].clear();
		}
		for (int i = k; i < n; i += 2) {
			int x = max(0, i - 2 * b[i] - 2);

			if (x > 0) {
				qr[x - 1].push_back({i - 1, -1});
			}
			if (i > 0) {
				qr[i - 1].push_back({i - 1, 1});
			}
		}
		solve(k, b);
	}

	cout << ans;


	// ll ans = 0;

	// for (int i = 0; i < n; i++) {
	// 	for (int j = i + 1; j < n; j += 2) {
	// 		int half = (j - i - 1) / 2;
	// 		if (a[i] - 1 >= half && a[j] - 1 >= half) {
	// 			// cout << i << " " << j << "\n";
	// 			ans++;
	// 		}
	// 	}
	// }

	// for (int i = 0; i < n; i++) {
	// 	for (int j = i + 2; j < n; j += 2) {
	// 		int half = (j - i - 2) / 2;
	// 		if (b[i] && b[j] && b[i] - 1 >= half && b[j] - 1 >= half) {
	// 			ans++;
	// 		}
	// 	}
	// }

	// cout << ans;

	return 0;
}