#include <bits/stdc++.h>
using namespace std;
#define int long long
int p = 31, m = 999999929, n;
vector<int> h, rh, pw;

int get_h(int l, int r) {
    if (l == 0) {
        return h[r];
    }
    return (h[r] - h[l - 1] * pw[r - l + 1] + m * m) % m;
}

int get_rh(int l, int r) {
    l = n - l - 1;
    r = n - r - 1;
    swap(l, r);
    if (l == 0) {
        return rh[r];
    }
    return (rh[r] - rh[l - 1] * pw[r - l + 1] + m * m) % m;
}

bool is_pal(int l, int r) {
    return (get_h(l, r) == get_rh(l, r));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie();
    cin >> n;
    string s;
    cin >> s;
    h.resize(n);
    rh.resize(n);
    pw.resize(n + 1);
    pw[0] = 1;
    h[0] = s[0];
    rh[0] = s[n - 1];
    for (int i = 1; i < n; ++i) {
        pw[i] = (pw[i - 1] * p) % m;
        h[i] = (h[i - 1] * p + s[i]) % m;
        rh[i] = (rh[i - 1] * p + s[n - i - 1]) % m;
    }
    pw[n] = (pw[n - 1] * p) % m;
    /*vector<int> st(n + 2), en(n + 2);
    for (int i = 0; i < 2 * n - 1; ++i) {
        if (i % 2 == 0) {
            int c = i / 2;
            int l = 0, r = min(c + 1, n - c);
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (is_pal(c - mid, c + mid)) {
                    l = mid;
                }
                else {
                    r = mid;
                }
            }
            st[c - l] += 1;
            st[c + 1] -= 1;
            en[c + 1] += 1;
            en[c + l + 1 + 1] -= 1;
        }
        else {
            int c = i / 2;
            int l = 0, r = min(c + 2, n - c);
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (is_pal(c - mid + 1, c + mid)) {
                    l = mid;
                }
                else {
                    r = mid;
                }
            }
            st[c - l + 1] += 1;
            st[c + 1] -= 1;
            en[c + 1] += 1;
            en[c + l + 1] -= 1;
        }
    }*/
    int ans = 0;
    for (int i = 1; i < n; ++i) {
        int j = 1;
        while (i - j >= 0 && i + j - 1 < n) {
            if (is_pal(i - j, i - 1) && is_pal(i, i + j - 1)) {
                ans += 1;
            }
            j += 1;
        }
    }
    cout << ans;
    return 0;
}