#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

vector<int> gt;
string s;

bool check(int l, int r)
{
	int root = l + r;
	if (r - l + 1 <= gt[root]) return true;
	else return false;
	return true;
}

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n;
	cin >> n >> s;
	gt.resize(2 * n);
	for (int i = 0; i < n; i++)
	{
		int temp = 2 * i;
		gt[temp] = 1;
		while (i - gt[temp] >= 0 && i + gt[temp] < n && s[i - gt[temp]] == s[i + gt[temp]]) gt[temp]++;
		gt[temp] = gt[temp] + gt[temp] - 1;
	}
	for (int i = 0; i < n - 1; i++)
	{
		int temp = 2 * i + 1;
		gt[temp] = 0;
		while (i - gt[temp] >= 0 && i + gt[temp] + 1 < n && s[i - gt[temp]] == s[i + gt[temp] + 1]) gt[temp]++;
		gt[temp] = gt[temp] + gt[temp];
	}

	int ans = 0;
	for (int l = 0; l < n; l++)
	{
		for (int r = l + 1; r < n; r += 2)
		{
			int mid = (l + r) / 2;
			if (check(l, mid) && check(mid + 1, r))
			{
				ans++;
			//	cout << l << " " << r << '\n';
			}
		}
	}
	cout << ans;
	return 0;
} 