#include<bits/stdc++.h>
using namespace std;
const int base=37;
const long long mod=/*1000000000000037*/1e9+7;
char take_inp()
{
    char c;
    scanf("%c",&c);
    while('a'>c||c>'z')scanf("%c",&c);
    return c;
}

const int nmax=1e6+42;
int n,inp[nmax];

long long hsh_front[nmax],hsh_back[nmax];
long long mem_pw[nmax];

long long calc_front(int l,int r)
{
    long long ret=(hsh_front[r]-hsh_front[l-1]*mem_pw[r-l+1])%mod;
    ret=(ret+mod)%mod;
    //cout<<"calc_front "<<l<<" "<<r<<" -> "<<ret<<endl;
    return ret;
}
long long calc_back(int l,int r)
{
    long long ret=(hsh_back[l]-hsh_back[r+1]*mem_pw[r-l+1])%mod;
    ret=(ret+mod)%mod;
    //cout<<"calc_back "<<l<<" "<<r<<" -> "<<ret<<endl;
    return ret;
}
bool is_pali(int l,int r)
{
    int mid=(l+r)/2,SZ=(r-l+1);
    if(SZ%2==0)return calc_front(l,l+SZ/2-1)==calc_back(l+SZ/2,r);
    return calc_front(l,l+SZ/2)==calc_back(l+SZ/2,r);
}
int main()
{
    scanf("%i",&n);

    mem_pw[0]=1;
    for(int i=1;i<=n;i++)
        mem_pw[i]=(mem_pw[i-1]*base)%mod;

    for(int i=1;i<=n;i++)
        inp[i]=take_inp();

    for(int i=1;i<=n;i++)
        hsh_front[i]=(hsh_front[i-1]*base+inp[i]-'a'+1)%mod;
    for(int i=n;i>=1;i--)
        hsh_back[i]=(hsh_back[i+1]*base+inp[i]-'a'+1)%mod;

    //cout<<is_pali(1,1)<<endl;

    int output=0;

    for(int i=1;i<=n;i++)
        for(int sz=1;sz<=n;sz++)
        {
            int l1=i-sz;
            int r1=i-1;

            int l2=i;
            int r2=i+sz-1;

            if(l1<=0||r1>n||l2<=0||r2>n)break;

            //cout<<l1<<" "<<r1<<" "<<l2<<" "<<r2<<endl;

            output=output+(is_pali(l1,r1)&&is_pali(l2,r2));
        }

    printf("%i\n",output);
    return 0;
}
/*
6
abacac

5
aaaaa
*/