#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()

void make(const string &s, vector<int> & v0, vector<int> & v1) {
    int n = s.size();
    v0.resize(n);
    v1.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < min(i + 1, n - i); j++) {
            if (s[i - j] == s[i + j]) {
                v0[i]++;
            } else {
                break;
            }
        }
    }

    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < min(i + 1, n - i - 1); j++) {
            if (s[i - j] == s[i + j + 1]) {
                v1[i]++;
            } else {
                break;
            }
        }
    }
}

void make1(const string &s, vector<int> & v0, vector<int> & v1) {
    int n = s.size();
    v0.resize(n);

    int l = 0;
    int r = 0;
    for (int i = 0; i < n; i++) {
        if (i >= r || v0[l + r - i] + i - 1 >= r) {
            r = max(r, i);
            l = 2 * i - r;
            while (l > 0 && r < n - 1 && s[r + 1] == s[l - 1]) {
                r++;
                l--;
            }
            v0[i] = r - i + 1;
        } else {
            v0[i] = v0[r + l - i];
        }
    }

    v1.resize(n);
    l = 1;
    r = 0;
    for (int i = 0; i < n - 1; i++) {
        if (i >= r || v1[l + r - i - 1] + i >= r) {
            r = max(i, r);
            l = 2 * i - r + 1;
            while (l > 0 && r < n - 1 && s[l - 1] == s[r + 1]) {
                r++;
                l--;
            }
            v1[i] = r - i;
        } else {
            v1[i] = v1[l + r - i - 1];
        }
    }

}

ll solve(const vector<int> & v0, const vector<int> &v1) {
    int n = v0.size();
    ll ans;
    for (int l = 0; l < n - 1; l++) {
        for (int r = l + 1; r < n; r += 2) {
            int sz = (r - l + 1) / 2;
            if (v0[l] >= sz && v0[r] >= sz) {
                ans++;
            }
        }
    }

    for (int l = 0; l < n - 3; l++) {
        for (int r = l + 2; r < n - 1; r += 2) {
            int sz = (r - l) / 2;
            if (v1[l] >= sz && v1[r] >= sz) {
                ans++;
            }
        }
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    // n = s.size();
    vector<int> v0, v1;
    // vector<int> v00, v10;
    // make(s, v00, v10);
    make1(s, v0, v1);

    cout << solve(v0, v1);
    // abbabbba
}