#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;
vector <ull> h, rh;
vector <ll> sh;
vector <ull> p;
vector <ll> q;

ll geth(ll l, ll r) {
	if (!l) return h[r];
	return h[r] - h[l - 1] * p[r - l + 1];
}

ll getrh(ll l, ll r) {
	if (!l) return rh[r];
	return rh[r] - rh[l - 1] * p[r - l + 1];
}

bool ispal(ll l, ll r, vector <ll>& z) {
	ll len = r - l + 1;
	if (len % 2 == 0) {
		ll nl = 2 + 2 * l;
		ll nr = nl + (len - 1) * 2;
		return z[(nl + nr) / 2] >= len / 2 + 1;
	}
	else {
		ll nl = 2 + 2 * l;
		ll nr = nl + (len - 1) * 2;
		return 1 + (z[(nl + nr) / 2] - 1) * 2 >= nr - nl + 1;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	string s;
	cin >> s;
/*	p.resize(n + 1, 1);
	for (int i = 1; i <= n; ++i) {
		p[i] = p[i - 1] * P;
	}
	h.resize(n);
	h[0] = s[0];
	for (int i = 1; i < n; ++i) {
		h[i] = h[i - 1] * P + s[i];
	}
	string t = s;
	reverse(t.begin(), t.end());
	rh.resize(n);
	rh[0] = t[0];
	for (int i = 1; i < n; ++i) {
		rh[i] = rh[i - 1] * P + t[i];
	}*/
/*	ll ans = n - 1;
	for (int len = 4; len <= n; len += 2) {
		for (int i = 0; i + len - 1 < n; ++i) {
			// i + len / 4 - 1, i + len / 2 - 1, i + len / 4 * 3 - 1, i + len - 1;

		}
	}*/
	string ns = "@#";
	for (auto& x : s) {
		ns += x;
		ns += '#';
	}
	ns += '$';
	vector <ll> z(ns.size());
	ll l = 0, r = 0;
	for (int i = 2; i < z.size() - 1; ++i) {
		if (i < r) {
			ll c = l - (i - l);
			z[i] = mmin(r - i, z[c]);
		}
		while (ns[i - z[i]] == ns[i + z[i]]) {
			++z[i];
			l = i;
			r = i + z[i];
		}
	}
/*	for (auto& x : ns) {
		cout << x << ' ';
	}
	cout << '\n';
	for (auto& x : z) {
		cout << x << ' ';
	}
	cout << '\n';*/
/*	for (int i = 2; i < ns.size() - 2; i += 1) {
		for (int j = 0 + i % 2; j < z[i] / 2; ++j) {
			if (i + (j + 1) * 2 < ns.size() - 2 && z[i + (j + 1) * 2] / 2 >= j + 1) {
				cout << "From position " << i << " checking length " << j << " using position " << i + (j + 1) * 2 << '\n';
				++ans;
			}
		}
	}*/
	ll ans = n - 1;
	for (int len = 2; len <= n; ++len) {
		for (int i = 0; i + 2 * len - 1 < n; ++i) {
			ans += (ispal(i, i + len - 1, z) & ispal(i + len, i + 2 * len - 1, z));
		}
	}
	cout << ans;
	return 0;
}

/*
aaa
*/