#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<time.h>
#include<random>
#include<stack>
#include<queue>
#include<deque>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	string s; cin >> s;
	vector<set<int>> lft(n);
	vector<set<int>> rgt(n);
	vector<vector<bool>> win(n, vector<bool>(n, false));
	for (int l = 0; l < n; ++l) {
		for (int x = 0; (x + l) < n; ++x) {
			if (l == 0 || (l == 1 && s[x] == s[x + 1]) || ((l > 1) && s[x] == s[x + l] && win[x + 1][x + l - 1])) {
				lft[x + l].insert(l);
				rgt[x].insert(l);
				win[x][x + l] = true;
			}
		}
	}
	ll ans = 0;
	for (int x = 0; x < n; ++x) {
		for (int y = x + 1; y < n; y += 2) {
			int len = (y - x - 1) / 2;
			if (rgt[x].count(len) + lft[y].count(len) == 2) {
				ans++;
			}
		}
	}
	cout << ans << endl;
	cout << endl;
	//system("pause");
	return 0;
}
