#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define int ll
typedef pair<int, int> pii;
typedef long double ld;
typedef unsigned long long ull;
mt19937 rnd;
#define rep(a, b, c) for (int a = (b); a < (int)(c); ++a)
#define put(a) cout << (a) << '\n'
#define all(a) a.begin(), a.end()
#define chkmin(a, b) a = min(a, (b))
#define chkmax(a, b) a = max(a, (b))

/*
 * while (clock() < t * CLOCK_PER_SEC)
 */
struct Hash {
    int p, mod;
    string s;
    vector<int> pref;
    vector<int> p_pows;
    Hash(){}
    Hash(string _s, int _p, int _mod) {
        s = _s;
        p = _p;
        mod = _mod;
        int n = s.size();
        pref.push_back(0);
        rep(i, 0, n){
            pref.push_back((pref.back() * p + s[i] - 'a' + 1) % mod);
        }
        p_pows.push_back(1);
        rep(i, 0, n) p_pows.push_back(p_pows.back() * p % mod);
    }
    int get(int l, int len) {
        int h6 = (pref[l] * p_pows[len]) % mod;
        return (pref[l + len] - (pref[l] * p_pows[len]) % mod + mod) % mod;
    }
};
int n;
int rev(int i) {
    return n - i - 1;
}
Hash h1, h2, h3, h4;

int is_pal(int i, int j) {
    if (h1.get(i, j) != h3.get(rev(i) - j + 1, j)) return 0;
    return h2.get(i, j) == h4.get(rev(i) - j + 1, j);
}
void solve() {
    string s;
    cin >> n >> s;
    const int M1 = 1000000007;
    const int M2 = 1000000009;
    h1 = Hash(s, 997, M1);
    string s2 = s;
    reverse(all(s2));
    h2 = Hash(s, 127, M2);
    h3 = Hash(s2, 997, M1);
    h4 = Hash(s2, 127, M2);
    int res = 0;
    rep(i, 1, n) {
        rep(j, 1, min(i, n - i) + 1) {
            if (is_pal(i, j) && is_pal(i - j, j)) ++res;
        }
    }
    put(res);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
//    freopen("in.txt", "r", stdin);

    int t = 1;
    while (t--) solve();
    return 0;
}