#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;
typedef long double db;

struct Node {
    int l, r, x, t;
    Node (int l = 0, int r = 0, int x = 0, int t = 0) :
        l(l), r(r), x(x), t(t) {};
};

#ifdef MY
const int N  = 100;
#else
const int N = 5e5 + 5;
#endif // MY

string s;
int n;
int ans = 0;
int val[N];
int len[N];
Node ask[N];
int sum[N];
int C = 0;
int p = 1;
int pos;

bool cmp(Node& a, Node& b) {
    if (a.x == b.x) {
        return a.t < b.t;
    }
    return a.x > b.x;
}

void add(int p, int x = 1) {
//    sum[p]++;
//    return;
    for (; p <= pos; p = (p | (p + 1))) {
        sum[p] += x;
    }
}

int get_sum(int p) {
    int res = 0;
    for (; p >= 0; p = (p & (p + 1)) - 1) {
        res += sum[p];
    }
    return res;
}

int get_sum(int l, int r) {
//    int res = 0;
//    for (int i = l; i <= r; i++) {
//        res += sum[i];
//    }
//    return res;
    return get_sum(r) - get_sum(l - 1);
}

void solve1() {
    //cout << ans << endl;
    fill(sum, sum + pos + 1, 0);
    sort(ask, ask + C, cmp);
    for (int i = 0; i < C; i++) {
        Node k = ask[i];
        ans += get_sum(ask[i].l, ask[i].r);
        add(k.t);
    }
}

void solve2(int x) {
    //cout << ans << endl;
    fill(sum, sum + pos + 1, 0);
    sort(ask, ask + C, cmp);
    for (int i = 0; i < C; i++) {
        Node k = ask[i];
        if (k.t == x) {
            add(k.l);
            continue;
        }
        ans += get_sum(ask[i].l, ask[i].r);
    }
}

void solveeven(int t) {
    C = 0;
    for (int i = 0; i < n; i++) {
        if (i % 2 != t) {
            continue;
        }
        ask[C++] = Node(max(0ll, i - 2 * len[i]), min(n - 1, i + 2 * len[i]), len[i], i);
        //ask[C++] = Node(i, i, len[i], 0);
        pos++;
    }
    pos = n;
    solve1();
}

void even() {

    int l = 1, r = 1;
    for (int i = 1; i < n; i++) {
        //len[i] = max(0ll, min(r - i, len[l - (i - l)]));
        while (i >= len[i] + 1 && i + len[i] < n &&
               s[i - len[i] - 1] == s[i + len[i]]) {
            len[i]++;
        }
        if (len[i] > r - l) {
            l = i, r = i + len[i];
        }
    }
//    for (int i = 1; i < n; i++) {
//        cout << len[i] << ' ';
//    } cout << endl;
    solveeven(0);
    solveeven(1);
}

void solveodd(int t) {
    C = 0;
    for (int i = 0; i < n; i++) {
        if (i % 2 == t) {
            ask[C++] = Node(max(0ll, i - 2 * len[i] + 1), min(n - 1, i + len[i] * 2 - 1), len[i], 1);
        } else {
            ask[C++] = Node(i, i, len[i], 0 + t * 2);
        }
    }
    pos = n;
    solve2(t * 2);
    //cout << ans << endl;
}

void odd() {
    //cout << ans << endl;
    fill(len, len + n, 0);
    int l = 0, r = 0;
    for (int i = 0; i < n; i++) {
        //len[i] = max(0ll, min(r - i + 1, len[l - (i - l)]));
        while (i >= len[i] && i + len[i] < n &&
                s[i - len[i]] == s[i + len[i]]) {
            len[i]++;
        }
        if (len[i] > r - l) {
            l = i, r = i + len[i];
        }
    }
//    for (int i = 0; i < n; i++) {
//        cout << len[i] << ' ';
//    } cout << endl;
    solveodd(0);
    solveodd(1);
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    cin >> s;
    even();
    odd();
    cout << ans;
    return 0;
}
