#include <bits/stdc++.h>

using namespace std;

const int p = 1e9 + 7;

vector<long long> pr, sf;
vector<long long> b;

int good(int l, int r, bool flag = false)
{
    int h1 = pr[r + 1] - pr[l] * b[r - l + 1];
    h1 %= p;
    h1 = (h1 + p) % p;
    int h2 = sf[l] - sf[r + 1] * b[r - l + 1];
    h2 %= p;
    h2 = (h2 + p) % p;
    return h1 == h2;
}

int main()
{
    int n;
    cin >> n;
    string s;
    cin >> s;
    b.resize(n + 1);
    b[0] = 1;
    for (int i = 1; i < n; ++i)
    {
        b[i] = (b[i - 1] * 37) % p;
    }
    pr.resize(n + 1);
    pr[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        pr[i + 1] = (pr[i] * b[1] + s[i] - 'a' + 1) % p;
    }
    sf.resize(n + 1);
    sf[n] = 0;
    for (int i = n - 1; i > -1; --i)
    {
        sf[i] = (sf[i + 1] * b[1] + s[i] - 'a' + 1) % p;
    }
    int ans = 0;
    for (int l = 0; l < n - 1; ++l)
    for (int r = l; r < n; ++r)
    {
        if ((r - l + 1) % 2) continue;
        int m = (l + r + 1) / 2; // l..m-1 , m..r
        if (good(l, m - 1) && good(m, r))
        {
            ++ans;
        }
    }
    cout << ans << endl;
}
