#include <iostream>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

char ch[MAXN + 5];
map< pair<int, int>, bool> m;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++ i)
    {
        cin >> ch[i];
        m[make_pair(i, i)] = true;
        for (int j = 0; j < i; ++ j)
        {
            if (ch[i] == ch[j])
            {
                if (j == i - 1) m[make_pair(j, i)] = true;
                else
                {
                    if (m.find(make_pair(j + 1, i - 1)) != m.end()) m[make_pair(j, i)] = true;
                }
            }
        }
    }

    long long ans = 0;
    for (int i = 1; i <= n / 2; ++ i)
    {
        for (int j = 0; j <= n - 2 * i; ++ j)
        {
            if (m.find(make_pair(j, j + i - 1)) != m.end() and m.find(make_pair(j + i, j + 2 * i - 1)) != m.end()) ans++;
        }
    }

    cout << ans << endl;

    return 0;
}
