#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
#define fst first
#define snd second
#define sz(X) (int)(X.size())
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MOD = 1e9 + 7;
const int N = 5e5;

int p[N];

vi get_hash(const string &s) {
    int n = sz(s);
    vi h(n + 1);
    forn(i, n) h[i + 1] = (h[i] + (((s[i] - 'a') + 1) * 1ll * p[i]) % MOD) % MOD;
    return h;
}

int get(vi h, int l, int r) {
    int x = (h[r + 1] - h[l] + MOD) % MOD;
    return (x * 1ll * p[N - l - 1]) % MOD;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    p[0] = 1;
    forab(i, 1, N) p[i] = (p[i - 1] * 1ll* 31) % MOD;
    int n;
    cin >> n;
    string s, t;
    cin >> s;
    t = s;
    reverse(all(t));
    vi h1 = get_hash(s), h2 = get_hash(t);
    ll ans = 0;
    forn(i, n) {
        forab(j, i, n) {
            int len = (j - i + 1);
            if (j + len >= n) break;
            if (get(h1, i, j) != get(h2, n - 1 - j, n - 1 - i)) continue;
            int a = j + 1, b = 2 * j - i + 1;
            if (get(h1, a, b) != get(h2, n - 1 - b, n - 1 - a)) continue;
            ans++;
        }
    }
    cout << ans << "\n";
    return 0;
}