#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
long long p = 31;
long long Mod = 1e9 + 7;
const int maxn = 5002;
vector<long long> poww(maxn);
void build(vector<long long> &Has, string &a) {
    Has[0] = a[0] - 'a';
    for(int i = 1; i < a.size(); ++i) {
        Has[i] = (Has[i - 1]*p + a[i] - 'a')%Mod;
    }
}
void buildr(vector<long long> &Has, string &a) {
    int n = a.size();
    Has[0] = a[n - 1 - 0] - 'a';
    for(int i = 1; i < a.size(); ++i) {
        Has[i] = (Has[i - 1]*p + a[n - 1 - i] - 'a')%Mod;
    }
}
void rev(string &b, string &a) {
    for(int i = a.size() - 1; i >= 0; --i) {
        b += a[i];
    }
}
long long Hash(vector<long long> &Has, int l, int r) {
    if(l == 0) {
        return Has[r];
    }
    return (Mod*Mod + Has[r] - Has[l - 1]*poww[r - l + 1])%Mod;
}
bool pal(int l, int r, vector<long long> Has, vector<long long> &Hasr) {
    int n = Has.size();
    return Hash(Has, l, r) == Hash(Hasr, n - r - 1, n - l - 1);
}
bool is(vector<int> &len, vector<int> &len2, int l, int r) {
    if((r - l + 1)%2 == 1) {
        int ser = (r + l)/2;
        return len[ser] >= (r - l + 1)/2;
    }
    else {
        int ser = (r + l)/2;
        return len2[ser] + 1>= (r - l + 1)/2;
    }
}
int main() {
    int n;
    cin >> n;
    string a;
    cin >> a;
    vector<int> len(n);
    for(int i = 0; i < n; ++i) {
        while(i - len[i] - 1 >= 0 && i + len[i] + 1 < n && a[i - len[i] - 1] == a[i + len[i] + 1]) {
            ++len[i];
        }
    }
    vector<int> len2(n, -1);
    for(int i = 0; i < n; ++i) {
        while(i - len2[i] - 1 >= 0 && i + 1 + len2[i] + 1 < n && a[i - len2[i] - 1] == a[i + 1 + len2[i] + 1]) {
            ++len2[i];
        }
    }
    int sum = 0;
    for(int i = 1; i*2 <= n; i += 1) {
        for(int j = 0; j + i*2 <= n; ++j) {
            if(is(len, len2, j, j + i - 1) && is(len, len2, j + i, j + 2*i - 1)) {
                    ++sum;
            }
        }
    }
    cout << sum;
}
