#include <bits/stdc++.h>

#define int long long
#define pb push back
#define endl '\n'
typedef long double ld;

using namespace std;

const int MOD = 1000000007;
const int p = 31;

bool is_pal (vector<int> hash1, vector<int> hash2, int i, int j, vector<int> pows, int n) {
//    cout << (hash1[j + 1] - hash1[i] + MOD) % MOD * pows[n - j - 1] % MOD << endl;
//    cout << (hash2[n - i] - hash2[n - j - 1] + MOD) % MOD * pows[i] % MOD << endl;
    return (hash1[j + 1] - hash1[i] + MOD) % MOD * pows[n - j - 1] % MOD == (hash2[n - i] - hash2[n - j - 1] + MOD) % MOD * pows[i] % MOD;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    string s;
    cin >> n >> s;
    vector<int> hash1(n + 1, 0);
    string s1 = s;
    reverse(s1.begin(), s1.end());
    vector<int> hash2(n + 1, 0);
    vector<int> powers(n + 1);
    powers[0] = 1;
    for (int i = 0; i < n; i++) {
        powers[i + 1] = powers[i] * p;
        powers[i + 1] %= MOD;
    }
    for (int i = 0; i < n; i++) {
        hash1[i + 1] = (hash1[i] + powers[i] * (s[i] - 'a' + 1) % MOD) % MOD;
        hash2[i + 1] = (hash2[i] + powers[i] * (s1[i] - 'a' + 1) % MOD) % MOD;
    }
//    cout << is_pal(hash1, hash2, 0, 0, powers, n) << endl;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 2; j <= n - i; j += 2) {
            if (is_pal(hash1, hash2, i, i + j / 2 - 1, powers, n) && is_pal(hash1, hash2, i + j / 2, i + j - 1, powers, n)) {
                ans++;
            }
        }
    }
    cout << ans << endl;
    return 0;
}