#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

int check(int l, int r, const string &s) {
    for (int i = 0; i < (r - l + 1) / 4; ++i)
        if (s[l + i] != s[l + (r - l + 1) / 2 - i - 1])
            return 0;
    for (int i = 0; i < (r - l + 1) / 4; ++i)
        if (s[i + l + (r - l + 1) / 2] != s[r - i])
            return 0;
    return 1;
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((j - i) % 2 == 0)
                continue;
            ans += check(i, j, s);
        }
    }
    cout << ans << '\n';
}