#include <bits/stdc++.h>
#define int long long 
#define l l228 
#define r r228

#define ff first 
#define ss second 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()

#define TIME (ld)clock() / CLOCKS_PER_SEC
#define debug(x) cout << #x << ": " << x << endl; 

using namespace std; 
mt19937 rnd(2007); 
typedef long long ll; 
typedef long double ld;
typedef pair<int, int> pii; 
const int maxn = 5e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7; 
const ll inf = 1e18; 
int n;
string s;
const int p = 31; 
int pw[maxn]; 
int hsh[maxn][2];

int get(int l, int r, bool t) {
    if (t == 1) {
        r = n - r - 1;
        l = n - l - 1; 
        swap(l, r);  
    }    
    return (hsh[r + 1][t] - hsh[l][t] * pw[r - l + 1] % mod + mod) % mod;
}

int odd[maxn]; 
int even[maxn]; 

int binn1(int id) {
    int l = 0; 
    int m; 
    int r = min(id, n - id - 1) + 1; 
    while (l + 1 < r) {
        m = (l + r) / 2;         
        if (get(id - m, id + m, 0) == get(id - m, id + m, 1)) l = m; 
        else r = m; 
    }
    return l; 
}

int binn0(int id) {
    int l = 0; 
    int m; 
    int r = min(id + 1, n - id - 1) + 1; 
    while (l + 1 < r) {
        m = (l + r) / 2;
        if (get(id - m + 1, id + m, 0) == get(id - m + 1, id + m, 1)) l = m;
        else r = m; 
    }
    return l; 
}

struct Tree {
    int tree[4 * maxn]; 
    void build() {
        for (int i = 0; i < 4 * maxn; ++i) tree[i] = 0; 
    }
    int get(int l, int r, int l1, int r1, int rt) {
        if (l >= l1 && r <= r1) return tree[rt];
        if (max(l, l1) > min(r, r1)) return 0; 
        int t = (l + r) / 2; 
        return get(l, t, l1, r1, rt * 2 + 1) + get(t + 1, r, l1, r1, rt * 2 + 2); 
    }
    void upd(int l, int r, int id, int rt, int xx) {
        if (l == id && r == id) {
            tree[rt] += xx; 
            return; 
        }
        if (l > id || r < id) return; 
        int t = (l + r) / 2; 
        upd(l, t, id, rt * 2 + 1, xx); 
        upd(t + 1, r, id, rt * 2 + 2, xx); 
        tree[rt] = tree[rt * 2 + 1] + tree[rt * 2 + 2]; 
    }
    int get(int l, int r) {
        if (l < 0) l = 0;  
        if (r < 0) return 0; 
        return get(0, n - 1, l, r, 0); 
    }
    void upd(int id, int xx) {
        upd(0, n - 1, id, 0, xx); 
    }                           
};

void solve() {
    pw[0] = 1; 
    for (int i = 1; i < maxn; ++i) {
        pw[i] = pw[i - 1] * p;
        pw[i] %= mod;         
    }
    cin >> n >> s;
    for (int i = 0; i < n; ++i) {
        hsh[i + 1][0] = hsh[i][0] * p + s[i] - 'a' + 1;
        hsh[i + 1][0] %= mod;
    }
    reverse(all(s)); 
    for (int i = 0; i < n; ++i) {
        hsh[i + 1][1] = hsh[i][1] * p + s[i] - 'a' + 1;
        hsh[i + 1][1] %= mod;
    }
    reverse(all(s)); 
    for (int i = 0; i < n; ++i) {
        odd[i] = binn1(i);
        even[i] = binn0(i); 
    }
    vector<pii> have; 
    for (int i = 0; i < n; ++i) {
        have.eb(i, odd[i]); 
    }
    sort(all(have), [&](pii a, pii b) {
        return a.ss > b.ss;
    }); 
    Tree tree0, tree1; 
    tree0.build(); 
    tree1.build(); 
    int ans = 0; 
    for (int i = 0; i < (int)have.size(); ++i) {
        int len = have[i].ss; 
        int id = have[i].ff; 
        if (id % 2 == 0) {
            ans += tree1.get(id - len * 2 - 1, id); 
            ans += tree1.get(id, id + len * 2 + 1);  
            tree0.upd(id, 1); 
        } else {
            ans += tree0.get(id - len * 2 - 1, id); 
            ans += tree0.get(id, id + len * 2 + 1);  
            tree1.upd(id, 1);         
        }
        /*
        for (int j = 0; j < i; ++j) {
            int id1 = have[j].ff; 
            if (id % 2 != id1 % 2) {
                ans += (abs(id1 - id) - 1 <= len * 2); 
            }                        
        }*/
    
    }
    have.clear(); 
    tree0.build(); 
    tree1.build(); 
    for (int i = 0; i < n; ++i) have.eb(i, even[i]); 
    sort(all(have), [&](pii a, pii b) {
        return a.ss > b.ss;
    }); 
    for (int i = 0; i < (int)have.size(); ++i) {
        int id = have[i].ff;
        int len = have[i].ss; 
        if (id % 2 == 0) {
            ans += tree0.get(id - len * 2, id);
            ans += tree0.get(id, id + len * 2); 
            tree0.upd(id, 1); 
        } else {
            ans += tree1.get(id - len * 2, id);
            ans += tree1.get(id, id + len * 2);             
            tree1.upd(id, 1); 
        }
    }        
    /*
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (i % 2 != j % 2) {   
                continue; 
            } else {
                int len = (j - i) / 2; 
                if (len <= min(even[i], even[j])) ++ans; 
            }
        }
    }
    */
    cout << ans; 
}

signed main() {
#ifdef LOCAL 
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout); 
#endif 
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    int t = 1; 
    for (int i = 0; i < t; ++i) solve(); 
    return 0; 
}
    