#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <queue>
#include <deque>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string.h>
#include <time.h>
#include <random>
#include <assert.h>
#include <string>

using namespace std;

typedef long long ll;
#define ff first
#define ss second
#define mp make_pair
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define vpii vector<pii>
#define make_unique(x) sort(x.begin(),x.end()); x.resize(unique(x.begin(),x.end()) - x.begin());
#define sz(x) ((int)x.size())
#define pb push_back
#define eb emplace_back

inline int nxt() {
	static int buf_nxt;
	cin >> buf_nxt;
	return buf_nxt;
}

inline ll nxtll() {
	static ll buf_nxt_ll;
	cin >> buf_nxt_ll;
	return buf_nxt_ll;
}
#define N (500000 + 19)
#define BASE (73)
#define MOD ((ll)1000000000 + 97)
#define inf (1000000000)
string s;
int n;

int h[N];
int rh[N];
int base_step[N];
int odd_len[N];
int even_len[N];

int get_hash(int l, int r) {
	r++;
	return (h[r] - (ll)h[l] * base_step[r - l] + (ll)MOD * MOD) % MOD;
}

int get_rhash(int nl, int nr) {
	int r = n - nl - 1;
	int l = n - nr - 1;
	r++;
	return (rh[r] - (ll)rh[l] * base_step[r - l] + (ll)MOD * MOD) % MOD;
}

int get_even_palindrome(int ind) {
	if (s[ind] != s[ind + 1]) {
		return 0;
	}
	int L = 1, R = n + 1;
	while (R - L > 1) {
		int len = (L + R) / 2;
		int l = ind - len + 1;
		int r = ind + len;
		if (l < 0 || r >= n) R = len;
		else {
			if (get_hash(l, ind) == get_rhash(ind + 1, r)) {
				L = len;
			}
			else {
				R = len;
			}
		}
	}
	return L;
}

int get_odd_palindrome(int ind) {
	int L = 1, R = n + 1;
	while (R - L > 1) {
		int len = (L + R) / 2;
		int l = ind - len + 1;
		int r = ind + len - 1;
		if (l < 0 || r >= n) R = len;
		else {
			if (get_hash(l, ind) == get_rhash(ind, r)) {
				L = len;
			}
			else {
				R = len;
			}
		}
	}
	return L;
}

void hash_precalc() {
	base_step[0] = 1;
	for (int i = 1; i < N; i++) {
		base_step[i] = ((ll)base_step[i - 1] * BASE) % MOD;
	}
	for (int i = 0; i < n; i++) {
		h[i + 1] = ((ll)h[i] * BASE + s[i] - 'a' + 1) % MOD;
	}
	string q = s;
	reverse(q.begin(), q.end());
	for (int i = 0; i < n; i++) {
		rh[i + 1] = ((ll)rh[i] * BASE + q[i] - 'a' + 1) % MOD;
	}
}


vector<int> odd_odd[2 * N];
vector<int> odd_even[2 * N];
vector<int> even_odd[2 * N];
vector<int> even_even[2 * N];

void build(vector<int> p, vector<int> *t) {
	for (int i = 0; i < p.size(); i++) {
		t[i + N].push_back(p[i]);
	}
	for (int i = N - 1; i >= 0; i--) {
		if (2 * i + 1 < 2 * N) {
			merge(t[2 * i].begin(), t[2 * i].end(), t[2 * i + 1].begin(), t[2 * i + 1].end(), back_inserter(t[i]));
		}
		else {
			if (2 * i < 2 * N) {
				t[i] = t[2 * i];
			}
		}
	}
}

int get_more(int l, int r, int x, vector<int>*t) {
	r++;
	int ans = 0;
	for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			ans += t[l].end() - upper_bound(t[l].begin(), t[l].end(), x);
			l++;
		}
		if (r & 1) {
			r--;
			ans += t[r].end() - upper_bound(t[r].begin(), t[r].end(), x);
		}
	}
	return ans;
}

void solution() {
	n = nxt();
	cin >> s;
	hash_precalc();
	int ans = 0;
	for (int i = 0; i < n - 1; i++) {
		even_len[i] = get_even_palindrome(i);
	}
	for (int j = 0; j < n; j++) {
		odd_len[j] = get_odd_palindrome(j);
	}
	vector<int>b_odd_odd;
	vector<int>b_even_odd;
	vector<int>b_odd_even;
	vector<int>b_even_even;
	for (int i = 0; i < n; i++) {
		if (i & 1) {
			b_odd_odd.push_back(odd_len[i]);
			b_odd_even.push_back(even_len[i]);
			b_even_odd.push_back(-inf);
			b_even_even.push_back(-inf);
		}
		else {
			b_even_odd.push_back(odd_len[i]);
			b_even_even.push_back(even_len[i]);
			b_odd_odd.push_back(-inf);
			b_odd_even.push_back(-inf);
		}
	}
	build(b_odd_odd, odd_odd);
	build(b_odd_even, odd_even);
	build(b_even_even, even_even);
	build(b_even_odd, even_odd);
	for (int i = 0; i < n - 1; i++) {
		int lj = i + 1;
		int rj = min(n - 1, odd_len[i] * 2 + i - 1);
		if (lj > rj)continue;
		if (i & 1) {
			ans += get_more(lj, rj, odd_len[i], even_odd);
		}
		else {
			ans += get_more(lj, rj, odd_len[i], odd_odd);
		}
	}
	for (int j = 1; j < n; j++) {
		int lj = max(0, j + 1 - 2 * odd_len[j]);
		int rj = j - 1;
		if (lj > rj)continue;
		if (j & 1) {
			ans += get_more(lj, rj, odd_len[j], even_odd);
		}
		else {
			ans += get_more(lj, rj, odd_len[j], odd_odd);
		}
	}

	for (int i = 0; i + 3 < n; i++) {
		int lj = i + 2;
		int rj = min(n - 1, 2 * even_len[i] + i);
		if (lj > rj)continue;
		if (i & 1) {
			ans += get_more(lj, rj, even_len[i], odd_even);
		}
		else {
			ans += get_more(lj, rj, even_len[i], even_even);
		}
	}

	for (int j = 2; j + 1 < n; j++) {
		int lj = max(j - 2 * even_len[j], 0);
		int rj = j - 2;
		if (lj > rj)continue;
		for (int i = lj; i <= rj; i++) {
			if ((i & 1) != (j & 1)) continue;
			if (even_len[i] >= even_len[j]) {
				ans++;
			}
		}
	}
	cout << ans;
}

void stupid() {
}
	
void gen() {

}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	srand(239);
	solution();
	return 0;
}