#include<bits/stdc++.h>
using namespace std;
#define int unsigned long long
int max(int a, int b)
{
	if (a > b)
	{
		return a;
	}
	return b;
}
vector <int> hash1, hash2, hash3, hash4;
vector <int> pow1, pow2;
vector <vector <int> > tree1, tree2, tree3, tree4;
const int const1 = 1e9 + 7;
const int const2 = 1e9 + 37;
int n;
pair <int, int> get_hash(int l, int r)
{
	if (l == 0)
	{
		return { hash1[r], hash2[r] };
	}
	else
	{
		return { hash1[r] - hash1[l - 1] * pow1[r - l + 1], hash2[r] - hash2[l - 1] * pow2[r - l + 1] };
	}
}
pair <int, int> get_hash1(int l, int r)
{
	if (r == n - 1)
	{
		return { hash3[l], hash4[l] };
	}
	else
	{
		return { hash3[l] - hash3[r + 1] * pow1[r - l + 1], hash4[l] - hash4[r + 1] * pow2[r - l + 1] };
	}
}
void update1(int v, int l, int r, int al, int ar, int a)
{
    if(l >= al && r <= ar) {
        tree1[v].push_back(a);
    }
    else if(l <= ar && r >= al)
    {
        update1(v * 2, l, (r + l) / 2, al, ar, a);
        update1(v * 2 + 1, (r + l) / 2 + 1, r, al, ar, a);
    }
}
void update2(int v, int l, int r, int al, int ar, int a)
{
    if(l >= al && r <= ar) {
        tree2[v].push_back(a);
    }
    else if(l <= ar && r >= al)
    {
        update2(v * 2, l, (r + l) / 2, al, ar, a);
        update2(v * 2 + 1, (r + l) / 2 + 1, r, al, ar, a);
    }
}
void build1(int v, int l, int r)
{
    tree1[v].push_back(0);
    if(tree1[v].size() != 0)
    {
        sort(tree1[v].begin(), tree1[v].end());
    }
    if(l == r)
    {
        return;
    }
    build1(v * 2, l, (r + l) / 2);
    build1(v * 2 + 1, (r + l) / 2 + 1, r);
}
void build2(int v, int l, int r)
{
    tree2[v].push_back(0);
    if(tree2[v].size() != 0)
    {
        sort(tree2[v].begin(), tree2[v].end());
    }
    if(l == r)
    {
        return;
    }
    build2(v * 2, l, (r + l) / 2);
    build2(v * 2 + 1, (r + l) / 2 + 1, r);
}
int sum1(int v, int l, int r, int ind, int a, int p)
{
    int l1 = 0, r1 = tree1[v].size();
    while(r1 - l1 > 1)
    {
        int midd = (r1 + l1) / 2;
        if(tree1[v][midd] + 2 * a + p >= ind)
        {
            r1 = midd;
        }
        else
        {
            l1 = midd;
        }
    }
    int cnt = tree1[v].size() - r1;
    if(l == r)
    {
        return cnt;
    }
    if(ind <= (r + l) / 2)
    {
        return cnt + sum1(v * 2, l, (r + l) / 2, ind, a, p);
    }
    else
    {
        return cnt + sum1(v * 2 + 1, (r + l) / 2 + 1, r, ind, a, p);
    }
}
int sum2(int v, int l, int r, int ind, int a, int p)
{
    int l1 = 0, r1 = tree2[v].size();
    while(r1 - l1 > 1)
    {
        int midd = (r1 + l1) / 2;
        if(tree2[v][midd] + 2 * a + p >= ind)
        {
            r1 = midd;
        }
        else
        {
            l1 = midd;
        }
    }
    int cnt = tree2[v].size() - r1;
    if(l == r)
    {
        return cnt;
    }
    if(ind <= (r + l) / 2)
    {
        return cnt + sum2(v * 2, l, (r + l) / 2, ind, a, p);
    }
    else
    {
        return cnt + sum2(v * 2 + 1, (r + l) / 2 + 1, r, ind, a, p);
    }
}
signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n;
	string s;
	cin >> s;
	hash1.resize(n);
	hash2.resize(n);
	hash3.resize(n);
	hash4.resize(n);
	pow1.resize(n + 1);
	pow2.resize(n + 1);
	pow1[0] = pow2[0] = 1;
	tree1.resize(4 * n);
	tree2.resize(n * 4);
	for (int i = 1; i <= n; i++)
	{
		pow1[i] = pow1[i - 1] * 27;
		pow2[i] = pow2[i - 1] * 27;
	}
	for (int i = 0; i < n; i++)
	{
		if (i == 0)
		{
			hash1[i] = s[i] - 'a' + 1;
			hash2[i] = s[i] - 'a' + 1;
		}
		else
		{
			hash1[i] = (hash1[i - 1] * 27 + s[i] - 'a' + 1);
			hash2[i] = (hash2[i - 1] * 27 + s[i] - 'a' + 1);
		}
	}
	for (int i = n - 1; i >= 0; i--)
	{
		if (i == n - 1)
		{
            hash3[i] = s[i] - 'a' + 1;
			hash4[i] = s[i] - 'a' + 1;
		}
		else
		{
			hash3[i] = (hash3[i + 1] * 27 + s[i] - 'a' + 1);
			hash4[i] = (hash4[i + 1] * 27 + s[i] - 'a' + 1);
		}
		if(i == 0)
        {
		    break;
        }
	}
	vector <int> pal1(n), pal2(n);
	for (int i = 0; i < n; i++)
	{
		int l = 0, r = min(i, n - i) + 1;
		while (r - l > 1)
		{
			int midd = (r + l) / 2;
			if (get_hash(i - midd, i - 1) == get_hash1(i, i + midd - 1))
			{
				l = midd;
			}
			else
			{
				r = midd;
			}
		}
		pal1[i] = l;
		l = 0, r = min(i + 1, n - i) + 1;
		while (r - l > 1)
		{
			int midd = (r + l) / 2;
			if (get_hash(i - midd + 1, i) == get_hash1(i, i + midd - 1))
			{
				l = midd;
			}
			else
			{
				r = midd;
			}
		}
		pal2[i] = l;
	}
	int ans = 0;
	for(int i = 0; i < n; i++)
    {
	    if(pal1[i] == 0)
        {
	        continue;
        }
	    if(i % 2 == 0)
        {
	        update1(1, 0, n - 1, i + 1, i + 2 * pal1[i], i);
        }
	    else{
	        update2(1, 0, n - 1, i + 1, i + 2 * pal1[i], i);
	    }
    }
	build1(1, 0, n - 1);
	build2(1, 0, n - 1);
	for(int i = 0; i < n; i++)
    {
	    if(i % 2 == 0)
        {
	        ans += sum1(1, 0, n - 1, i, pal1[i], 0);
        } else
        {
	        ans += sum2(1, 0, n - 1, i, pal1[i], 0);
        }
    }
	for(int i = 0; i < 4 * n; i++)
    {
	    if(tree1[i].size() != 0)
        {
	        tree1[i].clear();
        }
	    if(tree2[i].size() != 0)
        {
	        tree2[i].clear();
        }
    }
    for(int i = 0; i < n; i++)
    {
        if(i % 2 == 0)
        {
            update1(1, 0, n - 1, i + 1, i + 2 * pal2[i] - 1, i);
        }
        else{
            update2(1, 0, n - 1, i + 1, i + 2 * pal2[i] - 1, i);
        }
    }
    build1(1, 0, n - 1);
    build2(1, 0, n - 1);
    for(int i = 0; i < n; i++)
    {
        if(i % 2 == 1)
        {
            ans += sum1(1, 0, n - 1, i, pal2[i] - 1, 1);
        } else
        {
            ans += sum2(1, 0, n - 1, i, pal2[i] - 1, 1);
        }
    }
	cout << ans;
	return 0;
}