#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define ld long double
#define w while
#define con continue
#define br break
#define elif else if
#define INF 1e18
#define inf 1e9
#define EPS 1e-8
#define eps 1e-4
#define int signed
#define datahash pair <pair <vector <ll>, vector <ll>>, vector <ll>>

const ll p1 = 359657;
const ll m1 = 1000000007;
const ll p2 = 307;
const ll m2 = 1000000009;

datahash phash(const string &s, ll p, ll m) {
    vector <ll> ps(s.size() + 1);
    vector <ll> hs(s.size() + 1);
    vector <ll> rhs(s.size() + 1);
    ps[0] = 1;
    hs[0] = 0;
    for (ll i = 0; i < s.size(); i++) {
        ps[i + 1] = (ps[i] * p) % m;
        hs[i + 1] = (hs[i] * p + s[i]) % m;
    }
    rhs[s.size()] = 0;
    for (ll i = s.size() - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * p + s[i]) % m;
    }
    return { {hs, rhs}, ps};
}

ll gethash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.first[j + 1] - hasher.first.first[i] * hasher.second[j - i + 1] + m * m) % m;
}
ll getrhash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.second[i] - hasher.first.second[j + 1] * hasher.second[j - i + 1] + m * m) % m;
}

bool poly(const datahash &hasher, ll a, ll b, ll p, ll m) {
    if ((b - a + 1) % 2) {
        ll t1, t2;
        if ((t1 = gethash(hasher, a, (a + b) / 2, p, m)) == (t2 = getrhash(hasher, (a + b) / 2, b, p , m)))
            return 1;
        else
            return 0;
    } else {
        if (gethash(hasher, a, (a + b) / 2, p, m) == getrhash(hasher, (a + b) / 2 + 1, b, p , m))
            return 1;
        else
            return 0;
    }
}

signed main() {
    ll n, su = 0;
    cin >> n;
    string inn;
    cin >> inn;
    datahash hasha1 = phash(inn, p1, m1), hasha2 = phash(inn, p2, m2);
    for (ll i = 0; i < n - 1; i++) {
        for (ll l = 1; l <= min(i + 1, n - i - 1); l++) {
           if (poly(hasha1, i - l + 1, i, p1, m1) && poly(hasha1, i + 1, i + l, p1, m1))
               su++;
        }
    }
    cout << su;
    return 0;
}