#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>

using namespace std;

int main() {
    int n;
    string s;
    cin >> n;
    cin >> s;
    int dp[n][n + 1];
    for (int i = 0; i < n; i++) {
        dp[i][0] = 1;
        dp[i][1] = 1;
    }

    for (int j = 2; j < n + 1; j++) {
        for (int i = 0; i < n - j + 1; i++) {
            dp[i][j] = 0;
            dp[i][j] = (s[i] == s[i + j - 1]) && dp[i + 1][j - 2];
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int d = 2; d < n - i + 1; d += 2) {
            if (dp[i][d/2] && dp[i + d/2][d/2]) ans++;
        }
    }
    cout << ans;

}