#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define vec vector
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(s) sort(all(s))

ostream& operator <<(ostream& out, vec<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vec<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

int main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    unordered_map<int, unordered_map<int, int>> starts;
    unordered_map<int, unordered_map<int, int>> ends;
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n / 2 + 1; ++j) {
            ends[i][j] = 0;
            starts[i + 1][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        int j = 0;
        while (i - j > -1 && i + j < n) {
            if (s[i - j] == s[i + j]) {
                starts[i - j][2 * j + 1] = 1;
                ends[i + j][2 * j + 1] = 1;
                ++j;
            }
            else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int j = 0;
        while (i - j > -1 && i + j + 1 < n) {
            if (s[i - j] == s[i + j + 1]) {
                starts[i - j][2 * j + 2] += 1;
                ends[i + j + 1][2 * j + 2] += 1;
                ++j;
            }
            else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n / 2 + 1; ++j) {
            ans += ends[i][j] * starts[i + 1][j];
        }
    }
    cout << ans;
}
