#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, INF = 1e9;

mt19937 rnd(time(0));

int n, pc[N], pn[N];
int64_t ans;
string s;


inline void read(){
    cin >> n >> s;
    s = "#" + s;
    s.push_back('$');
}

inline void stupid_calc_mid_pals(){
    for(int i = 1; i <= n; ++i){
        while(s[i+pn[i]]==s[i-pn[i]]) ++pn[i];
        while(s[i+pc[i]+1]==s[i-pc[i]]) ++pc[i];
    }
}

bool is_palindrom(int l, int r){
    int len = r-l+1, mid = (l+r)/2;
    if(len%2) return pn[mid]>r-mid;
    return pc[mid]>=r-mid;
}

bool is_double_pal(int l, int r){
    int len = r-l+1, mid = (l+r)/2;
    if(len%2) return false;
    return is_palindrom(l,mid)&is_palindrom(mid+1,r);
    }
inline void solve_square(){
    stupid_calc_mid_pals();
    for(int i = 1; i <= n; ++i){
        for(int j = i; j <= n; ++j){
            ans+=is_double_pal(i,j);
        }
    }
}

inline void print(){
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    solve_square();
    print();

    return 0;
}
