#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
typedef pair<vector<ull>, vector<ull> > pvv;
ull q = 157;
ull mod = 1e9 + 7;
vector <ull> qp1, qp2;
pvv calc_hash(string& s) {
    s = '-' + s;
    if (s.size() > qp1.size()) {
        qp1.assign(s.size(), 1);
        qp2.assign(s.size(), 1);
    }
    vector<ull>h1(s.size(), 0), h2(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        h1[i] = h1[i - 1] * q + s[i] - 'a';
        h2[i] = ((h2[i - 1] * q) % mod + s[i] - 'a') % mod;
        qp1[i] = qp1[i - 1] * q;
        qp2[i] = (qp2[i - 1] * q) % mod;
    }
    return { h1, h2 };
}
pair<ull, ull> get_hash(int l, int r, vector<ull>& h1, vector<ull>& h2) {
    ull ha = h1[r] - h1[l - 1] * qp1[r - l + 1];
    ull hb = (h2[r] + mod - (h2[l - 1] * qp2[r - l + 1]) % mod) % mod;
    return { ha, hb };
}
bool palindrom(int l, int r, pvv& h, pvv& rh) {
    auto h1 = get_hash(l, r, h.first, h.second);
    auto h2 = get_hash(h.first.size() - r, h.first.size() - l, rh.first, rh.second);
    return h1 == h2;
}
int main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int n; cin >> n;
    string s;
    cin >> s;
    string rs = s;
    reverse(all(rs));
    auto h = calc_hash(s), rh = calc_hash(rs);
    int cnt = 0;
    vector<int> mxp(s.size(), 1);
    vector<set<int> >mxl(s.size(), set<int>()), mxr(s.size(), set<int>());
    for (int i = 1; i < s.size(); ++i) {
        int l = 0, r = s.size() - i, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (i + mid < h.second.size() && i - mid + 1>0 && palindrom(i - mid + 1, i + mid, h, rh))l = mid;
            else r = mid;
        }
        mxp[i] = l;
        if (l== 0)continue;
        cnt += mxp[i];
        mxr[i - l + 1].insert(mxp[i] * 2);
        mxl[i + l].insert(2 * mxp[i]);
    }
    for (int i = 1; i < s.size(); ++i) {
        int l = 1, r = s.size(), mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (i + mid - 1 < s.size() && i - mid + 1 > 0 && palindrom(i - mid + 1, i + mid - 1, h, rh)) {
                l = mid;
            }
            else r = mid;
        }
        /*cout << "in " << i << " mxpal: " << l << "\n";
        if(i-l>0 && i+l<s.size())
        cout << palindrom(i - l, i + l, h, rh) << "\n";*/
        mxl[i].insert(1), mxr[i].insert(1);
        mxl[i + l - 1].insert(2 * l - 1);
        mxr[i - l + 1].insert(2 * l - 1);
    }
    for (int i = 1; i < s.size() - 1; ++i) {
        if (s[i] == s[i + 1])continue;
        //cout << "look at " << s[i] << " and " << s[i + 1] << "\n";
        for (int ln : mxl[i]) {
            if (ln == 3) {
               // cout << "have " << ln << " from " << s[i] << "\n";
            }
            if (mxr[i + 1].count(ln)) {
                ++cnt;
                //cout << "from " << s[i] << " by " << ln << " in left and from " << s[i + 1] << " by " << ln << " right\n";
            }
        }
    }
    cout << cnt;
    return 0;
}
/*
abacac


*/