#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

#define int long long

using namespace std;

struct Test {
    int data;
    bool is_ans_unique = false;
    int expected_ans = -1;

    Test(int d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = true;

int n;
string s;

int solve() {
    return 0;
}

vector<int> forward_hash, backward_hash;            //[l, r); second = just on the reversed string
int p = 43;
vector<int> p_powers;
int mod = 1500000001;

int cut_hash_f(int l, int r) {
    return ((forward_hash[r] - forward_hash[l] * p_powers[r - l]) % mod + mod) % mod;
}

int cut_hash_b(int l, int r) {
    return ((backward_hash[r] - backward_hash[l] * p_powers[r - l]) % mod + mod) % mod;
}

bool is_pal(int l, int r) {     //[l:r)
    for (int i = 0; i < (l + r) / 2 - l; ++i) {
        if (s[i + l] != s[r - 1 - i]) return false;
    }
    return true;
}

bool is_pal_2(int l, int r) {
//    cerr << cut_hash_f(l, r) << ' ' << cut_hash_b(n - r, n - l) << '\n';
    return cut_hash_f(l, r) == cut_hash_b(n - r, n - l);
}

void calc_hash() {
    forward_hash.resize(n + 1);
    backward_hash.resize(n + 1);
    p_powers.resize(n + 1);
    p_powers[0] = 1;
    for (int i = 1; i <= n; ++i) {
        p_powers[i] = (p_powers[i - 1] * p) % mod;
        forward_hash[i] = (forward_hash[i - 1] * p + (s[i - 1] - 'a' + 1)) % mod;
    }
    for (int i = 1; i <= n; ++i) {
        backward_hash[i] = (backward_hash[i - 1] * p + (s[n - i] - 'a' + 1)) % mod;
    }
}

int stupid() {
    calc_hash();
    int cnt = 0;
    for (int l = 0; l < n; ++l) {
        for (int len = 2; len < n - l + 1; len += 2) {
            if (is_pal_2(l, l + len / 2) && is_pal_2(l + len / 2, l + len)) {
                cnt++;
            }
        }
    }
    return cnt;
}

void gen_test() {

}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> s;
}

bool check() {
    return false;
}

vector<Test> pretests = {};

bool check_pretests() {
    return true;
}

void precalc() {

}

int32_t main() {
    precalc();
    if (!IS_TESTING) {
        check_pretests();
    } else {
        read();
        cout << stupid() << '\n';
    }

}

//8
//abcbabcb