#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 5005;
int pal[N][2];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	int n;
	cin >> n;
	string s;
	cin >> s;
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i + j >= n || i - j < 0) break;
			if (s[i + j] == s[i - j]) pal[i][0] = j;
			else break;
		}
		for (int j = 0; j < n; ++j) {
			if (i + j >= n || i - j - 1 < 0) break;
			if (s[i + j] == s[i - j - 1]) pal[i][1] = j + 1;
			else break;
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= pal[i][0]; ++j) {
			int len = j * 2 + 1;
			if (i + len < n && pal[i + len][0] >= j) {
				cnt++;
			}
		}
		for (int j = 1; j <= pal[i][1]; ++j) {
			int len = j * 2;
			if (i + len < n && pal[i + len][1] >= j) {
				cnt++;
			}
		}
	}
	cnt += (n - 1);
	cout << cnt << endl;
}