#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define int long long
using namespace std;
const int mod = 1e9 +33, P = 37, N = 5000;

int p[N + 4];
int h[N + 4];
int rh[N + 4];
string s, rs;
int n;

void calc(){
    h[0] = 0;
    rh[0] = 0;
    p[0] = 1;
    for (int i = 1; i < n + 1; ++i){
        p[i] = (p[i - 1] * P) % mod;
        h[i] = (h[i - 1] * P + (int)(s[i - 1] - 'a')) % mod;
        rh[i] = (rh[i - 1] * P + (int)(rs[i - 1] - 'a')) % mod;

    }
}

int hsh(int l, int r){
    if (l > r)
        return 0;
    return ((h[r + 1] - h[l] * p[r - l + 1]) % mod + mod) % mod;
}

int rhsh(int l, int r){
    r = n - 1 - r;
    l = n - 1 - l;
    swap(r, l);
    if (l > r)
        return 0;
    return ((rh[r + 1] - rh[l] * p[r - l + 1]) % mod + mod) % mod;
}



int32_t main()
{
    cin >> n;
    cin >> s;
    rs = s;
    reverse(rs.begin(), rs.end());
    calc();
    vector<int> mx(n);
    for (int i = 0; i< n; ++i){
        int l = 1;
        int r = min(n - i, i + 1);
        if (hsh(i, i + r - 1) == rhsh(i - r + 1, i)){
            mx[i]  =r;
            continue;
        }
        while(r - l >1){
            int m = (l + r) / 2;
            if (hsh(i, i + m - 1) == rhsh(i - m + 1, i))
                l = m;
            else
                r = m;
        }
        mx[i] = l;
    }
    vector<int> mx2(n - 1);
    for (int i = 0; i < n - 1; ++i){
        int l = 0;
        int r = min(i + 1, n - i - 1);
        if (hsh(i + 1, i + r) == rhsh(i - r + 1, i)){
            mx2[i] = r;
            continue;
        }
        while(r - l >1){
            int m = (l + r) / 2;
            if (hsh(i + 1, i + m) == rhsh(i - m + 1, i))
                l = m;
            else
                r = m;
        }
        mx2[i] = l;
    }
//    for (int i = 0; i < n; ++i) cout << mx[i] << " "; cout << "\n";
//    for (int i = 0; i < n - 1; ++i) cout << mx2[i] << " "; cout << "\n";

    int res = 0;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j){
            if ((j - i)&1){
                int l = (j - i + 1) / 2;
                if (mx[i] >= l && mx[j] >= l)
                    res++;
            }
        }
     for (int i  = 0; i < n - 1; ++i)
        for (int j = i + 2; j < n - 1; ++j){
            if ((j - i) % 2 == 0){
                int l = (j - i) / 2;
                if (mx2[i] >= l && mx2[j] >= l)
                    res++;
            }

        }
    cout << res;
}

