#include<bits/stdc++.h>
using namespace std;
const int base=41;
const long long mod=/*1000000000000037*/1e9+9;
char take_inp()
{
    char c;
    scanf("%c",&c);
    while('a'>c||c>'z')scanf("%c",&c);
    return c;
}

const int nmax=1e6+42;
int n,inp[nmax];

long long hsh_front[nmax],hsh_back[nmax];
long long mem_pw[nmax];

long long calc_front(int l,int r)
{
    long long ret=(hsh_front[r]-hsh_front[l-1]*mem_pw[r-l+1])%mod;
    ret=(ret+mod)%mod;
    //cout<<"calc_front "<<l<<" "<<r<<" -> "<<ret<<endl;
    return ret;
}
long long calc_back(int l,int r)
{
    long long ret=(hsh_back[l]-hsh_back[r+1]*mem_pw[r-l+1])%mod;
    ret=(ret+mod)%mod;
    //cout<<"calc_back "<<l<<" "<<r<<" -> "<<ret<<endl;
    return ret;
}
bool is_pali(int l,int r)
{
    int mid=(l+r)/2,SZ=(r-l+1);
    if(SZ%2==0)return calc_front(l,l+SZ/2-1)==calc_back(l+SZ/2,r);
    return calc_front(l,l+SZ/2)==calc_back(l+SZ/2,r);
}

int longest[nmax];


struct query
{
    int l,r,parity;
    int upper;
};
query make_query(int l,int r,int parity,int upper)
{
    query ret;
    ret.l=l;
    ret.r=r;
    ret.parity=parity;
    ret.upper=upper;
    return ret;
}
vector< query > all;

int fenwick[2][nmax];
void update(int pos,int parity)
{
    while(pos<=n)
    {
        fenwick[parity][pos]++;
        pos=pos+(pos&(-pos));
    }
}
int quer(int pos,int parity)
{
    int ret=0;
    while(pos)
    {
        ret=ret+fenwick[parity][pos];
        pos=pos-(pos&(-pos));
    }
    return ret;
}
int sum(int l,int r,int parity)
{
    return quer(r,parity)-quer(l-1,parity);
}

bool cmp(query a,query b)
{
    return a.upper<b.upper;
}
pair<int/*value*/,int/*position*/> to_add[nmax];
long long calc_all()
{
    memset(fenwick,0,sizeof(fenwick));
    for(int i=1;i<=n;i++)
        to_add[i]={i-2*longest[i],i};
    sort(to_add+1,to_add+n+1);
    sort(all.begin(),all.end(),cmp);
    long long ret=0;

    int pointer_to_add=1,pointer_all=0;
    while(pointer_all<all.size())
    {
        if(pointer_to_add<=n&&to_add[pointer_to_add].first<=all[pointer_all].upper)
        {
            update(to_add[pointer_to_add].second,to_add[pointer_to_add].second%2);
            pointer_to_add++;
            continue;
        }

        ret=ret+sum(all[pointer_all].l,all[pointer_all].r,all[pointer_all].parity);
        pointer_all++;
    }
    /*
    for(auto q:all)
    {
        //cout<<"calc_all "<<q.l<<" "<<q.r<<" "<<q.parity<<" "<<q.upper<<endl;
        for(int i=q.l;i<=q.r;i++)
            if(i%2==q.parity)
            {
                if(i-2*longest[i]<=q.upper)ret++;
            }
    }
    */

    return ret;
}

long long cnt_odd()
{
    /*
    long long ret=0;
    for(int l=1;l<=n;l++)
        for(int r=l;r<=n;r++)
            if(l%2!=r%2)
            {
                int av=(l+r)/2;
                if(longest[l]+l>=av&&r-longest[r]<=av+1)ret++;
                //if(longest[])
            }
    return ret;
    */
    all={};
    for(int l=1;l<=n;l++)
    {
        int LHS=l+1,RHS=l+2*longest[l]+1;
        RHS=min(RHS,n);
        if(LHS>RHS)continue;

        all.push_back(make_query(LHS,RHS,1-l%2,l+1));
    }
    return calc_all();
}
long long odd()
{
    for(int i=1;i<=n;i++)
    {//[i-ok,i+ok] is palindrome
        int ok=0,not_ok=n+1;
        while(not_ok-ok>1)
        {
            int av=(ok+not_ok)/2;

            int l=i-av,r=i+av;
            if(1<=l&&l<=n&&1<=r&&r<=n&&is_pali(l,r))ok=av;
            else not_ok=av;
        }
        longest[i]=ok;
    }
    /*
    cout<<"odd: "<<endl;
    for(int i=1;i<=n;i++)cout<<i<<" -> "<<longest[i]<<endl;
    cout<<cnt_odd()<<endl;
    */
    return cnt_odd();
}


long long cnt_even()
{
    /*
    long long ret=0;
    for(int l=1;l<=n;l++)
        for(int r=l+1;r<=n;r++)
            if(l%2==r%2)
            {
                int av=(l+r)/2;
                if(longest[l]+l>=av&&r-longest[r]<=av)ret++;
                //if(longest[])
            }
    return ret;
    */
    all={};
    for(int l=1;l<=n;l++)
    {
        int LHS=l+2,RHS=2*longest[l]+l;
        RHS=min(RHS,n);
        if(LHS>RHS)continue;

        all.push_back(make_query(LHS,RHS,l%2,l));
    }

    return calc_all();
}
long long even()
{
    longest[n]=0;
    for(int i=1;i<n;i++)
    {   //[i-ok+1,i+ok] is palindrome
        int ok=0,not_ok=n+1;
        while(not_ok-ok>1)
        {
            int av=(ok+not_ok)/2;

            int l=i-av+1,r=i+av;
            if(1<=l&&l<=n&&1<=r&&r<=n&&is_pali(l,r))ok=av;
            else not_ok=av;
        }
        longest[i]=ok;
    }
    /*
    cout<<"even: "<<endl;
    for(int i=1;i<=n;i++)cout<<i<<" -> "<<longest[i]<<endl;
    cout<<cnt_even()<<endl;
    */

    return cnt_even();
}
int main()
{
    scanf("%i",&n);

    mem_pw[0]=1;
    for(int i=1;i<=n;i++)
        mem_pw[i]=(mem_pw[i-1]*base)%mod;

    for(int i=1;i<=n;i++)
        inp[i]=take_inp();

    for(int i=1;i<=n;i++)
        hsh_front[i]=(hsh_front[i-1]*base+inp[i]-'a'+1)%mod;
    for(int i=n;i>=1;i--)
        hsh_back[i]=(hsh_back[i+1]*base+inp[i]-'a'+1)%mod;

    printf("%lld\n",odd()+even());
    return 0;
}
/*
6
abacac

5
aaaaa
*/
