#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(5e5) + 3;
const ll mod = ll(1e9) + 7;
const ll p = 31;

ll n;
string s = "";

ll degs[maxn], heh[maxn], revheh[maxn];

ll get_hash(ll l, ll r) {
    ll res = (heh[r] - heh[l - 1] * degs[r - l + 1]) % mod;
    if(res < 0) {
        res += mod;
    }
    return res;
}

ll get_rev_hash(ll l, ll r) {
    ll res = (revheh[l - 1] - revheh[r] * degs[r - l + 1]) % mod;
    if(res < 0) {
        res += mod;
    }
    return res;
}

void solve() {
    cin >> n;
    ll startn = n;
    string tmp;
    cin >> tmp;
    for(ll i = 0; i < n; i++) {
        s += tmp[i];
        if(i < n - 1) s += "#";
    }
    n = 2 * n - 1;
    for(ll i = 0; i < n; i++) {
        heh[i + 1] = (heh[i] * p + (s[i] - 'a' + 1)) % mod;
    }
    for(ll i = n - 1; i >= 0; i--) {
        revheh[i] = (revheh[i + 1] * p + (s[i] - 'a' + 1)) % mod;
    }
    degs[0] = 1;
    for(ll i = 0; i < n; i++) {
        degs[i + 1] = (degs[i] * p) % mod;
    }

    vector<ll> lens;
    for(ll i = 0; i < n; i++) {
        ll l = 0, r = min(i + 1, n - i);
        while(r - l > 1) {
            ll mid = (l + r) / 2;
            if(get_hash(i + 1, i + mid + 1) == get_rev_hash(i - mid + 1, i + 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        lens.pb(l);
        //cout << lens.back() << " ";
    }
    //cout << endl;

    ll ans = startn - 1;
    for(ll i = 0; i < n; i++) {
        for(ll j = i + 4; j < n; j++) {
            if(i % 2 != j % 2) continue;
            ll dif = (j - i) / 2;
            if(i % 2 == 0 && dif % 2 == 0) continue;
            if(i % 2 == 1 && dif % 2 == 1) continue;
            if(lens[i] >= dif - 1 && lens[j] >= dif - 1) {
                ans++;
                //cout << i << " " << j << endl;
            }
        }
    }

    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
