#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
//#include <map>
#include <vector>
//#include <unordered_set>
//#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
//#include <queue>
//#include <utility>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

size_t const ALLOC_MEM_CNT = 216 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_CNT];
size_t ALLOC_POS = ALLOC_MEM_CNT;

using ll = long long;
#define all(c) c.begin(),c.end()

// using xll = __int128;

void _tmain([[maybe_unused]] int test_id) {
    int n;
    cin >> n;
    string s;
    cin >> s;
    //vector<int> max_r(n, -1);
    //vector<int> max_l(n,  );
    vector<vector<bool>> is_pal(n, vector<bool>(n + 1));
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            int len = (j - i + 1) / 2;
            string s1 = s.substr(i, len);
            string s2 = s.substr(j - len, len);
            reverse(all(s2));
            if (s1 == s2) {
                is_pal[i][j] = true;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int k = 1; k < n; ++k) {
            if (i+2*k> n) {break;}
            if (is_pal[i][i+k] && is_pal[i+k][i+2*k]) {
                ++ans;
                $ printf("%s_%s\n", s.substr(i, k).c_str(), s.substr(i+k, k).c_str());
            }
        }
    }
    cout << ans << "\n";
}