#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

vector<int> hs, hsr;
vector<ll> base;
const ll X = 28;	
const int MOD = 1e9 + 7;

int getHash (int l, int r) {
	return ((hs[r] - hs[l] * base[r - l]) % MOD + MOD) % MOD;
}

int getHashR (int l, int r) {
	std::swap(l, r);
	l = hs.size() - 1 - l;
	r = hs.size() - 1 - r;
	return ((hsr[r] - hsr[l] * base[r - l]) % MOD + MOD) % MOD;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int n;
	cin >> n;
	string s;
	cin >> s;

	hs.resize(n + 1);
	hsr.resize(n + 1);
	base.resize(n + 1);
	base[0] = 1;
	for (int i = 0; i < n; ++i) {
		base[i + 1] = base[i] * X % MOD;
	}

	for (int i = 0; i < n; ++i) {
		hs[i + 1] = (hs[i] * X + s[i] - 'a' + 1) % MOD;
	}

	std::reverse(s.begin(), s.end());

	for (int i = 0; i < n; ++i) {
		hsr[i + 1] = (hsr[i] * X + s[i] - 'a' + 1) % MOD;
	}

	vector<int> max(n);
	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		//for (; cnt <= i && cnt + i < n && s[i - cnt] == s[i + cnt]; ++cnt) {};
		int l = 0, r = std::min(i, n - i - 1) + 1;
		while (r - l != 1) {
			int m = (r + l) / 2;
			if (getHash(i - m, i + 1) == getHashR(i, i + m + 1))
				l = m;
			else
				r = m;
			
		}
		max[i] = r;
	}

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < max[i] && i + 2 * j + 1 < n; ++j)
			if (max[i + 2 * j + 1] > j)
				++ans;
	}
	
	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		//for (; cnt <= i + 1 && cnt + i < n && s[i - cnt + 1] == s[i + cnt]; ++cnt) {};
		int l = 0, r = std::min(i + 1, n - i - 1) + 1;
		while (r - l != 1) {
			int m = (r + l) / 2;
			if (getHash(i - m + 1, i + 1) == getHashR(i + 1, i + m + 1))
				l = m;
			else
				r = m;
			
		}
		max[i] = l;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < max[i] && i + 2 * j + 2 < n; ++j)
			if (max[i + 2 * j + 2] > j)
				++ans;
	}

	cout << ans;

	return 0;
}