#include<bits/stdc++.h>                      

using namespace std;

const int N = 5002;

struct Fenw {
	int f[N];

	Fenw() {
		fill(f, f + N, 0);
	}

	void add(int pos) {
		for (int i = pos; i < N; i = (i | (i + 1))) {
			f[i]++;
		}
	}

	int sum(int r) {
		int ans = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
			ans += f[i];	
		}
		return ans;
	}

	int sum(int l, int r) {
		if (l >= r) return 0;
		return sum(r - 1) - sum(l - 1);
	}
};

int dp[N][N];
        
string s;

int calc(int l, int len) {
	if (len == 0) return 1;
	if (len == 1) return 1;
	if (dp[l][len] == -1) {
		if (s[l] == s[l + len - 1]) {
			dp[l][len] = calc(l + 1, len - 2);
		} else {
			dp[l][len] = 0;
		}
	}
	return dp[l][len];
}
       
void init(int n) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			dp[i][j] = -1;
		}
	}                   
}


int pal(int l, int r) {
	if (l < 0 || r > (int)s.size()) return 0;
	return calc(l, r - l);
}

int solve_f(int n) {
	vector<int> mid(n, -1);
	for (int i = 0; i < n; i++) {
		for (int lp = n / 2 + 1; lp >= 0; lp--) {
			if (pal(i - lp, i + lp + 1)) {
				mid[i] = lp;
				break;
			}
		}   
	}
	int ans = 0;
	vector<int> ind(n);
	iota(ind.begin(), ind.end(), 0);
	sort(ind.rbegin(), ind.rend(), [&](int i, int j) {
		return mid[i] < mid[j];
	});
	Fenw c[2];
	for (auto t : ind) {
		c[t % 2].add(t);
		{
			int st = t - 2 * mid[t] - 1;
			st = max(st, (int)0);
			if (st % 2 == t % 2) st++;
			int en = t; 
			ans += c[st % 2].sum(st, en);
		}
		{
			int st = t + 1;
			if (st % 2 == t % 2) st++;
			int en = min(n, t + 2 * mid[t] + 2);
			ans += c[st % 2].sum(st, en);
		}
	}
	return ans;
}              

int solve_s(int n) {
	int ans = 0;
	vector<int> mid(n - 1, -1);
	for (int i = 0; i + 1 < n; i++) {
		for (int lp = n / 2 + 1; lp >= 0; lp--) {
			if (pal(i - lp + 1, i + lp + 1)) {
				mid[i] = lp;
				break;
			}
		}   
	}
	vector<int> ind(n - 1);
	iota(ind.begin(), ind.end(), 0);
	sort(ind.rbegin(), ind.rend(), [&](int i, int j) {
		return mid[i] < mid[j];
	});
	vector<int> tk(n - 1, 0);
	Fenw c[2];
	for (auto t : ind) {
		if (mid[t] == 0) break;
		c[t % 2].add(t);
		{
			int st = max(t % 2, t - 2 * mid[t]);
			if (st % 2 != t % 2) st++;
			int en = t;
			ans += c[st % 2].sum(st, en); 
		}
		{
			int st = t + 1;
			if (st % 2 != t % 2) st++;
			int en = min(n - 1, t + 2 * mid[t] + 1);
			ans += c[st % 2].sum(st, en);
		}
	}
	return ans;
}
                     
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
        
	int n;
	cin >> n;
	cin >> s;
	init(n);
	cout << solve_f(n) + solve_s(n) << endl;
}                         