#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

typedef long long ll;
const int N = 5e5 + 10;
const int Nn = N;
const ll mod = 1e9 + 13;

const ll pp = 31;
int n;
char a[N];
ll f[N], s[N], p[N];


int getf(int l, int r)
{
    return (f[r] - f[l - 1] * p[(r - l + 1)] % mod + mod) % mod;
}

int getsec(int l, int r)
{
    return (s[l] - s[r + 1] * p[r - l + 1] % mod + mod) % mod;
}
ll ans = 0;
int d[N];


struct node
{
    int x;
    node* L;
    node* R;
    node()
    {
        L = nullptr;
        R = nullptr;
    }
};

void build(node* v, int l, int r)
{
    if (v == nullptr)
    {
        cout << 0;
        exit(0);
    }
    v->x = 0;
    if (l == r - 1)
    {
        return;
    }
    int m = (l + r) / 2;
    if (v->L == nullptr) v->L = new node();
    if (v->R == nullptr) v->R = new node();
    build(v->L, l, m);
    build(v->R, m, r);
}
node* upd(node* v, int p, int l, int r)
{
    if (v == nullptr)
    {
        cout << 0;
        exit(0);
    }
    if (l + 1 == r)
    {
        node* b = new node();
        b->x = v->x + 1;
        return b;
    }
    int m = (l + r) / 2;
    node* b = new node();
    b->L = v->L;
    b->R = v->R;
    b->x = v->x;
    ++b->x;
    if (p >= m) b->R = upd(v->R, p, m, r);
    else b->L = upd(v->L, p, l, m);
    return b;
}

ll get(node* v, int i, int l, int r)
{
    if (v == nullptr)
    {
        cout << 0;
        exit(0);
    }
    if (l >= i) return v->x;
    else if (r <= i) return 0;
    int m = (l + r) / 2;
    return get(v->L, i, l, m) + get(v->R, i, m, r);
}
node* t[N];

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];

    p[0] = 1;
    for (int i = 1; i <= n; ++i) p[i] = p[i - 1] * pp % mod;
    for (int i = 1; i <= n; ++i)
    {
        f[i] = (f[i - 1] * pp % mod + a[i] - 'a') % mod;
    }

    for (int i = n; i >= 1; --i)
    {
        s[i] = (s[i + 1] * pp % mod + a[i] - 'a') % mod;
    }

    for (int i = 1; i <= n; ++i)
    {
        int l = 0, r = min(i - 1, n - i) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (getf(i - m, i - 1) == getsec(i + 1, i + m)) l = m;
            else r = m;
        }
        d[i] = l;
    }

    t[0] = new node();
    t[1] = new node();
    build(t[0], 1, Nn);
    build(t[1], 1, Nn);
    if (i + 2 * d[i] + 1 >= Nn)
        {
            cout << 0;
            exit(0);
        }
    t[1] = upd(t[1], 1 + 2 * d[1] + 1, 1, Nn);

    for (int i = 2; i <= n; ++i)
    {
        int st = i - 2 * d[i] - 1;
        if (st <= 0)
        {
            if (st % 2 == 0) st = 2;
            else st = 1;
        }
        if (st <= 2)
        {
            ans += get(t[i - 1], i, 1, Nn);
        } else
        {
            ans += get(t[i - 1], i, 1, Nn) - get(t[st - 2], i, 1, Nn);
        }
        if (i + 2 * d[i] + 1 >= Nn)
        {
            cout << 0;
            exit(0);
        }
        t[i] = upd(t[i - 2], i + 2 * d[i] + 1, 1, Nn);
    }

    for (int i = 1; i <= n; ++i)
    {
        int l = 0, r = min(i, n - i) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (getf(i - m + 1, i) == getsec(i + 1, i + m)) l = m;
            else r = m;
        }
        d[i] = l;
    }
    build(t[0], 1, Nn);
    build(t[1], 1, Nn);
    if (i + 2 * d[i] >= Nn)
        {
            cout << 0;
            exit(0);
        }
    t[1] = upd(t[1], 1 + 2 * d[1], 1, Nn);
    for (int i = 2; i <= n; ++i)
    {
        int st = i - 2 * d[i];
        if (st <= 0)
        {
            if (st % 2 == 0) st = 2;
            else st = 1;
        }
        if (st <= 2)
        {
            ans += get(t[i - 2], i, 1, Nn);
        } else
        {
            ans += get(t[i - 2], i, 1, Nn) - get(t[st - 2], i, 1, Nn);
        }
        /*for (int j = st; j < i; j += 2)
        {
            if (j + 2 * d[j] >= i) ++ans;//, cout << i << ' ' << j << "E1" << endl;
        }*/
        if (i + 2 * d[i] >= Nn)
        {
            cout << 0;
            exit(0);
        }
        t[i] = upd(t[i - 2], i + 2 * d[i], 1, Nn);
    }
    cout << ans;

    return 0;
}

