#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;
#define int long long
#define x first
#define y second

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

const int mod = (1e9) + 9, p = 27;
const int modsq = mod * mod;
int pref[500009];
int revp[500009];
int powp[500009];
int n;
string s;

void build() {
    powp[0] = 1;
    for (int i = 0; i < n; i ++) {
        powp[i + 1] = (powp[i] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        pref[i + 1] = (pref[i] * p + (s[i] - 'a')) % mod;
    }

    for (int i = 0; i < n; i ++) {
        revp[i + 1] = (revp[i] * p + (s[n - i - 1] - 'a')) % mod;
    }
}

int getlr(int l, int r) {
    return (pref[r + 1] - pref[l] * powp[r - l + 1] + modsq) % mod;
}

int getrev(int l, int r) {
    l = n - l - 1;
    r = n - r - 1;
    swap(l, r);

    return (revp[r + 1] - revp[l] * powp[r - l + 1] + modsq) % mod;
}

struct Node {
    signed sum;
    Node *l, *r;
    Node() {
        sum = 0;
        l = nullptr;
        r = nullptr;
    }

    Node(signed _sum, Node *_l, Node *_r) {
        sum = _sum;
         l = _l;
         r = _r;
    }
};

Node *tree[250009];
inline Node *build(signed tl, signed tr) {
    Node *v = new Node();
    if (tr - tl == 1) {
        return v;
    }

    signed tm = (tl + tr) >> 1;
    v->l = build(tl, tm);
    v->r = build(tm, tr);

    return v;
}

inline Node *upd(Node *v, signed tl, signed tr, signed i, signed x) {
    if (tr - tl == 1) {
        Node *u = new Node(v->sum + x, nullptr, nullptr);
        return u;
    }

    signed tm = (tl + tr) >> 1;
    Node *u = new Node(v->sum, v->l, v->r);
    if (i < tm) {
        u->l = upd(v->l, tl, tm, i, x);
        u->sum += x;
    }

    else {
        u->r = upd(v->r, tm, tr, i, x);
        u->sum += x;
    }

    return u;
}

inline int getsum(Node *v, signed tl, signed tr, signed l, signed r) {
    if (tl >= r || l >= tr) return 0;
    if (tl >= l && tr <= r) return v->sum;
    signed tm = (tl + tr) >> 1;
    return getsum(v->l, tl, tm, l, r) + getsum(v->r, tm, tr, l, r);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    cin >> s;
    build();

    vector<int> pal(n);
    vector<int> pal2(n);
    int answ = 0;
    int MAXS = 0;
    for (int i = 0; i < n; i ++) {
        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getrev(i - m + 1, i) == getlr(i, i + m - 1)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        pal[i] = l;
        MAXS = max(MAXS, l);
    }

    MAXS = n + n / 2 + 2;

    tree[0] = build(0, MAXS);
    int LAST = 0;
    for (int i = 1; i < n; i += 2) {
        tree[(i + 1) >> 1] = upd(tree[i >> 1], 0, MAXS, pal[i] - (i + 1) / 2 + n, 1);
        LAST = max(LAST, (i + 1) >> 1);
    }

    for (int i = 0; i < n; i += 2) {
        int cnt = getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) - getsum(tree[i >> 1], 0, MAXS, -i/2 + n, MAXS);
        //cout << i << ' ' << cnt << ' ' << pal[i] << ' ' << getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) << endl;
        answ += cnt;
    }


    tree[0] = build(0, MAXS);
    LAST = 0;
    for (int i = 2; i < n; i += 2) {
        tree[(i >> 1)] = upd(tree[(i >> 1) - 1], 0, MAXS, pal[i] - (i >> 1) + n, 1);
        LAST = max(LAST, (i >> 1));
    }

    for (int i = 1; i < n; i += 2) {
        int cnt = getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) - getsum(tree[i >> 1], 0, MAXS, -i/2 + n, MAXS);
        //cout << i << ' ' << cnt << ' ' << pal[i] << ' ' << getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) << endl;
        answ += cnt;
    }



    for (int i = 0; i < n - 1; i ++) {
        int l = 0, r = min(i + 1, n - i - 1) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            //cout << i << ' ' << m << ' ' << getrev(i - m + 1, i ) << ' ' << getlr(i + 1, i+ m) <<  endl;
            if (getrev(i - m + 1, i) == getlr(i + 1, i + m)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        //cout << l << endl;
        pal2[i] = l;
    }

    tree[0] = build(0, MAXS);
    LAST = 0;
    for (int i = 2; i < n - 1; i += 2) {
        tree[i >> 1] = upd(tree[(i >> 1) - 1], 0, MAXS, pal2[i] - (i >> 1) + n, 1);
        LAST = max(LAST, i >> 1);
    }

    for (int i = 0; i < n - 1; i += 2) {
        int cnt = getsum(tree[min(LAST, pal2[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) - getsum(tree[i >> 1], 0, MAXS, -i/2 + n, MAXS);
        //cout << i << ' ' << cnt << ' ' << pal[i] << ' ' << getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) << endl;
        answ += cnt;
    }


    tree[0] = build(0, MAXS);
    LAST = 0;
    for (int i = 1; i < n - 1; i += 2) {
        tree[(i + 1) >> 1] = upd(tree[(i >> 1)], 0, MAXS, pal2[i] - ((i + 1) >> 1) + n, 1);
        LAST = max(LAST, (i + 1) >> 1);
    }

    for (int i = 1; i < n - 1; i += 2) {
        int cnt = getsum(tree[min(LAST, pal2[i] + (i + 1) / 2)], 0, MAXS, -i/2 + n, MAXS) - getsum(tree[i >> 1], 0, MAXS, -i/2 + n, MAXS);
        //cout << i << ' ' << cnt << ' ' << pal[i] << ' ' << getsum(tree[min(LAST, pal[i] + i / 2)], 0, MAXS, -i/2 + n, MAXS) << endl;
        answ += cnt;
    }

    cout << answ;

    return 0;
}



