#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int long long
#define double long double
#define F first
#define S second
#define forn(i,n) for(int i=0;i<n;++i)

using namespace std;
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> SET;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
uniform_real_distribution<> rnd01(0,1);
const int N = 1e6+5;
const int INF  = 1e18+7;
const int MOD = 1e9+7;
const double EPS = 1e-9;

int n;
string s;
int p=31;
vector<int> p_pow;
vector<int> h,rh;
int MX = 5005;

int get1(int l, int r)
{
    int hh = h[r];
    if(l) hh-=h[l-1];
    if(hh<0) hh+=MOD;
    hh%=MOD;
    hh*=p_pow[MX-l];
    hh%=MOD;
    return hh;
}

int get2(int l, int r)
{
    int hh = rh[l];
    if(r!=n-1) hh-=rh[r+1];
    if(hh<0) hh+=MOD;
    hh%=MOD;
    hh*=p_pow[MX-(n-r-1)];
    hh%=MOD;
    return hh;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);
    p_pow.push_back(1); while(p_pow.size()<5500) p_pow.push_back((p_pow.back()*p)%MOD);
    cin>>n>>s;
    for(int i=0;i<n;i++){
        int hh = ((s[i]-'a'+1)*p_pow[i])%MOD;
        if(i) hh+=h.back();
        h.push_back(hh%MOD);
    }
    reverse(s.begin(),s.end());
    for(int i=0;i<n;i++){
        int hh = ((s[i]-'a'+1)*p_pow[i])%MOD;
        if(i) hh+=rh.back();
        rh.push_back(hh%MOD);
    }
    reverse(s.begin(),s.end());
    reverse(rh.begin(),rh.end());

//    for(int x : h) cout<<x<<" "; cout<<endl;
//    for(int x : rh) cout<<x<<" "; cout<<endl;
//
//    cout<<get1(0,0)<<endl;
//    cout<<get2(0,0)<<endl;
    int ans=0;
    for(int i=0;i<n;i++){
        for(int j=i+1;j<n;j++){
            int len=(j-i+1);
            if(len%2==0){
                int h1 = get1(i,i+len/2-1);
                int hh1 = get2(i,i+len/2-1);
                int h2 = get1(i+len/2,j);
                int hh2 = get2(i+len/2,j);
                if(h1==hh1 && h2==hh2) ans++;
            }
        }
    }
    cout<<ans<<endl;
}
