#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
int const maxn = 5e5 + 5;
int l[maxn], r[maxn];
vector < int > tree[2][(1 << 20)];

void build(int i, int l, int r) {
    tree[0][i] = {}, tree[1][i] = {};
    if (r - l == 1) return;
    int m = (r + l) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
}

void add(int i, int l, int r, int lq, int rq, int x) {
    if (lq >= rq) return;
    if (lq >= r || l >= rq) return;
    if (lq <= l && r <= rq) {
        tree[(l - lq) % 2][i].push_back(x);
        return;
    }
    int m = (r + l) / 2;
    add(2 * i + 1, l, m, lq, rq, x);
    add(2 * i + 2, m, r, lq, rq, x);
}

int get(int i, int l, int r, int lq, int x) {
    int cur = 0;
    for (auto key : tree[(lq - l) % 2][i]) if (key >= x) cur++;
    if (r - l == 1) return cur;
    int m = (r + l) / 2;
    if (lq < m) cur += get(2 * i + 1, l, m, lq, x);
    else cur += get(2 * i + 2, m, r, lq, x);
    return cur;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll ans = 0;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int j = i;
        while (j >= 0 && 2 * i - j < n && s[j] == s[2 * i - j]) --j;
        l[i] = j + 1, r[i] = 2 * i - j - 1;
    }
    for (int i = 0; i < n; ++i) {
        if (i % 2 == 1) add(0, 0, n, i + 1, min(2 * r[i] - i + 2, n), i);
        else add(0, 0, n, i + 1, min(2 * r[i] - i + 2, n), i);
    }
    for (int i = 1; i < n; ++i) {
        if (i % 2 == 0) {
            ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 1);
        }
        else {
            ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 1);
        }
    }
    build(0, 0, n);
    for (int i = 0; i < n - 1; ++i) {
        int j = i;
        while (j >= 0 && 2 * i - j + 1 < n && s[j] == s[2 * i - j + 1]) --j;
        l[i] = j + 1, r[i] = 2 * i - j;
        //cout << l[i] << " " << r[i] << endl;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) continue;
        add(0, 0, n, i + 2, min(n, 2 * r[i] - i + 1), i);
    }
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) continue;
        ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 2);
        //if (i == 3) cout << 2 * l[i] - i << endl;
    }
    cout << ans << '\n';
    return 0;
}
