#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define PB push_back
#define MP make_pair
#define MP3(a,b,c) MP(MP(a,b),c)
#define pii pair<int, int>
#define pi3 pair<pii, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define pli pair<ll, int>
#define pil pair<int, ll>
#define ft first
#define sd second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
using namespace std;
using namespace __gnu_pbds;
template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int N = 500100;
const int oo = 2e9;
const ll OO = 1e18;
const int PW = 233;
const int md = 998244353;
vector<pi3> qr;
int n, nm[N], sot[N], len[N], fen[2][N], po[N], hsh[N], shsh[N];
string s, t, p;
ll ans = 0;

int sum(int x, int y){
    x += y;

    if (x >= md)
        x -= md;

    return x;
}

int sub(int x, int y){
    x -= y;

    if (x < 0)
        x += md;

    return x;
}

int mult(int x, int y) { return (1ll * x * y) % md;}

bool ok(int l1, int r1, int l2, int r2){

    l1++; r1++;

    int h1 = sub(hsh[r1], hsh[l1 - 1]);
    int h2 = sub(shsh[l2], shsh[r2 + 1]);

    int p1 = l1 - 1;
    int p2 = n - 1 - r2;

    if (p1 < p2)
        h1 = mult(h1, po[p2 - p1]);
    else h2 = mult(h2, po[p1 - p2]);

    return (h1 == h2);
}

bool cmp(pi3 x, pi3 y){

    if (x.ft.sd == y.ft.sd)
        return x.ft.ft > y.ft.ft;
    else return x.ft.sd > y.ft.sd;

}

void upd(int tp, int ps){

    for (; ps < n; ps = (ps | (ps + 1)))
        fen[tp][ps]++;
}

int get(int tp, int ps){

    int res = 0;

    for (; ps >= 0; ps = (ps & (ps + 1)) - 1)
        res += fen[tp][ps];

    return res;
}

int main(){

//    ifdef

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif // _LOCAL

    cin >> n >> s;

    po[0] = 1;

    for (int i = 1; i <= n; i++)
        po[i] = mult(po[i - 1], PW);

    hsh[0] = 0;

    for (int i = 1; i <= n; i++)
        hsh[i] = sum(hsh[i - 1], mult(s[i - 1] - 'a' + 1, po[i - 1]));

    shsh[n] = 0;

    for (int i = n - 1; i >= 0; i--)
        shsh[i] = sum(shsh[i + 1], mult(s[i] - 'a' + 1, po[n - 1 - i]));

    qr.clear();

    for (int i = 0; i < n; i++){

        int l = 1, r = n;

        while (l < r){

            int md = (l + r + 1) >> 1;

            if (i - md + 1 < 0 || i + md - 1 >= n){
                r = md - 1;
                continue;
            }

            if (ok(i - md + 1, i, i, i + md - 1))
                l = md;
            else r = md - 1;
        }

        len[i] = l;

        nm[i] = i;

        qr.PB(MP3(i, len[i] - (i + 1) / 2, 0));

        if (i + 1 < n)
            qr.PB(MP3(i, 1 - (i + 2) / 2, 1));
    }

    sort(all(qr), cmp);

    for (int i = 0; i < n; i++)
        fen[0][i] = fen[1][i] = 0;

    for (pi3 cr : qr){

        if (cr.sd == 0){
            if (cr.ft.ft & 1)
                upd(1, cr.ft.ft);
            else upd(0, cr.ft.ft);
        } else {

            int lf = cr.ft.ft + 1, rt = min(n - 1, cr.ft.ft + len[cr.ft.ft] * 2);

            if (cr.ft.ft & 1)
                ans += get(0, rt) - get(0, lf - 1);
            else ans += get(1, rt) - get(1, lf - 1);
        }
    }

    //  

    qr.clear();

    for (int i = 0; i < n - 1; i++){

        if (s[i] != s[i + 1]) continue;

        int l = 1, r = n;

        while (l < r){

            int md = (l + r + 1) >> 1;

            if (i - md + 1 < 0 || i + md >= n){
                r = md - 1;
                continue;
            }

            if (ok(i - md + 1, i, i + 1, i + md))
                l = md;
            else r = md - 1;
        }

        len[i] = l;

        nm[i] = i;

        qr.PB(MP3(i, len[i] - (i + 1) / 2, 0));

        if (i + 1 < n)
            qr.PB(MP3(i, 1 - (i + 3) / 2, 1));
    }

    sort(all(qr), cmp);

    for (int i = 0; i < n; i++)
        fen[0][i] = fen[1][i] = 0;

    for (pi3 cr : qr){

        if (cr.sd == 0){
            if (cr.ft.ft & 1)
                upd(1, cr.ft.ft);
            else upd(0, cr.ft.ft);
        } else {

            int lf = cr.ft.ft + 2, rt = min(n - 1, cr.ft.ft + len[cr.ft.ft] * 2);

            if (cr.ft.ft % 2 == 0)
                ans += get(0, rt) - get(0, lf - 1);
            else ans += get(1, rt) - get(1, lf - 1);
        }
    }

    cout << ans;

    return 0;
}
