#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <tuple>
#include <set>
#include <map>
#include <iomanip>
#include <assert.h>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#pragma optimize(Ofast)
#define pii pair<ll, ll>
#define endl '\n'
#define ff first
#define ss second
#define pb push_back
#define optimize1 ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define all(x) (x).begin(),(x).end()
#define sz(x) ((ll)size((x)))
#define rall(x) ((x).rbegin(), (x.rend()))
typedef long long ll;
typedef long double ld;

using namespace std;
const ll MOD = 1e9 + 3, P = 31;
vector<ll> hash1, hash2, P1;
string s, rs;
int n;

void make_hash(string& s, vector<ll>& hash) {
    hash.pb(0);
    for (int i = 0; i < sz(s); ++i) {
        hash.pb((P * hash.back()) % MOD + (s[i] - 'a' + 1));
        hash.back() %= MOD;
    }
}

ll get_hash(int l, int r, vector<ll>& hash) {
    int st = r - l + 1;
    r++;
    return (hash[r] - (hash[l] * P1[st]) % MOD + MOD) % MOD;
}

bool equa(int l, int r) {
    int st = max(r, n - 1 - l);
    //cout << st << endl;
    ll tmp1 = (get_hash(l, r, hash1) * P1[max(st - r, 0)]) % MOD;
    ll tmp2 = (get_hash(n - 1 - r, n - 1 - l, hash2) * P1[max(st - (n - 1 - l), 0)]) % MOD;
    tmp1 = (get_hash(l, r, hash1)) % MOD;
    tmp2 = (get_hash(n - 1 - r, n - 1 - l, hash2)) % MOD;
    //cout << tmp1 << ' ' << tmp2 << endl;
    return tmp1 == tmp2;
}


signed main()
{
    optimize1;
    cin >> n;
    cin >> s;
    rs = s;
    P1.pb(1);
    for (int i = 0; i < n; ++i) {
        P1.pb((P1.back() * P) % MOD);
    }
    reverse(all(rs));
    //cout << s << ' ' << rs << endl;
    make_hash(s, hash1);
    make_hash(rs, hash2);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int l = 0; l + i + 1 < n && i - l >= 0; ++l) {
            int l1 = i - l, r1 = i, l2 = i + 1, r2 = i + 1 + l;
            //cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << endl;
            ans += (ll)(equa(l1, r1) == true && equa(l2, r2) == true);
        }
    }
    cout << ans << endl;
    return 0;
}
