#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n;
    cin >> n;
    string s;
    cin >> s;
    ll ans = 0;
    ans += n - 1;
    vector <vector <bool>> u(n, vector <bool>(n));
    for (ll sz = 2; sz * 2 <= n; sz++) {
        for (ll l = 0; l < n; l++) {
            ll r = l + sz - 1;
            if (r + sz >= n)
                break;
            if (!u[l][r]) {
                ll err = 0;
                for (ll i = l; i < r - i + l; i++) {
                    if (s[i] != s[r - i + l]) {
                        err++;
                        break;
                    }
                }
                if (err == 0)
                    u[l][r] = true;
            }
            if (!u[r + 1][r + sz]) {
                ll err = 0;
                for (ll i = r + 1; i < r + sz - i + r + 1; i++) {
                    if (s[i] != s[r + sz - i + r + 1]) {
                        err++;
                        break;
                    }
                }
                if (err == 0)
                    u[r + 1][r + sz] = true;
            }
            if (u[l][r] && u[r + 1][r + sz])
                ans++;
        }
    }
    cout << ans;
    return 0;
}