#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 1e5 + 47;

int n, ans;
string s;
int d1[N], d2[N];

void inc(int pos, vector<int> &f) {
    pos++;
    while (pos < f.size()) {
        f[pos]++;
        pos += pos & -pos;
    }
}

int sum(int r, vector<int> &f) {
    int res = 0;
    while (r) {
        res += f[r];
        r -= r & -r;
    }
    return res;
}

int sum(int l, int r, vector<int> &f) {
    r++;
    return sum(r, f) - sum(l, f);
}

void calc1() {
    {
        int l = 0, r = -1;
        for (int i = 0; i < n; i++) {
            int k = (i > r ? 1 : min(d1[l + r - i], r - i + 1));
            while (i + k < n && i - k >= 0 && s[i + k] == s[i - k]) k++;
            d1[i] = k;
            if (i + k - 1 > r) {
                l = i - k + 1;
                r = i + k - 1;
            }
        }
        for (int i = 0; i < n; i++) d1[i]--;
    }
    vector<int> perm;
    for (int i = 0; i < n; i++) {
        //d1[i] = 0;
        //while (i + d1[i] + 1 < n && i - d1[i] - 1 >= 0 && s[i + d1[i] + 1] == s[i - d1[i] - 1]) {
            //d1[i]++;
        //}
        perm.push_back(i);
    }
    sort(all(perm), [&](int i, int j) {
        return d1[i] > d1[j];
    });
    vector<int> cnt0i(n), cnt0j(n), cnt1i(n), cnt1j(n);
    for (int iter = 0; iter < n; iter++) {
        int i = perm[iter];
        {   // i == j
            if (i % 2 == 0) {
                ans += sum(max(0ll, (i - 2 * d1[i]) / 2), i / 2, cnt0i);
            } else {
                ans += sum(max(0ll, (i - d1[i] * 2) / 2), i / 2, cnt1i);
            }
        }
        {   // i == i
            if ((i + 1) % 2 == 0) {
                ans += sum((i + 1) / 2, min(n - 1, (i + 1 + 2 * d1[i]) / 2), cnt0j);
            } else {
                ans += sum((i + 1) / 2, min(n - 1, (2 * d1[i] + i + 1) / 2), cnt1j);
            }
        }
        if ((i + 1) % 2 == 0) inc((i + 1) / 2, cnt0i);
        else inc((i + 1) / 2, cnt1i);
        if (i % 2 == 0) inc(i / 2, cnt0j);
        else inc(i / 2, cnt1j);
    }
}

void calc2() {
    {
        int l = 0, r = -1;
        for (int i = 0; i < n; i++) {
            int k = (i > r ? 0 : min(d2[l + r - i + 1], r - i + 1));
            while (i + k < n && i - k - 1 >= 0 && s[i + k] == s[i - k - 1]) k++;
            d2[i] = k;
            if (i + k - 1 > r) {
                l = i - k;
                r = i + k - 1;
            }
        }
    }
    vector<int> perm;
    for (int i = 0; i < n; i++) {
        //d2[i] = 0;
        //while (i - d2[i] >= 0 && i + 1 + d2[i] < n && s[i - d2[i]] == s[i + d2[i] + 1]) {
            //d2[i]++;
        //}
        perm.push_back(i);
    }
    sort(all(perm), [&](int i, int j){
       return d2[i] > d2[j];
    });
    vector<int> cnt0i(n), cnt0j(n), cnt1i(n), cnt1j(n);
    for (int iter = 0; iter < n; iter++) {
        int i = perm[iter];
        {   // i == j
            if (i % 2 == 0) {
                ans += sum(max(0ll, (i - 2 * d2[i]) / 2), i / 2, cnt0i);
            } else {
                ans += sum(max(0ll, (i - d2[i] * 2) / 2), i / 2, cnt1i);
            }
        }
        {   // i == i
            if (i % 2 == 0) {
                ans += sum((i) / 2, min(n - 1, (i + 2 * d2[i]) / 2), cnt0j);
            } else {
                ans += sum((i) / 2, min(n - 1, (2 * d2[i] + i) / 2), cnt1j);
            }
        }
        if ((i) % 2 == 0) inc((i) / 2, cnt0i);
        else inc((i) / 2, cnt1i);
        if (i % 2 == 0) inc(i / 2, cnt0j);
        else inc(i / 2, cnt1j);
    }
}

void PUNKS_NOT_DEAD() {
    cin >> n;
    cin >> s;
    calc1();
    calc2();
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    PUNKS_NOT_DEAD();
}