#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

#define ll long long
#define S second
#define F fist

using namespace std;

ll a, b, c, d, e;
vector <ll> ar, pp;
vector <vector <ll> > arr;
vector <ll> hash1, hash2;

ll q = 1e9 + 7;
ll p = 17253;

ll get_hash1(ll l, ll r)
{
    if (l == 0)
        return hash1[r];
    return (hash1[r] - (hash1[l - 1] * pp[r - l + 1]) % q + q) % q;
}

ll get_hash2(ll l, ll r)
{
    if (l == 0)
        return hash2[r];
    return (hash2[r] - (hash2[l - 1] * pp[r - l + 1]) % q + q) % q;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a;
    pp.resize(a + 3);
    pp[0] = 1;
    for (ll i = 1; i <= a; ++i)
        pp[i] = (pp[i - 1] * p) % q;
    string s;
    cin >> s;
    hash1.resize(a);
    hash2.resize(a);
    string s1 = s;
    reverse(s1.begin(), s1.end());
    for (ll i = 0; i < a; ++i)
    {
        if (i == 0)
        {
            hash1[i] = s[i] - 'a' + 1;
            hash2[i] = s1[i] - 'a' + 1;
        }
        else
        {
            hash1[i] = ((hash1[i - 1] * p) % q + s[i] - 'a' + 1) % q;
            hash2[i] = ((hash2[i - 1] * p) % q + s1[i] - 'a' + 1) % q;
        }
    }
    //reverse(hash2.begin(), hash2.end());
    ll ot = 0;
    for (ll i = 1; i < a; ++i)
    {
        ll dl = 1;
        //cout << endl;
        while (i - dl >= 0 && i + dl - 1 < a)
        {
            //cout << i - dl << " " << i - 1 << " " << a - i << " " << a - i + dl - 1 << endl;
            //cout << i << " " << i + dl - 1 << " " << a - i - dl << " " << a - i - 1 << endl;
            if (get_hash1(i - dl, i - 1) == get_hash2(a - i, a - i + dl - 1) && get_hash1(i, i + dl - 1) == get_hash2(a - i - dl, a - i - 1))
                ++ot;
            ++dl;
        }
        //cout << ot << " " << i << endl;
    }
    cout << ot << endl;
}
