#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <deque>
#include <string>
#include <cmath>


#define x first
#define y second
#define int long long


typedef long long ll;
typedef long double ld;


using namespace std;


const int maxn = 5e5 + 10;
const int m2 = 1e6 + 10;
int p[maxn];
int d[maxn];
int d2[maxn];
const int mod = 1e9 + 7;
const int x = 37;


int get(vector<int> &h, int l, int r) {
	return (h[r] - h[l] * p[r - l] + mod * mod) % mod;
}

vector<pair<pair<int, int>, int>> zap[maxn];
int fen[4][(int)3e6];

void add(int el, int c) {
	el += m2;
	for (int i = el; i < 3e6; i = (i | (i + 1))) {
		fen[c][i]++;
	}
}

int ask(int el, int c) {
	el += m2;
	int ans = 0;
	for (int i = el; i > -1; i = (i & (i + 1)) - 1) {
		ans += fen[c][i];
	}
	return ans;
}



signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<int> h(1);
	vector<int> hr(1);
	p[0] = 1;
	for (int i = 1; i <= n; i++)
		p[i] = p[i - 1] * x % mod;
	for (int i = 0; i < n; i++) {
		h.push_back((s[i] - 'a' + 1 + h.back() * x) % mod);
	}
	for (int i = n - 1; i >= 0; i--) {
		hr.push_back((s[i] - 'a' + 1 + hr.back() * x) % mod);
	}
	for (int i = 0; i < n; i++) {
		int l = 0;
		int r = min(i, n - i - 1) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (get(h, i - m, i + m + 1) == get(hr, n - (i + m) - 1, n - (i - m)))
				l = m;
			else
				r = m;
		}
		d[i] = l;
		l = 0;
		r = min(i + 1, n - i - 1) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (get(h, i - m + 1, i + m + 1) == get(hr, n - (i + m) - 1, n - (i - m + 1))) {
				l = m;
			}
			else {
				r = m;
			}
		}
		d2[i] = l;
		//cout << d[i] << ' ' << d2[i] << endl;
	}
	int ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		int x = 1 - i % 2;
		if (x % 2 == 0) {
			zap[i].push_back({ {i + 1, 1}, -1 });
			zap[min(n - 1, 2 * d[i] + 1 + i)].push_back({ {i + 1, 1}, 1 });
		}
		else {
			zap[i].push_back({ {i + 1, 3}, -1 });
			zap[min(n - 1, 2 * d[i] + 1 + i)].push_back({ {i + 1, 3}, 1 });
		}
		x = 1 - x;
		if (x % 2 == 0) {
			zap[i].push_back({ {i, 0}, -1 });
			zap[min(n - 1, 2 * d2[i] + i)].push_back({ {i, 0}, 1 });
		}
		else {
			zap[i].push_back({ {i, 2}, -1 });
			zap[min(n - 1, 2 * d2[i] + i)].push_back({ {i, 2}, 1 });
		}
		/*
		for (int j = i + 1; j < n; j++) {
			if (j % 2 == x && j <= 2 * d[i] + 1 + i && j - 2 * d[j] <= i + 1) {
				ans++;
			}
		}
		for (int j = i + 1; j < n; j++) {
			if (j % 2 == 1 - x && j <= 2 * d2[i] + i && j - 2 * d2[j] <= i) {
				ans++;
			}
		}
		*/
	}
	for (int i = 0; i < n; i++) {
		int n = 0;
		if (i % 2 == 0) {
			add(i - 2 * d2[i], 0);
			add(i - 2 * d[i], 1);
		}
		else {
			add(i - 2 * d2[i], 2);
			add(i - 2 * d[i], 3);
		}
		for (auto el : zap[i]) {
			int aa = ask(el.x.x, el.x.y);
			ans += aa * el.y;
		}
	}
	cout << ans;
	return 0;
}

