

#include <iostream>
#include <random>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

bool is_pal(string &s, int l, int r) {
    int n = r - l;
    for (int i = 0; i < n / 2; i++) {
        if (s[i + l] != s[n - i - 1 + l])
            return false;
    }
    return true;
}

void run() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 2; j <= n; j += 2) {
            int k = (i + j) / 2;
            int cur = is_pal(s, i, k) && is_pal(s, k, j);
            //cerr << i << ' ' << j << ' ' << cur << endl;
            ans += cur;
        }
    }
    cout << ans << endl;
}