#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 500004;
const int x = 29;
const int mod = 1791791791;

int hs[maxn], hsr[maxn];
int xp[maxn];

int n;
string s;

int geths(int i, int j) {
    return ((hs[j] - hs[i] * xp[j - i]) % mod + mod) % mod;
}

int gethsr(int ti, int tj) {
    int i = n - tj;
    int j = n - ti;
    return ((hsr[j] - hsr[i] * xp[j - i]) % mod + mod) % mod;

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> s;

    string sr = s;
    reverse(sr.begin(), sr.end());

    xp[0] = 1;
    for (int i = 1; i < maxn; ++i)
        xp[i] = (xp[i - 1] * x) % mod;

    for (int i = 1; i <= n; ++i) {
        hs[i] = (hs[i - 1] * x + s[i - 1]) % mod;
        hsr[i] = (hsr[i - 1] * x + sr[i - 1]) % mod;
    }

    vector<pair<int, int>> type1, type2;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            if (i + j + 1 > n)
                break;

            int t1 = gethsr(i - j, i + 1);
            int t2 = geths(i, i + j + 1);

            if (t1 == t2)
                type1.push_back({i, j});
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < n; ++j) {
            if (i - j + 1 >= 0 && i + 1 + j <= n) {
                int t1 = gethsr(i - j + 1, i + 1);
                int t2 = geths(i + 1, i + 1 + j);
                if (t1 == t2) {
                    type2.push_back({i, j});
                }
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < type1.size(); ++i) {
        for (int j = i + 1; j < type1.size(); ++j) {
            if (type1[i].second == type1[j].second) {
                if (abs(type1[i].first - type1[j].first) == 1 + 2 * type1[i].second) {
                    ans++;
                }
            }
        }
    }

    for (int i = 0; i < type2.size(); ++i) {
        for (int j = i + 1; j < type2.size(); ++j) {
            if (type2[i].second == type2[j].second) {
                if (abs(type2[j].first - type2[i].first) == type2[i].second * 2) {
                    //cout << i << " " << j << endl;
                    ans++;
                }
            }
        }
    }

    cout << ans << '\n';

    return 0;
}
