#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

mt19937_64 rng(397);

const int N = 5050;
ll hsh[N][27], sub[N][N], rev_sub[N][N];
int n;
string s;

void init() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < 27; j++) {
            hsh[i][j] = rng();
        }
    }

    for (int l = 0; l < n; l++) {
        ll curhash = 0;
        for (int r = l; r < n; r++) {
            curhash ^= hsh[r - l][s[r] - 'a'];
            sub[l][r] = curhash;
        }
    }
    for (int l = n - 1; l >= 0; l--) {
        ll curhash = 0;
        for (int r = l; r >= 0; r--) {
            curhash ^= hsh[l - r][s[r] - 'a'];
            rev_sub[l][r] = curhash;
        }
    }
}

inline bool palind(int l, int r) {
    if (r == l)
        return true;
    int len = (r - l + 1) / 2;
    if (sub[l][l + len - 1] == rev_sub[r - len + 1][r])
        return true;
    return false;
}

signed main()
{
    fast_io;

    cin >> n >> s;
    init();

    int ans = 0;
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r += 2) {
            int len = (r - l + 1) / 2;

            if (palind(l, l + len - 1) && palind(r - len + 1, r))
                ans++;
        }
    }
    cout << ans;

    return 0;
}
