#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

ll h[500005];
ll sh[500005];
ll mod = 1e9 + 11;
ll p = 37;
ll pw[500005];
int pal[5001][5001];

ll get_h(int l, int r) {
    ll sm = (h[l] * pw[r - l + 1]) % mod;
    return (h[r + 1] + mod - sm) % mod;
}

ll get_sh(int l, int r) {
    ll sm = (sh[r + 1] * pw[r - l + 1]) % mod;
    return (sh[l] + mod - sm) % mod;
}

int main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        h[i + 1] = (h[i] * p + s[i]) % mod;
    }
    for (int i = n - 1; i >= 0; --i) {
        sh[i] = (sh[i + 1] * p + s[i]) % mod;
    }
    pw[0] = 1;
    for (int i = 1; i <= n; ++i) {
        pw[i] = (pw[i - 1] * p) % mod;
    }


    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            int len = j - i + 1;
            if (len % 2 == 1) {
                //cout << i << " " << i + len / 2 << " " << j << "\n";
                if (get_sh(i, i + len / 2) == get_h(i + len / 2, j)) {
                    pal[i][j] = 1;
                }
            } else {
                if (get_sh(i, i + len / 2 - 1) == get_h(i + len / 2, j)) {
                    pal[i][j] = 1;
                }
            }
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << pal[i][j];
        }
        cout << "\n";
    }*/
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if ((j - i + 1) % 2 == 1) continue;
            if (pal[i][i + (j - i + 1) / 2 - 1] && pal[i + (j - i + 1) / 2][j]) {
                ++ans;
                //cout << i << " " << j << "\n";
            }
        }
    }
    cout << ans;

    return 0;
}

