#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
#define cerr if (false) cerr
int n;
string s, t;
const int MAXN = 5e5 + 7;
const int BASE = 997;
const int MOD = 1791791791;
int h[MAXN], bases[MAXN];
int h1[MAXN];
int d[MAXN];
int have[MAXN];
int st[2][4 * MAXN];
void build(){
	bases[0] = 1;
	for (int i = 0; i < n; i++){
		bases[i + 1] = (bases[i] * BASE) % MOD;
		h[i + 1] = (s[i] + (h[i] * BASE) % MOD) % MOD;
	}
	reverse(ALL(s));
	for (int i = 0; i < n; i++)
		h1[i + 1] =  ((h1[i] * BASE) % MOD + s[i]) % MOD;
	reverse(ALL(s));
}
int get_s_hash(int l, int r){
	return (h[r] + MOD - (h[l] * bases[r - l]) % MOD) % MOD;
}
int get_s_hash1(int l, int r){
	return (h1[r] + MOD - (h1[l] * bases[r - l]) % MOD) % MOD;
}
int get_s(int v, int tl, int tr, int l, int r, int x){
	if (r <= tl || tr <= l)
		return 0;
	if (l <= tl && tr <= r)
		return st[x][v];
	int tm = (tl + tr) / 2;
	return get_s(v * 2, tl, tm, l, r, x) + get_s(v * 2 + 1, tm, tr, l, r, x);
}
void ins(int v, int tl, int tr, int pos, int x){
	// cerr << v << ' ' << tl << ' ' << tr << ' ' << pos << ' ' << x << '\n';
	if (pos < tl || tr <= pos)
		return;
	if (tr - tl == 1){
		st[pos & 1][v] += x;
		return;
	}
	int tm = (tl + tr) / 2;
	ins(v * 2, tl, tm, pos, x);
	ins(v * 2 + 1, tm, tr, pos, x);
	st[pos & 1][v] = st[pos & 1][2 * v] + st[pos & 1][2 * v + 1];
}
int solve(){
	if (!(cin >> n >> t))
		return 1;
	s = t;
	n = SZ(s);
	int N = 1;
	while (N < n)
		N *= 2;
	cerr << N << '\n';
	build();
	int ans = 0;
	for (int i = 0; i < n; i++){
		int l = 0, r = i + 1;
		while (r - l > 1){
			int m = (l + r) / 2;
			if (i < m){
				r = m;
				continue;
			}
			int l1 = i - m, r1 = i + m + 1;
			if (r1 > n){
				r = m;
				continue;
			}
			if (get_s_hash(l1, r1) == get_s_hash1(n - r1, n - l1))
				l = m;
			else
				r = m;
		}
		d[i] = 2 * l + 1;
	}
	set<pair<int, int>> have1;
	for (int i = 0; i < n; i++){
		while (SZ(have1) && have1.begin()->first < i){
			ins(1, 0, N, have1.begin()->second, -1);
			have1.erase(*have1.begin());
		}
		int tmp = 0;
		// for (int i = 0; i <= 2 * N; i++)
		// 	cerr << st[0][i] << " \n"[i == 2 * N];
		// for (int i = 0; i <= 2 * N; i++)
		// 	cerr << st[1][i] << " \n"[i == 2 * N];
		cerr << max(0LL, i - d[i]) << ' ' << i + 1 << ' ' << get_s(1, 0, N, max(0LL, i - d[i]), i + 1, (i & 1) ^ 1) << '\n';
		ans += get_s(1, 0, N, max(0LL, i - d[i]), i + 1, (i & 1) ^ 1);
		// for (int j = max(0LL, i - d[i]); j <= i; j++){
		// 	if ((i - j) % 2 == 0)
		// 		continue;
		// 	ans += have[j];
		// 	tmp += have[j];
		// }
		ins(1, 0, N, i, 1);
		have1.insert({d[i] + i, i});
	}
	have1.clear();
	for (int i = 0; i < n; i++)
		have[i] = 0;
	for (int i = 0; i < n; i++){
		if (get_s_hash(i, i + 1) != get_s_hash1(n - (i + 1), n - i)){
			d[i] = 0;
			continue;
		}
		int l = 0, r = i + 2;
		while (r - l > 1){
			int m = (l + r) / 2;
			int l1 = i - m + 1, r1 = i + m + 1;
			if (l1 < 0 || r1 > n){
				r = m;
				continue;
			}
			if (get_s_hash(l1, r1) == get_s_hash1(n - r1, n - l1))
				l = m;
			else
				r = m;
		}
		d[i] = l * 2;
	}
	fill(st[0], st[0] + 4 * MAXN, 0);
	fill(st[1], st[1] + 4 * MAXN, 0);
	for (int i = 0; i < n; i++){
		while (SZ(have1) && have1.begin()->first < i){
			ins(1, 0, N, have1.begin()->second, -1);					
			have1.erase(*have1.begin());
		}
		int tmp = 0;
		// for (int j = max(0LL, i - d[i]); j <= i; j++){
		// 	if ((i - j) % 2 == 1)
		// 		continue;
		// 	ans += have[j];
		// 	tmp += have[j];
		// }
		// cer
		ans += get_s(1, 0, N, max(0LL, i - d[i]), i + 1, (i & 1));
		ins(1, 0, N, i, 1);
		have1.insert({d[i] + i, i});
	}
	cout << ans << '\n';
	return 0;
}
signed main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}