#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

mt19937_64 rng(397);

const int N = 5050;
int n;
string s;
bool palind[N][N];

void init() {
    for (int i = 0; i < n; i++)
        palind[i][i] = true;
    for (int i = 0; i < n; i++) {
        int l = i - 1, r = i + 1;
        while(l >= 0 && r < n && s[l] == s[r]) {
            palind[l][r] = true;
            l--, r++;
        }
    }
    for (int i = 0; i < n; i++) {
        int l = i - 1, r = i;
        while(l >= 0 && r < n && s[l] == s[r]) {
            palind[l][r] = true;
            l--, r++;
        }
    }
}

signed main()
{
    fast_io;

    cin >> n >> s;
    init();

    int ans = 0;
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r += 2) {
            int len = (r - l + 1) / 2;

            if (palind[l][l + len - 1] && palind[r - len + 1][r])
                ans++;
        }
    }
    cout << ans;

    return 0;
}
