#include <bits/stdc++.h>
#define fst first
#define snd second
#define pb push_back
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
using namespace std; typedef long long ll; typedef long double ld;
mt19937 rnd(time(0));

#define int ll

const int p = 137;
const int mod = 1e9 + 7;
vector<int> h1;
vector<int> h2;
vector<int> ps;

int get1(int l, int r){
    return ((h1[r] - h1[l] * ps[r - l] % mod + mod) % mod);
}

int get2(int l, int r){
    return ((h2[r] - h2[l] * ps[r - l] % mod + mod) % mod);
}

int n;

bool check(int i, int j){
    return get1(i, j) == get2(n - j, n - i);
}

void solve(){
    cin >> n;
    string s;
    cin >> s;
    h1.resize(n + 1); h2.resize(n + 1); ps.resize(n + 1);
    h1[0] = h2[0] = 0;
    ps[0] = 1;
    for (int i = 0; i < s.size(); i++){
        h1[i + 1] = (h1[i] * p + s[i]) % mod;
        ps[i + 1] = ps[i] * p % mod;
    }
    reverse(s.begin(), s.end());
    for (int i = 0; i < s.size(); i++)
        h2[i + 1] = (h2[i] * p + s[i]) % mod;
    int ans = 0;
    for (int len = 1; len <= n; len++){
        for (int i = 0; i < n; i++){
            if (i + 2 * len > n)
                break;
            if (check(i, i + len) && check(i + len, i + 2 * len)){
                ans++;
            }
        }
    }
    cout << ans << endl;
}

signed main() {
    ios;
    int t = 1;
    while(t--)
        solve();
    return 0;
}
