#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;
#define int long long
#define x first
#define y second

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

const int mod = (1e9) + 9, p = 27;
const int modsq = mod * mod;
int pref[500009];
int revp[500009];
int powp[500009];
int n;
string s;

void build() {
    powp[0] = 1;
    for (int i = 0; i < n; i ++) {
        powp[i + 1] = (powp[i] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        pref[i + 1] = (pref[i] * p + (s[i] - 'a')) % mod;
    }

    for (int i = 0; i < n; i ++) {
        revp[i + 1] = (revp[i] * p + (s[n - i - 1] - 'a')) % mod;
    }
}

int getlr(int l, int r) {
    return (pref[r + 1] - pref[l] * powp[r - l + 1] + modsq) % mod;
}

int getrev(int l, int r) {
    l = n - l - 1;
    r = n - r - 1;
    swap(l, r);

    return (revp[r + 1] - revp[l] * powp[r - l + 1] + modsq) % mod;
}


signed tree[3000009];
inline void build(signed v, signed tl, signed tr) {
    if (tr - tl == 1) {
        tree[v] = 0;
        return;
    }

    signed tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build((v << 1) + 1, tm, tr);

    tree[v] = 0;
    return;
}

inline void upd(signed v, signed tl, signed tr, signed i, signed x) {
    if (tr - tl == 1) {
        tree[v] += x;
        return ;
    }

    signed tm = (tl + tr) >> 1;
    tree[v] += x;
    if (i < tm) {
        upd(v << 1, tl, tm, i, x);
    }

    else {
        upd((v << 1) + 1, tm, tr, i, x);
    }

    return ;
}

inline int getsum(signed v, signed tl, signed tr, signed l, signed r) {
    if (tl >= r || l >= tr) return 0;
    if (tl >= l && tr <= r) return tree[v];
    signed tm = (tl + tr) >> 1;
    return getsum(v << 1, tl, tm, l, r) + getsum((v << 1) + 1, tm, tr, l, r);
}

struct event {
    signed sgn;
    signed l, r;
    event() {};
    event(signed _sgn, signed _l, signed _r) {
        sgn = _sgn;
        l = _l;
        r = _r;
    }

    bool operator < (event oth) {
        if (r != oth.r) return r < oth.r;

        if (sgn != oth.sgn) {
            if (sgn == 0) return 1;
            if (oth.sgn == 0) return 0;
        }

        return l < oth.l;
    }
};

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    cin >> s;
    build();

    vector<int> pal(n);
    vector<int> pal2(n);
    int answ = 0;
    int MAXS = 0;
    for (int i = 0; i < n; i ++) {
        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getrev(i - m + 1, i) == getlr(i, i + m - 1)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        pal[i] = l;
        MAXS = max(MAXS, l);
    }

    MAXS = n + n / 2 + 2;

    build(1, 0, MAXS);
    vector<event> events;

    for (int i = 1; i < n; i += 2) {
        events.emplace_back(0, (signed)(pal[i] - (i + 1) / 2 + n), i);
    }

    for (int i = 0; i < n; i += 2) {
        events.emplace_back(1, -i/2 + n, (signed)(pal[i] * 2 + i - 1));
        events.emplace_back(-1, -i/2 + n, (signed)(i - 1));
    }

    sort(events.begin(), events.end());
    for (auto u : events) {
        if (u.sgn == 0) {
            upd(1, 0, MAXS, u.l, 1);
        }

        else {
            answ += u.sgn * getsum(1, 0, MAXS, u.l, MAXS);
        }
    }


    events.clear();
    build(1, 0, MAXS);

    for (int i = 2; i < n; i += 2) {
        events.emplace_back(0, (signed)(pal[i] - (i + 1) / 2 + n), i);
    }

    for (int i = 1; i < n; i += 2) {
        events.emplace_back(1, -i/2 + n, (signed)(pal[i] * 2 + i - 1));
        events.emplace_back(-1, -i/2 + n, (signed)(i - 1));
    }

    sort(events.begin(), events.end());
    for (auto u : events) {
        if (u.sgn == 0) {
            upd(1, 0, MAXS, u.l, 1);
        }

        else {
            answ += u.sgn * getsum(1, 0, MAXS, u.l, MAXS);
        }
    }



    for (int i = 0; i < n - 1; i ++) {
        int l = 0, r = min(i + 1, n - i - 1) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            //cout << i << ' ' << m << ' ' << getrev(i - m + 1, i ) << ' ' << getlr(i + 1, i+ m) <<  endl;
            if (getrev(i - m + 1, i) == getlr(i + 1, i + m)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        //cout << l << endl;
        pal2[i] = l;
    }

    events.clear();
    build(1, 0, MAXS);

    for (int i = 2; i < n - 1; i += 2) {
        events.emplace_back(0, (signed)(pal2[i] - (i) / 2 + n), i);
    }

    for (int i = 0; i < n - 1; i += 2) {
        events.emplace_back(1, -i/2 + n, (signed)(pal2[i] * 2 + i));
        events.emplace_back(-1, -i/2 + n, (signed)(i));
    }

    sort(events.begin(), events.end());
    for (auto u : events) {
        if (u.sgn == 0) {
            upd(1, 0, MAXS, u.l, 1);
        }

        else {
            answ += u.sgn * getsum(1, 0, MAXS, u.l, MAXS);
        }
    }

    events.clear();
    build(1, 0, MAXS);

    for (int i = 1; i < n - 1; i += 2) {
        events.emplace_back(0, (signed)(pal2[i] - (i) / 2 + n), i);
    }

    for (int i = 1; i < n - 1; i += 2) {
        events.emplace_back(1, -i/2 + n, (signed)(pal2[i] * 2 + i));
        events.emplace_back(-1, -i/2 + n, (signed)(i));
    }

    sort(events.begin(), events.end());
    for (auto u : events) {
        if (u.sgn == 0) {
            upd(1, 0, MAXS, u.l, 1);
        }

        else {
            answ += u.sgn * getsum(1, 0, MAXS, u.l, MAXS);
        }
    }

    cout << answ;

    return 0;
}




