#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
int const maxn = 5e5 + 5;
int l[maxn], r[maxn];
vector < int > tree[2][(1 << 20)];
ll h[maxn], p[maxn], rev[maxn], h1[maxn];
ll mod = 1e9 + 7, P = 29;

ll st(ll x, ll y) {
    if (y == 0) return 1;
    if (y % 2 == 0) {
        ll c = st(x, y / 2);
        return c * c % mod;
    }
    return x * st(x, y - 1) % mod;
}

void build(int i, int l, int r) {
    tree[0][i] = {}, tree[1][i] = {};
    if (r - l == 1) return;
    int m = (r + l) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
}

void add(int i, int l, int r, int lq, int rq, int x) {
    if (lq >= rq) return;
    if (lq >= r || l >= rq) return;
    if (lq <= l && r <= rq) {
        tree[(l - lq) % 2][i].push_back(x);
        return;
    }
    int m = (r + l) / 2;
    add(2 * i + 1, l, m, lq, rq, x);
    add(2 * i + 2, m, r, lq, rq, x);
}

int get(int i, int l, int r, int lq, int x) {
    int cur = 0;
    //for (auto key : tree[(lq - l) % 2][i]) if (key >= x) cur++;
    int it = lower_bound(tree[(lq - l) % 2][i].begin(), tree[(lq - l) % 2][i].end(), x) - tree[(lq - l) % 2][i].begin();
    cur = (int)tree[(lq - l) % 2][i].size() - it;
    if (r - l == 1) return cur;
    int m = (r + l) / 2;
    if (lq < m) cur += get(2 * i + 1, l, m, lq, x);
    else cur += get(2 * i + 2, m, r, lq, x);
    return cur;
}

ll geth(int L, int R, int t) {
    if (t == 0) return (h[R] - h[L - 1] + mod) * rev[L - 1] % mod;
    return (h1[R] - h1[L - 1] + mod) * rev[L - 1] % mod;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll ans = 0;
    cin >> n;
    string s, s1;
    cin >> s;
    s1 = s;
    reverse(s1.begin(), s1.end());
    p[0] = 1, rev[0] = 1;
    for (int i = 1; i <= n + 1; ++i) p[i] = p[i - 1] * P % mod, rev[i] = st(p[i], mod - 2);
    for (int i = 1; i <= n; ++i) h[i] = (h[i - 1] + p[i - 1] * (s[i - 1] - 'a' + 1)) % mod, h1[i] = (h1[i - 1] + p[i - 1] * (s1[i - 1] - 'a' + 1)) % mod;
    for (int i = 0; i < n; ++i) {
        int j = i;
        while (j >= 0 && 2 * i - j < n && s[j] == s[2 * i - j]) --j;
        //l[i] = j + 1, r[i] = 2 * i - j - 1;
        int lef = 0, righ = min(i, n - i - 1) + 1;
        while (righ - lef > 1) {
            int mid = (righ + lef) / 2;
            //if (i == 1) cout << i + 2 << " " << i + mid + 1 << endl;
            if (geth(i - mid + 1, i, 0) == geth(n - i - mid, n - i - 1, 1)) lef = mid;
            else righ = mid;
        }
        l[i] = i - lef, r[i] = i + lef;
    }
    for (int i = 0; i < n; ++i) {
        if (i % 2 == 1) add(0, 0, n, i + 1, min(2 * r[i] - i + 2, n), i);
        else add(0, 0, n, i + 1, min(2 * r[i] - i + 2, n), i);
    }
    for (int i = 1; i < n; ++i) {
        if (i % 2 == 0) {
            ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 1);
        }
        else {
            ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 1);
        }
    }
    build(0, 0, n);
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) continue;
        int lef = 0, righ = min(i, n - i - 2) + 1;
        while (righ - lef > 1) {
            int mid = (righ + lef) / 2;
            if (geth(i - mid + 1, i + 1, 0) == geth(n - i - mid, n - i - 1, 1)) lef = mid;
            else righ = mid;
        }
        l[i] = i - lef, r[i] = i + lef;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) continue;
        add(0, 0, n, i + 2, min(n, 2 * r[i] - i + 1), i);
    }
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) continue;
        ans += (ll)get(0, 0, n, i, 2 * l[i] - i - 2);
        //if (i == 3) cout << 2 * l[i] - i << endl;
    }
    cout << ans << '\n';
    return 0;
}
