#include <bits/stdc++.h>
using namespace std;

int n;
string s;
vector<pair<int, int>> pals = {};

bool check_pal(int i, int j) {
	if ( (i < 0) || (j >= n) ) return false;
	for ( int k = i; k <= j; ++k ) if ( s[k] != s[i + j - k] ) return false;
	return true;
}

void find_pals() {
	for ( int i = 0; i < n; ++i ) {
		for ( int j = 1; j <= min(i+1, n - i) + 1; ++j ) {
			if ( !check_pal(i - j + 1, i + j - 1) ) {
				pals.push_back({i - j + 2, i + j - 2});
				break;
			}
		}
	}

	for ( int i = 0; i < n; ++i ) {
		for ( int j = 1; j <= min(i+1, n - i - 1) + 1; ++j ) {
			if ( !check_pal(i - j + 1, i + j) ) {
				pals.push_back({i - j + 2, i + j - 1});
				break;
			}
		}
	}
}



int main() {
	cin >> n;
	cin >> s;

	find_pals();
	int ans = 0;

	// for ( int i = 0; i < pals.size(); ++i ) {
	// 	cout << pals[i].first << " " << pals[i].second << endl;
	// }

	for ( int i = 0; i < pals.size(); ++i ) {
		for ( int j = 0; j < pals.size(); ++j ) {
			if ( i == j ) continue;
			if ( (pals[i].first + pals[i].second) > (pals[j].first + pals[j].second) ) continue;
			int x = pals[i].first + pals[i].second + pals[j].first + pals[j].second - 2;
			if ( x % 4 != 0 ) continue;
			x = x >> 2;
			if ( !((pals[i].first <= x) && (pals[i].second >= x)) ) continue;
			if ( !((pals[j].first <= x+1) && (pals[j].second >= x+1)) ) continue;
			ans += 1;
		}
	}

	cout << ans << endl;
	return 0;
}