#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << ' ' << x << endl

using namespace std;

int n;
string s;

bool isPalindrome(int l, int r) {
    int length = r - l + 1;
    int mid = length >> 1;
    int ptr = r;
    for (int i = l; i <= l + mid; i++, ptr--) {
        if (s[i] != s[ptr]) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    cin >> s;

    long long answer = n - 1;
    for (int len = 4; len <= n; len += 2) {
        for (int beg = 0; beg <= n - len; beg++) {
            int end = beg + len - 1;
            int mid = (beg + end) >> 1;
            if (isPalindrome(beg, mid) && isPalindrome(mid + 1, end)) {
                answer++;
            }
        }
    }

    cout << answer << endl;

    return EXIT_SUCCESS;
}
