#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 5000 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;


int n;
string s;
bool pal[MAXN][MAXN];
              

int main() {
	fastIO();
	cin >> n >> s;
	for (int i = 0; i < n; i++)
		pal[i][i] = 1; 
	for (int i = n - 2; i >= 0; i--) {
		if (s[i] == s[i + 1])
			pal[i][i + 1] = 1;
		for (int j = i + 2; j < n; j++) {
			if (pal[i + 1][j - 1] && s[i] == s[j])
				pal[i][j] = 1;
	 	}
	}
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		for (int j = i; i + (j - i + 1) * 2 <= n; j++) {
			if (pal[i][j] && pal[j + 1][j + j - i + 1])
				ans++;
		}
	}
	cout << ans;
	
	
	
	return 0;

}