//#define _GLIBcxx_DEBUG

#pragma GCC optimaze("unroll-loops")
//#pragma GCC optimaze("fast-math")
//#pragma GCC optimaze("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;
vector<int> randmod = {1000000007, 1000000009, 1000006957, 1000001329};
int mod = randmod[rand() % randmod.size()];
vector<int> randp = {29, 31, 37, 43, 157};
int p = randp[rand() % randp.size()];
vector<int> pows = {1};

int mul(int a, int b) {
	ll c = (ll) a * b;
	if (c >= mod)
		c %= mod;
	return c;
}

int sum(int a, int b) {
	int c = a + b;
	if (c >= mod)
		c -= mod;
	return c;
}

int diff(int a, int b) {
	int c = a - b;
	if (c < 0)
		c += mod;
	return c;
}

vector<int> getHash(string s) {
	int n = s.size();
	int sz = pows.size();
	for (int i = sz; i <= n; ++i) {
		pows.push_back(mul(pows[i - 1], p));
	}
	vector<int> h(n + 1, 0);
	for (int i = 0; i < n; ++i) {
		h[i + 1] = sum(h[i], mul(s[i] - 'a' + 1, pows[i]));
	}
	return h;
}

int getSeg(int L, int R, vector<int>& h) {
	return diff(h[R + 1], mul(h[L], pows[R - L + 1]));
}

signed main() {
	fastio();
	int n; cin >> n;
	string s; cin >> s;
	vector<int> h = getHash(s);
	string t = s;
	rev(t);
	vector<int> rh = getHash(t);
	int ans = 0;
	for (int L = 0; L < n; ++L) {
		for (int R = L + 1; R < n; R += 2) {
			int m = (R + L) / 2;
			bool ok = true;
			for (int i = 0; m - i > L + i; ++i) {
				if (s[L + i] != s[m - i]) {
					ok = false;
				}
			}
			for (int i = 1; R - i + 1 > m + 1; ++i) {
				if (s[m + i] != s[R - i + 1]) {
					ok = false;
				}
			}
			ans += ok;
			if (ok) {
				cout << L << " " << R << endl;
			}
			/*if ((m - L + 1) % 2 == 0) {
				int m1 = (L + m) / 2;
				int m2 = (m + R) / 2;
				if (getSeg(L, m1, h) == getSeg(n - 1 - m, n - 1 - (m1 + 1), rh) && getSeg(m, m2, h) == getSeg(n - 1 - R, n - 1 - (m2 + 1), rh)) {
					++ans;
				}
			} 
			else {
				int m1 = (L + m) / 2;
				int m2 = (m + R) / 2;
				if (getSeg(L, m1, h) == getSeg(n - 1 - m, n - 1 - m1, rh) && getSeg(m, m2, h) == getSeg(n - 1 - R, n - 1 - m2, rh)) {
					++ans;
				}
			}*/
		}
	}
	cout << ans << endl;
}