#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << ' ' << x << endl

using namespace std;

const int SIGMA = 26;

int n;
string s;
vector<int> poses[SIGMA];

bool isPalindrome(int l, int r) {
    int length = r - l + 1;
    int mid = length >> 1;
    int ptr = r;
    for (int i = l; i <= l + mid; i++, ptr--) {
        if (s[i] != s[ptr]) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    cin >> s;

    for (int i = 0; i < n; i++) {
        poses[s[i] - 'a'].emplace_back(i);
    }

    long long answer = n - 1;
    for (int i = 0; i < SIGMA; i++) {
        for (int j = 0; j < (int)poses[i].size(); j++) {
            for (int k = j + 1; k < (int)poses[i].size(); k++) {
                int length = poses[i][k] - poses[i][j] + 1;
                int l = poses[i][k] + 1;
                int r = l + length - 1;
                if (l < n && r < n) {
                    if (isPalindrome(poses[i][j], poses[i][k]) && isPalindrome(l, r)) {
                        answer++;
                    }
                }
            }
        }
    }

    cout << answer << endl;

    return EXIT_SUCCESS;
}
