#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <cassert>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef pair <int, int> pii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,avx,popcnt,ssse3,mmx,tune=native")

const int N = 5005;

int dp[N][N];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i)
        dp[i][i] = true;
    for (int i = 0; i < n - 1; ++i)
        if (s[i] == s[i + 1])
            dp[i][i + 1] = true;
    for (int le = 3; le <= n; ++le)
        for (int i = 0; i < n - le + 1; ++i)
            dp[i][i + le - 1] = (dp[i + 1][i + le - 2] && s[i] == s[i + le - 1]);
    int ans = 0;
    for (int L = 0; L < n; ++L)
        for (int R = L; 2 * R - L + 1 < n; ++R)
            if (dp[L][R] && dp[R + 1][2 * R - L + 1])
                ++ans;
    cout << ans << endl;
    return 0;
}
