#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"
#define x first
#define y second 
#define vec vector
#define pii pair<int, int>
#define pb push_back

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	srand(time(0));
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}

const int MOD = 1e9 + 9, MAXN = 500000 + 10, INF = 1e9, BASE = 37;
// int h[MAXN], rh[MAXN];

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;

	vec<int> a(n), b(n - 1);
	for (int i = 0; i < n; ++i) {
		int l = i, r = i;
		while (l >= 0 && r < n && s[l] == s[r]) {
			l--, r++;
		}
		a[i] = 1 + 2 * (r - i - 1);
	}
	for (int i = 0; i < n - 1; ++i) {
		int l = i, r = i + 1;
		if (s[l] != s[r]) continue;
		while (l >= 0 && r < n && s[l] == s[r]) {
			l--, r++;
		}
		r--, l++;
		b[i] = (r - l + 1);
	}

	int ans = 0;
	vec<int> t(MAXN, 0);
	for (int i = 0; i < n; ++i) {
		if (i & 1) {
			int k = (a[i] + 1) / 2;
			for (int j = i + 1; j < n; j += 2) {
				if (k == 0) break;
				if (a[j] < (j - i)) {
					k--;
					break;
				}
				t[j]++;
				k--;
			}
		}
	}

	for (int i = 2; i < n; i += 2) {
		ans += t[i];
	}

	t.assign(MAXN, -INF);
	for (int i = 0; i < n; ++i) {
		if (!(i & 1)) {
			t[i] = a[i];
		}
	}
	for (int i = 1; i < n; i += 2) {
		for (int j = i - 3; j >= 0; --j) {
			t[j] -= 2;
		}
		t[i - 1] -= 1;
		int k = (a[i] / 2) * 2 + 1;
		for (int j = max(0ll, i - k); j < i; ++j) {
			if (t[j] >= 0) {
				ans++;
			}
		}
	}

	t.assign(MAXN, -INF);
	for (int i = 0; i < n - 1; ++i) {
		if (!(i & 1)) {
			t[i] = b[i];
		}
	}

	for (int i = 2; i < n - 1; i += 2) {
		for (int j = i - 2; j >= 0; --j) {
			t[j] -= 2;
		}
		int k = b[i];
		for (int j = max(0ll, i - k); j < i; ++j) {
			if (t[j] >= 0) {
				ans++;
			}
		}
	}

	t.assign(MAXN, -INF);
	for (int i = 0; i < n - 1; ++i) {
		if (i & 1) {
			t[i] = b[i];
		}
	}

	for (int i = 3; i < n - 1; i += 2) {
		for (int j = i - 2; j >= 0; --j) {
			t[j] -= 2;
		}
		int k = b[i];
		for (int j = max(0ll, i - k); j < i; ++j) {
			if (t[j] >= 0) {
				ans++;
			}
		}
	}

	cout << ans << endl;
}