#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cstdio>
using namespace std;
typedef long long li;
const li MAX = (li)1e5;
li n;
li mod1 = (li)1e9 + 7, mod2 = (li)1e9 + 9;
li p = 151;
li maxl[MAX][2], stpref[MAX][2], l[MAX][2], fast[MAX][2], hsh[MAX][2][2];
void counthash() {
    for (int i = 1; i <= n; i++) {
        hsh[i][0][0] = (hsh[i - 1][0][0] * p + l[i][0]) % mod1;
        hsh[i][0][1] = (hsh[i - 1][0][1] * p + l[i][0]) % mod2;
        hsh[i][1][0] = (hsh[i - 1][1][0] * p + l[i][1]) % mod1;
        hsh[i][1][1] = (hsh[i - 1][1][1] * p + l[i][1]) % mod2;
    }
}
pair<li, li> gethsh(li l, li r, li a) {
    li an1 = (hsh[r][a][0] + mod1 - (hsh[l - 1][a][0] * fast[r - l + 1][0]) % mod1) % mod1;
    li an2 = (hsh[r][a][1] + mod2 - (hsh[l - 1][a][1] * fast[r - l + 1][1]) % mod2) % mod2;
    return { an1, an2 };
}
li pos(li l1, li r) {
    pair<li, li> an1 = gethsh(l1, r, 0);
    pair<li, li> an2 = gethsh(n - r + 1, n - l1 + 1, 1);
    return (an1 == an2);
}
int main() {
    cin >> n;
    string s;
    cin >> s;
    fast[0][0] = 1;
    fast[0][1] = 1;
    for (int i = 1; i <= n; i++) {
        fast[i][0] = (fast[i - 1][0] * p) % mod1;
        fast[i][1] = (fast[i - 1][1] * p) % mod2;
    }
    for (int i = 1; i <= n; i++) {
        l[i][0] = s[i - 1] - 96;
    }
    for (int i = n; i > 0; i--) {
        l[n - i + 1][1] = s[i - 1] - 96;
    }
    counthash();
    li tmp = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            if ((j - i + 1) % 2 == 0) {
                if (pos(i, (i + j) / 2) && pos((i + j) / 2 + 1, j)) tmp++;
            }
        }
    }
    cout << tmp;
    return 0;
}