#include<bits/stdc++.h>

using namespace std;
#define f(n) for(int i = 0; i < n; i++)
#define fj(n) for(int j = 0; j < n; j++)
#define fk(n) for(int k = 0; k < n; k++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define eb emplace_back
#define pri(a, n) for(int i = 0; i < n; i++) cout << a[i] << ' '; cout << '\n';
#define ic(a) int a; cin >> a;
#define con cout << '\n';
#define int long long
const int mod = 1791791791, p = 179;
const int maxn = 10000;

class Tree
{
    vector<int> tree[4 * maxn];
 public:
     void build(int a[], int v, int vl, int vr)
     {
         if(vr - vl == 1)
         {
             tree[v].pb(a[vl]);
             return;
         }
         int m = (vl + vr) >> 1;
         build(a, 2 * v + 1, vl, m);
         build(a, 2 * v + 2, m, vr);
         merge(all(tree[2 * v + 1]), all(tree[2 * v + 2]), back_inserter(tree[v]));
     }
     int get(int v, int vl, int vr, int l, int r, int x)
     {
         if(vl >= l && vr <= r)
         {
             //cout << "QUE " << l << ' ' << r << ' ' << x << '\n';
             //pri(tree[v], tree[v].size())
             //con
             return tree[v].size() - (lower_bound(all(tree[v]), x) - tree[v].begin());
         }
         if(vl >= r || vr <= l) return 0;
         int m = (vl + vr) >> 1;
         return get(2 * v + 1, vl, m, l, r, x) + get(2 * v + 2, m, vr, l, r, x);
     }
};
signed main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int pw[n + 1];
    pw[0] = 1;
    for(int i = 1; i <= n; i++) pw[i] = (pw[i - 1] * p) % mod;
    string s;
    cin >> s;
    int hl[n + 1], hr[n + 1];
    hl[0] = 0, hr[0] = 0;
    for(int i = 1; i <= n; i++)
    {
        hl[i] = (hl[i - 1] + (s[i - 1] - 'a' + 1) * pw[i - 1]) % mod;
        hr[i] = (hr[i - 1] + (s[i - 1] - 'a' + 1) * pw[n - i]) % mod;
    }
    int pl[n], pc[n];
    f(n)
    {
        int l = 0, r = min(i + 1, n - i - 1) + 1;
        while(r - l > 1)
        {
            int m = (l + r) >> 1;
            int chr = ((hl[i + 1 + m] - hl[i + 1] + mod)) % mod;
            chr = (chr * pw[max(n - i - 1 - (i + 1), 0ll)]) % mod;
            int chl = (hr[i + 1] - hr[i - m + 1] + mod) % mod;
            chl = (chl * pw[max(i + 1 - (n - i - 1), 0ll)]) % mod;
            if(chl == chr) l = m;
            else r = m;
        }
        pl[i] = l;
    }
    f(n)
    {
        int l = 0, r = min(i, n - i - 1) + 1;
        while(r - l > 1)
        {
            int m = (l + r) >> 1;
            int chr = ((hl[i + 1 + m] - hl[i + 1] + mod)) % mod;
            chr = (chr * pw[max(n - i - (i + 1), 0ll)]) % mod;
            int chl = (hr[i] - hr[i - m] + mod) % mod;
            chl = (chl * pw[max(i + 1 - (n - i), 0ll)]) % mod;
            if(chl == chr) l = m;
            else r = m;
        }
        pc[i] = l;
    }
    int ans = 0;
    int apl[2][n], apc[2][n];
    f(n)
    {
        fj(2) apl[j][i] = (((j % 2) == (i % 2) && pl[i] > 0) ? i + pl[i] : -1);
        fj(2) apc[j][i] = (((j % 2) == (i % 2)) ? i + pc[i] : -1);
    }
    /*f(2)
    {
        fj(n) cout << apc[i][j] << ' ';
        con
    }*/
    Tree tr[2], tc[2];
    f(2) tr[i].build(apl[i], 0, 0, n);
    f(2) tc[i].build(apc[i], 0, 0, n);
    f(n)
    {
        ans += tr[i & 1].get(0, 0, n, max(i - 2 * pl[i], 0ll), i, max(i - pl[i], 0ll));
        ans += tc[1 ^ (i & 1)].get(0, 0, n, max(i - 2 * pc[i] - 1, 0ll), i, max(i - pc[i] - 1, 0ll));
        //cout << tr[i & 1].get(0, 0, n, max(i - 2 * pl[i], 0ll), i, max(i - pl[i], 0ll)) << '\n';
       /* el e = ln[i];
        while(lp - 1 >= 0 && lp - 1 >= e.v)
        {
            lp--;
            if(pl[lp] > 0) fn[lp & 1].upd(lp + pl[lp] + 1, 1);
        }
        if(pl[e.i] > 0) ans += fn[e.i & 1].sm(e.i - pl[e.i] + 1, n) - (n - e.i);

        //ans += fnc[1 ^ (i & 1)].sm(max(i - pc[i] - 1, 0ll) + 1, n);
        //cout << fnc[1 ^ (i & 1)].sm(max(i - pc[i] - 1, 0ll) + 1, n) << '\n';
        //fnc[i & 1].upd(i + pc[i] + 1, 1);*/
    }
    //pri(pl, n)
    //pri(pc, n)
    cout << ans;
}
