#include<bits/stdc++.h>
#define int long long int
#define ft first
#define sc second
#define pb push_back
#define ld long double
using namespace std;
const int maxn = 500010, p = 164, mod = 1791791791;
int phash[maxn];
int shash[maxn];
int predp[maxn];
int mas[maxn];
int tree[4 * maxn];
int tree1[4 * maxn];
int hashf(int l, int r) {
    return ((phash[r] - phash[l] * predp[r - l]) % mod + mod) % mod;
}
int hashb(int l, int r) {
    return ((shash[l] - shash[r] * predp[r - l]) % mod + mod) % mod;
}
void build(int tl, int tr, int num) {
    if (tl + 1 == tr) {
        tree[num] = 0;
        tree1[num] = 0;
        return;
    }
    int m = (tl + tr) / 2;
    build(tl, m, 2 * num);
    build(m, tr, 2 * num + 1);
    tree[num] = 0;
    tree1[num] = 0;
}
struct event {
    int l, r, x, ch;
    event (int _l, int _r, int _x, int _ch) {
        l = _l; r = _r; x = _x; ch = _ch;
    }
};
bool cmp(event a, event b) {
    return a.x > b.x;
}
void change(int tl, int tr, int i, int zn, int num) {
    if (tl + 1 == tr) {
        if (tl % 2 == 0) {
            tree[num] = zn;
        } else {
            tree1[num] = zn;
        }
        return;
    }
    int m = (tl + tr) / 2;
    if (i < m) {
        change(tl, m, i, zn, 2 * num);
    } else {
        change(m, tr, i, zn, 2 * num + 1);
    }
    tree[num] = tree[2 * num] + tree[2 * num + 1];
    tree1[num] = tree1[2 * num] + tree1[2 * num + 1];
}
int get(int tl, int tr, int l, int r, int ch, int num) {
    if (tl >= r || tr <= l) return 0;
    if (tl >= l && tr <= r) {
        if (ch == 0) {
            return tree[num];
        } else {
            return tree1[num];
        }
    }
    int m = (tl + tr) / 2;
    return get(tl, m, l, r, ch, 2 * num) + get(m, tr, l, r, ch, 2 * num + 1);
}
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    string s;
    cin >> s;
    predp[0] = 1;
    for (int d = 1; d < s.size(); d++) {
        predp[d] = (predp[d - 1] * p) % mod;
    }
    phash[0] = 0;
    for (int d = 0; d < s.size(); d++) {
        phash[d + 1] = (phash[d] * p + s[d]) % mod;
    }
    shash[n] = 0;
    for (int d = n - 1; d >= 0; d--) {
        shash[d] = (shash[d + 1] * p + s[d]) % mod;
    }
    vector<int> mas;
    vector<int> mas1;
    for (int d = 0; d < n; d++) {
        int l = 0, r = min(d + 1, n - d);
        while (l + 1 < r) {
            int m = (l + r) / 2;
            int hash1 = hashf(d, d + m + 1);
            int hash2 = hashb(d - m, d + 1);
            // cout << hash1 << " " << hash2 << "\n";
            if (hash1 == hash2) {
                l = m;
            } else {
                r = m;
            }
        }
        mas.pb(l + 1);
        if (d != n - 1) {
            l = 0, r = min(d + 1, n - d - 1) + 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                int hash1 = hashf(d + 1, d + m + 1);
                int hash2 = hashb(d - m + 1, d + 1);
                //cout << hash1 << " " << hash2 << "\n";
                if (hash1 == hash2) {
                    l = m;
                } else {
                    r = m;
                }
            }
            mas1.pb(l);
        }
    }
//    for (int i : mas) {
//        cout << i << " ";
//    }
    int ans = 0;
    for (int d = 0; d < mas.size(); d++) {
        mas[d] *= 2;
        mas[d] -= d;
    }
    vector<event> events;
    vector<pair<int, int> > vec;
    for (int d = 0; d < mas.size(); d++) {
        //cout << mas[d] << " ";
        event ev(d + 1, min((int)(mas.size()), 2 * d + mas[d]), -d, ((d % 2) ^ 1));
        events.pb(ev);
        vec.pb({mas[d], d});
//        for (int i = d + 1; i < mas.size() && i < 2 * d + mas[d]; i += 2) {
//            if (mas[i] >= -d) {
//                ans++;
//            }
//        }
    }
    sort(vec.begin(), vec.end());
    reverse(vec.begin(), vec.end());
    sort(events.begin(), events.end(), cmp);
    int k = 1;
    while (k <= n) {
        k *= 2;
    }
    build(0, k, 1);
    int l = 0;
    for (int d = 0; d < vec.size() && l < events.size(); d++) {
        while (l < events.size() && events[l].x > vec[d].ft) {
            ans += get(0, k, events[l].l, events[l].r, events[l].ch, 1);
            //cout << "ask " << events[l].l << " " << events[l].r << " " << events[l].x << " " << ans << "\n";
            l++;
        }
        change(0, k, vec[d].sc, 1, 1);
        //cout << "add " << vec[d].ft << " " << vec[d].sc << "\n";
    }
    while (l < events.size()) {
        ans += get(0, k, events[l].l, events[l].r, events[l].ch, 1);
        //cout << "ask " << events[l].l << " " << events[l].r << " " << events[l].x << " " << ans << "\n";
        l++;
    }
    for (int d = 0; d < mas1.size(); d++) {
        mas1[d] *= 2;
        mas1[d] -= d;
    }
    vec.clear(); events.clear();
    for (int d = 0; d < mas1.size(); d++) {
         //cout << mas1[d] << " ";
        //cout << d << ":\n";
        event ev(d + 2, min((int)(mas1.size()), 2 * d + mas1[d] + 1), -d, (d % 2));
        events.pb(ev);
        vec.pb({mas1[d], d});
//        for (int i = d + 2; i < mas1.size() && i <= 2 * d + mas1[d]; i += 2) {
//            if (mas1[i] >= -d) {
//                ans++;
//                //cout << i << " ";
//            }
//        }
        //cout << "\n";
    }
    sort(vec.begin(), vec.end());
    reverse(vec.begin(), vec.end());
    sort(events.begin(), events.end(), cmp);
    l = 0;
    build(0, k, 1);
    for (int d = 0; d < vec.size() && l < events.size(); d++) {
        while (l < events.size() && events[l].x > vec[d].ft) {
            ans += get(0, k, events[l].l, events[l].r, events[l].ch, 1);
            //cout << "ask " << events[l].l << " " << events[l].r << " " << events[l].x << " " << ans << "\n";
            l++;
        }
        change(0, k, vec[d].sc, 1, 1);
        //cout << "add " << vec[d].ft << " " << vec[d].sc << "\n";
    }
    while (l < events.size()) {
        ans += get(0, k, events[l].l, events[l].r, events[l].ch, 1);
        //cout << "ask " << events[l].l << " " << events[l].r << " " << events[l].x << " " << ans << "\n";
        l++;
    }
    cout << ans;
}
/*
7
zzzzaaa
*/
