#include <bits/stdc++.h>
using namespace std;

int n;
string s;
vector<pair<int, int>> pals = {};

bool check_pal(int i, int j) {
	if ( (i < 0) || (j >= n) ) return false;
	for ( int k = i; k <= j; ++k ) if ( s[k] != s[i + j - k] ) return false;
	return true;
}

int xi;

bool cmp1(const int & j, const int & zuzz) {
	if ( !check_pal(xi - j + 1, xi + j - 1) ) return false;
	return true;
}

bool cmp2(const int & j, const int & zuz) {
	if ( !check_pal(xi - j + 1, xi + j) ) return false;
	return true;
}

void find_pals() {
	vector<int> nat(n * 2, 1);
	for ( int i = 0; i < n * 2; ++i ) nat[i] = i + 1;
	int ans;
	
	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i), 1, cmp1) - nat.begin();
		ans += 1;
		pals.push_back({i - ans + 2, i + ans - 2});
	}

	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i - 1), 1, cmp2) - nat.begin();
		ans += 1;
		if ( ans == 1 ) continue;
		pals.push_back({i - ans + 2, i + ans - 1});
	}
}



int main() {
	cin >> n;
	cin >> s;

	find_pals();
	int ans = 0;

	// for ( int i = 0; i < pals.size(); ++i ) {
	// 	cout << pals[i].first << " " << pals[i].second << endl;
	// }

	for ( int i = 0; i < pals.size(); ++i ) {
		for ( int j = 0; j < pals.size(); ++j ) {
			if ( i == j ) continue;
			if ( (pals[i].first + pals[i].second) > (pals[j].first + pals[j].second) ) continue;
			int x = pals[i].first + pals[i].second + pals[j].first + pals[j].second - 2;
			if ( x % 4 != 0 ) continue;
			x = x >> 2;
			if ( !((pals[i].first <= x) && (pals[i].second >= x)) ) continue;
			if ( !((pals[j].first <= x+1) && (pals[j].second >= x+1)) ) continue;
			ans += 1;
		}
	}

	cout << ans << endl;
	return 0;
}