#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
const int MAXN = 5007;
struct hasher {
	int h[MAXN], P, Q, p[MAXN], n, inv;
	void init(string s) {
		inv = 0;
		n = s.size();
		p[0] = 1;
		for (int i = 1; i < MAXN; ++i)
			p[i] = p[i - 1] * P % Q;
		for (int i = 0; i < s.size(); ++i)
			h[i] = ((i ? h[i - 1] : 0) * P + s[i]) % Q;
	}
	inline int md(int x) {
		if (x >= Q)
			return x - Q;
		else
			return x;
	}
	int get(int l, int r) {
		if (inv)
			l = n - l - 1, r = n - r - 1;
		if (l > r)
			swap(l, r);
		if (!l)
			return h[r];
		else
			return md(h[r] - h[l - 1] * p[r - l + 1] % Q + Q);
	}
};
hasher h1, h2, h1r, h2r;
int n;
int is(int l, int r) {
	int len = (r - l) / 2 + 1;
	return (h1.get(l, l + len - 1) == h1r.get(r, r - len + 1)) && 
		   (h2.get(l, l + len - 1) == h2r.get(r, r - len + 1));
}
void solve() {
	cin >> n;
	string s;
	cin >> s;
	string sr;
	sr = s;
	reverse(sr.begin(), sr.end());
	h1.P = h1r.P = 179;
	h1.Q = h1r.Q = 1791791791;

	h2.P = h2r.P = 79;
	h2.Q = h2r.Q = 1e9 + 9;
	
	h1.init(s), h2.init(s);
	h1r.init(sr), h2r.init(sr);
	h1r.inv = h2r.inv = 1;
	int ans = 0;
	for (int len = 2; len <= s.size(); len += 2)
		for (int l = 0; l + len - 1 < s.size(); ++l)
			if (is(l, l + len / 2 - 1) && is(l + len / 2, l + len - 1))
				++ans;
	cout << ans;
	return;
}
signed main() {
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}