#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#define endl '\n'
#define MODULE 1000000007
#define MAXN 1000006
int br; string input, rev;
int power[MAXN], hass[MAXN], hashrev[MAXN];
set<pair<int, int> > palin;
bool check(int from, int to){
	int hash1 = hass[to];
	if(from > 0) hash1 -= hass[from - 1] * power[to - from + 1];
	if(hash1 < 0) hash1 += MODULE;
	int fromr = br - from - 1, tor = br - to - 1;
	int hash2 = hashrev[fromr];
	if(tor > 0) hash2 -= hashrev[tor - 1] * power[fromr - tor + 1];
	if(hash2 < 0) hash2 += MODULE;
	return hash1 == hash2;
}
int main(){
	cin.tie(0); ios::sync_with_stdio(false);
	int cur = 1;
	for(int i = 0; i < MAXN; ++i){
		power[i] = cur; cur *= 26; cur %= MODULE;
	}
	cin >> br >> input; rev = input;
	reverse(rev.begin(), rev.end());
	cur = 0;
	for(int i = 0; i < br; ++i){
		cur *= 26; cur += (input[i] - 'a');
		cur %= MODULE; hass[i] = cur;
	}
	cur = 0;
	for(int i = 0; i < br; ++i){
		cur *= 26; cur += (rev[i] - 'a');
		cur %= MODULE; hashrev[i] = cur;
	}
	for(int i = 0; i < br; ++i){
		for(int z = i; z < br; ++z){
			bool b = check(i, z);
			if(b) palin.insert({i, z});
		}
	}
	int result = 0;
    for(int i = 0; i < br; ++i){
        for(int z = i + 1; z < br; z += 2){
            int interval = z - i + 1;
            int onef = i, onet = i + (interval / 2) - 1;
            int twof = onet + 1, twot = z;
            if(palin.find({onef, onet}) != palin.end() && palin.find({twof, twot}) != palin.end()) result++;
        }
    }
    cout << result << endl;
	return 0;
}
