#include<bits/stdc++.h>
#define int long long
#define x first
#define y second

typedef long long ll;
typedef long double ld;

using namespace std;

int x = 1000, mod = 1e9;

vector<int> count_hah(string s){
    int n = s.size();
    vector<int> ans(n + 1, 0);
    for(int i = 1; i <= n;i++){
        ans[i] = (ans[i - 1] * x + s[i - 1]) % mod;
    }
    return ans;
}

int get_hah(int l, int r, vector<int> &hah, vector<int> &cnt){
    return (hah[r] - hah[l - 1] * cnt[r - l  + 1] % mod + mod) % mod;
}

bool is_Pal(int l, int r, vector<int> &hah, vector<int> &hahr, vector<int> &cnt){
    int n = hah.size();
    //cout << l << ' ' << r << ' ' << get_hah(l, r, hah, cnt) <<  ' ' << get_hah(n - r - 2, n - l - 2, hahr, cnt) << endl;
    return get_hah(l, r, hah, cnt) == get_hah(n - r, n - l, hahr, cnt);
}

bool is_dPal(int l, int r, vector<int> &hah, vector<int> &hahr, vector<int> &cnt){
    int m = (l + r) / 2;
    return is_Pal(l,m, hah, hahr, cnt) && is_Pal(m + 1, r, hah, hahr, cnt);
}

void solve(){
    int n;
    cin >> n;
    string s;
    cin >> s;
    int ans = 0;
    vector<int> cnt(n + 1, 1);
    for(int i = 1; i <= n; i++){
        cnt[i] = cnt[i - 1] * x % mod;
    }
    vector<int> hah = count_hah(s);
    //cout << hah[1];
    reverse(s.begin(), s.end());
    vector<int> hahr = count_hah(s);
    //cout << hahr[3] << endl;
    for(int i = 0; i < n; i++){
        for(int j = i; j < n; j++){
            if((j - i + 1) % 2 == 1){
                continue;
            }
            ans += is_dPal(i + 1, j + 1, hah, hahr, cnt);
            if(is_dPal(i + 1, j + 1, hah, hahr, cnt)){
                //cout << i << ' ' << j << endl;
            }
        }
    }
    cout << ans << endl;
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    //freopen("r", "input.txt", stdin);
    //freopen("w", "output.txt", stdout);
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}
