#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <unordered_set>
#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define int long long
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;
const int N = 1000001;
const ll mod = 111111113;
const ll pp = 31;

ll bp(ll x, ll st) {
	if (st == 0) return 1;
	if (st == 1) return x;
	ll xx = bp(x, st >> 1ll);
	xx *= xx;
	xx %= mod;
	return xx * bp(x, st & 1ll) % mod;
}
ll ps[N];

void seth(string str, vll &hs) {
	int n = str.size();
	for (int i = 0; i < n; ++i) hs[i + 1] = (hs[i] * pp + str[i] - 'a' + 1) % mod;

}
ll gt(int l, int r, vll &hs) {
	if (l > r) return 0;
	++r;
	return (((hs[r] - (hs[l] * ps[r - l])) % mod) + mod) % mod;
}
ll d1[N];
ll d2[N];
vector<ll> v1[2];
vector<ll> v2[2];
vi mn[2][N];
vi pl[2][N];
ll f[N];
ll cnt = 0;
void add(int i) {
	i += 500001;
	for (; i < N; i += i & -i) f[i]++;
	++cnt;
}
void del(int i) {
	i += 500001;
	for (; i < N; i += i & -i) f[i]--;
	--cnt;
}

ll gt(int i) {
	i += 500000;
	int sm = 0;
	for (; i > 0; i -= i & -i) sm += f[i];
	return cnt - sm;
}
ll cc = 0;
void ff(vi vec, int f) {
	for (int i = 0; i < vec.size(); ++i) {
		add(vec[i]);
		for (auto it : pl[f][i]) cc += gt(it);
		for (auto it : mn[f][i]) cc -= gt(it);
	}
	for (int i = 0; i < vec.size(); ++i) {
		del(vec[i]);
	}
}
void solve() {
	int n; cin >> n;
	string str; cin >> str;
	vll h1(N); seth(str, h1);
	reverse(all(str));
	vll h2(N); seth(str, h2);
	reverse(all(str));
	for (int i = 0; i < n; ++i) {
		int l = 1; int r = min(n - i, i + 1) + 1;
		while (l + 1 < r) {
			int mid = l + r >> 1;
			if (gt(i - mid + 1, i + mid - 1, h1) == gt(n - i - 1 - mid + 1, n - i - 1 + mid - 1, h2)) l = mid;
			else r = mid;
		}
		d1[i] = l;
	}
	for (int i = 0; i < n - 1; ++i) {
		int l = 0; int r = min(n - i - 1, i + 1) + 1;
		while (l + 1 < r) {
			int mid = l + r >> 1;
			if (gt(i - mid + 1, i + mid, h1) == gt(n - i - 2 - mid + 1, n - i - 2 + mid, h2)) l = mid;
			else r = mid;
		}
		d2[i] = l;
	}
	for (int i = 0; i < n; ++i)
		v1[i % 2].push_back(d1[i] - (i / 2));
	for (int i = 0; i < n - 1; ++i)
		v2[i % 2].push_back(d2[i] - (i / 2));

	for (int i = 0; i < n; i += 2) {
		int l = (i - 1) / 2;
		if (i == 0) l = -1;
		int r = min((i + 2 * d1[i] - 1) / 2 + 1, (ll)v1[i + 1 & 1].size());
		if (l >= 0) mn[1][l].push_back(-l);
		pl[1][r - 1].push_back(-l);
	}
	ff(v1[1], 1);
	for (int i = 1; i < n; i += 2) {
		int l = (i - 1) / 2;
		if (i == 0) l = -1;
		int r = min((i + 2 * d1[i] - 1) / 2 + 1, (ll)v1[i + 1 & 1].size());
		if (l >= 0) mn[0][l].push_back(-l);
		pl[0][r - 1].push_back(-l);
	}
	ff(v1[0], 0);

	fill(pl[0], pl[0] + N, vi());
	fill(pl[1], pl[1] + N, vi());
	fill(mn[0], mn[0] + N, vi());
	fill(mn[1], mn[1] + N, vi());

	for (int i = 0; i < n - 1; i += 2) {
		int l = i / 2;
		int r = min((i + 2 * d2[i]) / 2 + 1, (ll)v2[i & 1].size());
		if (l >= 0) mn[0][l].push_back(-l);
		pl[0][r - 1].push_back(-l);
	}
	ff(v2[0], 0);
	for (int i = 1; i < n - 1; i += 2) {
		int l = i / 2;
		int r = min((i + 2 * d2[i]) / 2 + 1, (ll)v2[i & 1].size());
		if (l >= 0) mn[1][l].push_back(-l);
		pl[1][r - 1].push_back(-l);
	}
	ff(v2[1], 1);

	
	cout << cc;
}
void pre_calc() {
	ps[0] = 1;
	for (int i = 1; i < N; ++i) {
		ps[i] = ps[i - 1] * pp % mod;
	}
}
bool check(int x) {
	for (int i = 2; i * i <= x; ++i) if (x % i) continue;
	else return false;
	return true;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	pre_calc();
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);


	solve();
	
}