#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

string s;
int n;
int k = 0;
vector<unsigned long long> step, has;

bool pruvv(int l, int len) {
	if (len == 1)return true;
	int l1, r1, l2, r2;
	if (len % 2 == 0) {
		l1 = l;
		r1 = l + len / 2 - 1;
		l2 = l + len / 2;
		r2 = l + len - 1;
	}
	else {
		l1 = l;
		r1 = l + len / 2 - 1;
		l2 = l + len / 2 + 1;
		r2 = l + len - 1;
	}
	//cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << endl;
	l1--;
	l2--;
	unsigned long long h1, h2;
	if (l1 >= 0) {
		h1 = (has[r1] - has[l1]);
	}
	else {
		h1 = has[r1];
	}
	if (l2 >= 0) {
		h2 = (has[r2] - has[l2]);
	}
	else {
		h2 = has[r2];
	}
	h2 *= step[l1 + 1];
	h1 *= step[l2 + 1];	
	return h1==h2;
}

bool pruv(int l, int len) {
	//s[l..l+len-1] = s[l+len.. l+2*len-1]
	for (int i = 0; 2 * i < len; i++) {
		if (s[l + i] != s[l + len - 1 - i])return false;
	}
	return true;
}

int main() {
	cin >> n;
	unsigned long long st = 1;
	for (int i = 0; i < n; i++) {
		step.push_back(st);
		has.push_back(0);
		st *= 2;
	}
	cin >> s;

	has[0] = (s[0] - 'a' + 2);
	//cout << has[0] << endl;
	for (int i = 1; i < n; i++) {
		has[i] = has[i - 1] + step[i] * (long long)(s[i] - 'a' + 2);
		//cout << has[i] << endl;
	}

	for (int b = 0; b < n; b++) {
		for (int len = 1; b + len + len - 1 < n; len++) {
			if (pruvv(b, len) && pruvv(b + len, len))k++;
			//if (pruv(b, len) && pruv(b + len, len))k++;
		}
	}
	cout << k;
} 