#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <queue>
#include <stack>
#include <deque>
#include <list>
#include <vector>
#include <string>


using namespace std;

typedef long long ll;
mt19937 ran(time(0));

const ll mod = 1000000009;
const ll inf = 2e18;
ll n;
string s;
vector<ll>even, odd;
ll b = 31;
vector<ll>pr, pr_r;
vector<ll>po;

ll get_hash(ll l, ll r) {
    return (pr[r] - (pr[l - 1] * po[r - l + 1]) % mod + mod) % mod;
}
ll get_hash_r(ll l, ll r) {
    return (pr_r[l] - (pr_r[r + 1] * po[r - l + 1]) % mod + mod) % mod;
}

ll p = 1;
vector<ll>t;

void upd(ll u, ll ind, ll tl, ll tr) {
    if (tr - tl == 1) {
        t[u] = 1;
        return;
    }
    ll mid = (tl + tr) / 2;
    if (ind >= mid)upd(u * 2 + 2, ind, mid, tr);
    else upd(u * 2 + 1, ind, tl, mid);
    t[u] = t[u * 2 + 1] + t[u * 2 + 2];
}

ll get_sum(ll u, ll l, ll r, ll tl, ll tr) {
    if (l >= tr || r <= tl)return 0;
    if (l == tl && r == tr)return t[u];
    ll mid = (tl + tr) / 2;
    return get_sum(u * 2 + 1, l, min(r, mid), tl, mid) + get_sum(u * 2 + 2, max(mid, l), r, mid, tr);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> s;
    odd.resize(n, 1);
    even.resize(n, 0);
    pr.resize(n + 1, 0);
    pr_r.resize(n + 2, 0);
    po.resize(n + 1);
    po[0] = 1;
    p = 1;
    while (p < n)p *= 2;
    for (ll i = 1; i < n; i++) {
        po[i] = po[i - 1] * b;
        if (po[i] >= mod)po[i] %= mod;
    }
    for (ll i = 1; i <= n; i++) {
        pr[i] = pr[i - 1] * b + s[i - 1] - 'a' + 1;
        if (pr[i] >= mod) {
            pr[i] %= mod;
        }
    }
    for (ll i = n; i >= 1; i--) {
        pr_r[i] = pr_r[i + 1] * b + s[i - 1] - 'a' + 1;
        if (pr_r[i] >= mod) {
            pr_r[i] %= mod;
        }
    }
    ll l, r, mid, last;
    for (ll i = 0; i < n; i++) {
        l = 0;
        r = min(n - i - 1, i);
        last = 1;
        while (l <= r) {
            mid = (l + r) / 2;
            if (get_hash(i + 1, i + 1 + mid) == get_hash_r(i + 1 - mid, i + 1)) {
                last = mid * 2 + 1;
                l = mid + 1;
            }
            else {
                r = mid - 1;
            }
        }
        odd[i] = last;
    }
    for (ll i = 0; i < n; i++) {
        l = 0;
        r = min(i, n - i - 2);
        last = 0;
        while (l <= r) {
            mid = (l + r) / 2;
            if (get_hash(i + 2, i + 2 + mid) == get_hash_r(i + 1 - mid, i + 1)) {
                last = (mid + 1) * 2;
                l = mid + 1;
            }
            else {
                r = mid - 1;
            }
        }
        even[i] = last;
    }
    vector<ll>a(n), b(n);
    ll ans = 0;
    set<pair<ll, ll>>st;
    for (ll i = 1; i < n; i += 2) {
        a[i] = odd[i] - i;
        st.insert({ a[i], i });
    }
    t.resize(p * 2, 0);
    for (ll i = 0; i < n; i += 2) {
        while (!st.empty() && (--st.end())->first >= -i) {
            upd(0, (--st.end())->second, 0, p);
            st.erase(--st.end());
        }
        ans += get_sum(0, i + 1, min(n, i + 1 + odd[i]), 0, p);
    }
    t.clear();
    t.resize(p * 2, 0);
    st.clear();
    for (ll i = 2; i < n; i += 2) {
        a[i] = odd[i] - i + 1;
        st.insert({ a[i], i });
    }
    for (ll i = 1; i < n; i += 2) {
        while (!st.empty() && (--st.end())->first >= -i + 1) {
            upd(0, (--st.end())->second, 0, p);
            st.erase(--st.end());
        }
        ans += get_sum(0, i + 1, min(n, i + 1 + odd[i]), 0, p);
    }
    t.clear();
    t.resize(p * 2, 0);
    st.clear();
    for (ll i = 2; i < n; i += 2) {
        b[i] = even[i] - i;
        if (even[i] != 0) {
            st.insert({ b[i], i });
        }
    }
    for (ll i = 0; i < n; i += 2) {
        while (!st.empty() && (--st.end())->first >= -i) {
            upd(0, (--st.end())->second, 0, p);
            st.erase(--st.end());
        }
        ans += get_sum(0, min(n, i + 1), min(n, i + 1 + even[i]), 0, p);
    }
    t.clear();
    t.resize(p * 2, 0);
    st.clear();
    for (ll i = 3; i < n; i += 2) {
        b[i] = even[i] - i + 1;
        if (even[i] != 0) {
            st.insert({ b[i], i });
        }
    }
    for (ll i = 1; i < n; i += 2) {
        while (!st.empty() && (--st.end())->first >= -i + 1) {
            upd(0, (--st.end())->second, 0, p);
            st.erase(--st.end());
        }
        ans += get_sum(0, min(n, i + 1), min(n, i + 1 + even[i]), 0, p);
    }
    cout << ans;
    return 0;
}