#include <bits/stdc++.h>

#include <ext\pb_ds\assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct pt
{
    int r, num, sg, val;
};

bool cmp(pt a, pt b)
{
    return a.r < b.r;
}

const int INF = 1e9 + 79;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < s.size(); ++i)
    {
        a[i] = 1;
        while (i - a[i] >= 0 && i + a[i] < s.size() && s[i - a[i]] == s[i + a[i]])
        {
            ++a[i];
        }
        b[i] = 0;
        while (i - b[i] >= 0 && i + b[i] + 1 < s.size() && s[i - b[i]] == s[i + b[i] + 1])
        {
            ++b[i];
        }
    }
    vector<pt> q;
    vector<int> ans(n);
    for (int i = 0; i < n; ++i)
    {
        pt nw;
        nw.r = i;
        nw.num = i;
        nw.sg = 1;
        nw.val = 2 + (i - 1);
        q.push_back(nw);
        pt cr;
        cr.r = i - a[i] * 2;
        cr.num = i;
        cr.sg = -1;
        cr.val = 2 + (i - 1);
        q.push_back(cr);
    }
    sort(q.begin(), q.end(), cmp);
    ordered_set odd;
    ordered_set even;
    int j = 0;
    for (int i = 0; i < n; ++i)
    {
        while (j < q.size() && q[j].r <= i)
        {
            if (q[j].r % 2 == 0)
            {
                ans[q[j].num] += q[j].sg * (odd.size() - odd.order_of_key({q[j].val, -1}));
            }
            else
            {
                ans[q[j].num] += q[j].sg * (even.size() - even.order_of_key({q[j].val, -1}));
            }
            ++j;
        }
        if (i % 2 == 0)
        {
            even.insert({2 * a[i] + i, i});
        }
        else
        {
            odd.insert({2 * a[i] + i, i});
        }
    }
    int res = 0;
    for (int i = 0; i < n; ++i)
    {
        res += ans[i];
    }

    q = {};
    vector<int> ans2(n);
    for (int i = 0; i < n; ++i)
    {
        pt nw;
        nw.r = i;
        nw.num = i;
        nw.sg = 1;
        nw.val = 2 + (i - 2);
        q.push_back(nw);
        pt cr;
        cr.r = i - b[i] * 2;
        cr.num = i;
        cr.sg = -1;
        cr.val = 2 + (i - 2);
        q.push_back(cr);
    }
    sort(q.begin(), q.end(), cmp);
    ordered_set odd2;
    ordered_set even2;
    j = 0;
    for (int i = 0; i < n; ++i)
    {
        while (j < q.size() && q[j].r <= i)
        {
            if (q[j].r % 2 == 0)
            {
                ans2[q[j].num] += q[j].sg * (even2.size() - even2.order_of_key({q[j].val, -1}));
            }
            else
            {
                ans2[q[j].num] += q[j].sg * (odd2.size() - odd2.order_of_key({q[j].val, -1}));
            }
            ++j;
        }
        if (i % 2 == 0)
        {
            even2.insert({2 * b[i] + i, i});
        }
        else
        {
            odd2.insert({2 * b[i] + i, i});
        }
    }
    for (int i = 0; i < n; ++i)
    {
        res += ans2[i];
    }

    cout << res << endl;
    return 0;
}

