#include <bits/stdc++.h>
#define int long long
#define endl '\n'
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
using namespace std;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}

string htag(string s){
    string res;
    for (auto i : s){
        res += '#';
        res += i;
    }
    res += '#';
    return res;
}

vector<int> manac(string s) {
    vector<int> a(len(s));
    for (int i = 0; i < len(s); ++i) {
        while (i - a[i] - 1 >= 0 && i + a[i] + 1 < len(s) && s[i - a[i] - 1] == s[i + a[i] + 1])
            ++a[i];
    }
    return a;
}


int cnt(int n){
    return n * (n + 1) / 2;
}


int solve_od(vector<int> a){
    forn (i, len(a)) a[i] = a[i] * 2 - 1;
    int ans = 0;
    for (int i = 0; i < len(a); ++i){
        for (int j = i + 1; j < len(a); ++j){
            if (i % 2 != j % 2){
                if (a[i] >= j - i && a[j] >= j - i) {
                    ans++;
                }
            }
        }
    }

    return ans;
}


int solve_ev(vector<int> a){
    int ans = 0;
    forn (i, len(a)) a[i] *= 2;


    for (int i = 0; i < len(a); ++i){
        for (int j = i + 1; j < a[i] - i + 1; ++j){
            if (i % 2 == j % 2){
                if (a[j] >= j - i)
                    ans++;
            }
        }
    }

    return ans;
}


void solve(){
    int n; cin >> n;
    string s; cin >> s;
    s = htag(s);
    auto a = manac(s);

    vector<int> ev(n - 1);
    forn (i, len(ev)){
        ev[i] = a[i * 2 + 2] / 2;
    }
    vector<int> od(n);
    forn (i, len(od)) {
        od[i] = (a[i * 2 + 1] + 1) / 2;
    }
    int ans = solve_od(od) + solve_ev(ev);
    cout << ans << endl;
}
