#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#define endl '\n'
#define MODULE 1000000007
#define MAXN 1000006
typedef long long lon;
lon br; string input, rev;
lon power[MAXN], hass[MAXN], hashrev[MAXN];
set<pair<lon, lon> > palin;
bool check(lon from, lon to){
	lon hash1 = hass[to];
	if(from > 0) hash1 -= (hass[from - 1] * power[to - from + 1]) % MODULE;
	if(hash1 < 0) hash1 += MODULE;
	lon fromr = br - from - 1, tor = br - to - 1;
	lon hash2 = hashrev[fromr];
	if(tor > 0) hash2 -= (hashrev[tor - 1] * power[fromr - tor + 1]) % MODULE;
	if(hash2 < 0) hash2 += MODULE;
	return hash1 == hash2;
}
int main(){
	cin.tie(0); ios::sync_with_stdio(false);
	lon cur = 1;
	for(lon i = 0; i < MAXN; ++i){
		power[i] = cur; cur *= 26; cur %= MODULE;
	}
	cin >> br >> input; rev = input;
	reverse(rev.begin(), rev.end());
	cur = 0;
	for(lon i = 0; i < br; ++i){
		cur *= 26; cur += (input[i] - 'a');
		cur %= MODULE; hass[i] = cur;
	}
	cur = 0;
	for(lon i = 0; i < br; ++i){
		cur *= 26; cur += (rev[i] - 'a');
		cur %= MODULE; hashrev[i] = cur;
	}
	for(lon i = 0; i < br; ++i){
		for(lon z = i; z < br; ++z){
			bool b = check(i, z);
			if(b) palin.insert({i, z});
		}
	}
	lon result = 0;
    for(lon i = 0; i < br; ++i){
        for(lon z = i + 1; z < br; z += 2){
            lon interval = z - i + 1;
            lon onef = i, onet = i + (interval / 2) - 1;
            lon twof = onet + 1, twot = z;
            if(palin.find({onef, onet}) != palin.end() && palin.find({twof, twot}) != palin.end()) result++;
        }
    }
    cout << result << endl;
	return 0;
}
