#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    string s;
    cin >> n >> s;
    vector<char> tmp(n + n + 3);
    tmp[0] = '!';
    for (int i = 0; i < n; ++i) {
        tmp[i + i + 1] = '*';
        tmp[i + i + 2] = s[i];
    }
    tmp[n + n + 1] = '*';
    tmp[n + n + 2] = '#';
    vector<int> pole(n + n + 3);
    int L = 0, M = 0;
    for (int i = 2; i <= n + n; ++i) {
        if (i < M + L)
            pole[i] = min(M + L - i, pole[M + M - i]);
        while (tmp[i + pole[i]] == tmp[i - pole[i]])
            ++pole[i];
        --pole[i];
        if (i + pole[i] > L + M) {
            M = i;
            L = pole[i];
        }
    }
    int ans = 0;
    for (int mid = 1; mid < n + n + 3; mid += 2)
        for (int len = 1; len + len <= mid && mid + len + len < n + n + 3; ++len) {
            if (pole[mid - len] >= len && pole[mid + len] >= len) {
                ++ans;
            }
        }
    cout << ans << endl;
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
