#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;

void z_func(string &s, vector <ll> &z) {
    ll n = s.size();
    z.resize(n, 0);
    z[0] = 0;
    for (ll i = 1, l = 0, r = 1; i < n; ++i) {
        z[i] = min(max(r - i, 0LL), z[i - l]);
        while (s[z[i]] == s[i + z[i]] && i + z[i] < n) {
            ++z[i];
        }
        if (i + z[i] > r) {
            l = i;
            r = i + z[i];
        }
    }
}

void p(string &s, vector <ll> &pi) {
    ll n = s.size();
    pi.resize(n, 0LL);
    for (ll i = 1; i < n; ++i) {
        ll j = pi[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = pi[j - 1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        pi[i] = j;
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    string s;
    cin >> s;
    ll ans = 0;
    for (ll i = 1; i <= n / 2; ++i) {
        for (ll j = 0; j < n - 2 * i + 1; ++j) {
            bool ok = true;
            ll l = j, r = j + i - 1;
            while (r > l) {
                if (s[l] != s[r]) {
                    ok = false;
                    break;
                }
                ++l, --r;
            }
            ans += ok;
        }
    }
    cout << ans << endl;
    return 0;
}

/**
0 1 2 3 4
0 1 2 3
0 1 2
0 1
0

0 0 1 0 1 0
0 0 0 0 0
0 0 1 2
0 0 1
0 0
0

6
abacac

5
aaaaa

**/
