#include <iostream>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

map< pair<int, int>, bool> m;
int dp[MAXN + 5];
char ch[MAXN + 5];

bool palin(int i, int j)
{
    if (m.find({i, j}) != m.end()) return m[{i, j}];
    while (i <= j)
    {
        if (ch[i] != ch[j]) return m[{i, j}] = false;
        i++; j--;
    }
    return m[{i, j}] = true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> ch[i];
        dp[i] = dp[i - 1];
        for (int j = (i + 1) / 2 + 1; j <= i; ++ j)
        {
            if (palin(j, i) and palin(2 * j - i - 1, j - 1)) dp[i]++;
        }
    }

    cout << dp[n] << endl;

    return 0;
}
