#include <bits/stdc++.h>

#define int long long

using namespace std;

struct pt
{
    int r, num, sg, val;
};

bool cmp(pt a, pt b)
{
    return a.r < b.r;
}

const int MAXN = 1.5e6 + 25;
const int INF = 1e9 + 79;

int pr[MAXN];
int rpr[MAXN];
int p1[MAXN];

const int mod = 2e9 + 179;

const int p = 179;

int get_hash(int l, int r)
{
    int ans = pr[r] - pr[l] * p1[r - l];
    ans %= mod;
    if (ans < 0)
    {
        ans += mod;
    }
    return ans;
}

int n;

int get_rhash(int l1, int r1)
{
    int r = n - l1;
    int l = n - r1;
    int ans = rpr[r] - rpr[l] * p1[r - l];
    ans %= mod;
    if (ans < 0)
    {
        ans += mod;
    }
    return ans;
}

int t[MAXN];
int t2[MAXN];

int get1(int r)
{
    int ans = 0;
    for (int i = r; i > 0; i -= i & -i)
    {
        ans += t[i];
    }
    return ans;
}

void update1(int pos, int val)
{
    for (int i = pos; i < MAXN; i += i & -i)
    {
        t[i] += val;
    }
    return;
}

int get2(int r)
{
    r += 2;
    int ans = 0;
    for (int i = r; i > 0; i -= i & -i)
    {
        ans += t2[i];
    }
    return ans;
}

void update2(int pos, int val)
{
    pos += 2;
    for (int i = pos; i < MAXN; i += i & -i)
    {
        t2[i] += val;
    }
    return;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    string s;
    cin >> s;
    p1[0] = 1;
    for (int i = 1; i < MAXN; ++i)
    {
        p1[i] = (p1[i - 1] * p) % mod;
    }
    pr[0] = 0;
    rpr[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        pr[i + 1] = (pr[i] * p + s[i]) % mod;
    }
    for (int i = 0; i < n; ++i)
    {
        rpr[i + 1] = (rpr[i] * p + s[n - i - 1]) % mod;
    }
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < s.size(); ++i)
    {
        int l = 0;
        int r = n + 1;
        while (r - l > 1)
        {
            int med = (l + r) / 2;
            if (i - med < 0 || i + med + 1 > n)
            {
                r = med;
                continue;
            }
            if (get_hash(i - med, i) == get_rhash(i + 1, i + med + 1))
            {
                l = med;
            }
            else
            {
                r = med;
            }
        }
        a[i] = 1 + l;
        l = 0;
        r = n + 1;
        while (r - l > 1)
        {
            int med = (l + r) / 2;
            if (i - med + 1 < 0 || i + med + 1 > n)
            {
                r = med;
                continue;
            }
            if (get_hash(i - med + 1, i + 1) == get_rhash(i + 1, i + med + 1))
            {
                l = med;
            }
            else
            {
                r = med;
            }
        }
        b[i] = l;
    }
    vector<pt> q;
    vector<int> ans(n);
    for (int i = 0; i < n; ++i)
    {
        pt nw;
        nw.r = i;
        nw.num = i;
        nw.sg = 1;
        nw.val = 2 + (i - 1);
        q.push_back(nw);
        pt cr;
        cr.r = i - a[i] * 2;
        cr.num = i;
        cr.sg = -1;
        cr.val = 2 + (i - 1);
        q.push_back(cr);
    }
    sort(q.begin(), q.end(), cmp);
    int j = 0;
    int sz1 = 0;
    int sz2 = 0;
    for (int i = 0; i < n; ++i)
    {
        while (j < q.size() && q[j].r <= i)
        {
            if (q[j].r % 2 == 0)
            {
                ans[q[j].num] += q[j].sg * (sz1 - get1(q[j].val - 1));
            }
            else
            {
                ans[q[j].num] += q[j].sg * (sz2 - get2(q[j].val - 1));
            }
            ++j;
        }
        if (i % 2 == 0)
        {
            ++sz2;
            update2(2 * a[i] + i, 1);
        }
        else
        {
            ++sz1;
            update1(2 * a[i] + i, 1);
        }
    }
    for (int i = 0; i < MAXN; ++i)
    {
        t[i] = 0;
        t2[i] = 0;
    }
    int res = 0;
    for (int i = 0; i < n; ++i)
    {
        res += ans[i];
    }

    q = {};
    vector<int> ans2(n);
    for (int i = 0; i < n; ++i)
    {
        pt nw;
        nw.r = i;
        nw.num = i;
        nw.sg = 1;
        nw.val = 2 + (i - 2);
        q.push_back(nw);
        pt cr;
        cr.r = i - b[i] * 2;
        cr.num = i;
        cr.sg = -1;
        cr.val = 2 + (i - 2);
        q.push_back(cr);
    }
    sort(q.begin(), q.end(), cmp);
    j = 0;
    sz1 = 0;
    sz2 = 0;
    for (int i = 0; i < n; ++i)
    {
        while (j < q.size() && q[j].r <= i)
        {
            if (q[j].r % 2 == 0)
            {
                ans2[q[j].num] += q[j].sg * (sz2 - get2(q[j].val - 1));
            }
            else
            {
                ans2[q[j].num] += q[j].sg * (sz1 - get1(q[j].val - 1));
            }
            ++j;
        }
        if (i % 2 == 0)
        {
            ++sz2;
            update2(2 * a[i] + i, 1);
        }
        else
        {
            ++sz1;
            update1(2 * a[i] + i, 1);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        res += ans2[i];
    }

    cout << res << endl;
    return 0;
}

