#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

void build_z1(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i - 1, z[left - (i - left)]), (ll)0);
        while (i + z[i] < n && i - z[i] - 1 >= 0 && s[i - z[i] - 1] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

void build_z2(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i, z[left - (i - left)]), (ll)1);
        while (i + z[i] < n && i - z[i] >= 0 && s[i - z[i]] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

const int K = 708;
int M;
vector<int> arr;
vector<int> brr;

int get(int x){
    int ans = 0;
    for (int i = 0; i < M; i++)
        ans += K - (lower_bound(brr.begin() + i * K, brr.begin() + (i + 1) * K, x) - (brr.begin() + i * K));
    return ans;
}

void update(int pos, int x){
    arr[pos] = x;
    int POS = pos / K;
    copy(arr.begin() + POS * K, arr.begin() + (POS + 1) * K, brr.begin() + POS * K);
    sort(brr.begin() + POS * K, brr.begin() + K * (POS + 1));
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    M = (n + K - 1) / K;
    string s; cin >> s;

    vector<int> z1(n);
    vector<int> z2(n, 1);
    build_z1(s, z1);
    build_z2(s, z2);

    ll ans = 0;
    // even
    int add = 0;
    arr.resize(M * K, -1);
    brr = arr;
    for (int i = n - 3; i >= 0; i -= 2){
        update(i + 2, z1[i + 2] - 1 + add);
        if (z1[i])
            ans += min(get(add), z1[i]);
        add++;
    }
    //cout << ans << endl;
    arr.assign(M * K, -1);
    brr = arr;
    add = 0;
    for (int i = n - 4; i >= 0; i -= 2){
        update(i + 2, z1[i + 2] - 1 + add);
        if (z1[i])
            ans += min(get(add), z1[i]);
        add++;
    }
    //cout << ans << endl;
    arr.assign(M * K, -1);
    brr = arr;
    add = 0;
    for (int i = n - 2; i >= 0; i -= 2){
        update(i + 1, z2[i + 1] - 1 + add);
        if (z2[i])
            ans += min(get(add), z2[i]);
        //cout << i << " " << ans << endl;
        add++;
    }
    //cout << ans << endl;
    arr.assign(M * K, -1);
    brr = arr;
    add = 0;
    for (int i = n - 3; i >= 0; i -= 2){
        update(i + 1, z2[i + 1] - 1 + add);

        if (z2[i])
            ans += min(get(add), z2[i]);
        //cout << i << " " << ans << endl;
        add++;
    }
    cout << ans;
    return 0;
}