#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;

const ll N = 5e5 + 8;
const ll M = (ll)1e9 + 7;

mt19937_64 rnd(time(0));

ll myrnd(ll l, ll r) {
    return (rnd() % (r - l + 1)) + l;
}

ll p = 7757, rp;
vector <ll> power = {1LL};
vector <ll> rpower = {1LL};
vector <ll> code;

ll sum(ll a, ll b) {
    return (a + b) % M;
}

ll mul(ll a, ll b) {
    return (a * b) % M;
}

ll sub(ll a, ll b) {
    return (a - b + M + M) % M;
}

ll binpow(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
            res %= M;
        }
        a *= a;
        a %= M;
        n >>= 1;
    }
    return res;
}

void start() {
    unordered_set <ll> s;
    while (s.size() < 26) {
        s.insert(myrnd(1e2, 1e3));
    }
    for (ll i : s) {
        code.push_back(i);
    }
    for (ll i = 0; i < N; ++i) {
        power.push_back(mul(power.back(), p));
    }
    rp = binpow(p, M - 2);
    for (ll i = 0; i < N; ++i) {
        rpower.push_back(mul(rpower.back(), rp));
    }
}

void cnt(string s, vector <ll> &h) {
    ll n = s.size();
    h.resize(n);
    for (ll i = 0; i < n; ++i) {
        s[i] -= 'a';
    }
    h[0] = code[s[0]];
    for (ll i = 1; i < n; ++i) {
        h[i] = mul(h[i - 1], p);
        h[i] = sum(h[i], code[s[i]]);
    }
}

ll get_hash(ll l, ll r, vector <ll> &h) {
    if (l == 0) {
        return h[r];
    }
    ll res = sub(h[r], mul(h[l - 1], power[r - (l - 1)]));
    return res;
}

vector <ll> hs, rhs;

bool pal(ll l, ll r) {
    ll ll = n - l + 1, rr = n - r + 1;
    return (get_hash(l, (r + l) / 2, hs) == get_hash((r + l) / 2 + 1, r, rhs));
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    start();
    ll n;
    string s, rs;
    cin >> n;
    cin >> rs;
    s = rs;
    reverse(rs.begin(), rs.end());
    cnt(s, hs);
    cnt(rs, rhs);

    ans += n - 1;

    for (ll i = 4; i <= n; i += 2) {
        ll t = i / 2;
        for (ll j = 0; j < n - i + 1; ++j) {
            //
            string a = s.substr(j, t);
            string b = s.substr(j + t, t);
            if (pal(j, j + t) && pal(j + t, t)) {
                ++ans;
            }
        }
    }
    return 0;
}

/**
3
aba

**/
