#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

void solve() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    ll bal = 0;
    ll len = 0;
    ll ans = 0;
    forEach(s) {
        if (it == '(') bal++;
        else if (it == ')') bal--;
        else assert(false);
        if (bal < 0) {
            len++;
        } else if (bal == 0 && len) {
            ans += len + 1;
            len = 0;
        }
    }
    if (len) ans += len;
    if (bal != 0) {
        cout << "-1\n";
    } else {
        cout << ans << "\n";
    }
}

int main() {
    FASTIO
    solve();
    return 0;
}