#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T, class U> using ordered_map = tree<T, U, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> balance(n);
    for (int i = 0; i < n; i++) {
        balance[i] = (i > 0 ? balance[i - 1] : 0) + (s[i] == ')' ? -1 : 1);
    }
    if (balance.back()) {
        cout << -1;
    } else {
        int prev = -1, ans = 0;
        for (int i = 0; i < n; i++) {
            if (balance[i] == 0) {
                if (prev != -1) {
                    ans += i - prev + 1;
                }
                prev = -1;
            } else if (balance[i] < 0) {
                if (prev == -1) {
                    prev = i;
                }
            }
        }
        cout << ans;
    }
    return 0;
}