#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0); 
}

//#define int ll

inline void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int bal = 0;
	bool is_bad = 0;
	int ans = 0, len = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '(') {
			bal++;
		}
		else {
			bal--;
		}
		len++;
		if (bal < 0) {
			is_bad = 1;
		}
		if (bal == 0) {
			if (is_bad) {
				ans += len;
			}
			is_bad = 0;
			len = 0;
		}
	}
	if (bal == 0) {
		cout << ans;
	}
	else {
		cout << -1;
	}
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}