#include <iostream>
#include <random>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

int main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

void run() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int bal = 0;
    for (int i = 0; i < n; i++) {
        bal += s[i] == '(' ? 1 : -1;
    }
    if (bal != 0) {
        cout << -1;
        return;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        bal += s[i] == '(' ? 1 : -1;
        if (bal >= 0) {
            continue;
        }
        int cur = bal;
        int p = i + 1;
        for ( ; p < n && cur != 0; p++) {
            cur += s[p] == '(' ? 1 : -1;
        }
        bal = 0;
        ans += p - i;
        i = p - 1;
    }
    cout << ans << endl;
}
/*
8
))((())(
*/