#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 1000006;
int n;
string s;
int bal[maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> s;
    bal[0] = 0;
    for (int i = 1; i <= n; ++i)
    {
        bal[i] = bal[i - 1] + (s[i - 1] == '(' ? 1 : -1);
    }
    if (bal[n] != 0)
    {
        cout << "-1\n";
        exit(0);
    }
    int cur = 0;
    int ans = 0;
    for (int i = 0; i <= n; ++i)
    {
        if (bal[i] < 0)
        {
            ++cur;
        }
        else
        {
            if (cur > 0)
                ans += cur + 1;
            cur = 0;
        }
    }
    if (cur > 0)
        ans += cur + 1;
    cout << ans << '\n';

    return 0;
}

