#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 2e5;

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int ans = 0;
	int idx = -1;
	int bal = 0;
	for (int i = 0; i < n; ++i) {
		bal += (s[i] == '(') - (s[i] == ')');
		if (bal < 0 && idx == -1) {
			idx = i;
		}
		if (bal == 0 && idx != -1) {
			ans += i - idx + 1;
			idx = -1;
		}
	}
	if (bal == 0) {
		cout << ans << "\n";
	} else {
		cout << "-1\n";
	}
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 2;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}