#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

//#define int ll

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define sz(a) (int)a.size()

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<double> vd;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int INF = 1e9;
const ll INFLL = 1e18;
const int M = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;
    string s;
    cin >> s;

    vpii evs;
    stack<pii> st;
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        bool op = (s[i] == '(');
        bal += 1 - 2 * (!op);
        if (!op && !st.empty() && st.top().F) {
            st.pop();
        } else if (op && !st.empty() && !st.top().F) {
            evs.eb(st.top().S, -1);
            evs.eb(i, 1);
            st.pop();
        } else {
            st.push({op, i});
        }
    }
    if (bal != 0) {
        cout << "-1\n";
        return 0;
    }

    sort(ALL(evs));
    int cnt = 0, p = 0;
    int ans = 0;
    for (pii ev : evs) {
        if (cnt == 0)
            p = ev.F;
        cnt -= ev.S;
        if (cnt == 0)
            ans += ev.F - p + 1;
    }

    cout << ans << "\n";
}