#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

int main() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int open = 0;
	int close = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '(')
			open++;
		else
			close++;
	}
	if (open != close) {
		cout << -1 << endl;
		return 0;
	}
	int ans = 0;
	int bal = 0;
	int L = 0, R = 0;
	vector<pair<int, int> > all;
	for (int i = 0; i < n; i++) {
		if (s[i] == '(')
			bal++;
		else
			bal--;
		if (bal == 0) {
			all.push_back({ L, i });
			L = i + 1;
		}
	}
	for (auto elem : all) {
		L = elem.first;
		R = elem.second;
		bal = 0;
		while (L <= R) {
			if (s[L] == '(')
				bal++;
			else
				bal--;
			if (bal < 0)
				break;
			L++;
		}
		bal = 0;
		while (R >= L) {
			if (s[R] == ')')
				bal++;
			else
				bal--;
			if (bal < 0)
				break;
			R--;
		}
		if (R < L)
			continue;
		ans += R - L + 1;
	}
	cout << ans << endl;
}
//*/