#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    int n, ans = 0;
    string s;
    cin >> n >> s;

    int le = -1, bal1 = 0, bal2 = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '(') {
            bal1++;
            if (bal2 >= 0)
                bal2++;
        }
        else {
            bal1--;
            bal2--;
        }

        if (bal1 == 0) {
            if (bal2 != 0)
                ans += i - le;
            le = i;
            bal1 = bal2 = 0;
        }
    }

    if (bal1 != 0 || bal2 != 0)
        cout << -1;
    else
        cout << ans;

    return 0;
}
