#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXN = 2e5 * 4 + 1;
int tree[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }
    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void change(int v, int cl, int cr, int ind, int val)
{
    if (cl > ind || cr < ind)
        return;
    if (cl == cr)
    {
        tree[v] = val;
        return;
    }
    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, ind, val);
    change(2 * v + 1, cm + 1, cr, ind, val);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int cl, int cr, int l, int r)
{
    if (cl >= l && cr <= r)
        return tree[v];
    if (cl > r || l > cr)
        return 0;
    int cm = (cl + cr) / 2;
    return query(2 * v, cl, cm, l, r) + query(2 * v + 1, cm + 1, cr, l, r);
}

signed main()
{
    hello();

    int n;
    cin >> n;
    string s;
    cin >> s;
    int check = 0;
    for (int i = 0; i < n; ++i)
        if (s[i] == '(')
            ++check;
    if (check * 2 != n)
    {
        cout << -1 << endl;
        return 0;
    }

    check = 0;
    int last = -1;
    int res = 0;
    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '(')
            ++check;
        else
            --check;
        if (last == -1 && check < 0)
            last = i;
        if (check == 0 && last != -1)
        {
            res += i - last + 1;
            last = -1;
        }
    }

    cout << res << endl;
}
