#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair < int, int > pii;
#define sz(x) int(x.size())
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 2;
const int MOD = 1e9 + 7;
const int N = 1e5 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    string s;
    int n, b = 0;
    vector < char > a;

    cin >> n >> s;

    if (n % 2 || count(s.begin(), s.end(), '(') != count(s.begin(), s.end(), ')')) {
        return cout << "-1", 0;
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '(') {
            a.push_back('(');
            b++;
        }
        else {
            if (!a.empty() && a.back() == '(') {
                a.pop_back();
            }
            else {
                a.push_back(')');
            }
            b--;
        }
        if (b == 0) {
            //cout << i << " " << sz(a) << endl;
            ans += sz(a);
            a.clear();
        }
    }

    cout << ans << endl;

    return 0;
}
