#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    string s;
    cin >> n >> s;

    int bal = 0;
    int fix_from = -1;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (bal == 0)
        {
            if (fix_from != -1)
            {
                ans += i - fix_from;
                fix_from = -1;
            }

            if (s[i] == ')')
                fix_from = i;
        }

        if (s[i] == '(')
            bal++;
        else
            bal--;
    }

    if (bal != 0)
        cout << "-1" << endl;
    else
    {
        if (fix_from != -1)
            ans += n - fix_from;

        cout << ans << endl;
    }

    return 0;
}