#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = (int)1e6 + 7;
string S;
int a[MAXN], n, cntOpen = 0, cntClose = 0;
ll answ = 0;
void solve() {
	cin >> n >> S;
	for(int i = 0; i < n; ++i) {
		if(S[i] == '(') {
			a[i] = +1;
			++cntOpen;
		} else {
			a[i] = -1;
			++cntClose;
		}
	}
	if(cntOpen != cntClose) {
		cout << "-1\n";
		return;
	}
	int bal = 0;
	int pos = 0;
	while(pos < n) {
		bal += a[pos];
		++pos;
		if(bal < 0) ++answ;
		while(bal < 0) {
			bal += a[pos];
			++pos;
			++answ;
		}
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	solve();
	return 0;
}
