#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

bool check(int l, int r, vector<int> &arr) {
    int sm = 0;
    for (int i = l; i <= r; i++) {
        sm += arr[i];
        if (sm < 0) {
            return false;
        }
    }
    return sm == 0;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    string s;
    cin >> n >> s;
    vector<int> arr(n + 1);
    for (int i = 1; i <= n; i++) {
        if (s[i - 1] == '(') {
            arr[i] = 1;
        } else {
            arr[i] = -1;
        }
    }
    vector<int> dp(n + 1, -1);
    dp[0] = 0;
    int sm = 0;
    for (int i = 1; i <= n; i++) {
        sm += arr[i];
        if (sm != 0) {
            continue;
        }
        dp[i] = i;
        for (int j = 0; j < i; j++) {
            if (dp[j] != -1 && check(j + 1, i, arr)) {
                dp[i] = min(dp[i], dp[j]);
            } else if (dp[j] != -1) {
                dp[i] = min(dp[i], dp[j] + (i - j));
            }
        }
    }
    cout << dp[n] << endl;
}