#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
//#define int long long
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n,0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n;
	cin >> n;
	string s;
	cin >> s;
	deque<int> close, open;
	int ans = 0, L = -1, bal = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == ')') {
			if (!open.empty()) {
				open.pop_back();
				continue;
			}
			if (close.empty()) {
				L = i;
				bal = 0;
			}
			bal--;
			close.push_back(i);
		}
		else {
			if (close.empty()) {
				open.push_back(i);
			}
			bal++;
			if (bal == 0) {
				ans += i - L + 1;
				close.clear();
			}
		}
	}
	if (close.empty() && open.empty()) {
		cout << ans;
		return 0;
	}
	cout << -1;
}