#include <bits/stdc++.h>

using namespace std;

#define DEBUGs

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> pref_op(n + 1), pref_close(n + 1);
    for (int i = 0; i < n; ++i) {
        pref_op[i + 1] = pref_op[i] + (s[i] == '(');
        pref_close[i + 1] = pref_close[i] + (s[i] == ')');
    }
    if (pref_op.back() != pref_close.back()) {
        cout << "-1\n";
        return;
    }
    vector<vector<int>> dp(n, vector<int> (n + 1, INF));
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            if (pref_op[r] - pref_op[l] != pref_close[r] - pref_close[l])
                continue;
            int tmp = 1;
            int bal = 0;
            for (int i = l; i < r; ++i) {
                if (s[i] == '(')
                    ++bal;
                else
                    --bal;
                if (bal < 0)
                    tmp = 0;
            }
            dp[l][r] = (1 - tmp) * (r - l);
            for (int mid = l + 2; mid < r; ++mid)
                dp[l][r] = min(dp[l][r], dp[l][mid] + dp[mid][r]);
        }
    }
    cout << dp[0][n] << '\n';

}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

