#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
#define fst first
#define snd second
#define sz(X) (int)(X.size())
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    stack<int> st;
    vi wr1, wr2;
    forn(i, n) {
        if (s[i] == '(') st.push(i);
        else {
            if (!st.empty() && st.top() == i-1) st.pop();
            else wr2.pb(i);
        }
    }
    while (!st.empty()) wr1.pb(st.top()), st.pop();
    if (sz(wr1) != sz(wr2)) {
        cout << "-1\n";
        return 0;
    }
    sort(all(wr1)), sort(all(wr2));
    vector<pii> segm;
    int m = sz(wr1);
    vector<pii> ev;
    forn(i, m) {
        segm.pb({wr1[i], wr2[i]});
        if (segm[i].fst > segm[i].snd) swap(segm[i].fst, segm[i].snd);
        ev.pb({segm[i].fst, 0});
        ev.pb({segm[i].snd, 1});
    }
    int ans = 0;
    int bal = 0;
    int l = 1e6, r = -1;
    sort(all(ev));
    for (const pii &e: ev) {
        if (e.snd == 0) {
            bal++;
            l = min(e.fst, l);
        } else {
            bal--;
            r = max(r, e.fst);
        }
        if (bal == 0) {
            ans += (r - l + 1);
            l = 1e6, r = -1;
        }
    }
    cout << ans << "\n";
    return 0;
}