#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 1e6 + 15;
int n;
string s;
int bal;
int last;

void solve() {
    cin >> n >> s;
    s = '#' + s;
    int ans = 0;
    for(int i = 1; i <= n; ++i) {
        if(s[i] == ')')
            ++ans;
        else
            --ans;
    }
    if(ans) {
        cout << -1 << endl;
        exit(0);
    }
    ans = 0;
    bal = 0;
    bool flag = false;
    for(int i = 1; i <= n; ++i) {
        if(s[i] == '(')
            ++bal;
        if(s[i] == ')')
            --bal;
        if(bal < 0)
            flag = true;
        if(bal == 0) {
            if(flag) {
                ans += i - last;
//                cout << last << ' ' << i << endl;
            }
            last = i;
            flag = false;
        }
    }
    cout << ans << endl;
}

main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    int tt = 1;
    while(tt--)
        solve();
    return 0;
}
