#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <set>

typedef long long ll;
using namespace std;


signed main()
{
    int n; cin >> n;
    string s; cin >> s;
    vector<int> st2;
    deque<int> st;
    vector<int> compat(n, -1);
    int am = 0;
    for(int i = 0; i < s.length(); i++){
        if(s[i] == ')'){
            if(st2.empty()) {
                st.push_back(i);
            } else {
                st2.pop_back();
            }
        } else {
            if(st.empty()) {
                st2.push_back(i);
            } else {
                int a = st.front();
                compat[a] = i;
                st.pop_front();
            }
        }
    }
    if(!st.empty() || !st2.empty()){
        cout << -1;
        return 0;
    } else {
        vector<pair<int, int>> otr;
        for(int i = 0; i < n; i++){
            if(compat[i] != -1){
                otr.push_back({i, compat[i]});
            }
        }
        sort(otr.begin(), otr.end());
        int l = -1, r = -1;
        int ans = 0;
        for(int i = 0; i < otr.size(); i++){
            if(otr[i].first > r){
                ans += r != -1 ?  r - l + 1 : 0;
                l = otr[i].first;
                r = otr[i].second;
            } else {
                r = max(r, otr[i].second);
            }
        }
        ans += r != -1 ? r - l + 1 : 0;
        cout << ans;
    }

}