#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
//#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 1e5 + 5;

bool check(string &s) {
    int bal = 0;
    rep(i, s.size()) {
        bal += (s[i] == '(' ? 1 : -1);
        if (bal < 0) return false;
    }
    return bal == 0;
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<string> parts;
    int bal = 0;
    rep(i, n) {
        if (s[i] == ')') bal--;
        else bal++;
    }
    if (bal != 0) {
        cout << -1;
        return;
    }
    bal = 0;
    for (int i = 0; i < n;) {
        int r = i;
        string pbs = "";
        pbs += s[i];
        parts.pb(pbs);
        bal = (s[i] == '(' ? 1 : - 1);
        while (r < n && bal != 0) {
            r++;
            bal += (s[r] == '(' ? 1 : -1);
            parts.back() += s[r];
        }
        i = r + 1;
    }
    int ans = 0;
    rep(i, parts.size()) {
        if (!check(parts[i])) ans += parts[i].size();
    }
    cout << ans;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}