#include <bits/stdc++.h>

#define fi first
#define se second
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define len(a) ll((a).size())
#define pw(a) (1LL << (a))

using namespace std;
using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const ll INF = 4e18;

ll x[5005][5005];
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    ll n; string s;
    cin >> n >> s;
    vector <vector <ll>> pref(2, vector <ll> (n + 1, 0));
    for(int i = 0; i < len(s); i++) {
        pref[0][i + 1] = pref[0][i] + (s[i] == '(');
        pref[1][i + 1] = pref[1][i] + (s[i] == ')');
    }
    for(int i = 0; i < n; i++) {
        ll sum = 0;
        for(int j = i; j < n; j++) {
            sum += (s[j] == '(');
            sum -= (s[j] == ')');
            if(sum < 0) break;
            x[i][j] = 1;
        }
    }
    vector <ll> dp(n + 1, INF);
    dp[0] = 0;
    for(int i = 1; i <= n; i++) {
        if(x[0][i - 1] == 1) dp[i] = 0;
        else if(pref[0][i] - pref[1][i] >= 0) dp[i] = i;
        for(int j = i - 1; j >= 0; j--) {
            ll val = pref[0][i] - pref[0][j] - (pref[1][i] - pref[1][j]);
            if(pref[0][j] - pref[1][j] >= -val) {
                dp[i] = min(dp[i], dp[j] + i - j);
                if(x[j][i - 1] == 1) {
                    dp[i] = min(dp[i], dp[j]);
                }
            }
        }
    }
    if(pref[0][n] - pref[1][n] != 0) return cout << "-1\n", 0;
    cout << dp[n] << '\n';
}
