#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(int &a, const int &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(int &a, const int &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 1e6 + 228;
int n, pref[mx];
string s;

signed main() {
	fast_io();
	cin >> n;
	cin >> s;
	int bal = 0;
	for (int i = 0; i < n; ++i) {
		bal += (s[i] == '(' ? 1 : -1);
		pref[i] = bal;
	}
	if (bal != 0) {
		cout << -1 << endl;
		exit(0);
	}
	int one = 0, cmp = 0;
	for (int i = 0; i < n; ++i) {
		if (pref[i] < 0) {
			one++;
			if (i == n - 1) {
				cmp++;
			}
		}
		if (pref[i] >= 0 && i > 0 && pref[i - 1] < 0) {
			cmp++;
		}
	}
	cout << one + cmp << endl;
}
