//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n;
	cin >> n;
	string s;
	cin >> s;
	int o = 0, c = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '(') ++o;
		else ++c;
	}
	if (o != c) {
		cout << -1;
		return 0;
	}
	o = 0; c = 0;
	int ans = 0;
	vector<char> check;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '(') {
			++o;
			check.pb('(');
		} else {
			++c;
			if (!check.empty() && check.back() == '(') check.pop_back();
			else check.pb(')');
		}
		if (o == c) {
			ans += check.size();
			check.clear();
			c = o = 0;
		}
	}
	cout << min(ans, n);
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}