#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#define int long long
#define endl '\n'

#define FastIO; ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less <int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;


int balance[1000000];
int t[4000000];

void build(int v, int tl, int tr)
{
    if (tl==tr) t[v] = balance[tl];
    else
    {
        int tm = (tl+tr)/2;
        build(v*2, tl, tm);
        build(v*2+1, tm+1, tr);
        t[v] = min(t[v*2],t[v*2+1]);
    }
}

int mini(int v, int tl, int tr, int l, int r)
{
    if (l>r) return 2e18;
    if (tl==l && tr==r) return t[v];
    int tm = (tl+tr)/2;
    return min(mini(v*2, tl, tm, l, min(r, tm)),mini(v*2+1, tm+1, tr, max(tm+1, l), r));
}

int32_t main()
{
   // FastIO;
    int n;
    cin >> n;
    string s;
    cin >> s;
    int cnt1 = 0, cnt = 0;
    for (int i=0; i<n; i++)
    {
        if (s[i]=='(')
        {
            balance[i+1] = balance[i] + 1;
            cnt1++;
        }
        else
        {
            balance[i+1] = balance[i] - 1;
            cnt++;
        }
    }

    //for (int i=0; i<=n; i++) cout << balance[i] << " ";
    //cout << endl;

    if (cnt!=cnt1)
    {
        cout << -1;
        return 0;
    }

    build(1,0,n);


   // cout << "ok";
    int pred = 0;
    int ans = n;


    for (int i=0; i<n; i++)
    {
        if (balance[i+1]==0)
        {
            if (mini(1,0,n, pred+1, i+1)>=0) ans-=i+1 - pred;
            pred = i+1;
        }
    }


    cout << ans;





    return 0;
}



