#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    string s;
    cin >> s;

    vector<int> a(n);
    int scnt = 0;
    for (int i = 0; i < n; ++i) {
        a[i] = (s[i] == ')');

        scnt += a[i];
    }

    if (scnt != n - scnt) {
        cout << -1;

        return 0;
    }

    int answ = 0;
    int last = -1;
    int balc = 0;

    for (int i = 0; i < n; ++i) {
        if (a[i] == 1) {
            --balc;
        } else {
            ++balc;
        }

        if (balc < 0) {
            if (last == -1) {
                last = i;
            }
        } else if (balc == 0) {
            if (last != -1) {
                answ += i - last + 1;

                last = -1;
            }
        }
    }

    cout << answ;

    return 0;
}
