#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

signed main() {
	warp();

	int n;
	cin >> n;
	string s;
	cin >> s;
	int bal = 0;
	for (char i : s) {
		bal += (i == '(' ? 1 : -1);
	}
	if (bal != 0) {
		cout << -1;
		return 0;
	}
	int pr = 0, ans = 0, bad = 0;
	for (int i = 0; i < n; ++i) {
		bal += (s[i] == '(' ? 1 : -1);
		if (bal == 0) {
			if (bad) {
				ans += (i - pr + 1);
			}
			pr = i + 1;
			bad = 0;
		} else if (bal < 0) {
			bad = 1;
		}
	}
	cout << ans;
}