// ТЯНОЧКУ БЫ

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define F first
#define S second
#define mp make_pair
//#define int long long
//#define int unsigned long long

const int SZ = 1e6 + 4;
const int inf = 2e9;
const int hashpow = 127;
const int mod = 1e9 + 7;

int n;
string s;

void read() {
	cin >> n >> s;
}

int p[SZ];
int x[SZ];
int dp[SZ];

void solve() {
	p[0] = 0;
	for (int i = 0; i < n; ++i) {
		p[i + 1] = p[i] + (s[i] == '(' ? 1 : -1);
	}

	int last = 0;
	for (int i = 1; i <= n; ++i) {
		x[i] = last;
		if (p[i] == 0) {
			last = i;
		}
	}

	dp[0] = 0;
	for (int i = 1; i <= n; ++i) {
		if (p[i]) {
			dp[i] = -1;
			continue;
		}

		dp[i] = dp[x[i]] + (p[x[i] + 1] == -1 ? i - x[i] : 0);
	}

	if (dp[n] == -1) {
		cout << -1;
		return;
	}
	cout << dp[n];
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	read();
	solve();

	return 0;
}