#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

using namespace std;
int INF = 2 * 1e9;
ll INFL = 1e18 + 500;

vector<int> bfs(vector<vector<int>> &g, int a) {
    int n = g.size();
    vector<int> d(n, -1);
    d[a] = 0;
    queue<int> q;
    q.push(a);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : g[u]) {
            if (d[v] == -1) {
                d[v] = d[u] + 1;
                q.push(v);
            }
        }
    }
    return d;
}

/*vector<int> t;

int sum(int v, int tl, int tr, int l, int r) {
    if (l > r) return 0;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    return sum(v * 2, tl, tm, l, min(tm, r)) + sum(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

void update(int v, int tl, int tr, int x, int val) {
    if (tl == tr) {
        t[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (tm <= x) {
        update(v * 2, tl, tm, x, val);
    } else {
        update(v * 2 + 1, tm + 1, tr, x, val);
    }
    t[v] = t[v * 2] + t[v * 2 + 1];
}*/

/*vector<int> pi_func(string s) {
    int n = s.size();
    vector<int> pi(n);
    for (int i = 1; i < n; i++) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = pi[j - 1];
        }
        if (s[i] == s[j]) j++;
        pi[i] = j;
    }
    return pi;
}*/

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    srand(time(NULL));
    int n;
    cin >> n;
    string s;
    cin>>s;
    vector<int> d(n + 1);
    int cur = 0;
    int ans = 0;
    for (int i = 0; i < n; i++){
        if (s[i] == '(') cur++;
        else cur--;
        d[i + 1] = cur;
    }
    for (int i = 1; i <= n; i++){
        if (d[i] == 0){
            int j = i - 1;
            for (; d[j] != 0; j--);
            j++;
            bool f = false;
            for (int k = j; k <= i; k++) if (d[k] < 0) f = true;
            if (f) ans += i - j + 1;
        }
    }
    if (d.back() == 0) cout<<ans;
    else cout<<-1;
    return 0;
}