#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii pair<int, int>
#define int ll
#define vi vector<int>
#define pb push_back
using namespace std;

map<int, int> mp;
const int maxn = 1e6 + 50;
int t[4 * maxn];
void update(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t[v] = x;
    } else {
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            update(2 * v, tl, tm, pos, x);
        else
            update(2 * v + 1, tm + 1, tr, pos, x);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
}
int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l || l > r)
        return 1e9;
    if (tl >= l && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return min(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int n;
    cin >> n;
    string s;
    cin >> s;
    int dp[n];
    mp[0] = -1;
    memset(dp, 127, sizeof(dp));
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        bal += (s[i] == '(' ? 1 : -1);
        update(1, 0, n - 1, i, bal);
        int j = -2;
        if (mp.count(bal) && bal == 0)
            j = mp[bal] + 1;
        else
            continue;
        mp[bal] = i;
        int kek = get(1, 0, n - 1, j, i);
        dp[i] = (j > 0 ? dp[j - 1] : 0) + (kek < 0) * (i - j + 1);
    }
    if (dp[n - 1] > 1e15) {
        cout << -1 << endl;
    } else {
        cout << dp[n - 1] << endl;
    }
    return 0;
}
