#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1003
#define INF 1000003
using namespace std;

string s;
int n;
int d[MAXN][MAXN];
bool pos[MAXN][MAXN];
int cnt1[MAXN];
int cnt2[MAXN];

void input()
{
    cin >> n;
    cin >> s;
    //n = s.size();
}

void init()
{
    cnt1[0] = 0;
    cnt2[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        cnt1[i+1] = cnt1[i];
        cnt2[i+1] = cnt2[i];
        if (s[i] == '(')
            ++cnt1[i+1];
        else
            ++cnt2[i+1];
    }
}

bool check(int l, int r)
{
    if (cnt1[r+1] - cnt1[l] == cnt2[r+1] - cnt2[l])
        return 1;
    return 0;
}

int rec(int l, int r)
{
    if (!check(l, r))
        return INF;

    if (l > r)
        return 0;

    int ret = r - l + 1;
    if (s[l] == '(' && s[r] == ')')
        ret = min(ret, rec(l + 1, r - 1));

    for (int i = l + 1; i < r - 1; ++i)
        ret = min(ret, rec(l, i) + rec(i + 1, r));

    return ret;
}

void solve()
{
    int ans = rec(0, n - 1);
    cout << (ans == INF ? -1 : ans) << endl;
}

/**

8
))((())(

3
(()

*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    init();
    solve();

    return 0;
}
