#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n;
	cin >> n;

	string a;
	cin >> a;

	vector <int> bal(n + 1, 0);
	int b = 0;

	for (int i = 0; i < n; i++)
		if (a[i] == '(')
			bal[i + 1] = bal[i] + 1;
		else
			bal[i + 1] = bal[i] - 1;

	if (bal[n] != 0)
		return cout << -1, 0;

	int i = 1;
	int ans = 0;
	while (i <= n) {
		if (bal[i] < 0) {
			int tbal = bal[i - 1];
			int par = i;
			bool fl = 1;
			while (fl || i <= n && tbal < 0) {
				fl = 0;
				if (a[i - 1] == '(')
					tbal++;
				else
					tbal--;
				i++;
			}
			ans += (i - par);
		} else {
			i++;
		}
	}

	cout << ans;

	return 0;
}