#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <string>

using namespace std;

//#define FAST_MEMORY_ALLOCATOR 256'000'000

#ifdef FAST_MEMORY_ALLOCATOR
char st[FAST_MEMORY_ALLOCATOR];
int pos = 0;
void * operator new(size_t x) {
	pos += x;
	return st + pos - x;
}

void operator delete(void *x) noexcept {}
#endif

bool is_psp(int L, int R, string &s) {
	int bal = 0;
	for (int i = L; i < R; i++) {
		if (s[i] == '(') {
			bal++;
		} else {
			bal--;
		}
		if (bal < 0)
			return 0;
	}
	return bal == 0;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ifstream cin("input.txt");
	ofstream cout("output.txt");
	int n;
	cin >> n;
	string s;
	cin >> s;
	int bal = 0;
	int len = 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '(')
			bal++;
		else
			bal--;
		len++;
		if (bal == 0) {
			if (!is_psp(i - len + 1, i + 1, s)) {
				ans += len;
			}
			len = 0;
		}
	}
	if (bal != 0) {
		cout << -1;
	} else {
		cout << ans;
	}
}