#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, ans;
string s;

bool check() {
    ll op = 0, za = 0;
    for (ll i = 0; i < n; i++)
        if (s[i] == '(')
            op++;
        else za++;
    return (op != za);
}

ll solve(ll i) {
    stack <char> all;
    ll j, pr = i + 1;
    for (j = i + 1; j < n; j++) {
        if (s[j] == '(')
            all.push(s[j]);
        else {
            if (all.size() > 0) {
                all.pop();
            }
            else {
                break;
            }
        }
        if (all.size() == 0)
            pr = j;
    }
    if (pr == i + 1 || all.size() != 0)
        return 1e18;
    j = pr + 1;
    if (j >= n)
        return 0;
    ll qwe = n - j;
    ll op = 0, za = 0;
    ll an = 0;
    for (j; i < n; i++) {
        if (s[j] == '(')
            op++;
        else za++;
        an++;
        if (op == za) {
            ll otv = solve(j);
            if (an + otv < qwe)
                qwe = an + otv;
        }
    }
    return qwe;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    cin >> s;
    if (check()) {
        cout << -1;
        return 0;
    }
    ans = 0;
    ll qwe = n;
    ll op = 0, za = 0;
    for (ll i = 0; i < n; i++) {
        if (op == za) {
            ll otv = solve(i);
            if (ans + otv < qwe)
                qwe = ans + otv;
        }
        if (s[i] == '(')
            op++;
        else za++;
        ans++;
        if (op == za) {
            ll otv = solve(i);
            if (ans + otv < qwe)
                qwe = ans + otv;
        }
    }
    cout << min(qwe, n);
    return 0;
}