//#include <bits/stdc++.h>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <vector>
#include <random>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9 + 7;

void fast() {
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

mt19937 rnd(time(0));

vector<int> m1;

bool check(int pos, int n) {
    if (pos <= 0 || pos >= n - 1) {
        return false;
    }
    if (m1[pos] < m1[pos - 1] && m1[pos] < m1[pos + 1]) {
        return true;
    }
    if (m1[pos] > m1[pos - 1] && m1[pos] > m1[pos + 1]) {
        return true;
    }
    return false;
}

signed main() {
    fast();

    int n;
    cin >> n;
    string s;
    cin >> s;
    int kol1 = 0;
    int kol2 = 0;
    for (auto& el : s) {
        if (el == '(') {
            kol1++;
        } else {
            kol2++;
        }
    }
    if (kol1 != kol2) {
        cout << -1;
        return 0;
    }
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i];
        if (s[i] == ')') {
            pref[i + 1]--;
        }
        else {
            pref[i + 1]++;
        }
    }
    for (int i = 1; i <= n; i++) {
        bool can = true;
        int kol = 0;
        for (int j = i; j <= n; j++) {
            if (s[j - 1] == '(') {
                kol++;
            } else {
                kol--;
            }
            if (kol < 0) {
                can = false;
            }
            if (can && kol == 0 && pref[i - 1] >= 0) {
                dp[j] = min(dp[j], dp[i - 1]);
            } else {
                dp[j] = min(dp[j], dp[i - 1] + j - i + 1);
            }
        }
    }
    cout << dp[n];
    return 0;
}
