#pragma GCC target("avx2")
#pragma GCC optimize("O3") 

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x)) 
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
//#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)2e6 + 123;
const ll inf = (ll)1e18 + 123;

const double pi = acos(-1.0);
const double eps = 1e-7;
const int dx[] = {0, 0, 0, -1, 1};
const int dy[] = {0, 1, -1, 0, 0};

int n, dp[N], cl[N], o[N], pos[N], t[4 * N];
char s[N];
bool is[5005][5005];
set <int> id[N];
map <int, int> cnt;

void upd (int pos, int val, int v = 1, int tl = 0, int tr = 2 * n) {
	if (tl == tr) {
		t[v] = val;
		return;
	}
	int tm = tl + tr >> 1;
	if (pos <= tm) upd (pos, val, v + v, tl, tm);
	else upd (pos, val, v + v + 1, tm + 1, tr);
	t[v] = min (t[v + v], t[v + v + 1]);
}

int get (int l, int r, int v = 1, int tl = 0, int tr = 2 * n) {
	if (tl > r || tr < l) return mod;
	if (l <= tl && tr <= r) return t[v];
	int tm = tl + tr >> 1;
	return min (get (l, r, v + v, tl, tm), get (l, r, v + v + 1, tm + 1, tr));
}

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}

inline void Solve () {
	boost ();
	cin >> n;
	cin >> s + 1;
	for (int i = 1; i <= n; i ++) dp[i] = mod;
	for (int i = 1; i <= n; i ++) {
		o[i] = o[i - 1] + (s[i] == '(');
		cl[i] = cl[i - 1] + (s[i] == ')');
	}                                  /*
	for (int i = 1; i <= n; i ++) {
		int bal = 0, mn = mod;
		for (int j = i; j <= n; j ++) {
			if (s[j] == '(') bal ++;
			else bal --;
			mn = min (mn, bal);
			if (mn < 0) break;
			if (bal == 0) is[i][j] = 1;
	   }                                 
	}                                    */
	for (int i = 1; i < 4 * N; i ++) t[i] = mod;
	for (int i = n; i >= 1; i --) {
		int B = o[i - 1] - cl[i - 1] + n;
		upd (o[i] - cl[i] + n, i);	
		int mx = get (0, B - 1);
		if (sz (id[B]) && *id[B].begin () < mx) pos[i] = *(-- id[B].lb (mx));
		else pos[i] = -1;
		id[o[i] - cl[i] + n].in (i);
	}
	for (int j = 1; j <= n; j ++) {
		int B = o[j] - cl[j];
		if (cnt.count (B)) dp[j] = min (dp[j], dp[cnt[B]] + j - cnt[B]);
		cnt[o[j - 1] - cl[j - 1]] = j - 1;
	   if (pos[j] != -1) dp[pos[j]] = min (dp[pos[j]], dp[j - 1]);
		/*for (int i = n; i > j; i --) {
	   	if (is[j][i]) {
	   		dp[i] = min (dp[i], dp[j - 1]);
	   		break;
	   	}
	   }*/
		/*for (int i = j - 1; i >= 1; i --) {
			if (is[i][j]) dp[j] = min (dp[j], dp[i - 1]);
			//if (can[i][j]) dp[j] = min (dp[j], dp[i - 1] + j - (i - 1));
			//if (dp[j] != mod) break;
		}*/
	}
	if (dp[n] == mod) dp[n] = -1;
	cout << dp[n];
}

int main () {
   int tt = 1;
   //cin >> tt;
   while (tt --) Solve (); 
	return 0;
}