#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;

    string st;
    cin >> st;

    ll cur = 0;
    vpll segs;
    for(int i = 0; i < st.size(); i++)
    {
  //      cerr << "cur " << cur << " st " << st << endl;
        if(st[i] == '(')
            cur++;
        else
            cur--;

        if(cur < 0)
        {
            ll nxt = -1;
            for(int j = i + 1; j < st.size(); j++)
            {
                if(st[j] == '(')
                {
                    nxt = j;
                    break;
                }
            }
            if(nxt == -1)
            {
                cout << -1 << endl;
                return 0;
            }

   //         cerr << "in swap" << endl;
            swap(st[i], st[nxt]);
            cur += 2;

            segs.pb({i, nxt});
        }
    }
   // cerr << "cur " << cur << endl;
    if(cur != 0)
    {
  //      cerr << "total problem" << endl;
        cout << -1 << endl;
        return 0;
    }

    ll answ = 0;
    sort(segs.begin(), segs.end());

  //  cerr << "segs " << endl;
  //  for(int i = 0; i < segs.size(); i++)
   //     cerr << segs[i].f << " " << segs[i].s << endl;

    for(int i = 0; i < segs.size(); i++)
    {
        pll x = segs[i];
        for(int j = i + 1; j < segs.size() && segs[j].f <= x.s; j++)
        {
            i = max(i, j);
            x.s = max(x.s, segs[j].s);
        }
   //     cerr << "in total " << x.f << " " << x.s << endl;
        answ += x.s - x.f + 1;
    }
    cout << answ << endl;
    return 0;
}