#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
using namespace std;

string s;

bool P(int l, int r) {
    stack<char> p;
    for (int i = l; i <= r; ++i)
        if (!p.empty() && p.top() == '(' && s[i] == ')') p.pop();
        else p.push(s[i]);
    if (p.empty()) return true;
    else return false;
}

inline void CL(stack<char> &p) {
    while (!p.empty())
    {
        p.pop();
    }
}

int main()
{
    int n;
    cin >> n >> s;
    int l = 0, r = 0, b = 0;
    for (int i = 0; i < n; ++i)
        if (s[i] == '(') ++l;
        else ++r;
    if (l != r) { cout << -1; return 0; }
    if (!P(0, n - 1)) {
        //cout << "NO";
        int g = 0, h = 0;
        l = 0, r = 0;
        stack<char> p;
        for (int i = 0; i < n; ++i) {
            if (s[i] == '(') ++l;
            else ++r;

            if (!p.empty() && p.top() == '(' && s[i] == ')') p.pop();
            else p.push(s[i]);

            if (p.empty()) {
                l = 0, r = 0;
                h = i + 1;
            }
            else if (l == r) {
                g += i - h + 1;
                CL(p);
                l = 0, r = 0;
                h = i + 1;
            }

        }
        cout << g;
    }
    else cout << 0;
    return 0;
}
/*
4
()()

2
()

10
)(()())()(

8
))((())(
3
(()

*/