#define ll long long
#define pb push_back
#include<vector>
#include<deque>
#include<iostream>
//#include<bits/stdc++.h>

using namespace std;
template <class T>
ostream& operator <<(ostream &in, vector<T> & arr)
{
    for (T &i: arr)
    {
        in << i << " ";
    }
    return in;
}

vector<vector<ll> > t(4001, vector<ll>(4001, 0));

void change(ll i, ll v, ll l, ll r, ll pos, ll x)
{
    if (l == r - 1)
    {
        t[i][v] = x;
        return;
    }
    ll m = (l + r)/2;
    if (pos < m)
    {
        change(i, 2 * v + 1, l, m, pos, x);
    } else
        change(i, 2 * v + 2, m , r, pos, x);
    t[i][v] = max(t[i][2 * v + 1], t[i][2 * v + 2]);
}

ll get_res(ll i, ll v, ll l, ll r, ll askl, ll askr)
{
    if (l >= askr or askl >= r)
        return 0;
    if (askl <= l and r <= askr)
        return t[i][v];
    ll m = (l + r)/2;
    return max(get_res(i, 2 *v + 1, l, m, askl, askr), get_res(i, 2 *v + 2, m, r, askl, askr));
}

vector<vector<ll> > t1(4001, vector<ll>(4001, 0));

void change1(ll i, ll v, ll l, ll r, ll pos, ll x)
{
    if (l == r - 1)
    {
        t1[i][v] = x;
        return;
    }
    ll m = (l + r)/2;
    if (pos < m)
    {
        change1(i, 2 * v + 1, l, m, pos, x);
    } else
        change1(i, 2 * v + 2, m , r, pos, x);
    t1[i][v] = max(t1[i][2 * v + 1], t1[i][2 * v + 2]);
}

ll get_res1(ll i, ll v, ll l, ll r, ll askl, ll askr)
{
    if (l >= askr or askl >= r)
        return 0;
    if (askl <= l and r <= askr)
        return t1[i][v];
    ll m = (l + r)/2;
    return max(get_res1(i, 2 *v + 1, l, m, askl, askr), get_res1(i, 2 *v + 2, m, r, askl, askr));
}


int main() {
    ll a;
    cin >> a;
    string s;
    cin >> s;
    vector<vector<ll> > ans(a + 1, vector<ll>(a + 1, 0));
    vector<vector<ll> > is(a + 1, vector<ll>(a + 1, 0));
    for (int i = 0; i < a; ++i)
    {
        ll x, y;
        x = 0;
        y = 0;
        if (s[i] == '(')
            x += 1;
        else
            y += 1;
        is[i][i] = -1;
        for (int j = i + 1; j < a; ++j)
        {
            if (s[j] == '(')
                x += 1;
            else
                y += 1;
            if (x == y)
                is[i][j] = 0;
            else
                is[i][j] = -1;
        }
    }
    if (is[0][a - 1] == -1)
        cout << -1 << endl;
    else
    {
        for (int i = 0; i < a; ++i) {
            deque<ll> ch;
            ll flag = 1;
            for (int j = i; j < a; ++j)
            {
                if (flag == 1) {
                    if (ch.size() == 0)
                        if (s[j] == '(')
                            ch.pb(s[j]);
                        else
                            flag = 0;
                    else {
                        if (s[j] == ch[ch.size() - 1])
                            ch.pb(s[j]);
                        else
                            ch.pop_back();
                    }
                }
                if (flag == 1 and ch.size() == 0) {
                    ans[i][j] = j - i + 1;
                    change(i, 0, 0, a, j, j - i + 1);
                    change1(j, 0, 0, a, i, j - i + 1);
                }

            }
        }



        for (int len = 0; len < a; ++len)
        {
            for (int l = 0; l + len < a; ++l)
            {
                ll r = l + len;
                ll k = max(get_res(l, 0, 0, a, l, r), get_res1(r, 0, 0, a, l, r));
                ans[l][r] = k;
                if (is[l][r] == -1)
                {ans[l][r] = -1; k = -1;}

                change(l, 0, 0, a, r, k);
                change1(r, 0, 0, a, l, k);
            }
        }cout << a - ans[0][a - 1] << endl;
    }
    




}
