#include <iostream>
#include <algorithm>
#include <cstdint>
#include <vector>
#include <string>
using namespace std;

string s;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n;
    cin>>s;
}

bool check_posible()
{
    if(s.size()%2!=0)
        return false;
    uint32_t bro=0, brz=0;

    for(uint32_t i=0; i<s.size(); i++)
    {
        if(s[i]=='(')
            bro++;
        else
            brz++;
    }

    if(bro != brz)
        return false;

    return true;
}

int main()
{
    init();

    if(check_posible()==false)
    {
        cout<<"-1\n";
        return 0;
    }

    uint64_t negpos=UINT64_MAX;

    int32_t cur_s=0;

    uint64_t res=0;

    for(uint32_t i=0; i<s.size(); i++)
    {
        cur_s += (s[i]=='(') ? +1 : -1;
        if(cur_s<0 && negpos==UINT64_MAX)
        {
            negpos=i;
        }
        else if(cur_s >=0 && negpos!=UINT64_MAX)
        {
            res+=(i-negpos+1);
            negpos=UINT64_MAX;
        }
    }

    cout<<res<<'\n';


    return 0;
}