#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <type_traits>
using namespace std;
typedef long long ll;
typedef long double ld;
template<class T>
using pt = pair<T, T>;

struct hoba
{
	char c;
	bool spec = false, used = false;
};

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<hoba> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].c;
	}
	ll ans = 0;
	int op = 0, cl = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i].used)
			continue;
		a[i].used = true;
		if (a[i].c == ')')
			cl++;
		else
			op++;
		if (cl > op)
		{
			a[i].spec = true;
			for (int j = i+1; j < n; j++)
			{
				if (a[j].c == ')' && !a[j].spec && !a[j].used)
				{
					a[j].spec = true;
				}
				else if (a[j].c == '(' && !a[j].used)
				{
					a[j].used = true;
					cl--;
					a[j].spec = true;
					break;
				}
			}
		}
		else if (op >= cl && cl > 0)
		{
			op--;
			cl--;
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (a[i].spec)
			ans++;
	}
	if (cl != op)
		cout << -1;
	else
		cout << ans;
	return 0;
}