#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>

//#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

bool check(veci& v) {
	for (int i = 1; i < sz(v) - 1; i++)
		if ((v[i] > v[i - 1] && v[i] > v[i + 1]) || (v[i] < v[i - 1] && v[i] < v[i + 1]))
			return false;
	return true;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	string str;
	cin >> str;
	/*if (n % 2 == 1) {
		cout << -1 << "\n";
		return 0;
	}*/
	
	vector<int> a(n);
	vector<int> l;
	l.reserve(n);
	int p = -1;
	for (int i = 0; i < n; ) {
		if (str[i] == '(') {
			int cnt_1 = 0, cnt_2 = 0;
			for (int j = i; j < n; j++) {
				if (str[j] == '(')
					cnt_1++;
				else
					cnt_2++;
				if (cnt_2 > cnt_1)
					break;
				if (cnt_1 == cnt_2)
					a[i] = j - i + 1;
			}
		}
		if (a[i] != 0) {
			if (i - p - 1 != 0)
				l.emplace_back(i - p - 1);
			p = i + a[i] - 1;
		}
		i += max(1, a[i]);
	}
	l.eb(n - p - 1);
	bool t = 0;
	if (l[0] % 2 == 1)
		t = 1;
	for (int i = 1; i < sz(l); i++) {
		if (l[i - 1] % 2 == 1)
			l[i]++;
	}
	if (l.back() % 2 == 1)
		cout << -1 << "\n";
	else {
		int res = 0;
		for (int i : l)
			res += i;
		cout << res + t << "\n";
	}


	return 0;
}
