#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T, class U> using ordered_map = tree<T, U, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int median(int a, int b, int c) {
    if (a <= b) {
        if (b <= c) {
            return b;
        } else if (c >= a) {
            return c;
        } else {
            return a;
        }
    } else {
        if (c >= a) {
            return a;
        } else if (c >= b) {
            return c;
        } else {
            return b;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    bool run = true;
    int it = 0;
    while (run) {
        run = false;
        vector<int> b(n);
        b[0] = a[0], b[n - 1] = a[n - 1];
        for (int i = 1; i + 1 < n; i++) {
            b[i] = median(a[i - 1], a[i], a[i + 1]);
            if (b[i] != a[i]) {
                run = true;
            }
        }
        it++;
        a = b;
    }
    if (t) {
        cout << it - 1 << '\n';
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    } else {
        cout << it - 1;
    }
    return 0;
}