#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define fs first
#define sc second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

const int N = 5e5 + 100;
vector<int> g[N], d(N), mark(N);


void dfs1(int v, int p) {
    d[v] = 1;
    for (auto u:g[v])
        if (u != p)
            dfs1(u, v);
}


bool dfs(int v, int p) {
    if (p != -1)
        d[v] = d[p] + 1;
    bool has = 0;
    for (auto u:g[v])
        if (u != p)
            has |= dfs(u, v);
    if (has == 0 && mark[v]) {
        has = 1;
        for (auto u:g[v])
            if (u != p)
                dfs1(u, v);
    }
    return has;
}


signed main() {
    fastio;
    #ifdef FlameDragon
        freopen("in.txt", "r", stdin);
    #endif // FlameDragon

    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }

    vector<pair<int, int>> ed(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        ed[i] = {a, b};
    }
    int root = -1;
    if (m == 1)
        root = ed[0].fs;
    else {
        if (ed[0].fs == ed[1].fs || ed[0].fs == ed[1].sc)
            root = ed[0].fs;
        else root = ed[0].sc;
    }
    for (int i = 0; i < m; i++)
        mark[ed[i].fs] = mark[ed[i].sc] = 1;

    d[root] = 1;
    dfs(root, -1);

    cout << *max_element(all(d)) << '\n';
    for (int i = 0; i < n; i++)
        cout << d[i] << ' ';
}


