#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb emplace_back
#define ff first
#define ss second
#define pii pair<int, int>
#define ld long double
#define mp make_pair
#define all(x) x.begin(), x.end()
#define uniq(x) sort(all(x)), x.resize(unique(all(x)) - x.begin())

const int maxn = 5e5 + 9;
vector<pii> g1[maxn];
vector<pii> g[maxn];
int n, m, t;
int h[maxn];
pii p[maxn];
int col[maxn];
bool used[maxn];

void find_h(int v, int pr)
{
    for (pii to : g1[v])
    {
        if (to.ff != pr)
        {
            h[to.ff] = h[v] + 1;
            p[to.ff] = mp(v, to.ss);
            find_h(to.ff, v);
        }
    }
}

void dfs(int v, int C)
{
    used[v] = 1;
    col[v] = C;
    for (pii to : g[v])
    {
        if (to.ss == 1)
        {
            if (used[to.ff])
            {
                if (col[to.ff] != col[v])
                {
                    cout << -1;
                    exit(0);
                }
            }
            else
                dfs(to.ff, C);
        }
        else
        {
            if (used[to.ff])
            {
                if (col[to.ff] == col[v])
                {
                    cout << -1;
                    exit(0);
                }
            }
            else
                dfs(to.ff, 1 - C);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].pb(b, i);
        g1[b].pb(a, i);
    }
    find_h(0, -1);
    for (int j = 0; j < m; j++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if (h[b] > h[a])
            swap(a, b);
        int pr1 = -1, pr2 = -1;
        while (h[a] > h[b])
        {
            int cur = p[a].ss;
            if (pr1 != -1)
            {
                g[pr1].pb(cur, 1);
                g[cur].pb(pr1, 1);
            }
            pr1 = cur;
            a = p[a].ff;
        }
        while (a != b)
        {
            int cur = p[a].ss;
            if (pr1 != -1)
            {
                g[pr1].pb(cur, 1);
                g[cur].pb(pr1, 1);
            }
            pr1 = cur;
            a = p[a].ff;

            cur = p[b].ss;
            if (pr2 != -1)
            {
                g[pr2].pb(cur, 1);
                g[cur].pb(pr2, 1);
            }
            pr2 = cur;
            b = p[b].ff;
        }
        if (pr1 != -1 && pr2 != -1)
        {
            g[pr1].pb(pr2, -1);
            g[pr2].pb(pr1, -1);
        }
    }
    for (int i = 0; i < n - 1; i++)
    {
        if (!used[i])
            dfs(i, 0);
    }
    if (t == 0)
    {
        cout << n;
        return 0;
    }
}

