#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int mod = 1e9 + 7;
const int pri = 997;
const ld PI = acos(-1);

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}

const int N = 5e5 + 5;
const int MAXN = 1e6 + 5;

int n, m, cs;
int a[N], b[N];
vector < int > g[N];


struct Data {
	vector < pt > ord;
	int lg[MAXN];
	int d[MAXN];
	int tin[MAXN];
	pt st[20][MAXN];
	void zfs (int v, int pr = 0) {
		d[v] = d[pr] + 1;
		tin[v] = sz(ord);
		ord.pb({d[v], v});
		for (auto e : g[v]) {
			int to = v ^ a[e] ^ b[e];
			if (to != pr) {
				zfs(to, v);
				ord.pb({d[v], v});
			}
		}
	}

	inline void clear () {
		ord.clear();
		memset(d, 0, sizeof d);
		memset(tin, 0, sizeof tin);

	}
	inline void build () {
		for (int i = 2; i < N; ++i) lg[i] = lg[i/2] + 1;
		for (int i = 0; i < sz(ord); i++) st[0][i] = ord[i];
		for (int j = 1; j <= lg[sz(ord)]; ++j) {
			for (int i = 0; i + (1 << j) <= sz(ord); ++i) {
				st[j][i] = min(st[j-1][i], st[j-1][i+(1<<(j-1))]);
			}
		}
	}
	int lca (int a, int b) {
		a = tin[a], b = tin[b];
		if(a > b) swap(a, b);
		int len = b - a + 1;
		len = lg[len];
		return min(st[len][a], st[len][b-(1<<len)+1]).second;
	}
	int dist (int a, int b) {
		return d[a] + d[b] - 2 * d[lca(a, b)];
	}
} A;

int c[N];
int up[N], dw[N];


void dfs (int v, int pr = 0) {
	
	for (auto e : g[v]) {
		int to = v ^ a[e] ^ b[e];
		if (to != pr) {
			dfs(to, v);
			if (dw[to]) {
				c[e] |= 1;
			}
			if (up[to]) {
				c[e] |= 2;
			}
			up[v] ^= up[to];
			dw[v] ^= dw[to];
		}
	}
}

int main () {
	randomizer3000 ();
	scanf("%d %d %d", &n, &m, &cs);
	For(i, 1, n - 1) {
		scanf("%d %d", &a[i], &b[i]);
		g[a[i]].pb(i);
		g[b[i]].pb(i);
	}

	A.zfs(1);
	A.build();

	for (int i = 1; i <= m; ++i) {
		int aa, bb;
		scanf("%d %d", &aa, &bb);
		int lc = A.lca(aa, bb);
		int x = rand();
		dw[bb] ^= x;
		up[lc] ^= x;
		dw[lc] ^= x;
		up[aa] ^= x;
	}

	dfs(1);

	for (int i = 1; i < n; ++i) if (c[i] == 3) {
		puts("-1");
		exit(0);
	}
}
