#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<string>

using namespace std;

int n, m;
vector<vector<int>> g;
vector<int> p;
vector<int> d;

void dfs(int v) {
	for (auto u : g[v]) {
		if (u != p[v]) {
			p[u] = v;
			d[u] = d[v] + 1;
			dfs(u);
		}
	}
}

map<pair<int, int>, bool> mp;

bool val = 1;
vector<int> ans;

void inc(int a, int b) {
	int a0 = a, b0 = b;
	vector<int> pa, pb;
	while (d[a] > d[b]) {
		if (mp[{p[a], a}]) {
			val = 0;
			return;
		}
		mp[{a, p[a]}] = 1;
		pa.push_back(a);
		a = p[a];
	}
	while (d[b] > d[a]) {
		if (mp[{b, p[b]}]) {
			val = 0;
			return;
		}
		mp[{p[b], b}] = 1;
		pb.push_back(b);
		b = p[b];
	}
	while (a != b) {
		if (mp[{p[a], a}]) {
			val = 0;
			return;
		}
		mp[{a, p[a]}] = 1;
		pa.push_back(a);
		a = p[a];
		if (mp[{b, p[b]}]) {
			val = 0;
			return;
		}
		mp[{p[b], b}] = 1;
		pb.push_back(b);
		b = p[b];
	}
	pa.push_back(a);
	vector<int> path = pa;
	while (pb.size()) {
		path.push_back(pb.back());
		pb.pop_back();
	}
	int num = 1;
	for (int i = 0; i < path.size(); i++) {
		ans[path[i]] = max(ans[path[i]], num);
		num = ans[path[i]] + 1;
	}
}


signed main() {
	int t;
	cin >> n >> m >> t;
	g.resize(n);
	p.resize(n);
	d.resize(n);
	ans.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		g[a - 1].push_back(b - 1);
		g[b - 1].push_back(a - 1);
	}
	dfs(0);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		inc(a - 1, b - 1);
	}
	int answer = 1;
	for (int i = 0; i < n; i++) {
		answer = max(answer, ans[i]);
	}
	if (val == 0) {
		cout << -1;
	}
	else {
		cout << answer << "\n";
		for (int i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
	}
}