#include <bits/stdc++.h>

using namespace std;

#define time time179
#define prev prev179

vector<vector<int> > gr;
vector<int> tin, tout;
vector<vector<int> > prev;
vector<int> d;
int depth = 0;
int time = 0;

void dfs(int x)
{
    if (tin[x] != -1) return;
    tin[x] = time++;
    d[x] = depth++;
    for (int i = 1; i < 30; ++i)
    {
        prev[x][i] = prev[prev[x][i - 1]][i - 1];
    }
    for (int i = 0; i < gr[x].size(); ++i)
    {
        if (tin[gr[x][i]] == -1) prev[gr[x][i]][0] = x;
        dfs(gr[x][i]);
    }
    depth--;
    tout[x] = time++;
}

bool son(int x, int y)
{
    if (tin[y] <= tin[x] && tout[x] <= tout[y]) return true;
    return false;
}

int LCA(int x, int y)
{
    if (son(x, y)) return y;
    if (son(y, x)) return x;
    int ans = x;
    for (int i = 29; i > -1; ++i)
    {
        if (!son(y, prev[ans][i]))
            ans = prev[ans][i];
    }
    ans = prev[ans][0];
    return ans;
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    tin.resize(n, -1);
    tout.resize(n);
    d.resize(n);
    prev.resize(n, vector<int> (30));
    for (int i = 0; i < 30; ++i)
        prev[0][i] = 0;
    dfs(0);
    vector<pair<int, int> > all(m);
    for (int i = 0; i < m; ++i)
        cin >> all[i].first >> all[i].second;
    cout << "wow" << endl;
    int ans = 0;
    vector<int> res(n, 1);
    for (int i = 0; i < m; ++i)
    {
        int u = all[i].first;
        int v = all[i].second;
        --u;
        --v;
        int lca = LCA(u, v);
        int l = d[u] + d[v] - 2 * d[lca];
        res[u] = 1;
        while (u != lca)
        {
            res[prev[u][0]] = res[u] + 1;
            u = prev[u][0];
        }
        res[v] = l + 1;
        while (v != lca)
        {
            res[prev[v][0]] = res[v] - 1;
            v = prev[v][0];
        }
        ans = max(ans, l + 1);
    }
    cout << ans << endl;
    for (int i = 0; i < n; ++i) cout << res[i] << " ";
}
