#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;

struct Test {
    int data;
    bool is_ans_unique = false;
    int expected_ans = -1;
    Test(int d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = false;

int n, m, t;
vector<vector<int>> graph;
vector<pair<int, int>> lines;

int solve() {
    return 0;
}

int npown() {
    int a = 1;
    for (int i = 0; i < n; ++i) {
        a *= n;
    }
    return a;
}

vector<vector<int>> routes;

vector<int> used;
int gen = 0;
vector<int> path;

bool dfs(int v, int dest) {
    used[v] = gen;
    path.emplace_back(v);
    if (v == dest) {
        return true;
    }
    for (int u : graph[v]) {
        if (used[u] == gen) continue;
        bool ans = dfs(u, dest);
        if (ans) return true;
    }
    path.pop_back();
    return false;
}

pair<int, vector<int>> stupid() {
    routes.resize(m);
    used.resize(n, -1);
    for (int i = 0; i < m; ++i) {
        dfs(lines[i].first, lines[i].second);
        routes[i] = path;
        path.clear();
        gen++;
    }

    int maxim = npown();
    int maxnum = 1'000'000;
    vector<int> that_ans = {-1};
    for (int i = 0; i < maxim; ++i) {
        vector<int> weights(n);
        int tmp = i;
        for (int j = 0; j < n; ++j) {
            weights[j] = tmp % n + 1;
            tmp /= n;
        }
        bool succ = true;
        for (int j = 0; j < m; ++j) {
            int d = weights[routes[j][1]] - weights[routes[j][0]];
            for (int k = 1; k < routes[j].size() - 1; ++k) {
                if ((weights[routes[j][k + 1]] - weights[routes[j][k]]) * d <= 0) {
                    succ = false;
                    break;
                }
            }
            if (!succ) break;
        }
        if (succ) {
            int maxxes = 0;
            for (int j = 0; j < n; ++j) {
                maxxes = max(maxxes, weights[j]);
            }
            if (maxxes < maxnum) {
                maxnum = maxxes;
                that_ans = weights;
            }
        }
    }
    return {maxnum, that_ans};
}

void gen_test() {

}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> m >> t;
    graph.resize(n);
    lines.resize(m);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        graph[a].emplace_back(b);
        graph[b].emplace_back(a);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        lines[i] = {a, b};
    }

}

bool check() {
    return false;
}

vector<Test> pretests = {};

bool check_pretests() {
    return true;
}

void precalc() {

}

int main() {
    precalc();
    if (IS_TESTING) {
        check_pretests();
    } else {
        read();
        auto ans = stupid();
        if (ans.first == 1'000'000) {
            cout << "-1\n";
        } else {
            cout << ans.first << '\n';
            for (auto e : ans.second) {
                cout << e << ' ';
            }
            cout << '\n';
        }
    }

}