#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pb emplace_back
#define ff first
#define ss second
#define pii pair<int, int>
#define ld long double
#define mp make_pair
#define all(x) x.begin(), x.end()
#define uniq(x) sort(all(x)), x.resize(unique(all(x)) - x.begin())

const int maxn = 5e5 + 9;
vector<pii> g1[maxn];
vector<pii> g[maxn];
int n, m, t;
int h[maxn];
pii p[maxn];
int col[maxn];
bool used[maxn];
vector<int> g2[maxn];
pii ed[maxn];
int dp[maxn];
bool used1[maxn];

void find_h(int v, int pr)
{
    for (pii to : g1[v])
    {
        if (to.ff != pr)
        {
            h[to.ff] = h[v] + 1;
            p[to.ff] = mp(v, to.ss);
            find_h(to.ff, v);
        }
    }
}

void dfs(int v, int C, vector<int>& kek)
{
    kek.pb(v);
    used[v] = 1;
    col[v] = C;
    for (pii to : g[v])
    {
        if (to.ss == 1)
        {
            if (used[to.ff])
            {
                if (col[to.ff] != col[v])
                {
                    cout << -1;
                    exit(0);
                }
            }
            else
                dfs(to.ff, C, kek);
        }
        else
        {
            if (used[to.ff])
            {
                if (col[to.ff] == col[v])
                {
                    cout << -1;
                    exit(0);
                }
            }
            else
                dfs(to.ff, 1 - C, kek);
        }
    }
}

void recol(vector<int>& kek)
{
    for (int i : kek)
        col[i] ^= 1;
}

void find_dp(int v)
{
    used1[v] = 1;
    dp[v] = 1;
    for (int to : g2[v])
    {
        if (!used1[to])
            find_dp(to);
        dp[v] = max(dp[v], dp[to] + 1);
    }
}

int solve(vector<int>& kek)
{
    for (int i : kek)
    {
        if (col[i])
            g2[ed[i].ff].pb(ed[i].ss);
        else
            g2[ed[i].ss].pb(ed[i].ff);
        used1[ed[i].ff] = 0;
        used1[ed[i].ss] = 0;
    }
    for (int i : kek)
    {
        if (!used1[ed[i].ff])
            find_dp(ed[i].ff);
        if (!used1[ed[i].ss])
            find_dp(ed[i].ss);
    }
    int ans = 0;
    for (int i : kek)
    {
        ans = max(ans, dp[ed[i].ff]);
        ans = max(ans, dp[ed[i].ss]);
    }
    for (int i : kek)
    {
        if (!g2[ed[i].ff].empty())
        {
            g2[ed[i].ff].resize(0);
            g2[ed[i].ff].shrink_to_fit();
        }
        if (!g2[ed[i].ss].empty())
        {
            g2[ed[i].ss].resize(0);
            g2[ed[i].ss].shrink_to_fit();
        }
    }
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].pb(b, i);
        g1[b].pb(a, i);
        ed[i] = mp(a, b);
    }
    find_h(0, -1);
    for (int i = 0; i < n - 1; i++)
    {
        if (h[ed[i].ff] > h[ed[i].ss])
            swap(ed[i].ff, ed[i].ss);
    }
    for (int j = 0; j < m; j++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if (h[b] > h[a])
            swap(a, b);
        int pr1 = -1, pr2 = -1;
        while (h[a] > h[b])
        {
            int cur = p[a].ss;
            if (pr1 != -1)
            {
                g[pr1].pb(cur, 1);
                g[cur].pb(pr1, 1);
            }
            pr1 = cur;
            a = p[a].ff;
        }
        while (a != b)
        {
            int cur = p[a].ss;
            if (pr1 != -1)
            {
                g[pr1].pb(cur, 1);
                g[cur].pb(pr1, 1);
            }
            pr1 = cur;
            a = p[a].ff;

            cur = p[b].ss;
            if (pr2 != -1)
            {
                g[pr2].pb(cur, 1);
                g[cur].pb(pr2, 1);
            }
            pr2 = cur;
            b = p[b].ff;
        }
        if (pr1 != -1 && pr2 != -1)
        {
            g[pr1].pb(pr2, -1);
            g[pr2].pb(pr1, -1);
        }
    }
    for (int i = 0; i < n - 1; i++)
    {
        if (!used[i])
        {
            vector<int> kek;
            dfs(i, 0, kek);
            int ans1 = solve(kek);
            recol(kek);
            int ans2 = solve(kek);
            if (ans1 < ans2)
                recol(kek);
        }
    }
    vector<int> kek(n - 1);
    for (int i = 0; i < n - 1; i++)
        kek[i] = i;
    cout << solve(kek) << "\n";
    for (int i = 0; i < n; i++)
        cout << dp[i] << " ";

}

