#include <bits/stdc++.h>

#define loop(i, n) for(int i  = 0; i < n; ++i)
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define vec vector
#define paii pair<int, int>
#define fr first
#define sc second
#define all(x) x.begin(), x.end()
#define Unique(x) x.erase(unique(all(x)), x.end())
#define SZ(x) (int) x.size()
#define pb push_back

#define int long long

using namespace std;

mt19937 rnd(time(0));

const int MAXN = 1e3 + 47;

int n, q, t;
vec<int> deep(MAXN, 0), hav(MAXN, 0), color(MAXN, -1);
vec<set<int> > en(MAXN);
vec<vec<int> > graf(MAXN), pat(MAXN), ng(MAXN);

int H = 0, Ind = -1;
vec<int> used(MAXN, 0);

void kek(int p1, int pr) {
    deep[p1] = 1;
    for(int p2 : ng[p1]) {
        if(p2 == pr) continue;
        kek(p2, p1);
        deep[p1] = max(deep[p1], deep[p2] + 1);
    }
    if(H < deep[p1]) {
        H = deep[p1];
        Ind = p1;
    }
}

int get_deep(int p1) {
    H = 0, Ind = -1;
    kek(p1, -1);
    return Ind;
}

int ANS = 0;

void paint(int p1, int pr, int cl) {
    color[p1] = cl, used[p1] = 1;
    ANS = max(ANS, cl);
    for(int p2 : ng[p1]) {
        if(p2 == pr) continue;
        paint(p2, p1, cl + 1);
    }
}

set<int> get(int p1, int pr) {
    set<int> our;
    for(int c : pat[p1]) our.insert(c);
    for(int p2 : graf[p1]) {
        if(p2 == pr) continue;
        set<int> t = get(p2, p1);
        for(int c : t) {
            if(our.find(c) == our.end()) our.insert(c);
            else our.erase(c);
        }
    }
    return our;
}

void dfs(int p1, int pr) {
    set<int> our;
    for(int c : pat[p1]) our.insert(c);
    vec<int> kek;
    int sum = 0;
    for(int p2 : graf[p1]) {
        if(p1 == p2) continue;
        set<int> t = get(p2, p1);
        int a = 0;
        for(int c : t) {
            if(our.find(c) == our.end()) a++;
        }
        sum += a;
        kek.pb(a);
    }
    sort(all(kek));
    if(kek.back() + kek.back() == sum || sum == kek.back()) {
        if(SZ(pat[p1]) != 0 || sum > 0) hav[p1] = 1;
    } else {/*
        cout << p1 << ": " << SZ(pat[p1]) << " " << sum << endl;
        for(int c : kek) cout << c << " ";
        cout << endl;*/
        cout << -1 << endl;
        exit(0);
    }

}

void solve() {
    cin >> n >> q >> t;
    loop(i, n - 1) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graf[a].pb(b);
        graf[b].pb(a);
    }
    loop(i, q) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        pat[a].pb(i);
        pat[b].pb(i);
    }
    loop(i, n) {
        dfs(i, -1);
    }
    //loop(i, n) cout << hav[i] << " ";

    loop(p1, n) {
        if(hav[p1] == 0) continue;
        for(int p2 : graf[p1]) {
            if(hav[p2] == 1) ng[p1].pb(p2), ng[p2].pb(p1);
        }
    }
    loop(p1 ,n) {
        if(used[p1] == 1) continue;
        int st = get_deep(p1);
        paint(st, -1, 1);
    }
    cout << ANS << endl;
    if(t == 1) {
        loop(i, n) cout << color[i] << " ";
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef COFFEE_MACHINE
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif // COFFEE_MACHINE

    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}
