#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define add push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
const ll INF = (ll)1e9 + 'b' + 'l' + 'i' + 'n' + 'k' + '-' + '1' + '8' + '2';

const int N = 1e5 + 10;
vector <int> gr[N];
int pr[N], tin[N], tout[N], T, ans[N];

void dfs(int v, int p) {
	tin[v] = T++;
	for (int u : gr[v]) {
		if (u != p) {
			pr[u] = v;
			dfs(u, v);
		}
	}
	tout[v] = T++;
}

bool anc(int u, int v) {
	return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int paint(int a, int b) {
	int la = 0, lb = 0;
	while (!anc(a, b)) {
		ans[a] = ++la; a = pr[a];
	}
	ans[a] = la + 1;
	vector <int> st;
	while (b != a) {
		st.add(b); b = pr[b]; lb++;
	}
	while (sz(st)) {
		ans[st.back()] = ans[pr[st.back()]] + 1; st.pop_back();
	}
	return la + lb;
}

void mane() {
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].add(v); gr[v].add(u);
	}
	dfs(0, -1);
	int mx = 0;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		mx = max(mx, paint(a, b) + 1);
	}
	cout << mx << endl;
	for (int i = 0; i < n; i++) {
		cout << ans[i] << " ";
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	mane();
#ifdef osss
	cout << endl; cerr << endl << "\t max is the best" << endl;
#endif
}