#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long
#define maxn 600000
#define logn 30
int n, m, t;
vector<vector<int>> lst;
vector<int> tin, tout;
int up[maxn][logn];
vector<int> col, d;
vector<int> prv;
int tt = 0;
void dfs(int v, int pr = -1){
    prv[v] = pr;
    for (int l = 1; l < logn; l++){
        up[v][l] = up[up[v][l - 1]][l - 1];
    }
    tin[v]= tt++;
    for (int to :lst[v]){
        if (to != pr){
            d[to] = d[v] + 1;
            up[to][0] = v;
            dfs(to, v);
        }
    }
    tout[v] = tt;
}
bool a(int v, int u){
    return tin[v] <= tin[u] && tin[v] < tout[u];
}
int lca(int v, int u){
    if (a(v, u)) return v;
    if (a(u, v)) return u;
    for (int l = logn - 1; l >= 0; l--){
        if (!a(up[v][l], u)){
            v = up[v][l];
        }
    }
    return up[v][0];
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    lst.assign(n, {});
    prv.assign(n, -1);
    for (int i =0; i < n - 1; i ++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        lst[u].push_back(v);
        lst[v].push_back(u);
    }
    tin.assign(n, 0);
    tout.assign(n, 0);
    d.assign(n, 0);
    dfs(0);
    col.assign(n, 1);
    int ans =0 ;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int x = lca(a, b);
        int cnt = 1;

        while (prv[a] != prv[x]){
            ans = max(ans, cnt);
            col[a] = cnt++;
            a = prv[a];
        }
        col[a] = cnt++;

        cnt = cnt + d[b] - d[x] - 1;
        while (prv[b] != prv[x]) {
            ans = max(ans, cnt);
            col[b] = cnt--;
            b = prv[b];
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < n; i++){
        cout << col[i] << " ";
    }
    return 0;
}