#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	string s;
	cin >> s;

	int balance = 0;
	int lastPos = -1, ans = 0;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '(')
			++balance;
		else
			--balance;

		if (balance < 0 && lastPos == -1)
			lastPos = i;

		if (balance == 0 && lastPos != -1)
		{
			ans += i - lastPos + 1;
			lastPos = -1;
		}
	}

	if (balance)
		cout << -1 << endl;
	else
		cout << ans;

	return 0;
}