#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 2e5;

ll n, m, t;
ve<ll> g[maxn];
ve<ll> c;
ve<ll> ans;
ve<pair<ll, ll>> e;
ll mn = oo;
ve<ll> st;
ve<ll> path;
ll need;

void dfs(ll v, ll from) {
    if(v == need) {
        path = st;
        return;
    }
    if(sz(path) > 0) {
        return;
    }
    fe(to, g[v]) {
        if(to == from) {
            continue;
        }
        st.pb(to);
        dfs(to, v);
        st.pop_back();
    }
}

void get_path(ll from, ll to) {
    st.clear();
    st.pb(from);
    need = to;
    dfs(from, -1);
    st.pop_back();
}

bool good(ve<ll>& c) {
    fe(x, e) {
        path.clear();
        get_path(x.fi, x.se);
        bool bad = 0;
        fr(i, 1, sz(path) - 1) {
            if(c[path[i]] >= c[path[i - 1]]) {
                bad = 1;
                break;
            }
        }
        if(!bad) continue;
        reverse(all(path));
        bad = 0;
        fr(i, 1, sz(path) - 1) {
            if(c[path[i]] >= c[path[i - 1]]) {
                bad = 1;
                break;
            }
        }
        if(bad) {
            return 0;
        }
    }
    return 1;
}

void rec(ll idx) {
    if(idx == n) {
        if(good(c)) {
            if(umn(mn, *max_element(all(c)))) {
                ans = c;
            }
        }
        return;
    }
    fr(i, 1, n) {
        c.pb(i);
        rec(idx + 1);
        c.pop_back();
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> t;
    fr(i, 1, n - 1) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        g[from].pb(to);
        g[to].pb(from);
    }
    fr(i, 1, m) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        e.pb({from, to});
    }
    fr(i, 1, n) {
        c.pb(i);
        rec(1);
        c.pop_back();
    }
    if(mn == oo) {
        cout << "-1\n";
        return 0;
    }
    cout << mn << "\n";
    fe(x, ans) {
        cout << x << " ";
    }
    cout << "\n";
    return 0;
}
