#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

vector<vector<int> > graph;
vector<int> pred;
vector<int> tin;
vector<int> tout;
vector<int> result;
int cnt = 0;

void dfs(int v, int p)
{
    pred[v] = p;
    tin[v] = cnt;
    cnt++;
    for (int i = 0; i < graph[v].size(); ++i)
    {
        if (graph[v][i] != p)
        {
            dfs(graph[v][i], v);
        }
    }
    tout[v] = cnt;
    cnt++;
}


void path(int v, int y, int cost)
{
    //cout << v << endl;
    result[v] = cost;
    if (v == y)
    {
        return;
    }
    if (tin[v] < tin[y] && tout[y] < tout[v])
    {
        for (int i = 0; i < graph[v].size(); ++i)
        {
            if (graph[v][i] != pred[v])
            {
                if (tin[graph[v][i]] <= tin[y] && tout[graph[v][i]] >= tout[y])
                {
                    path(graph[v][i], y, cost + 1);
                }
            }
        }
    }
    else
    {
        path(pred[v], y, cost + 1);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    int t;
    cin >> t;
    graph.resize(n);
    result.assign(n, 1);
    tin.resize(n);
    tout.resize(n);
    pred.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    dfs(0, -1);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        path(x, y, 1);
    }
    int max1 = 1;
    for (int i = 0; i < n; ++i)
    {
        max1 = max(max1, result[i]);
    }
    cout << max1 << endl;
    if (t)
    {
        for (int i = 0; i < n; ++i)
        {
            cout << result[i] << endl;
        }
    }
    return 0;
}
