#include <bits/stdc++.h>
#define int long long
#define endl '\n'

// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC target("avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	fast();

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

void solve() {

	int n;
	cin >> n;

	string s;
	cin >> s;

	int cnt_ot = 0;
	int cnt_zk = 0;

	for (auto &d: s) {
		cnt_ot += (d == '(');
		cnt_zk += (d == ')');
	}

	if (cnt_zk != cnt_ot) {
		cout << -1 << endl;
		return;
	}

	vector <int> ans(n);

	int bal = 0;

	for (int i = 0; i < n; ++i) {

		if (s[i] == '(')
			bal++;
		else 
			bal--;

		if (bal == 0) 
			ans[i] = 1;
	}

	vector <char> st;

	int prev = -1	;
	int cnt = 0;

	// for (auto &d: ans) 
	// 	cout << d << " ";
	cout << endl;

	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '(') 
			st.push_back(s[i]);
		else if (st.size() && st.back() == '(')
			st.pop_back();
		else 
			st.push_back(')');

		if (ans[i]) {
			if (st.size())
				cnt += i - prev;
			prev = i;
			while (st.size()) 
				st.pop_back();
		}
	}

	cout << cnt << endl;
}