#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long
#define maxn 600000
#define logn 30
int n, m, t;
vector<vector<int>> lst;
vector<int> tin, tout;
int up[maxn][logn];
vector<int> col, d;
vector<int> prv;
int tt = 0;
void dfs(int v, int pr = -1){
    prv[v] = pr;
    for (int l = 1; l < logn; l++){
        up[v][l] = up[up[v][l - 1]][l - 1];
    }
    tin[v]= tt++;
    for (int to :lst[v]){
        if (to != pr){
            d[to] = d[v] + 1;
            up[to][0] = v;
            dfs(to, v);
        }
    }
    tout[v] = tt;
}
bool a(int v, int u){
    return tin[v] <= tin[u] && tin[u] < tout[v];
}
int lca(int v, int u){
    if (a(v, u)) return v;
    if (a(u, v)) return u;
    for (int l = logn - 1; l >= 0; l--){
        if (!a(up[v][l], u)){
            v = up[v][l];
        }
    }
    return up[v][0];
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    lst.assign(n, {});
    prv.assign(n, -1);
    int st = 0;
    for (int i =0; i < n - 1; i ++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        lst[u].push_back(v);
        lst[v].push_back(u);
        if (lst[u].size() > lst[st].size()) st = u;
        if (lst[v].size() > lst[st].size()) st = v;

    }
    //tin.assign(n, 0);
    //tout.assign(n, 0);
    //d.assign(n, 0);
    // dfs(st);
    col.assign(n, -1);
    int bl =0;
    col[st] = 2;
    for (int i = 0; i <m; i++){
        int a, b;
        cin >> a;
        cin >> b;
        a--;
        b--;
        if (a == st || b == st) continue;
        bl = 1;
        if (col[a] == 1){
            if (col[b] == 1){
                cout << -1;
                return -1;
            }
            else{
                col[b] = 3;
            }
        }
        if (col[b] == 1){
            if (col[a] == 1){
                cout << -1;
                return -1;
            }
            else{
                col[a] = 3;
            }
        }
        if (col[b] == 3){
            if (col[a] == 3){
                cout << -1;
                return -1;
            }
            else{
                col[a] = 1;
            }
        }if (col[a] == 3){
            if (col[b] == 3){
                cout << -1;
                return -1;
            }
            else{
                col[b] = 1;
            }
        }
        if (col[a] == -1 && col[b] == -1){
            col[a] = 1;
            col[b] = 3;
        }
    }
    if(bl){
        cout << 3 << "\n";
    }
    else{
        cout << 2 << "\n";
    }
    for (int i =0 ; i < n; i++){
        if (col[i] == -1) col[i] = 1;
        cout << col[i] << " ";
    }






//    int ans =0 ;
//    for (int i = 0; i < m; i++){
//        int a, b;
//        cin >> a >> b;
//        a--;
//        b--;
//        int x = lca(a, b);
//        int cnt = 1;
//        while (a != x){
//            ans = max(ans, cnt);
//            col[a] = cnt++;
//            a = prv[a];
//        }
//        ans = max(ans, cnt);
//        col[a] = cnt++;
//        cnt = cnt + d[b] - d[x] - 1;
//        while (b != x) {
//            ans = max(ans, cnt);
//            col[b] = cnt--;
//            b = prv[b];
//        }
//    }
//    cout << ans << '\n';
//    for (int i = 0; i < n; i++){
//        cout << col[i] << " ";
//    }
    return 0;
}