
#include <iostream>
#include<string>
#include<vector>
#include<cmath>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>

// using namespace __gnu_pbds;
using namespace std;
#define ll long long
#define ld long double
int med(int a, int b, int c) {
    return a + b + c - min(a, min(b, c)) - max(a, max(b, c));
}
vector<vector<int>> g;
vector<bool> used;
vector<vector<int> > way;
vector<pair<int, int >> rout;
int cur_rout;
bool add(int v, int cend)
{
    if(v==cend) {
        way[cur_rout].push_back(v);
        return 1;
    }
    used[v]=1;
    bool ok=0;
    for(auto to:g[v])
    {
        if(!used[to])
        {
            if(add(to, cend))
            {
                way[cur_rout].push_back(v);
                return 1;
            }
        }
    }
    return 0;
}
void rev_way(int f) {
    reverse(way[f].begin(), way[f].end());
}
int orr[20][20];
int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    way.resize(m);
    rout.resize(m);
    used.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v), g[v].push_back(u);
    }
    for (int i = 0; i < m; ++i) {
        cin >> rout[i].first >> rout[i].second;
        rout[i].first--, rout[i].second--;
        used.assign(n, 0);
        cur_rout = i;
        add(rout[i].first, rout[i].second);
        reverse(way[i].begin(), way[i].end());
    }

    int ans = 1e9;
    vector<int> c(n);
    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<int> cur(n), dir(m);
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i) != 0)
                dir[i] = 1;
            else
                dir[i] = 0;
        }
        for (int i = 0; i < m; ++i) {
            if ((dir[i] == 0 && way[i][0] != rout[i].first) || (dir[i] == 1 && way[i][0] != rout[i].second))
                rev_way(i);
        }
        bool ok = 1;
        for (int i = 0; i < 20; ++i) {
            for (int j = 0; j < 20; ++j) {
                orr[i][j] = 0;
            }
        }
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < (int) way[i].size() - 1; ++j) {
                if (orr[way[i][j]][way[i][j + 1]] == -1) {
                    ok = 0;
                    break;
                }
                orr[way[i][j]][way[i][j + 1]] = 1;
                orr[way[i][j + 1]][way[i][j]] = -1;
            }
            if (!ok)
                break;
        }
        if (!ok)
            continue;

        bool any = 1;
        while (any) {
            any = 0;
            for (int i = 0; i < m; ++i) {
                cur[way[i][0]] = max(1, cur[way[i][0]]);
                for (int j = 1; j < way[i].size(); ++j) {
                    if (cur[way[i][j - 1]] + 1 > cur[way[i][j]])
                        cur[way[i][j]] = cur[way[i][j - 1]] + 1, any = 1;
                }
            }
        }
        int curans = -1;
        for (int i = 0; i < n; ++i)
            curans = max(curans, cur[i]);
        if (curans < ans) {
            ans = curans;
            c = cur;
        }
    }

    if (ans >= 1e8) {
        cout << -1;
        return 0;
    }
    cout << max(1, ans) << '\n';
    for (int i = 0; i < n; ++i)
        cout << max(1, c[i]) << ' ';
    return 0;
}