#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

vector<vector<int> >g;
vector<int>st;
vector<pair<int, int> >metro;
vector<int>c;
vector<bool>used;
vector<int>path;

int n, m, t;

bool find_path(int v, int finish, int p = -1){
    if(v == finish){
        return 1;
    }
    for(int i = 0; i < g[v].size(); i++){
        if(p == g[v][i]) continue;
        bool ok = find_path(g[v][i], finish, v);
        if(ok){
            path.push_back(g[v][i]);
            return 1;
        }
    }
    return 0;
}

void solve1(){
    vector<pair<int, int> >start;
    set<pair<int, int> >lower;
    int mn_mx = 1e8;
    vector<int>ans_c;
    for(int mask = 0; mask < (1 << m); mask++){
        lower.clear();
        bool ok = 1;
        for(int i = 0; i < m; i++){
            if(mask & (1 << i)){
                find_path(metro[i].first, metro[i].second);
                path.push_back(metro[i].first);
                reverse(path.begin(), path.end());
                c[metro[i].first] = max(c[metro[i].first], 1);
                for(int j = 1; j < path.size(); j++){
                    c[path[j]] = max(c[path[j]], c[path[j - 1]] + 1);
                }
                for(int j = 0; j < path.size(); j++){
                    if(!ok){
                        break;
                    }
                    for(int k = j + 1; k < path.size(); k++){
                        if(lower.count({path[k], path[j]})){
                            ok = 0;
                            break;
                        }
                        lower.insert({path[j], path[k]});
                    }
                }
                if(!ok) break;
            }
            else{
                find_path(metro[i].second, metro[i].first);
                path.push_back(metro[i].second);
                reverse(path.begin(), path.end());
                c[metro[i].second] = max(c[metro[i].second], 1);
                for(int j = 1; j < path.size(); j++){
                    c[path[j]] = max(c[path[j]], c[path[j - 1]] + 1);
                }
                for(int j = 0; j < path.size(); j++){
                    if(!ok){
                        break;
                    }
                    for(int k = j + 1; k < path.size(); k++){
                        if(lower.count({path[k], path[j]})){
                            ok = 0;
                            break;
                        }
                        lower.insert({path[j], path[k]});
                    }
                }
                if(!ok) break;
            }
            path.clear();
        }
        if(!ok){
            continue;
        }
        int mx = -1;
        for(int i = 0; i < n; i++){
            mx = max(mx, c[i]);
        }
        if(mn_mx > mx){
            mn_mx = mx;
            ans_c = c;
        }
        c.assign(n, 1);
    }
    if(mn_mx == 1e8){
        cout << -1 << endl;
        exit(0);
    }
    cout << mn_mx << endl;
    if(t){
        for(int i = 0; i < n; i++){
            cout << ans_c[i] << ' ';
        }
    }
    exit(0);
}

void solve_pr(int p){
    for(int i = 0; i < m; i++){
        if(metro[i].first == p){
            c[metro[i].second] = 1;
        }
        else if(metro[i].second == p){
            c[metro[i].first] = 1;
        }
        else{
            c[metro[i].first] = 1;
            c[metro[i].second] = 3;
        }
    }
    c[p] = 2;
    int mx = 1;
    for(int i = 0; i < n; i++){
        if(!c[i]){
            c[i] = 1;
        }
        mx = max(mx, c[i]);
    }
    cout << mx << endl;
    for(int i = 0; i < n; i++){
        cout << c[i] << ' ';
    }
    cout << endl;
}

int main()
{
    QuickStart();
    cin >> n >> m >> t;
    g.resize(n);
    st.resize(n);
    c.resize(n);
    for(int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
        st[a - 1]++, st[b - 1]++;
    }
    metro.resize(m);
    for(int i = 0; i < m; i++){
        cin >> metro[i].first >> metro[i].second;
        metro[i].first--, metro[i].second--;
    }
//    for(int i = 0; i < n; i++){
//        if(st[i] == n - 1){
//            solve_pr(i);
//            return 0;
//        }
//    }
    if(n <= 15 && m <= 15){
        solve1();
    }
    return 0;
}
