#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

vector <vector <int>> g;
map <pair <int, int>, int> to;
int target;
vector <int> way;
vector <int> color;

bool dfs(int u, int p = -1) {
	bool fl = (u == target);
	bool can = 1;
	for (auto v : g[u]) {
		if (p == v)
			continue;
		if (to[{min(u, v), max(u, v)}] == -1) {
			to[{min(u, v), max(u, v)}] = v;
			fl |= dfs(v, u);
			continue;
		}
		if (to[{min(u, v), max(u, v)}] == v) {
			fl |= dfs(v, u);
			continue;
		}
		can = false;
		break;
	}
	if (fl) way.push_back(u);
	return fl && can;
}

bool recolor() {
	int par = 0;
	int y = 0;
	reverse(all(way));
	for (int i = 0; i < len(way); i++) {
		if (color[way[i]] <= par) {
			y++;
			color[way[i]] = par + 1;
		}
		par = color[way[i]];
	}
	return (y > 0);
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n, m, t;
	cin >> n >> m >> t;
	g.resize(n);
	color.resize(n, 1);

	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
		to[{min(u, v), max(u, v)}] = -1;
	}

	vector <pair <int, int>> ws(m);
	for (int i = 0; i < m; i++) {
		cin >> ws[i].f >> ws[i].s;
		ws[i].f--; ws[i].s--;
	}

	int last = 0;

	for (int z = 0; z < m + 1; z++) {
		last = 0;
		for (int i = 0; i < m; i++) {
			way.clear();
			target = ws[i].s;
			bool fl = dfs(ws[i].f);
			if (!fl)
				return cout << "-1", 0;
			last += recolor();
			//cerr << way;
		}
	}

	if (last > 0)
		cout << -1;
	else {
		cout << *max_element(all(color)) << '\n';
		cout << color;
	}

	return 0;
}