#include <bits/stdc++.h>

using namespace std;

const int N = 1000;

int root = -1;

vector<int> c(N, 1);
vector<int> g[N];
unordered_set<int> gg[N];


bool dfs(int v, int p, int finish) {
    if (v == finish) {
        return true;
    }

    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }

        bool cur = dfs(u, v, finish);
        if (cur) {
            gg[v].insert(u);
            gg[u].insert(v);
            return true;
        }
    }
    return false;
}

bool dfs2(int v, int p, int finish, int depth) {
    if (v == finish) {
        c[v] = max(c[v], depth);
        return true;
    }

    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }

        bool cur = dfs2(u, v, finish, max(c[v], depth) + 1);
        if (cur) {
            c[v] = max(c[v], depth);

            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m, t;

    cin >> n >> m >> t;

    vector<int> cnt(n, 0);

    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    vector<pair<int, int>> branches;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        cnt[v]++;
        cnt[u]++;
//        dfs(v, -1, u);
        branches.emplace_back(v, u);
    }

    int ans = -1;
    vector<int> ans_c;

    for (int mask = 0; mask < (1 << m); ++mask) {
        fill(c.begin(), c.end(), 1);

        for (int j = 0; j < m + 2; ++j) {
            int tmp = mask;
            for (int i = 0; i < m; ++i) {
                if (tmp % 2) {
                    dfs2(branches[i].first, -1, branches[i].second, 1);
                } else {
                    dfs2(branches[i].second, -1, branches[i].first, 1);
                }

                tmp /= 2;
            }
        }


        vector<int> prev_c = c;

        int tmp = mask;
        for (int i = 0; i < m; ++i) {
            if (tmp % 2) {
                dfs2(branches[i].first, -1, branches[i].second, 1);
            } else {
                dfs2(branches[i].second, -1, branches[i].first, 1);
            }

            tmp /= 2;
        }
        if (prev_c != c) {
            continue;
//            cout << -1 << '\n';
        } else {
            int res = 1;
            for (int i = 0; i < n; ++i) {
                res = max(res, c[i]);
            }

            if (ans == -1 || res < ans) {
                ans = res;
                ans_c = c;
            }
//            cout << res << '\n';
//            for (int i = 0; i < n; ++i) {
//                cout << c[i] << ' ';
//            }
//            cout << '\n';
        }
    }
    cout << ans << '\n';
    if (ans != -1) {
        for (int i = 0; i < n; ++i) {
            cout << ans_c[i] << ' ';
        }
    }

}