#pragma GCC optimize("-Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>


#define F first
#define S second
#define pb push_back
#define ll long long

using namespace std;
using namespace __gnu_pbds;


typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

mt19937 gen(time(0));

const int maxn = 5e5 + 55;
const int inf = 1e9 + 9;
vector <int> g[maxn];
bool isway[maxn];
int cnt[maxn];
int ans[maxn];
pair <int, int> z[maxn];

void dfs(int v, int pr, int cl)
{
    ans[v] = cl;
    for(int to : g[v])
        if (to != pr)
        {
            dfs(to, v, cl + 1);
            if (isway[to]) isway[v] = true;
        }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, t;
    cin >> n >> m >> t;
    for(int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        g[y].pb(x);
        cnt[x]++;
        cnt[y]++;

    }
    int kek = -1;
    for(int i = 0; i < n; ++i)
        if (cnt[i] == n - 1) kek = i;
    bool flag = true;
    for(int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        z[i] = {x, y};
        if (x != kek && y != kek) flag = false;
    }
    if (flag)
    {
        for(int i = 0 ; i < n; ++i)
            ans[i] = 1;
        ans[kek] = 2;
    }
    else
    {
        ans[kek] = 2;
        for(int i = 0; i < m; ++i)
        {
            int x = z[i].F;
            int y = z[i].S;
            if (ans[x] == 0 && ans[y] == 0)
            {
                ans[x] = 3;
                ans[y] = 1;
            }
            if (ans[x] == 0)
            {
                if (ans[y] == 1) ans[x] = 3;
                    else         ans[x] = 1;
            }
            if (ans[y] == 0)
            {
                if (ans[x] == 1) ans[y] = 3;
                    else         ans[y] = 1;
            }
            if (ans[x] == ans[y])
            {
                cout << -1;
                return 0;
            }
        }
    }
    int k = 0;
    for(int i = 0; i < n; ++i)
    {
        if (!isway[i]) ans[i] = 1;
        k = max(k, ans[i]);
    }
    cout << k << '\n';
    for(int i = 0; i < n; ++i)
        cout << ans[i] << ' ';
    return 0;
}
