#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"
#define x first
#define y second 
#define vec vector
#define pii pair<int, int>
#define pb push_back

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	srand(time(0));
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}

const int MOD = 1e9 + 9, MAXN = 500000 + 10, INF = 1e9;
int n, m, t;
vec<int> g[MAXN];
vec<int> path;
bool flag;

void dfs(int v, int p, int b, vec<int> &c) {
	path.pb(v);
	if (v == b) {
		for (int i = 0; i < path.size() - 1; ++i) {
			if (c[path[i]] != 0 && c[path[i + 1]] != 0 && c[path[i]] >= c[path[i + 1]]) {
				flag = true;
			}
		}
		if (c[path[0]] == 0) {
			c[path[0]] = 1;
		}
		for (int i = 1; i < path.size() - 1; ++i) {
			int u = path[i];
			int mx =  0;
			for (auto it : g[u]) {
				if (it != path[i + 1]) {
					mx = max(mx, c[it]);
				}
			}
			c[path[i]] = mx + 1;
		}
		int u = path.back();
		int mx = 0;
		for (auto it : g[u]) {
			mx = max(c[it], mx);
		}
		c[u] = mx + 1;
		return;
	}
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v, b, c);
		}
	}
	path.pop_back();
}

void solve() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
		g[v].pb(u);
	}

	vec<pii> a(m);
	for (int i = 0; i < m; ++i) {
		cin >> a[i].x >> a[i].y;
	}

	vec<int> ans;
	int ansc = INF;
	for (int mask = 0; mask < (1 << m); ++mask) {
		vec<int> c(n + 1);
		flag = false;
		for (int i = 0; i < m; ++i) {
			if ((mask >> i) & 1) {
				dfs(a[i].x, 0, a[i].y, c);
			}
			else {
				dfs(a[i].y, 0, a[i].x, c);
			}
		}
		if (flag) continue;

		int mx =  *max_element(c.begin(), c.end());
		if (mx < ansc) {
			ansc = mx;
			ans = c;
		}
	}

	if (ansc == INF) {
		cout << -1 << endl;
		return;
	}

	cout << ansc << endl;
	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << " ";
	}
	cout << endl;
}