#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma ("Ofast")

#define ll long long

using namespace std;

vector <bool> used;
vector <vector <int>> g;
int m, n;
bool flag;
vector <int> c;

int MAX (vector <int> v) {
    int res = v[0];
    for (int i = 0; i < v.size(); i ++) {
        res = max(res, v[i]);
    }
    return res;
}

void dfs (int s, int prev) {
    used[s] = true;
    for (int i = 0; i < g[s].size(); i ++) {
        if (used[g[s][i]] && g[s][i] != prev) {
            flag = true;
        }
        if (!used[g[s][i]]) {
            dfs(g[s][i], s);
        }
    }
}

void check_cycle () {
    for (int i = 0; i < n; i ++) {
        if (!used[i]) {
            dfs(i,-1);
        }
    }
}

void dfs1 (vector <vector <int>>& v, int& counter, int s) {
    c[s] = counter;
    counter ++;
    for (int i = 0; i < v[s].size(); i ++) {
        if (c[v[s][i]] == 0) {
            dfs1(v, counter, v[s][i]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> n >> m >> t;
    vector < vector <int>> v = vector (n, vector<int>());
    int a, b;
    for (int i = 0; i < n - 1; i ++) {
        cin >> a >> b; a --; b --;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    int y = 0;
    g = vector (n, vector <int>());
    for (int i = 0; i < m; i ++) {
        cin >> a >> b; a --; b --;
        g[a].push_back(b);
        g[b].push_back(a);
        y = a;
    }
    flag = false;
    used = vector <bool> (n, false);
    check_cycle();
    if (flag) {
        cout << -1;
    }
    else {
        c = vector <int>(n, 0);
        int counter = 1;
        dfs1(v,counter, y);
        cout << MAX(c) << "\n";
        for (int i = 0; i < n; i ++) {
            cout << c[i] << " ";
        }
    }
    return 0;
}