#include <bits/stdc++.h>

#pragma GCC optimize("-O3")
#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")


#define fi first
#define se second
#define p_b push_back
#define m_p make_pair
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sqr(x) ((x) * (x))
#define pw(x) (1ll << x)
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define fout(x) {cout << x << "\n"; return;}

using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAXN = 1123456;
const ll N = 5e5;
const ll inf = 1e18;
const ll mod = 1e9 + 7;
const ll mod1 = 998244353;
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
template <typename T> void vout(T s){cout << s << endl; exit(0);}

vector <ll> v[MAXN];
ll cnt[MAXN];
ll tin[MAXN], tout[MAXN], stn, deep[MAXN], p[MAXN];
pll qr[MAXN];
ll n, m, t;

void dfs(ll x, ll pr = 0){
    p[x] = pr;
    tin[x] = ++stn;
    deep[x] = deep[pr] + 1;
    for(auto to : v[x])if(to != pr)dfs(to, x);
    tout[x] = stn;
}

//void solve1(ll root){
//    dfs(root);
//    for(int i = 1; i <= n; i++)ans[i] = 1;
//    for(int i = 0; i < m; i++){
//        ll x = qr[i].fi;
//        if(x == root)x = qr[i].se;
//        while(x != root){
//            if(ans[x] != 1)break;
//            ans[x] = deep[x];
//            x = p[x];
//        }
//    }
//    cout << *max_element(ans + 1, ans + n + 1) << "\n";
//    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
//    cout << "\n";
//    exit(0);
//}

void solve2(){
    vout(-1);
}

void way(ll a, ll b, vector <ll> &res){
    vector <ll> va, vb;
    while(deep[a] > deep[b]){
        va.p_b(a);
        a = p[a];
    }
    while(deep[a] < deep[b]){
        vb.p_b(b);
        b = p[b];
    }

    while(a != b){
        vb.p_b(b);
        b = p[b];
        va.p_b(a);
        a = p[a];
    }
    va.p_b(a);
    reverse(all(vb));
    for(auto i : vb)va.p_b(i);
    res = va;
    va.clear();
    vb.clear();
}

ll f[MAXN], ans[MAXN], dp[MAXN];

vector <int> g[MAXN];

bool find_cycle(ll x){
    if(f[x] == 2)return 0;
    if(f[x] == 1)return 1;
    f[x] = 1;
    for(auto to : g[x]){
        if(find_cycle(to))return 1;
    }
    f[x] = 2;
    return 0;
}

vector <ll> order;

void top_sort(ll x){
    if(f[x])return;
    f[x] = 1;
    for(auto to : g[x])top_sort(to);
    order.p_b(x);
}

void solve_brute(){
    dfs(1ll);
    vector <ll> res;
    ll a, b;
    ll mx = -1;
    for(int musk = 0; musk < pw(m); musk++){
        fill(f + 1, f + n + 1, 0);
        for(int i = 1; i <= n; i++)g[i].clear();
        for(int i = 0; i < m; i++){
            res.clear();
            a = qr[i].fi, b = qr[i].se;
            if((musk & pw(i)))swap(a, b);
            way(a, b, res);
            for(int j = 1; j < sz(res); j++)g[res[j - 1]].p_b(res[j]);
        }
        bool cycle = 0;
        for(int i = 1; i <= n; i++)cycle |= find_cycle(i);
        if(cycle)continue;
        fill(f + 1, f + n + 1, 0);
        order.clear();
        for(int i = 1; i <= n; i++)top_sort(i);
        fill(dp + 1, dp + n + 1, 1);
        for(auto i : order){
            for(auto j : g[i]){
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        ll val = *max_element(dp + 1, dp + n + 1);
        if(val < mx || mx == -1){
            mx = val;
            for(int i = 1; i <= n; i++)ans[i] = dp[i];
        }
    }
    if(mx == -1)vout(-1);
    cout << mx << "\n";
    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
    cout << '\n';
}

//void solve3(){
//    dfs(1ll, 0ll);
//    for(int i = 1; i <= n; i++)ans[i] = 1;
//    for(int step = 0; step < m; step++){
//        vector <ll> wy = way(qr[step].fi, qr[step].se);
//        for(int i = 0; i < sz(wy); i++){
//            ans[wy[i]] = i + 1;
//        }
//    }
//    cout << *max_element(ans + 1, ans + n + 1) << "\n";
//    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
//    cout << "\n";
//    exit(0);
//}

int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    cin >> n >> m >> t;

    for(int i = 1; i < n; i++){
        ll a, b;
        cin >> a >> b;
        v[a].p_b(b);
        v[b].p_b(a);
    }

    for(int i = 0; i < m; i++){
        cin >> qr[i].fi >> qr[i].se;
        cnt[qr[i].fi]++;
        cnt[qr[i].se]++;
    }

    ll x = 0;
    for(int i = 1; i <= n; i++)if(sz(v[i]) == n - 1)x = i;
    //if(x)solve1(x);
    //if(n <= 15 && m <= 15)solve2();
    solve_brute();

    return 0;
}
