#include <bits/stdc++.h>
#define ll long long
#define int ll
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second
#define pb emplace_back
#pragma GCC optimize("Ofast")

using namespace std;

const ll INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, vi &a) {
	for (auto &i : a) in >> i;
	return in;
}

vvi g, fat;
vi depth;
map<ll, bool> ori;
int k = 0;

ll has(int a, int b) {
	return (ll)a * INF + (ll)b;
}

void dfs(int u, int d, int f) {
	depth[u] = d;
	fat[0][u] = f;
	for (auto v : g[u]) {
		if (depth[v] == -1) dfs(v, d + 1, u);
	}
}

int la(int u, int up) {
	for (int i = 0; i < k; ++i) {
		if ((up | (1 << i)) == up) u = fat[i][u];
	}
	return u;
}

int lca(int u, int v) {
	if (depth[u] < depth[v]) swap(u, v);
	u = la(u, depth[u] - depth[v]);
	if (u == v) return u;
	for (int i = k - 1; i >= 0; --i) {
		if (fat[i][u] != fat[i][v]) u = fat[i][u], v = fat[i][v];
	}
	return fat[0][u];
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n, m, t, u, v;
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		cin >> u >> v;
		g[u - 1].pb(v - 1);
		g[v - 1].pb(u - 1);
	}
	depth.resize(n, -1);
	while ((1 << k) < n) k++;
	k++;
	fat.resize(k, vi(n));
	dfs(0, 0, 0);
	for (int i = 1; i < k; ++i) {
		for (int u = 0; u < n; ++u) {
			fat[i][u] = fat[i - 1][fat[i - 1][u]];
		}
	}
	for (int i = 0; i < m; ++i) {
		cin >> u >> v;
		u--, v--;
		int r = lca(u, v);
		while (u != r) {
			int s = fat[0][u];
			if ((ori.find(has(u, s)) == ori.end()) || (ori[has(u, s)])) {
				ori[has(u, s)] = true;
				ori[has(s, u)] = false;
			} else {
				cout << -1 << endl;
				return 0;
			}
			u = s;
		}
		while (v != r) {
			int s = fat[0][v];
			if ((ori.find(has(s, v)) == ori.end()) || (ori[has(s, v)])) {
				ori[has(s, v)] = true;
				ori[has(v, s)] = false;
			} else {
				cout << -1 << endl;
				return 0;
			}
			v = s;
		}
	}
	vvi ng(n), tng(n);
	vi cnt(n, 0);
	for (int u = 0; u < n; ++u) {
		int v = fat[0][u];
		if (u == v) continue;
		if (ori.find(has(u, v)) != ori.end()) {
			if (ori[has(u, v)]) ng[u].pb(v), cnt[v]++, tng[v].pb(u);
			else ng[v].pb(u), cnt[u]++, tng[u].pb(v);
		} else {
			ng[u].pb(v), cnt[v]++, tng[v].pb(u);
		}
	}
	set<pii> least;
	for (int u = 0; u < n; ++u) {
		least.insert({cnt[u], u});
	}
	vi ans(n, 1);
	while (!least.empty()) {
		pii vv = *least.begin();
		assert(vv.fi == 0);
		least.erase(vv);
		int v = vv.se;
		for (auto u : tng[v]) ans[v] = max(ans[v], ans[u] + 1);
		for (auto u : ng[v]) {
			auto it = least.find({cnt[u], u});
			cnt[u]--;
			least.erase(it);
			least.insert({cnt[u], u});
		}
	}
	int mx = 0;
	for (auto i : ans) mx = max(mx, i);
	cout << mx << endl;
	for (auto i : ans) cout << i << ' ';
	cout << endl;
	return 0;
}
