#include <bits/stdc++.h>
#define ld long double
#define ll long long
//#define int long long
#define all(c) (c).begin(), (c).end()
#define pb push_back
#define fast ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define X first
#define Y second
using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const int N = 2e5, inf = 1e9, lg = 20;
int t, pr[N], h[N], a[N], b[N], tin[N], tout[N], d[N][lg], cur, dir[N], used[N], ans[N], mx = 0;
vector <int> v[N], ln[N];
vector <int> r[N], g[N];
vector <int> o;
map <pair<int, int>, int> mp;
void dfs(int x, int p) {
    if(p != -1) {
        h[x] = h[p + 1];
        d[x][0] = p;
        pr[x] = p;
    }
    tin[x] = t++;
    for(auto u : v[x]) {
        if(u == p)
            continue;
        dfs(u, x);
    }
    tout[x] = t++;
}

bool isanc(int x, int y) {
    return tin[x] <= tin[y] && tout[x] >= tout[y];
}

int lca(int x, int y) {
    if(isanc(x, y))
        return x;
    if(isanc(y, x))
        return y;
    for (int i = lg - 1; i >= 0; i--) {
        if(isanc(d[x][i], y))
            continue;
        x = d[x][i];
    }
    return d[x][0];
}

void up(int x, int end) {
    if(x == end)
        return;
    ln[cur].pb(x);
    up(pr[x], end);
}

void ts(int x) {
    used[x] = 1;
    for (auto u : g[x]) {
        if(used[u])
            continue;
        ts(u);
    }
    o.pb(x);
}

void color(int x, int cl) {
    ans[x] = cl;
    mx = min(mx, cl);
    used[x] = 1;
    for (auto u : g[x]) {
        if(used[u])
            continue;
        color(u, cl - 1);
    }
}

signed main() {
    fast;
    int n, m, f, type;
    cin >> n >> m >> type;
    for (int i = 0; i < n - 1; i++) {
        cin >> f >> t;
        f--, t--;
        mp[{f, t}] = i + 1;
        v[f].pb(t);
        v[t].pb(f);
    }
    dfs(0, -1);
    for (int k = 1; k < lg; k++) {
        for (int i = 0; i < n; i++) {
            d[i][k] = d[d[i][k - 1]][k - 1];
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> a[i] >> b[i];
        a[i]--, b[i]--;
        int l = lca(a[i], b[i]);
        cur = i;
        up(b[i], l);
        ln[cur].pb(l);
        up(a[i], l);
        reverse(all(ln[cur]));
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < ln[i].size() - 1; j++) {
            int num = mp[{ln[i][j], ln[i][j + 1]}];
            r[num].pb(i);
            r[num].pb(-i);
        }
    }
    for (int i = 0; i < m; i++) {
        int z = -1;
        for (int j = 0; j < ln[i].size() - 1; j++) {
            int num = mp[{ln[i][j], ln[i][j + 1]}];
            for(auto u : r[num]) {
                if(dir[abs(u)] == 0)
                    continue;
                int c;
                if(u < 0)
                    c = 3 - dir[-u];
                else
                    c = dir[u];
                if(z != -1 && c != z) {
                    cout << -1;
                    return 0;
                }
                z = c;
            }
        }
        z = max(z, 1);
        for (int j = 0; j < ln[i].size() - 1; j++) {
            int num = mp[{ln[i][j], ln[i][j + 1]}];
            for(auto u : r[num]) {
                dir[abs(u)] = z;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < ln[i].size() - 1; j++) {
            if(dir[i] == 1) {
                g[ln[i][j]].pb(ln[i][j + 1]);
            }
            else {
                g[ln[i][j + 1]].pb(ln[i][j]);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if(!used[i])
            ts(i);
    }
    reverse(all(o));
    memset(used, 0, sizeof used);
    for (auto u : o) {
        if(!used[u]) {
            color(u, 0);
        }
    }
    cout << -mx + 1 << endl;
    for (int i = 0; i < n; i++) {
        cout << -ans[i] + 1 << ' ';
    }
}
