
 #pragma GCC optimize("O3")
 #pragma GCC optimize("unroll-loops", "fast-math")
 #pragma GCC target("avx", "avx2")

#include<bits/stdc++.h>


using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;



#define int long long
#define F first
#define S second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

void accell() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int inf = 1e18;
const int N = 5e5;
const int K = 47;
const int mod = 1e9 + 7;
int n, m, t;
int p[N], d[N];
bool used[N];
vector<int>ts;
vector<int>g[N];
vector<int>g1[N];
vector<pair<int, int> > pt;

void dfs0(int v, int par = -1) {
    p[v] = par;
    for (int to : g[v]) {
        if (to != par) {
            d[to] = d[v] + 1;
            dfs0(to, v);
        }
    }
}

void dfs(int v) {
    used[v] = true;
    for (int to : g1[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    ts.push_back(v);
}
int get_lca(int a, int b) {
    if (d[a] < d[b])
        swap(a, b);
    while (d[a] > d[b]) a = p[a];
    while (a != b) a = p[a], b = p[b];
    return a;
}

void make_path(int a, int b) {
    int cc = get_lca(a, b);
    while (a != cc) {
        g1[a].push_back(p[a]);
        a = p[a];
    }
    while (b != cc) {
        g1[p[b]].push_back(b);
        b = p[b];
    }
}

vector<int> calc() {
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);
    reverse(all(ts));
    vector<int>pos(20);
    for (int i = 0; i < ts.size(); ++i)
        pos[ts[i]] = i;
    vector<int>dp(n, -1);
    for (int i = 0; i < n; ++i) {
        for (auto to : g1[i]) {
            if (pos[i] > pos[to])
                return dp;
        }
    }
    dp[0] = 1;
    for (int i = 0; i < ts.size(); ++i) {
        if (dp[i] == -1) {
            dp[i] = 1;
        }
        for (int to : g1[ts[i]]) {
            dp[pos[to]] = max(dp[pos[to]], dp[i] + 1);
        }
    }
    vector<int>ans(n, -1);
    // cout << ts[0] << endl;
    for (int i = 0; i < ans.size(); ++i) {
      //  cout << ts[i] << ' ' << dp[i] << endl;
        ans[ts[i]] = dp[i];
    }
    return ans;
}

void solve() {
    vector<int>res(n, -1);
    int mn = 1e18;
    for (int mask = 0; mask < (1 << m); ++mask) {
        ts.clear();
        for (int i = 0; i < n; ++i) g1[i].clear();
        fill(used, used + n, false);
        for (int i = 0; i < m; ++i) {
            int a = pt[i].first;
            int b = pt[i].second;
            if ((1 << i) & mask) {
                swap(a, b);
            }
            make_path(a, b);
        }
        vector<int>ans = calc();
        if (ans[0] == -1) {
            continue;
        }
        int mx = 0;
        for (int i = 0; i < ans.size(); ++i) {
            mx = max(mx, ans[i]);
        }
        if (mx < mn) {
            mn = mx;
            res = ans;
        }
    }
    if (mn == 1e18) {
        cout << -1 << endl;
        exit(0);
    }
    cout << mn << endl;
    for (int i = 0; i < n; ++i) {
        cout << res[i] << ' ';
    }
}


signed main() {
    accell();
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs0(0);
    pt.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> pt[i].first >> pt[i].second;
    for (int i = 0; i < m; ++i) {
        pt[i].first--, pt[i].second--;
    }
    if (m <= 15)
        solve();
    return 0;
}

