#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,avx,avx2")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

mt19937 rnd;

ll const N = 5e5 + 1, M = 228228227, INF = 1e18, P = 257;
ld const EPS = 1e-10;

void FastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

/*void zfunc(string s) {
    vector<ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (r >= i) {
            z[i] = min(z[i - l], r - i + 1);
        }

        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (i + z[i] - 1 > r) {
            r = i + z[i] - 1;
            l = i;
        }
    }
}

void pfunc(string s) {
    vector<ll> p(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        ll j = p[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        p[i] = j;
    }
}

ll tree[4 * N], mode[4 * N];

void Build(ll v, ll l , ll r) {
    if (r - l == 1) {
        tree[v] = 0;
    }

    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void Upd(ll v, ll l, ll r, ll pos, ll val) {
    if (r - l == 1 && l == pos) {
        tree[v] = val;
        return;
    }

    if (l > pos || r <= pos) {
        return;
    }

    ll m = (l + r) / 2;
    Upd(v * 2, l, m, pos, val);
    Upd(v * 2 + 1, m, r, pos, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return tree[v];
    }

    ll m = (l + r) / 2;
    return Get(v * 2, l, m, ql, qr) + Get(v * 2 + 1, m, r, ql, qr);
}

struct Node {
    ll x, sz, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rnd();
    }
};

ll GetSz(Node* tree) {
    return (tree ? tree->sz : 0);
}

void Update(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (! left) {
        return right;
    }
    if (! right) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        Update(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        Update(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (! tree) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        Update(tree);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        Update(tree);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        Update(tree);
        return {tree, tmp.second};
    }
}

Node* Ins(Node* tree, ll x, ll pos) {
    Node* node = new Node(x);
    auto tmp = Split(tree, pos - 1);
    return Merge(Merge(tmp.first, node), tmp.second);
}*/

vector<ll> g[N];
vector<ll> way;
ll d[N], t = 0, lg[2 * N], st[30][2 * N], tin[N];

void Dfs(ll v, ll p, ll dep) {
    way.push_back(v);
    d[v] = dep;
    tin[v] = t++;
    for (int i = 0; i < g[v].size(); ++i) {
        if (g[v][i] == p) {
            continue;
        }
        Dfs(g[v][i], v, dep + 1);
        way.push_back(v);
        t++;
    }
}

ll GetV(ll l, ll r) {
    ll log = lg[r - l + 1];
    ll left = d[st[log][l]];
    ll right = d[st[log][r - (1 << log) + 1]];
    if (left < right) {
        return st[log][l];
    }
    else {
        return st[log][r - (1 << log) + 1];
    }
}

int main() {
    //FastIO();

    ll n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    ll cur = 0;
    lg[0] = 0;
    for (int i = 1; i < 2 * N; ++i) {
        if ((1 << (cur + 1)) == i) {
            ++cur;
        }
        lg[i] = cur;
    }

    Dfs(1, -1, 0);

    for (int i = 0; i < way.size(); ++i) {
        st[0][i] = way[i];
        //cout << way[i] << ' ';
    }
    //cout << '\n';

    for (int i = 1; i < 30; ++i) {
        for (int j = 0; j <= (ll)way.size() - (1 << i); ++j) {
            if (d[st[i - 1][j]] < d[st[i - 1][j + (1 << (i - 1))]]) {
                st[i][j] = st[i - 1][j];
            }
            else {
                st[i][j] = st[i - 1][j + (1 << (i - 1))];
            }
        }
    }

    vector<ll> ans(n + 1, INF);
    ll k = 0;

    for (int i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;
        ll lca = GetV(min(tin[a], tin[b]), max(tin[a], tin[b]));
        ll ind = tin[a], cur = 1, sz = d[a] + d[b] - 2 * d[lca] + 1;
        k = max(k, sz);
        //cout << lca << '\n';
        while (way[ind] != lca) {
            ans[way[ind]] = cur++;
            ind = tin[way[ind - 1]];
        }
        ans[lca] = cur++;
        ind = tin[b];
        cur = 0;
        while (way[ind] != lca) {
            ans[way[ind]] = sz - cur;
            ++cur;
            //cout << way[ind] << ' ' << way[ind - 1] << '\n';
            ind = tin[way[ind - 1]];
        }
    }

    cout << k << '\n';
    for (int i = 1; i <= n; ++i) {
        if (ans[i] == INF) {
            cout << 1 << ' ';
        }
        else {
            cout << ans[i] << ' ';
        }
    }

    return 0;
}
