#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define _ <<' '<<

using namespace std;

mt19937 gen(time(0));

const int N = 1e5 + 7;
const int M = 1e9 + 7;

int n, m, t, T, a[N], b[N], up[N][20], in[N], out[N], u[N*2], A[N], us[N], c[N];
vector<int> G[N], g[N], del[N], z[N];
unordered_set<int> all[N];

void add(int x, int y){
//    cerr << x << ' ' << y << endl;
    G[x + n].pb(y + n);
    G[y + n].pb(x + n);
    x *= -1;
    y *= -1;
    G[x + n].pb(y + n);
    G[y + n].pb(x + n);
}

bool upp(int v, int u){
    return in[v] <= in[u] && out[u] <= out[v];
}

int get(int v, int u){
    if (upp(v, u)) return v;
    for (int i = 19; i >= 0; i--)
        if (!upp(up[v][i], u)) v = up[v][i];
    return v;
}

void df(int v, int p){
    in[v] = ++T;
    up[v][0] = p;
    for (int i = 1; i < 20; i++) up[v][i] = up[up[v][i - 1]][i - 1];
    for (auto to : g[v]){
        if (to == p) continue;
        df(to, v);
    }
    out[v] = ++T;
}

void dfs(int v, int p){
//    for (auto it : del[v]) all[v].erase(it);
    for (auto to : g[v]){
        if (to == p) continue;
        dfs(to, v);
        if (all[to].size() > all[v].size()) swap(all[v], all[to]);
        if (!all[to].empty()){
            add(*all[v].begin(), *all[to].begin());
        }
        for (auto it : all[to]) all[v].insert(it);
    }
    if (!all[v].empty()) A[v] = (*all[v].begin());
    for (auto it : del[v]) all[v].erase(it);
}

void Dfs(int v){
    u[v] = 1;
    for (auto to : G[v]){
        if (u[to]) continue;
        Dfs(to);
    }
}

void solve(int v){
    us[v] = 1;
//    cerr << v << endl;
    for (auto to : z[v]){
        solve(to);
        c[v] = max(c[v], c[to] + 1);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++){
        int x, y;
        cin >> x >> y;x--;y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    df(0, 0);
    for (int i = 1; i <= m; i++){
        cin >> a[i] >> b[i];a[i]--;b[i]--;
        int da = get(a[i], b[i]);
        int db = get(b[i], a[i]);
        if (!upp(a[i], b[i]) && !all[a[i]].empty()) add(-i, *all[a[i]].begin());
        if (!upp(a[i], b[i])) all[a[i]].insert(-i);
        del[da].pb(-i);
        if (!upp(b[i], a[i]) && !all[b[i]].empty()) add(i, *all[b[i]].begin());
        if (!upp(b[i], a[i])) all[b[i]].insert(i);
        del[db].pb(i);
    }
    dfs(0, 0);
    for (int i = 1; i <= m; i++){
        int a = -i + n;
        int b = i + n;
        if (!u[a]) Dfs(a);
        if (u[a] && u[b]){
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < n; i++){
        c[i] = 1;
        if ((!i) || (!A[i])) continue;
        else if (u[A[i] + n]) z[i].pb(up[i][0]);
        else z[up[i][0]].pb(i);
    }
    for (int i = 0; i < n; i++) if (!us[i]) solve(i);
    int res = 0;
    for (int i = 0; i < n; i++) res = max(res, c[i]);
    cout << res << endl;
    for (int i = 0; i < n; i++) cout << c[i] << ' ';
    return 0;
}
