#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
const int MAXN = (1 << 20), MAXM = (1 << 20);

struct path
{
    int from, to;
} p[MAXM];

vector < int > t[MAXN];
int n, m, T, used[MAXN], k = 1, sp[MAXN];

bool dfs(int beg, int p = -1, int cnt = 1)
{
    if (sp[beg] == 1)
    {
        used[beg] = cnt;
        return true;
    }

    int sz = t[beg].size();
    bool is = false;
    for (int i = 0; i < sz; i ++)
    {
        int to = t[beg][i];
        if (to == p)
            continue;
        if (dfs(to, beg, cnt + 1))
        {
            used[beg] = cnt;
            is = true;
        }
    }
    return is;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> T;
    for (int i = 1; i < n; i ++)
    {
        int v1, v2;
        cin >> v1 >> v2;
        t[v1].push_back(v2);
        t[v2].push_back(v1);
    }

    for (int i = 1; i <= m; i ++)
    {
        cin >> p[i].from >> p[i].to;
        sp[p[i].from] = 1;
    }

    dfs(p[1].to);

    int maxx = 0;
    for (int i = 1; i <= m; i ++)
        if (used[p[i].from] > maxx)
        maxx = used[p[i].from];

    cout << maxx << endl;
    for (int i = 1; i <= n; i ++)
    {
        if (used[i] == 0)
            cout << 1 << " ";
        else
            cout << maxx - used[i] + 1 << " ";
    }
    cout << endl;
    return 0;
}
/**
8 3 1
1 2
2 3
3 8
3 7
3 6
3 4
4 5
2 8
5 8
7 8
*/

