#include <bits/stdc++.h>

using namespace std;

#define time time179
#define prev prev179

vector<vector<int> > gr;
vector<int> tin, tout;
vector<vector<int> > prev;
vector<int> d;
int depth = 0;
int time = 0;

void dfs(int x)
{
    if (tin[x] != -1) return;
    tin[x] = time++;
    d[x] = depth++;
    for (int i = 1; i < 30; ++i)
    {
        prev[x][i] = prev[prev[x][i - 1]][i - 1];
    }
    for (int i = 0; i < gr[x].size(); ++i)
    {
        if (tin[gr[x][i]] == -1) prev[gr[x][i]][0] = x;
        dfs(gr[x][i]);
    }
    depth--;
    tout[x] = time++;
}

bool son(int x, int y)
{
    if (tin[y] <= tin[x] && tout[x] <= tout[y]) return true;
    return false;
}

int LCA(int x, int y)
{
    if (son(x, y)) return y;
    if (son(y, x)) return x;
    int ans = x;
    for (int i = 29; i > -1; --i)
    {
        if (!son(y, prev[ans][i]))
            ans = prev[ans][i];
    }
    ans = prev[ans][0];
    return ans;
}

vector<bool> used;
vector<int> color;

void paint(int x)
{
    if (used[x]) return;
    used[x] = true;
    color[x] = 1;
    for (int i = 0; i < gr[x].size(); ++i)
    {
        paint(gr[x][i]);
        color[x] = max(color[x], color[gr[x][i]] + 1);
    }
    if (color[x] == 0) cout << "WHAT???" << endl;
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    tin.resize(n, -1);
    tout.resize(n);
    d.resize(n);
    prev.resize(n, vector<int> (30));
    for (int i = 0; i < 30; ++i)
        prev[0][i] = 0;
    dfs(0);
    vector<pair<int, int> > all(m);
    for (int i = 0; i < m; ++i)
        cin >> all[i].first >> all[i].second;
    int ans = 1e9;
    vector<int> b(n, -1);
    for (int i = 0; i < (1 << (n - 1)); ++i)
    {
        vector<bool> up(n);
        for (int j = 0; j < n - 1; ++j)
            up[j + 1] = ((i >> j) & 1);
        bool good = true;
        for (int j = 0; j < m; ++j)
        {
            int u = all[j].first - 1;
            int v = all[j].second - 1;
            int lca = LCA(u, v);
            bool flag1 = true, flag2 = true;
            while (u != lca)
            {
                if (up[u]) flag2 = false;
                else flag1 = false;
                u = prev[u][0];
            }
            while (v != lca)
            {
                if (up[v]) flag1 = false;
                else flag2 = false;
                v = prev[v][0];
            }
            if (!flag1 && !flag2)
                good = false;
        }
        if (!good) continue;
        gr.resize(0);
        gr.resize(n);
        for (int j = 1; j < n; ++j)
        {
            int u = j, v = prev[j][0];
            if (up[j])
            {
                gr[u].push_back(v);
            }
            else
            {
                gr[v].push_back(u);
            }
        }
        used.resize(0);
        used.resize(n, false);
        color.resize(0);
        color.resize(n);
        for (int j = 0; j < n; ++j)
        {
            if (!used[j])
                paint(j);
        }
        int mx = 0;
        for (int j = 0; j < n; ++j)
            mx = max(mx, color[j]);
        if (mx <= ans)
        {
            ans = mx;
            b = color;
        }
    }
    cout << ans << endl;
    for (int i = 0; i < n; ++i) cout << b[i] << " ";
}

