#include <bits/stdc++.h>
using namespace std;
const int maxn = 501000;
int n, m, t;
int lca[maxn][20], d[maxn], dp[maxn], used[maxn];
vector<int> g[maxn], h[maxn];
vector<int> ss;

void dfs(int v, int f = 0) {
    lca[v][0] = f;
    d[v] = d[f] + 1;
    for (auto i : g[v]) {
        if (i == f) continue;
        dfs(i, v);
    }
}

void ts(int v) {
    used[v] = 1;
    for (auto i : h[v]) {
        if (!used[i]) ts(i);
    }
    ss.push_back(v);
}

int get_lca(int u, int v) {
    if (u == v) return v;
    if (d[u] < d[v]) swap(u, v);
    for (int L = 19; L >= 0; L--) {
        if (d[u] - (1 << L) >= d[v]) u = lca[u][L];
    }
    if (u == v) return u;
    for (int L = 19; L >= 0; L--) {
        if (lca[u][L] != lca[v][L]) u = lca[u][L], v = lca[v][L];
    }
    return lca[u][0];
}

vector<int> get_path(int u, int v) {
    int c = get_lca(u, v);
    //cout << "lca " << u << " " << v << " " << c << endl;
    vector<int> a;
    while (u != c) a.push_back(u), u = lca[u][0];
    vector<int> k = {v};
    while (v != c) k.push_back(lca[v][0]), v = lca[v][0];
    reverse(k.begin(), k.end());
    for (auto i : k) a.push_back(i);
    return a;
}

set<pair<int, int>> S;

signed main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1);
    for (int L = 1; L < 20; L++) {
        for (int i = 0; i <= n; i++) lca[i][L] = lca[lca[i][L - 1]][L - 1];
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        vector<int> tmp = get_path(a, b);
        for (int i = 0; i < tmp.size() - 1; i++) {
            h[tmp[i]].push_back(tmp[i + 1]);
            if (S.count({tmp[i + 1], tmp[i]})) {
                cout << -1;
                return 0;
            }
            S.insert({tmp[i], tmp[i + 1]});
        }
    };
   /* for (int i = 0; i <= n; i++) {
        for (auto j : h[i]) cout << i << " " << j << endl;
    }*/
    for (int i = 1; i <= n; i++) {
        if (!used[i]) ts(i);
    }
    for (auto i : ss) {
        if (h[i].empty()) dp[i] = 1;
        else {
            int mx = 1;
            for (auto j : h[i]) mx = max(mx, dp[j]);
            dp[i] = mx + 1;
        }
    }
    int amx = 0;
    for (int i = 0; i <= n; i++) amx = max(amx, dp[i]);
    cout << amx << "\n";
    for (int i = 1; i <= n; i++) cout << (dp[i] ? amx - dp[i] + 1 : amx) << " ";
}
