#include <bits/stdc++.h>

using namespace std;

int n;
vector<vector<int> > g;
vector<int> c;
vector<vector<int> > v;
vector<bool> used;

vector<int> ans, cnt;

void find_way(int u, int b){
    cnt.push_back(u);
    used[u] = 1;
    if(u == b){
        ans = cnt;
        return;
    }
    for(int i = 0; i < g[u].size(); ++i){
        if(used[g[u][i]])
            continue;
        find_way(g[u][i], b);
    }
    cnt.pop_back();
}

void make_way(int a, int b){
    find_way(a, b);
    v.push_back(ans);
    for(int i = 1; i < ans.size(); ++i)
        c[ans[i]] = max(c[ans[i]], c[ans[i - 1]] + 1);
    ans.clear(), cnt.clear();
    used.assign(n, 0);
}

int main()
{
    int t, m;
    cin >> n >> m >> t;
    c.resize(n, 1);
    g.resize(n);
    used.resize(n);
    for(int i = 0; i < n - 1; ++i){
        int a, b; cin >> a >> b; --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b; --a, --b;
        make_way(a, b);
    }
    for(int i = 0; i < v.size(); ++i){
        for(int j = 1; j < v[i].size(); ++j){
            if(c[v[i][j]] <= c[v[i][j - 1]]){
                cout << -1;
                return 0;
            }
        }
    }
    int a = -1e9;
    for(int i = 0; i < n; ++i)
        a = max(a, c[i]);
    cout << a << '\n';
    for(int i = 0; i < n; ++i)
        cout << c[i] << ' ';
    return 0;
}
