#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 5e5 + 5;

vector<int> g[N];
set<int> finish[N];
int c[N];

int n, m, t;

void dfs(int v, int p, int start) {
	if (finish[start].find(v) != finish[start].end()) {
		c[v] = 1;
		return;
	}
	for (auto& to : g[v]) {
		if (to == p) continue;
		dfs(to, v, start);
		c[v] = max(c[v], c[to] + 1);
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		finish[x].insert(y);
		finish[y].insert(x);
	}
	for (int i = 1; i <= n; ++i) {
		if (!c[i]) {
			dfs(i, 0, i);
		}
	}
	cout << *max_element(c, c + N) << endl;
	for (int i = 1; i <= n; ++i) {
		cout << c[i] << ' ';
	}
}