#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N = 20;
int n, m, tp;
vector<int> g[N];
int a[N], b[N], p[N], h[N], ans[N];

void dfs(int v, int par) {
    p[v] = par;
    for (int u : g[v]) {
        if (u != par) {
            h[u] = h[v] + 1;
            dfs(u, v);
        }
    }
}

void path(int v, int u) {
    vector<int> x, y;
    while (v != u) {
        if (h[v] >= h[u]) {
            x.push_back(v);
            v = p[v];
        } else {
            y.push_back(u);
            u = p[u];
        }
    }
    x.push_back(v);
    x.insert(x.end(), y.rbegin(), y.rend());
    int delta = 1;
    for (int i = 0; i < (int)x.size(); ++i) {
        delta = max(delta, ans[x[i]] - i);
    }
    for (int i = 0; i < (int)x.size(); ++i) {
        ans[x[i]] = i + delta;
    }
}

main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> tp;
    for (int v, u, i = 0; i < n - 1; ++i) {
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, -1);
    fill_n(ans, n, 1);
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i];
        --a[i];
        --b[i];
        path(a[i], b[i]);
    }
    cout << *max_element(ans, ans + n) << endl;
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << endl;
}
