#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
const int MAXN = (1 << 20), MAXM = (1 << 20);

struct path
{
    int from, to;
}p[MAXM];

set < pair < int, int > > s;

vector < int > t[MAXN];
int n, m, T, used[MAXN], k = 1;
bool ans;

bool dfs(int beg, int d, int p = -1)
{
    if (beg == d)
        return true;
    int sz = t[beg].size();
    for (int i = 0; i < sz; i ++)
    {
        int nb = t[beg][i];
        if (nb == p)
            continue;
        if (dfs(nb, d, beg))
        {
            if (s.find(make_pair(nb, beg)) != s.end())
            {
                cout << "-1" << endl;
                exit(0);
            }
            s.insert(make_pair(beg, nb));

            if (used[nb] <= used[beg])
                ans = false;
            return true;
        }
    }
    return false;
}
void check()
{
    bool done = true;
    for (int i = 1; i <= m; i ++)
    {
        ans = true;
        dfs(p[i].from, p[i].to);
        if (!ans)
        {
            done = false;
            break;
        }
    }

    if (done)
    {
        cout << k << endl;
        for (int i = 1; i <= n; i ++)
            cout << used[i] << " ";
        cout << endl;
        exit(0);
    }
}

void gen(int pos)
{
    if (pos == n + 1)
    {
        check();
        return;
    }

    for (int i = 1; i <= k; i ++)
    {
        used[pos] = i;
        gen(pos + 1);
    }
}

void test(int pos)
{
    if (pos == m + 1)
    {
        s.clear();
        gen(1);
    }
    else
    {
        test(pos + 1);
        swap(p[pos].from, p[pos].to);
        test(pos + 1);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> T;

    for (int i = 1; i < n; i ++)
    {
        int v1, v2;
        cin >> v1 >> v2;
        t[v1].push_back(v2);
        t[v2].push_back(v1);
    }

    for (int i = 1; i <= m; i ++)
        cin >> p[i].from >> p[i].to;

    while(true)
    {
        test(1);
        k ++;
    }

    cout << "-1" << endl;
    return 0;
}
/**
3 2 1
1 2
2 3
1 3
2 3
*/
