#pragma GCC optimize("-Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>


#define F first
#define S second
#define pb push_back
#define ll long long

using namespace std;
using namespace __gnu_pbds;


typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

mt19937 gen(time(0));

const int maxn = 30;
const int inf = 1e9 + 9;
vector <int> g[maxn];
vector <int> kek;
int t;

void find_path(int v, int pr)
{
    kek.pb(v);
    if (kek.back() == t) return;
    for(int to : g[v])
        if (to != pr)
        {
            find_path(to, v);
            if (kek.back() == t) break;
        }
    if (kek.back() == t) return;
    kek.pop_back();
    return;
}

int n, m, TYPE;
int ans[maxn];
int mn = maxn;
pair <int, int> z[maxn];
vector <int> path[maxn];
int f[maxn];

void solve(int cnt)
{
    if (cnt == n)
    {
        bool flag = true;
        for(int i = 0; i < m && flag; ++i)
        {
            int cnt = f[path[i][1]] - f[path[i][0]];
            if (cnt <= 0) flag = false;
            for(int j = 2; j < int(path[i].size()) && flag; ++j)
                if (cnt * (f[path[i][j]] - f[path[i][j - 1]]) <= 0) flag = false;
        }
        if (flag)
        {
            int cur = 0;
            for(int i = 0; i < n; ++i)
                cur = max(cur, f[i]);
            if (cur < mn)
            {
                mn = cur;
                for(int i = 0; i < n; ++i)
                    ans[i] = f[i];
            }
        }
        return;
    }
    for(f[cnt] = 1; f[cnt] <= n; ++f[cnt])
        solve(cnt + 1);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> m >> TYPE;
    for(int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        g[y].pb(x);
    }
    for(int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        t = y;
        kek.clear();
        find_path(x, x);
        path[i] = kek;
    }
    solve(0);
    if (mn == maxn) cout << -1;
    else
    {
        cout << mn << '\n';
        for(int i = 0; i < n; ++i)
            cout << ans[i] << ' ';
    }
    return 0;
}
