#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii pair<int, int>
//#define int ll
#define vi vector<int>
#define pb push_back
using namespace std;

const int maxn = 5e5 + 50;

vi r[maxn], used(maxn * 2);
vi gr[maxn * 2];
vi g[maxn];
vi ng[maxn];
map<pii, int> mp;
int par[maxn];
int tim = 0;
int tin[maxn], tout[maxn];
vi nice[maxn];

void dfs(int v, int p = -1) {
    tin[v] = tim++;
    par[v] = max(p, 0LL);
    for (auto &u : r[v]) {
        if (u != p)
            dfs(u, v);
    }
    tout[v] = tim++;
}

bool inside(int a, int b) {
    return tin[a] >= tin[b] && tout[a] <= tout[b];
}

void dfs2(int v, int kek = 1) {
    //cout << v << endl;
    used[v] = kek;
    for (auto &u : gr[v]) {
        if (!used[u]) {
            dfs2(u, kek + 1);
        } else {
            if ((used[v] - used[u]) % 2 == 0) {
                cout << -1 << endl;
                exit(0);
            }
        }
    }
}

vi used2(maxn);

void dfs3(int v, int p = -1) {
    used2[v] = 1;
    for (auto &u : ng[v]) {
        if (u != p) {
            if (used[u] % 2) {
                g[v].pb(u);
            } else {
                g[u].pb(v);
            }
            dfs3(u, v);
        }
    }
}

vi top;
void dfs4(int v) {
    used[v] = 1;
    for (auto &u : g[v]) {
        if (!used[u])
            dfs4(u);
    }
    top.pb(v);
}

int col[maxn];

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        r[a].pb(b);
        r[b].pb(a);
    }
    vector<pii> p;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        p.pb({a, b});
    }
    dfs(0);
    for (int i = 0; i < m; ++i) {
        if (inside(p[i].f, p[i].s)) {
            int k = p[i].f;
            while (k != p[i].s) {
                gr[n + i].pb(k);
                gr[k].pb(n + i);
            ng[par[k]].pb(k);
                k = par[k];
            }
            continue;
        } else if (inside(p[i].s, p[i].f)) {
            int k = p[i].s;
            while (k != p[i].f) {
                //cout << "CAN:T" << k + 1 << ' ' << n + i + 1 << endl;
                gr[n + i].pb(k);
                gr[k].pb(n + i);
            ng[par[k]].pb(k);
                k = par[k];
            }
            continue;
        }
        int k = p[i].s;
        while (!inside(p[i].f, k)){
            //cout << "CAN:T" << k + 1 << ' ' << p[i].f + 1 << ' ' << par[k] + 1 << endl;
            //cout << inside(p[i].f, par[k]) << endl;
            gr[k].pb(p[i].f);
            gr[p[i].f].pb(k);
            ng[par[k]].pb(k);
            k = par[k];
        }
        k = p[i].f;
        while (!inside(p[i].s, k)) {
            //cout << "CAN:T" << k + 1 << ' ' << p[i].s + 1 << endl;
            gr[k].pb(p[i].s);
            gr[p[i].s].pb(k);
            ng[par[k]].pb(k);
            k = par[k];
        }
    }
    for (int i = 0; i < n + m; ++i) {
        if (!used[i])
            dfs2(i);
    }
    int order[n];
    iota(order, order + n, 0);
    sort(order, order + n, [](int a, int b) {
         return tin[a] < tin[b];
    });
    for (auto &i : order)
        if (!used2[i])
            dfs3(i);
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            dfs4(i);
    }
    int k = 0;
    //reverse(top.begin(), top.end());
    for (auto &i : top) {
        int max = 1;
        for (auto &j : g[i]) {
    //        cout << i << ' ' << j << endl;
            max = std::max(max, col[j] + 1);
        }
        col[i] = max;
        if (max > 1e7) {
            cout << -1 << endl;
            exit(0);
        }
        k = std::max(k, max);
    }
    cout << k << endl;
    for (int i = 0; i < n; ++i) {
        cout << col[i] << ' ';
    }
    cout << endl;
    return 0;
}
