#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;
#define endl '\n'
#define MAXN 500005
int br, lines, t;
vector<int> tree[MAXN];
unordered_set<int> graph[MAXN];
int depth[MAXN], parent[MAXN], result[MAXN], maximum;
void calcd(int vertex, int dep, int p){
	parent[vertex] = p; depth[vertex] = dep;
	for(int i : tree[vertex]){
		if(i != p){
			calcd(i, dep + 1, vertex);
		}
	}
}
vector<int>* one, *two;
bool inside[MAXN], u[MAXN], queue[MAXN];
inline void operation(int from, int to){
	one = new vector<int>(); two = new vector<int>();
	while(depth[from] > depth[to]){
		one->push_back(from); from = parent[from];
	}
	while(depth[to] > depth[from]){
		two->push_back(to); to = parent[to];
	}
	while(from != to){
		one->push_back(from); from = parent[from];
		two->push_back(to); to = parent[to];
	}
    one->push_back(to); two->push_back(to);
	for(int i = 1; i < one->size(); ++i){
		int cur = (*one)[i], bef = (*one)[i - 1];
		graph[bef].insert(cur);
		inside[cur] = 1;
	}
	for(int i = two->size() - 2; i >= 0; --i){
		int cur = (*two)[i], bef = (*two)[i + 1];
		graph[bef].insert(cur);
		inside[cur] = 1;
	}
}
void dfs(int vertex, int value){
	u[vertex] = 1; queue[vertex] = 1; result[vertex] = value;
	for(int i : graph[vertex]){
		if(queue[i]){
			cout << -1 << endl; exit(0);
		}
		dfs(i, value + 1);
	}
	queue[vertex] = 0;
}
int main(){
	cin.tie(0); ios::sync_with_stdio(false);
	maximum = 1;
	cin >> br >> lines >> t;
	for(int i = 0; i < br - 1; ++i){
		int from, to; cin >> from >> to;
		tree[from].push_back(to); tree[to].push_back(from);
	}
	calcd(1, 1, 0);
	for(int i = 0; i < lines; ++i){
		int from, to; cin >> from >> to;
		operation(from, to);
	}
	bool flag = false;
	for(int i = 1; i <= br; ++i){
		if(!inside[i] && !u[i]){
			dfs(i, 1); flag = true;
		}
	}
    if(!flag){
        cout << -1 << endl; return 0;
    }
	int maximum = 0;
	for(int i = 1; i <= br; ++i){
		maximum = max(maximum, result[i]);
	}
	cout << maximum << endl;
	for(int i = 1; i <= br; ++i){
		cout << result[i] << ' ';
	}
	cout << endl;
	return 0;
}
