/*#pragma GCC optimize("Ofast, no-stack-protector")
 #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx,mmx,avx,tune-native")
 #pragma GCC optimize("unroll-loops")
 #pragma GCC optimize("fast-math") */

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()

typedef long long ll;
typedef long double lld;

const int maxn = 140;

int pre[maxn];

vector <int> g[maxn];

set <pair<int, int> > st;

void DFS(int v, int p = -1) {
    pre[v] = p;
    for (auto to : g[v]) {
        if (to != p)
            DFS(to, v);
    }
}

int cnt[maxn];

int ans[maxn];

int ss = 0;

void GFS(int v, int cn = 1) {
    ans[v] = max(ans[v], cn);
    ss = max(ss, ans[v]);
    for (auto to : g[v]) {
        if (st.count({v, to}))
            GFS(to, cn + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // комменти файлы, умоляю
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m, t;
    cin >> n >> m >> t;
    vector <pair<int, int> > v(n - 1);
    vector <pair<int, int> > f(m);
    for (auto &it : v) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
        it.first = x;
        it.second = y;
    }
    for (auto &it : f) {
        cin >> it.first >> it.second;
        fill(pre, pre + maxn, -1);
        DFS(it.first);
        int h = it.second;
        while (h != it.first) {
            st.insert({pre[h], h});
            cnt[h]++;
            h = pre[h];
        }
    }
    for (auto it : v) {
        if (st.count({it.first, it.second}) && st.count({it.second, it.first})) {
            cout << -1;
            return 0;
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!cnt[i]) {
            GFS(i);
        }
    }
    if (n != 3 && ss != 3)
        assert(0);
    cout << ss << endl;
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << " ";
    }
    return 0;
}