#include <bits/stdc++.h>

using namespace std;
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define endl "\n"

//#define MULTITEST

#define double long double
#define int long long

#ifdef LOCAL
#define cin fin
ifstream fin; // NOLINT(cert-err58-cpp)
#endif

vector<int> cedpath;
vector<int> cpath;
vector<pair<int, int>> *gr;
bool fpath(int v, int t, int p) {
    cpath.push_back(v);
    if (v == t) {
        return true;
    }

    for (auto ge : gr[v]) {
        int g = ge.first;
        int e = ge.second;
        if (g == p) {
            continue;
        }
        cedpath.push_back(e);
        if (fpath(g, t, v)) {
            return true;
        }
        cedpath.pop_back();
    }
    cpath.pop_back();
    return false;
}

struct E_T {
    int a, b;
    bool dirs;
};

int *mmd;
vector<int> *mgr;

void setmmd(int v, int d) {
    if (mmd[v] >= d) {
        return;
    }
    mmd[v] = d;
    d++;
    for (int g : mgr[v]) {
        setmmd(g, d);
    }
}

void solve() {
    int n, m, zzz;
    cin >> n >> m >> zzz;
    vector<pair<int, int>> _gr[n];
    gr = _gr;
    E_T ed[n];
    ed[0] = {0, 0, false};
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].emplace_back(b, i);
        gr[b].emplace_back(a, i);
        ed[i] = {a, b, false};
    }
    vector<int> mtre[m];
    vector<int> mtrv[m];
    bool orient[m];
    for (int i = 0; i < m; i++) {
        orient[i] = false;
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        cedpath.clear();
        cpath.clear();
        fpath(a, b, -1);
        mtre[i] = cedpath;
        mtrv[i] = cpath;
    }
    for (int i = 0; i < m; i++) {
        if (orient[i]) {
            continue;
        }
        orient[i] = true;

        for (int ei : mtre[i]) {
            for (int vi = 0; vi < (int)mtrv[i].size(); vi++) {
                if (mtrv[i][vi] == ed[ei].a) {
                    if (vi > 0 && mtrv[i][vi - 1] == ed[ei].b) {
                        swap(ed[ei].a, ed[ei].b);
                        ed[ei].dirs = true;
                    } else {
                        ed[ei].dirs = true;
                    }
                }
            }
        }

        for (int j = i + 1; j < m; j++) {
            if (orient[j]) {
                continue;
            }
            for (int ei : mtre[j]) {
                if (ed[ei].dirs) {
                    for (int vi = 0; vi < (int)mtrv[j].size(); vi++) {
                        if (mtrv[j][vi] == ed[ei].a) {
                            if (vi > 0 && mtrv[j][vi - 1] == ed[ei].b) {
                                reverse(mtrv[j].begin(), mtrv[j].end());
                            }
                            break;
                        }
                    }

                    orient[j] = true;
                    break;
                }
            }
            if (!orient[j]) {
                continue;
            }

            for (int ei : mtre[j]) {
                for (int vi = 0; vi < (int)mtrv[j].size(); vi++) {
                    if (mtrv[j][vi] == ed[ei].a) {
                        if (vi > 0 && mtrv[j][vi - 1] == ed[ei].b) {
                            if (ed[ei].dirs) {
                                cout << "-1\n";
                                return;
                            }
                            swap(ed[ei].a, ed[ei].b);
                            ed[ei].dirs = true;
                        } else {
                            ed[ei].dirs = true;
                        }
                    }
                }
            }
        }
    }
    //
    vector<int> _mgr[n];
    mgr = _mgr;
    vector<int> mgrev[n];
    int _mmd[n];
    mmd = _mmd;
    memset(_mmd, 0, sizeof(_mmd));
    for (auto e : ed) {
        if (!e.dirs) {
            continue;
        }

        mgr[e.a].push_back(e.b);
        mgrev[e.b].push_back(e.a);
    }

    for (int i = 0; i < n; i++) {
        if (!mgrev[i].empty()) {
            continue;
        }
        setmmd(i, 1);
    }
    int maxim = 0;
    for (int i = 0; i < n; i++) {
        if (mmd[i] > maxim) {
            maxim = mmd[i];
        }
    }
    cout << maxim << endl;
    for (int i = 0; i < n; i++) {
        cout << mmd[i] << (i == n - 1 ? endl : " ");
    }
}

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ON_START
#ifdef MULTITEST
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}
