#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define mp make_pair

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18, N = 5e5 + 10, P = 1e9 + 7, X = 2007;
const ld EPS = 1e-9;
int FL = 1, used[N], term[N];
vector<int> g[N], g2[N], path;
map<pii, int> used_ed;

void dfs2(int v, int fn, int pr) {
    path.pb(v);
    if (v == fn) {
        for (int i = 0; i < path.size() - 1; i++) {
            int x = path[i], y = path[i + 1];
            used_ed[{x, y}] = 1;
            used_ed[{y, x}] = 1;
        }
        return;
    }
    for (int u : g2[v]) {
        if (u != pr) {
            dfs2(u, fn, v);
        }
    }
    path.ppb();
}

void dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

int dfs4(int v, int pr) {
    for (int u : g2[v]) {
        if (u != pr) {
            if (dfs4(u, v)) {
                term[v] = 1;
            }
        }
    }
    return term[v];
}

void dfs3(int v, int col, vector<int> &ans, int pr) {
    ans[v] = col;
    for (int u : g2[v]) {
        if (u != pr) {
            if (term[u]) {
                dfs3(u, col + 1, ans, v);
            } else {
                dfs3(u, 1, ans, v);
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<pii> ed;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g2[v].pb(u);
        g2[u].pb(v);
        ed.pb({v, u});
    }
    vector<pii> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i].ff >> a[i].ss;
        a[i].ff--;
        a[i].ss--;
        if (n <= 15 && m <= 15){
            path = {};
            dfs2(a[i].ff, a[i].ss, -1);
        }
    }
    if ((n <= 15 && m <= 15)) {
        int ans = INF;
        vector<int> col;
        int M = (1 << (n - 1));
        /*mt( = vector<vector<int> > (n, vector<int> (n));
        for (int i = 0; i < n; i++) {
            for (int j : g[i]) {
                mt[i][j] = 1;
            }
        }
        */
        for (int mask = 0; mask < M; mask++) {
            for (int i = 0; i < n; i++) {
                g[i] = {};
            }
            for (int i = 0; i < n - 1; i++) {
                int v = ed[i].ff, u = ed[i].ss;
                if (mask & (1 << i)) {
                    swap(v, u);
                }
                g[v].pb(u);
            }
            int fl = 1;
            for (int i = 0; i < m; i++) {
                int x = a[i].ff, y = a[i].ss;
                for (int i = 0; i < n; i++) {
                    used[i] = 0;
                }
                dfs(x);
                if (used[y]) {
                    continue;
                }
                for (int i = 0; i < n; i++ ) {
                    used[i] = 0;
                }
                dfs(y);
                if (used[x]) {
                    continue;
                }
                fl = 0;
                break;
            }
            if (!fl) {
                continue;
            }
            deque<int> q;
            vector<int> cnt(n);
            for (int i = 0; i < n; i++) {
                for (int u : g[i]) {
                    cnt[u]++;
                }
            }
            for (int i = 0; i < n; i++) {
                if (cnt[i] == 0) {
                    q.pb(i);
                }
            }
            vector<int> vl(n, 1);
            int cur_ans = 0;
            while (!q.empty()) {
                int v = q.front();
                q.ppf();
                cur_ans = max(cur_ans, vl[v]);
                for (int u : g[v]) {
                    cnt[u]--;
                    if (used_ed[{u, v}]) {
                        vl[u] = max(vl[u], vl[v] + 1);
                    }
                    if (!cnt[u]) {
                        q.pb(u);
                    }
                }
            }
            if (cur_ans < ans) {
                ans = cur_ans;
                col = vl;
            }
        }
        if (ans == INF) {
            cout << -1;
            return 0;
        }
        cout << ans << "\n";
        for (int elem : col) {
            cout << elem << ' ';
        }
        return 0;
    }
    int root = a[0].ff;
    for (int i = 1; i < m; i++) {
        if (a[i].ff != root && a[i].ss != root) {
            root = -1;
            break;
        }
    }
    if (root == -1) {
        root = a[0].ss;
        for (int i = 1; i < m; i++) {
            if (a[i].ff != root && a[i].ss != root) {
                root = -1;
                break;
            }
        }
    }
    if (root != -1) {
        for (int i = 0; i < m ;i++) {
            if (a[i].ff != root) {
                term[a[i].ff] = 1;
            }
            if (a[i].ss != root) {
                term[a[i].ss] = 1;
            }
        }
        vector<int> ans(n, 1);
        dfs4(root, -1);
        dfs3(root, 1, ans, -1);
        int num = -1;
        for (int i = 0; i < n; i++) {
            num = max(num, ans[i]);
        }
        cout << num << "\n";
        for (int elem : ans) {
            cout << elem << ' ';
        }
        return 0;
    }
    return 0;
}
