#pragma optimize("Ofast")
#include <bits/stdc++.h>
#define F first
#define S second
#define PB push_back

using namespace std;
using ll = long long;
using ld = long double;

const ld PI = acos(-1);
const ll N = 5e5+5, inf = 1e9+9, mod = 1e9 + 97;

vector < int > g[N];

int tin[N], up[N];
int d[N], timer = 0, cd = 0;

pair < int, int > tr[N*2];
int sz = 1;

void update(int i, pair < int, int > x){
    i += sz;
    tr[i] = x;
    i /= 2;
    while(i > 0){
        tr[i] = min(tr[i*2+1], tr[i*2]);
        i /= 2;
    }
}

int get(int l, int r){
    l += sz; r += sz;
    pair < int, int > res = {inf, 0};
    while(l <= r){
        if(l % 2 == 1){
            res = min(res, tr[l]);
            l++;
        }
        if(r % 2 == 0){
            res = min(res, tr[r]);
            r--;
        }
        l /= 2;
        r /= 2;
    }
    return res.S;
}

void dfs(int v, int p = 0){
    up[v] = p;
    tin[v] = timer;
    d[v] = cd;
    update(timer++, {d[v], v});
   // cout << d[v] << " " << v << endl;
    cd++;
    for(auto to : g[v])
        if(to != p){
            dfs(to, v);
            update(timer++, {d[v], v});
           //     cout << d[v] << " " << v << endl;
        }

    cd--;
}

int main()
{
    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);   cin.tie(0);
    int n, m, t; cin >> n >> m >> t;
    for(int i = 0; i < n-1; i++){
        int x, y; cin >> x >> y;
        g[x].PB(y);
        g[y].PB(x);
    }
    while(sz < (n-1)*2 + n) sz *= 2;
    dfs(1);
    int ans = 1;
    vector < int > c(n+1, 1);
    for(int i = 0; i < m; i++){
        int a, b; cin >> a >> b;
       // cout << tin[a] << " " << tin[b] << "    ";
        int p = get(min(tin[a], tin[b]), max(tin[a], tin[b]));
       // cout << p;
        ans = max(ans, d[a] - d[p] + d[b] - d[p] + 1);
        int rs = d[a] - d[p] + d[b] - d[p] + 1;
        int tt = 1;
        for(;a != p; c[a] = tt++, a = up[a]){}
        c[a] = tt;
        for(;b != p; c[b] = rs--, b = up[b]){}
    }
    cout << ans << "\n";
    for(int i = 1; i <= n; i++) cout << c[i] << " ";
}

