#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<queue>
#include<string>
#include<assert.h>

using namespace std;

vector<vector<int>> g;

map<pair<int, int>, int> mp;

vector<int> ans;


void dfs(int v) {
	for (auto u : g[v]) {
		ans[u] = max(ans[u], ans[v] + 1);
		dfs(u);
	}
}

signed main() {
	int n, m, t;
	cin >> n >> m >> t;
	if (n <= 100 && m <= 100) {
		g.resize(n);
		ans.resize(n);
		for (int i = 1; i < n; i++) {
			int a, b;
			cin >> a >> b;
			g[a - 1].push_back(b - 1);
			g[b - 1].push_back(a - 1);
		}
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			queue<int> q;
			q.push(a);
			vector<int> p(n);
			vector<int> dist(n, 1e9);
			dist[a] = 0;
			while (q.size()) {
				int v = q.front();
				q.pop();
				for (auto u : g[v]) {
					if (dist[v] + 1 < dist[u]) {
						q.push(u);
						dist[u] = dist[v] + 1;
						p[u] = v;
					}
				}
			}
			vector<int> path;
			int v = b;
			while (v != a) {
				path.push_back(v);
				v = p[v];
			}
			path.push_back(a);
			while (path.size() > 1) {
				int v = path.back();
				path.pop_back();
				mp[{v, path.back()}] = 1;
			}
		}
		ans[0] = 0;
		g.clear();
		g.resize(n);
		vector<int> vec(n + 1);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (mp[{i, j}] && mp[{j, i}]) {
					cout << -1;
					return 0;
				}
				else {
					if (mp[{i, j}]) {
						g[i].push_back(j);
						vec[j]++;
					}
					else if (mp[{j, i}]) {
						g[j].push_back(i);
						vec[i]++;
					}
				}
			}
		}
		for (int i = 0; i < n; i++) {
			if (vec[i] == 0) {
				ans[i] = 1;
				dfs(i);
			}
		}
		int answ = 0;
		for (int i = 0; i < n; i++) {
			answ = max(answ, ans[i]);
		}
		if (t == 1) {
			cout << answ << "\n";
		}
		for (int i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
	}
}