#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector <int> st;
vector <int> color;
vector <vector <int> > g;
void paint(int v, int from, int u) {
    st.push_back(v);

    if (v == u) {
        for(int i = 1; i < st.size(); i++) {
            while(color[st[i]] <= color[st[i - 1]]) {
                color[st[i]]++;
            }
        }

        st.pop_back();
        return;
    }

    for(auto to : g[v]) {
        if (to != from) {
            paint(to, v, u);
        }
    }

    st.pop_back();
}

int flag;
void ok(int v, int from, int u) {
    st.push_back(v);

    if (v == u) {
        for(int i = 1; i < st.size(); i++) {
            if (color[st[i]] <= color[st[i - 1]]) {
                flag = 1;
                break;
            }
        }

        st.pop_back();
        return;
    }

    for(auto to : g[v]) {
        if (to != from) {
            ok(to, v, u);
        }
    }

    st.pop_back();
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    srand(time(0));

    int n, m, t;
    cin >> n >> m >> t;

    g.resize(n);
    for(int i = 1; i < n; i++) {
        int v, to;
        cin >> v >> to;
        v--, to--;

        g[v].push_back(to);
        g[to].push_back(v);
    }

    vector <pair <int, int> > a(m);
    color.assign(n, 1);
    for(int i = 0; i < m; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--, a[i].second--;

        paint(a[i].first, -1, a[i].second);
    }

    for(int i = 0; i < m; i++) {
        paint(a[i].first, -1, a[i].second);
    }

    flag = 0;

    for(int i = 0; i < m; i++) {
        ok(a[i].first, -1, a[i].second);
    }

    pair <int, vector <int> > ans;

    ans.first = *max_element(color.begin(), color.end());
    ans.second = color;
    if (!flag) {
        cout << ans.first << "\n";
        for(auto i : ans.second) {
            cout << i << " ";
        }
    }
    else {
        cout << "-1\n";
    }
    return 0;
}
/*
*/
