#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, 10);
typedef pair <int, int> pii;

const int N = 500007;
int n, m, t, col[N];
vector <int> q[N], g[N];
vector <pii> f[N];

stack <int> st;
bool found;

void go(int v, int p, int f) {
    st.push(v);
    if (v == f) {
        int last = -1;
        found = true;
        while (!st.empty()) {
            if (last != -1) {
                g[st.top()].pb(last);
            }
            last = st.top();
            st.pop();
        }
        return;
    }
    for (auto to : q[v]) {
        if (to == p) {
            continue;
        }
        go(to, v, f);
    }
    if (!found) {
        st.pop();
    }
}

int used[N];
vector <int> ord;

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (used[to] == 1) {
            cout << -1;
            exit(0);
        }
        if (used[to] == 0) {
            dfs(to);
        }
    }
    used[v] = 2;
    ord.pb(v);
}

int was[N], start[N];

void solve(int v, int c) {
    was[v] = 1;
    for (auto i : f[v]) {
        int to = i.fi, ind = i.se;
        if (c == 0) {
            start[ind] = v;
        }   else {
            start[ind] = to;
        }
        if (!was[to]) {
            solve(to, 1 - c);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    cin >> n >> m >> t;
    int x, y;
    for (int i = 1; i <= n - 1; i++) {
        cin >> x >> y;
        q[x].pb(y);
        q[y].pb(x);
    }
    vector <pii> edge;
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        f[x].pb({y, i});
        f[y].pb({x, i});
        edge.pb({x, y});
    }
    for (int i = 1; i <= n; i++) {
        if (!was[i]) {
            solve(i, 0);
        }
    }
    for (int i = 1; i <= m; i++) {
        x = edge[i - 1].fi, y = edge[i - 1].se;
        found = false;
        if (start[i] == x) {
            cerr << "path " << x << ' ' << y << '\n';
            go(x, x, y);
        }   else {
            cerr << "path " << y << ' ' << x << '\n';
            go(y, y, x);
        }
        while (!st.empty()) {
            st.pop();
        }
    }
    for (int i = 1; i <= n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    reverse(all(ord));
    for (auto i : ord) {
        for (auto to : g[i]) {
            col[to] = max(col[to], col[i] + 1);
        }
    }
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        cnt = max(cnt, col[i] + 1);
    }
    cout << cnt << '\n';
    for (int i = 1; i <= n; i++) {
        cout << col[i] + 1 << ' ';
    }
}
