#include <bits/stdc++.h>

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 1000;
int n, m, t;
vector<int> graph[N];
int a[N], b[N];
int V[N], U[N];
int go[N][N];

void dfs(int v, int p, int st, int save)
{
    go[v][st] = save;
    for (auto id : graph[v]) if (V[id] + U[id] - v != p) dfs(V[id] + U[id] - v, v, st, id);
}

vector<int> lines[N];
vector<int> here[N];

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++)
    {
        cin >> V[i] >> U[i];
        V[i]--, U[i]--;
        graph[V[i]].push_back(i);
        graph[U[i]].push_back(i);
    }
    for (int i = 0; i < m; i++)
    {
        cin >> a[i] >> b[i];
        a[i]--, b[i]--;
    }
    for (int i = 0; i < n; i++)
    {
        dfs(i, -1, i, -1);
    }
    for (int i = 0; i < m; i++)
    {
        int x = a[i];
        while (x != b[i])
        {
            int y = go[x][b[i]];
            int z = V[y] + U[y] - x;
            lines[i].push_back(z);
            here[y].push_back(i);
            x = z;
        }
        lines[i].push_back(x);
    }
    if (m <= 15)
    {
        int ans = 1e9;
        vector<int> c(n);
        for (int mask = 0; mask < (1 << m); mask++)
        {
            vector<int> wh(n - 1, -1);
            int t = 1;
            //cout << "! " << mask << endl;
            for (int i = 0; i < m; i++)
            {
                int x = a[i];
                int f = b[i];
                if ((1 << i) & mask) swap(x, f);
                while (x != f)
                {
                    int y = go[x][f];
                    int z = V[y] + U[y] - x;
                    if (wh[y] != z && wh[y] >= 0) t = 0;
                    wh[y] = z;
                    x = z;
                }
            }
            //cout << 1 << " " << t << endl;
            if (t)
            {
                vector<int> in(n);
                for (int i = 0; i < n - 1; i++)
                {
                    in[wh[i]]++;
                }
                vector<int> d(n);
                int cnt = n;
                for (int i = 1; cnt > 0; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (in[j] == 0 && d[j] == 0)
                        {
                            d[j] = i;
                            cnt--;
                        }
                    }
                    for (int j = 0; j < n; j++)
                    {
                        if (d[j] == i)
                        {
                            for (auto e : graph[j])
                            {
                                int kk = V[e] + U[e] - j;
                                in[kk]--;
                            }
                        }
                    }
                    if (cnt == 0)
                    {
                        ans = min(ans, i);
                        if (i == ans) c = d;
                    }
                }
            }
        }
        if (ans == 1e9)
        {
            cout << -1;
            return 0;
        }
        cout << ans << "\n";
        for (int i = 0; i < n; i++) cout << c[i] << " ";
        return 0;
    }
}

/*
7 1
1 1 2 1 2 1 1

7 1
1 1 2 1 2 2 2
*/
