#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


const int N = 5 * 1e5;
bool used[N];
vector<vector<int>> s(N);



void Do(vector<int> &a, int v, int u) {
    if (a[v] != 0 || a[u] != 0) {
            if (a[v] != 0 && a[u] != 0) {
                if (a[v] == a[u]) {
                    cout << -1 << "\n";
                    exit(0);
                }
            }
            if (a[v] == 2)
                a[u] = 1;
            if (a[u] == 2)
                a[v] = 1;
            else if (a[v] != 0)
                a[u] = (a[v] + 2) % 4;
            else
                a[v] = (a[u] + 2) % 4;
        }
        else {
            a[v] = 1;
            a[u] = 3;
        }
}


void dfs(vector<int> &a, int v) {
    used[v] = true;
    for (int i = 0; i < s[v].size(); ++i) {
        Do(a, v, s[v][i]);
        if (!used[v])
            dfs(a, s[v][i]);
    }
}



int main() {
    int n, m, t;
    cin >> n >> m >> t;

    vector<int> a(n);
    int v1, u1;
    cin >> v1 >> u1;
    --v1; --u1;
    for (int i = 1; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        if (i == 1) {
            if (u == u1 || u == v1)
                a[u] = 2;
            else
                a[v] = 2;
        }
    }

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        s[v].push_back(u);
        s[u].push_back(v);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < s[i].size(); ++j) {
            if (!used[s[i][j]]) {
                Do(a, i, s[i][j]);
                dfs(a, s[i][j]);
            }
        }

    }
    cout << 3 << "\n";
    for (int i = 0; i < n; ++i) {
        cout << (a[i] == 0 ? 1 : a[i]) << " ";
    }
}
