#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 1e3 + 234;
const int M = 1e9 + 7;

vector < int > g[N];

pair < int, int > way[N];

int cost[N];

int best[N];

bool can(int v, int need) {
    if (v == need) {
        return 1;
    }
    for (auto to : g[v]) {
        if (cost[to] <= cost[v]) {
            continue;
        }
        if (can(to, need)) {
            return 1;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m, t;
    cin >> n >> m >> t;
    int x, y;
    for (int i = 1; i < n; ++i) {
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        g[y].pb(x);
    }
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        way[i] = {x, y};
    }
    vector < int > p(n + 1, 1);
    int j;
    int cur;
    int ans = 1e9;
    bool ok;
    while (p[0] == 1) {
        for (int i = 0; i < n; ++i) {
            cost[i] = p[i + 1];
        }
        ok = 1;
        for (int i = 0; i < m; ++i) {
            if (!can(way[i].F, way[i].S) && !can(way[i].S, way[i].F)) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            cur = 0;
            for (auto i : p) {
                cur = max(cur, i);
            }
            if (ans > cur) {
                ans = cur;
                for (int i = 0; i < n; ++i) {
                    best[i] = cost[i];
                }
            }
        }
        j = n;
        while (p[j] == n) {
            p[j] = 1;
            --j;
        }
        ++p[j];
    }
    if (ans == 1e9) {
        cout << -1;
    } else {
        cout << ans << '\n';
        if (t) {
            for (int i = 0; i < n; ++i) {
                cout << best[i] << ' ';
            }
        }
    }
    return 0;
}
