import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class C {
    static BufferedReader in;
    static StringTokenizer st;
    static ArrayList adj[];
    static int m;
    static int pr[][];

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int n = nextInt();
        m = nextInt();
        int t = nextInt();
        adj = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            adj[i] = new ArrayList();
        }
        for (int i = 0; i < n - 1; i++) {
            fn();
            int x = nextInt() - 1;
            int y = nextInt() - 1;
            adj[x].add(y);
            adj[y].add(x);
        }
        pr = new int[m][2];
        for (int i = 0; i < m; i++) {
            fn();
            pr[i][0] = nextInt() - 1;
            pr[i][1] = nextInt() - 1;
        }
        r = new int[n];
        if (fk(1, n) == -1) System.out.println(-1);
    }

    static int r[];

    private static int fk(int tk, int n) {
        if (tk == n+1&&r[3]==4&&r[0]==2) {
            for (int i = 0; i < m; i++) {
                us = new int[n];
                if (dfs(pr[i][0], pr[i][1]) == 2) return -1;
            }
            System.out.println(n);
            for (int i = 0; i < n; i++) {
                System.out.print(r[i] + " ");
            }
            return 0;
        }
        for (int i = 0; i < n; i++) {
            if (r[i] == 0) {
                r[i] = tk;
                if (fk(tk + 1, n) != -1) return 0;
                r[i] = 0;
            }
        }
        return -1;
    }

    static int us[];

    private static int dfs(int tk, int to) {
        if (tk == to) return -2;
        us[tk] = 1;
        for (int i = 0; i < adj[tk].size(); i++) {
            int p = (int) adj[tk].get(i);
            if (us[p] == 0) {
                int k = dfs(p, to);
                if (k == -2) {
                    if (r[tk] > r[p]) return 1;
                    else return -1;
                } else if (k == 1) {
                    if (r[tk] > r[p]) return 1;
                    return 2;
                } else if (k == -1) {
                    if (r[tk] < r[p]) return -1;
                    return 2;
                } else if (k == 2) return 2;
            }
        }
        return 0;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
