#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

using namespace std;
int INF = 2 * 1e9;
ll INFL = 1e18 + 500;

vector<int> c;
vector<int> cur;
vector<char> used;
vector<int> path;
vector<vector<int>> g;
vector<vector<char>> edg;

void dfs(int u, int t) {
    cur.push_back(u);
    used[u] = 1;
    if (u == t) {
        path = cur;
        return;
    }
    for (auto v : g[u]) {
        if (!used[v]) {
            dfs(v, t);
        }
    }
    cur.pop_back();
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    srand(time(NULL));
    int n, m, t;
    cin >> n >> m >> t;
    c.resize(n);
    used.resize(n);
    g.resize(n);
    edg.resize(n, vector<char>(n));
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        e.push_back({a, b});
    }
    bool f = true;
    vector<vector<int>> ps;
    for (auto[a, b] : e) {
        used.assign(n, 0);
        path.clear();
        cur.clear();
        dfs(a, b);
        ps.push_back(path);
        if (c[path[0]] == 0) c[path[0]] = 1;
        for (int i = 0; i < path.size() - 1; i++) {
            if (edg[path[i + 1]][path[i]]) {
                f = false;
            } else {
                edg[path[i]][path[i + 1]] = 1;
                if (i >= 1){
                    c[path[i]] = max(c[path[i - 1]] + 1, c[path[i]]);
                }
            }
        }
        c[path.back()] = max(c[path[path.size() - 2]] + 1, c[path.back()]);
    }
    if (!f){
        cout<<-1;
        return 0;
    }
    int mx = -1;
    for (auto c_ : c) mx = max(mx, c_);
    cout<<mx<<endl;
    for (auto c_ : c) cout<<c_<<' ';
    return 0;
}