#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 2e5;

ll n, m, t;
ve<ll> g[maxn];
ve<ll> ans;
ve<pair<ll, ll>> e;
ve<ll> path;
ve<ll> st;
ve<ll> c;
ll finish;
ll best = oo;
bool ok;

void dfs(ll v, ll par) {
//    cout << "Vertex " << v << " from " << par << ", finish = " << finish << "\n";
    if(v == finish) {
        path = st;
        ok = 1;
        return;
    }
    if(ok) {
        return;
    }
    fe(to, g[v]) {
        if(to == par) {
            continue;
        }
        st.pb(to);
        dfs(to, v);
        st.pop_back();
    }
}

void get_path(ll u, ll v) {
    path.clear();
    ok = 0;
    st.clear();
    finish = v;
    st.pb(u);
    dfs(u, -1);
    st.pop_back();
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> t;
    c.resize(n);
    fr(i, 1, n - 1) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        g[from].pb(to);
        g[to].pb(from);
    }
    fr(i, 1, m) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        e.pb({from, to});
    }
    fr(mask, 0, pw(m) - 1) {
        fr(i, 0, n - 1) c[i] = 1;
        fr(i, 0, m - 1) {
            ll from, to;
            tie(from, to) = e[i];
            if(mask & pw(i)) {
                swap(from, to);
            }
            get_path(from, to);
            fr(i, 1, sz(path) - 1) {
                umx(c[path[i]], ll(i) + c[path[0]]);
            }
        }
        bool bad = 0;
        fr(i, 0, m - 1) {
            ll from, to;
            tie(from, to) = e[i];
            if(mask & pw(i)) {
                swap(from, to);
            }
            get_path(from, to);
            fr(i, 1, sz(path) - 1) {
                if(c[path[i]] <= c[path[i - 1]]) {
                    bad = 1;
                    break;
                }
            }
        }
        if(!bad) {
            if(umn(best, *max_element(all(c)))) {
                ans = c;
            }
        }
    }
    if(best == oo) {
        cout << "-1\n";
        return 0;
    }
    cout << best << "\n";
    fr(i, 0, n - 1) cout << ans[i] << " ";
    cout << "\n";
    return 0;
}
