#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 15 + 10, LG = 19, P = 31, mod = 1e9 + 7;
std::vector<int> g[N];
bool used[N], answCheck[N];
int answ[N], pred[N], bestAnsw[N];
std::vector<int> order;
void dfs1(int v, int need) {
	used[v] = 1;
	if (need == v) {
		int q = v;

		while (q != -1) {
			answCheck[q] = 1;
			q = pred[q];
		}

		return;
	}
	for (auto e : g[v]) {
		if (!used[e]) {
			pred[e] = v;
			dfs1(e, need);
		}
	}
	order.pb(v);
}
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m, t;
	std::cin >> n >> m >> t;
	std::vector<std::pair<int,int>> edges;
	FOR(i, n - 1) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		edges.pb({a, b});
	}
	std::vector<std::pair<int,int>> check(m);
	FOR(i, m) {
		std::cin >> check[i].first >> check[i].second;
		--check[i].first; --check[i].second;
	}
	int min = 1e9;
	FOR(mask, (1 << (n - 1))) {
		FOR(i, n) {
			g[i].clear();
		}
		FOR(j, n - 1) {
			if ((mask >> j) & 1) {
				g[edges[j].first].pb(edges[j].second);
			}
			else {
				g[edges[j].second].pb(edges[j].first);
			}
		}
		memset(answCheck, 0, sizeof(answCheck));
		bool can = true;
		FOR(i, m) {
			memset(used, 0, sizeof(used));
			memset(pred, -1, sizeof(pred));

			dfs1(check[i].first, check[i].second);
			if (used[check[i].second]) continue;

			memset(used, 0, sizeof(used));
			memset(pred, -1, sizeof(pred));
			dfs1(check[i].second, check[i].second);
			if (used[check[i].first]) continue;
			can = false;
			break;
		}
		if (!can) continue;
		order.clear();
		memset(used, 0, sizeof(used));
		FOR(i, n) {
			if (!used[i]) dfs1(i, -1);
			answ[i] = 1;
		}
		int nowAnsw = 0;
		for (auto v : order) {
			if (!answCheck[v]) continue;
			for (auto to : g[v]) {
				if (!answCheck[to]) continue;
				answ[v] = std::max(answ[v], answ[to] + 1);
			}
			nowAnsw = std::max(nowAnsw, answ[v]);			
		}
		if (nowAnsw < min) {
			min = nowAnsw;
			memcpy(bestAnsw, answ, sizeof(answ));
		}
	}
	if (min == 1e9) {
		std::cout << -1;
	}
	else {
		std::cout << min << '\n';
		FOR(i, n) {
			std::cout << bestAnsw[i] << ' ';
		}
	}

}