#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m, t;
vector<vector<int>> g;
vector<pair<int, int>> a;
vector<int> color, ans, lg;
vector<vector<int>> PR;
vector<int> h, pr;

bool check(int v, int k, int pr) {
    if (v == k) {
        return true;
    }
    bool f = false;
    for (auto x : g[v]) {
        if (x != pr && color[x] < color[v]) {
            f |= check(x, k, v);
        }
    }
    return f;
}


void dfs(int v, int pr2, int d) {
    pr[v] = pr2;
    PR[v][0] = pr2;
    h[v] = d;
    for (int i = 0; i <= lg[n]; i++) {
        PR[v][i] = PR[PR[v][i - 1]][i - 1];
    }
    for (auto el : g[v]) {
        if (el != pr2) dfs(el, v, d + 1);
    }
}

int get(int x, int y) {
    if (h[x] < h[y]) swap(x, y);
    int z = h[x] - h[y];
    for (int i = 0; i <= lg[n]; i++) {
        if (z & (1 << i)) {
            x = PR[x][i];
        }
    }
    if (x == y) return x;
    for (int i = lg[n]; i >= 0; i--) {
        int _x = PR[x][i];
        int _y = PR[y][i];
        if (_x != _y) {
            x = _x;
            y = _y;
        }
    }
    return pr[x];
}

void FILL(int x, int y) {
    while (x != y) {
        color[pr[x]] = max(color[pr[x]], color[x] + 1);
        x = pr[x];
    }
}

void FILL2(int x, int y) {
    vector<int> z;
    z.push_back(y);
    while (y != x) {
        z.push_back(pr[y]);
        y = pr[y];
    }
    for (int i = z.size() - 1; i >= 1; i--) {
        color[z[i - 1]] = max(color[z[i - 1]], color[z[i]] + 1);
    }
}

signed main() {
    cin >> n >> m >> t;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    a.resize(m);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a.push_back({x, y});
    }
    if (n <= 8 && m <= 8) {
        int k = 1;
        for (int i = 0; i < n; i++) {
            k *= n;
        }
        color.resize(n);
        ans.resize(n);
        int mx = 1e18;
        for (int i = 0; i < k; i++) {
            int x = i;
            for (int j = 0; j < n; j++) {
                color[j] = x % n;
                x /= n;
            }
            bool f = true;
            for (auto el : a) {
                if (check(el.first, el.second, -1) || check(el.second, el.first, -1)) {
                    continue;
                }
                f = false;
            }
            if (f) {
                int z = 0;
                for (auto el : color) z = max(z, el);
                if (z < mx) {
                    mx = z;
                    for (int j = 0; j < n; j++) {
                        ans[j] = color[j];
                    }
                }
            }
        }
        if (mx == 1e18) {
            cout << -1;
            return 0;
        }
        cout << mx + 1 << endl;
        for (auto x : ans) cout << x + 1 << " ";
        return 0;
    }
    color.resize(n, 0);
    lg.resize(n + 1, 0);
    h.resize(n);
    int k = 2;
    for (int i = 2; i <= n; i++) {
        lg[i] = lg[i - 1];
        if (i == k) {
            lg[i]++;
            k *= 2;
        }
    }
    PR.resize(n, vector<int> (lg[n] + 1, 0));
    pr.resize(n);
    dfs(0, 0, 0);
    for (int i = 0; i < m; i++) {
        int x = a[i].first, y = a[i].second;
        int p = get(x, y);
        FILL(x, p);
        FILL2(p, y);
    }
    int an = 0;
    for (auto x : color) an = max(x, an);
    cout << an + 1 << endl;
    for (auto x : color) cout << x + 1 << " ";
}
