#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    int INF = 1e18;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    int INF = 1e18;
//    #define mod = 2600000069;
//    #define p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

const int MAXN = 20;

int n, m, t;
set<int> kids[MAXN]; //список детей через которых нам нужно пройти чтобы попать в какой-то конец ветки
int c[MAXN];
int naprav[MAXN][MAXN];
vector<int> g[MAXN];
pii q[MAXN]; // список путей так как он дан, при этом в маске 0 если путь из first в second и 1 иначе
int ansc[MAXN];
int ans = INF;

bool BAD = 0;

bool find_kids(int v, int p, int need_to_find_from_v) {
    if (v == need_to_find_from_v) return 1;
    for (auto u : g[v]) {
        if (u != p) {
            if (find_kids(u, v, need_to_find_from_v)) {
                if (naprav[v][u] == 2) BAD = 1;
                naprav[v][u] = 1;
                naprav[u][v] = 2;
                kids[v].insert(u);
                return 1;
            }
        }
    }
    return 0;
}

void relax(int v, int p, int val) {
    if (c[v] < val) {
        c[v] = val;
        for (auto u : kids[v]) {
            if (u == p) {
                BAD = 1;
                return;
            }
            relax(u, v, val + 1);
        }
    }
}

void tryhard(int mask) {
    BAD = 0;
    for (int i = 0; i < MAXN; i++) for (int j = 0; j < MAXN; j++) naprav[i][j] = 0;
    for (int i = 0; i < n; i++) kids[i].clear();
    for (int i = 0; i < n; i++) c[i] = 0;
    vector<pii> paths(m);
    for (int i = 0; i < m; i++) {
        if ((mask >> i) & 1) {
            paths[i] = q[i];
        } else {
            paths[i].first = q[i].second;
            paths[i].second = q[i].first;
        }
    }
    for (int i = 0; i < m; i++) {
        find_kids(paths[i].first, paths[i].first, paths[i].second);
    }
//    for (int i = 0; i < n; i++) {
//        cout << i << " : ";
//        for (auto k : kids[i]) cout << k << " ";
//        cout << "\n";
//    }
    for (int i = 0; i < m; i++) {
        relax(paths[i].first, paths[i].first, 1);
    }
    if (BAD) return;
    int curans = 0;
    for (int i = 0; i < n; i++) {
        curans = max(curans, c[i]);
    }
    if (curans < ans) {
        ans = curans;
        for (int i = 0; i < n; i++) ansc[i] = c[i];
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    int u, v;
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    for (int i = 0; i < m; i++) {
        cin >> q[i].first >> q[i].second;
        q[i].first--, q[i].second--;
    }
    for (int mask = 0; mask < (1 << m); mask++) {
//        dbg(mask)
        tryhard(mask);
    }
    if (ans == INF) {
        cout << -1;
        return 0;
    }
    cout << ans << "\n";
    for (int i = 0; i < n; i++) cout << ansc[i] << " ";
}
/*
3 1 1
1 2
2 3
1 3
->  3
1 2 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4
-> -1

сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
