#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

vector <vector <int> > edges;
vector <vector <int> > lines;
vector <bool> used;
vector <int> p;

void dfs(int v, int f, int s, int num)
{
    used[v] = true;
    if (v == f)
    {
        for (int i = f; i != s; i = p[i])
        {
            lines[num].push_back(i);
        }
        lines[num].push_back(s);
        return;
    }
    for (int i = 0; i < edges[v].size(); i++)
    {
        if  (!used[edges[v][i]])
        {
            p[edges[v][i]] = v;
            dfs(edges[v][i], f, s, num);
        }
    }
}


int main()
{
    int n, m, t, i, j, a, b, x;
    cin >> n >> m >> t;
    vector <bool> used2(n, false);
    vector <int> p2(n, -1);
    edges.resize(n);
    for (i = 0; i < n - 1; i++)
    {
        cin >> a >> b;
        a--; b--;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    lines.resize(m);
    for (i = 0; i < m; i++)
    {
        cin >> a >> b;
        a--; b--;
        used = used2;
        p = p2;
        dfs(a, b, a, i);
    }
    vector <int> answer;
    int maxi = 1e9;
    for (i = 0; i < (1 << m); i++)
    {
        vector <int> ans(n, 0);
        bool checker = true;
        for (j = 0; j < m; j++)
        {
            if (i & (1 << j))
            {
                //reversed
                for (x = lines[j].size() - 1; x >= 0; x--)
                {
                    if (x == lines[j].size() - 1 && ans[lines[j][x]] == 0)
                    {
                        ans[lines[j][x]] = 1;
                        continue;
                    }
                    if (x == lines[j].size() - 1)
                        continue;
                    if (ans[lines[j][x]] != 0)
                    {
                        if (ans[lines[j][x]] <= ans[lines[j][x + 1]])
                        {
                            checker = false;
                        }
                        continue;
                    }
                    ans[lines[j][x]] = ans[lines[j][x + 1]] + 1;
                    if (!checker)
                        break;
                }
            }
            else
            {
                for (x = 0; x < lines[j].size(); x++)
                {
                    if (x == 0 && ans[lines[j][x]] == 0)
                    {
                        ans[lines[j][x]] = 1;
                        continue;
                    }
                    if (x == 0)
                        continue;
                    if (ans[lines[j][x]] != 0)
                    {
                        if (ans[lines[j][x]] <= ans[lines[j][x - 1]])
                        {
                            checker = false;
                        }
                        continue;
                    }
                    ans[lines[j][x]] = ans[lines[j][x - 1]] + 1;
                    if (!checker)
                        break;
                }
            }
            if (!checker)
                break;
        }
        if (checker)
        {
            int m = 0;
            for (j = 0; j < ans.size(); j++)
            {
                m = max(m, ans[j]);
            }
            if (m < maxi && m != 0)
            {
                maxi = m;
                answer = ans;
            }
        }
    }
    if (answer.size() == 0)
    {
        cout << "-1";
        return 0;
    }
    cout << maxi << endl;
    for (i = 0; i < answer.size(); i++)
    {
        if (answer[i] == 0)
        {
            cout << "1 ";
            continue;
        }
        cout << answer[i] << " ";
    }
    return 0;
}
