#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

const int maxn = 1e5 + 1;
const int inf = 1e9 + 1;

vector<int> g[maxn];
vector<pair<int, int>> a;
int ans = inf;
vector<int> ansv;
int n, m;
int need, nxt = 1, pos = 1;
vector<int> res;

bool paint(int v, int p = -1) {
    if (v == need) {
        if (res[v] == 0) {
            res[v] = nxt++;
        }
        return true;
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        if (paint(u, v)) {
            if (res[v] == 0) res[v] = nxt++;
            else if (res[v] > res[u]) pos = 0;
            return true;
        }
    }
    return false;
}

void check(int mask) {
    pos = 1;
    nxt = 1;
    res.clear();
    for (int i = 0; i < m; i++) {
        if (mask & (1 << i)) {
            need = a[i].y;
            paint(a[i].x);
        } else {
            need = a[i].x;
            paint(a[i].y);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (res[i] == 0) {
            res[i] = nxt++;
        }
    }
    if (pos && nxt - 1 < ans) {
        ans = nxt - 1;
        swap(res, ansv);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> n >> m >> t;
    res.resize(n + 1);
    ansv.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    a.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i].x >> a[i].y;
    }
    for (int i = 0; i < (1 << m); i++) {
        check(i);
    }
    if (ans == inf) {
        cout << -1;
        return 0;
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++) {
        cout << ansv[i] << " ";
    }
    return 0;
}