#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()
#define forn(i, st, end) for(int i = st; i <= end; ++i)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
typedef pair<vector<ull>, vector<ull> > pvv;

vector<int>path;
bool found = 0;
void go(int v, int start, int end, vector<vector<int> >& g, vector<int>& used, vector<int>& a, int vers) {
    used[v] = vers;
    if (v == end)found = 1;
    for (int to : g[v]) {
        if (used[to] == vers)continue;
        path.push_back(a[v] - a[to]);
        //cout << "to " << to << " from " << v << "\n";
        go(to, start, end, g, used, a, vers);
    }
    if (!found)path.pop_back();
}
bool ok(vector<int>& a, vector<vector<int> >& g, vector<pll>&b) {
    vector<int>used(a.size(), 0);
    int vers = 1;
    for (int i = 0; i < b.size(); ++i) {
        //if (upper(b[i].second, b[i].first))swap(b[i].second, b[i].first);
        path.clear();
        found = 0;
        go(b[i].first, b[i].first, b[i].second, g, used, a, vers);
        for (int i = 1; i < path.size(); ++i) {
            if (path[i] * path[i - 1] <= 0) {
                return 0;
            }
        }
        if (path.size() > 0 && path[0] == 0)return 0;
        ++vers;
    }
    return 1;

}
vector<int>ans;
int mn = 1e9;
void gen(vector<vector<int> >& g, vector<pll>& b, vector<int>cur, int ind = 0, int mx = 0) {
    if (ind == cur.size()) {
        if (ok(cur, g, b)) {
            if (mx < mn) {
                mn = mx; ans = cur;
            }
        }
        return;
    }
    for (int i = 1; i <= 8; ++i) {
        cur[ind] = i;
        gen(g, b, cur, ind + 1, max(mx, i));
    }
}
int main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int n, m, t;
    cin >> n >> m >> t;
    //init(n);
    vector<vector<int> > g(n + 1, vector<int>());
    for (int i = 1; i < n; ++i) {
        int a, b; cin >> a >> b;
        g[a].push_back(b), g[b].push_back(a);
    }
    vector<pll> b(m);
    for (int i = 0; i < m; ++i)cin >> b[i].first >> b[i].second;
    vector<int>used(n + 1, 0);
    vector<int>cur(n + 1, 0);
    gen(g, b, cur);
    if (ans.size() == 0) {
        cout << -1;
    }
    else {
        cout << mn << "\n";
        if (t) {
            for (int i = 1; i < ans.size(); ++i)cout << ans[i] << " ";
        }
    }
    return 0;
}
/*
3 1 1
1 2
2 3
1 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4

9 3 1
1 6
1 2
2 3
2 9
3 4
3 5
6 8
6 7
1 7
4 8
2 5


*/