#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;
typedef long double db;

#ifdef MY
const int N = 100;
#else
const int N = 5e5 + 5;
#endif // MY
const int D = 20;
int dp[N][D];
vector < int > gr[N];
int lev[N];
int lca[N];
pii way[N];
int ans[N];
bool kek[N];
bool used[N];

void dfs(int v, int p = -1, int l = 0) {
    lev[v] = l;
    dp[v][0] = p;
    for (int i = 1; i < D; i++) {
        dp[v][i] = dp[dp[v][i - 1]][i - 1];
    }
    for (auto u : gr[v]) {
        if (u != p) {
            dfs(u, v, l + 1);
        }
    }
}

int get_lca(int v, int u) {
    if (lev[v] < lev[u]) {
        swap(v, u);
    }
    for (int i = D - 1; lev[v] > lev[u]; i--) {
        if (lev[v] - (1 << i) < lev[u]) {
            continue;
        }
        v = dp[v][i];
    }
    int t = D - 1;
    while (v != u) {
        if (dp[v][t] != dp[u][t]) {
            v = dp[v][t];
            u = dp[u][t];
        }
        t--;
    }
    if (v != u) {
        v = dp[v][0];
    }
    return v;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt;
    int n, m;
    cin >> n >> m >> tt;
    int root;
    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        gr[v].pb(u);
        gr[u].pb(v);
        if (kek[v]) {
            root = v;
        } else if (kek[u]) {
            root = u;
        } else {
            kek[v] = kek[u] = 1;
        }
    }
    fill(ans, ans + n, 1);
    //dfs(0);
    //int root = get_lca(0, 1);
    ans[root] = 2;

    int k = 2;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (v == root || u == root) {
            continue;
        }
        k = 3;
        if (!used[v] && !used[u]) {
            used[v] = 1;
            used[u] = 1;
            ans[v] = 3;
        }
        if (used[u] && used[v]) {
            if (ans[u] == ans[v]) {
                cout << -1;
                return 0;
            }
        }
        if (used[u]) {
            swap(v, u);
        }
        used[u] = 1;
        if (ans[v] == 1) {
            ans[u] = 3;
        }
    }
    cout << k << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }

    return 0;
}
