#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

#define ll long long
#define S second
#define F first

using namespace std;

ll a, b, c, d, e;
vector <ll> ar, height, parent, pp;
vector <vector <ll> > arr, binup;
vector <pair <ll, ll> > zapr;

ll maxn = 27;

void dfs(ll v, ll pr, ll h)
{
    height[v] = h;
    parent[v] = pr;
    binup[v].resize(maxn);
    binup[v][0] = pr;
    for (ll i = 1; i < maxn; ++i)
    {
        binup[v][i] = binup[binup[v][i - 1]][i - 1];
    }
    for (ll i = 0; i < arr[v].size(); ++i)
    {
        if (arr[v][i] == pr)
            continue;
        dfs(arr[v][i], v, h + 1);
    }
    return;
}

ll upper(ll v, ll v1)
{
    for (ll i = maxn - 1; i >= 0; --i)
    {
        if (binup[v][i] != binup[v1][i])
        {
            v = binup[v][i];
            v1 = binup[v1][i];
        }
    }
    return binup[v][0];
}

ll up(ll v, ll del)
{
    for (ll i = maxn - 1; i >= 0; --i)
    {
        if (pp[i] <= del)
        {
            del -= pp[i];
            v = binup[v][i];
        }
    }
    return v;
}

int main()
{
    cin >> a >> b >> c;
    arr.resize(a);
    pp.resize(maxn);
    pp[0] = 1;
    map <ll, ll> map1;
    for (ll i = 1; i < maxn; ++i)
        pp[i] = pp[i - 1] * 2;
    binup.resize(a);
    parent.resize(a);
    height.resize(a);
    for (ll i = 0; i < a - 1; ++i)
    {
        ll p, p1;
        cin >> p >> p1;
        --p, --p1;
        //++map1[p];
        //++map1[p1];
        arr[p].push_back(p1);
        arr[p1].push_back(p);
    }
    zapr.resize(b);
    for (ll i = 0; i < b; ++i)
    {
        cin >> zapr[i].F >> zapr[i].S;
        ++map1[zapr[i].F - 1];
        ++map1[zapr[i].S - 1];
    }
    ll maxv = 0;
    for (auto it : map1)
        if (map1[maxv] < it.S)
            maxv = it.F;
    //cout << maxv << endl;
    dfs(maxv, maxv, 1);
    vector <ll> ot;
    ot.resize(a);
    ll maxot = 0;
    for (ll i = 0; i < b; ++i)
    {
        ll v, v1;
        //cin >> v >> v1;
        v = zapr[i].F;
        v1 = zapr[i].S;
        --v, --v1;
        ll v1_l = v1;
        ll v_l = v;
        if (height[v] > height[v1])
            swap(v, v1);
        v1 = up(v1, height[v1] - height[v]);
        if (maxv == v1_l)
            swap(v_l, v1_l);
        //cout << v << " " << v1 << endl;
        if (v1 == v)
        {
            vector <ll> prost;
            prost.push_back(v1_l);
            while(v1_l != v)
            {
                v1_l = parent[v1_l];
                prost.push_back(v1_l);
            }
            reverse(prost.begin(), prost.end());
            for (ll i = 0; i < prost.size(); ++i)
            {
                //cout << prost[i] << " ";
                if (ot[prost[i]] == 0)
                {
                    ++maxot;
                    ot[prost[i]] = maxot;
                }
            }
            //cout << endl;
            continue;
        }
    }
    cout << maxot << endl;
    //if (c == 1)
        for (ll i = 0; i < a; ++i)
            cout << ot[i] << " ";
}
