#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 20 + 15;
int n, m, t;
vector <int> g[N];

pii is[N];

int p[N];

vector <int> nwg[N], gr[N];

void dfs(int v) {
    for(int to : g[v]) {
        if(to != p[v]) {
            p[to] = v;
            dfs(to);
        }
    }
}

int cur[N], ans[N];

bool e[N][N];

void mark(int v, int now = 1) {
    Max(cur[v], now);
    for(int to : nwg[v]) {
        mark(to, now + 1);
    }
}

main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    cin >> n >> m >> t;
    for(int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    for(int i = 0; i < m; ++i) {
        cin >> is[i].f >> is[i].se;
        --is[i].f, --is[i].se;
    }
    for(int mask = 0; mask < (1 << m); ++mask) {
        memset(cur, 0, sizeof(cur));
        for(int i = 0; i < n; ++i)
            nwg[i].clear(), gr[i].clear();
        memset(e, 0, sizeof(e));
        bool flag = true;
        for(int i = 0; i < m; ++i) {
            if(1 << i & mask) {
                memset(p, -1, sizeof(p));
                dfs(is[i].f);
                int v = is[i].se;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    nwg[u].pb(v);
                    gr[v].pb(u);
                    e[u][v] = true;
                    if(e[v][u])
                        flag = false;
                }
            }
            else {
                memset(p, -1, sizeof(p));
                dfs(is[i].se);
                int v = is[i].f;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    nwg[u].pb(v);
                    gr[v].pb(u);
                    e[u][v] = true;
                    if(e[v][u])
                        flag = false;
                }
            }
//            for(int i = 0; i < n; ++i)
//                cout << p[i] << ' ';
//            cout << endl;
        }
//        cout << "mask: " << mask << endl;
//        for(int i = 0; i < n; ++i) {
//            cout << i << endl;
//            for(int to : nwg[i])
//                cout << to << ' ';
//            cout << endl;
//        }
//        cout << endl;
        if(flag) {
            for(int i = 0; i < n; ++i) {
                if(gr[i].empty())
                    mark(i, 1);
            }
        }
            int mx1 = *max_element(cur, cur + n);
            int mx2 = *max_element(ans, ans + n);
//            cout << "max: " << mx1 << ' ' << mx2 << endl;
            if(mx1 < mx2 || mx2 == 0) {
                for(int i = 0; i < n; ++i)
                    ans[i] = cur[i];
            }
    }
    if(ans[0] == 0)
        cout << -1 << endl;
    else {
        cout << *max_element(ans, ans + n) << endl;

        for(int i = 0; i < n; ++i)
            cout << ans[i] << ' ';
        cout << endl;
    }
    return 0;
}
