#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define fs first
#define sc second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

const int N = 10;
int ver[10][10][10];

vector<int> g[N], d(N), mark(N);
vector<pair<int, int>> ed(N);
int n, m, t;
int clr[N], res[N];
int ans = 100;

bool path(int v, int u) {
    int i = 0;
    int prev = -100;
    while(ver[v][u][i] != -1) {
        int cur = ver[v][u][i];
        if (prev >= clr[cur])
            return 0;
        prev = clr[cur];
        i++;
    }
    return 1;
}
void check() {
    int cur = 0;
    for (int i = 0; i < n; i++)
        cur = max(cur, clr[i]);
    bool ok = 1;
    for (int i = 0; i < m; i++)
        ok&=path(ed[i].fs, ed[i].sc);
    if (!ok)
        return ;

    if (cur < ans) {
        ans = cur;
        for (int i = 0; i < n; i++)
            res[i] = clr[i];
    }
}
void rec(int pos) {
    if (pos == n) {
       check();
       return ;
    }
    for (int i = 0; i < 10; i++) {
        clr[i] = i;
        rec(pos + 1);
    }
}

void dfs(int s, int v, int p) {
    int i = 0;
    for (i = 0; p != -1 && ver[s][p][i] != -1; i++)
        ver[s][v][i] = ver[s][p][i];
    ver[s][v][i] = v;

    for (auto u:g[v])
        if (u != p)
            dfs(s, u, v);
}

void solve1() {
    for (int i = 0; i < 10; i++)
        for (int j = 0; j < 10; j++)
            for (int k = 0; k < 10; k++)
                ver[i][j][k] = -1;
    for (int i = 0; i < n; i++)
        dfs(i, i, -1);
    rec(0);

    if (ans == 100)
        cout << -1;
    else {
        cout << ans + 1 << '\n';
        if (t)
            for (int i = 0; i < n; i++)
                cout << res[i] + 1 << ' ';
    }
}



signed main() {
    fastio;
    #ifdef FlameDragon
        freopen("in.txt", "r", stdin);
    #endif // FlameDragon


    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        ed[i] = {a, b};
    }

    solve1();
}


