#include <bits/stdc++.h>

#define ft first
#define sc second
#define int ll
#define len(v) (int)v.size()
#define pb push_back

using namespace std;
typedef long long ll;

int inf = 1e9 + 100;
vector<int> color;
vector<vector<int>> g;
vector<int> used;

bool dfs(int v, int cl = 1) {
	color[v] = cl;
	for (auto x : g[v]) {
		if(color[x] != -1) {
			if(color[x] == 3 - cl) 
				continue;
			return 0;
		}
		if(!dfs(x, 3 - cl))
			return 0;
	}
	return 1;
}

void dfs2(int v) {
	used[v] = 1;
	for (auto x : g[v]) {
		if(used[x]) 
			continue;
		dfs2(x);
	}
}

signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, t;
	cin >> n >> m >> t;
	if(n == 2) {
		cout << 2 << endl;
		cout << 1 << " " << 2 << endl;
		return 0;
	}

	if(n <= 15 && m <= 15) {
		vector<pair<int, int>> have(n - 1);
		vector<pair<int, int>> need(m);
		for (int i = 0; i < n - 1; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			have[i] = {a, b};
		}	
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			need[i] = {a, b};
		}
		int answ = inf;
		vector<int> ans(n, inf);
		for (int i = 0; i < (1 << (n - 1)); i++) {
			g = vector<vector<int>> (n);
			int ic = i;
			for (int j = 0; j < n - 1; j++) {
				if(ic % 2 == 1) 
					g[have[j].sc].pb(have[j].ft);
				else
					g[have[j].ft].pb(have[j].sc);
				ic /= 2;
			}
			bool flag = 1;
			for (int j = 0; j < m; j++) {
				used = vector<int> (n, 0);
				dfs2(need[j].ft);
				if(used[need[j].sc]) 
					continue;
				used = vector<int> (n, 0);
				dfs2(need[j].sc);
				if(used[need[j].ft]) 
					continue;
				flag = 0;
				break;
			}
			if(!flag) 
				continue;
			used = vector<int> (n, 0);
			vector<int> now(n, 0);
			int k = 1;
			while(1) {
				vector<int> oao;
				for (int i = 0; i < n; i++) {
					if(used[i]) 
						continue;
					bool flag = 1;
					for (auto x : g[i]) {
						if(used[x])
							continue;
						flag = 0;
						break;
					}
					if(flag) 
						oao.pb(i);
				}
				if(len(oao) == 0) 
					break;
				for (auto x : oao) {
					used[x] = 1;
					now[x] = k;
				}
				k++;
			}
			if(answ > k - 1) {
				answ = k - 1;
				ans = now;
			}
		}
		if(answ == inf) {
			cout << -1;
			return 0;
		}
		cout << answ << endl;
		for (auto x : ans) 
			cout << x << " ";
		return 0;
	}
	g = vector<vector<int>> (n);

	vector<pair<int, int>> have(n - 1);
	vector<int> p(n);
	vector<int> cnt(n, 0);
	vector<pair<int, int>> need(m);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		have[i] = {a, b};
		cnt[a]++, cnt[b]++;
	}	
	int centr = -1;
	for (int i = 0; i < n; i++) {
		if(cnt[i] == n - 1) {
			centr = i;
			break;
		}
	}

	for (int i = 0; i < n - 1; i++) {
		if(have[i].sc == centr) 
			swap(have[i].ft, have[i].sc);
		p[have[i].sc] = i;
	}
	vector<int> used(n, 0);
	color = vector<int> (n + 1, -1);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if(a != centr) 
			used[p[a]] = 1;
		if(b != centr) 
			used[p[b]] = 1;
		if(a != centr && b != centr) {
			g[p[a]].pb(p[b]);
			g[p[b]].pb(p[a]);
		}
	}

	for (int i = 0; i < n; i++) {
		if(!used[i]) 
			continue;
		if(color[i] != -1) 
			continue;
		if(!dfs(i)) {
			cout << -1;
			return 0;
		}
	}
	int k = 1;
	vector<int> ans(n, 1);
	bool flag = 0;
	for (int i = 0; i < n - 1; i++) {
		if(color[i] != 1) 
			continue;
		ans[have[i].sc] = 1;
	}
	ans[centr] = 2;
	for (int i = 0; i < n - 1; i++) {
		if(color[i] != 2) 
			continue;
		flag = 1;
		ans[have[i].sc] = 3;
	}
	if(flag) 
		cout << 3 << endl;
	else
		cout << 2 << endl;
	for (auto x : ans) 
		cout << x << " ";
}