#include <iostream>
#include <cstring>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int ANS = MAXN + 5, C[MAXN + 5];
bool fff = true;
bool used[MAXN + 5];
int a[MAXN + 5], b[MAXN + 5];
map< pair<int, int>, bool> M;
int top_sort[MAXN + 5], c[MAXN + 5];
vector<int> G[MAXN + 5], G1[MAXN + 5];

bool DFS(int u, int v)
{
    used[u] = true;
    if (u == v) return true;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (DFS(G[u][i], v))
            {
                if (M.find({G[u][i], u}) != M.end())
                {
                    /// -1
                    fff = false;
                    return false;
                }
                else if (!(M.find({u, G[u][i]}) != M.end()))
                {
                    M[{u, G[u][i]}] = true;
                    G1[u].push_back(G[u][i]);
                }
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 0; i < m; ++ i)
    {
        cin >> a[i] >> b[i];
    }

    for (int i = 0; i < (1ll << m); ++ i)
    {
        memset(used, false, sizeof(used));
        fff = true;
        M.clear();
        for (int j = 1; j <= n; ++ j)
        {
            G1[j].clear();
            top_sort[j - 1] = 0;
            c[j] = 0;
        }

        for (int j = 0; j < m; ++ j)
        {
            if (i & (1ll << j)) DFS(a[j], b[j]);
            else DFS(b[j], a[j]);
            memset(used, false, sizeof(used));
            if (!fff) break;
        }

        if (!fff) continue;

        int k = 0;
        for (int j = 1; j <= n; ++ j)
        {
            if (G[j].size() == G1[j].size())
            {
                c[j] = 1;
                used[j] = true;
                top_sort[k++] = j;
            }
        }

        int ans = 1;
        for (int j = 0; j < k; ++ j)
        {
            int u = top_sort[j];
            for (int jj = 0; jj < G1[u].size(); ++ jj)
            {
                if (!used[G1[u][jj]])
                {
                    used[G1[u][jj]] = true;
                    top_sort[k++] = G1[u][jj];
                    c[G1[u][jj]] = c[u] + 1;
                    ans = max(ans, c[G1[u][jj]]);
                }
            }
        }

        if (t == 0)
        {
            cout << ans << endl;
            for (int j = 1; j <= n; ++ j)
                cout << (c[j] != 0 ? c[j] : 1) << " ";
            cout << endl;
            return 0;
        }

        if (ANS > ans)
        {
            ANS = ans;
            for (int j = 1; j <= n; ++ j)
                C[j] = (c[j] != 0 ? c[j] : 1);
        }
    }

    if (ANS == MAXN + 5) cout << -1 << endl;
    else
    {
        cout << ANS << endl;
        for (int i = 1; i <= n; ++ i)
            cout << C[i] << " ";
        cout << endl;
    }

    return 0;
}
