#include<bits/stdc++.h>
using namespace std;
const int nmax=5e5+42;
int n,m,t;
vector<int> adj[nmax];

int c[nmax];
vector<int> to[nmax];
int deg[nmax];

queue<int> to_remove;

int output[nmax],out_costs=-1;

int make_costs()
{
    for(int i=1;i<=n;i++)c[i]=1;

    for(int i=1;i<=n;i++)deg[i]=0;

    for(int i=1;i<=n;i++)
        for(auto k:to[i])
            deg[k]++;

    for(int i=1;i<=n;i++)
        if(deg[i]==0)to_remove.push(i);

    for(int i=1;i<=n;i++)
    {
        if(to_remove.size()==0)return -1;
        int current=to_remove.front();
        to_remove.pop();

        for(auto k:to[current])
        {
            c[k]=max(c[k],c[current]+1);
            deg[k]--;
            if(deg[k]==0)to_remove.push(k);
        }
    }
    int MX=0;
    for(int i=1;i<=n;i++)
        MX=max(MX,c[i]);

    if(out_costs==-1||out_costs>MX)
    {
        out_costs=MX;
        for(int i=1;i<=n;i++)
            output[i]=c[i];
    }
    return MX;
}

pair<int,int> lines[nmax];

int height[nmax];
int up[20][nmax];
int lca(int a,int b)
{
    if(height[a]>height[b])swap(a,b);
    for(int i=19;i>=0;i--)
        if(height[a]<=height[b]-(1<<i))b=up[i][b];
    if(a==b)return a;
    for(int i=19;i>=0;i--)
        if(up[i][a]!=up[i][b])a=up[i][a],b=up[i][b];
    return up[0][a];
}

int parent[nmax];
void dfs(int node,int p,int h)
{
    height[node]=h;
    up[0][node]=p;
    parent[node]=p;

    for(auto k:adj[node])
        if(k!=p)
        dfs(k,node,h+1);
}

void path(int start,int en,int add/*1-> add, -1->destroy*/)
{
    int mid=lca(start,en);
    while(start!=mid)
    {
        if(add==1)to[start].push_back(parent[start]);
        else to[start].pop_back();
        start=parent[start];
    }

    while(en!=mid)
    {
        if(add==1)to[parent[en]].push_back(en);
        else to[parent[en]].pop_back();
        en=parent[en];
    }
}
void rec(int pos)
{
    if(pos>m)
    {
        make_costs();
        return;
    }

    path(lines[pos].first,lines[pos].second,1);
    rec(pos+1);
    path(lines[pos].first,lines[pos].second,-1);

    path(lines[pos].second,lines[pos].first,1);
    rec(pos+1);
    path(lines[pos].second,lines[pos].first,-1);
}
int main()
{
    scanf("%i%i%i",&n,&m,&t);

    int u,v;
    for(int i=1;i<n;i++)
    {
        scanf("%i%i",&u,&v);
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=m;i++)
        scanf("%i%i",&lines[i].first,&lines[i].second);

    dfs(1,1,0);
    for(int st=1;st<20;st++)
        for(int i=1;i<=n;i++)
            up[st][i]=up[st-1][up[st-1][i]];

    rec(1);

    printf("%i\n",out_costs);

    if(out_costs!=-1)
    {
        for(int i=1;i<=n;i++)
        {
            printf("%i",output[i]);
            if(i==n)printf("\n");
            else printf(" ");
        }
    }
    return 0;
}
/*
3 1 1
1 2
2 3
1 3

3 1 0
1 2
2 3
1 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4
*/
