/*#pragma GCC optimize("Ofast, no-stack-protector")
 #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx,mmx,avx,tune-native")
 #pragma GCC optimize("unroll-loops")
 #pragma GCC optimize("fast-math") */

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()

typedef long long ll;
typedef long double lld;

const int maxn = 5e5 + 228;

int pre[maxn];

vector <int> g[maxn];

set <pair<int, int> > st;

int dp[maxn][20];

void DFS(int v, int p = -1) {
    pre[v] = p;
    for (auto to : g[v]) {
        if (to != p)
            DFS(to, v);
    }
}

int cnt[maxn];

int ans[maxn];

int ss = 0;

void GFS(int v, int cn = 1) {
    ans[v] = max(ans[v], cn);
    ss = max(ss, ans[v]);
    for (auto to : g[v]) {
        if (st.count({v, to}))
            GFS(to, cn + 1);
    }
}

int deep[maxn];

void build_lca(int v, int p = -1) {
    pre[v] = p;
    if (p == -1) {
        dp[v][0] = v;
        deep[v] = 0;
    } else {
        dp[v][0] = p;
        deep[v] = deep[p] + 1;
        for (int i = 1; i < 20; i++) {
            dp[v][i] = dp[dp[v][i-1]][i-1];
        }
    }
    for (auto to : g[v]) {
        if (to != p)
            build_lca(to, v);
    }
}


int lca(int a, int b) {
    if (deep[a] < deep[b])
        swap(a, b);
    for (int i = 19; i >= 0; i--) {
        if (deep[dp[a][i]] >= deep[b])
            a = dp[a][i];
    }
    if (a == b)
        return a;
    for (int i = 19; i >= 0; i--) {
        if (dp[a][i] != dp[b][i]) {
            a = dp[a][i];
            b = dp[b][i];
        }
    }
    return pre[a];
}

int sos[maxn];

int pokras(int v, int p = -1) {
    for (auto to : g[v]) {
        if (to != p)
            sos[v] += pokras(to, v);
    }
    return sos[v];
}

void flex(int v, int p = -1) {
    if (p == -1) {
        ans[v] = 1;
    } else {
        if (sos[v])
            ans[v] = ans[p] + 1;
        else
            ans[v] = 1;
    }
    for (auto to : g[v])
        if (to != p)
            flex(to, v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // комменти файлы, умоляю
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m, t;
    cin >> n >> m >> t;
    vector <pair<int, int> > v(n - 1);
    vector <pair<int, int> > f(m);
    for (auto &it : v) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
        it.first = x;
        it.second = y;
    }
    map <int, int> mp;
    int rt = -1;
    for (auto &it : f) {
        cin >> it.first >> it.second;
        mp[it.first]++;
        mp[it.second]++;
        if (mp[it.first] == m)
            rt = it.first;
        if (mp[it.second] == m)
            rt = it.second;
        /*fill(pre, pre + maxn, -1);
        DFS(it.first);
        int h = it.second;
        while (h != it.first) {
            st.insert({pre[h], h});
            cnt[h]++;
            h = pre[h];
        }*/
    }
    if (n <= 15 && m <= 15) {
        int resans = 1000;
        int ansuka[maxn];
        for (int step = 0; step < (1 << m); step++) {
            for (int i = 1; i <= n; i++) {
                cnt[i] = ans[i] = 0;
            }
            st.clear();
            int q = step;
            for (auto it : f) {
                if (q % 2)
                    swap(it.first, it.second);
                q /= 2;
                for (int i = 1; i <= n; i++) {
                    pre[i] = -1;
                }
                DFS(it.first);
                int h = it.second;
                while (h != it.first) {
                    st.insert({pre[h], h});
                    cnt[h]++;
                    h = pre[h];
                }
            }
            bool ok = true;
            for (auto it : v) {
                if (st.count({it.first, it.second}) && st.count({it.second, it.first})) {
                    ok = false;
                    break;
                }
            }
            if (!ok)
                continue;
            ss = 0;
            for (int i = 1; i <= n; i++) {
                if (!cnt[i]) {
                    GFS(i);
                }
            }
            if (ss < resans) {
                resans = ss;
                for (int i = 1; i <= n; i++) {
                    ansuka[i] = ans[i];
                }
            }
        }
        if (resans == 1000) {
            cout << -1;
        } else {
            cout << resans << endl;
            for (int i = 1; i <= n; i++) {
                cout << ansuka[i] << " ";
            }
        }
        return 0;
    }
    if (rt == -1)
        assert(0);
    for (auto it : f) {
            sos[it.second]++;
            sos[it.first]++;
    }
    pokras(rt);
    flex(rt);
    /*build_lca(1);
    for (auto it : f) {
        int h = lca(it.first, it.second);
        vector <int> ch;
        int w =  it.first;
        while (w != h) }{

    }*/
    int mx = 0;
    for (int i = 1; i <= n; i++)
        mx =max(mx, ans[i]);
    cout << mx << endl;
    for (int i = 1; i <= n; i++)
        cout << ans[i] << " ";
    return 0;
}