#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
const int maxn = 500000;
int rr = 0;
vector<int> in(maxn);
vector<int> out(maxn);
vector<int> pred(maxn);
vector<vector<int>> g(maxn);
vector<int> d(maxn, 1);
int f(int v1, int v2) {
    int an = 0;
    while(v1 != -1 && !(in[v1] <= in[v2] && out[v2] <= out[v1])) {
        ++an;
        v1 = pred[v1];
    }
    return an;
}
void m1(int v1, int v2, int l) {
    while(v1 != -1 && !(in[v1] <= in[v2] && out[v2] <= out[v1])) {
        d[v1] = l;
        --l;
        v1 = pred[v1];
    }
}
void m2(int v1, int v2) {
    int g = 1;
    while(v1 != -1 && !(in[v1] <= in[v2] && out[v2] <= out[v1])) {
        d[v1] = g;
        ++g;
        v1 = pred[v1];
    }
    d[v1] = g;
}
void dfs(int v, int pref = -1) {
    pred[v] = pref;
    in[v] = rr;
    ++rr;
    for(int i = 0; i < g[v].size(); ++i) {
        if(pref == g[v][i]) {
            continue;
        }
        dfs(g[v][i], v);
    }
    out[v] = rr;
    ++rr;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    int t;
    cin >> t;
    for(int i = 0; i < n - 1; ++i) {
        int v1 , v2;
        cin >> v1 >> v2;
        --v1, --v2;
        g[v1].push_back(v2);
        g[v2].push_back(v1);
    }
    dfs(0);
    int ans = 1;
    for(int i = 0; i < m; ++i) {
        int v1, v2;
        cin >> v1 >> v2;
        --v1, --v2;
        int l = 1 + f(v1, v2) + f(v2, v1);
        ans = max(ans, l);
        m1(v1, v2, l);
        m2(v2, v1);
    }
    cout << ans << "\n";
    for(int i = 0; i < n; ++i) {
        cout << d[i] << " ";
    }
}
