#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

int n, m;
vector <vector <int>> g;
vector <pii> way;
vector <pii> r;

vector <bool> use;
bool flag = 0;

vector <int> out;
void give(int x, int d) {

	use[x] = 1;
	out[x] = d;

	FR(i, n) if (g[x][i] != 0 && !use[i]) give(i, d + g[x][i]);


}

bool dfs(int x, int v) {

	bool ans = 0;

	use[x] = 1;
	if (x == v) return 1;

	FR(i, n) if (g[x][i] == 1 && !use[i]) ans |= dfs(i, v);

	return ans;
}

int out_ans = int(1e9);
vector <int> out_out;

void check() {

	bool ans = 1;
	FR(i, m) {

		FR(i, n) use[i] = 0;
		if (!dfs(way[i].first, way[i].second)) ans = 0;

	}

	if (ans) {
	
		flag = 1;
		FR(i, n) use[i] = 0;
		
		give(0, 0);

		int mn = 0, mx = 0;
		FR(i, n) mn = min(mn, out[i]), mx = max(mx, out[i]);

		mn = -mn + 1;

		if (mn + mx < out_ans) {
		
			out_ans = mn + mx;
			FR(i, n) out_out[i] = out[i] + mn;

		}

	}
}

void rec(int step) {

	if (step == n - 1) {
	
		check();
		return;

	}

	g[r[step].first][r[step].second] = 1;
	g[r[step].second][r[step].first] = -1;
	
	//if (rec(step + 1)) return true;
	rec(step + 1);

	g[r[step].first][r[step].second] = -1;
	g[r[step].second][r[step].first] = 1;

	//if (rec(step + 1)) return true;
	rec(step + 1);

	return;

}



int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t;
	cin >> n >> m >> t;

	use.resize(n);
	out.resize(n);
	out_out.resize(n);

	g.resize(n, vector <int> (n));
	r.resize(n - 1);
	FR(i, n - 1) cin >> r[i].first >> r[i].second, r[i].first--, r[i].second--;

	way.resize(m);
	FR(i, m) cin >> way[i].first >> way[i].second, way[i].first--, way[i].second--;

	rec(0);
	if (!flag) cout << -1;
	else {
	
		cout << out_ans << '\n';
		FR(i, n) cout << out_out[i] << ' ';

	}

	/*if (rec(0)) {
		
		FR(i, n) use[i] = 0;
		out.resize(n);
		give(0, 0);

		int mn = 0, mx = 0;
		FR(i, n) mn = min(mn, out[i]), mx = max(mx, out[i]);

		mn = -mn + 1;
		cout << mx + mn << '\n';
		FR(i, n) cout << mn + out[i] << ' ';

	}
	else cout << -1;*/

	return 0;
}
