#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
const int mod = 1e9 +33, P = 37, N = 5000;

vvi g;
int n, m;
vi pr;
vvi up;
int L;
int timer = 0;
vi tin, tout, gl;

int lg(int a){
    int l = 0;
    while((1 << l) < a)
        l++;
    return l;
}

void dfs(int v, int p){
    gl[v] = gl[p] + 1;
    tin[v] = timer++;
    pr[v] = p;
    up[v][0] = p;
    for (int i = 1; i < L + 1; ++i){
        up[v][i] = up[up[v][i -1]][i - 1];
    }
    for (int i = 0; i < g[v].size(); ++i){
        int to = g[v][i];
        if (to != p)
            dfs(to, v);
    }
    tout[v] = timer++;
}

bool upper(int a, int b){
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b){
    if (upper(a, b))
        return a;
    if (upper(b, a))
        return b;
    for (int i = L; i > -1; --i){
        if (!upper(up[a][i], b))
            a = up[a][i];
    }
    assert(upper(pr[a], b));
    return pr[a];
}


int32_t main()
{
    int t;
    cin >> n >> m >> t;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    gl.resize(n);
    pr.resize(n);
    L = lg(n);
    up.assign(n, vector<int>(L + 1));
    for (int i = 0; i < n - 1; ++i){
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0);
    vi res(n);
    for (int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int lc =lca(a, b);
        int len = gl[a] + gl[b] - gl[lc] * 2 + 1;
        int tec = 1;
        while(a != lc)
            res[a] = tec++, a = pr[a];
        while(b != lc)
            res[b] = len--, b = pr[b];
        assert(len == tec);
        res[lc] = len;
    }
    int mx = 0;
    for (int i = 0; i < n; ++i){
        if (!res[i])
            res[i] = 1;
        mx = max(mx, res[i]);
    }
    cout<< mx << "\n";
    for(int i = 0; i < n; ++i)
    cout << res[i + 0] << " ";
}

