#include <bits/stdc++.h>

using namespace std;

signed main() {
  int n, m, t;
  cin >> n >> m >> t;
  vector<vector<int>> graph(n);
  for (int i = 0; i < n - 1; i++) {
    int v, u;
    cin >> v >> u;
    v--;
    u--;
    graph[v].push_back(u);
    graph[u].push_back(v);
  }
  int center = 0;
  for (int i = 0; i < n; i++) {
    if (graph[i].size() == n - 1) {
      center = i;
      break;
    }
  }
  vector<int> inq(n, 0);
  queue<int> q;
  vector<pair<int, int>> paths(m);
  set<pair<int, int>> setik;
  for (int i = 0; i < m; i++) {
    cin >> paths[i].first >> paths[i].second;
    paths[i].first--;
    paths[i].second--;
    setik.emplace(paths[i].second, i);
    setik.emplace(paths[i].first, i);
  }
  vector<int> ans(n, -1);
  if (center == 0) {
    ans[1] = 1;
    q.push(1);
    inq[1] = 1;
  } else {
    ans[0] = 1;
    q.push(0);
    inq[0] = 1;
  }
  ans[center] = 2;
  while (!q.empty()) {
    int cur = q.front();
    q.pop();
    auto it = setik.lower_bound({cur, -1});
    while (it != setik.end() && it->first == cur) {
      int ind = it->second;
      int end = paths[ind].first ^paths[ind].second ^cur;
      if (end != center) {
        if (ans[end] != -1) {
          cout << -1;
          return 0;
        }
        ans[end] = 1 ^ 3 ^ ans[cur];
        if (!inq[end]) {
          inq[end] = 1;
          q.push(end);
        }
      }
      setik.erase(it);
      setik.erase({end, ind});
      it = setik.lower_bound({cur, -1});
    }
  }
  for (int i = 0; i < n; i++) {
    if (ans[i] == -1)
      ans[i] = 1;
  }
  cout << *max_element(ans.begin(), ans.end()) << '\n';
  for (auto e : ans) {
    cout << e << ' ';
  }
  return 0;
}