#include <bits/stdc++.h>
#define FI(n) for(int i = 0; i < n; ++i)
#define FJ(n) for(int j = 0; j < n; ++j)
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define endl '\n'
#define g0(x) get<0>(x)
#define g1(x) get<1>(x)
#define g2(x) get<2>(x)

#ifndef LOCAL
    #define LOCAL 0
#endif // LOCAL
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define cerr LOCAL && std::cerr
#define watch(x) cerr << #x << " = " << x << endl

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using namespace std;

int main()
{
#if !LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#endif

    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<tuple<int, int, bool>>> g(n);
    FI(n - 1)
    {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].eb(u, i, 0);
        g[u].eb(v, i, 1);
    }
    vector<pair<int, int>> q(m);
    FI(m)
    {
        cin >> q[i].first >> q[i].second;
        q[i].first--, q[i].second--;
    }
    if (n <= 15)
    {
        int best = INT_MAX;
        vector<int> ans;
        FI(1 << (n - 1))
        {
            bool ok = true;
            FJ(m)
            {
                int a = q[j].first;
                int b = q[j].second;
                auto check = [&](int from, int to) -> bool
                {
                    vector<bool> used(n);
                    used[from] = true;
                    queue<int> q;
                    q.push(from);
                    while (!q.empty())
                    {
                        int v = q.front();
                        q.pop();
                        for (const auto& it : g[v])
                        {
                            int u = g0(it);
                            int id = g1(it);
                            bool flag = g2(it);
                            if (bool(i & (1 << id)) != flag)
                                continue;
                            if (!used[u])
                            {
                                used[u] = true;
                                q.push(u);
                            }
                        }
                    }
                    return used[to];
                };
                if (!check(a, b) && !check(b, a))
                {
                    ok = false;
                    break;
                }
            }
            if (!ok)
                continue;
            vector<int> cur(n, 1);
            FJ(n)
            {
                bool skip = false;
                for (const auto& it : g[j])
                {
                    int u = g0(it);
                    int id = g1(it);
                    bool flag = g2(it);
                    if (bool(i & (1 << id)) != flag)
                    {
                        skip = true;
                        break;
                    }
                }
                if (skip)
                    continue;
                vector<bool> used(n);
                used[j] = true;
                queue<int> q;
                q.push(j);
                while (!q.empty())
                {
                    int v = q.front();
                    q.pop();
                    for (const auto& it : g[v])
                    {
                        int u = g0(it);
                        int id = g1(it);
                        bool flag = g2(it);
                        if (bool(i & (1 << id)) != flag)
                            continue;
                        if (!used[u])
                        {
                            used[u] = true;
                            cur[u] = max(cur[u], cur[v] + 1);
                            q.push(u);
                        }
                    }
                }
            }
            int curans = *max_element(cur.begin(), cur.end());
            if (curans < best)
            {
                best = curans;
                ans = cur;
            }
        }
        if (best == INT_MAX)
            cout << -1;
        else
        {
            cout << best << endl;
            FI(n)
                cout << ans[i] << ' ';
        }
        return 0;
    }

    return 0;
}

/**
3 1 1
1 2
2 3
1 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4
*/
