#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}


vector<int> g[100];
vector<int> now;
vector<int> path;

int cost[100][100];

void dfs(int v, int need, int p = -1) {
	now.push_back(v);

	if (v == need) {
		path = now;
	}
	for (auto u: g[v]) {

		if (u == p) {
			continue;
		}
		dfs(u, need, v);
	}

	now.pop_back();
}


vector<int> now1(100);

void dfs1(int v, int s, int p = -1) {
	now1[v] = s;

	for (auto u: g[v]) {
		if (u == p) {
			continue;
		}

		dfs1(u, s + cost[v][u], v);
	}
}

signed main() {
	//fast_io();

	int n, m, t;
	cin >> n >> m >> t;

	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	vector<pair<int, int>> arr(m);

	vector<vector<int>> paths(m);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		dfs(a, b);
		paths[i] = path;

		/*for (auto ll : path) {
            cout << ll << " ";
		}
		cout << endl;*/
	}

	int ans_val = 57575757;
	vector<int> ans(n);

	for (int mask = 0; mask < (1 << m); mask++) {

		for (int i = 0; i < 100; i++) {
			for (int j = 0; j < 100; j++) {
				cost[i][j] = 0;
			}
		}

		bool lol = true;
		for (int i = 0; i < m; i++) {
			auto kek = paths[i];

			if ((mask & (1 << i)) > 0) {
				reverse(kek.begin(), kek.end());
			}

			for (int i = 0; i < (int)kek.size() - 1; i++) {
				int v = kek[i];
				int u = kek[i + 1];
				if (cost[v][u] == -1) {
					lol = false;
					break;
				}
				cost[v][u] = 1;
				if (cost[u][v] == 1) {
					lol = false;
					break;
				}
				cost[u][v] = -1;
			}
		}

		if (!lol) {
            continue;
        }

        /*cout << mask << endl;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                cout << cost[i][j] << " ";
            }
            cout << endl;
        }

        cout << endl;*/

        dfs1(0, 0);

        int min1 = 1000000LL;
        int max1 = -100000LL;

        for (int i = 0; i < n; i++) {
            min1 = min(now1[i], min1);
            max1 = max(now1[i], max1);
        }

        if (max1 - min1 + 1 < ans_val) {
            ans_val = max1 - min1 + 1;

            for (int i = 0; i < n; i++) {
                ans[i] = now1[i] - min1 + 1;
            }
        }
	}

	if (ans_val == 57575757) {
		cout << -1;
		return 0;
	}

	cout << ans_val << endl;

	for (int i = 0; i < n; i++) {
		cout << ans[i] << " ";
	}
    return 0;
}
