#include <bits/stdc++.h>

#pragma GCC optimize("-O3")
#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")


#define fi first
#define se second
#define p_b push_back
#define m_p make_pair
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sqr(x) ((x) * (x))
#define pw(x) (1ll << x)
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define fout(x) {cout << x << "\n"; return;}

using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAXN = 1123456;
const ll N = 5e5;
const ll inf = 1e18;
const ll mod = 1e9 + 7;
const ll mod1 = 998244353;
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
template <typename T> void vout(T s){cout << s << endl; exit(0);}

vector <ll> v[MAXN], g[MAXN];
ll cnt[MAXN], tin[MAXN], tout[MAXN], stn, deep[MAXN], p[MAXN], n, m, t, f[MAXN], ans[MAXN], dp[MAXN];
pll qr[MAXN];

void color(ll x, ll cl){
    if(f[x])return;
    ans[x] = cl;
    f[x] = 1;
    ll need = 1;
    if(cl == 1)need = 3;
    for(auto to : g[x]){
        if(f[to]){
            if(ans[to] != need)vout(-1);
        }else color(to, need);
    }
}

void dfs(ll x, ll pr = 0){
    p[x] = pr;
    tin[x] = ++stn;
    deep[x] = deep[pr] + 1;
    for(auto to : v[x])if(to != pr)dfs(to, x);
    tout[x] = stn;
}

void solve1(ll root){
    for(int i = 1; i <= n; i++)ans[i] = 1;
    ans[root] = 2;
    for(int i = 0; i < m; i++){
        ll a = qr[i].fi, b = qr[i].se;
        if(a != root && b != root){
            g[a].p_b(b);
            g[b].p_b(a);
        }
    }
    for(int i = 1; i <= n; i++)if(root != i && !f[i])color(i, 1);
    cout << *max_element(ans + 1, ans + n + 1) << "\n";
    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
    cout << "\n";
    exit(0);
}

void solve2(){
    vout(-1);
}

void way(ll a, ll b, vector <ll> &res){
    vector <ll> va, vb;
    while(deep[a] > deep[b]){
        va.p_b(a);
        a = p[a];
    }
    while(deep[a] < deep[b]){
        vb.p_b(b);
        b = p[b];
    }

    while(a != b){
        vb.p_b(b);
        b = p[b];
        va.p_b(a);
        a = p[a];
    }
    va.p_b(a);
    reverse(all(vb));
    for(auto i : vb)va.p_b(i);
    res = va;
    va.clear();
    vb.clear();
}

bool find_cycle(ll x){
    if(f[x] == 2)return 0;
    if(f[x] == 1)return 1;
    f[x] = 1;
    for(auto to : g[x]){
        if(find_cycle(to))return 1;
    }
    f[x] = 2;
    return 0;
}

vector <ll> order;

void top_sort(ll x){
    if(f[x])return;
    f[x] = 1;
    for(auto to : g[x])top_sort(to);
    order.p_b(x);
}

void solve_brute(){
    dfs(1ll);
    vector <ll> res;
    ll a, b;
    ll mx = -1;
    for(int musk = 0; musk < pw(m); musk++){
        fill(f + 1, f + n + 1, 0);
        for(int i = 1; i <= n; i++)g[i].clear();
        for(int i = 0; i < m; i++){
            res.clear();
            a = qr[i].fi, b = qr[i].se;
            if((musk & pw(i)))swap(a, b);
            way(a, b, res);
            for(int j = 1; j < sz(res); j++)g[res[j - 1]].p_b(res[j]);
        }
        bool cycle = 0;
        for(int i = 1; i <= n; i++)cycle |= find_cycle(i);
        if(cycle)continue;
        fill(f + 1, f + n + 1, 0);
        order.clear();
        for(int i = 1; i <= n; i++)top_sort(i);
        fill(dp + 1, dp + n + 1, 1);
        for(auto i : order){
            for(auto j : g[i]){
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        ll val = *max_element(dp + 1, dp + n + 1);
        if(val < mx || mx == -1){
            mx = val;
            for(int i = 1; i <= n; i++)ans[i] = dp[i];
        }
    }
    if(mx == -1)vout(-1);
    cout << mx << "\n";
    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
    cout << '\n';
    exit(0);
}


ll pre[N + 10][19], fufel[MAXN];

void build(ll x, ll pr = 0){
    pre[x][0] = pr;
    for(int i = 1; i < 19; i++)pre[x][i] = pre[pre[x][i - 1]][i - 1];
    tin[x] = ++stn;
    deep[x] = deep[pr] + 1;
    for(auto to : v[x])if(to != pr)build(to, x);
    tout[x] = stn;
}


bool is_less(ll a, ll b){
    return (tin[b] <= tin[a] && tout[a] <= tout[b]);
}

ll lca(ll a, ll b){
    if(is_less(b, a))return a;
    if(is_less(a, b))return b;
    for(int i = 18; i >= 0; i--)if(is_less(b, pre[a][i]))a = pre[a][i];
    return pre[a][0];
}

void calc(ll x){
    for(auto to : v[x])if(to != pre[x][0]){
        calc(to);
        fufel[x] += fufel[to];
    }
    if(fufel[x]){
        g[x].p_b(pre[x][0]);
        g[pre[x][0]].p_b(x);
    }
}

void result(ll x, ll deep){
    if(f[x])return;
    f[x] = 1;
    ans[x] = deep;
    for(auto to : g[x])result(to, deep + 1);
}

//void solve_mb_21(){
//    fill(ans + 1, ans + n + 1, 1);
//    build(1);
//    for(int i = 0; i < m; i++){
//        ll a, b;
//        a = qr[i].fi, b = qr[i].se;
//        fufel[a]++;
//        fufel[b]++;
//        fufel[lca(a, b)] -= 2;
//    }
//    calc(1);
//    for(int i = 1; i <= n; i++)if(sz(g[i]) == 1)result(i, 1);
//    cout << *max_element(ans + 1, ans + n + 1) << "\n";
//    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
//    cout << '\n';
//    exit(0);
//}

ll sn[MAXN];

map <ll, ll> mpp[MAXN];

void solve_mb_10(){
    fill(ans + 1, ans + n + 1, 1);
    vector <pll> fuf(m);
    build(1);
    dfs(1);
    for(int i = 0; i < m; i++){
        ll a, b;
        a = qr[i].fi, b = qr[i].se;
        fuf[i] = {deep[lca(a, b)], i};
    }
    sort(all(fuf));
    vector <ll> res;
    for(auto kek : fuf){
        res.clear();
        way(qr[kek.se].fi, qr[kek.se].se, res);
        for(int i = 1; i < sz(res); i++){
            if(mpp[res[i]].find(res[i - 1]) != mpp[res[i]].end()){
                reverse(all(res));
                break;
            }
        }
        for(int i = 1; i < sz(res); i++){
            if(mpp[res[i]].find(res[i - 1]) != mpp[res[i]].end()){
                vout(-1);
            }
            mpp[res[i - 1]][res[i]] = 1;
            g[res[i - 1]].p_b(res[i]);
        }
    }
    for(int i = 1; i <= n; i++)top_sort(i);
    ll step = 1;
    for(auto i : order){
        ans[i] = step++;
    }
    cout << *max_element(ans + 1, ans + n + 1) << "\n";
    for(int i = 1; i <= n; i++)cout << ans[i] << " ";
    cout << '\n';
    exit(0);
}

int main()
{
    tout[0] = inf;
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    cin >> n >> m >> t;

    for(int i = 1; i < n; i++){
        ll a, b;
        cin >> a >> b;
        v[a].p_b(b);
        v[b].p_b(a);
    }

    for(int i = 0; i < m; i++){
        cin >> qr[i].fi >> qr[i].se;
        cnt[qr[i].fi]++;
        cnt[qr[i].se]++;
    }

    ll x = 0;
    for(int i = 1; i <= n; i++)if(sz(v[i]) == n - 1)x = i;
    if(x)solve1(x);
    if(n <= 15 && m <= 15)solve_brute();
    solve_mb_10();

    return 0;
}
