#include <bits/stdc++.h>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define endl '\n'
#define ll long long

using namespace std;
const int MAXN = 5e5+2;
vector<int> gr[MAXN];
vector<int> need[MAXN];
int res[MAXN];
bool used[MAXN];
int mx = 1;
//0-----------------
int par[MAXN];
int h[MAXN];
vector<int> tmpGr[16];
bool matr[16][16];
int in[16];
//1-----------------
bool usedD[16];
int maxH[16];
int curH[16];
bool cycle = false;
void dfs(int v, bool start)
{
    res[v] = 2;
    if(start){
        res[v] = 0;
    }
    mx = max(mx,res[v]);
    used[v] = true;
    for(auto to:need[v]){
        if(!used[to]){
            dfs(to,!start);
        }
    }
}
void dfs1(int v, int p)
{
    h[v] = h[p]+1;
    par[v] = p;
    for(int i = 0; i < gr[v].size();i++){
        int to = gr[v][i];
        if(to != p){
            dfs1(to,v);
        }
    }
}
void dfs2(int v, int p)
{
    maxH[v] = 0;
    curH[v] = curH[p]+1;
    usedD[v] = true;
    for(int i = 0;i<tmpGr[v].size();i++){
        int to = tmpGr[v][i];
        if(usedD[to] && curH[v] >= curH[to]){
            cycle = true;
        }
        if(!usedD[to]){
            dfs2(to,v);
            maxH[v] = max(maxH[v],maxH[to]+1);
            continue;
        }
        if(curH[v] +1 == curH[to]){
            maxH[v] = max(maxH[v],maxH[to]+1);
        }
    }
}
signed main()
{
    fast;
    freopen("input.txt","r",stdin);
    int n, m, t;
    cin >> n >> m >> t;
    int a, b;
    for(int i = 1; i < n;i++){
        cin >> a >> b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector<pair<int,int>> path(m);
    for(int i = 0; i < m;i++){
        cin >> path[i].first >> path[i].second;
        need[path[i].first].push_back(path[i].second);
        need[path[i].second].push_back(path[i].first);
    }
    if(n <= 15 && m <= 15){
        vector<vector<int>> ord(m);
        for(int i = 0; i < m ;i++){
            int start = path[i].first;
            par[start] = start;
            h[start] = 0;
            dfs1(start,start);
            int cur = path[i].second;
            while(cur != start){
                ord[i].push_back(cur);
                cur = par[cur];
            }
            ord[i].push_back(cur);
        }
        int globAnswer = 1e9;
        int mask = -1;
        for(int i = 0; i < (1<<m);i++){
            for(int j = 0; j < 16;j++){
                for(int k = 0; k < 16;k++){
                    matr[j][k] = false;
                }
                tmpGr[j].clear();
                in[j] = 0;
                usedD[j] = false;
                cycle = false;
                res[j] = 0;
                curH[j] = 0;
            }
            bool bad = false;
            for(int j = 0; j < m;j++){
                if(i&(1<<j)){   // 1 means reversed
                    for(int k = ord[j].size()-1;k> 0;k--){
                        a = ord[j][k];
                        b = ord[j][k-1];
                        if(matr[b][a]){
                            bad = true;
                            break;
                        }
                        if(matr[a][b]){
                            continue;
                        }
                        matr[a][b] = true;
                        tmpGr[a].push_back(b);
                        in[b]++;
                    }
                }
                else{
                    for(int k = 0;k+1 < ord[j].size();k++){
                        a = ord[j][k];
                        b = ord[j][k+1];
                        if(matr[b][a]){
                            bad = true;
                            break;
                        }
                        if(matr[a][b]){
                            continue;
                        }
                        matr[a][b] = true;
                        tmpGr[a].push_back(b);
                        in[b]++;
                    }
                }
            }
            // not forget to inialize
            if(bad){
                continue;
            }
            bool went = false;
            cycle = false;
            int answer = 1;
            for(int j = 1; j <= n;j++){
                if(in[j] == 0){
                    went = true;
                    dfs2(j,j);
                    answer = max(answer,maxH[j]);
                }
            }
            if(cycle || !went){
                continue;
            }
            if(globAnswer > answer){
                globAnswer = answer;
                mask = i;
            }
        }
        // output answer --------------------------------
        if(mask == -1){
            cout << -1 << endl;
            exit(0);
        }
        for(int j = 0; j < 16;j++){
            for(int k = 0; k < 16;k++){
                matr[j][k] = false;
            }
            res[j] = 0;
            tmpGr[j].clear();
            in[j] = 0;
            usedD[j] = false;
            cycle = false;
            curH[j] = 0;
        }
        bool bad = false;
        for(int j = 0; j < m;j++){
            if(mask&(1<<j)){   // 1 means reversed
                for(int k = ord[j].size()-1;k> 0;k--){
                    a = ord[j][k];
                    b = ord[j][k-1];
                    if(matr[b][a]){
                        bad = true;
                        break;
                    }
                    if(matr[a][b]){
                        continue;
                    }
                    matr[a][b] = true;
                    tmpGr[a].push_back(b);
                    in[b]++;
                }
            }
            else{
                for(int k = 0;k+1 < ord[j].size();k++){
                    a = ord[j][k];
                    b = ord[j][k+1];
                    if(matr[b][a]){
                        bad = true;
                        break;
                    }
                    if(matr[a][b]){
                        continue;
                    }
                    matr[a][b] = true;
                    tmpGr[a].push_back(b);
                    in[b]++;
                }
            }
        }
        // not forget to inialize
        bool went = false;
        cycle = false;
        int answer = 1;
        for(int j = 1; j <= n;j++){
            if(in[j] == 0){
                went = true;
                dfs2(j,j);
                answer = max(answer,maxH[j]);
            }
        }
        cout << answer+1 << endl;
        for(int i = 1; i <= n;i++){
            cout << maxH[i]+1 << " " ;
        }
        cout << endl;
        exit(0);
    }
    int v = 1;
    for(int i = 1; i <= n;i++){
        if(gr[i].size() > 1){
            v = i;
        }
    }
    res[v] = 1;
    used[v] = true;
    for(int i = 1; i <= n;i++){
        if(!used[i]){
            dfs(i,true);
        }
    }
    for(int i = 0; i < m;i++){
        if(res[path[i].first] == res[path[i].second]){
            cout << -1 << endl;
            exit(0);
        }
    }
    cout << mx+1 << endl;
    for(int i = 1; i <= n;i++){
        cout << res[i]+1 << " " ;
    }
    cout << endl;

    return 0;
}