#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define pb push_back
#define eb emplace_back
#define xmax(x,y) x = max(x, y)
#define xmin(x,y) x = min(x, y)
#define mp make_pair
#define output(a) cout << #a << ' '; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) sort(all(a)); a.resize(unique(all(a)) - a.begin());

using namespace std;

const int N = 5e5 + 7;
const int S = 20;
vector<int> g[N];

int res[N];

int tin[N], tout[N];
int t = 0;

int pr[N][S];

void dfs(int v, int p = 0) {
    pr[v][0] = p;
    for (int i = 1; i < S; ++i) {
        pr[v][i] = pr[pr[v][i - 1]][i - 1];
    }
    ++t;
    tin[v] = t;
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = t;
}

bool an(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (an(u, v)) {
        return u;
    }
    if (an(v, u)) {
        return v;
    }
    for (int i = S; i >= 0; --i) {
        if (!an(pr[u][i], v)) {
            u = pr[u][i];
        }
    }
    return pr[u][0];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;
    tout[0] = n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].eb(v);
        g[v].eb(u);
    }

    dfs(1);

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        int w = lca(u, v);
        vector<int> pu, pv;
        while (u != w) {
            pu.eb(u);
            u = pr[u][0];
        }
        while (v != w) {
            pv.eb(v);
            v = pr[v][0];
        }
        pu.eb(w);
        reverse(all(pv));
        xmax(ans, sz(pu) + sz(pv));
        int c = 1;
        for (int v : pu) {
            res[v] = c;
            ++c;
        }
        for (int v : pv) {
            res[v] = c;
            ++c;
        }
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; ++i) {
        cout << (!res[i] ? 1 : res[i]) << ' ';
    }
    return 0;
}
