#include <bits/stdc++.h>
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define pb push_back
#define fst first
#define snd second
#define all(c) c.begin(), c.end()
using namespace std;
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int INF32 = 1e9 + 228;
const ll INF64 = 2e18 + 228;
mt19937 rng(time(0));
uniform_int_distribution<int> rnd(1, 2);
vector< vector<int> > g;
vector<int> tin, tout;
int timer = 0;
vector<vector<int> > up;
vector<int> d;
int l = 20;

void dfs(int v, int p = -1, int dep = 0)
{
    tin[v] = timer++;
    d[v] = dep;
    up[v][0] = (p == -1 ? v : p);
    for(int i = 1; i < l; i++)
        up[v][i] = up[up[v][i - 1]][i - 1];
    for(auto& it : g[v])
        if(it != p)
            dfs(it, v, dep + 1);
    tout[v] = timer++;
}
bool upper(int a, int b)
{
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int lca(int a, int b)
{
    if(upper(a, b)) return a;
    if(upper(b, a)) return b;
    for(int i = l - 1; i >= 0; i--)
        if(!upper(up[a][i], b))
            a = up[a][i];
    return up[a][0];
}
vector< vector<pair<int, int> >  > lazy;
vector<int> can;
void ans(int v, int p = -1, int push = 0)
{
    for(auto& it : g[v])
        if(it != p)
        {
            ans(it, v, push + 1);
        }
    for(auto& it : g[v])
    {
        if(lazy[it][0].snd != it && lazy[it][0].fst != -1)
            if(lazy[v][0].fst < lazy[it][0].fst + 1)
            {
                lazy[v][0].fst = lazy[it][0].fst + 1;
                lazy[v][0].snd = lazy[it][0].snd;
            }
        if(lazy[it][1].snd != it && lazy[it][1].fst != -1)
            if(lazy[v][1].fst < lazy[it][1].fst - 1)
            {
                lazy[v][1].fst = lazy[it][1].fst - 1;
                lazy[v][1].snd = lazy[it][1].snd;
            }
    }
    can[v] = max(0, max(lazy[v][0].fst, lazy[v][1].fst));
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    d.resize(n);
    up.resize(n, vector<int>(l));
    lazy.resize(n, vector<pair<int, int> >(2, {-1, -1}));
    can.resize(n);
    for(int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(0);
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        int x = lca(a, b);
        int len1 = d[a] - d[x];
        int len2 = d[b] - d[x];
        lazy[a][0] = {1, x};
        lazy[b][1] = {len2 + len1 + 1, x};
    }
//    cout << "\n";
//    for(int i = 0; i < n; i++)
//    {
//        for(int j = 0; j < 2; j++)
//            cout << lazy[i][j].fst << " " << lazy[i][j].snd << "\n";
//        cout << "\n";
//    }
//    cout << "\n";
    ans(0);
    for(auto& it : can)
        if(it == 0)
            it = 1;
    int mxlen = 0;
    for(int i = 0; i < n; i++)
        mxlen = max(mxlen, can[i]);
    cout << mxlen << "\n";
    for(auto& it : can)
        cout << it << " ";
    cout << "\n";
    return 0;
}
/**
6 2 1
1 2
1 3
3 5
2 4
4 6
3 5
2 6
*/
