#include <bits/stdc++.h>
#define int long long

using namespace std;


void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 500005;
vector <int> gr[maxn];
vector <pair <int, int> > g[maxn];
int up[maxn];
int used[maxn];
pair <int, int> req[maxn];
int n, m, t;
int pre[maxn][21];
vector <pair <int, int>> vec;
int deep[maxn];
int inf = 1e9;
int ans[maxn];
vector <int> hav[maxn];

void find_bin(int v, int p) {
    deep[v] = deep[p] + 1;
    for (auto to : gr[v]) {
        if (to == p) continue;
        pre[to][0] = v;
        for (int i = 1; i < 21; i++) {
            pre[to][i] = pre[pre[to][i - 1]][i - 1];
        }
        find_bin(to, v);
    }
}

int lca(int a, int b) {
    if (deep[b] > deep[a]) {
        swap(a, b);
    }
    for (int j = 20; j >= 0; j--) {
        if (deep[b] + (1 << j) <= a) {
            a = pre[a][j];
        }
    }
    if (a == b) {
        return a;
    }
    for (int j = 20; j >= 0; j--) {
        if (pre[a][j] != pre[b][j]) {
            a = pre[a][j];
            b = pre[b][j];
        }
    }
    return pre[a][0];
}

void chk(int v, int col) {
    used[v] = col;
    for (auto too : g[v]) {
        int to = too.first;
        int c = col;
        if (too.second) {
            c = c % 2 + 1;
        }
        if (!used[to]) {
            chk(to, c);
        } else {
            if (used[to] != c) {
                cout << -1;
                exit(0);
            }
        }
    }
}

signed main() {
    fast();
    int a, b, i, c, d, j, k;
    cin >> n >> m >> t;
    for (i = 0; i < n - 1; i++) {
        cin >> a >> b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    find_bin(1, 0);
    for (i = 1; i <= n; i++) {
        up[i] = inf;
    }
    for (i = 0; i < m; i++) {
        cin >> a >> b;
        req[i] = {a, b};
        c = lca(a, b);
        up[a] = min(up[a], deep[c]);
        up[b] = min(up[b], deep[c]);
        if (a != c && b != c) {
            g[a].push_back({b, 1});
            g[b].push_back({a, 1});
        }
    }
    for (i = 1; i <= n; i++) {
        vec.push_back({deep[i], i});
    }
    sort(vec.begin(), vec.end());
    for (i = n - 1; i >= 0; i--) {
        int v = vec[i].second;
        int p = pre[v][0];
        for (auto to : gr[v]) {
            if (to == p) continue;
            up[v] = min(up[v], up[to]);
        }
        if (up[v] <= deep[v] - 2) {
            g[p].push_back({v, 0});
            g[v].push_back({p, 0});
        }
    }
    for (i = 1; i <= n; i++) {
        if (!used[i]) {
            chk(i, 1);
        }
    }
    int mx = 0;
    for (i = 1; i <= n; i++) {
        ans[i] = deep[i] + 1e6;
        mx = max(mx, ans[i]);
    }
    cout << mx << endl;
    for (i = 1; i <= n; i++) {
        if (used[i] == 1) {
            ans[i] = 1e6 - deep[i];
        }
        cout << ans[i] << " ";
    }
    return 0;
}
