#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 3e5 + 234;
const int M = 1e9 + 7;

vector < int > g[N];

vector < int > ng[N];

pair < int, int > way[N];

int cost[N];

pair < int, int > e[N];

int in[N];

int tin[N], tout[N], timer;

int pr[N];

int best[N];

int h[N];

bool can(int v, int need) {
    if (v == need) {
        return 1;
    }
    for (auto to : g[v]) {
        if (can(to, need)) {
            ng[v].pb(to);
            ++in[to];
            return 1;
        }
    }
    return 0;
}

void dfs(int v) {
    for (auto to : ng[v]) {
        if (cost[to] < cost[v] + 1) {
            cost[to] = cost[v] + 1;
            dfs(to);
        }
    }
}

int n, m, t;

int up[N][20];

int res = 1;

bool upper(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

void prec(int v, int p) {
    tin[v] = ++timer;
    pr[v] = p;
    up[v][0] = p;
    for (int i = 1; i < 20; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to : g[v]) {
        if (to == p) {
            continue;
        }
        h[to] = h[v] + 1;
        prec(to, v);
    }
    tout[v] = ++timer;
}

int lca(int a, int b) {
    if (upper(a, b)) {
        while (1) {
            continue;
        }
    }
    if (upper(b, a)) {
        while (1) {
            continue;
        }
    }
    for (int i = 19; i >= 0; --i) {
        if (!upper(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

void inc(int x, int y, bool f) {
    res = max(res, best[x]);
    if (x == y) {
        return;
    }
    if (!f) {
        best[pr[x]] = best[x] + 1;
    } else {
        best[pr[x]] = best[x] - 1;
    }
    inc(pr[x], y, f);
}

void solve() {
    int x, y;
    for (int i = 1; i < n; ++i) {
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        g[y].pb(x);
    }
    for (int i = 0; i < n; ++i) {
        best[i] = 1;
    }
    prec(0, 0);
    int c;
    int cur;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        if (upper(x, y)) {
            inc(y, x, 0);
            continue;
        }
        if (upper(y, x)) {
            inc(x, y, 0);
            continue;
        }
        c = lca(x, y);
        inc(x, c, 0);
        cur = h[x] - h[c] + h[y] - h[c] + 1;
        best[y] = cur;
        inc(y, c, 1);
    }
    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << best[i] << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m >> t;
    if (n > 15) {
        solve();
        return 0;
    }
    int x, y;
    for (int i = 1; i < n; ++i) {
        cin >> x >> y;
        --x;
        --y;
        e[i] = {x, y};
    }
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        way[i] = {x, y};
    }
    bool ok;
    int cur;
    int ans = 1e9;
    for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
        for (int i = 0; i < n; ++i) {
            g[i].clear();
            ng[i].clear();
            cost[i] = 1;
            in[i] = 0;
        }
        for (int i = 1; i < n; ++i) {
            if ((1 << i) & mask) {
                g[e[i].F].pb(e[i].S);
            } else {
                g[e[i].S].pb(e[i].F);
            }
        }
        ok = 1;
        for (int i = 0; i < m; ++i) {
            if (!can(way[i].F, way[i].S) && !can(way[i].S, way[i].F)) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            for (int i = 0; i < n; ++i) {
                if (!in[i]) {
                    dfs(i);
                }
            }
            cur = 0;
            for (int i = 0; i < n; ++i) {
                cur = max(cur, cost[i]);
            }
            if (ans > cur) {
                ans = cur;
                for (int i = 0; i < n; ++i) {
                    best[i] = cost[i];
                }
            }
        }
    }
    if (ans == 1e9) {
        cout << -1;
    } else {
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) {
            cout << best[i] << ' ';
        }
    }
    return 0;
}
