#include <bits/stdc++.h>
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define pb push_back
#define fst first
#define snd second
#define all(c) c.begin(), c.end()
using namespace std;
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int INF32 = 1e9 + 228;
const ll INF64 = 2e18 + 228;
mt19937 rng(42);
uniform_int_distribution<int> rnd(0, INF32);
vector< set<int> > g;
vector<pair<int, int> > que;
vector<int> can;
vector<int> tin, tout;
int timer = 0;
vector<vector<int> > up;
int l = 20;

void dfs(int v, int p = -1)
{
    tin[v] = timer++;
    up[v][0] = (p == -1 ? v : p);
    for(int i = 1; i < l; i++)
        up[v][i] = up[up[v][i - 1]][i - 1];
    for(auto& it : g[v])
        if(it != p)
            dfs(it, v);
    tout[v] = timer++;
}
bool upper(int a, int b)
{
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int lca(int a, int b)
{
    if(upper(a, b)) return a;
    if(upper(b, a)) return b;
    for(int i = l - 1; i >= 0; i--)
        if(!upper(up[a][i], b))
            a = up[a][i];
    return up[a][0];
}
const int N = 20;
int napr[N][N];
bool trash = 0;
void go(int v, int targ, int type, int cur = 1)
{
//    cout << v << " " << targ << " " << type << " go\n";
    can[v] = max(can[v], cur);
    if(v == targ) return;
    if(type == 0)
    {
        for(auto& it : g[v])
        {
            if(upper(it, v))
            {
                if(napr[it][v])
                {
//                    cout << v << " -> " << it << " trash\n";
                    trash = 1;
                    return;
                }
                napr[v][it] = 1;
//                cout << v << " - > " << it << " 0\n";
                go(it, targ, type, can[v] + 1);
                break;
            }
        }
    }
    else
    {
        for(auto& it : g[v])
        {
            if(upper(v, it) && upper(it, targ))
            {
                if(napr[it][v])
                {
//                    cout << v << " -> " << it << " trash\n";
                    trash = 1;
                    return;
                }
                napr[v][it] = 1;
//                cout << v << " - > " << it << " 1\n";
                go(it, targ, type, can[v] + 1);
                break;
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    que.resize(m);
    can.resize(n, 0);
    tin.resize(n);
    tout.resize(n);
    up.resize(n, vector<int>(l));
    for(int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    dfs(0);
    for(int i = 0; i < m; i++)
    {
        cin >> que[i].fst >> que[i].snd;
        que[i].fst--;
        que[i].snd--;
    }
    int mask = 0;
    int lim = (1 << m);
    int best = INF32;
    vector<int> bans;
    while(mask != lim)
    {
        can.clear();
        can.resize(n, 0);
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
                napr[i][j] = 0;
        bool bad = 0;
        for(int i = 0; i < m; i++)
        {
            int from, to;
            if((mask >> i) & 1)
            {
                from = que[i].fst;
                to = que[i].snd;
            }
            else
            {
                from = que[i].snd;
                to = que[i].fst;
            }
//            cout << from << " " << to << "\n";
            trash = 0;
            if(upper(to, from))
            {
                go(from, to, 0);
            }
            else if(upper(from, to))
            {
                go(from, to, 1);
            }
            else
            {
                int x = lca(from, to);
                go(from, x, 0);
                go(x, to, 1);
            }
//            cout << trash << "\n";
//            for(int i = 0; i < n; i++, cout << "\n")
//                for(int j = 0; j < n; j++)
//                cout << napr[i][j] << " ";
//            cout << "\n";
            if(trash)
            {
                bad = 1;
                break;
            }
        }
        if(bad)
        {
            mask++;
            continue;
        }
//        for(auto& it : can)
//            cout << it << " ";
//        cout << "\n";
        int mx = 0;
        for(int i = 0; i < n; i++)
        {
            mx = max(mx, can[i]);
        }
//        cout << ind << "\n";
//        for(auto& it : can)
//            cout << it << " ";
//        cout << "\n";
        if(mx < best)
        {
            best = mx;
            bans = can;
        }

        mask++;
    }
    if(best == INF32)
    {
        cout << -1;
        return 0;
    }
    int mxans = 0;
    for(auto& it : bans)
    {
        if(it == 0)
            it++;
        mxans = max(mxans, it);
    }

    cout << mxans << "\n";
    for(auto& it : bans)
        cout << it << " ";

    return 0;
}
