#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;
#define x first
#define y second

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<int> g[500009];
vector<int> color;

vector<int> way;
vector<vector<int>> ways;
void dfs(int v, int p, int fin, int ind) {
    way.push_back(v);
    if (v == fin) {ways[ind] = way; return;}

    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v, fin, ind);
    }

    way.pop_back();
}

int n, m;

const int inf = 1e9;
int mn = inf;
vector<int> answ;

inline void gen(int i, int up, int currmx) {
    bool ok = 1;
    for (auto u : ways) {
        bool rise = 1, nris = 1;
        int prev = color[u[0]];
        for (int x = 1; x < u.size(); x ++) {
            if (prev == 0) {
                prev = color[u[x]];
                continue;
            }

            if (color[u[x]] == 0) continue;

            if (prev <= color[u[x]]) nris = 0;
            if (prev >= color[u[x]]) rise = 0;
            prev = color[u[x]];
        }

        if (!rise && !nris) {
            ok = 0;
            break;
        }
    }

    if (!ok) return;

    if (i == n) {
        if (ok && mn > currmx) {
            mn = currmx;
            answ = color;
        }

        return;
    }

    for (int x = 1; x <= up; x++) {
        color[i] = x;
        gen(i + 1, up, max(x, currmx));
    }
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> n >> m >> t;

    for (int i = 0;  i< n - 1; i ++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    vector<pii> path(m);
    ways.resize(m);

    for (int i = 0; i < m; i ++) {
        cin >> path[i].x >> path[i].y;
        path[i].x--;
        path[i].y--;
        dfs(path[i].x, -1, path[i].y, i);
    }

    color.resize(n);
    gen(0, 64, 0);

    if (mn == inf) {
        cout << -1;
        return 0;
    }

    cout << mn << "\n";
    for (auto u : answ) {
        cout << u << ' ';
    }

    return 0;
}


