#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 5e5 + 15;
const int L = 22;
int n, m, t;
vector <int> g[N];

pii is[N];

int p[N];

vector <int> nwg[N], gr[N];

void dfs(int v) {
    for(int to : g[v]) {
        if(to != p[v]) {
            p[to] = v;
            dfs(to);
        }
    }
}

int cur[N], ans[N];

vector <int> topsort;

bool used[N];

void mark(int v) {
    used[v] = true;
    for(int to : nwg[v])
        if(!used[to])
            mark(to);
    topsort.pb(v);
}

int cnt[N];

int tin[N], tout[N], tt;

int up[L][N];

inline void build(int v, int p = 0) {
    up[0][v] = p;
    for(int i = 1; i < L; ++i)
        up[i][v] = up[i-1][up[i-1][v]];
    tin[v] = tt++;
    for(int to : g[v]) {
        if(to != p)
            build(to, v);
    }
    tout[v] = tt;
}

inline bool upper(int a, int b) {
    return tin[a] <= tin[b] && tin[b] < tout[a];
}

inline int lca(int a, int b){
    if(upper(a, b))
        return a;
    if(upper(b, a))
        return b;
    for(int i = L - 1; i >= 0; --i)
        if(!upper(up[i][a], b))
            a = up[i][a];
    return up[0][a];
}

int s[N];

void calc(int v, int p = -1) {
    for(int to : g[v])
        if(to != p) {
            calc(to, v);
            s[v] += s[to];
        }
}

void go(int v, int p = -1, int now = 1) {
    cur[v] = now;
    for(int to : g[v])
        if(to != p)
            go(to, v, now + 1);
}

void solve2() {
    build(0, 0);
    for(int i = 0; i < m; ++i)
        ++cnt[is[i].f], ++cnt[is[i].se];
    for(int i = 0; i < m; ++i) {
        int a = is[i].f, b = is[i].se;
        int lc = lca(a, b);
        ++s[a];
        ++s[b];
        s[lc] -= 2;
    }
    calc(0);
    for(int i = 0; i < n; ++i)
        if(cnt[i] == m) {
            go(i);
            break;
        }
    for(int i = 0; i < m; ++i)
        s[lca(is[i].f, is[i].se)] = 1;
    for(int i = 0; i < n; ++i)
        if(!s[i])
            cur[i] = 1;
//    for(int i = 0; i < n; ++i)
//        cout << s[i] << ' ';
//    cout << endl;
    cout << *max_element(cur, cur + n) << endl;
    for(int i = 0; i < n; ++i)
        cout << cur[i] << ' ';
    cout << endl;
}

void solve() {
for(int mask = 0; mask < (1 << m); ++mask) {
        for(int i = 0; i < n; ++i)
            cur[i] = 0;
        for(int i = 0; i < n; ++i)
            nwg[i].clear(), gr[i].clear();
        for(int i = 0; i < n; ++i)
            used[i] = false;
        bool flag = true;
        topsort.clear();
        for(int i = 0; i < m; ++i) {
            if(1 << i & mask) {
                for(int j = 0; j < n; ++j)
                    p[j] = -1;
                dfs(is[i].f);
                int v = is[i].se;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    nwg[u].pb(v);
                    gr[v].pb(u);
                }
            }
            else {
                for(int j = 0; j < n; ++j)
                    p[j] = -1;
                dfs(is[i].se);
                int v = is[i].f;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    nwg[u].pb(v);
                    gr[v].pb(u);
                }
            }
        }
//        cout << "mask: " << mask << endl;
//        for(int i = 0; i < n; ++i) {
//            cout << i << endl;
//            for(int to : nwg[i])
//                cout << to << ' ';
//            cout << endl;
//        }
//        cout << endl;
            for(int i = 0; i < n; ++i) {
                if(gr[i].empty())
                    mark(i);
            }
            reverse(topsort.begin(), topsort.end());
            for(int v : topsort) {
                if(cur[v] == 0)
                    cur[v] = 1;
                for(int to : nwg[v])
                    Max(cur[to], cur[v] + 1);
            }
            for(int i = 0; i < m; ++i) {
            if(1 << i & mask) {
                for(int j = 0; j < n; ++j)
                    p[j] = -1;
                dfs(is[i].f);
                int v = is[i].se;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    if(cur[u] >= cur[v])
                        flag = false;
                }
            }
            else {
                for(int j = 0; j < n; ++j)
                    p[j] = -1;
                dfs(is[i].se);
                int v = is[i].f;
                vector <int> now = {};
                while(v != -1) {
                    now.pb(v);
                    v = p[v];
                }
                reverse(now.begin(), now.end());
                for(int i = 1; i < now.size(); ++i) {
                    int u = now[i-1], v = now[i];
                    if(cur[u] >= cur[v])
                        flag = false;
                }
            }
        }
        if(!flag)
            continue;

            int mx1 = *max_element(cur, cur + n);
            int mx2 = *max_element(ans, ans + n);
//            cout << "max: " << mx1 << ' ' << mx2 << endl;
            if(mx1 < mx2 || mx2 == 0) {
                for(int i = 0; i < n; ++i)
                    ans[i] = cur[i];
            }
    }
    if(ans[0] == 0)
        cout << -1 << endl;
    else {
        cout << *max_element(ans, ans + n) << endl;

        for(int i = 0; i < n; ++i)
            cout << ans[i] << ' ';
        cout << endl;
    }
}

main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    cin >> n >> m >> t;
    for(int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    for(int i = 0; i < m; ++i) {
        cin >> is[i].f >> is[i].se;
        --is[i].f, --is[i].se;
    }
    if(n <= 16)
        solve();
    else
        solve2();
    return 0;
}
