#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int mod = 1e9 + 7;
const int pri = 997;
const ld PI = acos(-1);

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}

const int N = 22;
#define pt dada

vector < int > g[N], pt[N][N], cur;

int n, m, a[N], b[N], qa[N], qb[N];
int rt=  0;

void dfs (int v, int pr = 0) {
	cur.pb(v);

	for(auto it : cur)
		pt[rt][v].pb(it);

	for (auto e : g[v]) {
		int to = (a[e] ^ b[e] ^ v);
		if (to != pr) {
			dfs(to, v);
		}
	}

	cur.pop_back();
}

unordered_map < int , int > dir[N];

int res = -1;
int Ans[N];
vector < int > gr[N];
int in[N], out[N];

int u[N];
int ans[N];

void two (int v) {
	u[v] = 1;
	//ans[v] = 1;
	for (auto e : g[v]) {
		int to = (a[e] ^ b[e] ^ v);
		if (!u[to]) {
			ans[to] = 3 - ans[v];
			two(to);
		}
	}
}

void go (int v) {
	if (u[v]) return;
	u[v] = ans[v] = 1;

	for (auto to : gr[v]) {
		go(to);
		ans[v] = max(ans[v], ans[to] + 1);
	}
}

void add (int a, int b) {
	in[b]++;
	out[a]++;
	gr[a].pb(b);
}

inline void upd () {
	for (int i = 1; i <= n; i ++) gr[i].clear(), u[i] = 0, in[i] = out[i] = 0;
	for (int i = 1; i < n; i ++) {
		if (dir[a[i]][b[i]] == 1)
			add(a[i], b[i]);

		if (dir[b[i]][a[i]] == 1)
			add(b[i], a[i]);
	}

	for (int i = 1; i <= n; i ++) if (!u[i] && !in[i]) {
		go(i);
	}

	for (int i = 1; i <= n; i ++) if (!u[i]) {
		ans[i] = 1;
		two(i);	
	}

	int k = *max_element(ans + 1, ans + n + 1);
	if (res == -1 || k < res) {
		res = k;
		for (int i = 1; i <= n; ++i) Ans[i] = ans[i];
	}
}

int main () {
	randomizer3000 ();
	int cs;
	cin >> n >> m >> cs;
	for (int i = 1; i < n; ++i) {
		cin >> a[i] >> b[i];
		g[a[i]].pb(i);
		g[b[i]].pb(i);
	}		

	for (int i = 1; i <= n; i ++) {
		rt = i;
		dfs(i);
	}
	for (int i = 0; i < m; i ++)
		cin >> qa[i] >> qb[i];
	//exit(0);
	for (int msk = 0; msk < (1 << m); ++msk) {
		for (int i = 1; i <= n; i ++) dir[i].clear();
		for (int i = 0; i < m; ++i) if (msk & (1 << i)) {
			int lst = -1;
			for (auto it : pt[qa[i]][qb[i]]) {
				if (lst != -1)
					dir[lst][it] = 1;

				lst = it;
			}
		} else {
			int lst = -1;
			for (auto it : pt[qb[i]][qa[i]]) {
				if (lst != -1)
					dir[lst][it] = 1;

				lst = it;
			}
		}
		bool bad = 0;
		for (int i = 1; i < n; i ++) {
			if (dir[a[i]][b[i]] == 1 && dir[b[i]][a[i]] == 1) {
				bad = 1;
				break;
			}
		}
		if(bad) continue;
		upd();
	}
	if (res == -1) {
		cout << -1 << '\n';
		exit(0);
	}

	int k = *max_element(Ans + 1, Ans + 1 + n);
	printf("%d\n", k);
	for (int i = 1; i <= n; i ++)
		printf("%d ", Ans[i]);
	puts("");
}
