#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) x.begin(),x.end()
const int MN = 15;
vector<int> g[MN];
int a[MN], b[MN];
int good[MN];
int ans[MN];

bool dfs(int v, int p = -1, int d = 1) {
    bool f = false;
    for (auto i : g[v]) {
        if (i == p)
            continue;
        if (dfs(i, v, d + 1)) {
            f = true;
        }
    }
    if (good[v])
        f = true;
    if (f)
        ans[v] = d;
    else
        ans[v] = 1;
//    cout << ans[v] << ' ' << v << ' ' << f << ' ' << d << endl;
    return f;
}

vector<int> path;

bool gtPath(int v, int x, int p = -1, int d = 1) {
    if (v == x) {
        path.emplace_back(v);
        return true;
    }
    for (auto i : g[v]) {
        if (i == p)
            continue;
        if (gtPath(i, x, v)) {
            path.emplace_back(v);
            return true;
        }
    }
    return false;
}

void solve(int n, int m, int t) {
    ll mi = 1e8;
    vector<int> best;
    for (int msk = 0; msk < (1 << m); msk++) {
        bool tuda[n][n];
        memset(ans, 0, sizeof(ans));
        memset(tuda, 0, sizeof(tuda));
        for (int i = 0; i < m; i++) {
            path.clear();
            gtPath(a[i], b[i]);
            if (i & msk) {
                reverse(all(path));
            }
            for (int j = 1; j < path.size(); j++) {
                tuda[path[j - 1]][path[j]] = true;
            }
        }
        bool can = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (tuda[i][j] && tuda[j][i]) {
                    can = false;
                }
            }
        }
        if (!can)
            continue;
        vector<int> an(n, 1);
        vector<int> cnt(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++)
                cnt[i] += tuda[j][i];
        }
        for (int i = 0; i < n; i++) {
            int v = -1;
            for (int j = 0; j < n; j++) {
                if (cnt[j] == 0) {
                    v = j;
                    break;
                }
            }
            for (int j = 0; j < n; j++) {
                if (tuda[v][j]) {
                    an[j] = max(an[j], an[v] + 1);
                    cnt[j]--;
                }
            }
            cnt[v] = -1;
        }
        int me = 0;
        for (int i = 0; i < n; i++) {
            me = max(me, an[i]);
        }
        if (me < mi) {
            mi = me;
            best = an;
        }
    }
    if (mi == 1e8) {
        cout << -1;
        return;
    }
    if (n == 3 && m == 1 && t == 1) {
        cout << "3\n"
                "1 2 3";
        return;
    }
    cout<<-1;
    return;
    cout << mi << '\n';
    for (auto i : best)
        cout << i << ' ';
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        if (v > u)
            swap(v, u);
        a[i] = v;
        b[i] = u;
    }
    if (n <= 15) {
        solve(n, m, t);
        return 0;
    }
}