//#define _GLIBcxx_DEBUG

#pragma GCC optimaze("unroll-loops")
//#pragma GCC optimaze("fast-math")
//#pragma GCC optimaze("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;

/*int n;
int g[16][16];
vector<vector<vector<int>>> path;
vector<int> h;

void dfs(int v, int p, int v0) {
	for (int u = 0; u <= n; ++u) {
		if (g[v][u] && u != p) {
			path[v0][u] = path[v0][v];
			path[v0][u].push_back(u);
			if (v0 == 1) {
				h[u] = h[v] + 1;
			}
			dfs(u, v, v0);
		}
	}
}*/

vector<vector<int>> g;
vector<bool> onPath;
vector<int> dist;

void dfs(int v, int p) {
	for (int u : g[v]) {
		if (u != p) {
			dist[u] = dist[v] + 1;
			dfs(u, v);
			if (onPath[u]) {
				onPath[v] = true;
			}
		}
	}
}

signed main() {
	fastio();
	int n, m, t; cin >> n >> m >> t;
	g = vector<vector<int>>(n + 1);
	onPath = vector<bool>(n + 1, false);
	dist = vector<int>(n + 1, 1);
	for (int i = 0; i < n - 1; ++i) {
		int a, b; cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int v1, v2; cin >> v1 >> v2;
	onPath[v1] = true;
	onPath[v2] = true;
	for (int i = 0; i < m - 1; ++i) {
		int u, v; cin >> u >> v;
		if (u != v1 && v != v1) {
			swap(v1, v2);
		}
		onPath[u] = true;
		onPath[v] = true;
	}
	dfs(v1, -1);
	int ma = 1;
	for (int i = 0; i <= n; ++i) {
		ma = max(ma, dist[i] * onPath[i]);
	}
	cout << ma << endl;
	if (t) {
		for (int i = 1; i <= n; ++i) {
			if (onPath[i]) {
				cout << dist[i] << " ";
			}
			else {
				cout << "1 ";
			}
		}
	}
	/*vector<pair<int, int>> l;
	path = vector<vector<vector<int>>>(16, vector<vector<int>>(16));
	h = vector<int>(16);
	for (int i = 0; i < m; ++i) {
		int u, v; cin >> u >> v;
		l.emplace_back(u, v);
	}
	for (int i = 0; i <= n; ++i) {
		path[i][i] = {i};
		dfs(i, -1, i);
	}
	for (int mask = 0; mask < (1 << m); ++mask) {
		bool ok = true;
		vector<vector<int>> f(16, vector<int>(16, 0));
		for (int i = 0; i < m; ++I) {
			if (mask & (1 << i)) {
				int u = l[i].first;
				int v = l[i].second;
				for (int i = 0; i < path[u][v].size() - 1; ++i) {
					int val = 1;
					if (h[path[u][v][i]] < h[path[u][v][i + 1]]) {
						val = 2;
					}
					if (f[path[u][v][i]][path[u][v][i + 1]] != val) {
						ok = false;
					}
					f[path[u][v][i]][path[u][v][i + 1]] = val;
				}
			}
			else {
				int v = l[i].first;
				int u = l[i].second;
				for (int i = 0; i < path[u][v].size() - 1; ++i) {
					int val = 1;
					if (h[path[u][v][i]] < h[path[u][v][i + 1]]) {
						val = 2;
					}
					if (f[path[u][v][i]][path[u][v][i + 1]] != val) {
						ok = false;
					}
					f[path[u][v][i]][path[u][v][i + 1]] = val;
				}
			}
		}
		if (!ok) {
			continue;
		}
		cout << mask << " ";
	}
	cout << endl;*/
}