#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

const int maxn = 500000;
vector<pair<int, int>> g[maxn], path[maxn], r, p;
vector<int> tin, tout, napr, inc[maxn], gn[maxn];
int timer = 0;
void dfs(int v = 0, int pr = 0, int i = 0) {
    p[v] = {pr, i};
    tin[v] = timer++;
    for (auto to : g[v]) {
        if (to.x != pr) dfs(to.x, v, to.y);
    }
    tout[v] = timer++;
}
bool ispr(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}
void addpath(int a, int b, int i) {
    if (ispr(a, b)) swap(a, b);
    for (; !ispr(a, b); a = p[a].x) {
        path[i].emplace_back(p[a].y, r[p[a].y].x == a ? 1 : -1);
        inc[p[a].y].push_back(i);
    }
    vector<pair<int, int>> tmp;
    for (; a != b; b = p[b].x) {
        tmp.emplace_back(p[b].y, r[p[b].y].x == b ? -1 : 1);
        inc[p[b].y].push_back(i);
    }
    reverse(all(tmp));
    for (auto j : tmp) path[i].push_back(j);
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, type;
    cin >> n >> m >> type;
    napr.assign(n - 1, 0);
    forn(i, n - 1) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].emplace_back(u, (int)r.size());
        g[u].emplace_back(v, (int)r.size());
        r.emplace_back(v, u);
    }
    p.resize(n);
    tin.resize(n);
    tout.resize(n);
    dfs();
    vector<pair<int, int>> b(m);
    forn(i, m) {
        cin >> b[i].x >> b[i].y;
        b[i].x--; b[i].y--;
        addpath(b[i].x, b[i].y, i);
    }
    napr.assign(n - 1, 0);
    if (n <= 15 && m <= 15) {
        if (n <= 15 && m <= 15) {
            vector<bool> tmp(m);
            vector<int> ans;
            int mn = inf;
            forn(mask, 1 << m) {
                forn(i, n) gn[i].clear();
                napr.assign(n - 1, 0);
                forn(i, m) tmp[i] = mask & (1 << i);
                bool ok = 1;
                forn(i, m) {
                    int cur = tmp[i] ? -1 : 1;
                    for (auto to : path[i]) {
                        if (cur * napr[to.x] * to.y == -1) {
                            ok = 0;
                            break;
                        }
                        napr[to.x] = cur * to.y;
                    }
                }
                if (!ok) continue;
                vector<int> st(n);
                forn(i, n - 1) {
                    if (napr[i] == 1) gn[r[i].x].push_back(r[i].y), st[r[i].y]++;
                    if (napr[i] == -1) gn[r[i].y].push_back(r[i].x), st[r[i].x]++;
                }
                queue<int> t;
                vector<int> d(n, -1);
                forn(i, n) {
                    if (!st[i]) t.push(i), d[i] = 0;
                }
                while (!t.empty()) {
                    auto v = t.front();
                    t.pop();
                    for (auto to : gn[v]) {
                        d[to] = d[v] + 1;
                        t.push(to);
                    }
                }
                int mx = 0;
                forn(i, n) uax(mx, d[i]);
                if (mx + 1 < mn) {
                    mn = mx + 1;
                    ans = d;
                }
            }
            if (mn == inf) {
                cout << -1 << el;
                return 0;
            }
            cout << mn << el;
            forn(i, n) cout << ans[i] + 1 << ' ';
            cout << el;
        }
    }
    else {
        vector<int> up(n - 1), down(n - 1), comp(n - 1);
        set<int> used, q, other;
        forn(i, n) other.insert(i);
        int cnt = 0;
        forn(i, m) {
            if (q.empty()) {
                q.insert(*other.begin());
                other.erase(other.begin());
            }
            int v = *q.begin();
            used.insert(*q.begin());
            q.erase(q.begin());
            bool ok = 1;
            int cur = 0;
            for (auto to : path[i]) {
                if (cur * (napr[to.x] * to.y) == -1) {
                    cout << -1 << el;
                    return 0;
                }
                if (napr[to.x] != 0) cur = napr[to.x] * to.y;
                for (auto j : inc[to.x]) {
                    if (used.find(j) == used.end()) {
                        q.insert(j);
                        other.erase(j);
                    }
                }
            }
            if (cur == 0) cur = 1;
            forn(j, path[i].size()) {
                auto to = path[i][j];
                napr[to.x] = cur * to.y;
                comp[to.x] = cnt;
                if (cur == 1) {
                    uax(down[to.x], j);
                    uax(up[to.x], n - j - 1);
                } else {
                    uax(up[to.x], j);
                    uax(down[to.x], n - j - 1);
                }
            }
            if (q.empty()) cnt++;
        }
        vector<int> st(n);
        forn(i, n - 1) {
            if (napr[i] == 1) gn[r[i].x].push_back(r[i].y), st[r[i].y]++;
            if (napr[i] == -1) gn[r[i].y].push_back(r[i].x), st[r[i].x]++;
        }
        queue<int> t;
        vector<int> d(n, -1);
        forn(i, n) {
            if (!st[i]) t.push(i), d[i] = 0;
        }
        while (!t.empty()) {
            auto v = t.front();
            t.pop();
            for (auto to : gn[v]) {
                d[to] = d[v] + 1;
                t.push(to);
            }
        }
        int mx = 0;
        forn(i, n) uax(mx, d[i]);
        bool tt = 0;
        forn(i, m) if ((int)path[i].size() > 1) tt = 1;
        if (!tt) {
            cout << 2 << el;
            forn(i, n) cout << (d[i] % 2) + 1 << ' ';
            cout << el;
        }
        else {
            cout << mx + 1 << el;
            forn(i, n) cout << d[i] + 1 << ' ';
            cout << el;
        }
    }
    return 0;
}