#define ll long long
#define pb push_back
#include<vector>
#include<deque>
#include<iostream>
//#include<bits/stdc++.h>

using namespace std;
template <class T>
ostream& operator <<(ostream &in, vector<T> & arr)
{
    for (T &i: arr)
    {
        in << i << " ";
    }
    return in;
}

vector<vector<ll> > gr(5* 10e5 + 2);
vector<ll> used(5* 10e5 + 2, 0);

void dfs(ll v, ll pre, ll fin, vector<ll> &way)
{
    way.pb(v);
    if (v == fin)
      return;

    for (int u: gr[v])
    {
        if (used[u] == 0 and u != pre)
        {
            dfs(u, v, fin, way);
            if (way[way.size() - 1] == fin)
                return;
        }
    }
    way.erase(way.begin() + way.size() - 1);

}

int main() {
    ll a;
    cin >> a;
    ll m, t;
    cin >> m >> t;
    for (int i = 0; i < a - 1; ++i)
    {
        ll x, y;
        cin >> x >> y;
        gr[x].pb(y);
        gr[y].pb(x);
    }
    vector<ll> ans(a + 1, 1);
    ll k = 1;

    for (int i = 0; i < m; ++i)
    {
        ll a, b;
        cin >> a >> b;
        vector<ll> way;
        dfs(a, -1, b, way);
        ll ops = 0;
        for (int j = 0; j < way.size(); ++j)
        {
            ops += 1;
            ops = max(ops, ans[way[j]]);
            used[way[j]] = 1;
            ans[way[j]] = ops;
            k = max(k, ops);
        }
        k = max(k, (ll)way.size());
    }
    cout << k << endl;
    for (int i = 1; i < a + 1; ++i)
        cout << ans[i] << " ";
}
