#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int long long
#define double long double
#define F first
#define S second
#define forn(i,n) for(int i=0;i<n;++i)

using namespace std;
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> SET;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
uniform_real_distribution<> rnd01(0,1);
const int N = 2e5+5;
const int INF  = 1e18+7;
const int MOD = 1e9+7;
const double EPS = 1e-9;

int a,b;
int to;
int n,m,t;
int bmx=INF, mx=1;
vector<int> bcolor,color;
vector<int> g[N];

bool have(int v, int p=-1)
{
    if(v==to){
        return true;
    }
    for(int u : g[v]){
        if(u!=p) if(have(u,v)) return true;
    }
    return false;
}

void dfs(int v, int p=-1)
{
    if(p!=-1){
        color[v]=max(color[v],color[p]+1);
    }
    for(int u : g[v]){
        if(u!=p && have(u,v)){
            dfs(u,v);
        }
    }
}

bool prov(int v, int p=-1)
{
    if(p!=-1){
        if(color[v]<=color[p]) return false;
    }
    for(int u : g[v]){
        if(u!=p && have(u,v)){
            return prov(u,v);
        }
    }
    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);
    cin>>n>>m>>t;
    bcolor.resize(n,1);
    color.resize(n,1);
    forn(i,n-1){
        cin>>a>>b; a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int,int>> v;
    forn(i,m){
        cin>>a>>b; a--, b--;
        v.push_back({a,b});
    }
    for(int mask=0;mask<(1LL<<m);mask++){
        /// 0 - a-b
        /// 1 - b-a
        vector<pair<int,int>> nv;
        for(int i=0;i<m;i++){
            if((mask>>i)&1){
                nv.push_back({v[i].F,v[i].S});
            }else{
                nv.push_back({v[i].S,v[i].F});
            }
        }
        sort(nv.begin(),nv.end());
        do{
            color.resize(n,1);
            for(int i=0;i<m;i++){
                to=nv[i].S;
                dfs(nv[i].F);
            }
            bool ok=true;
            for(int i=0;i<m;i++){
                to=nv[i].S;
                ok&=prov(nv[i].F);
            }
            if(ok){
                mx=1;
                for(int i=0;i<n;i++) mx=max(mx,color[i]);
                if(mx<bmx){
                    bmx=mx;
                    bcolor=color;
                }
            }
        }while(next_permutation(nv.begin(),nv.end()));
    }
    if(bmx==INF){
        cout<<-1<<endl;
    }else{
        cout<<bmx<<endl;
        for(int x : bcolor) cout<<x<<" ";
    }
}
