#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

//using ord = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
void solve();

signed main() {
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}

const int N = 5e5 + 5;
const int lg = 22;
int tin[N], tout[N], tt, n, m, t, sz[N], p[N], dp[lg][N], c[N], ans;
vector<int> g[N], gg[N], gr[N];
map<pair<int, int>, int> sp;
vector<int> lol[N];

int pred(int v) {
    return v == p[v] ? v : p[v] = pred(p[v]);
}

void merg(int a, int b) {
    a = pred(a);
    b = pred(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    p[b] = a;
}

void dfs(int v, int pr = -1) {
    if (pr != -1) {
        dp[v][0] = pr;
        for (int i = 1; i < lg; ++i) {
            dp[v][i] = dp[dp[v][i - 1]][i - 1];
        }
    }
    tin[v] = ++tt;
    for (auto d : g[v]) {
        if (d != pr) {
            dfs(d, v);
        }
    }
    tout[v] = ++tt;
}

bool check(int x, int y) {
    return tin[x] <= tin[y] && tout[x] >= tout[y];
}

int get_lca(int x, int y) {
    if (check(x, y)) return x;
    if (check(y, x)) return y;
    for (int i = lg - 1; i >= 0; --i) {
        if (dp[x][i] != 0 && !check(dp[x][i], y)) x = dp[x][i];
    }
    return dp[x][0];
}

void ddo(int a, int b) {
    int g = get_lca(a, b);
//    cout << a << ' ' << b << ' ' << g << '\n';
    int x = a;
    while (x != g) {
        int y = dp[x][0];
//        cout << x << ' ' << y << '\n';
        gr[x].pb(y);
        gg[y].pb(x);
        x = y;
    }
    x = b;
    while (x != g) {
        int y = dp[x][0];
//        cout << y << ' ' << x << '\n';
        gr[y].pb(x);
        gg[x].pb(y);
        x = y;
    }
}

int root[N], cc[N], uk, cnt, cntm[N], h[N], mxh[N], prom[N], mx, mxu[N], best, res[N];
bool used[N];
vector<int> ord;

void dfs1(int v) {
    used[v] = 1;
    for (auto d : gr[v]) {
        if (!used[d]) dfs1(d);
    }
    ord.pb(v);
}

void dfs2(int v) {
    used[v] = 1;
    ++cnt;
    for (auto d : gg[v]) {
        if (!used[d]) dfs2(d);
    }
}

bool can() {
    ord.clear();
    for (int i =1; i <= n; ++i) used[i]  =0;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(ord.begin(), ord.end());
    for (int i  =1; i <= n; ++i) used[i] = 0;
    for (auto d : ord) {
        if (!used[d]) {
            cnt = 0;
            dfs2(d);
            if (cnt > 1) {
                return false;
            }
        }
    }
    return true;
}

void getans(int v) {
    prom[v] = 1;
    for (auto d : gr[v]) {
        getans(d);
        prom[v] = max(prom[v], prom[d] + 1);
    }
    mx = max(mx, prom[v]);
}

void dfs4(int v) {
    used[v] = 1;
    cc[v] = uk;
    for (auto d : gg[v]) {
        if (!used[d]) {
            h[d] = h[v] + 1;
            dfs4(d);
            if (mxh[d] == mxh[v]) {
                ++cntm[v];
            }
            mxh[v] = max(mxh[v], mxh[d]);
        }
    }
    if (h[v] == mxh[v]) ++cntm[v];
    mxh[v] = max(mxh[v], h[v]);
}

void dfs5(int v, int pr = -1, int mxx = 0) {
    if (pr == -1) {
        mxu[v] = mxh[v];
        best = v;
    } else {
        mxu[v] = mxu[pr] + 1;
    }
    vector<pair<int, int>> vv;
    for (auto d : gg[v]) {
        if (pr != d) {
            vv.pb({mxh[d], d});
        }
    }
    sort(vv.begin(), vv.end());
    for (auto d : gg[v]) {
        if (pr != d) {
            if (vv.back().Y != d) {
                dfs5(d, v, max(mxx, vv.back().X) + 1);
            } else {
                if (sz(vv) == 1) {
                    dfs5(d, v, mxx + 1);
                } else {
                    dfs5(d, v, vv[sz(vv) - 2].X + 1);
                }
            }
        }
    }
    int lol = mxx;
    if (!vv.empty()) {
        lol = max(lol, vv.back().X);
    }
    mxu[v] = lol;
    if (lol < mxu[best]) {
        best = v;
    }
}

void dfs6(int v, int pr = -1) {
    c[v] = 1;
    for (auto d : gg[v]) {
        if (pr != d) {
            dfs6(d, v);
            c[v] = max(c[v], c[d] + 1);
        }
    }
}

void solve() {
    cin >>  n >> m >> t;
    for (int i =1 ; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    dfs(1);
    vector<pair<int, int>> v;
    for (int i = 1; i <= m; ++i) {
        int a, b;
        cin >> a >> b;
        v.pb({a, b});
    }
    ans = 1e9 + 7;
    if (n <= 15 && m <= 15) {
        for (int mask = 0; mask < (1 << (sz(v))); ++mask) {
            for (int i = 1; i <= n; ++i) gr[i].clear(), gg[i].clear();
     //       cout << "A" << endl;
            for (int i = 0; i < sz(v); ++i) {
                if ((1 << i) & mask) {
                    ddo(v[i].X, v[i].Y);
                } else {
                    ddo(v[i].Y, v[i].X);
                }
            }
    //        cout << "B" << endl;
            if (can()) {
                mx = 0;
    //            cout << "A" << endl;
                //for (int i = 1; i <= n; ++i) used[i] = 0;
                for (int i = 1; i <= n; ++i) {
     //               if (!used[i])
                    getans(i);
                }
                if (mx < ans) {
                    ans = mx;
                    for (int i = 1; i <= n; ++i) c[i] = prom[i];
                }
     //           cout << "B" << endl;
            }
        }
        if (ans == 1e9 + 7) {
            cout << -1;
            return;
        }
        cout << ans << '\n';
        for (int i = 1; i <= n; ++i) cout << c[i] << ' ';
        return;
    }
    for (auto d : v) {
        ddo(d.X, d.Y);
    }
    for (int i = 1; i <= n; ++i) {
        for (auto d : gr[i]) {
            gg[i].pb(d);
        }
    }
    ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            best = i;
            root[++uk] = i;
            dfs4(i);
            dfs5(i);
            root[uk] = best;
            ans = max(ans, mxu[best] + 1);
        }
    }
    cout << ans << '\n';
    for (int i = 1; i <= uk; ++i) {
        dfs6(root[i]);
    }
    for (int i = 1; i <= n; ++i) cout << c[i] << ' ';
}
//find_by_order
//order_of_key
