#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vvi g(n);
    map<int, int> cnt;
    forn(i, n - 1){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u), g[u].pb(v);
    }
    vi a(m), b(m);
    set<int> set1;
    forn(i, m){
        cin >> a[i] >> b[i];
        a[i]--, b[i]--;
        cnt[a[i]]++;
        cnt[b[i]]--;
        set1.insert(a[i]);
        set1.insert(b[i]);
    }
    vi ans(n, 1);
    forn(i, n){
        if (cnt[i] == m){
            queue<int> q;
            q.push(i);
            while (!q.empty()){
                int v = q.front();
                q.pop();
                for (int u : g[v]){
                    if (ans[u] != 1 || u == i) continue;
                    ans[u] = ans[v] + 1;
                    q.push(u);
                }
            }
            vi used(n);
            forn(j, n){
                if (g[j].size() == 1){
                    used[j] = 1;
                    q.push(j);
                }
            }
            while (!q.empty()){
                int v = q.front();
                q.pop();
                if (set1.count(v)) continue;
                ans[v] = 1;
                for (int u : g[v]){
                    if (used[u]) continue;
                    used[u] = 1;
                    q.push(u);
                }
            }
            cout << *max_element(all(ans)) << '\n';
            if (t){
                forn(j, n) cout << ans[j] << ' ';
                cout << '\n';
            }
            return 0;
        }
    }

    return 0;
}