#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;

mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

const int N = 5e5 + 7;

vector<pair<int, int>> g[N];

int tin[N], tout[N];
int tm = 0;

int c[N], p[N];

bool used[N];

void dfs(int v, int last = -1) {
	tin[v] = tm++;
	p[v] = last;
	for (auto u : g[v]) {
		if (u.first == last) continue;
		dfs(u.first, v);
	}
	tout[v] = tm++;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void calc(int v) {
	used[v] = true;
	c[v] = 1;
	for (auto u : g[v]) {
		if (u.second != -1) continue;
		if (!used[u.first]) {
			calc(u.first);
		}
		c[v] = max(c[v], c[u.first] + 1);
	}
}

int nc[N];

void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++) {
		int a, b; cin >> a >> b; a--; b--;
		g[a].push_back({ b, 0 });
		g[b].push_back({ a, 0 });
	}
	dfs(0);
	vector<pair<int, int>> f(m);
	for (int i = 0; i < m; i++) {
		cin >> f[i].first >> f[i].second;
		f[i].first--; f[i].second--;
	}
	if (n <= 15 && m <= 15) {
		int kek = inf0;
		for (int mask = 0; mask < (1 << m); mask++) {
			int ans = 1;
			for (int i = 0; i < n; i++) {
				used[i] = false;
				for (auto& u : g[i])
					u.second = 0;
			}
			for (int i = 0; i < m; i++) {
				int a = f[i].first;
				int b = f[i].second;
				if ((1 << i) & mask) swap(a, b);
				if (!upper(a, b))
					while (a != 0) {
						for (auto& u : g[a]) {
							if (u.first == p[a]) {
								if (u.second == -1) {
									//cout << -1 << endl;
									ans = inf0;
									break;
								}
								u.second = 1;
								break;
							}
						}
						for (auto& u : g[p[a]]) {
							if (u.first == a) {
								if (u.second == 1) {
									//cout << -1 << endl;
									ans = inf0;
									break;
								}
								u.second = -1;
								break;
							}
						}
						if (upper(p[a], b)) break;
						a = p[a];
					}
				if (!upper(b, a))
					while (b != 0) {
						for (auto& u : g[b]) {
							if (u.first == p[b]) {
								if (u.second == 1) {
									ans = inf0;
									break;
								}
								u.second = -1;
								break;
							}
						}
						for (auto& u : g[p[b]]) {
							if (u.first == b) {
								if (u.second == -1) {
									ans = inf0;
									break;
								}
								u.second = 1;
								break;
							}
						}
						if (upper(p[b], a)) break;
						b = p[b];
					}
			}
			for (int i = 0; i < n; i++) {
				if (!used[i]) calc(i);
				ans = max(ans, c[i]);
			}
			if (kek > ans) {
				kek = ans;
				for (int i = 0; i < n; i++)
					nc[i] = c[i];
			}
		}
		if (kek == inf0) cout << -1 << endl;
		else {
			cout << kek << endl;
			for (int i = 0; i < n; i++)
				cout << nc[i] << " ";
		}
	}
	else {
		sort(all(f));
		f.erase(unique(all(f)), f.end());
		m = f.size();
		int t = f[0].first;
		if (m > 1) {
			if (f[1].first != t && f[1].second != t)
				t = f[0].second;
		}
		int ans = 1;
		for (int i = 0; i < m; i++) {
			int a = f[i].first;
			int b = f[i].second;
			if (b == t) swap(a, b);
			if (!upper(a, b))
				while (a != 0) {
					for (auto& u : g[a]) {
						if (u.first == p[a]) {
							if (u.second == -1) {
								//cout << -1 << endl;
								ans = inf0;
								break;
							}
							u.second = 1;
							break;
						}
					}
					for (auto& u : g[p[a]]) {
						if (u.first == a) {
							if (u.second == 1) {
								//cout << -1 << endl;
								ans = inf0;
								break;
							}
							u.second = -1;
							break;
						}
					}
					if (upper(p[a], b)) break;
					a = p[a];
				}
			if (!upper(b, a))
				while (b != 0) {
					for (auto& u : g[b]) {
						if (u.first == p[b]) {
							if (u.second == 1) {
								ans = inf0;
								break;
							}
							u.second = -1;
							break;
						}
					}
					for (auto& u : g[p[b]]) {
						if (u.first == b) {
							if (u.second == -1) {
								ans = inf0;
								break;
							}
							u.second = 1;
							break;
						}
					}
					if (upper(p[b], a)) break;
					b = p[b];
				}
		}
		for (int i = 0; i < n; i++) {
			if (!used[i]) calc(i);
			ans = max(ans, c[i]);
		}
		if (ans == inf0) cout << -1 << endl;
		else {
			cout << ans << endl;
			if(t)
			for (int i = 0; i < n; i++) {
				cout << nc[i] << " ";
			}
		}
	}
}