#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair < int, int > pii;
#define sz(x) int(x.size())
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 2;
const int MOD = 1e9 + 7;
const int N = 5e5 + 7;

int n, m, t, ans[N];
vector < int > g[N];
vector < pii > s;



struct solver1 {
    int k[N];

    void dfs(int u, int p) {
        for (int v : g[u]) {
            if (v != p) {
                ans[v] = ans[u] + 1;
                dfs(v, u);
            }
        }
    }

    void solve() {
        int e;
        for (auto [u, v] : s) {
            k[u]++;
            k[v]++;
        }

        for (int i = 1; i <= n; i++) {
            if (k[i] == m) {
                e = i;
                break;
            }
        }

        ans[e] = 1;
        dfs(e, 0);
        //cout << e << endl;

        int mx = 0;
        for (auto [u, v] : s) {
            mx = max(mx, ans[u]);
            mx = max(mx, ans[v]);

            //cout << u << " " << v << endl;
        }

        cout << mx << endl;
        for (int i = 1; i <= n; i++) {
            cout << (ans[i] > mx ? 0 : ans[i]) << " ";
        }
    }
} s1;


struct solver2 {
    void solve() {

    }
} s2;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> m >> t;
    

    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int e1, e2;
    cin >> e1 >> e2;
    if (e1 > e2) {
        swap(e1, e2);
    }
    s.emplace_back(e1, e2);

    for (int i = 1; i < m; i++) {
        int u, v;
        cin >> u >> v;

        if (u > v) {
            swap(u, v);
        }
        if (u != e1) {
            e1 = 0;
        }
        if (v != e2) {
            e2 = 0;
        }
        s.emplace_back(u, v);
    }

    if (n <= 15 && m <= 15) {
        s1.solve();
    }
    else {
        s1.solve();
    }


    return 0;
}
