#include <bits/stdc++.h>
using namespace std;
int n, m;
bool t;
vector <int> adj [500005];
vector <int> lines [500005];
int par [500005];
vector <int> bfs1 (int u, int v){
    queue <int> q;
    for (int i = 0; i < n; i ++) par [i] = -1;
    par [u] = n;
    q.push (u);
    while (!q.empty ()){
        int a = q.front ();
        q.pop ();
        bool dali = 0;
        for (int i : adj [a]){
            if (i != par [a]){
                par [i] = a;
                q.push (i);
                if (i == v){
                    dali = 1;
                    break;
                }
            }
        }
        if (dali) break;
    }
    vector <int> ans;
    for (int i = v; i != n; i = par [i]) ans.push_back (i);
    reverse (ans.begin (), ans.end ());
    return ans;
}
vector <int> adj1 [500005];
pair <int, int> L [500005];
void bruteforce (){

    pair <int, vector <int> > ans;
    ans.first = n + 1;
    for (int i = 0; i < (1 << m); i ++){
        for (int j = 0; j < n; j ++) par [j] = 0, adj1 [j].clear ();
        queue <int> q;
        vector <int> val (n, 1);
        int k = 0;
        for (int j = 0; j < m; j ++){
            vector <int> x = lines [j];
            if ((i >> j) % 2) reverse (x.begin (), x.end ());
            int sz = x.size ();
            for (int p = 1; p < sz; p ++){
                adj1 [x [p - 1]].push_back (x [p]);
                par [x [p]] ++;
            }
            q.push (x [0]);
        }
        while (!q.empty ()){
            int a = q.front ();
            q.pop ();
            if (par [a] != 0) continue;
            par [a] = -1;
            k = max (k, val [a]);
            for (int p : adj1 [a]){
                val [p] = max (val [p], val [a] + 1);
                par [p] --;
                if (par [p] == 0) q.push (p);
            }
        }
        for (int j = 0; j < n; j ++) if (par [j] > 0) k = n + 2;
        ans = min (ans, {k, val});
    }
    if (ans.first == n + 1) cout << "-1\n";
    else{
        cout << ans.first << '\n';
        for (int i : ans.second) cout << i << ' ';
        cout << '\n';
    }
}
int ans [500005];
vector <int> ll [500005];
int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> t;
    for (int i = 1; i < n; i ++){
        int u, v;
        cin >> u >> v;
        u --; v --;
        adj [u].push_back (v);
        adj [v].push_back (u);
    }
    for (int i = 0; i < m; i ++){
        int u, v;
        cin >> u >> v;
        u --;
        v --;
        if (n <= 15 && m <= 15) lines [i] = bfs1 (u, v);
        else{
            L [i] = {u, v};
            ll [u].push_back (i);
            ll [v].push_back (i);
        }
    }
    if (n <= 15 && m <= 15){
        bruteforce ();
        return 0;
    }

    int centre;
    for (int i = 0; i < n; i ++){
        if (adj [i].size () > 1){
            centre = i;
            break;
        }
    }
    int br = 0;
    bool dali = 1;
    int Long;
while (br < m){
    Long = -1;
    for (int i = 0; i < m; i ++){
        if (L [i].first != centre && L [i].second != centre){
            Long = i;
            break;
        }
    }
    if (Long == -1){
        break;
    }
    br ++;
    ans [L [Long].first] = 1;
    ans [L [Long].second] = 3;
    ans [centre] = 2;
    queue <int> q;
    q.push (L [Long].first);
    q.push (L [Long].second);
    while (!q.empty ()){
        int a = q.front ();
        q.pop ();
        for (int j : ll [a]){
                auto i = L [j];
            if (ans [i.first] == ans [i.second]){
                dali = 0;
                break;
            }
            br ++;
            if (ans [i.first] == 0){
                ans [i.first] = 4 - ans [a];
                q.push (i.first);
            }
            else{
                ans [i.second] = 4 - ans [a];
                q.push (i.second);
            }
        }
        if (!dali) break;
    }
    if (!dali) break;

}

if (!dali){
    cout << "-1\n";
    return 0;
}
for (int i = 0; i < n; i ++) if (ans [i] == 0) ans [i] = 1;
ans [centre] = 2;
if (br == 0) cout << "2\n";
else cout << "3\n";
for (int i = 0; i < n; i ++) cout << ans [i] << ' ';
cout << '\n';

}
