#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
#define MP make_pair
#define PB push_back
#define MT make_tuple
#define RS resize
#define F(i, a, b) for(int i = int(a); i <= int(b); i++)
#define f(i, a, b) for(int i = int(a); i >= int(b); i--)

int const N = 5e5 + 47;
vi gr[N];
bool mark[N], uv[N];
int ans[N], mx;

bool dfs1(int v, int p = 0){
	bool need = mark[v];
	for(int to : gr[v]){
		if(to != p)
			need |= dfs1(to, v);
	}
	return uv[v] = need;
}
void dfs2(int v, int p = 0){
	if(uv[v])
		ans[v] = ans[p] + 1;
	else
		ans[v] = 1;
	mx = max(mx, ans[v]);
	for(int to: gr[v])
		if(to != p)
			dfs2(to, v);
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m, t;
	cin >> n >> m >> t;
	F(i, 1, n-1){
		int a, b;
		cin >> a >> b;
		gr[a].PB(b);
		gr[b].PB(a);
	}
	map<int, int> cnt;
	pii qu[m+1];
	int cen = 0;
	F(i, 1, m){
		int u, v;
		cin >> u >> v;
		mark[u] = 1;
		mark[v] = 1;
		cnt[u]++, cnt[v]++;
		qu[i] = MP(u, v);
	}
	if(cnt[qu[m].first] == m)
		cen = qu[m].first;
	else
		cen = qu[m].second;
	mark[cen] = 0;
	dfs1(cen);
	dfs2(cen);
	cout << mx << endl;
	F(i, 1, n)
		cout << ans[i] << ' ';
	return 0;
}