#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//#define int ll

int n, m, qqqqq;

vector<int> ans;
vector<vector<int>> g, g2;

void dfs(int v, int color) {
	ans[v] = color;
	for (auto to : g2[v]) {
		if (ans[to] == 0) {
			dfs(to, (color + 2) % 4);
		}
		if (ans[to] == color) {
			cout << -1;
			exit(0);
		}
	}
}

inline void solve() {
	cin >> n >> m >> qqqqq;
	g.resize(n);
	g2.resize(n);
	ans.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int q, w;
		cin >> q >> w;
		q--;
		w--;
		g[q].push_back(w);
		g[w].push_back(q);
	}
	vector<pair<int, int>> lines(m);
	for (int i = 0; i < m; i++) {
		int q, w;
		cin >> q >> w;
		q--;
		w--;
		g2[q].push_back(w);
		g2[w].push_back(q);
		lines[i] = { q, w };
	}
	int cent = 0;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == n - 1) {
			cent = i;
		}
	}
	ans[cent] = 2;
	for (int i = 0; i < n; i++) {
		if (!ans[i]) {
			dfs(i, 1);
		}
	}
	cout << *max_element(all(ans)) << nl;
	for (auto t : ans) {
		cout << t << ' ';
	}
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}