#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,avx,avx2")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

mt19937 rnd;

ll const N = 5e5 + 1, M = 228228227, INF = 1e18, P = 257;
ld const EPS = 1e-10;

void FastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

/*void zfunc(string s) {
    vector<ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (r >= i) {
            z[i] = min(z[i - l], r - i + 1);
        }

        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (i + z[i] - 1 > r) {
            r = i + z[i] - 1;
            l = i;
        }
    }
}

void pfunc(string s) {
    vector<ll> p(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        ll j = p[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        p[i] = j;
    }
}

ll tree[4 * N], mode[4 * N];

void Build(ll v, ll l , ll r) {
    if (r - l == 1) {
        tree[v] = 0;
    }

    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void Upd(ll v, ll l, ll r, ll pos, ll val) {
    if (r - l == 1 && l == pos) {
        tree[v] = val;
        return;
    }

    if (l > pos || r <= pos) {
        return;
    }

    ll m = (l + r) / 2;
    Upd(v * 2, l, m, pos, val);
    Upd(v * 2 + 1, m, r, pos, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return tree[v];
    }

    ll m = (l + r) / 2;
    return Get(v * 2, l, m, ql, qr) + Get(v * 2 + 1, m, r, ql, qr);
}

struct Node {
    ll x, sz, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rnd();
    }
};

ll GetSz(Node* tree) {
    return (tree ? tree->sz : 0);
}

void Update(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (! left) {
        return right;
    }
    if (! right) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        Update(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        Update(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (! tree) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        Update(tree);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        Update(tree);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        Update(tree);
        return {tree, tmp.second};
    }
}

Node* Ins(Node* tree, ll x, ll pos) {
    Node* node = new Node(x);
    auto tmp = Split(tree, pos - 1);
    return Merge(Merge(tmp.first, node), tmp.second);
}*/

vector<ll> g[N];
vector<ll> way, ansk;
ll a, b, m, n, an = INF;
vector<vector<ll> > f;

void Dfs(ll v, ll p) {
    way.push_back(v);
    if (v == b) {
        f.push_back(way);
        return;
    }
    for (int i = 0; i < g[v].size(); ++i) {
        if (g[v][i] == p) {
            continue;
        }
        Dfs(g[v][i], v);
    }
    way.pop_back();
}

void rec(ll x) {
    if (x == m) {
        set<pll> s;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < f[i].size() - 1; ++j) {
                if (s.find({f[i][j + 1], f[i][j]}) != s.end()) {
                    return;
                }
                else {
                    s.insert({f[i][j], f[i][j + 1]});
                }
            }
        }

        vector<ll> ans(n + 1, -INF);

        ll mx = 0;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < f[i].size(); ++j) {
                ans[f[i][j]] = max(ans[f[i][j]], (ll)i + 1);
                mx = max(mx, ans[f[i][j]]);
            }
        }

        for (int i = 0; i < m; ++i) {
            for (int j = 1; j < f[i].size(); ++j) {
                ans[f[i][j]] = max(ans[f[i][j]], ans[f[i][j - 1]]);
                mx = max(mx, ans[f[i][j]]);
            }
        }

        if (mx < an) {
            an = mx;
            ansk = ans;
        }

        return;
    }

    rec(x + 1);
    reverse(f[x].begin(), f[x].end());
    rec(x + 1);
    reverse(f[x].begin(), f[x].end());
}

int main() {
    FastIO();

    ll t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        Dfs(a, -1);
    }

    rec(0);
    if (an == INF) {
        cout << -1;
    }
    else {
        cout << an << '\n';
        for (int i = 1; i <= n; ++i) {
            cout << (ansk[i] == -INF ? 1 : ansk[i]) << ' ';
        }
    }

    return 0;
}
