#include <bits/stdc++.h>

using namespace std;

int n, m, t;
int col[9];
pair<int, int> e[9];
vector<int> adj[9];

bool good(int u, int v, int par = -1, int incr = 0){
    if(u == v)
        return true;

    for(int to: adj[u]){
        if(to == par || col[u] == col[to])
            continue;
        if(incr != 0 && incr != (col[to] > col[u] ? 1 : -1))
            continue;

        if(good(to, v, u, col[to] > col[u] ? 1 : -1))
            return true;
    }

    return false;
}

array<int, 9> check(){
    for(int i = 0; i < m; ++i){
        if(!good(e[i].first, e[i].second)){
            array<int, 9> ans;
            ans[0] = 10;
            return ans;
        }
    }

    array<int, 9> ans;
    ans[0] = 0;
    for(int i = 1; i <= n; ++i){
        ans[i] = col[i];
        ans[0] = max(ans[0], ans[i]);
    }
    return ans;
}

array<int, 9> recurse(int u){
    if(u == n + 1){
        array<int, 9> ans = check();
        return ans;
    }

    array<int, 9> ans;
    ans[0] = 10;
    for(int i = 1; i <= n; ++i){
        col[u] = i;
        array<int, 9> curr = recurse(u + 1);
        if(curr[0] < ans[0])
            ans = curr;
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> t;

    for(int i = 0; i < n - 1; ++i){
        int u, v;
        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i = 0; i < m; ++i)
        cin >> e[i].first >> e[i].second;

    auto ans = recurse(1);
    if(ans[0] == 10){
        cout << "-1\n";
        return 0;
    }

    cout << ans[0] << "\n";
    if(t == 1){
        for(int i = 1; i <= n; ++i)
            cout << ans[i] << " ";
        cout << "\n";
    }
}
