#include <bits/stdc++.h>

#define ft first
#define sc second
#define int ll
#define len(v) (int)v.size()
#define pb push_back

using namespace std;
typedef long long ll;

int inf = 1e9 + 100;

vector<vector<pair<int, int>>> g;
vector<vector<int>> g1;
vector<vector<int>> g2;
vector<vector<int>> g3;
vector<vector<int>> g4;
vector<int> tin;
vector<int> tout;
vector<pair<int, int>> pr;
vector<pair<int, int>> nado;
vector<int> comp;
vector<int> color;
vector<int> ob;
vector<int> used;
int T = 0;

void dfs(int v, int p = 0, int num = 0) {
	tin[v] = T++;
	pr[v] = {p, num};
	for (auto x : g[v]) {
		if(x.ft == p) 
			continue;
		dfs(x.ft, v, x.sc);
	}
	tout[v] = T++;
}

bool isp(int a, int b) {
	if(tin[a] <= tin[b] && tout[b] <= tout[a]) 
		return 1;
	return 0;
}

int up(int a, int b) {
	int ans = -1, pred = pr[a].sc;
	while(!isp(a, b)) {
		used[pr[a].sc] = 1;
		g1[pr[a].sc].pb(pred);
		g1[pred].pb(pr[a].sc);
		pred = pr[a].sc;
		ans = pr[a].sc, a = pr[a].ft;
	}
	return ans;
}


void doo(int a, int b) {
	int v1 = up(a, b), v2 = up(b, a);
	if(!isp(a, b) && !isp(b, a)) {
		nado.pb({v1, v2});
	}
	return;
}

void dfs1(int v, int cnt) {
	comp[v] = cnt;
	for (auto x : g1[v]) {
		if(comp[v] != -1) 
			continue;
		dfs1(x, cnt);
	}
}

bool dfs2(int v, int cl = 1) 
{
	color[v] = cl;
	for (auto x : g3[v]) {
		if(color[x] != -1) {
			if(color[x] == 3 - cl) 
				continue;
			return 0;
		}
		if(!dfs2(x, 3 - cl))
			return 0;
	}
	return 1;
}

void dfs3(int v) {
	used[v] = 1;
	for (auto x : g4[v]) {
		if(used[x]) 
			continue;
		dfs3(x);
	}
	ob.pb(v);
}


signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, m, t;
	cin >> n >> m >> t;
	vector<pair<int, int>> have(n - 1);
	tin = vector<int> (n, 0);
	tout = vector<int> (n, 0);
	g = vector<vector<pair<int, int>>> (n);
	g1 = vector<vector<int>> (n);
	g2 = vector<vector<int>> (n);
	comp = vector<int> (n, -1);
	color = vector<int> (n, -1);
	used = vector<int> (n, 0);
	pr = vector<pair<int, int>> (n);	
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		have[i] = {a, b};
		g[a].pb({b, i});
		g[b].pb({a, i});
	}
	dfs(0);
	for (int i = 0; i < n - 1; i++) {
		if(tin[have[i].ft] > tin[have[i].sc]) 
			swap(have[i].ft, have[i].sc);
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		doo(a, b);
	}

	int cnt = 0;
	for (int i = 0; i < n - 1; i++) {
		if(comp[i] != -1)
			continue;
		if(!used[i]) 
			continue;
		dfs1(i, cnt++); 
	}
	g3 = vector<vector<int>> (cnt);

	for (auto x : nado) {
		if(comp[x.ft] == comp[x.sc]) {
			cout << -1;
			return 0;
		}
		g3[comp[x.ft]].pb(comp[x.sc]);
		g3[comp[x.sc]].pb(comp[x.ft]);
	}

	for (int i = 0; i < cnt; i++) {
		if(color[i] != -1) 
			continue;
		if(!dfs2(i)) {
			cout << -1;
			return 0;
		}
	}

	g4 = vector<vector<int>> (n);
	for (int i = 0; i < n - 1; i++) {
		if(comp[i] == -1) 
			continue;
		if(color[comp[i]] == 1)
			g4[have[i].ft].pb(have[i].sc);
		else
			g4[have[i].sc].pb(have[i].ft);
	}
	used = vector<int> (n, 0);
	for (int i = 0; i < n; i++) {
		if(used[i]) 
			continue;
		dfs3(i);
	}

	vector<int> ans(n, 0);
	int answ = 0;
	for (int j = 0; j < n; j++) {
		int i = ob[j];
		for (auto x : g4[i]) {
			if(ans[x] == 0) 
				continue;
			ans[i] = max(ans[i], ans[x] + 1);
		}
		if(ans[i] == 0)
			ans[i] = 1;
		answ = max(answ, ans[i]);
	}

	cout << answ << endl;
	for (auto x : ans) {
		cout << x << " ";
	}
}