#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
bool dfs(int v, vector<vector<pair<int, int>>> &g, vector<int> &d, int en, int pred = -1) {
    if(v == en) {
        for(int i = 0; i < g[v].size(); ++i) {
            if(g[v][i].first == pred && g[v][i].second == 1) {
                return 0;
            }
        }
        return 1;
    }
    bool h = 0;
    for(int i = 0; i < g[v].size(); ++i) {
        if(g[v][i].first == pred) {
            continue;
        }
        if(dfs(g[v][i].first, g, d, en, v)) {
            g[v][i].second = 1;
            h = 1;
        }
    }
    if(h == 0) {
        return 0;
    }
    for(int i = 0; i < g[v].size(); ++i) {
        if(g[v][i].first == pred && g[v][i].second == 1) {
            return 0;
        }
    }
    return 1;
}
void dfs(int v, vector<vector<pair<int,int>>> &g, vector<char> &used, vector<int> &s) {
    int mx = 0;
    if(used[v] == 1) {
        return;
    }
    used[v] = 1;
    for(int i = 0; i < g[v].size(); ++i) {
        if(g[v][i].second == 0) {
            continue;
        }
        dfs(g[v][i].first, g, used, s);
        mx = max(mx, s[g[v][i].first]);
    }
    s[v] = mx  +1;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    int m;
    cin >> n >> m;
    int tt;
    cin >> tt;
    vector<vector<pair<int,int>>> g(n);
    for(int i = 0; i < n - 1; ++i) {
        int v1, v2;
        cin >> v1 >> v2;
        --v1,--v2;
        g[v1].push_back({v2, 0});
        g[v2].push_back({v1, 0});
    }
    vector<pair<int,int>> sp(m);
    for(int i = 0; i < m; ++i) {
        cin >> sp[i].first >> sp[i].second;
        --sp[i].first, --sp[i].second;
    }
    int ans = 1e9;
    int pos = -1;
    vector<int> d(n);
    for(int i = 0; i < (1 << m); ++i) {
        bool iss = 1;
        for(int v = 0; v < n; ++v) {
            for(int f = 0; f < g[v].size(); ++f) {
                g[v][f].second = 0;
            }
        }
        for(int j = 0; j < n; ++j) {
            d[j] = 1;
        }
        for(int j = 0; j < m; ++j) {
            if((i|(1 << j)) == i) {
                if(dfs(sp[j].first, g, d, sp[j].second) == 0) {
                    iss = 0;
                }
            }
            if((i|(1 << j)) != i) {
                if(dfs(sp[j].second, g, d, sp[j].first) == 0) {
                    iss = 0;
                }
            }
        }
        if(iss == 0) {
            continue;
        }
        vector<char> used(n, 0);
        vector<int> w(n, 1);
        for(int j = 0; j < n; ++j) {
            if(used[j] == 0) {
                dfs(j, g, used, w);
            }
        }
        int tr = 1;
        for(int j = 0; j < n; ++j) {
            tr = max(tr, w[j]);
        }
        if(ans > tr) {
            ans = tr;
            pos = i;
        }
    }
    if(pos == -1) {
        cout << -1;
        return 0;
    }
    cout << ans << "\n";
    int i = pos;
    bool iss = 1;
    for(int v = 0; v < n; ++v) {
        for(int f = 0; f < g[v].size(); ++f) {
            g[v][f].second = 0;
        }
    }
    for(int j = 0; j < n; ++j) {
        d[j] = 1;
    }
    for(int j = 0; j < m; ++j) {
        if((i|(1 << j)) == i) {
            if(dfs(sp[j].first, g, d, sp[j].second) == 0) {
                iss = 0;
            }
        }
        if((i|(1 << j)) != i) {
            if(dfs(sp[j].second, g, d, sp[j].first) == 0) {
                iss = 0;
            }
        }
    }
    vector<char> used(n, 0);
    vector<int> w(n, 1);
    for(int j = 0; j < n; ++j) {
        if(used[j] == 0) {
            dfs(j, g, used, w);
        }
    }
    int tr = 1;
    for(int j = 0; j < n; ++j) {
        tr = max(tr, w[j]);
    }
    if(ans > tr) {
        ans = tr;
        pos = i;
    }
    for(int ii = 0; ii < n; ++ii) {
        cout << w[ii] << " ";
    }
}
