#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 5e5 + 10, LG = 19, P = 31, mod = 1e9 + 7;
std::vector<std::pair<int,int>> g1[N], g2[N];
std::vector<int> g3[N];
int tin[N], tout[N], predI[N], pred[N], h[N];
int LCA[N][LG];
int timer = 0;
void dfs(int v, int p = 0) {
	LCA[v][0] = p;
	FOR(i, LG - 1) {
		LCA[v][i + 1] = LCA[LCA[v][i]][i];
	}
	tin[v] = timer++;
	for (auto e : g1[v]) {
		if (e.first == p) continue;
		predI[e.first] = e.second;
		pred[e.first] = v;
		h[e.first] = h[v] + 1;
		dfs(e.first, v);
	}
	tout[v] = timer++;
}
bool is_pred(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int up[N];
int get(int v) {
	if (up[v] == v) return v;
	return up[v] = get(up[v]);
}
int not_lca(int a, int b) {
	// assert(!is_pred(a, b));
	for (int i = LG - 1; i >= 0; --i) {
		if (!is_pred(LCA[a][i], b)) {
			a = LCA[a][i];
		}
	}
	return a;
}
int lca(int a, int b) {
	if (is_pred(a, b)) return pred[not_lca(b, a)];
	return pred[not_lca(a, b)];
}
int clr[N], answ[N];
void dfs2(int v, int c) {
	clr[v] = c;
	for (auto e : g2[v]) {
		if (clr[e.first] == -1) {
			dfs2(e.first, (c + e.second) % 2);
		}
		if (clr[e.first] != (c + e.second) % 2) {
			std::cout << -1;
			exit(0);
		}
	}
}
int used[N];
std::vector<int> order;
void dfs3(int v) {
	used[v] = 1;
	for (auto e : g3[v]) {
		if (!used[e]) {
			dfs3(e);
		}
	}
	order.pb(v);
}
std::vector<int> g123[100];
bool answCheck[100];
int bestAnsw[N];
void dfs123(int v, int need) {
	used[v] = 1;
	if (need == v) {
		int q = v;

		while (q != -1) {
			answCheck[q] = 1;
			q = pred[q];
		}

		return;
	}
	for (auto e : g123[v]) {
		if (!used[e]) {
			pred[e] = v;
			dfs123(e, need);
		}
	}
	order.pb(v);
}
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m, t;
	std::cin >> n >> m >> t;
	std::vector<std::pair<int,int>> edges;
	if (t == 1 && n <= 15) {
		FOR(i, n - 1) {
			int a, b;
			std::cin >> a >> b;
			--a; --b;
			edges.pb({a, b});
			g1[a].pb({b, i});
			g1[b].pb({a, i});
		}
		std::vector<std::pair<int,int>> check(m);
		std::vector<int> cnt(n);
		FOR(i, m) {
			std::cin >> check[i].first >> check[i].second;
			--check[i].first; --check[i].second;
			cnt[check[i].first]++;
			cnt[check[i].second]++;
		}
		FOR(i, n) {
			if (cnt[i] == m) {
				memset(pred, -1, sizeof(pred));
				dfs(i, i);
				std::vector<std::pair<int,int>> vertex;
				FOR(j, m) {
					if (check[j].first == i) {
						vertex.pb({h[check[j].second], check[j].second});
					}
					else {
						vertex.pb({h[check[j].first], check[j].first});
					}
				}
				std::sort(vertex.rbegin(), vertex.rend());
				memset(answ, -1, sizeof(answ));
				for (auto e : vertex) {
					int nowV = e.second;
					int kek = 1;
					while (answ[nowV] == -1 && nowV != -1) {
						answ[nowV] = kek++;
						nowV = pred[nowV];
					}
				}
				std::cout << *std::max_element(answ, answ + n) << '\n';
				FOR(i, n) {
					if (answ[i] == -1) {
						answ[i] = 1;
					}
					std::cout << answ[i] << ' ';
				}
				return 0;
			}
		}
		int min = 1e9;
		FOR(mask, (1 << (n - 1))) {
			FOR(i, n) {
				g123[i].clear();
			}
			FOR(j, n - 1) {
				if ((mask >> j) & 1) {
					g123[edges[j].first].pb(edges[j].second);
				}
				else {
					g123[edges[j].second].pb(edges[j].first);
				}
			}
			memset(answCheck, 0, sizeof(answCheck));
			bool can = true;
			FOR(i, m) {
				FOR(zxc, 123) {
					used[zxc] = 0;
					pred[zxc] = -1;
				}

				dfs123(check[i].first, check[i].second);
				if (used[check[i].second]) continue;
				FOR(zxc, n) {
					used[zxc] = 0;
					pred[zxc] = -1;
				}
				dfs123(check[i].second, check[i].first);
				// debug(mask << ' ' << can << ' ' << used[check[i].first])
				if (used[check[i].first]) continue;
				can = false;
				break;
			}
			// return 0;
			if (!can) continue;
			order.clear();
			FOR(zxc, n) {
				used[zxc] = 0;
				pred[zxc] = -1;
			}
			FOR(i, n) {
				if (!used[i]) dfs123(i, -1);
				answ[i] = 1;
			}
			int nowAnsw = 0;
			for (auto v : order) {
				if (!answCheck[v]) continue;
				for (auto to : g123[v]) {
					if (!answCheck[to]) continue;
					answ[v] = std::max(answ[v], answ[to] + 1);
				}
				nowAnsw = std::max(nowAnsw, answ[v]);			
			}
			if (nowAnsw < min) {
				min = nowAnsw;
				memcpy(bestAnsw, answ, sizeof(answ));
			}
		}
		if (min == 1e9) {
			std::cout << -1;
		}
		else {
			std::cout << min << '\n';
			FOR(i, n) {
				std::cout << bestAnsw[i] << ' ';
			}
		}
	}
	else  {
		int mx = 0;
		FOR(i, n - 1) {
			int a, b;
			std::cin >> a >> b;
			--a; --b;
			g1[a].pb({b, i});
			g1[b].pb({a, i});
			edges.pb({a, b});
		}
		FOR(i, n) {
			up[i] = i;
			if (g1[mx].size() < g1[i].size()) {
				mx = i;
			}
		}
		dfs(mx);
		for (auto &e : edges) {
			if (is_pred(e.first, e.second)) {
				std::swap(e.first, e.second);
			}
		}
		FOR(i, m) {
			int a, b;
			std::cin >> a >> b;
			--a; --b;
			int kekA = get(a), kekB = get(b);
			int l = lca(a, b);
			// debug(a << ' ' << b)
			// debug(h[kekA] << ' ' << h[l] << ' ' << pred[kekA])
			// return 0;
			while (h[kekA] - 1 > h[l]) {
				g2[predI[kekA]].pb({predI[pred[kekA]], 0});
				g2[predI[pred[kekA]]].pb({predI[kekA], 0});
				up[kekA] = pred[kekA];
				kekA = get(kekA);
			}
			while (h[kekB] - 1 > h[l]) {
				g2[predI[kekB]].pb({predI[pred[kekB]], 0});
				g2[predI[pred[kekB]]].pb({predI[kekB], 0});

				up[kekB] = pred[kekB];
				kekB = get(kekB);
			}
			if (!is_pred(a, b) && !is_pred(b, a)) {
				kekA = not_lca(a, b);
				kekB = not_lca(b, a);
				// debug(kekA << ' ' << kek)
				// debug(predI[kekA] << ' ' << predI[kekB])
				g2[predI[kekA]].pb({predI[kekB], 1});
				g2[predI[kekB]].pb({predI[kekA], 1});
			}
		}
		memset(clr, -1, sizeof(clr));
		FOR(i, n - 1) {
			if (clr[i] == -1) {
				dfs2(i, 0);
			}
		}
		FOR(i, n - 1) {
			if (clr[i] == 0) {
				g3[edges[i].first].pb(edges[i].second);
			}
			else {
				g3[edges[i].second].pb(edges[i].first);
			}
		}
		FOR(i, n) {
			if (!used[i]) {
				dfs3(i);
			}
		}
		FOR(i, n) {
			answ[i] = 1;
		}
		int k = 1;
		for (auto v : order) {
			for (auto to : g3[v]) {
				answ[v] = std::max(answ[v], answ[to] + 1);
			}
			k = std::max(k, answ[v]);
		}
		std::cout << k << '\n';
		FOR(i, n) {
			std::cout << answ[i] << ' ';
		}
	}

}