#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;
const int inf = 1e9;

int n, m, t;
vector<vector<int> > v;
vector<int> ans;
vector<int> dsu;
vector<int> rev;
vector<int> sz;
vector<vector<int> > all;

void init(){
    v.resize(n);
    ans.resize(n, 1);
    dsu.resize(n);
    for(int c=0; c<n; c++)
        dsu[c] = c;
    rev.resize(n);
    sz.resize(n, 1);
    all.resize(n);
    for(int c=0; c<n; c++)
        all[c].push_back(c);
}

bool ee = false;

bool dfs2(int ver, int pr, int need, int dop){
    if(ver == need){
        if(ans[ver] <= dop)ee = true;
        return true;
    }
    bool b = false;
    for(auto to : v[ver]){
        if(to == pr)continue;
        if(dfs2(to, ver, need, ans[ver])){
            if(ans[ver] >= ans[to])
                ee = true;
            b = true;
        }
    }
    return b;
}


bool dfs(int ver, int pr, int need, int dop){
    if(ver == need){
        ans[ver] = max(ans[ver], dop);
        return true;
    }
    bool b = false;
    for(auto to : v[ver]){
        if(to == pr)continue;
        b |= dfs(to, ver, need, max(dop+1, ans[to]));
    }
    if(b){
        ans[ver] = max(ans[ver], dop);
    }
    return b;
}

int get(int ver){
    if(dsu[ver] == ver)return ver;
    return dsu[ver] = get(dsu[ver]);
}

void unite(int a, int b){
    a = get(a);
    b = get(b);
    if(sz[a] > sz[b])swap(a, b);
    dsu[a] = b;
    for(auto i : all[a]){
        if(ans[i] == 1)ans[i] = 3;
        else ans[i] = 1;
        all[b].push_back(i);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    srand(time(0));
    cin >> n >> m >> t;
    init();
    for(int c=0; c<n-1; c++){
        int e, e1;
        cin >> e >> e1;
        e--; e1--;
        v[e].push_back(e1);
        v[e1].push_back(e);
    }

    vector<pair<int, int> > vet(m);
    for(int c=0; c<m; c++)
        cin >> vet[c].first >> vet[c].second;
    int answ = inf;
    vector<int> ccout(n);
    /*
    if(m <= 15){
        int mask = 0;
        int mmin = 0;
        while(mask < (1 << m)){
            for(int c=0; c<n; c++)
                ans[c] = 1;
            for(int i=0; i<20; i++){
                for(int c=0; c<m; c++){
                    if((mask&(1<<c)))dfs(vet[c].first-1, -1, vet[c].second-1, ans[vet[c].first-1]);
                    else dfs(vet[c].second-1, -1, vet[c].first-1, ans[vet[c].second-1]);
                }
            }

            ee = false;

            for(int c=0; c<m; c++){
                if((mask&(1<<c)))dfs2(vet[c].first-1, -1, vet[c].second-1, -1);
                else dfs2(vet[c].second-1, -1, vet[c].first-1, -1);
            }

            if(!ee){
                mmin = 0;
                for(int c=0; c<n; c++)
                    mmin = max(mmin, ans[c]);

                if(mmin < answ){
                    answ = mmin;
                    ccout = ans;
                }
            }
            mask++;
        }
        if(answ == inf){
            cout << -1;
            return 0;
        }
        cout << answ << "\n";
        for(auto i : ccout)
            cout << i << " ";
    }
    */
    int mxsz = 0, ver = -1;
    for(int c=0; c<n; c++){
        if(v[c].size() > mxsz){
            mxsz = v[c].size();
            ver = c;
        }
    }
    for(int c=0; c<n; c++)
        ans[c] = -1;
    ans[ver] = 2;
    for(int c=0; c<m; c++){
        if(vet[c].first-1 == ver || vet[c].second-1 == ver){
            continue;
        }
        if(ans[vet[c].first-1] ==  3){
            if(ans[vet[c].second-1] ==  3){
                int a = get(vet[c].first-1);
                int b = get(vet[c].second-1);
                if(a != b){
                    unite(a, b);
                    continue;
                }
                cout << -1;
                return 0;
            }
            else ans[vet[c].second-1] =  1;
        }
        else {
            if(ans[vet[c].first-1] ==  1){
                if(ans[vet[c].second-1] ==  1){
                    int a = get(vet[c].first-1);
                    int b = get(vet[c].second-1);
                    if(a != b){
                        unite(a, b);
                        continue;
                    }
                    return 0;
                }
                else ans[vet[c].second-1] =  3;
            }
            else {
                if(ans[vet[c].second-1] ==  -1){
                    ans[vet[c].second-1] =  1;
                    ans[vet[c].first-1] =  3;
                }
                else {
                    if(ans[vet[c].second-1] ==  1)ans[vet[c].first-1] = 3;
                    else ans[vet[c].first-1] = 1;
                }
            }
        }
    }
    int mmax = 1;
    for(int c=0; c<n; c++)
        mmax = max(ans[c], mmax);
    cout << mmax << "\n";
    for(auto i : ans)
        cout << max(i, 1ll) << " ";
    return 0;
}

