#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool lol = true;

void dfs1(int u, int f, vector <bool> &used, vector <vector <int>> &g, vector <vector <int>>& p, vector <vector <int>>& d) {
	used[u] = true;
	for (int v : g[u]) 
		if (!used[v]) {
			d[f][v] = d[f][u] + 1;
			p[f][v] = u;
			dfs1(v, f, used, g, p, d);
		}
}

void dfs2(int u, vector <bool>& used, vector <vector <int>>& g, vector <int>& order) {
	used[u] = true;
	for (int v : g[u])
		if (!used[v])
			dfs2(v, used, g, order);
	order.push_back(u);
}

void dfs3(int u, vector <bool>& used, vector <vector <int>>& g) {
	used[u] = true;
	for (int v : g[u])
		if (!used[v])
			dfs3(v, used, g);
}

void dfs4(int u, vector <bool>& used, vector <int>& color, vector <vector <int>>& g) {
	used[u] = true;
	for (int v : g[u]) {
		if (!used[v])
			dfs4(v, used, color, g);
		color[u] = max(color[u], color[v] + 1);
	}
}

void dfs5(int u, vector <bool>& used, vector <int>& color, vector <vector <int>>& g) {
	used[u] = true;
	for (int v : g[u]) {
		if (!used[v]) {
			color[v] = 4 - color[u];
			dfs5(v, used, color, g);
		}
		if (color[v] == color[u])
			lol = false;
	}
}

int main() {
	int n, m, t;
	cin >> n >> m >> t;
	vector <bool> used(n);
	vector <int> cnt(n);
	bool z = false;
	vector <vector <int>> g(n);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
		cnt[u]++;
		cnt[v]++;
	}
	for (int i = 0; i < n; i++)
		if (cnt[i] == n - 1)
			z = true;
	if (!z) {
		vector <vector <int>> d(n, vector <int>(n)), p(n, vector <int>(n));
		for (int i = 0; i < n; i++) {
			used.assign(n, false);
			d[i][i] = 0;
			dfs1(i, i, used, g, p, d);
		}
		vector <pair <int, int>> c(m);
		for (int i = 0; i < m; i++) {
			cin >> c[i].first >> c[i].second;
			c[i].first--;
			c[i].second--;
		}
		bool tf = true;
		pair <int, vector <int>> answer = { 10000000, {} };
		int counter = 0;
		if (m > 15) {
			while (counter < 10000) {
				vector <vector <int>> gg(n), _gg(n);
				int k = 0;
				vector <pair <int, int>> b = c;
				for (int j = 0; j < m; j++) 
					if (rand() % 2)
						swap(b[j].first, b[j].second);
				for (int i = 0; i < m; i++) {
					int u = b[i].first;
					int v = b[i].second;
					while (u != v) {
						gg[p[u][v]].push_back(v);
						_gg[v].push_back(p[u][v]);
						v = p[u][v];
					}
				}
				used.assign(n, false);
				vector <int> order;
				for (int i = 0; i < n; i++)
					if (!used[i])
						dfs2(i, used, gg, order);
				used.assign(n, false);
				for (int i = 0; i < n; i++) {
					int v = order[n - i - 1];
					if (used[v]) {
						k = 1e7;
						break;
					}
					dfs3(v, used, _gg);
				}
				if (k == 0) {
					vector <int> color(n, 1);
					used.assign(n, false);
					for (int i = 0; i < n; i++) {
						int v = order[n - i - 1];
						if (!used[v])
							dfs4(v, used, color, gg);
					}
					int k = 0;
					for (int i = 0; i < n; i++)
						k = max(k, color[i] + 1);
					answer = min(answer, { k, color });
				}
			}
			if (answer.first > n + 1) {
				cout << -1;
				return 0;
			}
			cout << answer.first - 1 << endl;
			for (int i = 0; i < n; i++)
				cout << answer.second[i] << " ";
			return 0;
		}
		for (int h = 0; h < (1 << m); h++) {
			vector <vector <int>> gg(n), _gg(n);
			int k = 0;
			vector <pair <int, int>> b = c;
			int kek = h;
			for (int j = 0; j < m; j++) {
				if (kek % 2)
					swap(b[j].first, b[j].second);
				kek /= 2;
			}
			for (int i = 0; i < m; i++) {
				int u = b[i].first;
				int v = b[i].second;
				while (u != v) {
					gg[p[u][v]].push_back(v);
					_gg[v].push_back(p[u][v]);
					v = p[u][v];
				}
			}
			used.assign(n, false);
			vector <int> order;
			for (int i = 0; i < n; i++)
				if (!used[i])
					dfs2(i, used, gg, order);
			used.assign(n, false);
			for (int i = 0; i < n; i++) {
				int v = order[n - i - 1];
				if (used[v]) {
					k = 1e7;
					break;
				}
				dfs3(v, used, _gg);
			}
			if (k == 0) {
				vector <int> color(n, 1);
				used.assign(n, false);
				for (int i = 0; i < n; i++) {
					int v = order[n - i - 1];
					if (!used[v])
						dfs4(v, used, color, gg);
				}
				int k = 0;
				for (int i = 0; i < n; i++)
					k = max(k, color[i] + 1);
				answer = min(answer, { k, color });
			}
		}
		if (answer.first > n + 1) {
			cout << -1;
			return 0;
		}
		cout << answer.first - 1 << endl;
		for (int i = 0; i < n; i++)
			cout << answer.second[i] << " ";
		return 0;
	}
	int kek;
	for (int i = 0; i < n; i++)
		if (cnt[i] == n - 1)
			kek = i;
	vector <vector <int>> ggg(n);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if (u != kek && v != kek) {
			ggg[u].push_back(v);
			ggg[v].push_back(u);
		}
	}
	used.assign(n, false);
	vector <int> color(n, 1);
	color[kek] = 2;
	used[kek] = true;
	for (int i = 0; i < n; i++)
		if (!used[i]) {
			color[i] = 1;
			dfs5(i, used, color, ggg);
		}
	if (!lol) {
		cout << -1;
		return 0;
	}
	int ans = 2;
	for (int i = 0; i < n; i++) 
		ans = max(color[i], ans);
	cout << ans << endl;
	for (int i = 0; i < n; i++)
		cout << color[i] << " ";
}