#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

vector<int> g[500005];
vector<int> path;
vector<int> br[500005];
int used[500005];
int inf = 1e9;
void dfs(int v, int d, int idx) {
    path.pb(v);
    used[v] = 1;
    if (v == d) {
        br[idx] = path;
    }
    for (int s : g[v]) {
        if (!used[s]) dfs(s, d, idx);
    }
    path.pop_back();
}

int ans = 1e9;
vector<int> res;
void f(vector<int> v, int idx, int n, int m) {
    if (idx == n) {
        int w = 1;
        for (int i = 0; i < m; ++i) {
            int q = 1;
            for (int j = 0; j < br[i].size() - 1; ++j) {
                if (v[br[i][j]] <= v[br[i][j + 1]]) {
                    q = 0;
                }
            }
            if (q == 0) {
                q = 1;
                for (int j = 0; j < br[i].size() - 1; ++j) {
                    if (v[br[i][j]] >= v[br[i][j + 1]]) {
                        q = 0;
                    }
                }
                if (q == 0) {
                    w = 0;
                    break;
                }

            }
        }
        if (w == 1) {
            int mx = 0;
            for (int i = 0; i < n; ++i) {
                mx = max(mx, v[i]);
            }
            if (mx < ans) {
                ans = mx;
                res = v;
            }
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        v[idx] = i + 1;
        f(v, idx + 1, n, m);
    }


}
int main() {
    int n, m, t;
    cin >> n >> m >> t;
    if (n <= 15 && m <= 15) {
        for (int i = 0; i < n - 1; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            g[a].pb(b);
            g[b].pb(a);
        }
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            path.clear();
            for (int j = 0; j < n; ++j) {
                used[j] = 0;
            }
            dfs(a, b, i);
        }
        /*for (int i = 0; i < m; ++i) {
            cout << i << ": ";
            for (int j : br[i]) {
                cout << j << " ";
            }
            cout << "\n";
        }
        cout << "\n";*/
        vector<int> u;
        for (int i = 0; i < n; ++i) {
            u.pb(0);
        }
        f(u, 0, n, m);
        if (ans == 1e9) {
            cout << -1;
        } else {
            cout << ans << "\n";
            for (int i = 0; i < n; ++i) {
                cout << res[i] << " ";
            }
        }

    }
    return 0;
}

