#include<bits/stdc++.h>
using namespace std;
int const maxn=500005;

struct SG
{
    int n;
    vector<int>tree;

    SG(){}
    SG(int nn)
    {
        n=nn+1;
        tree.resize(n*4);
        for(int i=0;i<n*4;i++)
            tree[i]=0;
    }

    bool real_update(int k,int l,int r,int x,int y,int m)
    {
        //cout<<k<<" "<<l<<" "<<r<<" "<<x<<" "<<y<<endl;
        if(x<=l&&r<=y)
        {
            if(tree[k]!=0&&tree[k]!=m)
                return false;

            tree[k]=m;
            return true;
        }

        int mid=(l+r)/2,p;
        if(mid<=y)
            p=real_update(k*2,l,mid,x,y,m);
        if(p==0)
            return false;
        if(mid>x)
            p=real_update(k*2+1,mid+1,r,x,y,m);
        if(p==0)
            return false;
        tree[k]=m;
        return true;
    }

    bool update(int x,int y,int m)
    {
        return real_update(1,1,n,x,y,m);
    }
};

int n,m,t;
vector<int>v[maxn];
vector<SG>E;
int lvl[maxn];
int nxt[maxn];
int chnum[maxn];
int head[maxn];
int par[maxn];
int pos[maxn];

int dfs(int i,int p)
{
    lvl[i]=lvl[p]+1;
    par[i]=p;

    int j,sz=v[i].size();
    int msize=0,tsize,chsize=1;
    for(j=0;j<sz;j++)
    {
        int nb=v[i][j];

        if(nb!=p)
        {
            tsize=dfs(nb,i);
            if(msize<tsize)
            {
                msize=tsize;
                nxt[i]=nb;
            }
            chsize+=tsize;
        }
    }
    return chsize;
}

int hld(int i,int p,int chsize)
{
    int j,sz=v[i].size();

    if(chsize==0)head[i]=i;
    else head[i]=head[p];

    pos[i]=chsize+1;

    for(j=0;j<sz;j++)
    {
        int nb=v[i][j];
        if(nb!=p&&nb!=nxt[i])
            hld(nb,i,0);
    }

    if(nxt[i]==-1)
    {
        chnum[i]=E.size();
        E.push_back(SG(chsize));
    }
    else chnum[i]=hld(nxt[i],i,chsize+1);

    return chnum[i];
}

bool update(int x,int y)
{
    int t=1,p;
    while(chnum[x]!=chnum[y])
    {
        //cout<<1<<endl;
        if(lvl[head[x]]<lvl[head[y]])
        {
            swap(x,y);
            t*=-1;
        }
        p=E[chnum[x]].update(1,pos[x],t);
        if(p==0)
            return false;

        x=par[head[x]];
    }
    if(x!=y)
    {
        if(lvl[x]>lvl[y])
        {
            swap(x,y);
            t*=-1;
        }
        p=E[chnum[x]].update(pos[x],pos[y],t);
    }
    return true;
}

void read()
{
    int i,x,y;
    cin>>n>>m>>t;
    for(i=0;i<n-1;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }

    memset(nxt,-1,sizeof(nxt));
    dfs(1,1);
    hld(1,1,0);

    bool lamp=false;
    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        if(lamp==false)
        if(!update(x,y))
            if(!update(y,x))
                lamp=true;
    }
    if(lamp==true)
    {
        cout<<-1<<endl;
        return ;
    }

}

int main()
{
    read();
    return 0;
}
/*

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4

*/
