#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
const int N = 500005, INF = 1000000009;

int n, m, ty;
vector<int> a[N];

int ux[N], uy[N];

vector<int> v;
bool dfs(int x, int p, int y)
{
    v.push_back(x);
    if (x == y)
        return true;
    for (int i = 0; i < a[x].size(); ++i)
    {
        int h = a[x][i];
        if (h == p)
            continue;
        if (dfs(h, x, y))
            return true;
    }
    v.pop_back();
    return false;
}

int maxyans = INF;
int yans[N];

bool c[N];
vector<int> g[N];

int ans[N];

void dfs1(int x)
{
    c[x] = true;
    ans[x] = 1;
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i];
        if (!c[h])
            dfs1(h);
        ans[x] = max(ans[x], ans[h] + 1);
    }
}

void solv0()
{
    for (int x = 0; x < (1 << m); ++x)
    {
        for (int i = 1; i <= n; ++i)
            c[i] = false;
        for (int i = 1; i <= n; ++i)
            g[i].clear();
        set<pair<int, int> > s;
        for (int i = 0; i < m; ++i)
        {
            v.clear();
            if (!(x & (1 << i)))
                dfs(ux[i], ux[i], uy[i]);
            else
                dfs(uy[i], uy[i], ux[i]);
            for (int j = 0; j < (int)v.size() - 1; ++j)
            {
                s.insert(m_p(v[j], v[j + 1]));
            }
        }
        bool z = true;
        for (set<pair<int, int> >::iterator it = s.begin(); it != s.end(); ++it)
        {
            int x = it->first;
            int y = it->second;
            if (s.find(m_p(y, x)) != s.end())
            {
                z = false;
                break;
            }
            g[y].push_back(x);
        }
        if (!z)
            continue;
        for (int i = 1; i <= n; ++i)
        {
            if (!c[i])
                dfs1(i);
        }
        int maxans = 0;
        for (int i = 1; i <= n; ++i)
            maxans = max(maxans, ans[i]);
        if (maxans < maxyans)
        {
            maxyans = maxans;
            for (int i = 1; i <= n; ++i)
                yans[i] = ans[i];
        }
    }
    if (maxyans == INF)
    {
        printf("-1\n");
        return;
    }
    printf("%d\n", maxyans);
    for (int i = 1; i <= n; ++i)
        printf("%d ", yans[i]);
    printf("\n");
}

int cc[N];
vector<int> gg[N];

void dfs6(int x, int y)
{
    cc[x] = y;
    for (int i = 0; i < gg[x].size(); ++i)
    {
        int h = gg[x][i];
        if (!cc[h])
        {
            dfs6(h, 3 - cc[y]);
        }
    }
}

void solv6()
{
    int r = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (a[i].size() == n - 1)
            r = i;
    }
    if (r == 0)
        return;
    for (int i = 0; i < m; ++i)
    {
        int x = ux[i];
        int y = uy[i];
        if (x == r || y == r)
            continue;
        gg[x].push_back(y);
        gg[y].push_back(x);
    }
    for (int i = 1; i <= n; ++i)
    {
        if (!cc[i])
            dfs6(i, 1);
    }
    bool z = true;
    for (int i = 0; i < m; ++i)
    {
        int x = ux[i];
        int y = uy[i];
        if (x == r || y == r)
            continue;
        if (cc[x] == cc[y])
        {
            z = false;
            break;
        }
        if (cc[x] == 1)
        {
            g[x].push_back(r);
            g[r].push_back(y);
        }
        else
        {
            g[y].push_back(r);
            g[r].push_back(x);
        }
    }
    if (!z)
    {
        printf("-1\n");
        return;
    }
    for (int i = 0; i < m; ++i)
    {
        int x = ux[i];
        int y = uy[i];
        if (x == r || y == r)
        {
            if (x != r)
            {
                if (cc[x])
                    continue;
                g[x].push_back(r);
            }
            if (y != r)
            {
                if (cc[y])
                    continue;
                g[y].push_back(r);
            }
        }
    }
    for (int i = 1; i <= n; ++i)
    {
        if (!c[i])
            dfs1(i);
    }
    int maxu = 0;
    for (int i = 1; i <= n; ++i)
        maxu = max(maxu, ans[i]);
    printf("%d\n", maxu);
    for (int i = 1; i <= n; ++i)
        printf("%d ", ans[i]);
    printf("\n");
}

int main()
{
    freopen("input.txt", "r", stdin);
    scanf("%d%d%d", &n, &m, &ty);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        a[x].push_back(y);
        a[y].push_back(x);
    }
    for (int i = 0; i < m; ++i)
    {
        scanf("%d%d", &ux[i], &uy[i]);
    }
    if (n <= 15 && m <= 15)
        solv0();
    else
        solv6();
    return 0;
}
