#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")


using namespace std;
//using namespace __gnu_pbds;

#define int long long
#define ss second
#define ff first
#define pb push_back

const int N = 2e6 + 51, INF = 1e18, MOD = 1e9 + 7;

using vi = vector <int>;
using vp = vector <pair <int, int>>;

mt19937 Flash_new_51(5151552525);

//gp_hash_table <int, int> a;

vi g[N], aa, ans[N], g1[N];
int dist[N], used[N], c[N], n, m, t, mx = INF, mem[N];

bool dfs (int v, int p, int f) {
    if (v == f) {
        aa.pb(f);
        return  true;
    }
    for (auto to : g[v]) {
        if (to == p) continue;
        if (dfs(to, v, f)) {
            aa.pb(v);
            return true;
        }
    }
    return false;
}

int dfs1 (int v) {
    used[v] = 1;
    for (auto to : g1[v]) {
        if (!used[to]) dist[v] = max(dist[v], dfs1(to));
        else dist[v] = max(dist[to], dist[v]);
    }
    dist[v]++;
    return dist[v];
}

bool check (int mask) {
     for (int i = 0; i < m; i++) {
        if ((mask >> i) & 1) {
            for (int j = (int)ans[i].size() - 1; j > 0; j--) {
                int v = ans[i][j], u = ans[i][j - 1];
                if (dist[v] <= dist[u]) return false;
            }
        }
        else {
            for (int j = 0; j < (int)ans[i].size() - 1; j++) {
                int v = ans[i][j], u = ans[i][j + 1];
                if (dist[u] >= dist[v]) return false;
            }
        }
     }
     return true;
}

void solve1() {
    int mask;
    int mmm = 0, ind;
    for (int i = 1; i <= n; i++) {
        if (mmm < mem[i]) mmm = mem[i], ind = i;
    }
    for (int i = 0; i < m; i++) {
        if (ans[i].back() == ind) reverse(ans[i].begin(), ans[i].end());
    }
     for (int o = 0; o < 80; o++) {
        if (o == 0) mask = 0;
        else mask = 1;
        for (int i = 1; i <= n; i++) {
            g1[i].clear();
            used[i] = dist[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            if (o >= 2) mask = Flash_new_51() % 2;
            if (mask) {
                for (int j = (int)ans[i].size() - 1; j > 0; j--) {
                    int v = ans[i][j], u = ans[i][j - 1];
                    g1[v].pb(u);
                }
            }
            else {
                for (int j = 0; j < (int)ans[i].size() - 1; j++) {
                    int v = ans[i][j], u = ans[i][j + 1];
                    g1[v].pb(u);
                }
            }
        }
        int maxx = 0, kol = 0;
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                maxx = max(maxx, dfs1(i));
            }
        }
        if (!check(mask)) {
            continue;
        }
        if (maxx < mx) {
            mx = maxx;
            for (int i = 1; i <= n; i++) c[i] = dist[i];
        }
    }
    if (mx  == INF) cout << -1;
    else {
        cout << mx << endl;
        for (int i = 1; i <= n; i++) cout << c[i] << ' ';
    }

}
signed main() {
    #ifdef Flash
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int l, r;
        cin >> l >> r;
        g[l].pb(r);
        g[r].pb(l);
    }
    for (int i = 0; i < m; i++)  {
        int l, r;
        aa.clear();
        cin >> l >> r;
        mem[l]++;
        mem[r]++;
        dfs(l, l, r);
        ans[i] = aa;
    }
    if (n + m > 30) {
        solve1();
        return 0;
    }

    int msk = (1ll << m);
    for (int mask = 0; mask < msk; mask++) {
        for (int i = 1; i <= n; i++) {
            g1[i].clear();
            used[i] = dist[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) {
                for (int j = (int)ans[i].size() - 1; j > 0; j--) {
                    int v = ans[i][j], u = ans[i][j - 1];
                    g1[v].pb(u);
                }
            }
            else {
                for (int j = 0; j < (int)ans[i].size() - 1; j++) {
                    int v = ans[i][j], u = ans[i][j + 1];
                    g1[v].pb(u);
                }
            }
        }
        int maxx = 0, kol = 0;
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                maxx = max(maxx, dfs1(i));
            }
        }
        if (!check(mask)) {
            continue;
        }
        if (maxx < mx) {
            mx = maxx;
            for (int i = 1; i <= n; i++) c[i] = dist[i];
        }
    }
    if (mx  == INF) cout << -1;
    else {
        cout << mx << endl;
        for (int i = 1; i <= n; i++) cout << c[i] << ' ';
    }
}
