#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define eb emplace_back
#define ff first
#define ss second

using itn = int;

const int MAXN = 500000;
//#define int long  long
const int INF = 1e9;

vector<int> g[MAXN];
vector<pair<int, int>> gi[MAXN];
vector<int> gg[MAXN];

struct tun {
    int a, b;
    tun() {}
    tun(int aa, int bb){
        a = min(aa, bb);
        b = max(aa, bb);
    }

    bool operator< (const tun& oth) const {
        return a < oth.a || (a == oth.a && b < oth.b);
    }
};

int col[MAXN];

void dfs(int v, int p, int c){
    col[v] = c;
    for (int i : g[v]){
        if (i == p) continue;
        dfs(i, v, c+1);
    }
}

vector<int> c;
int fin = 0;
int dfs3(int v, int p){
    if (v == fin) return 1;
    for (int i : g[v]){
        if (i == p) continue;
        if (dfs3(i, v) && c[i] > c[v]) return 1;
    }
    return 0;
}

vector<tun> v;
void stupid(int n, int m, int t){
    for (int i =0; i < n; i++) c.eb(i+1);
    int f = 1;
    while (1){
        f = 1;
        for (int i = 0; i < m; i++){

            fin = v[i].b;
            int r1 = dfs3(v[i].a, -1);
            fin = v[i].a;
            int r2 = dfs3(v[i].b, -1);
            if (r1 || r2){
                continue;
            } else f = 0;
        }
        if (f) return;
        if (!next_permutation(c.begin(), c.end())) break;
    }
}

void upd(int n){
    int curmx = 0;
    for (int i = 0; i < n; i++){
        curmx = max(curmx, col[i]);
    }

    int newmx = 0;
    for (int i = 0; i < n; i++){
        newmx = max(newmx, c[i]);
    }

    if (newmx < curmx){
        for (int i = 0; i < n; i++) col[i] = c[i];
    }
}

void check(int n, int m){
    int f = 1;
    for (int i = 0; i < m; i++){
        fin = v[i].b;
        int r1 = dfs3(v[i].a, -1);
        fin = v[i].a;
        int r2 = dfs3(v[i].b, -1);
        if (r1 || r2){
            continue;
        } else {
            f = 0;
            break;
        }
    }
    if (f)
        upd(n);
}

void gen(int n, int m, int t, int st){
    if (st == n){
        check(n, m);
        return;
    }
    for (int i = 1; i <= n; i++){
        c.eb(i);
        gen(n, m, t, st+1);
        c.pop_back();
    }
}

vector<int> ls(MAXN, -1);

int dfs4(int v, int p){
    //cerr << v << '\n';
    if (v == fin) return 1;
    for (auto rr : gi[v]){
        int i = rr.ff;
        if (i == p) continue;
        if (dfs4(i, v)){
            if (ls[rr.ss] == i) return 0;
            ls[rr.ss] = v;
            return 1;
        }
    }
    return 0;
}

int test(int x, int pos){
    return (x >> pos) & 1;
}

void get(int n, int m){
    c.assign(n, INF+228);
    for (int cur = 1; cur <= n; cur++)
    for (int i = 0; i < n; i++){
        int f = 1;
        if (c[i] < INF) continue;
        for (auto j : gi[i]){
            if (ls[j.ss] != i && c[ls[j.ss]] >= cur){
                f = 0;
                break;
            }
        }
        if (f){
            c[i] = cur;
        }
    }
    upd(n);
}

void gett(int n, int m){
    c.assign(n, INF+228);
        for (int i = 0; i < n; i++){
            int f = 1;
            if (c[i] < INF) continue;
            for (auto j : gi[i]){
                if (ls[j.ss] != i && c[ls[j.ss]] >= cur){
                    f = 0;
                    break;
                }
            }
            if (f){
                c[i] = cur;
                deque<int> q;
                q.eb(i);
                while (!q.empty()){
                    int v = q.front();
                    q.pop_front();

                    for (auto j : gi[v]){
                        if (ls[j.ss] == v){
                            c[j.ff] = c[v] + 1;
                            q.eb(j.ff);
                        }
                    }
                }
            }
        }
    upd(n);
}

void stupid(int n, int m){
    for (int mask = 0; mask < (1 << m); mask++){
        //cerr << mask << '\n';
        int f = 1;
        ls.assign(n, -1);
        for (int i =0 ; i < m; i++){
            int r = 0;
            if (test(mask, i)){
                fin = v[i].a;
                r = dfs4(v[i].b, -1);
            } else {
                //cerr << "JPOA\n";
                fin = v[i].b;
                r = dfs4(v[i].a, -1);
                //cerr << "WHYYYYYYYYYYYYYYYYYYY\n";
            }
            //cerr << "JOPA\n";
            if (!r){
                f = 0;
                break;
            }
        }
        if (f){
            get(n, m);
        }
    }
}


void smart(int n, int m){
    int f = 1;
    ls.assign(n, -1);

    for (int i =0 ; i < m; i++){
            int r = 0;
            if (1){
                fin = v[i].a;
                r = dfs4(v[i].b, -1);
            } else {
                //cerr << "JPOA\n";
                fin = v[i].b;
                r = dfs4(v[i].a, -1);
                //cerr << "WHYYYYYYYYYYYYYYYYYYY\n";
            }
            //cerr << "JOPA\n";
            if (!r){
                f = 0;
                break;
            }
        }
        if (f){
            get(n, m);
        }

}


int used[MAXN];
int cool = -1;
int dfs2(itn v, int c){
    used[v] = c;
    int r = 1;
    for (int i : gg[v]){
        if (i == cool) continue;
        if (!used[i]) r = dfs2(i, ((c-1)^1) + 1);
        else if (used[i] == used[v]) return 0;

        if (!r) return 0;
    }
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;



    int a, b;
    for (int i = 0; i < n-1; i++){
        cin >> a >> b;
        a--;
        b--;

        g[a].eb(b);
        g[b].eb(a);

        gi[a].eb(b, i);
        gi[b].eb(a, i);
    }


    for (int i = 0; i < n; i++){
        if ((int)g[i].size() == n-1) {
            cool = i;
            break;
        }
    }
    //cerr << cool << '\n';

    memset(col, 0x3F, sizeof col);
    for (int i =0 ; i < m; i++){
        cin >> a >> b;
        a--;
        b--;
        v.eb(a, b);
        gg[a].eb(b);
        gg[b].eb(a);
    }
    //stupid(n, m, t);

    if (cool != -1){
        memset(used, 0, sizeof used);
        int res = 0;

        for (int i = 0; i < m; i++)
        {
            if (v[i].a == cool || v[i].b == cool) continue;


            if (v[i].a != cool && !used[v[i].a])
                res = dfs2(v[i].a, 1);

            if (!res){
                cout << "-1\n";
                return 0;
            }

            if (v[i].b != cool && !used[v[i].b]) res = dfs2(v[i].b, 1);

            if (!res){
                cout << "-1\n";
                return 0;
            }
        }

        for (int i = 0; i < n; i++){
            if (i == cool) col[i] = 2;
            else if (!used[i]) col[i] = 1;
            else if (used[i] == 1) col[i] = 1;
            else col[i] = 3;
        }
    } else {
        //gen(n, m ,t, 0);
        if (n <= 15 && m <= 15)
            stupid(n, m);
        else smart(n, m);
    }


    //stable_sort(v.begin(), v.end());

    //dfs(x, -1, 1);

    itn mx = 0;

    for(itn i = 0; i < n; i++) mx = max(col[i], mx);

    if (mx > (int)1e9){
        cout << -1 << '\n';
        return 0;
    }

    cout << mx << '\n';
    for (itn i = 0; i < n; i++) cout << col[i] << ' ';

    return 0;
}