//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "  ";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<ll> > g;
vector<ll> tin;
vector<ll> tout;
ll T = 0;

vector<vector<ll> > up;
vector<ll> h;

void dfs(ll v, ll pr = -1, ll ha = 0)
{
    tin[v] = T++;
    h[v] = ha;
    up[v][0] = pr;
    for (int i = 1; i < 24; i++)
    {
        ll to1 = up[v][i - 1];
        if (to1 == -1)
            continue;
        up[v][i] = up[to1][i - 1];
    }
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        dfs(to, v, ha + 1);
    }
    tout[v] = T++;
}

bool pre(ll v, ll to)
{
    if (tin[v] < tin[to] && tout[v] > tout[to])
        return true;
    return false;
}

ll lca(ll v, ll to)
{
    if (v == to)
        return v;
    if (pre(v, to))
        return v;
    if (pre(to, v))
        return to;
    for (int i = 23; i >= 0; i--)
    {
        ll v1 = up[v][i];
        if (v1 == -1)
            continue;
        if (pre(v1, to))
            continue;
        v = v1;
    }
    return up[v][0];
}

vector<ll> c;

ll X;

bool go(ll v, ll z)
{
    c[v] = X++;
    while (v != z)
    {
        v = up[v][0];
        if (c[v] == -1)
            c[v] = X++;
        else
        {
            if (c[v] <= X)
                return false;
            X = c[v] + 1;
            continue;
        }
    }
    return true;
}

bool go1(ll ce, ll to, ll X1)
{
    c[to] = X1--;
    while (ce != to)
    {
        if (X1 <= 0)
            return false;
        to = up[to][0];
        if (c[to] == -1)
        c[to] = X1--;
        else
        {
            if (c[to] >= X)
                return false;
            X = c[to] - 1;
            continue;
        }
    }
    return true;
}

void dfs1(ll v, ll H, ll pr = -1)
{
    c[v] = H;
    if (H == 1)
        return;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        dfs1(to, H - 1, v);
    }
}

/**
9 5 1
1 2
2 3
3 4
4 5
4 6
3 7
7 8
8 9

3 6
8 3
2 3
5 3
3 1

3 1 1
1 2
2 3
1 3


4 3 0
1 2
1 3
1 4
2 3
2 4
3 4
*/

int main()
{
    ll n, m, t;
    cin >> n >> m >> t;
    h.resize(n);
    up.resize(n, vector<ll> (24, -1));
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    c.resize(n);
    for (int i = 1; i < n; i++)
    {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<ll, ll> > ma;
    ma.resize(m);
    for (int i = 0; i < m; i++)
    {
        cin >> ma[i].first >> ma[i].second;
        ma[i].first--;
        ma[i].second--;
    }
    dfs(0);

    vector<ll> per(m);
    for (int i = 0; i < m; i++)
        per[i] = i;
    vector<ll> optc;
    ll optmx = 1e10;
    do
    {
        c.clear();
        c.resize(n, -1);
        bool yk = false;
        for (int i = 0; i < per.size(); i++)
        {
            ll id = per[i];
            ll v = ma[id].first;
            ll to = ma[id].second;
            ll ce = lca(v, to);
            if (rand() % 2)
                swap(v, to);
            X = max(1LL, c[v]);
            if (!go(v, ce))
            {
                yk = true;
                break;
            }
            ll X1 = X + h[to] - h[ce] - 1;
            if (c[to] == -1)
            {
                if (!go1(ce, to, X + h[to] - h[ce] - 1))
                {
                    yk = true;
                    break;
                }

            }
            else
            {
                if (!go1(ce, to, c[to]))
                {
                    yk = true;
                    break;
                }
            }

        }
        if (yk)
            continue;
        ll M = *max_element(all(c));
        if (M < optmx)
        {
            optmx = M;
            optc = c;
        }
    }while (next_permutation(all(per)));
    if (optmx > 1e6)
    {
        cout << "-1";
        return 0;
    }
    cout << optmx << "\n";
    for (int i = 0; i < n; i++)
        cout << abs(optc[i]) << " ";
}
