#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 17;
const int INF = 1000;

int n, m, t;
vector<pair<int, int>> e, z;
vector<int> g[N], rg[N];
int tc[N];
bool onpth[N];

void check15(int v, int par) {
	int cc = 1;
	for (int i = 0; i < rg[v].size(); i++) {
		int fr = rg[v][i];
		if (fr == par) {
			uax(cc, tc[fr] + 1);
			continue;
		}
		check15(fr, v);
		uax(cc, tc[fr] + 1);
	}
	if (!onpth[v]) {
		tc[v] = 1;
	}
	else tc[v] = cc;
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (to == par) continue;
		check15(to, v);
	}
	return;
}

int par[N];

void dfs_sos(int v) {
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (par[to] == -1) {
			par[to] = v;
			dfs_sos(to);
		}
	}
}

bool check15_corr(int a, int b) {
	fill(par, par + N, -1);
	par[a] = -2;
	dfs_sos(a);
	if (par[b] != -1) {
		int cur = b;
		while (cur != -2) {
			onpth[cur] = true;
			cur = par[cur];
		}
		return true;
	}
	fill(par, par + N, -1);
	par[b] = -2;
	dfs_sos(b);
	if (par[a] != -1) {
		int cur = a;
		while (cur != -2) {
			onpth[cur] = true;
			cur = par[cur];
		}
		return true;
	}
	return false;
}

void solve15() {
	int res = INF;
	vector<int> ans(n);
	for (int i = 0; i < (1 << (n - 1)); i++) {
		fill(g, g + n, vector<int>());
		fill(rg, rg + n, vector<int>());
		fill(tc, tc + n, INF);
		for (int j = 0; j < n - 1; j++) {
			int a, b;
			a = e[j].first;
			b = e[j].second;
			if ((1 << j) & i) {
				rg[a].pb(b);
				g[b].pb(a);
			}
			else {
				g[a].pb(b);
				rg[b].pb(a);
			}
		}
		fill(onpth, onpth + n, false);
		bool cor = true;
		for (int j = 0; j < m; j++) {
			if (!check15_corr(z[j].first, z[j].second)) cor = false;
		}
		if (cor) {
			check15(0, -1);
			int mx = 0;
			for (int i = 0; i < n; i++) {
				uax(mx, tc[i]);
			}
			if (uin(res, mx)) {
				for (int i = 0; i < n; i++) {
					ans[i] = tc[i];
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		uax(res, ans[i]);
	}
	if (res == INF) {
		cout << -1 << nn;
	}
	else {
		assert(res > 0); assert(res < INF);
		cout << res << nn;
		if (t == 0) return;
		for (int i = 0; i < n; i++) {
			int e = ans[i];
			assert(e > 0);
			assert(e < INF);
			cout << e << pp;
		}
		//cout << nn;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n >> m >> t;
	e.resize(n - 1);
	z.resize(m);
	for (int i = 0; i < n - 1; i++) {
		cin >> e[i].first >> e[i].second;
		e[i].first--;
		e[i].second--;
	}
	for (int i = 0; i < m; i++) {
		cin >> z[i].first >> z[i].second;
		z[i].first--;
		z[i].second--;
	}
	if (n < N && m < N) {
		solve15();
		exit(0);
	}
}