#include <bits/stdc++.h>
#define int long long
#define all(x) (x).begin(), (x).end()
#define F first
#define pb push_back
#define S second
#define len(x) (int)(x).size()
using namespace std;
const int maxn = 5e5 + 5;
const int lg = 21;
const int mod = 1e9 + 7;
const int INF = 1e18 + 1;
int n, m, t;
vector<int>g[maxn];
vector<int>gr[maxn];
int ans[maxn];
int d[maxn];
vector<pair<int, int> >z;
int up[maxn][lg];
int par[maxn];
vector<vector<int> >paths;
void dfs(int v, int p = 0, int dp = 0) {
    up[v][0] = p;
    par[v] = p;
    d[v] = dp;
    for (int i = 1; i < lg; i++) up[v][i] = up[up[v][i - 1]][i - 1];
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v, dp + 1);
    }
}
int lca(int a, int b) {
    if (d[a] < d[b]) swap(a, b);
    for (int i = lg - 1; i >= 0; i--) {
        if (d[a] - (1ll << i) >= d[b]) a = up[a][i];
    }
    if (a == b) return a;
    for (int i = lg - 1; i >= 0; i--) {
        if (up[a][i] != up[b][i]) {
            a = up[a][i];
            b = up[b][i];
        }
    }
    return up[a][0];
}
int col[maxn];
bool used[maxn];
vector<int>ts;
/*bool dfsik(int v, int dpt) {
    used[v] = 1;
    bool xx = 1;
    for (auto to : g[v]) {
        if (!used[to]) xx &= dfsik(to);
        else if (used[to] == 1) {
            return 0;
        }
    }
    used[v] = 2;
    ts.pb(v);
    return xx;
}*/
void tops(int v) {
    used[v] = 1;
    for (auto to : gr[v]) {
        if (!used[to]) tops(to);
    }
    ts.pb(v);
}
bool kal(int v, int p, bool xr) {
    col[v] = xr;
    used[v] = 1;
    bool zez = 1;
    for (auto to : gr[v]) {
        if (to == p) continue;
        if (!used[to]) zez &= kal(to, v, xr ^ 1);
        else if (used[to]) {
            if (col[to] ^ 1 != col[v]) return 0;
        }
    }
    return zez;
}
void solve(int x) {
    for (int i = 0; i < m; i++) {
        if (z[i].F != x && z[i].S != x) {
            gr[z[i].F].pb(z[i].S);
            gr[z[i].S].pb(z[i].F);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bool uu = kal(i, -1, 0);
            if (!uu) {
                cout << -1;
                return;
            }
        }
    }
    int mx = 0;
    for (int i = 0; i < n; i++) mx = max(mx, col[i]);
    if (mx) mx = 3;
    else mx = 2;
    cout << mx << '\n';
    for (int i = 0; i < n; i++) {
        if (i == x) cout << 2 << ' ';
        else if (!col[i]) cout << 1 << ' ';
        else cout << 3 << ' ';
    }
}
/*void solve2() {
    for (int i = 0; i < (1 << m); i++) {
        for (int j = 0; j < m; j++) {
            if ((1 << j) & i) {

            }
            else {

            }
        }
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                if (!dfsik(j)) {
                    flagus = 1;
                    break;
                }
            }
        }
        if (flagus) continue;
        reverse(all(ts));
        for (int i = 0; i < ts.sizE)
    }
}*/
map<pair<int, int>, int>mp;
int where[maxn];
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].pb(v - 1);
        g[v - 1].pb(u - 1);
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        z.pb({a, b});
    }
    for (int i = 0; i < n; i++) ans[i] = 1;
    int id = -1;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == n - 1) id = i;
    }
    if (id != -1) {solve(id);return 0;}
    if (t) return 1;
//    if (n <= 15 && m <= 15) {solve2();return 0;}
    for (int i = 0; i < n; i++) ans[i] = -1;
    dfs(0);
    par[0] = -1;
    //cout << lca(2, 4) << endl;
    //return 0;
    for (int i = 0; i < m; i++) {
        int a, b;
        a = z[i].F, b = z[i].S;
        vector<int>aa, bb;
        int lc = lca(a, b);
        if (d[a] < d[b]) swap(a, b);
        int nw = a;
        while (nw != lc) {
            aa.pb(nw);
            nw = par[nw];
        }
        aa.pb(lc);
        nw = b;
        while (nw != lc) {
            bb.pb(nw);
            nw = par[nw];
        }
        reverse(all(bb));
        for (auto ii : bb) aa.pb(ii);
        map<int, int>zz;
        for (int i = 0; i < len(aa) - 1; i++) {
            if (mp.count({aa[i], aa[i + 1]})) zz[0]++;
            if (mp.count({aa[i + 1], aa[i]})) zz[1]++;
        }
        if (zz.size() == 2) {
            cout << -1;
            return 1;
        }
        if (zz[1])
            reverse(all(aa));
        for (int i = 0; i < len(aa) - 1; i++) {
            mp[{aa[i], aa[i + 1]}]++;
        }
    }
    for (auto ii : mp) gr[ii.F.F].pb(ii.F.S);
    for (int i = 0; i < n; i++) if (!used[i]) tops(i);
    reverse(all(ts));
    cout << n << '\n';
    for (int i = 0; i < n; i++) where[ts[i]] = i;
    for (int i = 0; i < n; i++) cout << where[i] + 1 << ' ';
    return 0;
}
/*
5 3 0
1 2
2 3
3 4
3 5
1 3
3 5
3 4
*/
