#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;
vector<int>* e;
vector<pair<int, bool>>* e1;
int* par;
int* fst;
int* cost;
bool* used;
vector<int> lca;
int minn = INT_MAX;
int maxx = 0;
void dfs(int v){
    lca.push_back(v);
    if(fst[v]==-1)
        fst[v] = lca.size()-1;
    for(auto z:e[v]){
        if(z!=par[v]){
            par[z] = v;
            dfs(z);
            lca.push_back(v);
        }
    }
}

struct tt{
    vector<int>* v;
    int n;
    tt(vector<int> ip){
        n = ip.size();
        v = new vector<int>[n];
        for(int i = 0; i<n; i++){
            v[i].push_back(ip[i]);
        }
        int k = 1;
        for(int i = 1; i<20; i++){
            for(int j = 0; j+k<n; j++){
                v[j].push_back(min(v[j][i-1], v[j+k][i-1]));
            }
            k*=2;
        }
    }
    int get(int l, int r){
        int d = r-l;
        int ct = 0;
        while(d>=2){
            d/=2;
            ct++;
        }
        if(!ct)
            return v[l][0];
        else return min(v[l][ct], v[r-(1<<ct)][ct]);
    }
};

void dfs1(int v){
    used[v] = 1;
    for(auto z:e1[v]){
        if(!used[z.x]){
            if(z.y)
                cost[z.x] = cost[v]+1;
            else cost[z.x] = cost[v]-1;
            minn = min(minn, cost[z.x]);
            maxx = max(maxx, cost[z.x]);
            dfs1(z.x);
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int  n, m, t, v1, v2;
    cin >> n >> m >> t;
    e = new vector<int>[n];
    e1 = new vector<pair<int, bool>>[n];
    par = new int[n];
    fst = new int[n];
    cost = new int[n];
    used = new bool[n];
    for(int i = 0; i<n-1; i++){
        fst[i] = -1;
        used[i] = 0;
        cin >> v1 >> v2;
        v1--;
        v2--;
        e[v1].push_back(v2);
        e[v2].push_back(v1);
    }
    fst[n-1] = -1;
    used[n-1] = 0;
    par[0] = -1;
    dfs(0);
    tt lc = tt(lca);
    for(int i = 0; i<m; i++){
        cin >> v1 >> v2;
        v1--;
        v2--;
        int bp = lc.get(min(fst[v1], fst[v2]), max(fst[v1], fst[v2]));
        int now = v1;
        while(now!=bp){
            e1[now].push_back(make_pair(par[now], 1));
            e1[par[now]].push_back(make_pair(now, 0));
            now = par[now];
        }
        now = v2;
        while(now!=bp){
            e1[now].push_back(make_pair(par[now], 0));
            e1[par[now]].push_back(make_pair(now, 1));
            now = par[now];
        }
    }
    for(int i = 0; i<n; i++){
        if(!used[i]){
            cost[i] = 0;
            dfs1(i);
        }
    }
    cout << maxx-minn+2 << "\n";
    for(int i = 0; i<n; i++){
        cout << cost[i]-minn+2 << " ";
    }
    return 0;
}
