#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;
vector<pair<int, int>> a;
vector<int> gr[20];
int w[20];
vector<int> way;
int n, t, m, x, y;

bool pruvway(int v, int pred, int y) {
	if (v == y) {
		way.push_back(v);
		return true;
	}
	for (int i = 0; i < gr[v].size(); i++) {
		if (gr[v][i] != pred) {
			bool b=pruvway(gr[v][i], v, y);
			if (b) {
				way.push_back(v);
				return true;
			}
		}
	}
	return false;
}

bool pruv(int q) {
	int qq = q;
	for (int i=0;i<n;i++){
		w[i] = q % 10;
		q /= 10;
	}
	for (int i = 0; i < m; i++) {
		way.clear();

		pruvway(a[i].first, -1, a[i].second);
		for (int j = 0; j < way.size() - 1; j++) {
			if (w[way[j]] >= w[way[j + 1]])return false;
		}
	}
	return true;
}

int main() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; i++) {
		cin >> x >> y;
		x--;
		y--;
		gr[x].push_back(y);
		gr[y].push_back(x);
	}
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		a.push_back({ x,y });
	}
	int q = pow(10, n);
	
	
	int bestm=1000, bestans;
	for (int i = 1; i < q; i++) {
		if (pruv(i)) {
			int ma = 0;
			for (int j = 0; j < n; j++) {
				ma = max(ma, w[j]);
			}
			if (bestm > ma) {
				bestm = ma;
				bestans = i;
			}
		}
	}
	if (bestm == 1000) {
		cout << -1;
		return 0;
	}

	cout << bestm + 1 << endl;
	vector<int> ans;
	for (int i = 0; i < n; i++) {
		ans.push_back(bestans % 10);
		bestans /= 10;
	}
	for (int i = 0; i < n; i++) {
		cout << ans[n - 1 - i]+1 << ' ';
	}
} 