#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#define int long long
#define endl '\n'

#define FastIO; ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less <int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;


int dst[1000000];


bool used[10000000];
void dfs(int v)
{
    used[v] = true;
    for (auto i:g[v])
    {
        if (!used[i])
        {
            dst[i] = dst[v] + 1;
            dfs(i);
        }
    }
}


vector <vector <int> > g;

int32_t main()
{
    FastIO;
    int n,m;
    cin >> n >> m >> t;
    g.resize(n);
    int first = 0;
    for (int i=0; i<n-1; i++)
    {
        int l,r;
        cin >> l >> r;
        first = l;
        l--;
        r--;
        g[l].push_back(r);
        g[r].push_back(l);
    }

    dfs(0);



    int maxans = 0;
    for (int i=0; i<m; i++)
    {
        int l,r;
        cin >> l >> r;
        l--;
        r--;
        maxans = max(maxans, abs(dst[r] - dst[l]));
    }

    cout << maxans;






    return 0;
}



