#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int med(int a, int b, int c)
{
	if ((a <= b && b <= c) || (c <= b && b <= a))
		return b;
	if ((a <= c && c <= b) || (b <= c && c <= a))
		return c;
	return a;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, t = 0;
	cin >> n >> t;

	vector<int> h(n);
	for (int i = 0; i < n; ++i)
		cin >> h[i];

	int ans = 0;
	while (true)
	{
		int cnt = 0;
		vector<int> newH = h;
		for (int i = 1; i < n - 1; ++i)
		{
			newH[i] = med(h[i - 1], h[i], h[i + 1]);
			if (h[i] != newH[i])
				cnt = 1;
		}

		if (cnt)
		{
			++ans;
			swap(h, newH);
		}
		else
			break;
	}

	cout << ans << "\n";
	if (t)
	{
		for (auto x : h)
			cout << x << " ";
	}

	return 0;
}