#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, INF = 1e9;

mt19937 rnd(time(0));

int n, t, cnt;
vector<int> a, b;

inline void read(){
    cin >> n >> t;
    a.resize(n+1);
    b.resize(n+1);
    for(int i = 1; i <= n; ++i)
        cin >> a[i];
}

int median(const int& a, const int& b, const int& c){
    vector<int> v{a,b,c};
    sort(ALL(v));
    return v[1];
}
bool is_ok(){
    for(int i = 2; i < n; ++i){
        if(median(a[i-1],a[i],a[i+1])!=a[i]) return false;
    }
    return true;
}

inline void step_transform(){
    b = a;
    for(int i = 2; i < n; ++i)
        b[i] = median(a[i-1],a[i],a[i+1]);
    a = b;
}
inline void solve(){
    while(!is_ok()){
        ++cnt;
        step_transform();
    }
}

inline void print(){
    cout << cnt;
    if(t){
        cout << "\n";
        for(int i = 1; i <=n; ++i)
            cout << a[i] << " ";
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    solve();
    print();

    return 0;
}
