//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx")
//#pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

int n, t;
vector<int> a;

void read() {
	cin >> n >> t;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
}

int get(int a, int b, int c) {
	vector<int> ans = {a, b, c};
	sort(all(ans));
	return ans[1];
}

int fans = 0;

bool it() {
	vector<int> ans(n);
	ans[0] = a[0];
	ans[n - 1] = a[n - 1];
	for (int i = 1; i < n - 1; i++) {
		ans[i] = get(a[i - 1], a[i], a[i + 1]);
	}
	bool flag = false;
	for (int i = 0; i < n; i++) {
		flag |= a[i] != ans[i];		
	}
	a = ans;
	if (flag)
		fans++;
	return flag;
}

void run() {
	while (it());
}

void write() {
	cout << fans << endl;
	if (t) {
		for (auto i : a)
			cout << i << " ";
		cout << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}