#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = (int)5e5 + 7;
int a[MAXN], b[MAXN], n, t, answ = 0;
int median(int a, int b, int c) {
	if(a > b) swap(a, b);
	if(a > c) swap(a, c);
	if(b > c) swap(b, c);
	return b;
}
void solve() {
	cin >> n >> t;
	for(int i = 0; i < n; ++i) cin >> a[i];
	int ch = 1;
	while(ch) {
		ch = 0;
		b[0] = a[0];
		b[n - 1] = a[n - 1];
		for(int i = 1; i < n - 1; ++i) {
			b[i] = median(a[i - 1], a[i], a[i + 1]);
			if(a[i] != b[i]) ch = 1;
		}
		for(int i = 0; i < n; ++i) a[i] = b[i];
		answ += ch;
	}
	cout << answ << '\n';
	if(t != 0) {
		for(int i = 0; i < n; ++i) cout << a[i] << ' ';
		cout << '\n'; 
	}
}
int main() {
	fastIO();
	solve();
	return 0;
}
