#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

int getmed(int a, int b, int c) {
  if (b > c)
    swap(b, c);
  if (a > b)
    swap(a, b);
  if (b > c)
    swap(b, c);
  return b;
}

void solve1(int n, int t, vector<int> &arr) {
  bool upd = true;
  int c = 0;
  while (upd) {
    upd = false;
    vector<int> brr(n);
    for (int i = 1; i < n - 1; ++i) {
      brr[i] = getmed(arr[i - 1], arr[i], arr[i + 1]);
      upd |= brr[i] != arr[i];
    }
    brr[0] = arr[0];
    brr[n - 1] = arr[n - 1];
    arr.swap(brr);
    c += upd;
  }
  cout << c << '\n';
  if (t) {
    for (int &el : arr)
      cout << el << ' ';
  }
}

void solve2(int n, int t, vector<int> &arr) {
  vector<pair<int, int>> posl;
  int lst = -1;
  for (int i = 0; i < n; ++i) {
    if (i - 1 == lst)
      continue;
    if (3 - arr[i - 1] == arr[i]) {
    } else {
      posl.emplace_back(lst + 1, i);
      lst = i - 1;
    }
  }
  if (lst != n - 2)
    posl.emplace_back(lst + 1, n);
  vector<int> brr(n);
  brr[0] = arr[0];
  brr[n - 1] = arr[n - 1];
  int ind = 0;
  int c = 0;
  for (int i = 1; i < n - 1; ++i) {
    while (ind < posl.size() && i >= posl[ind].second)
      ind++;
    if (ind == posl.size()) {
      brr[i] = arr[i];
      continue;
    }
    auto[l, r] = posl[ind];
    if (arr[l] == arr[r - 1]) {
      brr[i] = arr[l];
      c = max(c, (r - l) / 2);
      continue;
    }
    int m = (l + r - 1) / 2;
    c = max(c, (r - l) / 2 - 1);
    if (i <= m)
      brr[i] = arr[l];
    else
      brr[i] = arr[r - 1];
  }
  cout << c << '\n';
  if (t) {
    for (int &el : brr)
      cout << el << ' ';
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n, t;
  cin >> n >> t;
  vector<int> arr(n);
  for (int &el : arr)
    cin >> el;
  if (n <= 1000) {
    solve1(n, t, arr);
  } else {
    solve2(n, t, arr);
  }
  return 0;
}
