#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)

int median(int a, int b, int c) {
	if (a >= min(b, c) && a <= max(b, c))return a;
	if (b >= min(a, c) && b <= max(a, c))return b;
	if (c >= min(a, b) && c <= max(a, b))return c;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	for (int i = 0; i < n; i++)cin >> a[i];
	int ans = 0;
	while (true) {
		vector<int> b = a;
		bool change = false;
		for (int i = 1; i < n - 1; i++) {
			b[i] = median(a[i - 1], a[i], a[i + 1]);
			if (b[i] != a[i])change = true;
		}
		a = b;
		if (!change) {
			cout << ans << "\n";
			if (t) {
				for (auto i : a) {
					cout << i << " ";
				}
			}
			return 0;
		}
		ans++;
	}
}