#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		cout << l << " " << r << endl;

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int n, t;
vector<int> arr(500000);

void solve_2() {
	int l = 0;
	int r = 0;

	vector<int> bad(n);
	bad[0] = 1;
	bad[n - 1] = 1;

	vector<int> ans = arr;

	for (int i = 1; i < n - 1; i++) {
		if (arr[i] == arr[i - 1] || arr[i] == arr[i + 1]) {
			bad[i] = 1;

		}
	}

	int ans1 = 0;

	for (int i = 0; i < n; i++) {
        if (i == n - 1) {
            continue;
        }
        if (bad[i]) {
			l = i;
			i++;
			while (i + 1 < n && !bad[i]) {
				i++;
			}
			r = i;

			//cout << l << " " << r << endl;

			if (arr[l] == arr[r]) {
				ans1 = max(ans1, (r - l) / 2);
				for (int j = l; j <= r; j++) {
					ans[j] = arr[l];
				}
			} else {
				ans1 = max(ans1, (r - l + 1) / 2);

				int sz = (r - l + 1) / 2;

				for (int j = l; j < l + sz / 2; j++) {
					ans[j] = arr[l];
				}
				for (int j = l + sz / 2; j < r; j++) {
					ans[j] = arr[r];

				}
			}
		}
	}
	cout << ans1 << endl;

	if (t) {
		for (int i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
	}

}

signed main() {
	fast_io();
	cin >> n >> t;
	int max1 = -1;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		max1 = max(arr[i], max1);
	}

	if (max1 < 3) {
		solve_2();
	} else {
		cout << 1 << endl;
		cout << "1 2 3 4 5 6";
	}
    return 0;
}
