#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

vector<int> a;

bool does() {
    bool flag = false;
    vector<int> b(a.size());
    for (int i = 1; i + 1 < (int)a.size(); ++i) {
        vector<int> tmp = {a[i - 1], a[i], a[i + 1]};
        sort(tmp.begin(), tmp.end());
        if (a[i] != tmp[1]) {
            flag = true;
        }
        b[i] = tmp[1];
    }
    b[0] = a[0];
    b[(int)a.size() - 1] = a[(int)a.size() - 1];
    a = b;
    return flag;
}

void solve() {
    int n, t;
    cin >> n >> t;
    a.resize(n);
    for (int &i : a) {
        cin >> i;
    }
    int cnt = 0;
    while(does()) {
        cnt++;
    }
    cout << cnt << '\n';
    if (t == 1) {
        for (int i : a) {
            cout << i << ' ';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}