#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 2e5;

struct seg {
	int l, r, h;
};

void spec_solve(int n, int t, vector <int> a) {
	vector <seg> segs;
	int last_pos = 0;
	int len = 2;
	for (int i = 1; i < n; ++i) {
		if (a[i] == a[last_pos]) {
			++len;
		} else {
			if (len >= 2) {
				segs.push_back({last_pos, i - 1, a[last_pos]});
			}
			last_pos = i;
			len = 1;
		}
	}
	segs.push_back({last_pos, n - 1, a[last_pos]});
	// for (auto i : segs) {
	// 	cout << i.l << " " << i.r << " " << i.h << "\n";
	// }
	vector <int> ans = a;
	int cnt = 0;
	for (int i = 1; i < segs.size(); ++i) {
		int l = segs[i - 1].r + 1;
		int r = segs[i].l - 1;
		if (l <= r) {
			int len = r - l + 1;
			if (len % 2 == 0) {
				int mid = l + len / 2;
				for (int j = l; j < mid; ++j) {
					// cout << "j = " << j << "\n";
					ans[j] = segs[i - 1].h;
				}
				for (int j = mid; j <= r; ++j) {
					ans[j] = segs[i].h;
				}
				cnt += len / 2;
			} else {
				for (int j = l; j <= r; ++j) {
					ans[j] = segs[i].h;
				}
				cnt += (len + 1) / 2;
			}
		}
	}
	cout << cnt << "\n";
	if (t) {
		out(int, ans);
	}
}

void solve() {
	int n, t;
	cin >> n >> t;
	vector <int> a(n), b(n);
	for (int& i : b) {
		cin >> i;
	}
	if (*max_element(all(b)) <= 2) {
		spec_solve(n, t, b);
		return;
	}
	bool any = 1;
	int ans = 0;
	for (; any; ) {
		any = 0;
		a[0] = b[0];
		a[n - 1] = b[n - 1];
		for (int i = 1; i < n - 1; ++i) {
			vector <int> cur;
			cur.push_back(b[i - 1]);
			cur.push_back(b[i]);
			cur.push_back(b[i + 1]);
			sort(all(cur));
			a[i] = cur[1];
			if (a[i] != b[i]) {
				any = 1;
			}
		}
		if (any) {
			++ans;
		}
		b = a;
	}
	cout << ans << "\n";
	if (t) {
		out(int, b);
	}
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 3;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}