#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

vector<int> get(vector<int> a) {
	int n = a.size();
	vector<int> b(n);
	b[0] = a[0], b[n - 1] = a[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		vector<int> c = { a[i - 1], a[i], a[i + 1] };
		sort(c.begin(), c.end());
		b[i] = c[1];
	}
	return b;
}

signed main() {
	warp();

	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	assert(t == 0);
	set<int> ss;
	for (int& i : a) {
		cin >> i;
		ss.insert(i);
	}
	int ans = 0;
	vector<int> s = get(a);
	if (a != s) {
		++ans;
		a = s;
	} else {
		cout << ans << '\n';
		if (t) {
			for (int i : a) {
				cout << i << " ";
			}
		}
		return 0;
	}
	int mx = 0;
	for (int i = 0; i < n - 1; ++i) {
		int j = i;
		int pl = -1;
		if (a[i] < a[i + 1])
			pl = 1;
		else if (a[i] > a[i + 1])
			pl = -1;
		else
			continue;
		while (j + 1 < n) {
			if (pl == 1) {
				if (a[j] < a[j + 1])
					++j, pl = -1;
				else
					break;
			} else if (pl == -1) {
				if (a[j] > a[j + 1])
					++j, pl = 1;
				else
					break;
			}
			if (i + 1 < j) {
				int len = j - i + 1;
				mx = max(mx, len / 2);
				i = j;
			}
		}
	}
	cout << ans + mx;
}