#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

int get(int a, int b, int c) {
  int d[3];
  d[0] = a, d[1] = b, d[2] = c;
  sort(d, d + 3);
  return d[1];
}

mt19937 gen;
void run() {
  gen.seed(time(0));
  int n, t;
  cin >> n >> t;
  vector<int> a(n);
 /* for(int &x : a) {
    x = gen() % 20;
  } */
  for(int &x : a) cin >> x;
  vector<int> cur(n, 1);
  int ans = 0;
  while (1) {
    vector<int> b(n);
    b[0] = a[0];
    for(int i = 1; i + 1 < n; i++) {
      b[i] = get(a[i - 1], a[i], a[i + 1]);
    }
    b[n - 1] = a[n - 1];
    for(int i = 0; i < n; i++) {
      if (a[i] != b[i]) {
        assert(cur[i]);
      } else cur[i] = 1;
    }
    if (a == b) break;
    a = b;
    ans++;
  }
  cout << ans << '\n';
  if (t) {
    for(int x : a) {
      cout << x << ' ';
    }
  }
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  run();
}
