#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    void solve() {
        int n, t;
        cin >> n >> t;
        vector<int> a(n);
        unordered_set<int> peaks;
        for (int i = 0; i < n; i++) {
            if (i > 0 && i < n - 1) {
                peaks.insert(i);
            }
            cin >> a[i];
        }
        int ans = 0;
        bool f = 1;
        while (f) {
            f = 0;
            vector<int> b(n);
            for (int i = 0; i < n; i++) {
                b[i] = a[i];
            }
            unordered_set<int> new_peaks;
            for (auto i : peaks) {
                int l = a[i - 1], r = a[i + 1], m = a[i];
                if (l >= m) {
                    swap(l, m);
                }
                if (l >= r) {
                    swap(l, r);
                }
                if (m >= r) {
                    swap(m, r);
                }
                b[i] = m;
                if (b[i] != a[i]) {
                    new_peaks.insert(i);
                    if (i - 1 > 0) {
                        new_peaks.insert(i - 1);
                    }
                    if (i + 1 < n - 1) {
                        new_peaks.insert(i + 1);
                    }
                    f = 1;
                }
            }
            swap(a, b);
            swap(peaks, new_peaks);
            ans++;
        }
        cout << ans - 1 << "\n";
        if (t) {
            for (auto v : a) {
                cout << v << " ";
            }
        }
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
