#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
typedef pair<vector<ull>, vector<ull> > pvv;
ull q = 157;
ull mod = 1e9 + 7;
vector <ull> qp1, qp2;
pvv calc_hash(string& s) {
    s = '-' + s;
    if (s.size() > qp1.size()) {
        qp1.assign(s.size(), 1);
        qp2.assign(s.size(), 1);
    }
    vector<ull>h1(s.size(), 0), h2(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        h1[i] = h1[i - 1] * q + s[i] - 'a';
        h2[i] = ((h2[i - 1] * q) % mod + s[i] - 'a') % mod;
        qp1[i] = qp1[i - 1] * q;
        qp2[i] = (qp2[i - 1] * q) % mod;
    }
    return { h1, h2 };
}
pair<ull, ull> get_hash(int l, int r, vector<ull>& h1, vector<ull>&h2) {
    ull ha = h1[r] - h1[l - 1] * qp1[r - l + 1];
    ull hb = (h2[r] + mod - (h2[l - 1] * qp2[r - l + 1]) % mod) % mod;
    return { ha, hb };
}

int mid(int a, int b, int c) {
    return a + b + c - min(a, min(b, c)) - max(max(a, b), c);
}
bool ok(vector<int>& a) {
    for (int i = 1; i < a.size() - 1; ++i) {
        if (a[i] != mid(a[i - 1], a[i], a[i + 1])) {
            return 0;
        }
    }
    return 1;
}
int main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int n, t;
    cin >> n >> t;
    vector<int>a(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = 0;
    while (!ok(a)) {
        vector<int>b(a.size()); 
        b[0] = a[0], b.back() = a.back();
        for (int i = 1; i < a.size() - 1; ++i) {
            b[i] = mid(a[i - 1], a[i], a[i + 1]);
        }
        ++ans;
        a.swap(b);
    }
    cout << ans << "\n";
    if (t) {
        for (int x : a)cout << x << " ";
    }
    return 0;
}
/*
5 1
1 2 1 2 1

*/