#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, t;
    cin >> n >> t;
    vector <ll> a(n);
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    bool fl = true;
    ll ans = 0;
    if (n > 1000) {
        set <ll> bp;
        bp.insert(0); bp.insert(n - 1);
        vector <bool> u(n, false);
        u[0] = u[n - 1] = true;
        for (ll i = 1; i < n - 1; i++) {
            if (a[i] == a[i - 1]) {
                if (!u[i - 1]) {
                    u[i - 1] = true;
                    bp.insert(i - 1);
                }
                if (a[i] != a[i + 1])
                    bp.insert(i);
                u[i] = u[i - 1];
            }
        }
        ll pr = a[0];
        for (ll i = 1; i < n - 1; i++) {
            if (a[i] != pr && a[i] != a[i + 1]) {
                ll up = *bp.upper_bound(i);
                auto dw = bp.lower_bound(i);
                dw--;
                ans = max(ans, min(i - *dw, up - i));
                pr = a[i];
                if (i - *dw < up - i)
                    a[i] = a[*dw];
                else a[i] = a[up];
            } else pr = a[i];
        }
    }
    else {
        while (fl) {
            fl = false;
            ll pr = a[0];
            for (ll i = 1; i < n - 1; i++) {
                ll b = a[i], c = a[i + 1];
                vector <ll> te(3);
                te[0] = pr; te[1] = b; te[2] = c;
                sort(te.begin(), te.end());
                if (te[1] != b) {
                    fl = true;
                    pr = a[i];
                    a[i] = te[1];
                }
                else pr = a[i];
            }
            if (fl)
                ans++;
        }
    }
    cout << ans << '\n';
    if (t == 1) {
        for (ll i = 0; i < n; i++)
            cout << a[i] << " ";
    }
    return 0;
}