#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>

//#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

bool check(veci& v) {
	for (int i = 1; i < sz(v) - 1; i++)
		if ((v[i] > v[i - 1] && v[i] > v[i + 1]) || (v[i] < v[i - 1] && v[i] < v[i + 1]))
			return false;
	return true;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);



	int n, t;
	cin >> n >> t;
	veci a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	if (n < 3) {
		cout << "0\n";
		if (t)
			cout << a[0] << " " << a[1] << "\n";
		return 0;
	}
	veci b(3);
	int cnt = 0;
	while (!check(a)) {
		b[0] = a[0];
		b[1] = a[1];
		b[2] = a[2];
		sort(all(b));
		int p = b[1];
		for (int i = 2; i < n - 1; i++) {
			b[0] = a[i-1];
			b[1] = a[i];
			b[2] = a[i+1];
			a[i - 1] = p;
			sort(all(b));
			p = b[1];
		}
		a[n - 2] = p;
		cnt++;
	}
	cout << cnt << "\n";
	if (t)
		for (int i : a)
			cout << i << " ";


	return 0;
}
