#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T> 
bool uin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 20;
const LL LINF = 1e18;
const int N = (int)5e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

int n, t, a[N], b[N];

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> t;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	a[0] = a[1], a[n + 1] = a[n];
	if (n <= 1000) {
		int ans = 0;
		while (true) {
			b[1] = a[1], b[n] = a[n];
			for (int i = 2; i < n; i++) {
				int arr[3] = { a[i - 1], a[i], a[i + 1] };
				sort(arr, arr + 3);
				b[i] = arr[1];
			}
			bool fl = true;
			for (int i = 1; i <= n; i++) {
				if (a[i] != b[i])
					fl = false;
				a[i] = b[i];
			}
			if (fl) {
				cout << ans << endl;
				if (t == 1)
					for (int i = 1; i <= n; i++)
						cout << a[i] << ' ';
				exit(0);
			}
			ans++;
		}
	}
	vector <pair<int, int>> comp;
	int ind = 0, sz = n + 2;
	while (ind < sz) {
		int st = a[ind], cnt = 0;
		while (ind < sz && st == a[ind])
			ind++, cnt++;
		comp.push_back(mp(st, cnt));
	}
	ind = 0, sz = size(comp);
	int ans = 0;
	vector <int> res;
	while (ind < sz) {
		while (ind < sz && comp[ind].second > 1) {
			for (int i = 0; i < comp[ind].second; i++)
				res.push_back(comp[ind].first);
			ind++;
		}
		if (ind == sz)
			break;
		int l = comp[ind - 1].first, cnt = 0;
		while (ind < sz && comp[ind].second == 1)
			cnt++, ind++;
		int r = comp[ind].first;
		uax(ans, (cnt + 1) / 2);
		if (l == r) {
			for (int i = 0; i < cnt; i++)
				res.push_back(l);
		}
		else {
			for (int i = 0; i < cnt / 2; i++)
				res.push_back(l);
			for (int i = 0; i < cnt / 2; i++)
				res.push_back(r);
		}
	}
	cout << ans << endl;
	if (t == 1) {
		for (int i = 1; i <= n; i++)
			cout << res[i] << ' ';
	}
}