#include <bits/stdc++.h>

using namespace std;

#define int long long

bool check(vector <int> &a) {
    for (int i = 1; i < (int) a.size() - 1; ++i) {
        if (a[i] >= min(a[i - 1], a[i + 1]) && a[i] <= max(a[i + 1], a[i - 1])) continue;
        return 0;
    }
    return 1;
}

vector <int> change(vector <int> a) {
    vector <int> ans;
    for (int i = 0; i < a.size(); ++i) {
        if (i == 0 || i == (int) a.size() - 1 || a[i] >= min(a[i - 1], a[i + 1]) && a[i] <= max(a[i + 1], a[i - 1])) {
            ans.push_back(a[i]);
            continue;
        }
        if (a[i - 1] >= min(a[i], a[i + 1]) && a[i - 1] <= max(a[i], a[i + 1])) ans.push_back(a[i - 1]);
        else ans.push_back(a[i + 1]);
    }
    return ans;
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int cnt = 0;
    while (!check(a)) {
        ++cnt;
        a = change(a);
    }
    if (t == 0) {
        cout << cnt;
        return;
    }
    cout << cnt << '\n';
    for (int i = 0; i < n; ++i) cout << a[i] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
