#include <iostream>
#define endl '\n'

using namespace std;

const int MAXN = 1e5;
int n;
int a[MAXN+10], b[MAXN+10];
bool t;
int days = 0;

void input()
{
    cin>>n>>t;
    for (int i=0; i<n; i++)
    {
        cin>>a[i];
    }
}

void output()
{
    cout<<days<<endl;
    if (t)
    {
        for (int i=0; i<n; i++)
        {
            cout<<a[i]<<' ';
        }
        cout<<endl;
    }
}

int median(int a, int b, int c)
{
    if (a > b) swap(a, b);
    if (a > c) swap(a, c);
    if (b > c) swap(b, c);
    return b;
}

void solve()
{
    days = -1;
    int st = 1, ed = n-2;
    bool p = 1;

    while (p)
    {
        p = 0;
        int o_med = median(a[st-1], a[st], a[st+1]);
        for (int i = st+1; i <= ed; i++)
        {
            int med = median(a[i-1], a[i], a[i+1]);
            if (a[i-1] != o_med)
            {
                p = 1;
                a[i-1] = o_med;
            }
            o_med = med;
        }
        if (a[ed] != o_med)
        {
            p = 1;
            a[ed] = o_med;
        }
        days++;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
5 1
1 2 1 2 1

6 1
1 3 2 5 4 6

6 0
1 1 2 2 1 1
*/


