#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

void solve() {
    ll n, t;
    cin >> n >> t;
    vector<ll> a(n);
    forEach(a) cin >> it;
    bool flag = true;
    ll cnt = 0;
    while (flag) {
        flag = false;
        vector<ll> na(all(a));
        for (ll i = 1; i < n - 1; i++) {
            if (a[i] > max(a[i - 1], a[i + 1])) {
                flag = true;
                na[i] = max(a[i - 1], a[i + 1]);
            }
            if (a[i] < min(a[i - 1], a[i + 1])) {
                flag = true;
                na[i] = min(a[i - 1], a[i + 1]);
            }
        }
        swap(a, na);
        cnt += ll(flag);
        assert(c < 100);
    }
    cout << cnt << "\n";
    if (t) {
        forEach(a) cout << it << " ";
    }
}

#define Search

int main() {
    FASTIO
#ifdef Search
    freopen("A.in", "r", stdin);
#endif
    solve();
    return 0;
}