#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

int n, t;
vector<ll> a;

bool check1() {
	return (n <= 1000);
}

bool move() {
	vector<ll> b(n);
	b[0] = a[0];
	b[n - 1] = a[n - 1];
	bool flag = 0;
	for (int i = 1; i < n - 1; i++) {
		int x = a[i - 1], y = a[i], z = a[i + 1];
		if (x > y)
			swap(x, y);
		if (y > z)
			swap(y, z);
		if (x > y)
			swap(x, y);
		b[i] = y;
		if (a[i] != b[i])
			flag = 1;
	}
	a = b;
	return flag;
}

void solve1() {
	int now = 0;
	while (1) {
		bool res = move();
		if (!res)
			break;
		now++;
	}
	cout << now << endl;
	if (t == 1) {
		for (auto elem : a)
			cout << elem << " ";
		cout << endl;
	}
}

bool check2() {
	for (int i = 0; i < n; i++) {
		if (a[i] > 2)
			return 0;
	}
	return 1;
}

void solve2() {
	int ans = 0;
	vector<int> b(n);
	int L = 0;
	vector<pair<int, int> > all;
	for (int i = 1; i < n; i++) {
		if (L != -1) {
			if (a[i] == a[i - 1]) {
				continue;
			}
			all.push_back({L, i - 1});
			L = -1;
		}
		else {
			if (a[i] == a[i - 1]) {
				L = i - 1;
			}
		}
	}
	if (L != -1)
		all.push_back({ L, n - 1 });
	else
		all.push_back({ n - 1, n - 1 });
	b[0] = a[0];
	b[n - 1] = a[n - 1];
	int pt = 0;
	for (int i = 0; i < n; i++) {
		while (pt < (int)all.size() - 1 && all[pt + 1].first <= i)
			pt++;
		if (all[pt].second >= i) {
			b[i] = a[i];
			continue;
		}
		int x1 = i - all[pt].second;
		int x2 = all[pt + 1].first - i;
		if (x1 < x2) {
			ans = max(ans, x1);
			b[i] = a[all[pt].first];
		}
		else {
			ans = max(ans, x2);
			b[i] = a[all[pt + 1].first];
		}
	}
	cout << ans << endl;
	if (t == 1) {
		for (auto elem : b)
			cout << elem << " ";
		cout << endl;
	}
}

int main() {
	cin >> n >> t;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (check1()) {
		solve1();
		return 0;
	}
	if (check2()) {
		solve2();
		return 0;
	}
}
//*/