#pragma GCC target("avx2")
#pragma GCC optimize("O3") 

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x)) 
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
//#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 123;
const ll inf = (ll)1e18 + 123;

const double pi = acos(-1.0);
const double eps = 1e-7;
const int dx[] = {0, 0, 0, -1, 1};
const int dy[] = {0, 1, -1, 0, 0};

int n, sum[5001], sum1[5001];
bool is[5001][5001];
ll ans;
string s;

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}

inline void Solve () {
	boost ();
	cin >> n >> s;
	for (int i = 0; i < n; i ++) {
		int l = i, r = i;
		while (l >= 0 & r < n) {
			is[l][r] = 1;
			l --, r ++;
			if (l < 0 || r >= n) break;
			if (s[l] != s[r]) break;
		}
		if (i == n - 1 || s[i] != s[i + 1]) continue;
		l = i, r = i + 1;
		while (l >= 0 & r < n) {
			is[l][r] = 1;
			l --, r ++;
			if (l < 0 || r >= n) break;
			if (s[l] != s[r]) break;
		}
	}
	for (int i = 0; i < n; i ++) {
		for (int j = i; j < n; j ++) {
			sum[i] += is[i][j];
			sum1[j] += is[i][j];
		}
	}
	for (int i = 0; i < n; i ++)
		for (int len = 1;; len ++) {
			if (i - len + 1 < 0 || i + len >= n) break;
			ans += is[i - len + 1][i] * is[i + 1][i + len];
		}	
	cout << ans;
}

int main () {
   int tt = 1;
   //cin >> tt;
   while (tt --) Solve (); 
	return 0;
}