#include <bits/stdc++.h>

using namespace std;

int med(int a, int b, int c) {
    if (min(a, c) <= b && b <= max(a, c))
        return b;
    if (min(b, c) <= a && a <= max(b, c))
        return a;
    return c;
}

void solver(int n, vector<int> &v, int t) {
    int answ = 0;
    vector<int> ans(n);
    ans[0] = v[0];
    ans[n - 1] = v[n - 1];
    for (int i = 1; i < n - 1; ++i)
        if (v[i] == v[i - 1] || v[i] == v[i + 1])
            ans[i] = v[i];
    vector<pair<int, int>> bads;
    int last_nul = -1;
    for (int i = 0; i < n; ++i) {
        if (last_nul == -1 && ans[i] == 0)
            last_nul = i;
        else if (last_nul != -1 && ans[i] != 0) {
            bads.push_back({last_nul, i});
            last_nul = -1;
        }
    }
    for (auto x : bads) {
        answ = max(answ, (x.second - x.first + 1) / 2);
        int lef = x.first, rig = x.second;
        if ((rig - lef) % 2 == 0) {
            for (int i = lef; i < (rig + lef) / 2; ++i)
                ans[i] = ans[lef - 1];
            for (int i = (rig + lef) / 2; i < rig; ++i)
                ans[i] = ans[rig];
        } else {
            for (int i = lef; i < rig; ++i)
                ans[i] = ans[lef - 1];
        }
    }
    cout << answ << '\n';
    if (t)
        for (auto x : ans)
            cout << x << ' ';
    if (t)
        cout << '\n';
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector<int> v(n);
    bool chit = true;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        if (v[i] > 2)
            chit = false;
    }
    if (chit) {
        solver(n, v, t);
        return;
    }
    int kolvo = 0;
    while (true) {
        vector<int> v1(n);
        v1[0] = v[0];
        v1[v1.size() - 1] = v[v.size() - 1];
        for (int i = 1; i < n - 1; ++i)
            v1[i] = med(v[i - 1], v[i], v[i + 1]);
        bool ch = false;
        for (int i = 0; i < n; ++i)
            if (v[i] != v1[i])
                ch = true;
        if (!ch)
            break;
        ++kolvo;
        v = v1;
    }
    cout << kolvo << '\n';
    for (int i = 0; i < n; ++i)
        if (t)
            cout << v[i] << ' ';
    if (t)
        cout << '\n';
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
