

#include <iostream>
#include <random>
#include <algorithm>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

void run() {
    int n, t;
    cin >> n >> t;
    auto a = arr<int>(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto b = arr<int>(n);
    int ans = 0;
    bool changed = true;
    while (changed) {
        changed = false;
        copy(a, a + n, b);
        for (int i = 1; i < n - 1; i++) {
            int p[3] = {b[i - 1], b[i], b[i + 1]};
            sort(p, p + 3);
            a[i] = p[1];
            changed = changed || a[i] != b[i];
        }
        ans += changed;
    }
    cout << ans << endl;
    if (t) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    }
}