#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		cout << l << " " << r << endl;

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int n, t;
vector<int> arr(500000);

void solve_2() {
	int l = 0;
	int r = 0;

	vector<int> bad(n);
	bad[0] = 1;
	bad[n - 1] = 1;

	vector<int> ans = arr;

	for (int i = 1; i < n - 1; i++) {
		if (arr[i] == arr[i - 1] || arr[i] == arr[i + 1]) {
			bad[i] = 1;

		}
	}

	int ans1 = 0;

	for (int i = 0; i < n; i++) {
        if (i == n - 1) {
            continue;
        }
        if (bad[i]) {
            if (bad[i + 1]) {
                continue;
            }
			l = i;
			i++;
			while (i + 1 < n && !bad[i]) {
				i++;
			}
			r = i;

			//cout << l << " " << r << endl;

			if (arr[l] == arr[r]) {
				ans1 = max(ans1, (r - l) / 2);
				for (int j = l; j <= r; j++) {
					ans[j] = arr[l];
				}
			} else {
				ans1 = max(ans1, (r - l) / 2);

				int sz = (r - l + 1) / 2;

				//cout << sz << " " << arr[l] << " " << arr[r] << endl;

				for (int j = l; j < l + sz; j++) {
					ans[j] = arr[l];
				}
				for (int j = l + sz; j < r; j++) {
					ans[j] = arr[r];

				}
			}
		}
	}
	cout << ans1 << endl;

	if (t) {
		for (int i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
	}

}

int med(int a, int b, int c) {
	vector<int> kek(3);
	kek[0] = a;
	kek[1] = b;
	kek[2] = c;
	sort(kek.begin(), kek.end());
	return kek[1];
}

vector<int> ans(500000);

vector<int> bad(500000);

vector<int> lol1(500000);

int ANS = 0;

void solve_1(int l, int r) {
	//cout << l << " " << r << endl;
	vector<int> now1(r - l + 1);
	now1[0] = arr[l];
	now1[r - l] = arr[r];
	//return;
	int cnt = 0;
	for (int i = l + 1; i < r; i++) {

        //cout << i - l << " " << i - 1 << " " << i << " " << i + 1 << endl;
        int was = now1[i - l];
		now1[i - l] = med(arr[i - 1], arr[i], arr[i + 1]);
		if (now1[i - l] != arr[i]) {
            lol1[i]++;
            cnt++;
            ANS = max(ANS, lol1[i]);
		}
	}

	if (cnt == 0) {
        return;
	}

	//return;
	for (int i = 0; i < r - l + 1; i++) {
		arr[i + l] = now1[i];
	}
	//return;

	vector<int> bad(r - l + 1);

	bad[l] = 1;
	bad[r] = 1;

	for (int i = l + 1; i < r; i++) {
		if (arr[i] == arr[i - 1] || arr[i] == arr[i + 1]) {
			bad[i] = 1;
		} else {
			bad[i] = 0;
		}
	}

	int l1 = 0; int r1 = 0;

	for (int i = l; i <= r; i++) {
        if (i == r) {
            continue;
        }
        if (bad[i]) {
            if (bad[i + 1]) {
                continue;
            }
			l1 = i;
			i++;
			while (i + 1 <= r && !bad[i]) {
				i++;
			}
			r1 = i;
			//cout << l << " " << r << " -> "<< l1 << " " << r1 << endl;

			solve_1(l1, r1);
		}
	}
}

void solve_1_1() {
	int l = 0;
	int r = 0;
	bad[0] = 1;
	bad[n - 1] = 1;

	vector<int> ans = arr;

	for (int i = 1; i < n - 1; i++) {
		if (arr[i] == arr[i - 1] || arr[i] == arr[i + 1]) {
			bad[i] = 1;

		}
	}

	int ans1 = 0;

	for (int i = 0; i < n; i++) {
        if (i == n - 1) {
            continue;
        }
        if (bad[i]) {
            if (bad[i + 1]) {
                continue;
            }
			l = i;
			i++;
			while (i + 1 < n && !bad[i]) {
				i++;
			}
			r = i;

			//cout << "! " << l << " " << r << endl;
			solve_1(l, r);
		}
	}
	/*for (int i = 0; i < n; i++) {
		cout << arr[i] << " ";
	}*/

}

signed main() {
	fast_io();
	cin >> n >> t;
	int max1 = -1;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		max1 = max(arr[i], max1);
	}

	if (max1 < 3) {
		solve_2();
		return 0;
	} else {
	}

	solve_1_1();

	cout << ANS << endl;

	if (t) {
        for (int i = 0; i < n; i++) {
            cout << arr[i] << " ";
        }
	}

    return 0;
}
