#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

vector<int> a;
vector<int> change;
int n, t;
set<int> p;

bool check(int i) {
    if (i == 0 || i + 1 == (int)a.size()) {
        return false;
    }
    bool ans = true;
    if (a[i - 1] <= a[i] && a[i] <= a[i + 1]) {
        ans = false;
    }
    if (a[i - 1] >= a[i] && a[i] >= a[i + 1]) {
        ans = false;
    }
    if (a[i - 1] == a[i] || a[i] == a[i + 1]) {
        ans = false;
    }
    return ans;
}

int middle(int num1, int num2, int num3) {
    vector<int> temp = {num1, num2, num3};
    sort(temp.begin(), temp.end());
    return temp[1];
}

void does() {
    set<int> tp;
    for (auto ind : p) {
        change[ind] = middle(a[ind - 1], a[ind], a[ind + 1]);
    }
    for (auto ind : p) {
        a[ind] = change[ind];
    }
    for (auto ind : p) {
        if (check(ind - 1)) {
            tp.insert(ind - 1);
        }
        if (check(ind + 1)) {
            tp.insert(ind + 1);
        }
    }
    p = tp;
}

void solve() {
    cin >> n >> t;
    a.resize(n);
    change.resize(n, -1);
    for (int &i : a) {
        cin >> i;
    }
    for (int i = 1; i + 1 < n; ++i) {
        if (!check(i)) {
            continue;
        }
        p.insert(i);
    }
    int cnt = 0;
    while (!p.empty()) {
        cnt++;
        does();
    }
    cout << cnt << '\n';
    if (t == 1) {
        for (int i : a) {
            cout << i << ' ';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}