#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    #define INF = 1e18;
//    #define mod = 2600000069;
//    #define p = 10;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define INF = 1e18;
//    #define mod = 2600000069;
//    #define p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

const int MAXN = 5e5 + 1;

int n, t;
vector<int> a;
int a1[2][MAXN];

int med(int a, int b, int c) {
    if (a > b) swap(a, b);
    if (a > c) swap(a, c);
    if (b > c) swap(b, c);
    return b;
}

void solve12() {
    vector<pii> kek;
    int lst = -1;
    for (int i = 0; i < n; i++) a[i]--;
    for (int i = 1; i < n - 1; i++) {
        if (a[i] == !a[i - 1] && a[i] == !a[i + 1]) {
            if (lst == -1) lst = i;
        } else {
            if (lst != -1) {
                kek.pb({lst, i - 1});
                lst = -1;
            }
        }
    }
    int ans = 0;
    if (lst != -1) kek.pb({lst, n - 2});
    for (auto k : kek) {
        // cout << k.first << " " << k.second << "\n";
        ans = max(ans, (k.second - k.first) / 2 + 1);
        bool inv = 0;
        while (k.second > k.first) {
//            dbg(k.second)
//            dbg(k.first)
            if (!inv) {
                a[k.second] = !a[k.second];
                a[k.first] = !a[k.first];
            }
            inv = !inv;
            k.second--;
            k.first++;
        }
        if (k.second == k.first) a[k.first] = med(a[k.first - 1], a[k.first], a[k.first + 1]);
    }
    cout << ans << "\n";
    if (t) for (int i = 0; i < n; i++) cout << a[i] + 1 << " ";
}

int ans = 0;
bool ok = 1, cur = 0;

void iter() {
    ans++;
    ok = 0;
    a1[!cur][0] = a1[cur][0];
    a1[!cur][n - 1] = a1[cur][n - 1];
    for (int i = 1; i < n - 1; i++) {
        if (med(a1[cur][i], a1[cur][i - 1], a1[cur][i + 1]) != a1[cur][i]) {
            a1[!cur][i] = med(a1[cur][i], a1[cur][i - 1], a1[cur][i + 1]);
            ok = 1;
        } else a1[!cur][i] = a1[cur][i];
    }
    cur = !cur;
}

void stupid() {
    while (ok) {
        iter();
    }
    cout << ans - 1 << "\n";
    if (t) {
        for (int i = 0; i < n; i++) cout << a1[cur][i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> t;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    bool ok12 = 1;
    for (int i = 0; i < n; i++) {
        if (a[i] != 1 && a[i] != 2) ok12 = 0;
        a1[cur][i] = a[i];
    }
    if (ok12) solve12();
    else stupid();
}
/*
7 1
1 2 1 1 1 1 2
----------
1
1 1 1 1 1 1 2
----------
3
1 1 2 2 2 2 2
----------

сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
