#include <iostream>
#include <random>
#include <algorithm>
#include <vector>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

void run() {
    int n, t;
    cin >> n >> t;
    auto a = arr<int>(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> check;
    for (int i = 1; i < n - 1; i++) {
        if ((a[i] < a[i - 1] && a[i] < a[i + 1]) || (a[i] > a[i - 1] && a[i] > a[i + 1])) {
            check.push_back(i);
        }
    }
    vector<int> to_check(n, -1);
    bool changed = true;
    int it = 0;
    int ans = 0;
    while (changed) {
        it++;
        changed = false;
        vector<pair<int, int>> new_val;
        vector<int> new_check;
        for (int i: check) {
            if (i == 0 || i == n - 1)
                continue;
            int p[3] = {a[i - 1], a[i], a[i + 1]};
            sort(p, p + 3);
            if (a[i] != p[1]) {
                changed = true;
                new_val.emplace_back(i, p[1]);
                for (int k = i - 1; k <= i + 1; k++) {
                    if (to_check[k] != it) {
                        to_check[k] = it;
                        new_check.push_back(k);
                    }
                }
            }
        }
        check = new_check;
        for (auto p: new_val) {
            a[p.first] = p.second;
        }
        ans += changed;
    }
    cout << ans << endl;
    if (t) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    }
}