#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, t; cin >> n >> t;
	vector <int> a(n); FR(i, n) cin >> a[i];
	vector <int> b(n); b[0] = a[0], b[n - 1] = a[n - 1];

	int ans = 0;
	bool ch = 1;
	while (ch) {
		
		ans++;
		ch = 0;

		FOR(i, 1, n - 1) {

			b[i] = a[i];
			if (a[i] > a[i - 1] && a[i] > a[i + 1]) ch = 1, b[i] = max(a[i - 1], a[i + 1]);
			if (a[i] < a[i - 1] && a[i] < a[i + 1]) ch = 1, b[i] = min(a[i - 1], a[i + 1]);
			
		}

		FR(i, n) a[i] = b[i];
	}

	cout << ans - 1 << '\n';
	if (t == 1) FR(i, n) cout << a[i] << ' ';

	return 0;
} 