#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n, t;
	cin >> n >> t;
	if (t == 1) return 0;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<int> stable;
	stable.push_back(0);
	for (int i = 1; i < n - 1; i++)
	{
		if ((a[i] <= a[i - 1] && a[i + 1] <= a[i]) || (a[i] >= a[i - 1] && a[i + 1] >= a[i])) stable.push_back(i);
	}
	stable.push_back(n - 1);
	int ans = 0;
	for (int i = 1; i < stable.size(); i++)
	{
		int curr = stable[i] - stable[i - 1] - 1;
		ans = max(ans, (curr + 1) / 2);
	}
	cout << ans;
	return 0;
}