#include <bits/stdc++.h>

#pragma GCC target("avx,avx2")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

vector<int> a;
int n;
vector<int> can;

bool ok(int x) {
    if (x == 0 || x == n - 1) return true;
    return min(a[x - 1], a[x + 1]) <= a[x] && a[x] <= max(a[x - 1], a[x + 1]);
}

bool solve() {
    int last = 0;
    vector<int> can2;
    for (int i = 0; i < sz(can); i++) {
        int j = can[i];
        int add;
        if (i == 0 || (i > 0 && can[i - 1] + 1 != can[i])) {
            last = a[j - 1];
        }
        if (min(a[j], a[j + 1]) <= last && last <= max(a[j], a[j + 1])) {
            add = last;
        } else {
            add = a[j + 1];
        }
        last = a[j];
        a[j] = add;
        if (!ok(j - 1)) {
            can2.emplace_back(j - 1);
        }
        if (i + 1 < sz(can) && can[i + 1] > j + 1) {
            if (!ok(j)) {
                can2.emplace_back(j);
            }
        }
        if (i + 1 < sz(can) && can[i + 1] > j + 2) {
            if (!ok(j)) {
                can2.emplace_back(j);
            }
        }
    }
    swap(can, can2);
    return sz(can);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> n >> t;
    a.resize(n);
    for (auto &el : a) cin >> el;
    for (int i = 0; i < n; i++) {
        if (!ok(i)) {
            can.emplace_back(i);
        }
    }
    int cnt = 0;
    if (sz(can)) cnt++;
    while (solve()) {
        cnt++;
    }
    cout << cnt << "\n";
    if (t) {
        for (auto &el : a) {
            cout << el << " ";
        }
    }

    return 0;
}