#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 500007;

int n, t, a[MAXN];
int b[2][MAXN];

int med(int a, int b, int c) {
    int x[3] = {a, b, c};
    sort(x, x + 3);
    return x[1];
}

void solve1() {
    for (int i = 0; i < n; ++i) {
        b[0][i] = a[i];
    }
    b[1][0] = a[0];
    b[1][n - 1] = a[n - 1];
    for (int i = 0;; ++i) {
        int cur = i % 2;
        int next = (i + 1) % 2;
        for (int j = 1; j < n - 1; ++j) {
            b[next][j] = med(b[cur][j - 1], b[cur][j], b[cur][j + 1]);
        }
        bool changed = false;
        for (int j = 0; j < n; ++j) {
            if (b[cur][j] != b[next][j]) {
                changed = true;
            }
        }
        if (!changed) {
            cout << i << '\n';
            if (t) {
                for (int j = 0; j < n; ++j) {
                    cout << b[cur][j] << ' ';
                }
            }
            return;
        }
    }
}

int b2[MAXN];

int solve2(int a, int b) {
    if (b - a <= 2) {
        return 0;
    }
    for (int i = a; i + 1 < b; ++i) {
        if (b2[i] == b2[i + 1]) {
            int x = solve2(a, i + 1);
            int y = solve2(i + 1, b);
            return max(x, y);
        }
    }
    int ans = (b - a - 1) / 2;
    if ((b - a) % 2 == 1) {
        for (int i = a; i < b; ++i) {
            b2[i] = b2[a];
        }
    } else {
        int m = (a + b) / 2;
        for (int i = a; i < m; ++i) {
            b2[i] =b2[a];
        }
        for (int i = m; i < b; ++i) {
            b2[i] = b2[b - 1];
        }
    }
    return ans;
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> t;
    bool larg = false;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] > 2) {
            larg = true;
        }
    }
    if (n <= 1000) {
        solve1();
        return 0;
    }
    if (!larg) {
        for (int i = 0; i < n; ++i) {
            b2[i] = a[i];
        }
        cout <<solve2(0, n) << '\n';
        if (t) {
            for (int i = 0; i < n; ++i) {
                cout << b2[i] << ' ';
            }
        }
    }
    return 0;
}