#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <string>
#include <random>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

mt19937 gen(34);

int n, a[500010];
bool t;

int median(int a, int b, int c)
{
	int x[3];
	x[0] = a;
	x[1] = b;
	x[2] = c;
	sort(x, x + 3);
	return x[1];
}

pair <int, vector <int>> stupid_solve_for_a_2()
{
	int a[500010];
	for (int i = 0; i < n; i++)
		a[i] = ::a[i];
	vector <pair <int, int>> v;
	for (int i = 0; i < n; i++)
		if (a[i] != a[i + 1])
		{
			int l = i, r = i;
			while (r + 2 < n && a[r + 1] != a[r + 2])
				r++;
			v.pb(mp(l, r));
			i = r;
		}
		else
			while (i + 1 < n && a[i + 1] == a[i])
				i++;
	int ans = 0;
	for (auto p : v)
	{
		int l = p.first, r = p.second, res = 0;
		assert(l > 0);
		assert(r + 1 < n);
		assert(l <= r);
		while (l <= r)
		{
			a[l] = a[l - 1];
			a[r] = a[r + 1];
			res++;
			l++;
			r--;
		}
		ans = max(ans, res);
	}
	//cout << ans << '\n';
	vector <int> sos;
	//if (t)
	for (int i = 1; i < n - 1; i++)
		sos.pb(a[i]);
	//cout << a[i] << ' ';
	return mp(ans, sos);
	//exit(0);
}

pair <int, vector <int>> stupid_solve_for_n_1000()
{
	int cnt = 0;
	int a[1010];
	for (int i = 0; i < n; i++)
		a[i] = ::a[i];
	int b[1010];
	while (true)
	{
		bool changes = false;
		b[0] = a[0];
		b[n - 1] = a[n - 1];
		for (int i = 1; i < n - 1; i++)
		{
			b[i] = median(a[i - 1], a[i], a[i + 1]);
			if (a[i] != b[i])
				changes = true;
		}
		if (!changes)
			break;
		cnt++;
		for (int i = 0; i < n; i++)
			a[i] = b[i];
	}
	//cout << cnt << '\n';
	//if(t)
	vector <int> sos;
	for (int i = 1; i < n - 1; i++)
		sos.pb(a[i]);
	//cout << a[i] << ' ';
	return mp(cnt, sos);
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	/*int CNT = 0;
	while (true)
	{
		if (CNT == 326)
			CNT = 326;
		n = gen() % 100;
		while (n == 0)
			n = gen() % 100;
		for (int i = 1; i <= n; i++)
			a[i] = (gen() & 1) + 1;
		a[0] = a[1];
		a[n + 1] = a[n];
		n += 2;
		auto p = stupid_solve_for_a_2();
		auto q = stupid_solve_for_n_1000();
		if (p.first == q.first && p.second == q.second)
			cerr << "TEST: " << CNT++ << " OK\n";
		else
		{
			cout << n - 2 << '\n';
			for (int i = 1; i < n - 1; i++)
				cout << a[i] << ' ';
			cout << '\n' << p.first << ' ' << q.first << '\n';
			for (int x : p.second)
				cout << x << ' ';
			cout << '\n';
			for (int x : q.second)
				cout << x << ' ';
			exit(0);
		}

	}*/
	cin >> n >> t;
	bool ch = true;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		ch &= (a[i] <= 2);
	}
	a[0] = a[1];
	a[n + 1] = a[n];
	n += 2;
	if (ch)
		stupid_solve_for_a_2();
	if (n <= 1002)
		stupid_solve_for_n_1000();
	return 0;
}
