#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int median(int a, int b, int c)
{
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	if (a > b)
		swap(a, b);

	return b;
}

int main()
{
	int n = 0, t = 0;
	cin >> n >> t;

	vector <int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	if (*max_element(a.begin(), a.end()) == *min_element(a.begin(), a.end()))
	{
		cout << "0\n";
		if (t == 1)
			for (int x : a)
				cout << x << ' ';
	}
	else if (*max_element(a.begin(), a.end()) <= 2)
	{
		vector <int> extr(n);
		for (int i = 1; i < n - 1; ++i)
		{
			if (a[i] > a[i - 1] && a[i] > a[i + 1])
				extr[i] = 1;
			if (a[i] < a[i - 1] && a[i] < a[i + 1])
				extr[i] = -1;
		}

		int c = 0, r = 0;
		vector <pair <int, int>> rng;
		for (int i = 0; i < n; ++i)
		{
			if (extr[i] != 0)
			{
				r = i;
				while (extr[r] != 0)
					++r;
				rng.push_back({ i, r });
				i = r;
			}
		}

		for (pair <int, int> x : rng)
		{
			c += (x.second - x.first + 1) / 2;
			int left = a[x.first - 1], right = a[x.second--];
			while (x.first < x.second)
			{
				a[x.first++] = left;
				a[x.second--] = right;
			}

			if (x.first == x.second)
				a[x.first] = median(a[x.first], a[x.first - 1], a[x.first + 1]);
		}

		cout << c << '\n';
		if (t == 1)
			for (int x : a)
				cout << x << ' ';
	}
	else
	{
		int c = 0;
		while (true)
		{
			vector <int> b(n);
			b[0] = a[0];
			b.back() = a.back();

			bool swapped = false;
			for (int i = 1; i < n - 1; ++i)
			{
				b[i] = median(a[i - 1], a[i], a[i + 1]);
				if (a[i] != b[i])
					swapped = true;
			}

			if (!swapped)
				break;
			swap(a, b);
			++c;
		}

		cout << c << '\n';
		if (t == 1)
			for (int x : a)
				cout << x << ' ';
	}


	return 0;
}