#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 10;

int a[MAX_N];

vector<pair<int, int>> cuts;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	char prev = 0;
	int last = -1;
	for (int i = 1; i < n - 1; ++i) {
		char curr = 0;
		if (a[i - 1] < a[i] && a[i] > a[i + 1])
			curr = 1;
		if (a[i - 1] > a[i] && a[i] < a[i + 1])
			curr = 2;
		if (curr) {
			if (last == -1)
				last = i;
		} else {
			if (prev) {
				cuts.push_back({last, i});
				last = -1;
			}
		}
		prev = curr;
	}
	if (prev)
		cuts.push_back({last, n - 1});
	int ans = 0;
	for (auto u : cuts) {
		if ((u.y - u.x) % 2) {
			assert(a[u.x - 1] == a[u.y]);
			fill(a + u.x, a + u.y, a[u.x - 1]);
		} else {
			for (int i = u.x; i < u.y; ++i) {
				if (i - u.x < u.y - i - 1) {
					a[i] = a[u.x - 1];
				} else {
					a[i] = a[u.y];
				}
			}
		}
		ans = max(ans, (u.y - u.x + 1) / 2);
	}
	cout << ans << "\n";
	if (t) {
		for (int i = 0; i < n; ++i)
			cout << a[i] << " ";
	}
	return 0;
}