#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const int N = 500010;
const int INF = (int)1e9 + 10;

const ll MOD = (int)1e9 + 7;

const ll P = 31;

int n, type;

int a[N], res[N];

int b[N];

struct Group {
	int left, right;
};

vector < Group > gr;

int ans = 0;

void solve01() {
	int l = 1;
	gr.clear();
	for (int i = 1; i <= n; ++i) {
		if (i == n || b[i] == b[i + 1]) {
			gr.push_back({ l, i });
			l = i + 1;
		}
	}
	int sz = gr.size();
	int col = 0;
	for (int i = 0; i < sz; ++i) {
		int len = gr[i].right - gr[i].left + 1;
		if (b[gr[i].left] == 0 && b[gr[i].right] == 0) {
			for (int j = gr[i].left; j <= gr[i].right; ++j) {
				res[j] = 0;
			}
			col = max(col, len / 2);
		}
		else if (b[gr[i].left] == 1 && b[gr[i].right] == 1) {
			for (int j = gr[i].left; j <= gr[i].right; ++j) {
				res[j] = 1;
			}
			col = max(col, len / 2);
		}
		else if (b[gr[i].left] == 0 && b[gr[i].right] == 1) {
			for (int j = gr[i].left; j < gr[i].left + len / 2; ++j) {
				res[j] = 0;
			}
			for (int j = gr[i].left + len / 2; j <= gr[i].right; ++j) {
				res[j] = 1;
			}
			col = max(col, (len / 2) - 1);
		}
		else {
			for (int j = gr[i].left; j < gr[i].left + len / 2; ++j) {
				res[j] = 1;
			}
			for (int j = gr[i].left + len / 2; j <= gr[i].right; ++j) {
				res[j] = 0;
			}
			col = max(col, (len / 2) - 1);
		}
	}
	ans = max(ans, col);
}

int l[N], r[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	cin >> n >> type;
	for (int i = 1; i <= n; ++i) {
		l[i] = 1, r[i] = 100;
		cin >> a[i];
	}
	for (int it = 1; it <= 100; ++it) {
		for (int i = 1; i <= n; ++i) {
			if (a[i] <= it)
				b[i] = 0;
			else
				b[i] = 1;
		}
		solve01();
		for (int i = 1; i <= n; ++i) {
			if (res[i] == 0)
				r[i] = min(r[i], it);
			else
				l[i] = max(l[i], it + 1);
		}
	}
	cout << ans << '\n';
	if (type == 1) {
		for (int i = 1; i <= n; ++i) {
			cout << l[i] << ' ';
		}
	}
}