//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx")
//#pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

int n, t;
vector<int> a;

void read() {
	cin >> n >> t;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
}

int get(int a, int b, int c) {
	vector<int> ans = {a, b, c};
	sort(all(ans));
	return ans[1];
}

int fans = 0;

int solve(vector<int> & a) {
	vector<int> ans(a.size());
	ans[0] = a[0];
	ans[a.size() - 1] = a[a.size() - 1];
	for (int i = 1; i < a.size() - 1; i++) {
			ans[i] = get(a[i - 1], a[i], a[i + 1]);
	}
	bool flag = false;
	for (int i = 0; i < a.size(); i++) {
		flag |= a[i] != ans[i];		
	}
	if (!flag) return 0;
	a = ans;
	vector<int> have;
	ans.clear();
	int ret = 0;
	for (int i = 0; i < a.size(); i++) {
		if (have.empty() || have.back() != a[i]) {
			have.push_back(a[i]);
		}
		else {
			chkmax(ret, solve(have));
			for (auto j : have)
				ans.push_back(j);
			have.clear();
			have.push_back(a[i]);
		}
	}
	chkmax(ret, solve(have));
	for (auto j : have)
		ans.push_back(j);
	a = ans;
	return ret + 1;
}

int solve(int l, int r) {
	int ans = (r - l) / 2;
	if (a[l] == a[r]) {
		for (int i = l; i <= r; i++) {
			a[i] = a[l];
		}
	}
	else {
		for (int i = 1; l + i < r - i; i++) {
			a[l + i] = a[l];
			a[r - i] = a[r]; 
		}
	}
	return ans;
}

bool check_group_2() {
	for (auto i : a)
		if (i > 2) return false;
	return true;
}

void solve_group_2() {
	fans = 0;
	for (int i = 0; i < n - 1; i++) {
		int j = i + 1;
		while (j < n && a[j] != a[j - 1]) j++;
		chkmax(fans, solve(i, j - 1));
		//cout << i << " " << j << endl;
		i = j - 1;
	}
}

void run() {
	/*for (auto i : a)
		cout << i << " ";
	cout << endl;
	while (it()) {
		for (auto i : a)
			cout << i << " ";
		cout << endl;
	}
	exit(0);*/
	if (check_group_2())
		solve_group_2();
	else
		fans = solve(a);
}

void write() {
	cout << fans << endl;
	if (t) {
		for (auto i : a)
			cout << i << " ";
		cout << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}