#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int mid(int a, int b, int c) {
	if (a > b) swap(a, b);
	if (a > c) swap(a, c);
	if (b > c) swap(b, c);
    return b;
}

int a[1000000];
int b[1000000];
int n;

bool change() {
    b[0] = a[0];
    b[n-1] = a[n-1];
    for (int i = 1; i < n-1; i++) {
        b[i] = mid(a[i-1], a[i], a[i+1]);
    }
    bool res = false;
    for (int i = 1; i < n-1; i++) {
        res |= (b[i] != a[i]);
        a[i] = b[i];
    }
    return res;
}

int solve(int l, int r) {
	if (a[l] == a[r]) {
        for (int i = l; i <= r; i++) a[i] = a[l];
	} else {
		if (a[l] < a[r]) {
			sort(a+l, a+r+1);
		} else {
			sort(a+l, a+r+1);
			reverse(a+l, a+r+1);
		}
	}
    return (r - l + 1) / 2;
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int t;
    cin >> n >> t;
    bool sub2 = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 2) sub2 = false;
    }
    int ans = 0;
    if (n > 1000) {
		int l = 0;
		for (int i = 0; i < n-1; i++) {
			if (a[i] == a[i+1]) {
				ans = max(ans, solve(l, i));
				l = i+1;
			}
		}
		ans = max(ans, solve(l, n-1));
    } else {
		while (change()) {
			ans++;
		}
    }
    cout << ans << endl;
    if (t == 1) {
        for (int i = 0; i < n; i++) cout << a[i] << " ";
        cout << endl;
    }

	return 0;
}
