#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, TASK;
    cin >> n >> TASK;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    if (n == 1)
    {
        cout << "0\n";
        if (TASK == 1)
        {
            cout << a[0] << '\n';
        }
        exit(0);
    }
    if (*max_element(all(a)) <= 2)
    {
        vector<pii> blocks;
        vector<int> bg;
        int cur = -1, cnt = 0;
        int cbg = -1;
        for (int i = 0; i < n; ++i)
        {
            if (cur != a[i])
            {
                if (cur != -1)
                {
                    bg.pb(cbg);
                    blocks.emplace_back(cur, cnt);
                }
                cur = a[i];
                cnt = 1;
                cbg = i;
            }
            else
            {
                ++cnt;
            }
        }
        blocks.emplace_back(cur, cnt);
        bg.pb(cbg);
        vector<int> idx;
        for (int j = 0; j < blocks.size(); ++j)
        {
            if (j == 0 || j + 1 == blocks.size() || blocks[j].se >= 2)
            {
                idx.pb(j);
            }
        }
        int ans = 0;
        for (int u = 0; u + 1 < idx.size(); ++u)
        {
            int b1 = idx[u];
            int b2 = idx[u + 1];
            if (b1 + 1 < b2)
            {
                int l = bg[b1 + 1];
                int r = bg[b2] - 1;
                chkmax(ans, (r - l + 2) / 2);
                if ((r - l + 1) % 2 == 0)
                {
                    for (int i = l; i <= (l + r) / 2; ++i)
                    {
                        a[i] = a[l - 1];
                    }
                    for (int i = (l + r) / 2 + 1; i <= r; ++i)
                    {
                        a[i] = a[r + 1];
                    }
                }
                else
                {
                    for (int i = l; i <= r; ++i)
                    {
                        a[i] = a[l - 1];
                    }
                }
            }
        }
        cout << ans << '\n';
        if (TASK == 1)
        {
            for (auto x : a)
                cout << x << ' ';
            cout << '\n';
        }
        exit(0);
    }
    for (int t = 0; ; ++t)
    {
        vector<int> b(n);
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        for (int i = 1; i < n - 1; ++i)
        {
            vector<int> y = {a[i - 1], a[i], a[i + 1]};
            sort(all(y));
            b[i] = y[1];
        }
        if (a == b)
        {
            cout << t << '\n';
            if (TASK == 1)
            {
                for (auto e : b)
                    cout << e << ' ';
                cout << '\n';
            }
            exit(0);
        }
        swap(a, b);
    }

    return 0;
}

