#include <bits/stdc++.h>

using namespace std;

vector <int> a;

int median(int a, int b, int c)
{
    vector <int> temp;
    temp.push_back(a);
    temp.push_back(b);
    temp.push_back(c);
    sort(temp.begin(), temp.end());
    return temp[1];
}

vector <int> parse(vector <int> a)
{
    vector <int> b;
    b.push_back(a[0]);
    for(int i = 1; i < a.size() - 1; i++)
    {
        b.push_back(median(a[i - 1], a[i], a[i + 1]));
    }
    b.push_back(a[a.size() - 1]);
    return b;
}

bool check(vector <int> a)
{
    for(int i = 1; i < a.size() - 1; i++)
    {
        if(a[i] != median(a[i - 1], a[i], a[i + 1]))
        {
            return false;
        }
    }
    return true;
}

vector <vector <int> > changes;

void do_changes(int c, vector <int> a)
{
    vector <int> a1;
    int c0 = 0;
    a1 = a;
    while(c0 < c)
    {
        a1 = parse(a1);
        c0++;
        changes.push_back(a1);
    }
}

bool f(int c)
{
    if(changes.size() < c + 1)
    {
        do_changes(c - (int)changes.size() + 1, changes[(int)changes.size() - 1]);
    }
    return check(changes[c]);
}

int bin(int left, int right)
{
    int l = left - 1, r = right;
    while(r - l > 1)
    {
        int mid = (l + r) / 2;
        if(f(mid))
        {
            r = mid;
        }
        else
        {
            l = mid;
        }
    }
    f(r);
    return r;
}

int main()
{
    int n, t;
    cin >> n >> t;
    a.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    changes.push_back(a);
    int ans = bin(0, 10000);
    cout << ans << endl;
    if(t == 1)
    {
        for(int i = 0; i < a.size(); i++)
        {
            cout << changes[ans][i] << " ";
        }
    }
    return 0;
}
