#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define ff first
#define ss second
#define pb push_back

using namespace std;

const ll N = 1e6 + 10;
const ll M = 1e3 + 10;
const ll mod = 1e9 + 7;
const ll INF = 1e18;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//uniform_int_distribution <int>(0, i)(rng);

ll n, T, a[N], cnt, ans;

pair<ll, ll> t[2 * N];

bool flag[N];

void build(ll v, ll l, ll r) {
    if (l == r) {
        t[v] = {a[l], l};
        return;
    }

    ll m = (l + r) / 2;

    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

void update(ll v, ll tl, ll tr, ll pos, ll val) {
    if (tl == tr && tl == pos) {
        t[v] = {val, pos};
        return;
    }

    ll m = (tl + tr) / 2;

    if (pos <= m) {
        update(2 * v, tl, m, pos, val);
    } else {
        update(2 * v + 1, m + 1, tr, pos, val);
    }
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int main() {
    //cout << fixed << setprecision(30);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> T;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    if (n == 1) {
        cout << 0 << endl;
        if (T == 1) {
            cout << a[1] << endl;
        }
        return 0;
    }

    flag[1] = 1;
    flag[n] = 1;
    cnt = 2;

    while(cnt != n) {
        ll cch = 0;
        vector <pair <ll, ll>> els, upd;

        for (int i = 1; i <= n; i++) {
            if (!flag[i]) {
                els.pb({a[i], i});
            }
        }

        sort(els.rbegin(), els.rend());

        for (auto i : els) {
            ll mv = i.ff;
            ll mp = i.ss;
            if (a[mp] == a[mp - 1]) {
                cnt += 1 - flag[mp];
                cnt += 1 - flag[mp - 1];
                cch += 1 - flag[mp] + 1 - flag[mp - 1];
                flag[mp] = 1;
                flag[mp - 1] = 1;
            }
            if (a[mp] == a[mp + 1]) {
                cnt += 1 - flag[mp];
                cnt += 1 - flag[mp + 1];
                cch += 1 - flag[mp] + 1 - flag[mp + 1];
                flag[mp] = 1;
                flag[mp + 1] = 1;
            }
            vector <ll> tmp = {a[mp - 1], a[mp], a[mp + 1]};
            sort(tmp.begin(), tmp.end());
            if (a[mp] != tmp[1]) {
                upd.pb({mp, tmp[1]});
            }
        }

        for (auto i : upd) {
            a[i.ff] = i.ss;
        }

        if (upd.size() == 0) break;
        ans++;
    }

    cout << ans << endl;

    if (T == 1) {
        for (int i = 1; i <= n; i++) {
            cout << a[i] << " ";
        }
        cout << endl;
    }
    return 0;
}