#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define eb emplace_back

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

#define SecondGroup true

void solve() {
    ll n, t;
    cin >> n >> t;
    vector<ll> a(n + 2);
    for (ll i = 1; i <= n; i++) cin >> a[i];
    a[0] = a[1];
    a[n + 1] = a[n];
    if (all_of(all(a), [](ll a) { return a <= 2; }) && SecondGroup) {
        ll cnt = 0;
////#ifndef Debug
//        for (ll i = 0; i < 10; i++) {
//            bool flag = false;
//            vector<ll> na(all(a));
//            for (ll i = 1; i < a.size() - 1; i++) {
//                if (a[i] > max(a[i - 1], a[i + 1])) {
//                    flag = true;
//                    na[i] = max(a[i - 1], a[i + 1]);
//                }
//                if (a[i] < min(a[i - 1], a[i + 1])) {
//                    flag = true;
//                    na[i] = min(a[i - 1], a[i + 1]);
//                }
//            }
//            swap(a, na);
//            cnt += ll(flag);
//        }
////#endif
        ll cntAdd = 0;
        vector<vector<ll>> part{{-1}};
        for (ll i = 1; i < a.size(); i++) {
            if (a[i] == a[i - 1]) {
                if (part.back().size() == 1) {
                    part.back().back() = i;
                } else if (part.back().size() > 1) {
                    part.eb(vector<ll>{i});
                }
            } else {
                part.back().pb(i);
            }
        }
        while (part.back().size() == 1) part.pop_back();
        if (!part.empty()) {
            forEach(part) {
                if (it.size() <= 2) continue;
                if (a[it.front()] == a[it.back()]) {
                    chMax(cntAdd, (ll)it.size() / 2);
                    for (ll i = it.front(); i <= it.back(); i++) {
                        a[i] = a[it.front()];
                    }
                } else {
                    chMax(cntAdd, (ll)it.size() / 2);
                    for (ll i = it.front(); i <= (it.front() + it.back()) / 2; i++) {
                        a[i] = a[it.front()];
                    }
                    for (ll i = (it.front() + it.back()) / 2 + 1; i <= it.back(); i++) {
                        a[i] = a[it.back()];
                    }
                }
            }
        }
        cout << cnt + cntAdd << "\n";
        if (t) {
            for (ll i = 1; i <= n; i++) cout << a[i] << " ";
        }
    } else {
        bool flag = true;
        ll cnt = 0;
        while (flag) {
            flag = false;
            vector<ll> na(all(a));
            for (ll i = 1; i < a.size() - 1; i++) {
                if (a[i] > max(a[i - 1], a[i + 1])) {
                    flag = true;
                    na[i] = max(a[i - 1], a[i + 1]);
                }
                if (a[i] < min(a[i - 1], a[i + 1])) {
                    flag = true;
                    na[i] = min(a[i - 1], a[i + 1]);
                }
            }
            swap(a, na);
            cnt += ll(flag);
        }

        cout << cnt << "\n";
        if (t == 1) {
            for (ll i = 1; i <= n; i++) cout << a[i] << " ";
        }
    }
}
#ifdef Debug
#define Search
#endif

int main() {
    FASTIO
#ifdef Search
    freopen("A.in", "r", stdin);
#endif
    solve();
    return 0;
}