#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 5e5 + 7;

int n, t;
int a[N];
int ans = 0;

void solve12() {
	vector<bool> fxd;
	fxd.assign(n, false);
	vector<int>sa(n);
	int res = 0;
	fxd[0] = fxd[n - 1] = true;
	sa[0] = a[0]; sa[n - 1] = a[n - 1];
	for (int i = 1; i < n; i++) {
		if (a[i] == a[i - 1]) {
			fxd[i] = fxd[i - 1] = true;
			sa[i] = sa[i - 1] = a[i];
		}
	}
	for (int i = 0; i < n; i++) {
		if (!fxd[i]) {
			int ind = i;
			while (ind < n && !fxd[ind]) {
				ind++;
			}
			int len = ind - i;
			uax(res, (len + 1) / 2);
			if (sa[i - 1] == sa[ind]) {
				for (int j = i; j < ind; j++) {
					sa[j] = sa[ind];
				}
			}
			else {
				for (int j = i; j < i + len / 2; j++) {
					sa[j] = sa[i - 1];
				}
				for (int j = i + len / 2; j < ind; j++) {
					sa[j] = sa[ind];
				}
			}
			i = ind - 1;
		}
	}
	cout << res << nn;
	if (t == 0) return;
	for (int i = 0; i < n; i++) {
		cout << sa[i] << pp;
	}
}

void slow_solve() {
	vector<int> a(n), b(n);
	for (int i = 0; i < n; i++) {
		a[i] = ::a[i];
	}
	b[0] = a[0];
	b[n - 1] = a[n - 1];
	bool op;
	int tr[3];
	int res = 0;
	while (true) {
		op = false;
		for (int i = 1; i < n - 1; i++) {
			tr[0] = a[i - 1];
			tr[1] = a[i];
			tr[2] = a[i + 1];
			sort(tr, tr + 3);
			b[i] = tr[1];
			if (b[i] != a[i]) op = true;
		}
		if (!op) break;
		swap(a, b);
		res++;
	}
	cout << res << nn;
	if (t == 0) return;
	for (int i = 0; i < n; i++) {
		cout << a[i] << pp;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n >> t;
	bool A12 = true;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] > 2) A12 = false;
	}
	if (A12) {
		solve12();
		exit(0);
	}
	slow_solve();
	exit(0);
}