#include <iostream>
#include <cstdint>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <vector>

int main() {
    int32_t n, t;
    std::cin >> n >> t;

    int32_t* state = new int32_t[n];
    for(int32_t i  = 0; i < n; i++) {
        std::cin >> state[i];
    }

    bool one_two = true;
    for(int32_t  i = 0 ; i < n; i++) {
        if(state[i] > 2)
            one_two = false;
    }

    if(n <= 1000 && !one_two) {
        int32_t *new_state = new int32_t[n];
        int32_t answer = 0;
        bool modified = true;
        while (modified) {
            modified = false;
            new_state[0] = state[0];
            new_state[n - 1] = state[n - 1];
            for (int32_t i = 1; i < n - 1; i++) {
                int32_t a = state[i - 1], b = state[i], c = state[i + 1];
                if (a > b) {
                    int32_t tmp = a;
                    a = b;
                    b = tmp;
                }
                if (b > c) {
                    int32_t tmp = b;
                    b = c;
                    c = tmp;
                }
                if (a > b) {
                    int32_t tmp = a;
                    a = b;
                    b = tmp;
                }
                new_state[i] = b;
                if (state[i] != new_state[i])
                    modified = true;
            }
            for (int32_t i = 0; i < n; i++)
                state[i] = new_state[i];
            answer++;
        }

        std::cout << answer - 1 << "\n";
        if (t == 1)
            for (int32_t i = 0; i < n; i++)
                std::cout << state[i] << " ";
        return 0;
    }

    int32_t* state_new = new int32_t[n];
    state_new[0] = state[0];
    state_new[n - 1] = state[n - 1];

    int32_t length_cur = 1;
    int32_t answer = 0;
    for(int32_t i = 1 ; i < n; i++) {
        if(state[i] == state[i - 1]) {
            answer = std::max(answer, (length_cur - 1) / 2);
            if(length_cur % 2 == 1)
                for(int32_t j = i - 1; j >= i - length_cur; j--)
                    state_new[j] = state[i];
            else {
                for(int32_t j = i - 1; j >= i - length_cur / 2; j--)
                    state_new[j] = state[i];
                for(int32_t j = i - length_cur; j < i - length_cur / 2; j++)
                    state_new[j] = state[i - length_cur];
            }
            length_cur = 1;
            continue;
        }
        length_cur++;
    }
    answer = std::max(answer, (length_cur - 1) / 2);
    if(length_cur % 2 == 1)
        for(int32_t j = n - 1; j >= n - length_cur; j--)
            state_new[j] = state[n - 1];
    else {
        for(int32_t j = n - 1; j >= n - length_cur / 2; j--)
            state_new[j] = state[n - 1];
        for(int32_t j = n - length_cur; j < n - length_cur / 2; j++)
            state_new[j] = state[n - length_cur];
    }

    std::cout << answer << "\n";
    if(t == 1)
        for(int32_t i = 0 ; i < n; i++)
            std::cout << state_new[i] << " ";
    return 0;
}