#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e5 + 5;

pair<int, vector<int>> find_ans(vector<int> mas) {
    int n = sz(mas);
    vector<int> cpy(n);
    int ans = 0;
    while (true) {
        bool go = false;
        for (int i = 0; i < n; ++i) {
            if (i == 0 || i == n - 1) {
                cpy[i] = mas[i];
            } else {
                vector<int> curr = {mas[i - 1], mas[i], mas[i + 1]};
                sort(all(curr));
                cpy[i] = curr[1];
            }
            if (mas[i] != cpy[i]) {
                go = true;
            }
        }
        if (go) {
            ++ans;
            for (int i = 0; i < n; ++i) {
                mas[i] = cpy[i];
            }
        } else {
            break;
        }
    }
    return mp(ans, mas);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, type;
    cin >> n >> type;
    vector<int> a(n);
    bool flag2 = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] > 2) {
            flag2 = false;
        }
    }
    if (flag2) {
        vector<vector<int>> groups;
        groups.pb(vector<int>());
        for (int i = 0; i < n; ++i) {
            if (i && a[i] == a[i - 1]) {
                groups.pb(vector<int>());
            }
            groups.back().pb(i);
        }
        int ans = 0;
        for (auto &group : groups) {
            if (sz(group) < 3) {
                continue;
            }
            if (a[group[0]] == a[group.back()]) {
                ans = max(ans, sz(group) / 2);
                for (int &i : group) {
                    a[i] = a[group[0]];
                }
            } else {
                ans = max(ans, sz(group) / 2 - 1);
                for (int i = 0; i < sz(group) / 2; ++i) {
                    a[group[i]] = a[group[0]];
                }
                for (int i = sz(group) / 2; i < sz(group); ++i) {
                    a[group[i]] = a[group.back()];
                }
            }
        }
        cout << ans << "\n";
        if (type) {
            for (int i = 0; i < n; ++i) {
                cout << a[i] << " ";
            }
            cout << "\n";
        }
        return 0;
    }
    auto answ = find_ans(a);
    cout << answ.x << "\n";
    if (type) {
        for (int i = 0; i < n; ++i) {
            cout << answ.y[i] << " ";
        }
        cout << "\n";
    }

    return 0;
}
