#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 5e5 + 5;
int n, t;
int a[MAXN];
int b[MAXN];

void sol() {
    rep(iter, n + 2) {
        bool ok = false;
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        for (int i = 1; i + 1 < n; ++i) {
            int mn = min(a[i - 1], min(a[i], a[i + 1]));
            int mx = max(a[i - 1], max(a[i], a[i + 1]));
            b[i] = a[i - 1] + a[i] + a[i + 1] - mn - mx;
        }
        rep(i, n) {
            if (a[i] != b[i]) {
                ok = true;
            }
            a[i] = b[i];
        }
        // cout << iter + 1 << " : ";
        // rep(i, n) {
        //     cout << a[i] << ' ';
        // }
        // cout << endl;
        if (!ok) {
            cout << iter << endl;
            if (t) {
                rep(i, n) {
                    cout << a[i] << ' ';
                }
                cout << endl;
            }
            exit(0);
        }
    }
    assert(false);
    exit(1);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> t;
    rep(i, n) {
        cin >> a[i];
        if (a[i] > 2) {
            sol();
            exit(0);
        }
    }

    int res = 0;
    int pos = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i] == a[i + 1] || i + 1 == n) {
            b[i] = a[i];
            if (pos == -1) {
                b[i] = a[i];
                continue;
            }

            // seg [pos, i]

            // cout << "seg " << pos << ' ' << i << endl;

            int len = (i - pos - 1);
            res = max(res, (len + 1) / 2);

            if (a[pos] == a[i]) {
                for (int j = pos + 1; j < i; ++j) {
                    b[j] = a[i];
                }
            } else {
                for (int j = 0; j < len / 2; ++j) {
                    b[pos + 1 + j] = a[pos];
                }
                for (int j = len / 2; j < len; ++j) {
                    b[pos + 1 + j] = a[i];
                }
            }

            pos = -1;
        } else {
            if (pos == -1) {
                b[i] = a[i];
                pos = i;
            }
        }
    }

    cout << res << endl;
    if (t) {
        rep(i, n) {
            cout << b[i] << ' ';
        }
        cout << endl;
    }
}
