#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;

#define size(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    int n, t;
    vector<int> a;
    unordered_set<int> peaks;

    void solve_other() {
        for (int i = 0; i < n; i++) {
            if (i > 0 && i < n - 1) {
                peaks.insert(i);
            }
        }
        int ans = 0;
        bool f = 1;
        while (f) {
            f = 0;
            vector<int> b(n);
            for (int i = 0; i < n; i++) {
                b[i] = a[i];
            }
            unordered_set<int> new_peaks;
            for (auto i : peaks) {
                int l = a[i - 1], r = a[i + 1], m = a[i];
                if (l >= m) {
                    swap(l, m);
                }
                if (l >= r) {
                    swap(l, r);
                }
                if (m >= r) {
                    swap(m, r);
                }
                b[i] = m;
                if (b[i] != a[i]) {
                    new_peaks.insert(i);
                    if (i - 1 > 0) {
                        new_peaks.insert(i - 1);
                    }
                    if (i + 1 < n - 1) {
                        new_peaks.insert(i + 1);
                    }
                    f = 1;
                }
            }
            swap(a, b);
            swap(peaks, new_peaks);
            ans++;
        }
        cout << ans - 1 << "\n";
        if (t) {
            for (auto v : a) {
                cout << v << " ";
            }
        }
    }

    inline int median(int l, int m, int r) {
        if (l >= m) {
            swap(l, m);
        }
        if (l >= r) {
            swap(l, r);
        }
        if (m >= r) {
            swap(m, r);
        }
        return m;
    }

    int solve_kek(int l, int r) {
        int ret = 0;
        for (int i = l + 1; i < r; i++) {
            if (a[i] != median(a[i - 1], a[i], a[i + 1])) {
                ret = 1;
            }
            a[i] = median(a[i - 1], a[i], a[i + 1]);
        }
        return ret;
    }

    int solve_pairity(int l, int r) {
        int len = (r - l) / 2;
        if ((a[l] & 1) != (a[r] & 1)) {
            for (int i = l; i <= l + len; i++) {
                a[i] = a[l];
            }
            for (int i = r; i >= r - len; i--) {
                a[i] = a[r];
            }
        } else {
            for (int i = l; i <= r; i++) {
                a[i] = a[l];
            }
        }
        return len;
    }

    void solve_subtask2() {
        int l = 0;
        int ans = 0;
        a.push_back(a.back());
        vector<int> last;
        for (int i = 1; i < size(a); i++) {
            last.push_back(a[i]);
            if (size(last) > 2 && last.back() != last[size(last) - 3]) {
                if (size(last) == 3) {
                    ans = max(ans, solve_kek(l, i - 1));
                } else {
                    ans = max(ans, solve_pairity(l, i - 1));
                }
                last.clear();
                last.push_back(a[i]);
                l = i;
            }
        }
        cout << ans << "\n";
        if (t) {
            for (int i = 0; i < n; i++) {
                cout << a[i] << " ";
            }
        }
    }

    void solve() {
        cin >> n >> t;
        a.resize(n);
        int mx = 0;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            mx = max(mx, a[i]);
        }
        if (mx <= 2) {
            solve_subtask2();
            return;
        } else {
            solve_other();
        }
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
