#include<iostream>
#include<vector>
#include<random>
#include<algorithm>

using namespace std;

const int MAXN = 5e5 + 5;

int n, T;
int a[MAXN], b[MAXN];

int median(int a, int b, int c)
{
    vector <int> v = {a, b, c};
    sort(v.begin(), v.end());

    return v[1];
}

bool isReady()
{
    for(int i = 1;i<n-1;i++)
    {
        if(median(a[i-1], a[i], a[i+1])!=a[i]) return false;
    }

    return true;
}

void slowSolve()
{
    int c = 0;
    int indL = 1, indR = n - 2;

    while(isReady()==false)
    {
        c++;
        for(int i = indL;i<=min(indR, indL+55);i++)
        {
            b[i] = median(a[i-1], a[i], a[i+1]);
        }

        while(indL<n-1 && a[indL+1]==b[indL+1]) indL++;
        while(indR>0 && a[indR-1]==b[indR-1]) indR--;

        for(int i = indL;i<=indR;i++)
        {
            a[i] = b[i];
        }

        //for(int i = 0;i<n;i++)
        //    cout << a[i] << " ";
        //cout << '\n';
    }

    cout << c << '\n';
    if(T!=0)
    {
        cout << a[0];
        for(int i = 1;i<n;i++)
        {
            cout << " " << a[i];
        }
        cout << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> T;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i];
        //a[i] = rand()%123;
    }

    slowSolve();
}
