#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)

int median(int a, int b, int c) {
	if (a >= min(b, c) && a <= max(b, c))return a;
	if (b >= min(a, c) && b <= max(a, c))return b;
	if (c >= min(a, b) && c <= max(a, b))return c;
}

void solve(int n, int t, vector<int> a) {
	int ans = 0;
	while (true) {
		vector<int> b = a;
		bool change = false;
		for (int i = 1; i < n - 1; i++) {
			b[i] = median(a[i - 1], a[i], a[i + 1]);
			if (b[i] != a[i])change = true;
		}
		a = b;
		if (!change) {
			cout << ans << "\n";
			if (t) {
				for (auto i : a) {
					cout << i << " ";
				}
			}
			return;
		}
		ans++;
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	int mm = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mm = max(mm, a[i]);
	}
	if (mm > 2 || n <= 1000) {
		solve(n, t, a);
		return 0;
	}
	vector<int> stay(n);
	stay[0] = 1;
	stay[n - 1] = 1;
	for (int i = 1; i < n - 1; i++) {
		if (a[i] == a[i - 1] || a[i] == a[i + 1])stay[i] = 1;
	}
	int i = 1;
	vector<int> res = a;
	int ans = 0;
	while (i < n) {
		if (stay[i] == 0) {
			int j = i;
			while (stay[i] == 0)i++;
			i--;
			if (a[j - 1] == a[i + 1]) {
				for (int k = j; k <= i; k++)res[k] = a[i + 1];
				ans = max(ans, (i - j + 2) / 2);
			}
			else {
				int cnt1 = 0, cnt2 = 0;
				for (int k = j; k <= i; k++) {
					if (a[k] == 1)cnt1++;
					else cnt2++;
				}
				ans = max(ans, (cnt1 + cnt2) / 2);
				if (a[j - 1] > a[i + 1]) {
					for (int k = j; k < j + cnt2; k++) {
						res[k] = 2;
					}
					for (int k = j + cnt2; k <= i; k++)res[k] = 2;
				}
				else {
					for (int k = j; k < j + cnt1; k++) {
						res[k] = 1;
					}
					for (int k = j + cnt1; k <= i; k++)res[k] = 2;
				}
			}
		}
		i++;
	}
	cout << ans << "\n";
	if (t)for (auto i : res)cout << i << " ";
}