#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int med(int a, int b, int c) {
    return a + b + c - min({a, b, c}) - max({a, b, c});
}

int main() {
    int n, t;
    cin >> n >> t;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    bool is_24 = true;
    for (int i : line) {
        if (i > 2)
            is_24 = false;
    }

    if (is_24) {
        int ans = 0;
        set <int> con = {0, n - 1};
        for (int i = 1; i < n - 1; i++) {
            if (line[i] == line[i - 1] || line[i] == line[i + 1])
                con.insert(i);
        }
        for (int i = 0; i < n; i++) {
            if (con.count(i))
                continue;
            auto it = con.upper_bound(i);
            auto lo = it;
            lo--;
            if (i - *lo < *it - i) {
                line[i] = line[*lo];
            } else {
                line[i] = line[*it];
            }
            ans = max(ans, min(i - *lo, *it - i));
        }
        cout << ans << endl;
        if (t == 1) {
            for (int i : line)
                cout << i << " ";
            cout << endl;
        }
        return 0;
    }

    bool chan = true;
    int c = 0;
    while (chan) {
        chan = false;
        vector <int> new_line = line;
        for (int i = 1; i < n - 1; i++) {
            new_line[i] = med(line[i - 1], line[i], line[i + 1]);
            if (new_line[i] != line[i])
                chan = true;
        }
        if (chan)
            c++;
        line = new_line;
    }

    cout << c << endl;
    if (t == 1) {
        for (int i : line)
            cout << i << " ";
        cout << endl;
    }
    return 0;
}
