#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define pb push_back
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(i, a.size()) cout << a[i] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x
#define ff first
#define ss second
#define sz(a) (a).size()

typedef long long ll;
typedef long double ld;

#define int ll

const int mod = 1e9 + 7;

bool check(vi & a) {
    int n = sz(a);
    fori(i, 1, n - 1) {
        if (a[i] > a[i - 1] && a[i] > a[i + 1])
            return 0;
        if (a[i] < a[i - 1] && a[i] < a[i + 1])
            return 0;
    }
    return 1;
}

int med(int a, int b, int c) {
    vector <int> kek = { a, b, c };
    mbort(kek);
    return kek[1];
}

void run() {
    int n, t;
    cin >> n >> t;
    vi a(n);
    cinm(a);
    if (n <= 1) {
        int ans = 0;
        while (!check(a)) {
            ++ans;
            vector <int> b = a;
            fori(i, 1, n - 1) {
                if (a[i] > b[i - 1] && a[i] > b[i + 1])
                    a[i] = max(b[i - 1], b[i + 1]);
                if (a[i] < b[i - 1] && a[i] < b[i + 1])
                    a[i] = min(b[i - 1], b[i + 1]);
            }
        }
        cout << ans << '\n';
        if (t)
            coutm(a);
    }
    else {
        int ans = 0;
        int prevUP = -1;
        int tcntUP = 0;
        int lastUP = -1;
        int tcntDOWN = 0;
        int prevDOWN = -1;
        int lastDOWN = -1;
        fori(i, 1, n - 1) {
            if ((lastUP == i - 2 || lastUP == -1)) {
                if (a[i] > a[i - 1] && a[i] > a[i + 1] && (prevUP == -1 || a[i - 2] < med(a[i - 2], a[i - 1], a[i]) && med(a[i - 2], a[i - 1], a[i]) > max(a[i + 1], a[i - 1]))) {
                    tcntUP++;
                    lastUP = i;
                    prevUP = max(a[i + 1], a[i - 1]);

                } else {
                    tcntUP = 0;
                    prevUP = -1;
                }
            }
            else if(lastUP != i - 1) {
                tcntUP = 0;
                prevUP = -1;
            }

            if ((lastDOWN == i - 2 || lastDOWN == -1)) {
                if (a[i] < a[i - 1] && a[i] < a[i + 1] && (prevDOWN == -1 || a[i - 2] > med(a[i - 2], a[i - 1], a[i]) && med(a[i - 2], a[i - 1], a[i]) < min(a[i + 1], a[i - 1]))) {
                    tcntDOWN++;
                    lastDOWN = i;
                    prevDOWN = min(a[i + 1], a[i - 1]);
                } else {
                    tcntDOWN = 0;
                    prevDOWN = -1;
                }
            } else if (lastDOWN != i - 1) {
                tcntDOWN = 0;
                prevDOWN = -1;
            }

            ans = max(max(tcntUP, tcntDOWN), ans);
        }
        cout << ans;
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
    return 0;
}
