#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//
/*
	1) Если мы сможем предугадывать как посмтроиться гора через -c- изменений
		то мы сможем бинпоиском найти ответ за nlogn
	2) Решим для a <= 2
	3) 1 2 1 2 1 -> 1 1 1 1 1 за 2 года
	4) 2 2 1 2 1 2 2 1 
	5) Если график гор четный и левая и правая граница отличаетя(1 и 2), то половина где 1 считаем количество 2
		, а где половина 2 считаем количество 1
*/

int midian(int a, int b, int c)
{
	if (a > b&& a > c)
	{
		if (b > c)
			return b;
		else
			return c;
	} else
		if (a < b && a < c)
		{
			if (b > c)
				return c;
			else
				return b;
		} else
			return a;
}
const int N = 500001;
vector<int> ans;
int calc(vector<int>& v, int idx, int i)
{
	int fi = 2 - v[idx - 1] + 1;
	int cnt1 = 0;
	for (int j = idx; j <= (i + idx) / 2; ++j)
	{
		if (ans[j] == fi)
			++cnt1;
		ans[j] = 2 - fi + 1;
	}
	fi = 2 - v[i + 1] + 1;
	int cnt2 = 0;
	for (int j = i; j > (i + idx) / 2; --j)
	{
		if (ans[j] == fi)
			++cnt2;
		ans[j] = 2 - fi + 1;
	}
	return  cnt1 + cnt2 - ((v[idx - 1] != v[i + 1]) ? 1 : 0);
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	int n, t;
	cin >> n >> t;

	vector<int> v(n);
	ans.resize(n);
	int maxi = 0;
	for (int i = 0; i < n; ++i)
		cin >> v[i], maxi = max(maxi, v[i]);
	ans = v;
	bool flag = true;
	int cnt = 0;
	vector<int> star(n);
	for (int i = 0; i < n; ++i)
		star[i] = v[i];

	if (maxi > 2)
	{
		while (flag)
		{
			flag = false;

			for (int i = 1; i < n - 1; ++i)
			{
				int mid = midian(star[i - 1], star[i], star[i + 1]);
				if (v[i] != mid)
					v[i] = mid, flag = true;
			}
			for (int i = 0; i < n; ++i)
				star[i] = v[i];
			if (flag)
				++cnt;
			//for (auto& u : v)
			//	cout << u << ' ';
			//cout << nl;
		}
		cout << cnt << nl;
		if (t)
			for (int i = 0; i < n; ++i)
				cout << v[i] << ' ';
	}
	else
	{
		bool flag = false;
		int pred = v[0];
		int idx = -1;
		for (int i = 1; i < n; ++i)
		{
			if (pred != v[i])
			{
				if (!flag)
				{
					idx = i;
					flag = true;
				}
			}
			else
				if (flag)
				{
					cnt = max(cnt, calc(v, idx + 1, i - 1));
					flag = false;
				}
			pred = v[i];
			
		}

		if (flag)
		{
			int i = n - 1;
			
			cnt = max(cnt, calc(v, idx + 1, i - 1));
			flag = false;
			
		}

		cout << cnt << nl;

		if (t)
			for (auto& u : ans)
				cout << u << ' ';
	}
	return 0;
}