#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 524288;

int a[2][MAX_N];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i)
		cin >> a[0][i];
	for (int i = n; i < n + 16; ++i)
		a[0][i] = a[0][n - 1];
	int from = 0, to = 1;
	int ans = 0;
	while (1) {
		for (int j = 1; j < n - 1; j += 8) {
			__m256i prev = _mm256_loadu_si256((__m256i*) (a[from] + j - 1));
			__m256i curr = _mm256_loadu_si256((__m256i*) (a[from] + j));
			__m256i next = _mm256_loadu_si256((__m256i*) (a[from] + j + 1));
			__m256i summ = _mm256_add_epi32(_mm256_add_epi32(prev, curr), next);
			__m256i minn = _mm256_min_epi32(_mm256_min_epi32(prev, curr), next);
			__m256i maxn = _mm256_max_epi32(_mm256_max_epi32(prev, curr), next);
			__m256i res = _mm256_sub_epi32(summ, _mm256_add_epi32(minn, maxn));
			_mm256_storeu_si256((__m256i*) (a[to] + j), res);
		}
		a[to][0] = a[from][0];
		a[to][n - 1] = a[from][n - 1];
		bool finish = 1;
		for (int i = 0; i < n; ++i)
			if (a[to][i] != a[from][i])
				finish = 0;
		if (finish)
			break;
		++ans;
		from = to;
		to = 1 - from;
	}
	cout << ans << "\n";
	if (t) {
		for (int i = 0; i < n; ++i)
			cout << a[from][i] << " ";
		cout << "\n";
	}
	return 0;
}