#include <iostream>
#include <algorithm>
#include <cstdint>
#include <vector>
using namespace std;

vector<uint32_t> c[2];

uint16_t t;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n>>t;

    //if(n>1000)

    c[0].resize(n);
    c[1].resize(n);

    for(uint32_t i=0; i<n; i++)
        cin>>c[0][i];
}

uint32_t median (uint32_t a, uint32_t b, uint32_t c)
{
    uint32_t tmp[]={a, b, c};
    sort(tmp, tmp+3);
    return tmp[1];
}

void process (const vector<uint32_t> &oldp, vector<uint32_t> &newp)
{
    newp[0]=oldp[0];
    for(uint32_t i=1; i<oldp.size()-1; i++)
        newp[i]=median(oldp[i-1], oldp[i], oldp[i+1]);
    newp.back()=oldp.back();
}

int main()
{
    init();

    uint32_t res=0;
    uint32_t newi=1;

    while(true)
    {
        process(c[newi^1], c[newi]);
        if(c[newi^1]!=c[newi])
        {
            newi=newi^1;
            res++;
        }
        else
            break;
    }

    cout<<res<<'\n';
    if(t)
    {
        for(uint32_t i=0; i<c[0].size(); i++)
            cout<<c[0][i]<<' ';
        cout<<endl;
    }


    return 0;
}