#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    auto median = [&](ll x, ll y, ll z) {
        vector<ll> a{x, y, z};
        sort(a.begin(), a.end());
        return a[1];
    };
    ll n, t;
    cin >> n >> t;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll o = 0;
    while (true) {
        vector<ll> c = a;
        for (ll i = 1; i < n - 1; i++) {
            c[i] = median(a[i - 1], a[i], a[i + 1]);
        }
        if (c == a) {
            break;
        }
        a = c;
        o++;
    }
    cout << o << endl;
    if (t) {
        for (ll i : a) {
            cout << i << " ";
        }
        cout << endl;
    }
    return 0;
}
