#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 500000 + 50;

int a[N], b[N], dist[N], ms[3], n, t, ans = 0;
bool fx[N];

inline int med(int x, int y, int z) {
    if (y >= x && y >= z)
        return max(x, z);
    if (z >= x && z >= y)
        return max(x, y);
    return max(y, z);
}

signed main()
{
    fast_io;

    ifstream cin("input.txt");
    ofstream cout("output.txt");

    cin >> n >> t;
    int mxai = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        mxai = max(mxai, a[i]);
    }

    vector<int> cur;

    fx[0] = fx[n - 1] = true;
    for (int i = 1; i < n - 1; i++) {
        if (a[i] == med(a[i], a[i - 1], a[i + 1]))
            fx[i] = true;
        else
            cur.pb(i);
    }

    if (mxai <= 2) {
        int curdist = 1;
        for (int i = 1; i < n - 1; i++) {
            if (fx[i])
                curdist = 0;
            dist[i] = curdist;
            curdist++;
        }
        curdist = 1;
        for (int i = n - 2; i > 0; i--) {
            if (fx[i])
                curdist = 0;
            dist[i] = min(dist[i], curdist);
            ans = max(ans, dist[i]);
            curdist++;
        }

        cout << ans << endl;
        if (t) {
            for (int i = 0; i < n; i++) {
                cout << ((a[i] - 1) ^ (dist[i]&1)) + 1 << " ";
            }
        }
    }

    if (!t) {
        int curdist = 1;
        for (int i = 1; i < n - 1; i++) {
            if (fx[i])
                curdist = 0;
            dist[i] = curdist;
            curdist++;
        }
        curdist = 1;
        for (int i = n - 2; i > 0; i--) {
            if (fx[i])
                curdist = 0;
            dist[i] = min(dist[i], curdist);
            ans = max(ans, dist[i]);
            curdist++;
        }

        cout << ans;
        return 0;
    }

    while(t) {
        bool updated = false;
        for (int i = 0; i < cur.size(); i++) {
            b[cur[i]] = med(a[cur[i] - 1], a[cur[i]], a[cur[i] + 1]);
        }
        for (int i = 0; i < cur.size(); i++) {
            if (b[cur[i]] != a[cur[i]]) {
                a[cur[i]] = b[cur[i]];
                updated = true;
            }
        }
        for (int i = 0; i < cur.size(); i++) {
            if (a[cur[i]] == med(a[cur[i] - 1], a[cur[i]], a[cur[i] + 1])) {
                swap(cur[i], cur.back());
                cur.pop_back();
                i--;
            }
        }

        if (updated)
            ans++;
        else
            break;
    }

    cout << ans << endl;
    if (t) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << " ";
        }
    }
    return 0;
}


/*
7 1
1 2 1 2 1 2 1

*/
