#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)

int get(int a, int b, int c) {
  if (a >= b) swap(a, b);
  if (b >= c) swap(b, c);
  if (a >= b) swap(a, b);
  assert(a <= b);
  assert(b <= c);
  return b;
}

mt19937 gen;

int get(vector<int> a, bool fl = 0) {
  vector<int> cur;
  int n = size(a);
  vector<int> nw(n);
  for(int i = 1; i < n - 1; i++) {
    cur.push_back(i);
  }
  int ans = 0;
  while (!cur.empty()) {
    ++ans;
    for(int i = 0; i < size(cur); i++) {
      int x = cur[i];
      nw[x] = get(a[x - 1], a[x], a[x + 1]);
      if (a[x] == nw[x]) {
        swap(cur.back(), cur[i]);
        cur.pop_back();
        --i;
      }
    }
    for(int x : cur) a[x] = nw[x];
  }
  cout << max(0, ans - 1) << '\n';
  for(int x : a) {
    cout << x << ' ';
  }
  exit(0);
  return max(0, ans - 1);
}

void gene() {
  gen.seed(time(0));
  int n;
  cin >> n;
  vector<int> a(n);
  vector<int> best(n, 1);
  int score = -1;
  for(int i = 0; i < 1e6; i++) {
    for(int &x : a) {
      x = gen() % 10;
    }
    int b = get(a);
    if (b > score)
      best = a, score = b;
  }
  cout << get(best, 1) << '\n';
  exit(0);
}

void run() {
  gen.seed(time(0));
  int n, t;
  cin >> n >> t;
  vector<int> a(n);
  for(int &x : a) cin >> x;
  if (*max_element(all(a)) > 2) {
    get(a);
  }
  vector<int> fl(n);
  for(int i = 1; i + 1 < n; i++) {
    if (a[i] != get(a[i - 1], a[i], a[i + 1]))
      fl[i] = 1;

  }
  int ans = 0;
  vector<int> ret = a;
  for(int i = 0; i < n; i++) {
    if (fl[i]) {
      int j = i;
      while (fl[j]) j++;
      chkmax(ans, (j - i + 1) / 2);
      if ((j - i) % 2 == 0) {
        for(int v = 0; v < (j - i) / 2; v++) {
          ret[i + v] = a[i - 1];
          ret[i + (j - i) / 2 + v] = a[j];
        }
      } else {
        for(int v = i; v < j; v++) {
          ret[v] = a[i - 1];
        }
      }
      i = j;
    }
  }
  cout << ans << '\n';
  if (t) {
    for(int x : ret) {
      cout << x << ' ';
    }
  }
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
// gene();

  run();
}
