#include <bits/stdc++.h>

using namespace std;
using ll = long long;
// #define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
int n;
const int MAXN = 5e5 + 7;
int arr[MAXN];

int solve(){
	int t;
	if (!(cin >> n >> t))
		return 1;
	for (int i = 0; i < n; i++)
		cin >> arr[i];
	vector<pair<int, int>> blocks;
	for (int i = 0; i < n; i++){
		if (!SZ(blocks) || blocks.back().first != arr[i])
			blocks.emplace_back(arr[i], 0);
		blocks.back().second++;
	}
	int start = -1;
	int len = 0;
	int m = SZ(blocks);
	int ans = 0;
	for (int i = 1; i < m; i++){
		if (i + 1 < m && blocks[i].second == 1){
			if (start < 0)
				start = i;
			len++;
		}
		else{
			if (len){
				ans = max((len + 1) / 2, ans);
				for (int j = 0; j < len / 2; j++)
					blocks[j + start].first = blocks[start - 1].first;
				for (int j = len / 2; j < len; j++)
					blocks[j + start].first = blocks[i].first;
			}
			len = 0, start = -1;
		}
	}
	cout << ans << '\n';
	if (t == 1){
		for (auto [x, y] : blocks){
			for (int i = 0; i < y; i++)
				cout << x << ' ';
		}
		cout << '\n';
	}
	return 0;
}
int main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}