#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 5e5 + 10;
int a[N], b[N], used[N], n, timer;
bool safe[N];
int mx[N], mn[N];

int med(int a, int b, int c) {
  if (a > b) {
    swap(a, b);
  }
  if (c < a) {
    return a;
  }
  else if (c < b) {
    return c;
  }
  else {
    return b;
  }
}

bool check() {
  //used = {};
  vector<pair<int, int>> blocks;
  int l = 1;
  for (int i = 2; i <= n; i++) {
    if (a[i] != a[l]) {
      blocks.pb({i - l, a[l]});
      l = i;
    }
  }
  blocks.pb({n + 1 - l, a[l]});
  if (SZ(blocks) == 1) {
    return true;
  }
  for (int i = 1; i + 1 < SZ(blocks); i++) {
    safe[i] = (blocks[i].F > 1);
  }
  safe[0] = safe[SZ(blocks) - 1] = true;
  l = 1;
  while (l < SZ(blocks)) {
    if (safe[l]) {
      l++;
    }
    else {
      int r = l;
      while (!safe[r + 1]) {
        r++;
      }
      mx[r] = mn[r] = blocks[r].S;
      for (int i = r - 1; i >= l; i--) {
        mx[i] = max(mx[i + 1], blocks[i].S);
        mn[i] = min(mn[i + 1], blocks[i].S);
      }
      for (int i = l; i <= r; i++) {
        if (blocks[i].S == mx[i] && blocks[i].S <= blocks[i - 1].S) {
          safe[i] = true;
        }
        else if (blocks[i].S == mn[i] && blocks[i].S >= blocks[i - 1].S) {
          safe[i] = true;
        }
        else {
          break;
        }
      }
      l = r + 1;
    }
  }
  l = SZ(blocks) - 2;
  while (l >= 0) {
    if (safe[l]) {
      l--;
    }
    else {
      int r = l;
      while (!safe[r - 1]) {
        r--;
      }
      mx[r] = mn[r] = blocks[r].S;
      for (int i = r + 1; i <= l; i++) {
        mx[i] = max(mx[i - 1], blocks[i].S);
        mn[i] = min(mn[i - 1], blocks[i].S);
      }
      for (int i = l; i >= r; i--) {
        if (blocks[i].S == mx[i] && blocks[i].S <= blocks[i + 1].S) {
          safe[i] = true;
        }
        else if (blocks[i].S == mn[i] && blocks[i].S >= blocks[i + 1].S) {
          safe[i] = true;
        }
        else {
          break;
        }
      }
      l = r - 1;
    }
  }
  l = 1;
  while (l < SZ(blocks)) {
    if (safe[l]) {
      l++;
    }
    else {
      int r = l;
      while (!safe[r + 1]) {
        r++;
      }
      timer++;
      int cnt = 0;
      for (int i = l; i <= r; i++) {
        if (used[blocks[i].S] < timer) {
          cnt++;
          used[blocks[i].S] = timer;
        }
      }
      if (cnt > 2) {
        return false;
      }
      l = r + 1;
    }
  }
  return true;
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int t;
  cin >> n >> t;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
  }
  int add = 0;
  while (!check()) {
    bool was = false;
    for (int i = 2; i < n; i++) {
      if (a[i] != med(a[i - 1], a[i], a[i + 1])) {
        was = true;
      }
      b[i] = med(a[i - 1], a[i], a[i + 1]);
    }
    if (!was) {
      cout << add << '\n';
      if (t) {
        for (int i = 1; i <= n; i++) {
          cout << a[i] << ' ';
        }
        cout << '\n';
      }
      exit(0);
    }
    add++;
    for (int i = 2; i < n; i++) {
      a[i] = b[i];
    }
    assert(add <= 105);
  }  
  vector<pair<int, int>> blocks;
  int l = 1;
  for (int i = 2; i <= n; i++) {
    if (a[i] != a[l]) {
      blocks.pb({i - l, a[l]});
      l = i;
    }
  }
  blocks.pb({n + 1 - l, a[l]});
  if (SZ(blocks) == 1) {
    cout << add << '\n';
    if (t == 1) {
      for (int i = 1; i <= n; i++) {
        cout << a[i] << ' ';
      }
      cout << '\n';
    }
    exit(0);
  }
  blocks[0].F++;
  blocks.back().F++;
  l = 1;
  int ans = 0;
  vector<pair<int, int>> ans_blocks = {blocks[0]};
  while (l < SZ(blocks)) {
    if (blocks[l].F > 1) {
      ans_blocks.pb(blocks[l]);
      l++;
    }
    else {
      int r = l;
      while (blocks[r + 1].F == 1) {
        r++;
      }
      if (blocks[l - 1].S == blocks[r + 1].S) {
        ans = max(ans, (r - l + 2) / 2);
        ans_blocks.pb(make_pair(r - l + 1, blocks[l - 1].S));
      }
      else {
        ans = max(ans, (r - l + 1) / 2);
        ans_blocks.pb(make_pair((r - l + 1) / 2, blocks[l - 1].S));
        ans_blocks.pb(make_pair((r - l + 1) / 2, blocks[r + 1].S));
      }
      l = r + 1;
    }
  }
  cout << ans + add << '\n';
  ans_blocks[0].F--;
  ans_blocks.back().F--;
  if (t) {
    for (auto it : ans_blocks) {
      for (int i = 0; i < it.F; i++) {
        cout << it.S << ' ';
      }
    }
  }
}