#include <bits/stdc++.h>

#define ft first
#define sc second
// #define int ll
#define len(v) (int)v.size()
#define pb push_back

using namespace std;
typedef long long ll;

set<pair<int, int>> have;
vector<int> p;

int findp(int v) {
	if(p[v] == v) 
		return v;
	p[v] = findp(p[v]);
	return p[v];
}

void merge(int a, int b) {
	a = findp(a), b = findp(b);
	if(a == b) 
		return;
	p[a] = b;
}

int inf = 1e9 + 100;
pair<int, int> get(int now) {
	auto uk = have.upper_bound({now, inf});
	uk--;
	auto ans = *uk;
	have.erase(ans);
	return ans;
}

signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, t;
	cin >> n >> t;
	if(t == 1) {
		vector<int> a(n);
		for (int i = 0; i < n; i++) 
			cin >> a[i];
		if(n < 3) {
			cout << 0 << endl;
			if(t == 1) {
				for (auto x : a) 
					cout << x << " ";
			}
			return 0;
		}
		if(n <= 1000) {
			int answ = 0;
			while(1) {
				vector<int> b(n);
				b[0] = a[0], b[n - 1] = a[n - 1];
				for (int i = 1; i < n - 1; i++) {
					vector<int> neww = {a[i - 1], a[i], a[i + 1]};
					sort(neww.begin(), neww.end());
					b[i] = neww[1];
				}
				if(a == b) 
					break;
				answ++;
				a = b;
			}
			cout << answ << endl;
			if(t != 0) {
				for (auto x : a) 
					cout << x << " ";
			}
			return 0;
		}
		int answ = 0;
		vector<int> ans(n, -1);
		ans[0] = a[0], ans[n - 1] = a[n - 1];

		for (int k = 100; k >= 0; k--) {
			vector<int> b(n);
			for (int i = 0; i < n; i++) {
				if(a[i] >= k) 
					b[i] = 2;
				else
					b[i] = 1;
			}
			int lst = 0;
			for (int i = 1; i < n; i++) {
				if(b[i] == b[i - 1]) {
					for (int j = lst; j <= i - 1; j++) {
						if(ans[j] != -1) 
							continue;
						if((j - lst) <= (i - 1 - j) && b[lst] == 2) 
							ans[j] = k;
						if((j - lst) > (i - 1 - j) && b[i - 1] == 2) 
							ans[j] = k;
					}
					lst = i;
				}
				answ = max(answ, (i - lst) / 2);
			}
			for (int j = lst; j <= n - 1; j++) {
				if(ans[j] != -1) 
					continue;
				if((j - lst) <= (n - 1 - j) && b[lst] == 2) 
					ans[j] = k;
				if((j - lst) > (n - 1 - j) && b[n - 1] == 2) 
					ans[j] = k;
			}
		}
		cout << answ << endl;
		if(t == 1) {
			for (int i = 0; i < n; i++) {
				cout << ans[i] << " ";
			}
		}
		return 0;
	}
	vector<int> a(n);
	for (int i = 0; i < n; i++) 
		cin >> a[i];
	if(n < 3) {
		cout << 0 << endl;
		if(t == 1) {
			for (auto x : a) 
				cout << x << " ";
		}
		return 0;
	}

	vector<int> ans(n, -1);
	p = vector<int> (n + 1, 0);
	for (int i = 0; i <= n; i++) {
		p[i] = i;
	}
	merge(0, 1);
	merge(n - 1, n);
	ans[0] = a[0], ans[n - 1] = a[n - 1];

	int answ = 0;
	map<int, vector<int>> hz;
	vector<int> b(n);
	int minn = 1e9 + 100;
	for (int i = 0; i < n; i++) {
		minn = min(minn, a[i]);
		hz[-a[i]].pb(i);
		b[i] = 1;
		have.insert({i, i});
	}

	for (auto aaa : hz) {
		// set<pair<int, int>> add;
		for (auto now : aaa.sc) {
			auto otrn = get(now);
			// cout << "- " << otrn.ft << " " << otrn.sc << endl;
			if(now > 0 && b[now - 1] == 2) {
				pair<int, int> otr1 = {otrn.ft, now - 1};
				otrn = {now, otrn.sc};
				// add.insert(otr1);
				// cout << "+ " << otr1.ft << " " << otr1.sc << endl;
				have.insert(otr1);
			}
			if(now < n - 1 && b[now + 1] == 2) {
				pair<int, int> otr1 = {now + 1, otrn.sc};
				otrn = {otrn.ft, now};
				// add.insert(otr1);
				// cout << "+ " << otr1.ft << " " << otr1.sc << endl;
				have.insert(otr1);
			}
			// cout << "+ " << otrn.ft << " " << otrn.sc << endl;
		}
		for (auto now : aaa.sc) 
			b[now] = 2;
		
		for (auto now : aaa.sc) {
			pair<int, int> otrn = {now, now};
			if(now > 0 && b[now - 1] == 1) {
				auto otr1 = get(now - 1);
				// add.erase(otr1);
				otrn = {otr1.ft, otrn.sc};
			}
			if(now < n - 1 && b[now + 1] == 1) {
				auto otr1 = get(now + 1);
				// add.erase(otr1);
				otrn = {otrn.ft, otr1.sc};
			}
			answ = max(answ, (otrn.sc - otrn.ft) / 2);
			// add.insert(otrn);
			have.insert(otrn);
		}
		// for (auto otrn: add) {
		// 	// cout << aaa.ft << "  " << otrn.ft << " " << otrn.sc << " " << b[otrn.ft] << " " << b[otrn.sc] << endl;
		// 	if(b[otrn.ft] == 2) {
		// 		int uk = otrn.ft;
		// 		while(1) {
		// 			uk = findp(uk);
		// 			if(uk > (otrn.ft + otrn.sc) / 2)
		// 				break;
		// 			if(ans[uk] != -1) {
		// 				merge(uk, uk + 1);
		// 				uk++;
		// 				continue;
		// 			}
		// 			ans[uk] = -aaa.ft;
		// 			merge(uk, uk + 1);
		// 			// cout << uk << " " << ans[uk] << endl;
		// 			uk++;
		// 			continue;
		// 		}
		// 	}
		// 	if(b[otrn.sc] == 2) {
		// 		int uk = (otrn.ft + otrn.sc) / 2 + 1;
		// 		while(1) {
		// 			uk = findp(uk);
		// 			if(uk > otrn.sc) {
		// 				break;
		// 			}
		// 			if(ans[uk] != -1) {
		// 				merge(uk, uk + 1);
		// 				uk++;
		// 				continue;
		// 			}
		// 			ans[uk] = -aaa.ft;
		// 			// cout << uk << " " << ans[uk] << endl;
		// 			merge(uk, uk + 1);
		// 			uk++;
		// 			continue;
		// 		}
		// 	}
		// }
	}
	for (int i = 0; i < n; i++) {
		if(ans[i] == -1) 
			ans[i] = minn;
	}
	cout << answ << endl;
	// if(t == 1) {
	// 	for (int i = 0; i < n; i++) {
	// 		cout << ans[i] << " ";
	// 	}
	// }
}