#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve(vector <int> a, int t) {
	int n = a.size();
	int lst = -1;
	vector <bool> fx(n);
	fx[0] = 1, fx[n - 1] = 1;
	for (int i = 1; i < n; ++i) {
		if (a[i] == a[i - 1]) {
			fx[i] = 1;
			fx[i - 1] = 1;
		}
	}
	int cnt = 0;
	for (int i = 0; i + 1 < n; ++i) {
		if (fx[i] && !fx[i + 1]) {
			int r = i + 1;
			while (!fx[r]) ++r;
			//cout << i << ' ' << r << endl;
			int len = r - i - 1;
			cnt = max(cnt, (len + 1) / 2);
			if (a[i] == a[r]) {
				for (int j = i + 1; j < r; ++j) {
					a[j] = a[i];
				}
			} else {
			 	for (int j = 0; j < len / 2; ++j) {
			 		a[i + 1 + j] = a[i];
			 	}
			 	for (int j = len / 2; j < len; ++j) {
			 		a[i + 1 + j] = a[r];
			 	}
			}
			i = r - 1;
		}
	}
	cout << cnt << '\n';
	if (t) {
	 	for (int i = 0; i < n; ++i) cout << a[i] << ' ';
	 	cout << '\n';
	}
}

void solve_stupid(vector <int> a, int t) {
	int n = a.size();
	bool ch = true;
	int cnt = 0;
	auto get = [&] (vector <int> v) {
		sort(v.begin(), v.end());
		return v[1];
	};
	vector <int> ban(n);
	vector <int> intr;
	for (int i = 1; i + 1 < n; ++i) intr.push_back(i);
		
	while (ch) {
		ch = false;
		vector <pair <int, int>> vals;
		for (int i : intr) {
			if (a[i - 1] > a[i] && a[i] < a[i + 1]) {             	
				ch = true;
				vals.emplace_back(i, min(a[i - 1], a[i + 1]));
			} else if (a[i - 1] < a[i] && a[i] > a[i + 1]) {
				ch = true;
				vals.emplace_back(i, max(a[i - 1], a[i + 1]));
			}
		}
		intr.clear();
		for (auto p : vals) {
			a[p.first] = p.second;
			intr.push_back(p.first);
		}
		if (ch) ++cnt;
	}
	cout << cnt << '\n';
	if (t) {
	 	for (int i = 0; i < n; ++i) cout << a[i] << ' ';
	 	cout << '\n';
	}
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, t;
	cin >> n >> t;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	bool fl = true;
	for (int i = 0; i < n; ++i) {
		fl &= (a[i] <= 2);
	}
	if (fl) solve(a, t);	
	else solve_stupid(a, t);
}