#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;

mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

int stupid(int n, vector<int> a) {
	vector<int> nn(n);
	int ans = 0;
	while (true) {
		nn[0] = a[0];
		nn[n - 1] = a[n - 1];
		for (int i = 1; i < n - 1; i++) {
			if (a[i] >= min(a[i - 1], a[i + 1]) && a[i] <= max(a[i - 1], a[i + 1]))
				nn[i] = a[i];
			else if (a[i - 1] >= min(a[i], a[i + 1]) && a[i - 1] <= max(a[i], a[i + 1]))
				nn[i] = a[i - 1];
			else
				nn[i] = a[i + 1];
		}
		if (nn == a) {
			return ans;
		}
		a = nn;
		ans++;
	}
}

int smart(int n, vector<int> a) {
	int cur = 0;
	int ans = 0;
	for (int i = 2; i < n; i++) {
		if (a[i] > a[i - 1] && a[i - 1] < a[i - 2]) {
			if (cur == 0) cur = 3;
			else cur++;
		}
		else if (a[i] < a[i - 1] && a[i - 1] > a[i - 2]) {
			if (cur == 0) cur = 3;
			else cur++;
		}
		else {
			if (cur) {
				ans = max(ans, (cur - 1) / 2 );
			}
			cur = 0;
		}
	}
	if (cur)
		ans = max(ans, (cur - 1) / 2);
	return ans;
}

void stress() {
	int cnt = 0;
	while (true) {
		cnt++;
		int n = rand() % 100 + 1;
		vector<int> a(n);
		for (int i = 0; i < n; i++)
			a[i] = rand() % 2 + 1;
		int m1 = smart(n, a);
		int m2 = stupid(n, a);
		if (m1 == m2) {
			cout << "TEST# " << cnt << " OK\n";
		}
		else {
			cout << "TEST# " << cnt << " FAILED\n";
			cout << n << endl;
			for (int i : a)
				cout << i << " ";
			cout << endl;
			cout << m1 << " " << m2 << endl;
			return;
		}
	}
}

void kek() {
	int m = 0;
	int cnt = 0;
	while (true) {
		cnt++;
		int n = 5e5;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			a[i] = mrand() % 1000 + 1;
		}
		m = max(m, stupid(n, a));
		cout << m << endl;
		return;
	}
}


const int N = 5e5 + 7;
int t1[N], t2[N];

void solve() {
	//kek(); return;
	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	bool fl = true;
	for (int& i : a) {
		cin >> i;
		if (i > 2)fl = false;
	}
	if (!fl && n <= 5e5) {
		if (n == 1) {
			cout << 0 << endl;
			if (t) cout << a[0] << endl;
			return;
		}
		else if (n == 2) {
			cout << 0 << endl;
			if (t) cout << a[0] << " " << a[1] << endl;
			return;
		}
		for (int i = 0; i < n; i++) t1[i] = a[i];
		for (int it = 1; ;it++) { 
			t2[0] = t1[0];
			t2[n - 1] = t1[n - 1];
			int a, b, c;
			bool fl = true;
			assert(n <= 1e3 || it <= 100);
			for (int i = 1; i < (n - 1); i++) {
				a = t1[i - 1];
				b = t1[i];
				c = t1[i + 1];
				if (b > c) swap(b, c);
				if (a > b) swap(a, b);
				if (b > c) swap(b, c);
				t2[i] = b;
				if (b != t1[i]) fl = false;
			}
			if (fl) {
				cout << it - 1 << endl;
				if (t) {
					for (int i = 0; i < n; i++)
						cout << t1[i] << " ";
				}
				break;
			}
			for (int i = 0; i < n; i++)
				t1[i] = t2[i];
		}
	}
	else{
		int cur = 0;
		int ans = 0;
		for (int i = 2; i < n; i++) {
			if (a[i] > a[i - 1] && a[i - 1] < a[i - 2]) {
				if (cur == 0) cur = 3;
				else cur++;
			}
			else if (a[i] < a[i - 1] && a[i - 1] > a[i - 2]) {
				if (cur == 0) cur = 3;
				else cur++;
			}
			else {
				if (cur) {
					i--;
					if (cur & 1) {
						for (int j = i; j > i - cur; j--)
							a[j] = a[i];
					}
					else {
						for (int j = i; j > i - cur/ 2; j--)
							a[j] = a[i];
						for (int j = i - cur / 2; j > i - cur; j--)
							a[j] = a[i - cur + 1];
					}
					i++;
					ans = max(ans, (cur - 1) / 2);
				}
				cur = 0;
			}
		}
		if (cur) {
			ans = max(ans, (cur - 1) / 2);
			if (cur & 1) {
				for (int j = n - 1; j > n - 1 - cur; j--)
					a[j] = a[n -1];
			}
			else {
				for (int j = n - 1; j > n - 1 - cur / 2; j--)
					a[j] = a[n- 1];
				for (int j = n - 1 - cur / 2; j > n - 1 - cur; j--)
					a[j] = a[n - 1 - cur + 1];
			}
		}
		cout << ans << endl;	
		if (t)
			for (int i : a)
				cout << i << " ";
	}
}