#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//
/*
	1) Если мы сможем предугадывать как посмтроиться гора через -c- изменений
		то мы сможем бинпоиском найти ответ за nlogn
	2) Решим для a <= 2
	3) 1 2 1 2 1 -> 1 1 1 1 1 за 2 года
	4) 2 2 1 2 1 2 2 1 
	5) Если график гор четный и левая и правая граница отличаетя(1 и 2), то половина где 1 считаем количество 2
		, а где половина 2 считаем количество 1
*/

int midian(int a, int b, int c)
{
	if (a > b&& a > c)
	{
		if (b > c)
			return b;
		else
			return c;
	} else
		if (a < b && a < c)
		{
			if (b > c)
				return c;
			else
				return b;
		} else
			return a;
}
const int N = 500001;
vector<int> ans;
int calc1(vector<int>& v, int idx, int i)
{
	if (idx > i)
		return 0;
	int cnt1 = 0;
	for (int j = idx; j <= (idx + i) / 2; ++j)
	{
		if (v[j] != v[idx - 1])
		{
			++cnt1;
			ans[j] = v[idx - 1];
		}
	}

	int cnt2 = 0;
	for (int j = i; j >= (idx + i) / 2; --j)
	{
		if (v[j] != v[i + 1])
		{
			++cnt2;
			ans[j] = v[i + 1];
		}
	}


	return max(cnt1 , cnt2) + ((i - idx) % 2 == 1 ? 1 : 0);
}

int calc(vector<int>& v, int idx, int i)
{
	if (v[idx - 1] != v[i + 1])
		return calc1(v, idx, i);
	int obr = v[idx - 1];
	int cnt = 0;
	for(int j = idx; j <= i; ++j)
		if (v[j] != obr)
		{
			++cnt;
			ans[j] = obr;
		}
	return cnt;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	int n, t;
	cin >> n >> t;

	vector<int> v(n);
	ans.resize(n);
	int maxi = 0;
	for (int i = 0; i < n; ++i)
		cin >> v[i], maxi = max(maxi, v[i]);
	ans = v;
	bool flag = true;
	int cnt = 0;
	vector<int> star(n);
	for (int i = 0; i < n; ++i)
		star[i] = v[i];

	if (maxi > 2)
	{
		while (flag)
		{
			flag = false;

			for (int i = 1; i < n - 1; ++i)
			{
				int mid = midian(star[i - 1], star[i], star[i + 1]);
				if (v[i] != mid)
					v[i] = mid, flag = true;
			}
			for (int i = 0; i < n; ++i)
				star[i] = v[i];
			if (flag)
				++cnt;
			//for (auto& u : v)
			//	cout << u << ' ';
		//	cout << nl;
		}
		cout << cnt << nl;
		if (t)
			for (int i = 0; i < n; ++i)
				cout << v[i] << ' ';
	}
	else
	{
		int pred = v[0];
		bool flag = false;
		int idx = -1;
		for (int i = 1; i < n; ++i)
		{
			if (v[i] != pred)
			{
				if (!flag)
				{
					flag = true;
					idx = i;
				}
			}
			else
				if (flag)
			{
				cnt = max(cnt, calc(v, idx, i - 2));
				flag = false;
			}
			pred = v[i];


		}

		if (flag)
		{
			cnt = max(cnt, calc(v, idx, n - 2));
		}

		cout << cnt << nl;
		if (t)
			for (auto& u : ans)
				cout << u << ' ';
	}
	return 0;
}