#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

#define ll long long
#define pii pair<int, int>

using namespace std;

int median(int a, int b, int c) {
    return a + b + c - max(max(a, b), c) - min(min(a, b), c);
}

void reform(int l, int r, vector<int> &a) {
    if ((r - l + 1) % 2 == 0) {
        int c = a[l];
        for (int i = l; i <= (l + r) / 2; i++) {
            a[i] = c;
        }
        c = a[r];
        for (int i = (l + r) / 2 + 1; i <= r; i++) {
            a[i] = c;
        }
    } else {
        int c = a[l];
        for (int i = l; i <= r; i++) {
            a[i] = c;
        }
    }
}

int main() {

    int n, t;
    cin >> n >> t;

    vector<int> a(n);
    bool ok = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 2)
            ok = false;
    }

    if (!ok) {
        bool bl = true;
        int c = 0;
        vector<int> b(n);
        while (bl) {
            bl = false;
            b.resize(n);
            b[0] = a[0];
            b[n - 1] = a[n - 1];
            for (int i = 1; i < n - 1; i++) {
                b[i] = median(a[i - 1], a[i], a[i + 1]);
                if (b[i] != a[i])
                    bl = true;
            }
            if (!bl)
                break;
            c++;
            a = b;
            b.clear();
        }
        cout << c << endl;
        if (t == 1)
            for (int i = 0; i < n; i++) {
                cout << a[i] << " ";
            }
    } else {
        int ans = 0;
        int cnt = 1;
        for (int i = 1; i < n; i++) {
            if (a[i] != a[i - 1])
                cnt++;
            else {
                if (cnt % 2 == 0)
                    ans = max(ans, cnt / 2 - 1);
                else
                    ans = max(ans, cnt / 2);
                reform(i - cnt, i - 1, a);
                cnt = 1;
            }
        }
        if (cnt > 1) {
            if (cnt % 2 == 0)
                ans = max(ans, cnt / 2 - 1);
            else
                ans = max(ans, cnt / 2);
            reform(n - cnt, n - 1, a);
            cnt = 1;
        }
        cout << ans << endl;
        if (t == 1)
            for (int i = 0; i < n; i++) {
                cout << a[i] << " ";
            }
    }
}