#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N = 1 << 20;

int n, tp, a[N], b[N], ans[N], f[N], anscnt = 0;

int med(int x, int y, int z) {
    if (x > y) {
        swap(x, y);
    }
    if (y > z) {
        swap(y, z);
    }
    if (x > y) {
        swap(x, y);
    }
    return y;
}

int solve() {
    int cnt = 0;
    vector<pair<int, int>> vec;
    int lst = a[0], pos = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] == lst) {
            continue;
        }
        if (pos < i - 1 || pos == 0) {
            vec.emplace_back(pos, i - 1);
        }
        lst = a[i];
        pos = i;
    }
    vec.emplace_back(pos, n - 1);
    for (int i = 0; i + 1 < (int)vec.size(); ++i) {
        int l = vec[i].y;
        int r = vec[i + 1].x;
        assert(l < r);
        cnt = max(cnt, (r - l) / 2);
        if (a[l] == a[r]) {
            fill(a + l + 1, a + r, a[l]);
        } else if (r - l >= 2) {
            fill(a + l + 1, a + (l + r + 1) / 2, a[l]);
            fill(a + (l + r + 1) / 2, a + r, a[r]);
        }
    }
    return cnt;
}

struct seg {
    int lcol, rcol, len;
    int pref, suff, ans;
    seg(int col) {
        lcol = col;
        rcol = col;
        len  = 1;
        pref = 1;
        suff = 1;
        ans  = 1;
    }
    seg() {
        lcol = -1;
        rcol = -1;
        len  = 0;
        pref = 0;
        suff = 0;
        ans  = 0;
    }
};

seg operator+(seg a, seg b) {
    if (a.len == 0) {
        return b;
    }
    if (b.len == 0) {
        return a;
    }
    seg c;
    c.lcol = a.lcol;
    c.rcol = b.rcol;
    c.pref = a.pref;
    c.suff = b.suff;
    c.ans  = max(a.ans, b.ans);
    c.len  = a.len + b.len;
    if (a.rcol != b.lcol) {
        if (a.pref == a.len) {
            c.pref = a.len + b.pref;
        }
        if (b.suff == b.len) {
            c.suff = b.len + a.suff;
        }
        c.ans = max(c.ans, a.suff + b.pref);
    }
    return c;
}

seg t[2 * N];

void upd(int i, int v) {
    t[i += N] = seg(v);
    for (i /= 2; i > 0; i /= 2) {
        t[i] = t[i + i] + t[i + i + 1];
    }
}

int query() {
    int len = t[1].ans;
    return (len - 1) / 2;
}

main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> tp;
    if (tp == 0) {
        map<int, vector<int>> g;
        for (int i = 0; i < n; ++i) {
            cin >> f[i];
            g[f[i]].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            upd(i, 1);
        }
        for (auto e : g) {
            for (int i : e.y) {
                upd(i, 0);
            }
            anscnt = max(anscnt, query());
        }
        cout << anscnt << endl;
    } else {
        set<int> vals;
        for (int i = 0; i < n; ++i) {
            cin >> f[i];
            vals.insert(f[i]);
        }
        for (int val : vals) {
            for (int i = 0; i < n; ++i) {
                a[i] = f[i] >= val;
            }
            anscnt = max(anscnt, solve());
            for (int i = 0; i < n; ++i) {
                if (a[i]) {
                    ans[i] = val;
                }
            }
        }
        cout << anscnt << endl;
        for (int i = 0; i < n; ++i) {
            cout << ans[i] << " ";
        }
        cout << endl;
    }
}
