import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import static java.lang.Math.*;

public class A {
    static BufferedReader in;
    static StringTokenizer st;
    static int x[];
    static int y[];
    static int mx = 1;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int n = nextInt();
        int t = nextInt();
        x = new int[n];
        y = new int[n];
        fn();
        for (int i = 0; i < n; i++) {
            x[i] = nextInt();
            mx = max(mx,x[i]);
        }
        System.out.println(ans(0, n - 1));
        if (t == 1) {
            for (int i = 0; i < n; i++) {
                System.out.print(x[i] + " ");
            }
        }
    }

    private static int ans(int l, int r) {
        if (l + 1 >= r) return 0;
        boolean ch = true;
        int ans = 0;
        while (ch) {
            ch = false;
            for (int i = l; i < r; i++) {
                if (x[i] == x[i + 1]) {
                    return ans + max(ans(l, i), ans(i + 1, r));
                }
                if (i - 1 >= l) {
                    if ((x[i - 1] >= x[i] && x[i] >= x[i + 1]) || (x[i - 1] <= x[i] && x[i] <= x[i + 1])) {
                        return ans + max(ans(l, i), ans(i, r));
                    }
                }
            }
            if (mx <= 2) return (r - l) / 2;
            for (int i = l + 1; i < r; i++) {
                int m1 = max(x[i], max(x[i - 1], x[i + 1]));
                int m2 = min(x[i], min(x[i - 1], x[i + 1]));
                y[i] = x[i - 1] + x[i] + x[i + 1] - m1 - m2;
                if (y[i] != x[i]) ch = true;
            }
            if (!ch) break;
            else {
                ans++;
                for (int i = l + 1; i < r; i++) {
                    x[i] = y[i];
                }
            }
        }
        return ans;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
