#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()

#define TIME (ld)clock() / CLOCKS_PER_SEC
#define debug(x) cout << #x << ": " << x << endl; 

using namespace std; 
mt19937 rnd(2007); 
typedef long long ll; 
typedef long double ld;
typedef pair<int, int> pii; 
const int maxn = 5e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7; 
const ll inf = 1e18; 
int n, test;
int a[maxn];        
int b[maxn];

struct node {
    int cnt, type, push; 
};  

node merge(node a, node b) {
    node res; 
    res.cnt = a.cnt + b.cnt; 
    res.type = 0; 
    res.push = 0; 
    return res;
}

struct Tree {
    node tree[4 * maxn];
    void push(int rt, int l, int r) {
        int push = tree[rt].push;
        if (push == 0) return; 
        tree[rt].type ^= push; 
        tree[rt].push = 0; 
        if (l != r) {
            tree[rt * 2 + 1].push ^= push; 
            tree[rt * 2 + 2].push ^= push; 
        }
    }
    void build() {
        for (int i = 0; i < 4 * maxn; ++i) {
            tree[i].cnt = 0; 
            tree[i].type = 0; 
            tree[i].push = 0; 
        }
    }
    void upd(int l, int r, int l1, int r1, int rt) {
        push(rt, l, r); 
        if (l >= l1 && r <= r1) {
            tree[rt].push ^= 1; 
            push(rt, l, r);
            return;  
        }
        if (max(l, l1) > min(r, r1)) return; 
        int t = (l + r)  / 2; 
        upd(l, t, l1, r1, rt * 2 + 1); 
        upd(t + 1, r, l1, r1, rt * 2 + 2);
        tree[rt] = merge(tree[rt * 2 + 1], tree[rt * 2 + 2]);  
    }
    void block(int l, int r, int id, int rt) {  

        if (l == id && r == id) {
            tree[rt].cnt = 1; 
            return; 
        } 
        if (l > id || r < id) return; 
        int t = (l + r) / 2; 
        block(l, t, id, rt * 2 + 1);
        block(t + 1, r, id, rt * 2 + 2); 
        tree[rt] = merge(tree[rt * 2 + 1], tree[rt * 2 + 2]); 
    }
    void upd_type(int l, int r, int id, int rt, int xx) {
        push(rt, l, r); 
        if (l == id && r == id) {
            tree[rt].type = xx; 
            return; 
        }
        if (l > id || r < id) return; 
        int t = (l + r) / 2; 
        upd_type(l, t, id, rt * 2 + 1, xx);
        upd_type(t + 1, r, id, rt * 2 + 2, xx);
        tree[rt] = merge(tree[rt * 2 + 1], tree[rt * 2 + 2]);  
    }
    int get_type(int l, int r, int id, int rt) {
        push(rt, l, r); 
        if (l == id && r == id) {
            return tree[rt].type; 
        }
        int t = (l + r) / 2; 
        if (id <= t) {
            int res = get_type(l, t, id, rt * 2 + 1); 
            tree[rt] = merge(tree[rt * 2 + 1], tree[rt * 2 + 2]); 
            return res; 
        } 
        int res = get_type(t + 1, r, id, rt * 2 + 2);
        tree[rt] = merge(tree[rt * 2 + 1], tree[rt * 2 + 2]);        
        return res; 
    }
    int get(int l, int r, int l1, int r1, int rt) {
        if (l >= l1 && r <= r1) return tree[rt].cnt; 
        if (max(l, l1) > min(r, r1)) return 0; 
        int t = (l + r) / 2; 
        return get(l, t, l1, r1, rt * 2 + 1) + get(t + 1, r, l1, r1, rt * 2 + 2); 
    }
    int getnull(int rt, int l, int r) {
        return r - l + 1 - tree[rt].cnt; 
    }
    int getnull(int l, int r) {
        return r - l + 1 - get(0, n - 1, l, r, 0); 
    }

    void upd(int l, int r) {
        upd(0, n - 1, l, r, 0); 
    }
    void block(int id) {
        block(0, n - 1, id, 0); 
    }
    void upd_type(int id, int xx) {
        upd_type(0, n - 1, id, 0, xx); 
    }
    int get_type(int id) {
        return get_type(0, n - 1, id, 0); 
    }               
    int get(int l, int r) {
        return get(0, n - 1, l, r, 0); 
    }
    int find_lst(int l, int r, int rt, int xx) {
        if (l == r) return l; 
        int t = (l + r) / 2;             
        int cnt = tree[rt * 2 + 1].cnt;
        if (cnt >= xx) {
            return find_lst(l, t, rt * 2 + 1, xx);                                                
        }
        return find_lst(t + 1, r, rt * 2 + 2, xx - cnt); 
    }
    int find_lst(int idd) {
        int t = get(0, idd) + 1; 
        return find_lst(0, n - 1, 0, t) - 1; 
    }
    int find_left(int l, int r, int rt, int xx) {
        if (l == r) {
            return (tree[rt].cnt == 1 ? -1 : l);  
        }
        int t = (l + r) / 2; 
        int cntnull = getnull(rt * 2 + 1, l, t);
        if (cntnull >= xx) return find_left(l, t, rt * 2 + 1, xx);
        return find_left(t + 1, r, rt * 2 + 2, xx - cntnull);             
    }
    int find_left(int idd) {
        int t = getnull(0, idd - 1) + 1; 
        return find_left(0, n - 1, 0, t);
    }
};

Tree tree;

void solve() {
    cin >> n >> test; 
    for (int i = 0; i < n; ++i) cin >> a[i];      
    tree.build(); 
    /*
    bool ok = false; 
    for (int i = 0; i < n; ++i) {
        ok |= (a[i] > 2); 
    } 
    if (ok) {
        int cnt = -1;
        int ptr = 0; 
        while (true) {
            bool ok = false; 
            ++cnt; 
            for (int i = 1; i < n - 1; ++i) {
                vector<int> t = {a[i - 1], a[i], a[i + 1]};
                sort(all(t));
                ok |= (a[i] != t[1]); 
                ptr += (a[i] != t[1]); 
                b[i] = t[1];             
            }
            for (int i = 1; i < n - 1; ++i) a[i] = b[i]; 
            if (!ok) break;  
        }
        cout << cnt << "\n"; 
        if (test == 0) {
            return; 
        }
        for (int i = 0; i < n; ++i) cout << a[i] << " " ;
        return; 
    }
    */
    for (int i = 0; i < n; ++i) --a[i]; 
    int l1 = 0; 
    int r1 = 0; 
    for (int i = 1; i < n; ++i) {   
        if (a[i - 1] == a[i]) {
            r1++; 
        } else {
            if (r1 != l1) {
                for (int j = l1; j <= r1; ++j) {
                    tree.block(j);
                }
            } 
            l1 = i; 
            r1 = i; 
        }
    }
    for (int i = 0; i < n; ++i) tree.upd_type(i, a[i]);
    tree.block(0); 
    tree.block(n - 1); 
    if (r1 != l1) {
        for (int j = l1; j <= r1; ++j) {
            tree.block(j);                     
        }
    }
    int cnt = 0; 
    while (tree.get(0, n - 1) != n) {
        int l = 0;
        ++cnt;  
        while (true) {
            l = tree.find_left(l);
            if (l == -1) break; 
            int r = tree.find_lst(l);
            tree.block(l); 
            tree.block(r); 
            tree.upd(l, l); 
            if (l != r) {
                tree.upd(r, r); 
            }
            tree.upd(l + 1, r - 1); 
            l = r + 1;                                                 
        }
    }
    cout << cnt << '\n'; 
    if (test == 0) return; 
    for (int i = 0; i < n; ++i) {
        cout << tree.get_type(i) + 1 << " "; 
    }                           
}               

signed main() {
#ifdef LOCAL 
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout); 
#endif 
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    int t = 1; 
    for (int i = 0; i < t; ++i) solve(); 
    return 0; 
}
