#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define vbb vector<bool>
#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    bool isDebug = 0;

    ll n, t;
    cin >> n >> t;

    if(n <= 1000 && !isDebug)
    {
        vll a(n);
        for (int i = 0; i < n; i++)
            cin >> a[i];

        ll steps = 0;
        while (true) {
            steps++;
            vll newA(n);
            newA[0] = a[0];
            newA[n - 1] = a[n - 1];

            for (int i = 1; i < n - 1; i++) {
                multiset<ll> st;
                st.insert(a[i - 1]);
                st.insert(a[i]);
                st.insert(a[i + 1]);

                st.erase(st.begin());
                newA[i] = *st.begin();
            }
            if (a == newA)
                break;
            a = newA;
        }
        steps--;
        cout << steps << endl;
        if (t == 0)
            return 0;
        for (int i = 0; i < a.size(); i++)
            cout << a[i] << " ";
        return 0;
    }

    vll a(n);
    for(int i = 0; i < a.size(); i++)
    {
        cin >> a[i];
        if(a[i] > 2)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    vbb isConst(n);
    isConst[0] = 1;
    isConst[n - 1] = 1;

    for(int i = 1; i < n - 1; i++)
    {
        if(a[i] == a[i - 1] || a[i + 1] == a[i])
            isConst[i] = 1;
    }

  /*  cerr << "isConst " << endl;
    for(int i = 0; i < n; i++)
        cerr << isConst[i] << " ";
    cerr << endl;*/

    vll final(n);
    ll time = 0;
    for(int i = 0; i < n; i++)
    {
        if(isConst[i])
        {
            final[i] = a[i];
            continue;
        }

        ll len = 1;
        for(int j = i + 1; j < n; j++)
        {
            if(isConst[j])
                break;
            len++;
        }

        //cerr << "i " << i << " len " << len << endl;
        if(len % 2 == 1)
        {
            time = max(time, (len + 1) / 2);
            for(int j = i; j < i + len; j++)
                final[j] = a[i - 1];
        }
        else
        {
            time = max(time, len / 2);
            for(int j = i; j < i + len / 2; j++)
                final[j] = a[i - 1];
            for(int j = i + len / 2; j < i + len; j++)
                final[j] = a[i + len];
        }
        i = i + len - 1;
    }
    cout << time << endl;
    for(int i = 0; i < n; i++)
        cout << final[i] << " ";
    return 0;
}