#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 5 * 1e5 + 42;
int a[MAX_N];
int b[MAX_N];

int get(int x, int y, int z) {
    vector < int > now = {x, y, z};
    sort(now.begin(), now.end());
    return now[1];
}

bool can(int n) {
    bool ans = 0;
    b[0] = a[0];
    b[n + 1] = a[n + 1];
    for (int i = 1; i <= n; i++) {
        b[i] = get(a[i - 1], a[i], a[i + 1]);
        if (b[i] != a[i]) {
            ans = 1;
        }
    }
    for (int i = 1; i <= n; i++) {
        a[i] = b[i];
    }
    return ans;
}

int solve1(int n) {
    int ans = 0;
    while (can(n)) {
        ans++;
    }
    return ans;
}

int solve2(int n) {
    int ans = 0;
    int x = 0;
    for (int i = 1; i <= n + 1; i++) {
            //cout << a[i] << endl;
        if (a[i] != a[i - 1]) {
            x++;
            continue;
        }
        //cout << i - x - 1 << " " << i - 1 << " " << x << endl;
        if (x % 2 == 1) {
            ans = max(x / 2, ans);
            int l = i - x - 1;
            int r = i - 1;
            while (l < r) {
                a[l] = a[l - 1];
                a[r] = a[r + 1];
                l++;
                r--;
            }
            x = 0;
            continue;
        }
        ans = max(x / 2, ans);
        for (int j = i - x - 1; j < i; j++) {
            a[j] = a[i];
        }
        x = 0;
        continue;
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    bool f = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        if (a[i] > 2) {
            f = 1;
        }
    }
    a[0] = a[1];
    a[n + 1] = a[n];
    int ans;
    if (f == 0) {
        ans = solve2(n);
    } else {
        ans = solve1(n);
    }
    cout << ans << endl;
    for (int i = 1; i <= n; i++) {
        cout << a[i] << " ";
    }
    return 0;
}
