//#define _GLIBCXX_DEBUG 1
#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, t;
    cin >> n >> t;
    vector<int> arr(n);
    int mx = 0;
    for (auto &i : arr) {
        cin >> i;
        mx = max(mx, i);
    }
    if (mx <= 2) {
        ll sum = 0;
        for (int i = 1; i < n - 1; ++i) {
            if (arr[i] != arr[i - 1]) {
                int j = i + 1;
                while (j < n) {
                    if (arr[j] == arr[j - 1]) break;
                    j++;
                }
                j--;
                sum = max(sum, (ll) (j - i) - (j - i) / 2);
                for (int k = 0; k < (j - i) / 2; ++k) {
                    arr[i + k] = arr[i - 1];
                }
                for (int k = (j - i) / 2; i + k < j; ++k) {
                    arr[i + k] = arr[j];
                }
                i = j;
            }
        }
        cout << sum << '\n';
        if (t) for (auto i : arr) cout << i << ' ';
        return 0;
    }
    array<int, 3> tr = {};
    int cnt = 0;
    while (true) {
        vector<int> narr(n);
        narr[0] = arr[0];
        narr[n - 1] = arr[n - 1];
        bool fl = false;
        for (int i = 1; i < n - 1; ++i) {
            tr = {arr[i - 1], arr[i], arr[i + 1]};
            sort(tr.begin(), tr.end());
            narr[i] = tr[1];
            if (narr[i] != arr[i]) fl = true;
        }
        if (!fl) break;
        arr = narr;
        cnt++;
    }
    cout << cnt << '\n';
    if (t) for (auto i : arr) cout << i << ' ';
}