#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int MAXN = 5e5 + 100;
const int LOGN = 20;
int lg[MAXN];
int mn1[LOGN][MAXN], mn2[LOGN][MAXN], mx1[LOGN][MAXN], mx2[LOGN][MAXN];
int arr[MAXN], brr[MAXN], tmp[MAXN], mm[MAXN], n, ans = 0;
bool st[MAXN];

int get_mn(int l, int r) {
	if (l < 0) {
		l += ((-l + 1) / 2) * 2;
	}
	if (r >= n) {
		r -= ((r - n + 1) / 2) * 2; 
	}
	if (l % 2 == 1) {
		return min(mn1[lg[r - l + 1]][l], mn1[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
	}
	else {
		return min(mn2[lg[r - l + 1]][l], mn2[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
	}
}

int get_mx(int l, int r) {
	if (l < 0) {
		l += ((-l + 1) / 2) * 2;
	}
	if (r >= n) {
		r -= ((r - n + 1) / 2) * 2; 
	}
	if (l % 2 == 1) {
		return max(mx1[lg[r - l + 1]][l], mx1[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
	}
	else {
		return max(mx2[lg[r - l + 1]][l], mx2[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
	}
}

int check(int i, int l, int f, int c) {
	if ((i - l) % 2 == f) {
		int x = -1, y = -1, z = -1;
		if (c % 2 == 0) {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return INF;
			} 
			y = get_mn(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
		else {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return INF;
			} 
			y = get_mx(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
	}
	else {
		int x = -1, y = -1, z = -1;
		if (c % 2 == 1) {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return INF;
			} 
			y = get_mn(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
		else {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return INF;
			}  
			y = get_mx(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
	}
	return -1;
}

void get(int i, int l, int f) {
	if ((i - l) % 2 == f) {
		int bl = -1, br = n, mid;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mn(lf, rg);
			int x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			if (y < x) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		int bad = br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mn(lf, rg);
			int z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (y < z) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		for (int c = max(0, 2 * min(bad, br) - 5); ; ++c) {
			int x = check(i, l, f, c);
			if (x != -1) {
				mm[i] = min(mm[i], c);
				break;
			}
		}
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mx(lf, rg);
			int x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			if (y > x) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		bad = br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mx(lf, rg);
			int z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (y > z) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		for (int c = max(0, 2 * min(bad, br) - 5); ; ++c) {
			int x = check(i, l, f, c);
			if (x != -1) {
				mm[i] = min(mm[i], c);
				break;
			}
		}
	}
	else {
		int bl = -1, br = n, mid;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mx(lf, rg);
			int x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			if (y > x) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		int bad = br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mx(lf, rg);
			int z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (y > z) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		for (int c = max(0, 2 * min(bad, br) - 5); ; ++c) {
			int x = check(i, l, f, c);
			if (x != -1) {
				mm[i] = min(mm[i], c);
				break;
			}
		}
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mn(lf, rg);
			int x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			if (y < x) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		bad = br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = 2 * mid + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			}  
			int y = get_mn(lf, rg);
			int z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (y < z) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		for (int c = max(0, 2 * min(bad, br) - 5); ; ++c) {
			int x = check(i, l, f, c);
			if (x != -1) {
				mm[i] = min(mm[i], c);
				break;
			}
		}
	}
}

void solve(int l, int r) {
	for (int i = l + 1; i < r; ++i) {
		mm[i] = INF;
	}
	int cur = 1;
	for (int i = 1; ; ++i) {
		int lf = l + i, rg = r - i;
		if (lf > rg) {
			break;
		}
		mm[lf] = mm[rg] = cur;
		brr[lf] = brr[l];
		brr[rg] = brr[r];
		cur++;
	}
	return;
	int f = 1;
	if (arr[l + 1] < arr[l]) {
		f ^= 1;
	}
	set<pii> setik;
	for (int i = l + 1; i < r; ++i) {
		get(i, l, f);
		setik.insert({mm[i], i});
		mm[i] = INF;
	}
	while (setik.size()) {
		int res = setik.begin()->first;
		int u = setik.begin()->second;
		setik.erase(setik.begin());
		if (mm[u] != INF) {
			continue;
		}
		mm[u] = res;
		brr[u] = check(u, l, f, res);
		if (mm[u - 1] == INF) {
			get(u - 1, l, f);
			setik.insert({mm[u - 1], u - 1});
			mm[u - 1] = INF;
		}
		if (mm[u + 1] == INF) {
			get(u + 1, l, f);
			setik.insert({mm[u + 1], u + 1});
			mm[u + 1] = INF;
		}
	}
}

void work() {
	for (int i = 1; i < n - 1; ++i) {
		vector<int> v = {arr[i - 1], arr[i], arr[i + 1]};
		sort(all(v));
		tmp[i] = v[1];
	}
	for (int i = 1; i < n - 1; ++i) {
		arr[i] = tmp[i];
	}
}

signed main() {
	FAST_IO();
	int hg = -1;
	for (int i = 1; i < MAXN; ++i) {
		if (!(i & (i - 1))) {
			hg++;
		}
		lg[i] = hg; 
	}
	int t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
		if (i % 2 == 0) {
			mn1[0][i] = INF;
			mx2[0][i] = mn2[0][i] = arr[i];
		}
		else {
			mx1[0][i] = mn1[0][i] = arr[i];
			mn2[0][i] = INF;
		}
	}
	if (n <= 1050) {
		int ans = 0;
		while (true) {
			bool any = false;
			for (int i = 0; i < n; ++i) {
				brr[i] = arr[i];
			}
			work();
			for (int i = 0; i < n; ++i) {
				if (arr[i] != brr[i]) {
					any = true;
					break;
				}
			}
			if (any) {
				ans++;
			}
			else {
				break;
			}
		}
		cout << ans << '\n';
		if (t == 1) for (int i = 0; i < n; ++i) {
			cout << brr[i] << ' ';
		}
		return 0;
	}
	st[0] = st[n - 1] = true;
	brr[0] = arr[0];
	brr[n - 1] = arr[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		if (arr[i] >= min(arr[i - 1], arr[i + 1]) && arr[i] <= max(arr[i - 1], arr[i + 1])) {
			st[i] = true;
		}
		if (st[i]) {
			brr[i] = arr[i];
		}
	}
	int l = -1;
	for (int i = 0; i < n; ++i) {
		if (st[i]) {
			if (l != -1) {
				solve(l, i);
			}
			l = -1;
		}
		else if (l == -1) {
			l = i - 1;
		}
	}
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		mx = max(mx, mm[i]);
	}
	cout << mx << '\n';
	if (t == 1) for (int i = 0; i < n; ++i) {
		cout << brr[i] << ' ';
	}
}