#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int median(int a, int b, int c)
{
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	if (a > b)
		swap(a, b);

	return b;
}

int main()
{
	int n = 0, t = 0;
	cin >> n >> t;
	vector <int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	if (n <= 1000)
	{
		int c = 0;
		while (true)
		{
			vector <int> b(n);
			b[0] = a[0];
			b.back() = a.back();

			bool swapped = false;
			for (int i = 1; i < n - 1; ++i)
			{
				b[i] = median(a[i - 1], a[i], a[i + 1]);
				if (a[i] != b[i])
					swapped = true;
			}

			if (!swapped)
				break;
			swap(a, b);
			++c;
		}

		cout << c << '\n';
		if (t == 1)
			for (int i = 0; i < a.size(); ++i)
				cout << a[i] << ' ';
	}
	else if (*max_element(a.begin(), a.end()) == *min_element(a.begin(), a.end()))
	{
		cout << "0\n";
		if (t == 1)
			for (int i = 0; i < n; ++i)
				cout << a[i] << ' ';
	}
	else
	{
		int r = 0;
		vector <pair <int, int>> rng = { {0, 1} };
		for (int i = 0; i < n; ++i)
		{
			r = i + 1;
			while (r < n && a[r] == a[i])
				++r;

			if (r - i > 1)
			{
				if (i == 0)
					rng.pop_back();
				rng.push_back({ i, r });
			}
			i = r - 1;
		}
		if (rng.back().second != n)
			rng.push_back({ n - 1, n });

		int c = 0;
		for (int i = 1; i < rng.size(); ++i)
			c = max(c, (rng[i].first - rng[i - 1].second + 1) / 2);
		cout << c << '\n';

		if (t == 1)
		{
			for (int i = 0; i < rng[0].second; ++i)
				cout << a[0] << ' ';
			for (int i = 1; i < rng.size(); ++i)
			{
				if (a[rng[i - 1].first] == a[rng[i].first])
					for (int j = rng[i - 1].second; j < rng[i].first; ++j)
						cout << a[rng[i].first] << ' ';
				else
				{
					int m = (rng[i - 1].second + rng[i].first) >> 1;
					for (int j = rng[i - 1].second; j < m; ++j)
						cout << a[rng[i - 1].first] << ' ';
					for (int j = m; j < rng[i].first; ++j)
						cout << a[rng[i].first] << ' ';
				}

				for (int j = rng[i].first; j < rng[i].second; ++j)
					cout << a[rng[i].first] << ' ';
			}
		}
	}

	return 0;
}