#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int median(int a, int b, int c)
{
    vector<int> k;
    k.push_back(a);
    k.push_back(b);
    k.push_back(c);
    sort(k.begin(), k.end());
    return k[1];
}


int solve(int n, int p, vector<int> a)
{
    bool flag = false;
    for (int t = 0; t <= 10000; t++)
    {
        flag = false;
        vector<int> b = a;
        for (int i = 1; i < n - 1; i++) b[i] = median(a[i - 1], a[i], a[i + 1]);
        for (int i = 0; i < n; i++) if (a[i] != b[i]) flag = true;
        a = b;
        if (flag) continue;
        cout << t << endl;
        if (p)
        {
            for (int i = 0; i < n; i++) cout << a[i] << " ";
            cout << endl;
        }
        return t;
    }
    return 153;
}


int dumb(int n, int p, vector<int> a)
{
    vector<bool> block(n);
    block[0] = true;
    block.back() = true;
    int ans = 0;
    for (int i = 1; i < n - 1; i++)
    {
        if (a[i] == a[i - 1] || a[i] == a[i + 1]) block[i] = true;
    }
    int ancor = 0;
    for (int i = 1; i < n; i++)
    {
        if (!block[i]) continue;
        if (ancor == i - 1)
        {
            ancor++;
            continue;
        }
        if (a[i] == a[ancor])
        {
            int l = i - ancor - 1;
            ans = max(ans, (l + 1) / 2);
            for (int j = ancor + 1; j < i; j++) a[j] = a[i];
        }
        else
        {
            int l = i - ancor - 1;
            ans = max(ans, (l + 1) / 2);
            for (int j = ancor + 1; j <= ancor + l/2; j++) a[j] = a[ancor];
            for (int j = ancor + l/2 + 1; j < i; j++) a[j] = a[i];
        }
        ancor = i;
    }
    cout << ans << endl;
    if (p)
    {
        for (int i = 0; i < n; i++) cout << a[i] << " ";
        cout << endl;
    }
    return ans;
}


signed main()
{
    warp();
    int n, p;
    cin >> n >> p;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (n <= 1000){
        solve(n, p, a);
        return 0;
    }
    dumb(n, p, a);
    /*
    const int n = 8;
    const int p = 1;
    for (int test = 0; true; test++)
    {
        vector<int> a(n);
        for (int i = 0; i < n; i++) a[i] = rand() % 2;
        if (solve(n, p, a) == dumb(n, p, a))
        {
            cout << "TEST " << test << " PASS" << endl;
            continue;
        }
        cout << "FAIL" << endl;
        cout << n << " " << p << endl;
        for (int i = 0; i < n; i++) cout << a[i] << " ";
        cout << endl;
        cout << "CORRECT " << solve(n, p, a) << endl << dumb(n, p, a) << endl;
        return 0;
    }
    */
    return 0;
}
