#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

int n, t;
vector <int> a;

void solve() {
	bool flag = 1;
	int kol = 0;
	while (flag) {
		flag = 0;
		vector <int> b = a;
		for (int i = 1; i < n - 1; ++i)
			b[i] = min({max(a[i], a[i - 1]), max(a[i], a[i + 1]), max(a[i - 1], a[i + 1])});
		if (a != b) {
			flag = 1;
			a = b;
			++kol;
		}
		//cerr << a;
	}
	if (t == 0)
		cout << kol;
	else
		cout << kol << '\n' << a;
}

int lm = 2e8;

bool try_do() {
	bool flag = 1;
	int kol = 0;
	lm /= n;
	while (flag) {
		if (kol > lm)
			return 0;
		flag = 0;
		vector <int> b = a;
		for (int i = 1; i < n - 1; ++i)
			b[i] = min({max(a[i], a[i - 1]), max(a[i], a[i + 1]), max(a[i - 1], a[i + 1])});
		if (a != b) {
			flag = 1;
			a = b;
			++kol;
		}
		//cerr << a;
	}
	if (t == 0)
		cout << kol;
	else
		cout << kol << '\n' << a;
	return 1;
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	/*ofstream cout("inp.txt");
	cout << 500000 << ' ' << 1 << endl;
	for (int i = 0; i < 500000; i++)
		cout << bool(i % 2) + 1 << ' ';*/

	//my_file_in_out();

	cin >> n >> t;
	a.resize(n);
	cin >> a;

	if (n <= 10000) {
		solve();
		return 0;
	}

	bool todo = try_do();
	if (todo)
		return 0;
	
	vector <int> b(1, a[0]);
	for (auto el : a)
		b.push_back(el);
	b.push_back(a.back());
	a = b;
	n += 2;

	vector <bool> used(n, 0);
	ll ans = 0;
	vector <int> pa;

	for (int i = 0; i < n;) {
		int j = i + 1;
		while (j < n && a[i] == a[j])
			j++;
		if (j - i > 1) {
			pa.push_back(i - 1);
			pa.push_back(j);
		}
		i = j;
	}

	for (int i = 0; i < len(pa); i += 2)
		for (int j = pa[i] + 1;  j < pa[i + 1]; j++)
			used[j] = 1;
	
	for (int i = 1; i < len(pa); i += 2) {
		int l = pa[i];
		int r = pa[i + 1];
		if (l == r)
			continue;
		int tmp = 0;
		while (r >= l) {
			if (tmp & 1) {
				if (l != r)
					a[l] = 3 - a[l];
				a[r] = 3 - a[r];
				if (l == r)
					break;
			}
			if (r - l == 1) {
				if (a[r] == a[r + 1] && a[l] == a[l - 1])
					break;
			}
			a[r] = a[r + 1];
			a[l] = a[l - 1];
			l++;
			r--;
			tmp++;
			//if (r - l == 1)
		}
		ans = max(ans, (ll)tmp);
	}

	cout << ans << '\n';
	for (int i = 1; i < n - 1; i++)
		cout << a[i] << ' ';

	return 0;
}