#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;
vector <ll> pref;

ll get(ll l, ll r, ll t) {
	ll len = r - l + 1;
	if (!l) {
		if (t == 1) {
			return pref[r];
		}
		return len - pref[r];
	}
	if (t == 1) {
		return pref[r] - pref[l - 1];
	}
	return len - (pref[r] - pref[l - 1]);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> n >> t;
	bool leq2 = true;
	vector <ll> a(n);
	for (auto& x : a) {
		cin >> x;
		if (x > 2) leq2 = false;
	}
	if (n > 1000 && leq2) {
		for (auto& x : a) {
			x--;
		}
		pref.resize(n);
		partial_sum(a.begin(), a.end(), pref.begin());
		used.resize(n);
		vector <vector <ll>> block;
		for (int i = 0; i < n; ++i) {
			ll j = i + 1;
			while (j < n && a[j] == a[i]) ++j;
			if (j - i >= 2) {
				for (int k = i; k < j; ++k) {
					used[k] = true;
				}
			}
			i = j - 1;
		}
		used[0] = used[n - 1] = true;
		for (auto x : used) {
			cout << x << ' ';
		}
		vector <ll> len;
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				ll j = i + 1;
				while (!used[j]) {
					++j;
				}
				len.push_back(j - i);
				i = j - 1;
			}
		}
		ll ans = 0;
		for (auto& x : len) {
			maxi(ans, (x - 1) / 2);
		}
		cout << '\n';
		cout << ans << '\n';
		vector <pair <ll, ll>> ord;
		for (int i = 0; i < n; ++i) {
			ll j = i + 1;
			while (j < n && a[j] == a[i]) {
				++j;
			}
			if (used[i]) {
				ord.push_back({ a[i], i });
			}
			i = j - 1;
		}
		if (t) {
			for (int i = 0; i < n; ++i) {

			}
		}
	}
	else {
		ll c = 0;
		bool updated = true;
		set <ll> to_check;
		set <ll> newc;
		vector <ll> newa(n);
		for (int i = 1; i <= n - 2; ++i) {
			to_check.insert(i);
		}
		newa[0] = a[0];
		newa[n - 1] = a[n - 1];
		while (true) {
			newc.clear();
			for (auto& i : to_check) {
				ll x = a[i - 1], y = a[i], z = a[i + 1];
				if (x > y) {
					swap(x, y);
				}
				if (y > z) {
					swap(y, z);
				}
				if (x > y) {
					swap(x, y);
				}
				if (y != a[i]) {
					updated = true;
					newc.insert(i);
					newc.insert(mmax(i - 1, 1));
					newc.insert(mmin(i + 1, n - 2));
				}
				newa[i] = y;
			}
			if (!newc.empty()) {
				++c;
				a.swap(newa);
				newc.swap(to_check);
			}
			else {
				break;
			}
		}
		cout << c << '\n';
		if (t) {
			for (auto& x : a) {
				cout << x << ' ';
			}
		}
	}
	return 0;
}