#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 5e5 + 5;

mt19937 mt(313);
int rng(int l, int r)
{
    return mt() % (r - l + 1) + l;
}

int median(vector <int> &t)
{
    assert(t.size() == 3);
    sort(t.begin(), t.end());
    return t[1];
}

bool proceed(vector <int> &v)
{
    int n = (int)v.size();
    vector <int> new_v(n);
    new_v[0] = v[0], new_v[n - 1] = v[n - 1];

    bool finished = true;
    for(int i = 1; i < n - 1; i++)
    {
        vector <int> temp(3);
        temp[0] = v[i - 1]; temp[1] = v[i]; temp[2] = v[i + 1];
        new_v[i] = median(temp);
        if(new_v[i] != v[i])
            finished = false;
    }

    v = new_v;
    return (!finished);
}

int n, type;
vector <int> v;

int solve()
{
    int ans = 0;
    while(proceed(v))
        ans++;
    return ans;
}

vector <int> answer;
int ans;

void go(int low, int high)
{
    if(high - low == 1)
        return;
    ans = max(ans, (high - low + 1) / 2);
    if(v[low] == v[high])
    {
        for(int i = low; i <= high; i++)
            answer[i] = v[low];
    }
    else
    {
        int mid = (low + high) / 2;
        for(int i = low; i <= mid; i++)
            answer[i] = v[low];
        for(int i = mid + 1; i <= high; i++)
            answer[i] = v[high];
    }
}

void two_sol()
{
    //cerr << "HERE" << endl;
    answer.resize(n);
    int last = 0;
    for(int i = 1; i < n; i++)
    {
        if(v[i] == v[i - 1])
        {
            go(last, i - 1);
            last = i;
        }
    }
    go(last, n - 1);

    cout << ans << endl;
    if(type == 1)
    {
        for(int x: answer)
            cout << x << ' ';
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> type;
    v.resize(n);
    for(int i = 0; i < n; i++)
        cin >> v[i];

    bool cool = true;
    for(int i = 0; i < n; i++)
    {
        if(v[i] > 2)
            cool = false;
    }

    if(cool)
    {
        two_sol();
        return 0;
    }

        cout << solve() << endl;
        if(type == 1)
        {
            for(int x: v)
                cout << x << ' ';
            cout << endl;
        }


    return 0;
}

/*

8 1
1 1 2 1 2 2 2 1

*/
