#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

/*bool check(int l, int r) {
	for (int i = 0; i <= r - l; i++)
		if (s[i + l] != s[r - i])
			return 0;
	return 1;
}*/

int n, t;
vector <int> a;

bool can() {
	vector <int> na = {a[0]};
	bool f = 0;
	for (int i = 1; i < n - 1; i++) {
		vector <int> b = {a[i - 1], a[i], a[i + 1]};
		sort(all(b));
		na.pb(b[1]);
		if (b[1] != a[i])
			f = 1;
	}

	na.pb(a.back());
	swap(a, na);
	return f;
}

bool check() {
	for (int i = 0; i < n; i++)
		if (a[i] > 2)
			return 0;
	return 1;
}

bool check1() {
	for (int i = 0; i < n; i++)
		if (a[i] > 100)
			return 0;
	return 1;
}

void solve1() {
	vector <pair <int, int>> kek;
	for (int i = 0; i < n; i++) {
		if (i == n - 1)
			break;
		int j = i, tp = (a[i] < a[i + 1] ? 0 : 1);
		while (j < n - 1 && (a[j] < a[j + 1] && tp == 0) || (a[j] > a[j + 1] && tp == 1)) {
			tp = tp % 2;
			j++;
		}

		if (j - i > 2)
			kek.pb({i, j - 1});
		i = j - 1;
	}

	int ans = 0;
	for (auto & i : kek) {
		ans = max(ans, (i.s - i.f) / 2);
		if (a[i.f] == a[i.s])
			for (int j = i.f + 1; j < i.s; j++)
				a[j] = a[i.f];
		else {
			int m = (i.f + i.s) / 2;
			for (int j = i.f + 1; j <= m; j++)
				a[j] = a[i.f];
			for (int j = m + 1; j <= i.s; j++)
				a[j] = a[i.s];
		}
	}

	cout << ans << endl;
	if (t == 1)
		cout << a << endl;

	exit(0);
}


void solve() {
	vector <pair <int, int>> kek;
	for (int i = 0; i < n; i++) {
		int j = i, tp = a[i];
		while (j < n && a[j] == tp) {
			tp = tp % 2 + 1;
			j++;
		}

		if (j - i > 2)
			kek.pb({i, j - 1});
		i = j - 1;
	}

	int ans = 0;
	for (auto & i : kek) {
		//cerr << i << endl;
		ans = max(ans, (i.s - i.f) / 2);
		if (a[i.f] == a[i.s])
			for (int j = i.f + 1; j < i.s; j++)
				a[j] = a[i.f];
		else {
			int m = (i.f + i.s) / 2;
			for (int j = i.f + 1; j <= m; j++)
				a[j] = a[i.f];
			for (int j = m + 1; j <= i.s; j++)
				a[j] = a[i.s];
		}
	}

	cout << ans << endl;
	if (t == 1)
		cout << a << endl;

	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	cin >> n >> t;
	a.resize(n);
	cin >> a;

	if (a.size() == 1) {
		cout << 0 << endl;
		if (t == 1)
			cout << a << endl;
		return 0;
	}	

	if (check()) 
		solve();	

	if (check1())
		solve1();

	int ans = 0;
	while (can())
		ans++;

	if (t == 1)
		return cout << ans << endl << a, 0;
	cout << ans; 
	return 0;
}