
#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
/*
int get(int i) {
	int ans = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		ans += f[i];
	return ans;
}
void add(int i, int x) {
	for (; i < MAXN; i |= (i + 1))
		f[i] += x;
}
*/
const int MAXN = 5e5 + 7;
int a[MAXN];
int b[MAXN];
int f(int a, int b, int c) {
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	if (a > b)
		swap(a, b);
	if (b > c)
		swap(b, c);
	return b;
}
int gn;
void print() {
	vector<char> ans;
	for (int i = 1; i + 1 < gn; ++i) {
		if ((a[i - 1] <= a[i] && a[i] <= a[i + 1]) || (a[i - 1] >= a[i] && a[i] >= a[i + 1]))
			ans.push_back('_');
		else if (f(a[i - 1], a[i], a[i + 1]) == a[i - 1])
			ans.push_back('-');
		else
			ans.push_back('+');
	}
	cout << string(ans.begin(), ans.end()) << "\n";
}
int solve(int n) {
	gn = n;
	int ans = 0;
	while (1) {
		++ans;
		bool ok = 0;
		b[0] = a[0];
		b[n - 1] = a[n - 1];
		for (int i = 1; i + 1 < n; ++i)
			b[i] = f(a[i - 1], a[i], a[i + 1]);
		for (int i = 0; i < n; ++i)
			if (a[i] != b[i])
				ok = 1;
		if (!ok)
			break;
		copy(b, b + n, a);
	}
	return ans - 1;
}
int bad[500000];
int solve2(int n) {
	bad[0] = 1;
	bad[n - 1] = 1;
	for (int i = 0; i < n; ++i)
		--a[i];
	for (int i = 1; i + 1 < n; ++i)
		if (a[i] == a[i - 1] || a[i] == a[i + 1])
			bad[i] = 1;
	vector<pair<int, int>> segs;
	for (int i = 1; i + 1 < n; ++i) {
		if (bad[i])
			continue;
		if (segs.size() && segs.back().y == i - 1)
			segs.back().y++;
		else
			segs.push_back({ i, i });
	}
	int ans = 0;
	for (auto s : segs) {
		int l = s.y - s.x + 1;
		ans = max(ans, (l - 1) / 2 + 1);
		fill(a + s.x, a + s.x + l / 2, a[s.x - 1]);
		fill(a + s.x + l / 2, a + s.y + 1, a[s.y + 1]);
	}
	for (int i = 0; i < n; ++i)
		++a[i];
	return ans;
}
signed main() {
	ios_base::sync_with_stdio(false);
	int n, t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (n <= 1000)
		cout << solve(n) << "\n";
	else
		cout << solve2(n) << "\n";
	if (t)
		for (int i = 0; i < n; ++i)
			cout << a[i] << " ";
	return 0;
}