#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXN = 2e5 * 4 + 1;
int tree[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }
    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void change(int v, int cl, int cr, int ind, int val)
{
    if (cl > ind || cr < ind)
        return;
    if (cl == cr)
    {
        tree[v] = val;
        return;
    }
    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, ind, val);
    change(2 * v + 1, cm + 1, cr, ind, val);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int cl, int cr, int l, int r)
{
    if (cl >= l && cr <= r)
        return tree[v];
    if (cl > r || l > cr)
        return 0;
    int cm = (cl + cr) / 2;
    return query(2 * v, cl, cm, l, r) + query(2 * v + 1, cm + 1, cr, l, r);
}

signed main()
{
    hello();

    int n, t;
    cin >> n >> t;
    vector <int> seq(n);
    bool f1 = 0;
    for (int i = 0; i < n; ++i)
    {
        cin >> seq[i];
        if (seq[i] > 2)
            f1 = 1;
    }
    int res = 0;
    if (n <= 1000)
    {
        int last = -1;
        for (int i = 1; i < n; ++i)
        {
            if (i != n - 1 && (seq[i] < seq[i - 1] && seq[i] < seq[i + 1] || seq[i] > seq[i - 1] && seq[i] > seq[i + 1]))
            {
                if (last == -1)
                    last = i;
                continue;
            }

            if (last == -1)
                continue;
            int tres = 0;
            while (true)
            {
                bool flag = 0;
                vector <int> nseq = seq;
                for (int j = last; j < i; ++j)
                {
                    vector <int> tmp = {seq[j - 1], seq[j], seq[j + 1]};
                    sort(tmp.B(), tmp.E());
                    nseq[j] = tmp[1];
                    if (seq[j] != nseq[j])
                        flag = 1;
                }
                if (!flag)
                    break;
                seq = nseq;
                ++tres;
            }
            res = max(res, tres);
        }
    }
    else if (f1 != 1)
    {
        int last = 0;
        for (int i = 0; i < n; ++i)
        {
            if (!(i == n - 1 || i != n - 1 && seq[i] == seq[i + 1]))
                continue;
            if (last == i)
            {
                last = i + 1;
                continue;
            }
            int pt = i - 1;

            res = max(res, ((i - 1) - last) / 2 + ((i - 1) - last) % 2);
            ++last;
            while (last <= pt)
            {
                seq[last] = seq[last - 1];
                seq[pt] = seq[pt + 1];
                --pt;
                ++last;
            }
            last = i + 1;
        }
    }
    else
    {
        //cout << "5 " << endl;
        int last = -1;
        for (int i = 1; i < n; ++i)
        {
            if (i != n - 1 && (seq[i] < seq[i - 1] && seq[i] < seq[i + 1] || seq[i] > seq[i - 1] && seq[i] > seq[i + 1]))
            {
                if (last == -1)
                    last = i;
                continue;
            }

            if (last == -1)
                continue;

            int maxx = 0;
            int v1 = seq[last - 1], v2 = seq[last - 1];
            int maxc = 0;
            int cnt = 0;
            for (int j = last; j <= i; ++j)
            {
                v1 = max(v1, seq[j]);
                v2 = min(v2, seq[j]);
                if (v1 == seq[j] && v2 == seq[j - 1] || v1 == seq[j - 1] && v2 == seq[j])
                {
                    ++cnt;
                }
                else
                {
                    v1 = v2 = seq[j];
                    maxc = max(maxc, cnt);
                    cnt = 1;

                }
            }

            maxc = max(maxc, cnt);
            //cout << last << " " << i << " " << maxc << endl;
            if (maxc < 2)
                res = max(res, 1ll);
            else
                res = max(res, maxc / 2);
            last = i;
        }
    }
    cout << res << endl;
    if (t)
        show(seq);
}
