#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n;
string s;

inline int check(string & s);
inline int is_pal(string & s);

signed main() {
    boot_up();

    while (cin >> n >> s) {
        solve();
    }
}

void solve() {
    ll ans = 0;

    for (int i = 0; i < n; ++i) {
        string curr = "";
        for (int j = i; j < n; ++j) {
            curr.push_back(s[j]);

            ans += check(curr);
        }
    }

    cout << ans << '\n';
}

inline int check(string & s) {
    if (len(s) % 2) {
        return 0;
    }

    string fst = s.substr(0, len(s) / 2);
    string scd = s.substr(len(s) / 2);

    return is_pal(fst) + is_pal(scd) == 2;
}

inline int is_pal(string & s) {
    string rev = s;
    reverse(all(rev));

    return rev == s;
}