#include <bits/stdc++.h>

using namespace std;
using ll = unsigned long long;
#define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
int n;
string s;
const int MAXN = 5005;
const int BASE = 239;
int h[MAXN], bases[MAXN];
int h1[MAXN];
void build(){
	bases[0] = 1;
	for (int i = 0; i < n; i++){
		bases[i + 1] = bases[i] * BASE;
		h[i + 1] = s[i] + h[i] * BASE;
	}
	reverse(ALL(s));
	for (int i = 0; i < n; i++)
		h1[i + 1] =  h1[i] * BASE + s[i];
	reverse(ALL(s));
}
int get_hash(int l, int r){
	return h[r] - h[l] * bases[r - l];
}
int get_hash1(int l, int r){
	return h1[r] - h1[l] * bases[r - l];
}
int solve(){
	if (!(cin >> n >> s))
		return 1;
	build();
	int ans = 0;
	// cout << get_hash(0, 1) << ' ' << get_hash1(n - 1, n) << '\n';
	for (int l = 1; l <= n; l++)
		for (int i = 0; i + 2 * l <= n; i++){
			// cerr << i << ' ' << i + l << ' ' << get_hash(i, i + l) << ' ' << get_hash1(n - (i + l), n - i) << '\n';
			// cerr << '\t' << n - (i + l) << ' ' << n - i << '\n';
			if (get_hash(i, i + l) != get_hash1(n - (i + l), n - i))
				continue;
			// cerr << i + l << ' ' << i + 2 * l << ' ' << get_hash(i + l, i + 2 * l) << ' ' << get_hash1(n - (i + 2 * l), n - (i + l)) << '\n';
			// cerr << '\t' << n - (i + l) << ' ' << n - i << '\n';
			
			if (get_hash(i + l, i + 2 * l) != get_hash1(n - (i + 2 * l), n - (i + l)))
				continue;
			// cout << l << ' ' << i << '\n';
			ans++;
		}
	cout << ans << '\n';
	return 0;
}
signed main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}