#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e5 + 5;
const pii P = mp(31, 53), MOD = mp(1e9 + 7, 1e9 + 9);

pii mul(pii A, pii B) {
    return mp(1ll * A.x * B.x % MOD.x, 1ll * A.y * B.y % MOD.y);
}

pii add(pii A, pii B) {
    A.x += B.x;
    if (A.x >= MOD.x) {
        A.x -= MOD.x;
    }
    if (A.x < 0) {
        A.x += MOD.x;
    }
    A.y += B.y;
    if (A.y >= MOD.y) {
        A.y -= MOD.y;
    }
    if (A.y < 0) {
        A.y += MOD.y;
    }
    return A;
}

int n;
string s;

pii p[N], h[N];

bool is_pal(int l, int r) {
    while (l < r) {
        if (s[l] != s[r]) {
            return false;
        }
        ++l, --r;
    }
    return true;
}

signed main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    p[0] = mp(1, 1);
    for (int i = 1; i < N; ++i) {
        p[i] = mul(p[i - 1], P);
    }

    cin >> n >> s;
    for (int i = 0; i < n; ++i) {
        if (i) {
            h[i] = h[i - 1];
        }
        h[i] = add(h[i], mul(mp(s[i] - 'a' + 1, s[i] - 'a' + 1), p[i]));
    }
    int ans = 0;
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r < n; r += 2) {
            int len = (r - l + 1) / 2;
            int l1 = l, r1 = l + len - 1, l2 = l + len, r2 = r;
            ans += is_pal(l1, r1) && is_pal(l2, r2);
        }
    }
    cout << ans << "\n";

    return 0;
}
