#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto start = chrono::high_resolution_clock::now();
#define end chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(end - start).count()

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<vector<int> > dp(s.size(), vector<int> (s.size() + 1));
    for (int i = 0; i < (int)s.size(); ++i) {
        dp[i][0] = dp[i][1] = 1;
    }
    for (int sz = 2; sz <= (int)s.size(); ++sz) {
        for (int l = 0; l < (int)s.size(); ++l) {
            if (l + sz - 1 < (int)s.size()) {
                int r = l + sz - 1;
                if (s[l] == s[r] && dp[l + 1][sz - 2] == 1) {
                    dp[l][sz] = 1;
                }
            }
        }
    }
    int cnt = 0;
    for (int l = 0; l < (int)s.size(); ++l) {
        for (int r = 0; r < (int)s.size(); ++r) {
            if ((r - l + 1) % 2 == 0) {
                int sz = (r - l + 1) / 2;
                if (dp[l][sz] && dp[l + sz][sz] && sz >= 1) {
                    cnt++;
                }
            }
        }
    }
    cout << cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}