// ТЯНОЧКУ БЫ

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define F first
#define S second
#define mp make_pair
//#define int long long
#define int unsigned long long

const int SZ = 5e5 + 4;
const int inf = 2e9;
const int hashpow = 127;
const int mod = 1e9 + 7;

int n;
string s;

void read() {
	cin >> n >> s;
}

int p[SZ];
int h1[SZ];
int h2[SZ];

void solve() {
	p[0] = 1;
	for (int i = 0; i < n; ++i) {
		p[i + 1] = p[i] * hashpow % mod;
	}

	h1[0] = 0;
	for (int i = 0; i < n; ++i) {
		h1[i + 1] = (h1[i] * hashpow % mod + s[i] - 'a' + 1) % mod;
	}

	reverse(s.begin(), s.end());
	h2[0] = 0;
	for (int i = 0; i < n; ++i) {
		h2[i + 1] = (h2[i] * hashpow % mod + s[i] - 'a' + 1) % mod;
	}

	auto get1 = [&](int l, int r) {
		return (h1[r] - h1[l - 1] * p[r - l + 1] % mod + mod) % mod;
	};

	auto get2 = [&](int l, int r) {
		l = n - l + 1;
		r = n - r + 1;
		swap(l, r);
		return (h2[r] - h2[l - 1] * p[r - l + 1] % mod + mod) % mod;
	};

	int ans = 0;
	for (int i = 0; i < n - 1; ++i) {
		for (int l = 1; l <= min(i + 1, n - i - 1); ++l) {
			if (get1(i - l + 2, i + 1) == get2(i - l + 2, i + 1) && get1(i + 2, i + l + 1) == get2(i + 2, i + l + 1)) {
				++ans;
			}
		}
	}
	cout << ans;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	read();
	solve();

	return 0;
}