#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

const int mod = (1e9) + 9, p = 27;
const int modsq = mod * mod;
int pref[500009];
int revp[500009];
int powp[500009];
int n;
string s;

void build() {
    powp[0] = 1;
    for (int i = 0; i < n; i ++) {
        powp[i + 1] = (powp[i] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        pref[i + 1] = (pref[i] * p + (s[i] - 'a')) % mod;
    }

    for (int i = 0; i < n; i ++) {
        revp[i + 1] = (revp[i] * p + (s[n - i - 1] - 'a')) % mod;
    }
}

int getlr(int l, int r) {
    return (pref[r + 1] - pref[l] * powp[r - l + 1] + modsq) % mod;
}

int getrev(int l, int r) {
    l = n - l - 1;
    r = n - r - 1;
    swap(l, r);

    return (revp[r + 1] - revp[l] * powp[r - l + 1] + modsq) % mod;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    cin >> s;
    build();

    vector<int> pal(n);
    vector<int> pal2(n);
    int answ = 0;
    for (int i = 0; i < n; i ++) {
        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getrev(i - m + 1, i) == getlr(i, i + m - 1)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        pal[i] = l;
    }


    for (int i = 0; i < n - 1; i ++) {
        int l = 0, r = min(i + 1, n - i - 1) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            //cout << i << ' ' << m << ' ' << getrev(i - m + 1, i ) << ' ' << getlr(i + 1, i+ m) <<  endl;
            if (getrev(i - m + 1, i) == getlr(i + 1, i + m)) {
                l = m;
            }

            else {
                r = m;
            }
        }

        //cout << l << endl;
        pal2[i] = l;
    }

    for (int i = 0; i < n; i ++) {
        for (int k = 1; k <= pal[i]; k++) {
            if (i + 2 * k - 1 < n && pal[i + 2 * k - 1] >= k) {
                answ++;
            }
        }
    }

    for (int i = 0; i < n - 1; i ++) {
        for (int k = 1; k <= pal2[i]; k++) {
            if (i + 2 * k < n - 1 && pal2[i + 2 * k] >= k) answ++;
        }
    }

    cout << answ;

    return 0;
}


