#include<bits/stdc++.h>

using namespace std;


const int N = 5002;

int dp[N][N];
        
string s;

int calc(int l, int len) {
	if (len == 0) return 1;
	if (len == 1) return 1;
	if (dp[l][len] == -1) {
		if (s[l] == s[l + len - 1]) {
			dp[l][len] = calc(l + 1, len - 2);
		} else {
			dp[l][len] = 0;
		}
	}
	return dp[l][len];
}

int solve_f(int n, string ts, int st) {
	s = ts;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			dp[i][j] = -1;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int len = st; i + 2 * len <= n; len += 2) {
			ans += (calc(i, len) & calc(i + len, len));
		}
	}
	return ans;
}              

int solve_s(int n, string ts) {
	string nw;
	for (auto t : ts) {
		nw.push_back(t);
		nw.push_back('#');
	}
	nw.pop_back();
	n = (int)nw.size();
	return solve_f(n, nw, 3);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif

	int n;
	cin >> n;
	cin >> s;
	cout << solve_f(n, s, 1) + solve_s(n, s) << endl;
}                        