#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    bool dp[n][n + 1];
    for (int len = 1; len <= n; ++len) {
        for (int i = 0; i + len <= n; ++i) {
            int j = i + len;
            if (len == 1) {
                dp[i][j] = 1;
            } else if (len == 2) {
                dp[i][j] = s[i] == s[i + 1];
            } else {
                if (s[i] == s[j - 1]) {
                    dp[i][j] = dp[i + 1][j - 1];
                } else {
                    dp[i][j] = 0;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int sz = 1; sz < n; ++sz) {
            if (i - sz < 0 || i + sz > n) {
                break;
            }
            if (dp[i - sz][i] && dp[i][i + sz]) {
                ans++;
                cout << i << " " << sz << "\n";
            }
        }
    }
    cout << ans;
    return 0;
}