#include <iostream>+
#include <vector>
#include <bitset>

#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl '\n'
#endif

using namespace std;
typedef long long ll;
const int N = 5005;

int n;
string s;
bitset<N> es[5005];

ll ans;

void update(int l, int r, bool middle){
    while(true){
        int len = r-l+1;
        if(l > 0 && es[l-1][len]) ans++;
        es[r][len] = true;
        if(l > 0 && r < n-1 && s[l-1] == s[r+1]){
            l--;r++;
        }else return;
    }
}

int32_t main(){
    header;
    cin >> n >> s;
    for(int i = 0; i < n; i++){
        update(i, i, true);
        if(i + 1 < n && s[i] == s[i+1]) update(i, i+1, false);
    }
    cout << ans << endl;
    return 0;
}
