#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 2e5;

bool is_pal(string s) {
	bool flag = 1;
	int k = (int)s.size() / 2;
	if ((int)s.size() % 2 == 1) {
		for (int i = 0; i <= k; ++i) {
			flag &= s[k - i] == s[k + i];
		}
	} else {
		for (int i = 0; i < k; ++i) {
			flag &= s[k + i] == s[k - 1 - i];
		}
	}
	// cout << s << " " << flag << "\n";
	return flag;
}

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int ans = 0;
	for (int l = 0; l < n; ++l) {
		for (int r = l; r < n; ++r) {
			if ((r - l + 1) % 2 == 0) {
				int mid = (l + r) / 2;
				// cout << "\t" << l << " " << r << "\n";
				// cout << s.substr(l, mid - l + 1) << "\n";
				// cout << s.substr(mid + 1, r - mid) << "\n";
				ans += is_pal(s.substr(l, mid - l + 1)) &&
					   is_pal(s.substr(mid + 1, r - mid));
			}
		}
	}
	cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 2;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}