#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 2e5+10;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

bool ispal[5010][5010];

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    string s; cin >> s;
    For (i, n) {
        int lidx = i, ridx = i;
        while (lidx >= 0 && ridx <= n && s[lidx] == s[ridx]) {
            ispal[lidx][ridx-lidx+1] = true;
            lidx--; ridx++;
        }
        lidx = i, ridx = i+1;
        while (lidx >= 0 && ridx <= n && s[lidx] == s[ridx]) {
            ispal[lidx][ridx-lidx+1] = true;
            lidx--; ridx++;
        }
    }

    int ans = 0;
    for (int len = 1; len <= n; len++) {
        For (i, n) {
            int nxt = i + len;
            if (nxt + len > n) break;
            if (ispal[i][len] && ispal[nxt][len])
                ans++;
        }
    }
    cout << ans << endl;
}
