#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

ll p = 127;

vector<ll> h, pws, rh;

void precalc(string &s) {
    ll n = s.size();
    h.resize(n);
    rh.resize(n);
    pws.resize(n + 1);
    pws[0] = 1;
    for (int i = 1; i <= n; ++i) {
        pws[i] = (pws[i - 1] * p) % mod;
    }
    h[0] = s[0];
    for (int i = 1; i < n; ++i) {
        h[i] = (h[i - 1] * p + s[i]) % mod;
    }
    reverse(s.begin(), s.end());
    rh[0] = s[0];
    for (int i = 1; i < n; ++i) {
        rh[i] = (rh[i - 1] * p + s[i]) % mod;
    }
    reverse(s.begin(), s.end());
}

ll get(ll l, ll r) {
    ll hash = h[r];
    if (l != 0) {
        hash -= (h[l - 1] * pws[r - l + 1]) % mod;
        hash += mod;
        hash %= mod;
    }
    return hash;
}

ll getr(ll l, ll r) {
    ll newr = h.size() - 1 - l;
    ll newl = h.size() - 1 - r;
    l = newl, r = newr;
    ll hash = rh[r];
    if (l != 0) {
        hash -= (rh[l - 1] * pws[r - l + 1]) % mod;
        hash += mod;
        hash %= mod;
    }
    return hash;
}

bool ispal(ll l, ll r) {
    if ((r - l + 1) % 2) {
        ll mid = (l + r) / 2;
        return (get(mid, r) == getr(l, mid));
    }
    else {
        ll mid = (l + r) / 2;
        return (get(mid + 1, r) == getr(l, mid));
    }
}

signed main() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    precalc(s);
//    for(int len = 1; len < n; ++len) {
//        for(int i = 0; i < n; ++i) {
//            if(i + len - 1 < n) {
//                cout << i << ' ' << i + len - 1 << ' ' << ispal(i, i + len - 1) << '\n';
//            }
//        }
//    }
    ll ans = 0;
    for (int len = 1; len < n; ++len) {
        for (int i = len - 1; i < n - len; ++i) {
            if (ispal(i - len + 1, i) && ispal(i + 1, i + len)) {
                ++ans;
            }
        }
    }
    cout << ans;
}