//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

const int MOD = 228228227;
const int pc = 37;

struct STRING_HASH {
	vector<long long> h;
	vector<long long> p;
	STRING_HASH(const string &s) {
		int n = s.size();
		h.resize(n + 1);
		p.resize(n + 1);
		p[0] = 1;
		for (int i = 1; i <= n; ++i) {
			h[i] = ((h[i - 1] * pc) % MOD + s[i - 1]) % MOD;
			p[i] = (p[i - 1] * pc) % MOD;
		}
	}

	long long get(const int &l, const int &r) {
		return ((h[r] - h[l - 1] * p[r - l + 1]) % MOD + MOD) % MOD;
	}
};

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n;
	cin >> n;
	string s, sr;
	cin >> s;
	sr = s;
	reverse(sr.begin(), sr.end());
	STRING_HASH strh(s);
	STRING_HASH strhr(sr);
	long long ans = 0;
	for (int l = 1; l <= n; ++l) {
		for (int r = l + 1; r <= n; r += 2) {
			int m = (l + r) / 2;
			if (strh.get(l, m) == strhr.get(n - m + 1, n - l + 1) && strh.get(m + 1, r) == strhr.get(n - r + 1, n - m)) {
				++ans;
			}
		}
	}
	cout << ans;
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}