#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<vector<int>> dp;
    for(int i =0 ; i < n; i++){
        dp.push_back({});
        for (int j = 0; j < n; j++){
            dp[i].push_back(0);
            if (i == j){
                dp[i][j] = 1;
            }
        }
    }
    for (int l = 1; l < n; l++){
        for (int i = 0; i + l < n; i++){
            int j = i + l;
            if ((l == 1 || dp[i + 1][j - 1] == 1) && s[i] == s[j]){
                dp[i][j] = 1;
            }
        }
    }
    int ans =0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j += 2){
            int l = (j - i + 1) / 2;
            if (dp[i][i + l - 1] && dp[i + l][j]){
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}