#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 5e5 + 100;
int can[MAXN];

ll solve(string s) {
	int n = s.length();
	ll ans = 0;
	fill(can, can + n, 0);
	int l = 0, r = 0;
	for (int i = 1; i < n; ++i) {
		if (i <= r) {
			int m = (r + l) / 2;
			can[i] = max(0, min(can[m - (i - m)], min(i - l, r - i)));
		}
		while (i - (can[i] + 1) >= 0 && i + (can[i] + 1) < n && s[i - (can[i] + 1)] == s[i + (can[i] + 1)]) {
			can[i]++;
		}
		if (i + can[i] > r) {
			l = i - can[i];
			r = i + can[i];
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j <= min(n - 1, i + 1 + 2 * can[i]); j += 2) {
			if (2 * can[j] - j + 1 >= -i) {
				ans++;
			}
		}
	}
	fill(can, can + n, -1);
	l = 0, r = 0;
	for (int i = 1; i < n; ++i) {
		if (i <= r) {
			int m = (r + l) / 2 + 1;
			can[i] = max(-1, min(can[m - (i - m)], min(i - l - 1, r - i)));
		}
		while (i - (can[i] + 2) >= 0 && i + (can[i] + 1) < n && s[i - (can[i] + 2)] == s[i + (can[i] + 1)]) {
			can[i]++;
		}
		if (i + can[i] > r) {
			l = i - can[i] - 1;
			r = i + can[i];
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 2; j <= min(n - 1, i + 2 + 2 * can[i]); j += 2) {
			if (2 * can[j] - j + 2 >= -i) {
				ans++;
			}
		}
	}
	return ans;
}

signed main() {
	FAST_IO();
	int n;
	string s;
	cin >> n >> s;
	ll ans = solve(s);
	cout << ans << '\n';
}