#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n; cin >> n;
	vector <vector <bool>> a(n, vector <bool>(n, 0));

	string s; cin >> s;
	FR(i, n) {
	
		int L = i, R = i;
		a[L][R] = 1;
		while (L > 0 && R < n - 1) {
		
			L--, R++;
			if (s[L] == s[R]) a[L][R] = 1;
			else break;

		}

	}
	FR(i, n) {

		int L = i + 1, R = i;
		while (L > 0 && R < n - 1) {

			L--, R++;
			if (s[L] == s[R]) a[L][R] = 1;
			else break;

		}

	}

	ll ans = 0;
	FR(L, n) {
	
		FOR(R, L, n) {
		
			if ((R - L + 1) % 2 == 0 && a[L][(L + R) / 2] && a[(L + R) / 2 + 1][R]) ans++;

		}

	}

	cout << ans;

	return 0;
}