#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
ll mod = 1e9 + 7;
ll p = 239;
const ll MN = 5e3;
ll hsh1[MN];
ll hsh2[MN];
ll St[MN];

void precalc(string &s) {
    hsh1[0] = s[0];
    ll st = 1;
    int n = s.size();
    hsh2[s.size() - 1] = s.back();
    St[0] = 1;
    for (int i = 1; i < s.size(); i++) {
        st = (st * p) % mod;
        St[i] = st;
        hsh1[i] = (hsh1[i - 1] + (s[i] * st) % mod) % mod;
        hsh2[n - i - 1] = (hsh2[n - i] + (s[n - i - 1] * st) % mod) % mod;

    }
}

int N;

pair<ll, ll> gtHash(ll l, ll r, bool first) {
    if (first) {
        if (!l)
            return {hsh1[r], 0};
        else
            return {(hsh1[r] - hsh1[l - 1] + mod) % mod, l};
    }
    if (r == N - 1)
        return {hsh2[l], 0};
    else
        return {(hsh2[l] - hsh2[r + 1] + mod) % mod, N - 1 - r};
}

bool eq(ll x1, ll st1, ll x2, ll st2) {
    if (st1 < st2) {
        swap(st1, st2);
        swap(x1, x2);
    }
    x2 = (x2 * St[st1 - st2]) % mod;
//    cout << st1 << ' ' << st2 << endl;
//    cout << x1 << ' ' << x2 << endl;
    return x1 == x2;
}

bool palindrom(int l, int r) {
    auto[x1, st1] = gtHash(l, r, true);
    auto[x2, st2] = gtHash(l, r, false);
    return eq(x1, st1, x2, st2);
}

int main() {
    int n;
    cin >> n;
    N = n;
    string s;
    cin >> s;
    precalc(s);
//    cout << palindrom(0, 0) << endl;
//    return 0;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j += 2) {
            int m = (i + j) / 2;
            if (palindrom(i, m) && palindrom(m + 1, j))
                ans++;
        }
    }
    cout << ans;
}