#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

bool check(string& st)
{
    for(int i = 0; i < st.size() / 2; i++)
    {
        if(st[i] != st[st.size() - 1 - i])
            return 0;
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    string st;
    cin >> st;

    ll answ = 0;
    for(int l = 0; l < n; l++)
    {
        for(int r = l + 1; r < n; r++)
        {
            int len = r - l + 1;
            if(len % 2 == 1)
                continue;

            string cur1 = "";
            string cur2 = "";
            for(int i = l; i <= r; i++)
            {
                if(i - l < len / 2)
                    cur1 += st[i];
                else
                    cur2 += st[i];
            }

           // cerr << "cur1 " << cur1 << " cur2 " << cur2 << endl;
            if(check(cur1) && check(cur2))
            {
            //    cerr << "l " << l << " r " << r << endl;
                answ++;
            }
        }
    }
    cout << answ << endl;
    return 0;
}