﻿#ifdef LOCAL
    #include <C:\bits\stdc++.h>
#else
    #include <bits/stdc++.h>
#endif
using namespace std;
typedef long long ll;
#define int long long
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vii;
#define all(a) (a).begin(), (a).end()

const ll MOD = 1e9 + 7;

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector <vector<bool>> pal(n, vector <bool>(n));
    for (int i = 0; i < n; ++i) {
        pal[i][i] = 1;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (s[i] == s[i + 1]) {
            pal[i][i + 1] = 1;
        }
    }
    for (int len = 3; len <= n; ++len) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;
            pal[l][r] = (s[l] == s[r] && pal[l + 1][r - 1]);
        }
    }
    int ans = 0;
    for (int len = 2; len <= n; len += 2) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;
            ans += (pal[l][l + (len / 2) - 1] && pal[l + (len / 2)][r]);
        }
    }
    cout << ans;
    return 0;
}