#include <bits/stdc++.h>
#define int long long
#define ld long double
#define fs first
#define sc second
#define vc vector
#define pr pair
#define pb push_back
#define mp make_pair
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()
#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using namespace std;
const int MAXN = 5e5 + 10;

pr<int, int> t[4 * MAXN];
int h[MAXN], hr[MAXN];
int p[MAXN];
pr<int, int> sums(pr<int, int> a, pr<int, int> b){
	return {a.fs + b.fs, a.sc + b.sc};
}

void build(int v, int l, int r){
	t[v] = {0, 0};
	if (l == r){
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
}

void upd(int v, int l, int r, int pos, pr<int, int> news){
	if (l == r && r == pos){
		t[v] = sums(t[v], news);
		return;
	}
	if (pos < l || r < pos){
		return;
	}
	int mid = (l + r) / 2;
	upd(2 * v, l, mid, pos, news);
	upd(2 * v + 1, mid + 1, r, pos, news);
	t[v] = sums(t[2 * v], t[2 * v + 1]);
}

pr<int, int> gets(int v, int l, int r, int tl, int tr){
	if (tl <= l && r <= tr){
		return t[v];
	}
	if (tr < l || r < tl){
		return {0, 0};
	}
	int mid = (l + r) / 2;
	return sums(gets(2 * v, l, mid, tl, tr), gets(2 * v + 1, mid + 1, r, tl, tr));
}

const int MOD = 1e9+7;
const int P = 101;

int sum(int a, int b){
	if (a + b >= MOD){
		return a + b - MOD;
	}
	return a + b;
}

int mul(int a, int b){
	return (a * b) % MOD;
}

int n;
int get_hashr(int l, int r){
	return mul(sum(h[r + 1], MOD - h[l]), p[n - r]);
}

int get_hashrr(int l, int r){
	return mul(sum(hr[r + 1], MOD - hr[l]), p[n - r]);
}

int get_hashc(int l, int r){
	return get_hashrr(n - 1 - r, n - 1 - l);
}
void solve(istream &in, ostream &out){
	in >> n;
	string s;
	in >> s;
	p[0] = 1;
	for (int i = 0; i < n; i++){
		p[i + 1] = mul(p[i], P);
		h[i + 1] = mul(h[i], mul(p[i], s[i]));
		hr[i + 1] = mul(hr[i], mul(p[i], s[n - 1 - i]));
	}
	int ans = 0;
	{
		//onepart
		vc<int> maxpal(n);
		vc<pr<int, int>> sexter;
		for (int i = 0; i + 1 < n; i++){
			int l = 0;
			int r = min(i, n - 2 - i) + 2;	
			while(r - l > 1){
				int mid = (l + r) / 2;
				if (get_hashr(i + 1, i + mid) == get_hashc(i, i - mid)){
					l = mid;		
				}
				else{
					r = mid;
				}
			}
			maxpal[i] = l;
			sexter.pb({maxpal[i], i});
			//out << maxpal[i] << ' ' << i << endl;
		}	
		sort(all(sexter));
		reverse(all(sexter));
		build(1, 0, n);
		for (auto v : sexter){
			pr<int, int> kek = gets(1, 0, n, v.sc - 2 * v.fs, v.sc + 2 * v.fs);
			//out << "kek" << kek.fs << ' ' << kek.sc << endl;
			pr<int, int> mem = {0, 0};
			if (v.sc % 2 == 0){
				mem.fs++;
				ans += kek.fs;
			}
			else{
				mem.sc++;
				ans += kek.sc;
			}
			upd(1, 0, n, v.sc, mem);
		}
		for (int i = 0; i < n - 1; i++){
			for (int j = i + 2; j < n - 1 && j <= i + 2 * maxpal[i]; j += 2){
				if (j - 2 * maxpal[j] <= i){
					//ans++;
				}
			}
		}
	}
	{
		//onepart
		vc<int> maxpal(n);
		vc<pr<int, int>> sexter;
		for (int i = 0; i < n; i++){
			int l = 0;
			int r = min(i, n - 1 - i) + 2;	
			while(r - l > 1){
				int mid = (l + r) / 2;
				if (get_hashr(i, i + mid) == get_hashc(i, i - mid)){
					l = mid;		
				}
				else{
					r = mid;
				}
			}
			maxpal[i] = l;
			sexter.pb({maxpal[i], i});
		}
		sort(all(sexter));
		reverse(all(sexter));
		build(1, 0, n);
		for (auto v : sexter){
			pr<int, int> kek = gets(1, 0, n, v.sc - 2 * v.fs + 1, v.sc + 2 * v.fs - 1);
			//out << "kek" << kek.fs << ' ' << kek.sc << endl;
			pr<int, int> mem = {0, 0};
			if (v.sc % 2 == 0){
				mem.fs++;
				ans += kek.sc;
			}
			else{
				mem.sc++;
				ans += kek.fs;
			}
			upd(1, 0, n, v.sc, mem);
		}
		for (int i = 0; i < n; i++){
			for (int j = i + 1; j < n && j <= i + 2 * maxpal[i] - 1; j += 2){
				if (j - (2 * maxpal[j] - 1) <= i){
					//ans++;
				}
			}
		}
	}
	out << ans;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve(cin, cout);
}