#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0); 
}

#define int ll

int n;
string s;

bool is_palindrome(int l, int r) {
	r--;
	int j = r;
	for (int i = l; i < j; i++) {
		if (s[i] != s[j]) {
			return 0;
		}
		j--;
	}
	return 1;
}

inline void solve() {
	cin >> n;
	cin >> s;
	int ans = 0;
	for (int l = 0; l < n; l++) {
		for (int r = l + 4; r <= n; r += 2) {
			int mid = (l + r) / 2;
			ans += is_palindrome(l, mid) && is_palindrome(mid, r);
		}
	}
	cout << ans + n - 1;

}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}