#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <deque>
#include <string>
#include <cmath>


#define x first
#define y second
#define int long long


typedef long long ll;
typedef long double ld;


using namespace std;


const int maxn = 5e5 + 10;
int p[maxn];
const int mod = 1e9 + 7;
const int x = 37;


int get(vector<int> &h, int l, int r) {
    //cout << "\t" << (h[r] - h[l] * p[r - l] + mod * mod) % mod << endl;
    return (h[r] - h[l] * p[r - l] + mod * mod) % mod;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	string s;
	cin >> s;
    vector<int> h(1);
    vector<int> hr(1);
    p[0] = 1;
    for (int i = 1; i <= n; i++)
        p[i] = p[i - 1] * x % mod;
    for (int i = 0; i < n; i++) {
        h.push_back((s[i] - 'a' + 1 + h.back() * x) % mod);
    }
    for (int i = n - 1; i >= 0; i--) {
        hr.push_back((s[i] - 'a' + 1 + hr.back() * x) % mod);
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((j - i + 1) % 2 == 0) {
                if (get(h, i, i + (j - i + 1) / 2) == get(hr, n - (i + (j - i + 1) / 2 - 1) - 1, n - i) && get(hr, n - j - 1, n - j - 1 + (j - i + 1) / 2) == get(h, i + (j - i + 1) / 2, j + 1))
                    ans++;
            }
        }
    }
    cout << ans;
	//system("pause");
	return 0;
}

