#include <bits/stdc++.h>

using namespace std;

#define endl "\n"
#define int long long

int mod = 1791791791, p = 57;
string s;
int n;
vector<int> hs, pw, rwhs;

void init() {
    hs.resize(n + 1);
    rwhs.resize(n + 1);
    pw.resize(n + 1);
    hs[0] = 0;
    rwhs[0] = 0;
    pw[0] = 1;
    for (int i = 1; i <= n; i++) {
        hs[i] = hs[i - 1] * p + s[i - 1];
        rwhs[i] = rwhs[i - 1] * p + s[n - i];
        pw[i] = pw[i - 1] * p;
        hs[i] %= mod;
        rwhs[i] %= mod;
        pw[i] %= mod;
    }
    return;
}

int HS(int i, int j) {
    return (mod + hs[j + 1] - ((hs[i] * pw[j - i + 1]) % mod)) % mod;
}

int rwHS(int i, int j) {
    return (mod + rwhs[n - i] - ((rwhs[n - j - 1] * pw[(n - i - 1) - (n - j - 1) + 1]) % mod)) % mod;
}



int32_t main()
{
    cin >> n;
    cin >> s;
    init();
    vector<vector<bool>> used(n, vector<bool>(n));
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (HS(i, j) == rwHS(i, j)) {
                used[i][j] = true;
            }
        }
    }

    int ans = 0;
    for (int i = 1; i < n; i++) {
        vector<int> left, right;
        for (int j = i - 1; j >= 0; j--) {
            if (used[j][i - 1]) {
                left.push_back(i - j);
            }
        }
        for (int j = i; j < n; j++) {
            if (used[i][j]) {
                right.push_back(j - i + 1);
            }
        }
        int ii = 0, jj = 0;
        while (ii < left.size() && jj < right.size()) {
            if (left[ii] < right[jj]) {
                ii++;
                continue;
            }
            if (left[ii] > right[jj]) {
                jj++;
                continue;
            }
            if (left[ii] == right[jj]) {
                ans++;
                ii++;
                jj++;
                continue;
            }
        }
        for (; ii < left.size(); ii++) {
            if (left[ii] == right[jj - 1]) ans++;
        }
        for (; jj < right.size(); jj++) {
            if (left[ii - 1] == right[jj]) ans++;
        }
    }
    cout << ans << endl;
    return 0;
}
