#include <bits/stdc++.h>

#define ft first
#define sc second
#define int ll
#define len(v) (int)v.size()

using namespace std;
typedef long long ll;

int n;
vector<int> hsh;
vector<int> hshr;
vector<int> step;
int p = 239;
int mod = 1e9 + 7;

int get(int l, int r) {
	int ans = (hsh[r + 1] - (hsh[l] * step[r - l + 1]) % mod + mod) % mod;
	return ans;
}

int getr(int l, int r) {
	int ans = (hshr[r + 1] - (hshr[l] * step[r - l + 1]) % mod + mod) % mod;
	return ans;
}

bool check(int l, int r) {
	int hsh1 = get(l, r);
	int hsh2 = getr(n - 1 - r, n - 1 - l);
	if(hsh1 == hsh2) 
		return 1;
	return 0;
}

signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	string s;
	cin >> s;
	auto sr = s;
	reverse(sr.begin(), sr.end());
	int ans = 0;
	hsh = vector<int> (n + 1, 0);
	hshr = vector<int> (n + 1, 0);
	step = vector<int> (n + 1, 1);
	for (int i = 0; i < n; i++) {
		hsh[i + 1] = (hsh[i] * p + s[i]) % mod;
		hshr[i + 1] = (hshr[i] * p + sr[i]) % mod;
		step[i + 1] = (step[i] * p) % mod;
	}

	vector<int> max(n + 1, 1);
	for (int i = 0; i < n; i++) {
		int l = 1, r = min(i, n - 1 - i) + 2;
		while(r - l > 1) {
			int mid = (l + r) / 2;
			if(check(i - mid + 1, i + mid - 1)) 
				l = mid;
			else
				r = mid;
		}
		// cout << i << " " << l << endl;
		max[i] = l;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 1; j <= max[i]; j++) {
			int pos = i - 2 * j + 1;
			if(pos < 0) 
				break;
			if(max[pos] >= j) 
				ans++;
		}
	}
	// cout << endl;
	max = vector<int> (n + 1, 0);
	for (int i = 0; i < n - 1; i++) {
		int l = 0, r = min(i + 1, n - 1 - i) + 1;
		while(r - l > 1) {
			int mid = (l + r) / 2;
			if(check(i - mid + 1, i + mid))
				l = mid;
			else
				r = mid;
		}
		// cout << i << " " << l << endl;
		max[i] = l;
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = 1; j <= max[i]; j++) {
			int pos = i - 2 * j;
			if(pos < 0) 
				break;
			if(max[pos] >= j)
				ans++;
		}
	}
	cout << ans << endl;
}	
