//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "  ";

const ll p = 37;
const ll mod = 1e9 + 9;

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector<ll> poww;

ll gh(vector<ll> &h, ll L, ll R)
{
    if (L == 0)
        return h[R];
    ll ans = h[R] - h[L - 1] * poww[R - L + 1];
    ans %= mod;
    while (ans < 0)
        ans += mod;
    return ans;
}

vector<ll> h1, h2;

vector<ll> gh(string s)
{
    vector<ll> ans(s.size());
    ans[0] = s[0] - 'a' + 1;
    for (int i = 1; i < s.size(); i++)
    {
        ans[i] = ans[i - 1] * p + s[i] - 'a' + 1;
        ans[i] %= mod;
    }
    return ans;
}

ll n;

bool pal(ll l, ll r)
{
    if (l == r)
        return true;
    ll H1 = gh(h1, l, r);
    ll H2 = gh(h2, n - r - 1, n - l - 1);
    return (H1 == H2);
}

bool pal2(ll l, ll r)
{
    ll m = (l + r) / 2;
    return (pal(l, m) && pal(m + 1, r));
}

int main()
{
    fast();
    poww.resize(500001, 1);
    for (int i = 1; i < poww.size(); i++)
    {
        poww[i] = poww[i - 1] * p;
        poww[i] %= mod;
    }
    cin >> n;
    h1.resize(n);
    h2.resize(n);
    string s;
    cin >> s;
    h1 = gh(s);
    reverse(all(s));
    h2 = gh(s);
    reverse(all(s));
    ll ans = 0;
    for (ll len = 2; len <= n; len += 2)
    {
        for (ll L = 0; L + len - 1 < n; L++)
        {
            ll R = L + len - 1;
            if (pal2(L, R))
                ans++;
        }
    }
    cout << ans;
}
