#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &a, const T2 &b) {if (a > b) a = b;}
template<class T1, class T2> inline void chkmax(T1 &a, const T2 &b) {if (a < b) a = b;}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";
const int MAXN = 500228;
const int Mod = 1000000007;
const int P = 424243;


int mul(int a, int b) {
	return (ll)a * b % Mod;
} 


int sum(int a, int b) {
	return (a + b >= Mod ? a + b - Mod: a + b);
}

int p[MAXN];
int n;
string s;
int len[MAXN], len1[MAXN];
int h[MAXN], rh[MAXN];


int gethash(int l, int r) {
	return sum(h[r], Mod - (l > 0 ? mul(h[l - 1], p[r - l + 1]): 0));
}

int gethashr(int l, int r) {
	return sum(rh[r], Mod - (l > 0 ? mul(rh[l - 1], p[r - l + 1]): 0));
}


int getrhash(int l, int r) {
	return gethashr(n - r - 1, n - l - 1);
}



struct fenwick
{
	vector<int> f;
	void init(int n) {
		f.resize(n, 0);
	}
	void inc(int i, int val) {
		for (; i < sz(f); i |= (i + 1)) {
			f[i] += val;
		}
	}
	int get(int i) {
		int ans = 0;
		for (; i >= 0; i = (i & (i + 1)) - 1) {
			ans += f[i];
		}
		return ans;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
} f[2], f1[2];

int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	cin >> n;
	cin >> s;
	p[0] = 1;
	for (int i =1; i <= n; i++) {
		p[i] = mul(p[i - 1], P);
	}
	int curh = 0;
	for (int i = 0; i < n; i++) {
		curh = sum(mul(curh, P), s[i]);
		h[i] = curh;
	}
	curh = 0;
	for (int i = 0; i < n; i++) {
		curh = sum(mul(curh, P), s[n - i - 1]);
		rh[i] = curh;
	}
	for (int i = 0; i < n; i++) {
		int l = 1;
		int r = min(i + 1, n - i);
		while (l < r) {
			int mid = (l + r + 1) >> 1;
			if (gethash(i, i + mid - 1) != getrhash(i - mid + 1, i)) {
				r = mid - 1;
			} else {
				l = mid;
			}
		}
		len[i] = l;
		//cout << len[i] << endl;
	}
	for (int i = 0; i < n - 1; i++) {
		if (s[i] != s[i+ 1]) {
			continue;
		}
		int l = 1;
		int r = min(i + 1, n - i - 1);
		while (l < r) {
			int mid = (l + r + 1) >> 1;
			if (gethash(i + 1, i + mid) != getrhash(i - mid + 1, i)) {
				r = mid - 1;
			} else {
				l = mid;
			}
		}
		len1[i] = l;
		//cout << len1[i] << endl;
	}
	ll ans = 0;
	vector<pair<int, int> > g;
	for (int i = 0; i < n; i++) {
		g.pb({len[i], i});
	}
	sort(all(g));
	reverse(all(g));
	f[0].init(n);
	f[1].init(n);
	for (int it = 0; it < sz(g); it++) {
		int i = g[it].second;
		int l = i - 2 * len[i] + 1;
		int r = i + 2 * len[i] - 1;
		chkmax(l, 0);
		chkmin(r, n - 1);
		//cout << f[(i & 1) ^ 1].get(l, r) << endl;
		ans += f[(i & 1) ^ 1].get(l, r);
		f[i &1].inc(i, 1);
	}
	g.clear();
	for (int i = 0; i < n - 1; i++) {
		g.pb({len1[i], i});
	}
	sort(all(g));
	reverse(all(g));
	f1[0].init(n);
	f1[1].init(n);
	for (int it = 0; it < sz(g); it++) {
		int i = g[it].second;
		int l = i - 2 * len1[i];
		int r = i + 2 * len1[i];
		chkmax(l, 0);
		chkmin(r, n - 1);
		ans += f1[i & 1].get(l, r);
		f1[i &1].inc(i, 1);
	}
	cout << ans << endl;
	return 0;
}