#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

void solve(){
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<vector<bool> >dp(n, vector<bool>(n));
    for(int i = 0; i < n; i++){
        dp[i][i] = 1;
    }
    for(int i = 0; i < n - 1; i++){
        dp[i][i + 1] = (s[i] == s[i + 1]);
    }
    for(int step = 2; step <= n - 1; step++){
        for(int l = 0; l <= n - 1 - step; l++){
            int r = l + step;
            if(s[l] == s[r]){
                dp[l][r] = dp[l + 1][r - 1];
            }
            else{
                dp[l][r] = 0;
            }
        }
    }
    ll ans = 0;
    for(int l = 0; l < n; l++){
        for(int r = l + 1; r < n; r += 2){
            if(dp[l][(l + r) / 2] && dp[(l + r) / 2 + 1][r]){
                ans++;
            }
        }
    }
    cout << ans;
}

int main()
{
    QuickStart();
    solve();
    return 0;
}
