#include <bits/stdc++.h>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define endl '\n'
#define ll long long
#define int ll

using namespace std;
const int MOD = 1e9+7, Hash = 31, MAXN = 5e5+228;
int pows[MAXN];
struct HASH{
    int n;
    string s, revs;
    vector<int> h,revh;
    HASH(){}
    HASH(string _s){
        s = _s;
        //revs = s;
        n = s.size();
        //reverse(revs.begin(),revs.end());
        h.resize(n+1);
        revh.resize(n+1);
    }
    void build(){
        for(int i = 1, j = MAXN-1; i <= n;i++,j--){
            h[i] = h[i-1];
            h[i] += pows[j]*(s[i-1]-'a'+1);
            h[i]%=MOD;
            revh[i] = revh[i-1];
            revh[i] += pows[i]*(s[i-1]-'a'+1);
            revh[i]%=MOD;
        }
    }
    bool check(int l, int r)
    {
        int first = h[r] - h[l-1];
        first%=MOD;
        first += MOD;
        first%=MOD;
        int second = revh[r] - revh[l-1];
        second%=MOD;
        second += MOD;
        second%=MOD;
        int st1 = MAXN;
        st1-=l;
        int st2 = r;
        if(st1 < st2){
            swap(first,second);
            swap(st1,st2);
        }
        int need = st1-st2;
        second*=pows[need];
        second%=MOD;
        return (first == second);
    }

};
signed main()
{
    fast;
    freopen("input.txt","r",stdin);
    pows[0] = 1;
    for(int i = 1; i < MAXN;i++){
        pows[i] = pows[i-1];
        pows[i]*=Hash;
        pows[i]%=MOD;
    }
    int n;
    cin >> n;
    string s;
    cin >> s;
    HASH tmp(s);
    tmp.build();
    ll answer = 0;
    for(int i = 0; i < n;i++){
        for(int j = i+1; j < n;j+=2){
            int mid = (i+j+1)/2;
            if(tmp.check(i+1,mid) && tmp.check(mid+1,j+1)){
                answer++;
                //cout << i+1 << " " << j+1 << endl;
            }
        }
    }
    cout << answer << endl;
    return 0;
}