#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")
#endif
using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

vector<int> f;
void init(int n) {
    f.assign(n, 0);
}
void upd(int i) {
    for (; i < (int)f.size(); i = (i | (i + 1)))
        f[i]++;
}
int sum(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
        ans += f[r];
    return ans;
}
int sum(int l, int r) {
    return sum(r) - sum(l - 1);
}
const int maxn = 500'000;
vector<pair<int, int>> b[maxn];
int ans = 0;
void man1(string s) {
    int n = (int)s.size();
    vector<int> a(n);
    forn(i, n) b[i].clear();
    for (int i = 1, l = 0, r = 0; i < n; ++i) {
        if (r >= i)
            a[i] = min(a[l + r - i], r - i);
        for (int j = a[i] + 1; i + j < n && i - j >= 0; j++) {
            if (s[i + j] != s[i - j]) break;
            a[i]++;
        }
        if (i + a[i] > r) l = i - a[i], r = i + a[i];
        b[i].emplace_back(i, 1);
        if (i + a[i] + a[i] + 2 < n) b[i + a[i] + a[i] + 2].emplace_back(i, -1);
    }
    init(n + n);
    for (int i = n - 1; i > 0; i -= 2) {
        upd(a[i] + (n - 1 - i) / 2);
        for (auto j : b[i - 1]) {
            ans += j.y * sum((n - 2 - j.x) / 2, n + n - 1);
        }
    }
    init(n + n);
    for (int i = n - 2; i > 0; i -= 2) {
        upd(a[i] + (n - 2 - i) / 2);
        for (auto j : b[i - 1]) {
            ans += j.y * sum((n - 3 - j.x) / 2, n + n - 1);
        }
    }
}
void man2(string s) {
    int n = (int)s.size();
    vector<int> a(n);
    forn(i, n) b[i].clear();
    for (int i = 1, l = 0, r = 0; i < n; i++) {
        if (r >= i)
            a[i] = min(a[l + r - i], r - i);
        for (int j = a[i] + 1; i + j - 1 < n && i - j >= 0; j++) {
            if (s[i + j - 1] != s[i - j]) break;
            a[i]++;
        }
        if (i + a[i] > r) l = i - a[i], r = i + a[i];
        b[i].emplace_back(i, 1);
        if (i + a[i] + a[i] < n - 1) b[i + a[i] + a[i]].emplace_back(i, -1);
    }
    init(n + n);
    for (int i = n - 1; i > 1; i -= 2) {
        upd(a[i] + (n - 1 - i) / 2);
        for (auto j : b[i - 2]) {
            ans += j.y * sum(1 + (n - 3 - j.x) / 2, n + n - 1);
        }
    }
    init(n + n);
    for (int i = n - 2; i > 1; i -= 2) {
        upd(a[i] + (n - 2 - i) / 2);
        for (auto j : b[i - 2]) {
            ans += j.y * sum(1 + (n - 4 - j.x) / 2, n + n - 1);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    man1(s);
    man2(s);
    if (n >= 2) ans++;
    cout << ans << el;
    return 0;
}