#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 5007;

bool pal[N][N];

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  string s;
  cin >> s;
  for (int i = 0; i < n; i++) {
    pal[i][i] = true;
  }
  for (int i = 0; i < n; i++) {
    for (int j = i - 2; j >= 0; j--) {
      if (s[i] == s[j]) {
        pal[j][i] = true;
        if (j + 1 <= i - 1) pal[j][i] &= pal[j + 1][i - 1];
      }
    }
  }
  int ans = 0;
  for (int l = 0; l < n; l++) {
    for (int r = l + 1; r < n; r++) {
      int len = r - l + 1;
      if (len % 2) continue;
      if (pal[l][l + len / 2 - 1] && pal[l + len / 2][r]) {
        ans++;
      }
    }
  }
  cout << ans << endl;
  return 0;
}
