#include <bits/stdc++.h>
#define int long long
#define endl '\n'

// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC target("avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	fast();

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

void solve() {

	int n;
	cin >> n;

	string s;
	cin >> s;

	vector <int> max_pol_nch(n);
	vector <int> max_pol_ch(n);

	for (int i = 0; i < n; ++i) {
		int c = 1;
		for (int j = 1; j < n; ++j) {
			if (i - j < 0 || i + j >= n) 
				break;
			if (s[i - j] != s[i + j]) 
				break;
			c += 2;
		}
		max_pol_nch[i] = c;
	}

	for (int i = 0; i < n; ++i) {
		int c = 0;

		for (int j = 1; j < n; ++j) {
			if (i - j + 1 < 0 || i + j >= n) 
				break;
			if (s[i - j + 1] != s[i + j]) 
				break;
			c += 2;
		}

		max_pol_ch[i] = c;
	}

	vector <int> pos_for_nch(n, 1);
	vector <int> max_len[n];

	for (int i = 0; i < n; ++i) 
		max_len[max_pol_nch[i]].push_back(i);

	int cnt = 0;

	// for (int i = 0; i < n; ++i)  {
	// 	cout << i << ": ";
	// 	for (auto &d: max_len[i])
	// 		cout << d << " ";
	// 	cout << endl;
	// }

	for (int i = 1; i < 4; i += 2) {

		for (int j = 0; j + i < n; ++j)
			if (pos_for_nch[j] && pos_for_nch[j + i]) 
				cnt++;	

		for (auto &d: max_len[i]) 
			pos_for_nch[d] = 0;
	}

	cout << cnt;
}