#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 1e6 + 10, P = 31, mod = 1e9 + 7;
int h[N], revH[N];
int power[N];
int add(int a, int b) {
	return (a + b) % mod;
}
int mult(int a, int b) {
	return a * 1ll * b % mod;
}
int sub(int a, int b) {
	return (a - b + mod) % mod;
}
int getH(int l, int r) {
	if (l > r) return 0;
	if (!r) return h[r];
	return sub(h[r], mult(h[l - 1], power[r - l + 1]));
}
int n;
int getRevH(int l, int r) {
	if (l > r) return 0;
	int newR = n - l - 1, newL = n - r - 1;
	l = newL, r = newR;
	// debug(l << ' ' << r)
	if (!r) return revH[r];
	return sub(revH[r], mult(revH[l - 1], power[r - l + 1]));
}
struct fenw
{
	int f[N];
	fenw() {
		memset(f, 0, sizeof(f));
	}
	void add(int i, int x) {
		for (; i < N; i = (i | (i + 1))) {
			f[i] += x;
		}
	}
	int get(int r) {
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			s += f[r];
		}
		return s;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
int poly1[N], poly2[N];
std::string s;
ll ans = 0;
std::vector<int> del[N];
void solve1() {
	for (int len = 2; len <= n; len += 2) {
		for (int l = 0; l + len <= n; ++l) {
			int r = l + len / 2 - 1;
			int l2 = r + 1;
			int r2 = l2 + len / 2 - 1;
			// debug(l << ' ' << r << ' ' << l2 << ' ' << r2)
			if (getH(l, r) == getRevH(l, r) && getH(l2, r2) == getRevH(l2, r2)) {
				ans++;
				// debug(l << ' ' << r << ' ' << l2 << ' ' << r2)
			}
		} 
	}
}
void solve2() {
}
int main() {
	power[0] = 1;
	FOR(i, N - 1) {
		power[i + 1] = mult(power[i], P);
	}
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	std::cin >> n;
	std::cin >> s;
	FOR(i, n) {
		if (!i) h[i] = s[i] - 'a' + 1;
		else {
			h[i] = add(mult(h[i - 1], P), s[i] - 'a' + 1);
		}
	}
	std::reverse(s.begin(), s.end());
	FOR(i, n) {
		if (!i) revH[i] = s[i] - 'a' + 1;
		else {
			revH[i] = add(mult(revH[i - 1], P), s[i] - 'a' + 1);
		}
	}
	// debug(getH(1, 2));
	// std::reverse(s.begin(), s.end());
	solve1();
	solve2();
	std::cout << ans;
	// debug(ans);
}