#include "bits/stdc++.h"

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>

using namespace std;

template<class T>
void read(vector<T> &a) {
    for (auto &i : a) cin >> i;
}

template<class T>
void write(vector<T> &a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

bool check(string &s, int l, int r) {
    for (int i = l; i <= r; ++i) {
        if (s[i] != s[r - i + l]) return false;
    }
    return true;
}

void solve() {
    int n; cin >> n;
    string s; cin >> s;
    vvi polis(n, vi(n, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            polis[i][j] = check(s, i, j);
        }
    }
    int ans = 0;
    for (int len = 1; len <= n / 2; ++len) {
        for (int i = 0; i + 2 * len <= n; ++i) {
            if (polis[i][i + len - 1] && polis[i + len][i + 2 * len - 1]) ans++;
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();

    return 0;
}