#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e6, MOD = 1791791791, B = 57;
int pref[MAXN], suf[MAXN], power[MAXN];

bool is_pal(int l, int r) {
    int h1 = pref[r] - pref[l] * power[r - l];
    int h2 = suf[l] - suf[r] * power[r - l];
    return (h1 - h2) % MOD == 0;
}

int pal[MAXN];

main() {
    int n;
    string s;
    cin >> n >> s;
    power[0] = 1;
    for (int i = 0; i < n; ++i) {
        power[i + 1] = (power[i] * B) % MOD;
        pref[i + 1] = (pref[i] * B + s[i] - 'a' + 1) % MOD;
        suf[n - i - 1] = (suf[n - i] * B + s[n - i - 1] - 'a' + 1) % MOD;
    }
    for (int i = 1; i < n; ++i) {
        int l = 0, r = min(i, n - i) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (is_pal(i - m, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        pal[i] = l;
    }
    int ans = 0;
    /**for (int i = 1; i < n; ++i) {
        for (int j = i + 2; j < n; j += 2) {
            if (pal[i] >= (j - i) / 2 && pal[j] >= (j - i) / 2) {
                ans++;
            }
        }
    }*/
    for (int i = 1; i < n; ++i) {
        for (int k = 1; k <= min(pal[i], (n - i - 1) / 2); ++k) {
            if (2 * pal[i + 2 * k] - i - 2 * k >= -i) {
                ans++;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (is_pal(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        pal[i] = l;
    }
    /**for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; j += 2) {
            if (pal[i] >= (j - i + 1) / 2 && pal[j] >= (j - i + 1) / 2) {
                ans++;
            }
        }
    }*/
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k <= min(pal[i] - 1, (n - i - 2) / 2); ++k) {
            if (2 * pal[i + 2 * k + 1] - i - 2 * k - 1 >= 1 - i) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
