/*#pragma GCC optimize("Ofast, no-stack-protector")
 #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx,mmx,avx,tune-native")
 #pragma GCC optimize("unroll-loops")
 #pragma GCC optimize("fast-math") */

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()
#define int long long
typedef long long ll;
typedef long double lld;

const int base = 41, mod1 = 1e9 +7, mod2= 1e9 + 17;

void hs(string s, vector <int> &hs, vector <int> &step, int mod) {
    int n = len(s);
    hs.resize(n + 1);
    step.resize(n + 1);
    hs[0] = 0;
    step[0] = 1;
    for (int i = 1; i <= n; i++) {
        step[i] = step[i-1] * base % mod;
        hs[i] = (hs[i-1] + s[i - 1]) * base % mod;
    }
}

int get(vector <int> &hs, vector <int> &step, int i, int j, int mod) {
    return ((hs[j + 1]  - hs[i] * step[j - i + 1]) % mod + mod) % mod;
}


int n;

bool check(vector <int> &hs1, vector<int> &step1, vector<int> &hs2, vector<int> &step2, int i, int j, int mod) {
    int first = get(hs1, step1, i, j, mod);
    int second = get(hs2, step2, n - 1 - j, n - 1 - i, mod);
    return first == second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // комменти файлы, умоляю
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    string s;
    cin >> s;
    vector <ll> hs1, step1, hs2, step2;
    hs(s, hs1, step1, mod1);
    reverse(all(s));
    hs(s, hs2, step2, mod1);
    int ans = 0;
    //cout << check(hs1, step1, hs2, step2, 0, 4, mod1) << endl;
    for (int i = 2; i <= n; i += 2) {
        for (int j = 0; j < n - i + 1; j++) {
            if (check(hs1, step1, hs2, step2, j, j + i / 2 - 1, mod1) &&
            check(hs1, step1, hs2, step2, j + i / 2, j + i - 1, mod1)) {
                ans++;
                //cout << i << " " << j << endl;
            }
        }
    }
    cout << ans;
    return 0;
}