#include<iostream>

using namespace std;

#define int long long

const int md1=1e9+7;
const int md2=1e9+9;

int st1[1000000+5];

int st2[1000000+5];

int h1[1000000+5];

int h2[1000000+5];

int h3[1000000+5];

int h4[1000000+5];

bool p[5000+5][5000+5];

string s;

int n;

bool check(int l, int r)
{
    if (l==r) return true;
    if (l+1==r) return s[l]==s[r];
    if ((r-l+1)%2==0)
    {
        int m=(l+r)/2;
        int H1=(h1[m]-h1[l-1]+md1)%md1;
        int H2=(h2[m]-h2[l-1]+md2)%md2;
        int H3=(h3[n-m]-h3[n-r]+md1)%md1;
        int H4=(h4[n-m]-h4[n-r]+md2)%md2;
        H1*=st1[n-l];
        H2*=st2[n-l];
        H3*=st1[n-(n-r+1)];
        H4*=st2[n-(n-r+1)];
        H1%=md1; H2%=md2; H3%=md1; H4%=md2;
        if (H1==H3&&H2==H4) return true;
        else return false;
    }
    else
    {
        int m=(l+r)/2;
        int H1=(h1[m]-h1[l-1]+md1)%md1;
        int H2=(h2[m]-h2[l-1]+md2)%md2;
        int H3=(h3[n-m+1]-h3[n-r]+md1)%md1;
        int H4=(h4[n-m+1]-h4[n-r]+md2)%md2;
        H1*=st1[n-l];
        H2*=st2[n-l];
        H3*=st1[n-(n-r+1)];
        H4*=st2[n-(n-r+1)];
        H1%=md1; H2%=md2; H3%=md1; H4%=md2;
        if (H1==H3&&H2==H4) return true;
        else return false;
    }
}

int32_t main()
{
    cin>>n;
    cin>>s;
    s="!"+s;
    st1[0]=31;
    st2[0]=37;
    for (int i=1; i<=n; i++)
    {
        st1[i]=st1[i-1]*31;
        st2[i]=st2[i-1]*37;
        st1[i]%=md1;
        st2[i]%=md2;
    }
    for (int i=1; i<=n; i++)
    {
        h1[i]=h1[i-1]+(s[i]-'a'+1)*st1[i-1];
        h2[i]=h2[i-1]+(s[i]-'a'+1)*st2[i-1];
        h1[i]%=md1;
        h2[i]%=md2;
        h3[i]=h3[i-1]+(s[n-i+1]-'a'+1)*st1[i-1];
        h4[i]=h4[i-1]+(s[n-i+1]-'a'+1)*st2[i-1];
        h3[i]%=md1;
        h4[i]%=md2;
    }
    for (int i=1; i<=n; i++)
    {
        p[i][i]=true;
        for (int j=i+1; j<=n; j++)
        {
            if (check(i,j))
            {
                p[i][j]=true;
            }
        }
    }
    int ans=0;
    for (int i=1; i<n; i++)
    {
        for (int d=1; d<n; d++)
        {
            int l=i-d+1;
            int r=i+d;
            if (l<1) break;
            if (r>n) break;
            if (p[l][i]&&p[i+1][r])
            {
                ans++;
            }
        }
    }
    cout<<ans;
}
