#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;
constexpr ll p = 179;
constexpr ll mod = 1e9 + 9;

vector <ll> h1 = { 0 }, h2 = { 0 }, power_p = { 1 };

ll sh(const vector <ll>& h, int l, int r)
{
	ll buf = h[r] - h[l] * power_p[r - l];
	buf %= mod;
	if (buf < 0)
		buf += mod;

	return buf;
}

int main()
{
	int n = 0;
	cin >> n;
	string s = "";
	cin >> s;

	for (int i = 0; i < n; ++i)
		power_p.push_back((power_p.back() * p) % mod);

	for (int i = 0; i < n; ++i)
		h1.push_back((h1.back() * p + s[i]) % mod);
	reverse(s.begin(), s.end());
	for (int i = 0; i < n; ++i)
		h2.push_back((h2.back() * p + s[i]) % mod);

	ll cnt = 0;
	for (int len = 2; len <= n; len += 2)
	{
		for (int i = 0; i + len <= n; ++i)
		{
			int m = i + len / 2, r = i + len;
			if (sh(h1, i, m) == sh(h2, n - m, n - i) && sh(h1, m, r) == sh(h2, n - r, n - m))
				++cnt;
		}
	}

	cout << cnt;

	return 0;
}