#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 1e6 + 10, P = 31, mod = 1e9 + 7;
int h[N], revH[N];
int power[N];
int add(int a, int b) {
	return (a + b) % mod;
}
int mult(int a, int b) {
	return a * 1ll * b % mod;
}
int sub(int a, int b) {
	return (a - b + mod) % mod;
}
int getH(int l, int r) {
	if (l > r) return 0;
	if (!r) return h[r];
	return sub(h[r], mult(h[l - 1], power[r - l + 1]));
}
int n;
int getRevH(int l, int r) {
	if (l > r) return 0;
	int newR = n - l - 1, newL = n - r - 1;
	l = newL, r = newR;
	// debug(l << ' ' << r)
	if (!r) return revH[r];
	return sub(revH[r], mult(revH[l - 1], power[r - l + 1]));
}
struct fenw
{
	int f[N];
	fenw() {
		memset(f, 0, sizeof(f));
	}
	void add(int i, int x) {
		for (; i < N; i = (i | (i + 1))) {
			f[i] += x;
		}
	}
	int get(int r) {
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			s += f[r];
		}
		return s;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
int poly1[N], poly2[N];
std::string s;
ll ans = 0;
std::vector<int> del[N];
void solve1() {
	FOR(i, n) {
		int l = 0, r = std::min(i + 1, n - i) + 1;
		while (r - l > 1) {
			int tm = (l + r) / 2;
			// debug(tm << ' ' << getH(i - tm + 1, i))
			// debug(tm << ' ' << getRevH(i + 1, i + tm))
			if (getH(i - tm + 1, i) == getRevH(i + 1, i + tm)) {
				l = tm;
			}
			else {
				r = tm;
			}
		}
		poly1[i] = l;
		// debug(i << ' ' << poly1[i])
	}
	fenw check[2];
	FOR(i, n) {
		for (auto e : del[i]) {
			check[e % 2].add(e, -1);
			// debug("DEL " << e)
		}
		if (!poly1[i]) continue;
		if (i + 2 * poly1[i] + 1 < n) {
			del[i + 2 * poly1[i] + 1].pb(i);
			// debug(i << ' ' << 2 * poly1[i] + 1)
		}
		ans += check[i % 2].get(i - 2 * poly1[i], i);
		// debug(i - 2 * poly1[i])
		// debug(i << ' ' << check[i % 2].get(i - 2 * poly1[i], i))
		check[i % 2].add(i, +1);
	}
}
void solve2() {
	FOR(i, n) {
		del[i].clear();
		int l = 0, r = std::min(i + 1, n - i) + 1;
		while (r - l > 1) {
			int tm = (l + r) / 2;
			if (getH(i - tm, i - 1) == getRevH(i + 1, i + tm)) {
				l = tm;
			}
			else {
				r = tm;
			}
		}
		poly2[i] = l;
		// debug(i << ' ' << poly2[i])
	}
	fenw check[2];
	FOR(i, n) {
		if (i + 2 * (poly2[i] + 1) < n) {
			del[i + 2 * (poly2[i] + 1)].pb(i);
		}
		for (auto e : del[i]) {
			check[(e % 2) ^ 1].add(e, -1);
		}
		ans += check[i % 2].get(i - 2 * (poly2[i] + 1) + 1, i);
		// debug(i << ' ' << i - 2 * (poly2[i] + 1) + 1)
		check[(i % 2) ^ 1].add(i, +1);
	}
}
int main() {
	power[0] = 1;
	FOR(i, N - 1) {
		power[i + 1] = mult(power[i], P);
	}
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	std::cin >> n;
	std::cin >> s;
	FOR(i, n) {
		if (!i) h[i] = s[i] - 'a' + 1;
		else {
			h[i] = add(mult(h[i - 1], P), s[i] - 'a' + 1);
		}
	}
	std::reverse(s.begin(), s.end());
	FOR(i, n) {
		if (!i) revH[i] = s[i] - 'a' + 1;
		else {
			revH[i] = add(mult(revH[i - 1], P), s[i] - 'a' + 1);
		}
	}
	// debug(getH(1, 2));
	// std::reverse(s.begin(), s.end());
	solve1();
	solve2();
	std::cout << ans;
	// debug(ans);
}