#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <queue>
#include <stack>
#include <deque>
#include <list>
#include <vector>
#include <string>


using namespace std;

typedef long long ll;
mt19937 ran(time(0));

/*vector<int> z_function(string s) {
    int n = (int)s.size();
    vector<int>z(n);
    int l = 0, r = 0;
    for (int i = 1; i < n; i++) {
        if (i <= r) {
            z[i] = max(0, min(r - i - 1, z[i - l]));
        }
        while (i + z[i] < n && s[z[i]] == s[i + z[i]]) {
            z[i]++;
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }
    return z;
}*/

/*int get_max(int u, int l, int r, int tl, int tr) {
    if (l >= tr || r <= tl)return -2e9;
    if (l == tl && r == tr) {

    }

}
*/

ll gcd(ll a, ll b) {
    return !a ? b : gcd(b % a, a);
}

const ll mod = 1000012121;
const ll inf = 2e18;
int n;
string s;
vector<int>even, odd;
ll b = 31;
vector<ll>pr, pr_r;
vector<ll>po;

ll get_hash(int l, int r) {
    return (pr[r] - (pr[l - 1] * po[r - l + 1]) % mod + mod) % mod;
}
ll get_hash_r(int l, int r) {
    return (pr_r[l] - (pr_r[r + 1] * po[r - l + 1]) % mod + mod) % mod;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> s;
    odd.resize(n, 1);
    even.resize(n, 0);
    pr.resize(n + 1, 0);
    pr_r.resize(n + 2, 0);
    po.resize(n + 1);
    po[0] = 1;
    for (int i = 1; i < n; i++) {
        po[i] = po[i - 1] * b;
        if (po[i] >= mod)po[i] %= mod;
    }
    for (int i = 1; i <= n; i++) {
        pr[i] = pr[i - 1] * b + s[i - 1] - 'a' + 1;
        if (pr[i] >= mod) {
            pr[i] %= mod;
        }
    }
    for (int i = n; i >= 1; i--) {
        pr_r[i] = pr_r[i + 1] * b + s[i - 1] - 'a' + 1;
        if (pr_r[i] >= mod) {
            pr_r[i] %= mod;
        }
    }
    int l, r, mid, last;
    for (int i = 0; i < n; i++) {
        l = 0;
        r = min(n - i - 1, i);
        last = 1;
        while (l <= r) {
            mid = (l + r) / 2;
            if (get_hash(i + 1, i + 1 + mid) == get_hash_r(i + 1 - mid, i + 1)) {
                last = mid * 2 + 1;
                l = mid + 1;
            }
            else {
                r = mid - 1;
            }
        }
        odd[i] = last;
    }
    for (int i = 0; i < n; i++) {
        l = 0;
        r = min(i, n - i - 2);
        last = 0;
        while (l <= r) {
            mid = (l + r) / 2;
            if (get_hash(i + 2, i + 2 + mid) == get_hash_r(i + 1 - mid, i + 1)) {
                last = (mid + 1) * 2;
                l = mid + 1;
            }
            else {
                r = mid - 1;
            }
        }
        even[i] = last;
    }
    /*vector<vector<int>>nums(n + 1);
    long double pl = n - 1;
    long double ans = n - 1;
    for (int i = 0; i < n; i++) {
        nums[odd[i]].push_back(i);
        nums[even[i]].push_back(i);
    }*/
    ll an = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j += 2) {
            if (odd[i] >= j - i && odd[j] >= j - i) {
                an++;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 2; j < n; j += 2) {
            if (even[i] >= j - i && even[j] >= j - i) {
                an++;
            }
        }
    }
    cout << an;
    return 0;
}