#include <bits/stdc++.h>
//#define int long long

using namespace std;

const int base_ = 29, mod = 1e9 + 7;
vector<int> base;

int segHash(const vector<int>& hash, int left, int right) {
    return (hash[right] - (hash[left] * 1ll * base[right - left]) % mod + mod) % mod;
}

int segReHash(const vector<int>& reHash, int left, int right) {
    return (reHash[left] - (reHash[right] * 1ll * base[left - right]) % mod + mod) % mod;
}

bool pol(int n, const vector<int>& hash, const vector<int>& reHash, int left, int right) {
    //cout << left << " " << right << " " << segHash(hash, left, right) << " " << segReHash(reHash, n - left, n - right) << "\n";
    return segHash(hash, left, right) == segReHash(reHash, n - left, n - right);
}

int32_t main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    base.resize(n + 1, 1);
    for (int i = 1; i < n + 1; ++i)
        base[i] = (base[i - 1] * 1ll * base_) % mod;
    vector<int> hash(n + 1);
    for (int i = 0; i < n; ++i)
        hash[i + 1] = (hash[i] * 1ll * base_ + s[i] - 'a' + 1) % mod;
    vector<int> reHash(n + 1);
    for (int i = 0; i < n; ++i)
        reHash[i + 1] = (reHash[i] * 1ll * base_ + s[n - i - 1] - 'a' + 1) % mod;
    int ans = 0;
    for (int len = 1; len < n; ++len)
        for (int i = 0; i + 2 * len <= n; ++i)
            if (pol(n, hash, reHash, i, i + len) && pol(n, hash, reHash, i + len, i + 2 * len))
                ++ans;
    cout << ans;
    return 0;
}
