#ifndef LOCAL
  #pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 5000;

bool ispal[MAXN][MAXN];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n;
  cin >> n;
  string s;
  cin >> s;
  for (int i = 0; i < n; ++i) {
    ispal[i][i] = true;
    if (i > 0)
      ispal[i][i - 1] = true;
  }
  for (int len = 2; len <= n; ++len) {
    for (int l = 0; l + len <= n; ++l) {
      int r = l + len - 1;
      ispal[l][r] = (s[l] == s[r] && ispal[l + 1][r - 1]);
    }
  }
  int ans = 0;
  for (int len = 1; 2 * len <= n; ++len) {
    for (int m = len; m + len <= n; ++m) {
      int l = m - len;
      int r = m + len;
      ans += ispal[l][m - 1] && ispal[m][r - 1];
    }
  }
  cout << ans;
  return 0;
}