#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define pb push_back
#define eb emplace_back
#define xmax(x,y) x = max(x, y)
#define xmin(x,y) x = min(x, y)
#define mp make_pair
#define output(a) cout << #a << ' '; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) sort(all(a)); a.resize(unique(all(a)) - a.begin());

using namespace std;

struct BIT {
    vector<int> t;

    BIT() {}

    BIT(int n) : t(n) {}

    void add(int _x, int y) {
        for (int x = _x; x < sz(t); x |= (x + 1)) {
            t[x] += y;
        }
    }

    int get(int _x) {
        int res = 0;
        for (int x = _x; x >= 0; x = (x & (x + 1)) - 1) {
            res += t[x];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;

    string t = "";
    for (char c : s) {
        t += c;
        t += '#';
    }
    t.pop_back();

    vector<int> ev, od;

    int n2 = n * 2 - 1;
    vector<int> mx(n2);
    int c = 0, r = 0;
    for (int i = 0; i < n2; ++i) {
        mx[i] = max(min(mx[max(2 * c - i, 0)], r - i), 0);
        while (i - mx[i] > 0 && t[i - mx[i] - 1] == t[i + mx[i] + 1]) {
            ++mx[i];
        }
        if (i + mx[i] > r) {
            c = i;
            r = i + mx[i];
        }
        if (t[i] == '#') {
            ev.eb((mx[i] + 1) >> 1);
        } else {
            od.eb(mx[i] >> 1);
        }
    }

    ll ans = 0;

    BIT b10(sz(ev)), b11(sz(ev));
    vector<vector<int>> add1(sz(ev));
    vector<vector<int>> del1(sz(ev));
    for (int i = 0; i < sz(ev); ++i) {
        add1[max(i - 2 * ev[i], 0)].eb(i);
        del1[i].eb(i);
    }
    for (int i = 0; i < sz(ev) - 2; ++i) {
        for (int x : add1[i]) {
            if (x & 1) {
                b11.add(x, 1);
            } else {
                b10.add(x, 1);
            }
        }
        for (int x : del1[i]) {
            if (x & 1) {
                b11.add(x, -1);
            } else {
                b10.add(x, -1);
            }
        }
        if (i & 1) {
            ans += b11.get(i + 2, min(i + 2 * ev[i], sz(ev) - 1));
        } else {
            ans += b10.get(i + 2, min(i + 2 * ev[i], sz(ev) - 1));
        }
    }

    BIT b20(sz(od)), b21(sz(od));
    vector<vector<int>> add2(sz(od));
    vector<vector<int>> del2(sz(od));
    for (int i = 0; i < sz(od); ++i) {
        add2[max(i - 2 * od[i] - 1, 0)].eb(i);
        del2[i].eb(i);
    }
    for (int i = 0; i < sz(od) - 1; ++i) {
        for (int x : add2[i]) {
            if (x & 1) {
                b21.add(x, 1);
            } else {
                b20.add(x, 1);
            }
        }
        for (int x : del2[i]) {
            if (x & 1) {
                b21.add(x, -1);
            } else {
                b20.add(x, -1);
            }
        }
        if (i & 1) {
            ans += b20.get(i + 1, min(i + 2 * od[i] + 1, sz(od) - 1));
        } else {
            ans += b21.get(i + 1, min(i + 2 * od[i] + 1, sz(od) - 1));
        }
    }
    cout << ans;
    return 0;
}
