#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
long long p = 31;
long long Mod = 1e9 + 7;
const int maxn = 1000;
vector<long long> poww(maxn);
void build(vector<long long> &Has, string &a) {
    Has[0] = a[0] - 'a';
    for(int i = 1; i < a.size(); ++i) {
        Has[i] = (Has[i - 1]*p + a[i] - 'a')%Mod;
    }
}
void rev(string &b, string &a) {
    for(int i = a.size() - 1; i >= 0; --i) {
        b += a[i];
    }
}
long long Hash(vector<long long> &Has, int l, int r) {
    if(l == 0) {
        return Has[r];
    }
    return (Mod*Mod + Has[r] - Has[l - 1]*poww[r - l + 1])%Mod;
}
bool pal(int l, int r, vector<long long> Has, vector<long long> &Hasr) {
    int n = Has.size();
    return Hash(Has, l, r) == Hash(Hasr, n - r - 1, n - l - 1);
}
int main() {
    int n;
    cin >> n;
    string a;
    cin >> a;
    poww[0] = 1;
    for(int i = 1; i < maxn; ++i) {
        poww[i] = (p*poww[i - 1])%Mod;
    }
    vector<long long> Has(n);
    build(Has, a);
    string b;
    rev(b, a);
    vector<long long> Hasr(n);
    build(Hasr, b);
    long long sum = 0;
    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j + i*2 <= n; ++j) {
            if(pal(j, j + i - 1, Has, Hasr) && pal(j + i, j + 2*i - 1, Has, Hasr)) {
                ++sum;
            }
        }
    }
    cout << sum;
}
