#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<deque>
#include<set>
#include<map>
#include<random>
#include<tuple>
#include<cassert>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

mt19937 gen(313);
uniform_int_distribution <int> rand_int(1, 1000000000);

const int N = 1e6 + 7, P = 29, MOD = 1e9 + 7;

string s, t;
int n, pal[N], h[N], rh[N], deg[N] = { 1 };

void calc_pals() {
	loop1(i, N - 1) deg[i] = deg[i - 1] * P % MOD;
	loop1(i, n) {
		h[i] = (h[i - 1] * P + (t[i - 1] == '#' ? 28 : t[i - 1] - 'a' + 1)) % MOD;
		rh[i] = (rh[i - 1] * P + (t[n - i] == '#' ? 28 : t[n - i] - 'a' + 1)) % MOD;
	}
	loop(i, n) {
		int l = 0, r = (n >> 1) + 2;
		while (r - l > 1) {
			int m = r + l >> 1;
			//if (i == 2) cout << i + 1 << " " << i - m << " " << n - i << " " << n - i - m - 1 << "\n";
			if (i - m < 0 || i + m >= n) {
				r = m; continue;
			}
			int h1 = (h[i + 1] - h[i - m] * deg[m + 1] % MOD + MOD) % MOD;
			int h2 = (rh[n - i] - rh[n - i - m - 1] * deg[m + 1] % MOD) % MOD;
			if (h1 == h2) l = m;
			else r = m;
		}
		//pal[i] = l;
		pal[i] = (l + (i & 1 ? 1 : 0)) / 2;
	}
}

void solve() {
	cin >> n; cin >> s;
	loop(i, n) {
		t.pb(s[i]); t.pb('#');
	}
	n = 2 * n;
	calc_pals();
	int ans = n / 2 - 1;
	loop(i, n) {
		loop1(j, pal[i]) {
			int nex = i + j * 4 + (i & 1 ? 0 : 2);
			//cout << i << " " << nex << "\n";
			if (nex >= n) continue;
			else if (pal[nex] >= j) ++ans;
		}
		//cout << pal[i] << " ";
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	solve();
	return 0;
}