#include <bits/stdc++.h>
#define int long long

using namespace std;


void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 500005;
int mod = 1000000033;
int base = 47;
int p[maxn];
int h[maxn];
int rh[maxn];
int len[maxn];
int le[maxn];
int n;
string s;

void count_hash() {
    int a, b, i, j;
    p[0] = 1;
    for (i = 1; i <= n; i++) {
        p[i] = p[i - 1] * base % mod;
    }
    h[0] = s[0] - 'a' + 1;
    for (i = 1; i < n; i++) {
        h[i] = (h[i - 1] * base + s[i] - 'a' + 1) % mod;
    }
    rh[n - 1] = s[n - 1] - 'a' + 1;
    for (i = n - 2; i >= 0; i--) {
        rh[i] = (rh[i + 1] * base + s[i] - 'a' + 1) % mod;
    }
}

bool chk(int i, int j) {
    int m1 = (i + j) / 2;
    int m2 = m1;
    if (m1 - i != j - m1)
        m2++;
    int h1 = h[m1];
    if (i > 0) {
        h1 = (h1 - h[i - 1] * p[m1 - i + 1] % mod + mod) % mod;
    }
    int h2 = rh[m2];
    if (j < n - 1) {
        h2 = (h2 - rh[j + 1] * p[j - m2 + 1] % mod + mod) % mod;
    }
    return h1 == h2;
}

signed main() {
    fast();
    int m, a, b, i, j, k, x, y;
    cin >> n;
    cin >> s;
    count_hash();
    for (i = 0; i < n; i++) {
        int l = 0, r = min(i, n - i - 1) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (chk(i - m, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        len[i] = l;
    }
    for (i = 0; i < n - 1; i++) {
        int l = 0, r = min(i + 1, n - 1 - i) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (chk(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        le[i] = l;
    }
    int ans = 0;
    for (i = 0; i < n; i++) {
        for (j = i + 1; j < n; j++) {
            a = (j - i - 1) / 2;
            if ((j - i - 1) % 2) continue;
            if (len[i] >= a && len[j] >= a) {
                ans++;
            }
        }
    }
    for (i = 0; i < n - 1; i++) {
        for (j = i + 1; j < n - 1; j++) {
            a = (j - i) / 2;
            if ((j - i) % 2) continue;
            if (le[i] >= a && le[j] >= a) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
