#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<string>

using namespace std;

vector<long long> hash1, hash2;
vector<long long> st;
long long mod = 1e9 + 7, k = 37;

long long h1(int l, int r) {
	return (((hash1[r] - hash1[l] * st[r - l]) % mod + mod) % mod);
}

long long h2(int l, int r) {
	return (((hash2[r] - hash2[l] * st[r - l]) % mod + mod) % mod);
}

int main() {
	int n;
	string s;
	cin >> n >> s;
	hash1.resize(n + 1, 0);
	hash2.resize(n + 1, 0);
	st.resize(n + 1, 1);
	for (int i = 0; i < n; i++) {
		hash1[i + 1] = (hash1[i] * k + (s[i] - 'a')) % mod;
		hash2[i + 1] = (hash2[i] * k + (s[n-1-i] - 'a')) % mod;
		st[i+1]=(st[i]*k)%mod;
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 1; i + 2 * j <= n; j++) {
			if (h1(i, i + j) == h2(n - i - j, n - i) && h1(i + j, i + 2 * j) == h2(n - i - 2 * j, n - i - j)) {
				ans++;
			}
		}
	}
	cout << ans;
}