#include <bits/stdc++.h>
#define len(s) (int)(s.size())
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (ll)(x * x)

const int sz = 6e5, oo = 2e9;
const double eps = 1e-7;

using namespace std;

using ll = long long;
using ld = long double;
using str = string;
using vi = vector <int>;
using pii = pair <int, int>;
using vpii = vector <pii>;
using vll = vector <ll>;
using pll = pair <ll, ll>;
using vpll = vector <pll>;
using three = pair <int, pair <int, int> >;

mt19937 rnd(time(0));

int cnt[sz], nl, nr, n; // 0 - start, 1 - finish
str s;
ll ans;

void read()
{
    cin >> n >> s;
}

void solve()
{
    ans = n - 1;
    for (int i = 0; i < n; ++i) cnt[i] = 1;
    for (int now = 2; now <= (n / 2); ++now) {
        vi r, l;
        for (int i = 1; i <= n - now; ++i) {
            if (cnt[i]) {
                nl = i - 1;
                nr  = nl + now;
                ///cout << i << '=' << nl << ' ' << nr << endl;
                if (nl >= 0 && nr < n && s[nl] == s[nr]) l.push_back(nl), r.push_back(nr);
            }
        }
        for (int i = 0; i < n; ++i) cnt[i] = 0;
        for (auto c: l) if (binary_search(all(r), c - 1)) ++ans;
        for (auto c: l) cnt[c] = 1;

    }

    for (int i = 0; i < n; ++i) cnt[i] = 0;
    for (int i = 0; i < n - 1; ++i) if (s[i] == s[i + 1]) cnt[i] = 1;
    for (int i = 0; i < n - 2; ++i) if (cnt[i] && cnt[i + 2]) ++ans;


    for (int now = 4; now <= n; now += 2) {
        vi r, l;
        for (int i = 1; i <= n - now + 1; ++i) {
            if (cnt[i]) {
                nl = i - 1;
                nr = nl + now - 1;
                if (nl >= 0 && nr < n && s[nl] == s[nr]) l.push_back(nl), r.push_back(nr);
            }
        }
        for (int i = 0; i < n; ++i) cnt[i] = 0;
        /*for (auto c: l) cout << c << "ll ";cout << endl;
        for (auto c: r) cout << c << "rr ";cout << endl;*/
        for (auto c: l) if (binary_search(all(r), c - 1)) ++ans;
        for (auto c: l) cnt[c] = 1;
    }


    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) read(), solve();
    return 0;
}
