#include <bits/stdc++.h>
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast", "unroll-loops", "fast-math", "no-stack-protector")
using namespace std;
typedef long long ll;
struct segment_tree {
    vector < int > t;
    vector < int > a;
    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = a[l];
            return ;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m + 1, r);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    int ask(int v, int l, int r, int tl, int tr) {
        if (l == r && tl == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
    }
};
int p = 37;
ll mod = 1e9 + 7;
string s;
int n;
vector < ll > h1, h2;
vector < ll > step;
void build() {
    h1.resize(n);
    h2.resize(n + 1);
    step.resize(n + 1);
    step[0] = 1;
    fori(n) step[i + 1] = (step[i] * p) % mod;
    fori(n) {
        if (i) h1[i] = h1[i - 1];
        h1[i] += step[i] * (s[i] - 'a' + 1);
        h1[i] %= mod;
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i != n - 1) h2[i] = h2[i + 1];
        h2[i] += step[n - 1 - i] * (s[i] - 'a' + 1);
        h2[i] %= mod;
    }
}
ll hah1, hah2;
bool ispal(int l, int r) {
    hah1 = h1[r];
    if (l) hah1 -= h1[l - 1];
    hah2 = h2[l] - h2[r + 1];
    if (hah1 < 0) hah1 += mod;
    if (hah2 < 0) hah2 += mod;
    if (n - 1 - r < l) {
        hah2 *= step[l - n + 1 + r];
        hah2 %= mod;
    } else {
        hah1 *= step[n - 1 - r - l];
        hah1 %= mod;
    }
    return (hah1 == hah2);
}
vector < vector < int > > z, keks;
ll ans = 0;
void calc() {
    vector < int > op, close;
    op.resize(n / 2 + 1);
    close.resize(n / 2 + 1);
    fori(n) {
        forj(op.size() - 1) op[j] = op[j + 1];
        op[op.size() - 1] = 0;
        for (auto c:keks[i]) op[c]++;

        forj(op.size()) ans += op[j] * close[j];

        for (int j = close.size() - 1; j >= 1; j--) close[j] = close[j - 1];
        close[0] = 0;
        for (auto c:z[i]) {
            if (c >= 0)
                close[c]++;
            else
                close[-c]--;
        }
    }
    return ;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    cin >> s;
    build();
    z.resize(n + 1);
    keks.resize(n);
    fori(n - 1) {
        if (s[i] != s[i + 1]) continue;
        int l = 0, r = min(i, n - 2 - i);
        int m;
        while (true) {
            if (l == r) break;
            m = (l + r) / 2;
            if (ispal(i - (m + 1), i + 1 + (m + 1)))
                l = m + 1;
            else
                r = m;
        }
        keks[i - l].pb(l);
        z[i + 1].pb(0);
        z[i + 1 + l + 1].pb(-l - 1);
    }
    //fori(n + 1) {
    //    cout << i << " : ";
    //    for (auto c: z[i]) cout << c << " ";
    //    cout << endl;
    //}
    calc();
    z.clear();
    keks.clear();
    z.resize(n + 1);
    keks.resize(n);
    fori(n) {
        int l = 0, r = min(i, n - 1 - i);
        int m;
        while (true) {
            if (l == r) break;
            m = (l + r) / 2;
            if (ispal(i - m - 1, i + m + 1)) {
                l = m + 1;
            } else {
                r = m;
            }
        }
        keks[i - l].pb(l);
        z[i].pb(0);
        z[i + l + 1].pb(-l - 1);
    }
    calc();
    cout << ans;
}
