#include<bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define TEST ""
#define int long long
//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma target (sse1,sse2,sse3,sse4)

typedef long long ll;
typedef long double ld;

using namespace std;

struct Hash{
    vector<ll> hs1, hs2;
    vector<ll> pw1, pw2;
    int n, p1, p2, mod1, mod2;
    Hash(string s){
        n = s.size();
        pw1.resize(n + 1);
        pw2.resize(n + 1);
        hs1.resize(n + 1);
        hs2.resize(n + 1);
        mod1 = 1e9 + 7;
        mod2 = 1e9 + 9;
        p1 = 31;
        p2 = 41;
        pw1[0] = pw2[0] = 1;
        hs1[0] = hs2[0] = 0;
        for(int i = 1; i < n + 1; i++){
            pw1[i] = pw1[i - 1] * p1 % mod1;
            pw2[i] = pw2[i - 1] * p2 % mod2;
            hs1[i] = (hs1[i - 1] * p1 + s[i - 1] - 'a' + 1) % mod1;
            hs2[i] = (hs2[i - 1] * p2 + s[i - 1] - 'a' + 1) % mod2;
        }
    }

    pair<ll, ll> get_hs(int l, int r){ /// отрезок [l, r]
        //cout << hs1[l] _ pw1[r - l + 1] _ hs1[l] * pw1[r - l + 1] _ hs1[r + 1] - hs1[l] * pw1[r - l + 1] << endl;
        return {(hs1[r + 1] - (hs1[l] * pw1[r - l + 1] % mod1) + mod1) % mod1,
                (hs2[r + 1] - (hs2[l] * pw2[r - l + 1] % mod2) + mod2) % mod2};
    }
};

bool Equal(int l1, int r1, int l2, int r2, Hash &h1, Hash &h2){ /// !!!ОТРЕЗКИ!!!
    pair<ll, ll> f = h1.get_hs(l1, r1), s = h2.get_hs(l2, r2);
    //cout << f.f _ f.s << endl;
    //cout << s.f _ s.s << endl;
    return f == s;
}

pair<int, int> get_rev(int l, int r, int n){
    return {n - r - 1, n - l - 1};
}

bool check(int i, int j, int n, Hash &h1, Hash &h2){
    pair<int, int> rev = get_rev(i, j, n);
    if(i < 0 || j >= n) return 0;
    return Equal(i, j, rev.f, rev.s, h1, h2);
}

void solve(){
    int n;
    string a;
    cin >> n >> a;
    Hash h1(a);
    reverse(a.begin(), a.end());
    Hash h2(a);
    reverse(a.begin(), a.end());
    int ans = 0;
    for(int i = 0; i < n - 1; i++){
        for(int k = 1; k < n; k++){
            if(check(i - k + 1, i, n, h1, h2) && check(i + 1, i + k ,n, h1, h2)) ans++;
        }
    }
    cout << ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}

