#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using ord = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
void solve();

signed main() {
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}

const int N = 5e5 + 5;
const ll mod1 = 1e9 + 7, mod2 = 1e9 + 9;
const ll p1 = 31;
const ll p2 = 29;
string s;
int n, z1[N], z2[N];
ll pw1[N], hsh1[N], pw2[N], hsh2[N], revhsh1[N], revhsh2[N], fenv[2][N];
vector<int> spis[N];

void inc(int r, int add, int c) {
    for (; r < N; r += r & -r) fenv[c][r] += add;
}

int get(int r, int c) {
    r = max(0, r);
    r = min(r, n);
    int res = 0;
    for (; r >= 1; r -= r & -r) res += fenv[c][r];
    return res;
}

ll get1(int l, int r) {
    return (mod1 + hsh1[r] - hsh1[l - 1]) % mod1;
}

ll rget1(int l, int r) {
    return (mod1 + revhsh1[l] - revhsh1[r + 1]) % mod1;
}

ll get2(int l, int r) {
    return (mod2 + hsh2[r] - hsh2[l - 1]) % mod2;
}

ll rget2(int l, int r) {
    return (mod2 + revhsh2[l] - revhsh2[r + 1]) % mod2;
}

bool get(int l1, int r1, int l2, int r2) {
    ll g1 = get1(l1, r1), g2 = rget1(l2, r2);
    g1 = (g1 * pw1[n - r2 + 1]) % mod1;
    g2 = (g2 * pw1[l1]) % mod1;
    ll g21= get2(l1, r1), g22 = rget2(l2, r2);
    g21 = (g21 * pw2[n - r2 + 1]) % mod2;
    g22 = (g22 * pw2[l1]) % mod2;
    return g1 == g2 && g22 == g21;
}

void solve() {
    cin >> n;
    cin >> s;
    s = '#' + s;
    pw1[0] = 1;
    pw2[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw1[i] = pw1[i - 1] * p1 % mod1;
        pw2[i] = pw2[i - 1] * p2 % mod2;
    }
    for (int i = 1; i <= n; ++i) {
        hsh1[i] = (hsh1[i - 1] + (s[i] - 'a' + 1) * pw1[i] % mod1) % mod1;
        hsh2[i] = (hsh2[i - 1] + (s[i] - 'a' + 1) * pw2[i] % mod2) % mod2;
    }
    for (int i = n; i >= 1; --i) {
        revhsh1[i] = (revhsh1[i + 1] + (s[i] - 'a' + 1) * pw1[n - i + 1] % mod1) % mod1;
        revhsh2[i] = (revhsh2[i + 1] + (s[i] - 'a' + 1) * pw2[n - i + 1] % mod2) % mod2;
    }
    for (int i = 1; i <= n; ++i) {
        int lef = 0, rig = min(i - 1, n - i) + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            int l1 = i - mid, r1 = i - 1, l2 = i + 1, r2 = i + mid;
            if (get(l1, r1, l2, r2)) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        z1[i] = lef;
    }//z1 - нечётная
    for (int i = 1; i <= n; ++i) {
        int lef = 0, rig = min(i, n - i) + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            int l1 = i - (mid - 1), r1 = i, l2 = i + 1, r2 = i + mid;
            if (get(l1, r1, l2, r2)) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        z2[i] = lef;
//        cout << z2[i] << ' ';
    }//z2 - чётная
//    cout << '\n';
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        while (!spis[i].empty()) {
            inc(spis[i].back(), -1, spis[i].back() & 1);
            spis[i].pop_back();
        }
        ans += get(i, 1 - (i & 1)) - get(i - 2 * z1[i] - 2, 1 - (i & 1));
        inc(i, 1, i & 1);
//        cout << i << ' ' << min(n + 1, i + 2 * z1[i] + 2) << '\n';
        spis[min(n + 1, i + 2 * z1[i] + 2)].pb(i);
    }
    while (!spis[n + 1].empty()) {
        inc(spis[n + 1].back(), -1, spis[n + 1].back() & 1);
        spis[n + 1].pop_back();
    }
//    cout << ans << '\n';
    for (int i = 1; i <= n; ++i) {
        while (!spis[i].empty()) {
            inc(spis[i].back(), -1, spis[i].back() & 1);
            spis[i].pop_back();
        }
        if (z2[i] == 0) continue;
        ans += get(i, 1 - (i & 1)) - get(i - 2 * z2[i] + 1, 1 - (i & 1));
        inc(i, 1, i & 1);
        spis[min(n + 1, i + 2 * z2[i] + 1)].pb(i);
    }
    while (!spis[n + 1].empty()) {
        inc(spis[n + 1].back(), -1, spis[n + 1].back() & 1);
        spis[n + 1].pop_back();
    }
    /*for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; j += 2) {
            int len = (j - i + 1) / 2;
            int l1 = i, r1 = i + len - 1, l2 = j - (len - 1), r2 = j;
            if (len % 2 == 0) {
                int mid1 = (l1 + r1) / 2;
                int mid2 = (l2 + r2) / 2;
                if ((z2[mid1] >= len / 2) && (z2[mid2] >= len / 2)) {
                    ++ans;
     //               cout << i << ' ' << j << '\n';
                }
            } else {
                continue;
                int mid1 = (l1 + r1) / 2;
                int mid2 = (l2 + r2) / 2;
                if ((z1[mid1] >= len / 2) && (z1[mid2] >= len / 2)) {
                    ++ans;
       //             cout << i << ' ' << j << '\n';
                }
            }
        }
    }*/
    cout << ans;
}
//find_by_order
//order_of_key


