#include <bits/stdc++.h>
#define FI(n) for(int i = 0; i < n; ++i)
#define FJ(n) for(int j = 0; j < n; ++j)
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define endl '\n'

#ifndef LOCAL
    #define LOCAL 0
#endif // LOCAL
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define cerr LOCAL && std::cerr
#define watch(x) cerr << #x << " = " << x << endl

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using namespace std;

int main()
{
#if !LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#endif

    int n;
    cin >> n;
    string s;
    cin >> s;
    const ll p = 31;
    vector<ll> pp(n + 5);
    pp[0] = 1;
    for (int i = 1; i < pp.size(); ++i)
        pp[i] = pp[i - 1] * p;
    vector<ll> pref(n);
    vector<ll> suff(n);
    FI(n)
    {
        pref[i] = (i ? pref[i - 1] : 0) + pp[i] * (s[i] - 'a' + 1);
        suff[i] = (i ? suff[i - 1] : 0) + pp[i] * (s[n - i - 1] - 'a' + 1);
    }
    auto isPal = [&pref, &suff, &pp, n](int l, int r)
    {
        ll h1 = pref[r] - (l ? pref[l - 1] : 0);
        int i1 = n - l - 1;
        int i2 = n - r - 1;
        ll h2 = suff[i1] - (i2 ? suff[i2 - 1] : 0);
        if (i1 > r)
            h1 *= pp[i1 - r];
        if (r > i1)
            h2 *= pp[r - i1];
        return h1 == h2;
    };
    ll ans = 0;
    FI(n)
    {
        for (int len = 1; ; ++len)
        {
            if (i + len * 2 - 1 >= n)
                break;
            int l1 = i, r1 = i + len - 1;
            int l2 = i + len, r2 = i + 2 * len - 1;
            ans += isPal(l1, r1) && isPal(l2, r2);
        }
    }
    cout << ans;

    return 0;
}
