#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 5e5 + 5;

string s;
int n;
int pos[MAXN];

void solve() {
	vector<int> maxpal(n, 1);
	int l = 0, r = -1;
	for (int i = 0; i < n; ++i) {
		if (i <= r) {
			maxpal[i] = min(maxpal[l + r - i], r - i + 1);
		}
		while (i - maxpal[i] >= 0 && i + maxpal[i] < n
			 && s[i - maxpal[i]] == s[i + maxpal[i]]) ++maxpal[i];
		if (i + maxpal[i] - 1 > r) {
			r = i + maxpal[i] - 1;
			l = i - maxpal[i] + 1;
		}
		//cout << "i: " << i << ' ' << maxpal[i] << endl;
	}
	for (int i = 0; i < n; ++i) {
		pos[i] = i - 2 * maxpal[i] + 1;
	}
	int counter = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j <= min(n - 1, i + 2 * maxpal[i] - 1); j += 2) {
			if (pos[j] <= i) ++counter;
		}
	}
	// even palindromes
	maxpal.assign(n, 0);
	l = 0; r = -1;
	for (int i = 1; i < n; ++i)  {
		if (i <= r) {
			maxpal[i] = min(maxpal[l + r - i + 1], r - i + 1);
		}
		while (i - maxpal[i] - 1 >= 0 && i + maxpal[i] < n && 
				s[i - maxpal[i] - 1] == s[i + maxpal[i]]) ++maxpal[i];
		//cout << "i: " << i << ' ' << maxpal[i] << endl;
		if (i + maxpal[i] - 1 > r) {
			r = i + maxpal[i] - 1;
			l = i - maxpal[i];
		}
	}
	for (int i = 1; i < n; ++i) {
		pos[i] = i - 2 * maxpal[i];
	}
	for (int i = 1; i < n; ++i) {
		for (int j = i + 2; j <= min(n - 1, i + 2 * maxpal[i]); j += 2) {
			if (pos[j] <= i) ++counter;
		}
	}
	cout << counter << endl;
}

int main() {
	cin >> n;
	cin >> s;
	solve();
	return 0;
}