#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()
#define norm norm228
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

mt19937 rnd(time(0));

struct hasher{
	string s;
	int n;
	int MOD;
	int base;
	vector<int> pows;
	vector<int> hashs;

	int add(int a, int b) {
		a += b;
		if (a >= MOD) 
			a -= MOD;
		return a;
	}

	int sub(int a, int b) {
		a -= b;
		if (a < 0)
			a += MOD;
		return a;
	}

	int mul(int a, int b) {
		return (ll) a * b % MOD;
	}

	hasher() {}
	hasher(string _s, int _MOD, int _base) {
		s = _s, MOD = _MOD;
		base = _base;
		n = s.size();
		pows.assign(n + 1, 1);
		for (int i = 1; i <= n; i++)
			pows[i] = mul(base, pows[i - 1]);
		hashs.assign(n + 1, 0);
		for (int i = 1; i <= n; i++) 
			hashs[i] = add(s[i - 1] - 'a', mul(hashs[i - 1], base));
	}

	int get(int l, int r) {
		return sub(hashs[r], mul(hashs[l], pows[r - l]));
	}
};

int n;
string s;

void read() {
	cin >> n >> s;
}

hasher norm, rev;

void build() {
	norm = hasher(s, 998244353, 179);
	reverse(all(s));
	rev = hasher(s, 998244353, 179);
}

bool check(int l, int r) {
	return norm.get(l, r) == rev.get(n - r + 1, n - l + 1);
}

int calc(int pos) {
	int ans = 0;
	for (int i = 0; pos - i >= 1 && pos + i + 1 <= n; i++) {
		//cout << pos - i << " " << pos << " " << pos + 1 << " " << pos + i + 1 << endl;
		ans += check(pos - i, pos) && check(pos + 1, pos + i + 1);
		//cout << check(pos - i, pos) << " " << check(pos + 1, pos + i + 1) << endl;
	}
	return ans;
}

int ans = 0;

void run() {
	build();
	//calc(3);
	//exit(0);
	for (int i = 1; i <= n; i++) {
		ans += calc(i);
		//cout << calc(i) << endl;
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}