#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

constexpr int MAXN = 5010;

int hs[MAXN][MAXN], rhs[MAXN][MAXN];
constexpr int P = 53;


void run() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        int h = 0;
        for (int j = i; j < n; j++) {
            hs[i][j] = h * P + s[j] - 'a' + 1;
            h = hs[i][j];
        }
    }
    string t = s;
    reverse(all(t));
    for (int i = 0; i < n; i++) {
        int h = 0;
        for (int j = i; j < n; j++) {
            rhs[i][j] = h * P + t[j] - 'a' + 1;
            h = rhs[i][j];
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j += 2) {
            int t = (j - i + 1) / 2;
            if (t % 2) {
                int l1 = i;
                int r1 = i + t / 2;
                int l2 = i + t / 2;
                int r2 = i + t - 1;
                int k = i + t;
                int l3 = k;
                int r3 = k + t / 2;
                int l4 = k + t / 2;
                int r4 = k + t - 1;
                if (hs[l1][r1] == rhs[n - r2 - 1][n - l2 - 1] && hs[l3][r3] == rhs[n - r4 - 1][n - l4 - 1])
                    ans++;
            } else {
                int l1 = i;
                int r1 = i + t / 2 - 1;
                int l2 = i + t / 2;
                int r2 = i + t - 1;
                int k = i + t;
                int l3 = k;
                int r3 = k + t / 2 - 1;
                int l4 = k + t / 2;
                int r4 = k + t - 1;
                if (hs[l1][r1] == rhs[n - r2 - 1][n - l2 - 1] && hs[l3][r3] == rhs[n - r4 - 1][n - l4 - 1])
                    ans++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}