#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <set>

typedef long long ll;
using namespace std;
int p = 31, mod = 1e9 + 7, n;
int p2 = 29, mod2 = 1e9 + 9;
vector<ll> pow, hashes, revhashes, hashes2, revhashes2, pow2;

ll gethash(int l, int r){
    if(l == 0) return hashes[r];
    return ((hashes[r] - (hashes[l - 1]*pow[r - l + 1])%mod) + mod)%mod;
}

ll getrevhash(int l, int r){
    if(r == n - 1) return revhashes[l];
    return ((revhashes[l] - (revhashes[r + 1]*pow[r - l + 1])%mod)%mod + mod)%mod;
}

ll gethash2(int l, int r){
    if(l == 0) return hashes2[r];
    return ((hashes2[r] - (hashes2[l - 1]*pow2[r - l + 1])%mod2)%mod2 + mod2)%mod2;
}

ll getrevhash2(int l, int r){
    if(r == n - 1) return revhashes2[l];
    return ((revhashes2[l] - (revhashes2[r + 1]*pow2[r - l + 1])%mod2)%mod2 + mod2)%mod2;
}


signed main()
{
    cin >> n;
    string s; cin >> s;
    hashes.resize(n);
    revhashes.resize(n);
    pow.resize(n);
    hashes2.resize(n);
    revhashes2.resize(n);
    pow2.resize(n);
    pow[0] = 1;
    pow2[0] = 1;
    for(int i = 1; i < n; i++){
        pow[i] = (pow[i - 1] * p)%mod;
        pow2[i] = (pow2[i - 1] * p2)%mod2;
    }
    hashes[0] = s[0] - 'a';
    revhashes[n - 1] = s[n - 1] - 'a';
    hashes2[0] = s[0] - 'a';
    revhashes2[n - 1] = s[n - 1] - 'a';
    for(int i = 1; i < n; i++){
        hashes[i] = ((hashes[i - 1] * p)%mod + (s[i] - 'a'))%mod;
        revhashes[n - i - 1] = ((revhashes[n - i] * p)%mod + (s[n - i - 1] - 'a'))%mod;
        hashes2[i] = ((hashes2[i - 1] * p2)%mod2 + (s[i] - 'a'))%mod2;
        revhashes2[n - i - 1] = ((revhashes2[n - i] * p2)%mod2 + (s[n - i - 1] - 'a'))%mod2;
    }
    int ans = 0;
    for(int i = 1; i < n; i+=2){
        for(int j = 0; j + i < n; j++){
            int bm  = (2*j + i)/2;
            bool sure = false;
            if(gethash(j, bm) == getrevhash(j, bm) && gethash(bm + 1, i + j) == getrevhash(bm + 1, i + j)){
                //cout << j << " " << i + j << endl;
                sure = true;
            }
            if(sure && gethash2(j, bm) == getrevhash2(j, bm) && gethash2(bm + 1, i + j) == getrevhash2(bm + 1, i + j)){
                ans++;
            }
        }
    }
    cout << ans;
}