#include <bits/stdc++.h>
#define  int long long
using namespace std;

const int pivo = 1e6 + 1;
int bal[pivo];
int n;

int fen[pivo + 5][4];

void add(int x, int pos) {
    int r = pos % 4;
    pos /= 4;
    for (; pos <= pivo / 4; pos += pos &- pos) fen[pos][r] += x;
}

int get(int l, int r, int T) {
    if (l != 1) return get(1, r, T) - get(1, l - 1, T);
    int ans = 0;
    for (; r > 0; r -= r & -r) ans += fen[r][T];
    return ans;
}

vector<int> man(string &s) {
    int L = 0, R = 0;
    vector<int> a(n, 0);
    a[0] = 1;
    for (int i = 1; i < n; i++) {
        if (i <= R) a[i] = min(a[L + (R - i)], R - i + 1);
        while (i - a[i] >= 0 && i + a[i] < n && s[i + a[i]] == s[i - a[i]]) a[i]++;
        if (R < i + a[i] - 1) R = a[i] + i - 1, L = i - a[i] + 1;
    }
    return a;
}

vector<int> sd[pivo];

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    n = 2 * n + 1;
    string s;
    cin >> s;
    string t;
    t.resize(n, '#');
    for (int i = 0; i <= n / 2; i++) t[2 * i + 1] = s[i];
    vector<int> m = man(t);
    for (int i = 0; i < n; i++) {
        sd[i + m[i] * 2].push_back(i);
        //cout << "Deleting " << i << " at " << i + m[i] * 2 << endl;
    }
    int ans = 0;
    for (int R = 0; R < n; R++) {
        for (auto j : sd[R]) add(-1, j + 4);
        if (R % 2 == 0) {
            int l = R - m[R] * 2;
            l = max(0, l);
            int nl = l / 4 * 4 + R % 4;
            while (nl < l) nl += 4;
            int T = nl % 4;
            nl += 4;
            nl /= 4;
            ans += get(nl, R / 4 + 1, T);
        }
        else {
            int l = R - m[R] * 2;
            l = max(0, l);
            int nl = l / 4 * 4 + (R + 2) % 4;
            while (nl < l) nl += 4;
            int T = nl % 4;
            nl += 4;
            nl /= 4;
            ans += get(nl, R / 4 + 1, T);
        };
        //cout << R << " " << ans << endl;
        add(1, R + 4);
    }
    cout << ans;
}
