#include <bits/stdc++.h>
#define FI(n) for(int i = 0; i < n; ++i)
#define FJ(n) for(int j = 0; j < n; ++j)
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define endl '\n'

#ifndef LOCAL
    #define LOCAL 0
#endif // LOCAL
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define cerr LOCAL && std::cerr
#define watch(x) cerr << #x << " = " << x << endl

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using namespace std;

int main()
{
#if !LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#endif

    int n;
    cin >> n;
    string s;
    cin >> s;

    const int k = 2;
    const ll p[k] = { 31, 37 };
    vector<ll> pp[k];
    vector<ll> pref[k], suff[k];
    FI(k)
    {
        pp[i].resize(n + 5);
        pp[i].front() = 1;
        pref[i].resize(n);
        suff[i].resize(n);
        for (int j = 1; j < pp[i].size(); ++j)
            pp[i][j] = pp[i][j - 1] * p[i];
        FJ(n)
        {
            pref[i][j] = (j ? pref[i][j - 1] : 0) + pp[i][j] * (s[j] - 'a' + 1);
            suff[i][j] = (j ? suff[i][j - 1] : 0) + pp[i][j] * (s[n - j - 1] - 'a' + 1);
        }
    }

    auto isPal = [&](int l, int r)
    {
        bool ok = true;

        FI(k)
        {
            ll h1 = pref[i][r] - (l ? pref[i][l - 1] : 0);
            int i1 = n - l - 1;
            int i2 = n - r - 1;
            ll h2 = suff[i][i1] - (i2 ? suff[i][i2 - 1] : 0);
            if (i1 > r)
                h1 *= pp[i][i1 - r];
            if (r > i1)
                h2 *= pp[i][r - i1];
            ok &= h1 == h2;
        }

        return ok;
    };
    ll ans = 0;
    FI(n)
    {
        for (int len = 1; ; ++len)
        {
            if (i + len * 2 - 1 >= n)
                break;
            int l1 = i, r1 = i + len - 1;
            int l2 = i + len, r2 = i + 2 * len - 1;
            ans += isPal(l1, r1) && isPal(l2, r2);
        }
    }
    cout << ans;

    return 0;
}
