#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

const int maxn = 5e5 + 4;
const int base = 197, mod = 1e15 + 7;
int n;
string s;
vector<int> h, revh;
int pw[maxn];

void precalc() {
	pw[0] = 1;
	for (int i = 1; i < maxn; i++) {
		pw[i] = (pw[i - 1] * base);
	}

	h.resize(n + 1);
	revh.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		h[i] = (h[i - 1] * base + s[i - 1]);
		revh[i] = revh[i - 1] * base + s[n - i];
	}
}

int gethash(int L, int R, vector<int>& h) {
	return h[R] - h[L - 1] * pw[R - L + 1];
}

int rev(int x) {
	return (n - x + 1);
}

vector<int> cent, x;

void calc() {
	cent.resize(n);
	for (int i = 1; i <= n; i++) {
		int L = 0, R = min(i - 1, n - i) + 1;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (gethash(i - M, i - 1, h) == gethash(rev(i + M), rev(i + 1), revh)) {
				L = M;
			}
			else {
				R = M;
			}
		}
		cent[i - 1] = 1 + 2 * L;
	}
	
	x.resize(n);
	for (int i = 1; i <= n - 1; i++) {
		int L = 0, R = min(i, n - i) + 1;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (gethash(i - M + 1, i, h) == gethash(rev(i + M), rev(i + 1), revh)) {
				L = M;
			}
			else {
				R = M;
			}
		}
		x[i] = 2 * L;
	}
}

void info() {
	cout << "cent: ";
	for (auto i : cent) {
		cout << i << " ";
	}
	cout << "\nx: ";
	for (int i = 1; i < n; i++) {
		cout << x[i] << " ";
	}
	cout << '\n';
}

int stupid() {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j += 2) {
			int d = (j - i - 1) / 2;
			int L = 2 * d + 1;
			if (cent[i] >= L && cent[j] >= L) {
				ans++;
			}
		}
	}

	for (int i = 1; i < n; i++) {
		for (int j = i + 2; j < n; j+=2) {
			if (x[i] >= j - i && x[j] >= j - i) {
				ans++;
			}
		}
	}

	return ans;
}

int stupid2() {
	int ans = 0;
	vector<int> f;
	for (int i = 0; i < n; i++) {
		if (i % 2 == 0) {
			for (auto& j : f) {
				j -= 2;
			}
			f.push_back(cent[i] - 1);
		}
		else {
			for (int j = 0; j <= cent[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
		}
	}

	f.clear();
	for (int i = 0; i < n; i++) {
		if (i % 2 == 1) {
			for (auto& j : f) {
				j -= 2;
			}
			f.push_back(cent[i] - 1);
		}
		else {
			for (int j = 0; j <= cent[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
		}
	}
	f.clear();
	vector<int> s;
	for (int i = 1; i < n; i++) {
		if (i % 2 == 1) {
			for (auto& j : f) {
				j -= 2;
			}
			for (int j = 0; j < x[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
			f.push_back(x[i]);
		}
		else {
			for (auto& j : s) {
				j -= 2;
			}
			for (int j = 0; j < x[i] / 2 && j + 1 <= s.size(); j++) {
				if (s[s.size() - 1 - j] >= 0) {
					ans++;
				}
			}
			s.push_back(x[i]);
		}
	}

	return ans;
}

signed main() {
	kekek;
	cin >> n >> s;
	precalc();
	calc();
	//info();
	cout << stupid2();

	return 0;
}