#pragma GCC optimize("-Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>


#define F first
#define S second
#define pb push_back
#define ll long long

using namespace std;
using namespace __gnu_pbds;


typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

mt19937 gen(time(0));

const int maxn = 5e5 + 55;
const int inf = 1e9 + 9;

int h[2][maxn];
int p = 37;
int m = 1e9 + 7;
int st[maxn];

void hsh(int nm, string& s)
{
    h[nm][0] = int(s[0] - 'a') + 1;
    for(int i = 1; i < int(s.size()); ++i)
    {
        h[nm][i] = (1ll * h[nm][i - 1] * p + int(s[i] - 'a') + 1) % m;
        cerr << h[nm][i] << endl;
    }
    return;
}

int n;

int gethash(int nm, int l, int r)
{
    if (nm == 1)
    {
        r = n - r - 1;
        l = n - l - 1;
        swap(l, r);
    }
    int ans = h[nm][r];
    if (l > 0)
            ans -= (1ll * h[nm][l - 1] * st[r - l + 1]) % m;
    if (ans < 0) ans += m;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    string s;
    cin >> n >> s;
    st[0] = 1;
    for(int i = 1; i <= n; ++i)
        st[i] = (1ll * st[i - 1] * p) % m;
    hsh(0, s);
    reverse(s.begin(), s.end());
    hsh(1, s);
    reverse(s.begin(), s.end());
    int ans = 0;
    for(int len = 1; len <= n / 2; ++len)
        for(int i = len - 1; i + len < n; ++i)
        {
            if (gethash(0, i - len + 1, i) == gethash(1, i - len + 1, i) &&
                gethash(0, i + 1, i + len) == gethash(1, i + 1, i + len)) ++ans;
        }
    cout << ans;
    return 0;
}
