#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

signed main() {
	warp();

	int n;
	string s;
	cin >> n >> s;
	int ans = n - 1;
	string p;
	p += s[0];
	for (int i = 1; i < n; ++i) {
		p += '#';
		p += s[i];
	}
	s = p;
	n = p.size();
	vector<int> L(n, 0);
	for (int i = 0; i < n; ++i) {
		int len = 0;
		while (i - (len + 1) >= 0 && i + (len + 1) < n) {
			int left = i - (len + 1), right = i + (len + 1);
			if (s[left] == s[right])
				++len;
			else
				break;
		}
		L[i] = len;
	}

	for (int len = 1; len <= n; ++len) {
		set<int> ss;
		for (int i = len; i + len < n; ++i) {
			if ((len % 2 == 1 && s[i] == '#') || (len % 2 == 0 && s[i] != '#')) {
				if (L[i] >= len)
					ss.insert(i);
			}
		}
		int nx = 2 * len + 2;
		for (int i : ss) {
			if (ss.count(i + nx))
				++ans;
		}
	}
	cout << ans;
}