#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG
#define int long long

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
// const int MOD2 = rnd() % 1000 + 9e8;
const int INF = 1e9 + 7;
const int MAXN = 2e5;
const int P = 31;

/*
bool is_pal(string s) {
	bool flag = 1;
	int k = (int)s.size() / 2;
	if ((int)s.size() % 2 == 1) {
		for (int i = 0; i <= k; ++i) {
			flag &= s[k - i] == s[k + i];
		}
	} else {
		for (int i = 0; i < k; ++i) {
			flag &= s[k + i] == s[k - 1 - i];
		}
	}
	// cout << s << " " << flag << "\n";
	return flag;
}
*/

int degs[MAXN];

void calc_degs() {
	degs[0] = 1;
	for (int i = 1; i < MAXN; ++i) {
		degs[i] = degs[i - 1] * P;
		degs[i] %= MOD;
		// degs[i] %= MOD2;
	}
}

vector <int> get(int n, string s) {
	vector <int> h(n);
	h[0] = s[0] - 'a' + 1;
	for (int i = 1; i < n; ++i) {
		h[i] = h[i - 1] * P + (s[i] - 'a' + 1);
		h[i] %= MOD;
		// h[i] %= MOD2;
	}
	return h;
}

int add(int h, int deg) {
	int res = h * degs[deg];
	res %= MOD;
	return res;
}

int get_subhash(vector <int>& h, int l, int r) {
	// cout << h.size() << " " << l << " " << r << endl;
	int len = r - l + 1;
	int res = h[r];
	// cout << h[r] << endl;
	if (l > 0) {
		res -= add(h[l - 1], len);
		if (res < 0) {
			res += MOD;
		}
	}
	return res;
}

bool is_pal(int n, vector <int>& forw_h, vector <int>& back_h, int l, int r) {
	int len = r - l + 1;
	int back_l = n - 1 - r;
	int back_r = n - 1 - l;
	// cout << l << " " << r << "\n";
	// cout << back_l << " " << back_r << endl;
	int h1 = get_subhash(forw_h, l, r);
	int h2 = get_subhash(back_h, back_l, back_r);
	// if (l > back_l) {
	// 	h1 = add(h1, l - back_l);
	// } else {
	// 	h2 = add(h2, back_l - l);
	// }
	return h1 == h2;
}

void solve() {
	calc_degs();
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector <int> forw_h = get(n, s);
	// out(int, forw_h);
	// int res = get_subhash(forw_h, 0, 2);
	// cout << res << "\n";
	reverse(all(s));
	vector <int> back_h = get(n, s);
	// out(int, back_h);
	// int res2 = get_subhash(back_h, 3, 5);
	// cout << res2 << "\n";
	// cout << endl;
	// return;
	int ans = 0;
	for (int l = 0; l < n; ++l) {
		for (int r = l; r < n; ++r) {
			if ((r - l + 1) % 2 == 0) {
				int mid = (l + r) / 2;
				// cout << "\t" << l << " " << r << "\n";
				// cout << s.substr(l, mid - l + 1) << "\n";
				// cout << s.substr(mid + 1, r - mid) << "\n";
				// if (is_pal(n, forw_h, back_h, l, mid) &&
				// 	   is_pal(n, forw_h, back_h, mid + 1, r)) {
				// 	cout << l << " " << mid << " " << r << endl;
				// }
				ans += is_pal(n, forw_h, back_h, l, mid) &&
					   is_pal(n, forw_h, back_h, mid + 1, r);// {
					// cout << l << " " << mid << " " << r << "\n";
				// }
			}
		}
	}
	cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 2;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}