#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    int INF = 1e18;
    int mod = 2600000069;
    int p = 10;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    int INF = 1e18;
    int mod = 2600000069;
    int p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

const int MAXN = 5e5 + 1;

int h[MAXN], rh[MAXN], pw[MAXN];
int n;
string s;

inline int subh(int l, int r) {
    int b = h[r], s = 0;
    if (l != 0) {
        s = (h[l - 1] * pw[r - l + 1]) % mod;
    }
    return (b - s + mod) % mod;
}

inline int subrh(int l, int r) {
    int b = rh[l], s = 0;
    if (r != n - 1) {
        s = (rh[r + 1] * pw[r - l + 1]) % mod;
    }
    return (b - s + mod) % mod;
}

inline bool pal(int l, int r) {
    return subh(l, r) == subrh(l, r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    pw[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        pw[i] = (pw[i - 1] * p) % mod;
    }
    cin >> n >> s;
    h[0] = s[0] - 'a' + 1;
    rh[n - 1] = s[n - 1] - 'a' + 1;
    for (int i = 1; i < n; i++) {
        h[i] = (h[i - 1] * p + s[i] - 'a' + 1) % mod;
    }
    for (int i = n - 2; i >= 0; i--) {
        rh[i] = (rh[i + 1] * p + s[i] - 'a' + 1) % mod;
    }
    int ans = n - 1;
    for (int l = 2; l <= n / 2; l++) {
        for (int s = l; s <= n - l; s++) {
            if (pal(s - l, s - 1) && pal(s, s + l - 1)) ans++;
        }
    }
    cout << ans;
}
/*
сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
