#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

bool checkOld(string& st)
{
    for(int i = 0; i < st.size() / 2; i++)
    {
        if(st[i] != st[st.size() - 1 - i])
            return 0;
    }
    return 1;
}

bool allCheckOld(string& st, ll l, ll r)
{
    int len = r - l + 1;
    if(len % 2 == 1)
        return 0;

    string cur1 = "";
    string cur2 = "";
    for(int i = l; i <= r; i++)
    {
        if(i - l < len / 2)
            cur1 += st[i];
        else
            cur2 += st[i];
    }

    // cerr << "cur1 " << cur1 << " cur2 " << cur2 << endl;
    if(checkOld(cur1) && checkOld(cur2))
    {
        return 1;
    }
    return 0;
}


vll p;
vector<vll > h;

ll count_hash(ll l, ll r, ll ind)
{
    if(l == 0)
        return h[ind][r];

    return (h[ind][r] - (h[ind][l - 1] * p[r - l + 1]) % MOD + MOD) % MOD; // Хз так можно или нет
}

bool check(ll l, ll r)
{
    if(l == r)
        return 1;

    ll len = r - l + 1;
    ll l1, r1, l2, r2;
    l1 = l;
    r1 = l1 + len / 2 - 1;

    if(len % 2 == 0)
        l2 = r1 + 1;
    else
        l2 = r1 + 2;
    r2 = l2 + len / 2 - 1;


  //  cerr << "l " << l << " r " << r << endl;
  //  cerr << "comparing pairA " << l1 << " " << r1 << " pairB " << h[0].size() - 1 - r2 << " " << h[0].size() - 1 - l2 << endl;
//    cerr << "res " << count_hash(l1, r1, 0) << " " << count_hash(h[0].size() - 1 - r2, h[0].size() - 1 - l2, 1) << endl;
    return count_hash(l1, r1, 0) == count_hash(h[0].size() - 1 - r2, h[0].size() - 1 - l2, 1);
}

vll countHash(string& st, vll& p)
{
    vll h;
    h.resize(st.size());
    h[0] = st[0] - 'a' + 1;
    for(int i = 1; i < st.size(); i++)
        h[i] = ((h[i - 1] * p[1]) % MOD + st[i] - 'a' + 1 + MOD) % MOD;
    return h;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    string st;
    cin >> st;
    string stRev = st;
    reverse(stRev.begin(), stRev.end());

    p.resize(n + 2);
    p[0] = 1;
    for(int i = 1; i < n; i++)
        p[i] = (p[i - 1] * 31) % MOD;

    h.resize(2);
    h[0] = countHash(st, p);
    h[1] = countHash(stRev, p);

    ll answ = 0;
    for(int l = 0; l < n; l++)
    {
        for(int r = l + 1; r < n; r++)
        {
            int len = r - l + 1;
            if(len % 2 == 1)
                continue;

            ll l1 = l;
            ll r1 = l + len / 2 - 1;
            ll l2 = r1 + 1;
            ll r2 = l2 + len / 2 - 1;

         /*   if((check(l1, r1) && check(l2, r2)) != allCheckOld(st, l, r))
            {
                cerr << "WRONG " << l << " " << r << endl;
                cerr << "l1 " << l1 << " r1 " << r1 << endl;
                cerr << "l2 " << l2 << " r2 " << r2 << endl;
                cerr << "check(l1, r1) " << check(l1, r1) << " " << check(l2, r2) << endl;
                cerr << "all check old " << allCheckOld(st, l, r) << endl;
                return 0;
            }*/

            if(check(l1, r1) && check(l2, r2))
                answ++;
        }
    }
    cout << answ << endl;
    return 0;
}