#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#define ll long long
#define mp make_pair
#define pb push_back
#define pll pair<ll,ll>
#define ld long double
#define se second
#define fi first
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

const ll MOD=1e9+7;

mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());

template<typename T>
using ord_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

ll n, m, k, l, r, d1[1000001], d2[1000001], rd2[1000001], ans;
ll b[1000001];
vector<pll> v, z;
string s;

ll binpow(ll h,ll r,ll md=MOD)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h, l%=md;
        h*=h;
        h%=md;
        r/=2;
    }
    return l;
}

ll gcd(ll x,ll y)
{
    if (x==0 || y==0) return x+y; else return __gcd(x,y);
}

struct fenwick_tree
{
    ll f[1000001];

    void update(int h,int k)
    {
        for (int i = h; i <= n; i+=(i&-i)) f[i]+=k;
    }

    ll get(int h)
    {
        ll ans=0;
        for (int i = h; i > 0; i-=(i&-i)) ans+=f[i];
        return ans;
    }
};

fenwick_tree f[2], g[2];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    cin >> s;
    s=' '+s;
    ll l=1, r=0;
    for (int i = 1; i <= n; i++)
    {
        d1[i]=0;
        if (i<=r) d1[i]=min(d1[l+r-i],r-i);
        while (i+d1[i]+1<=n && i-d1[i]-1>0 && s[i+d1[i]+1]==s[i-d1[i]-1])
            d1[i]++;
        if (i+d1[i]>r) l=i-d1[i], r=i+d1[i];
    }
    //for (int i = 1; i <= n; i++) cout << d1[i] << " ";
    //cout << "\n";
    l=1, r=0;
    for (int i = 1; i <= n; i++)
    {
        d2[i]=0;
        if (i+1<=r) d2[i]=min(rd2[l+r-i],r-i);
        while (i-d2[i]>0 && i+d2[i]+1<=n && s[i-d2[i]]==s[i+d2[i]+1])
            d2[i]++;
        if (i+d2[i]>r) l=i-d2[i]+1, r=i+d2[i];
        rd2[i+1]=d2[i];
    }
    //for (int i = 1; i <= n; i++) cout << d2[i] << " ";
    //cout << "\n";

    for (int i = 1; i <= n; i++) v.pb(mp(d1[i],i)), f[i%2].update(i,1);

    sort(all(v));

    for (int it = 0; it < v.size(); it++)
    {
        ll j=(v[it].se+1)%2, u=v[it].se%2, i=v[it].se, len=v[it].fi;
        f[u].update(i,-1);
        ans+=f[j].get(min(n,i+len*2+1))-f[j].get(i);
        ans+=f[j].get(i)-f[j].get(max(0ll,i-len*2-2));
        //cout << i << " " << len << " ";
        //cout << ans << "\n";
    }

    for (int i = 1; i <= n; i++) g[i%2].update(i,1), z.pb(mp(d2[i],i));

    sort(all(z));

    for (int it = 0; it < z.size(); it++)
    {
        ll i=z[it].se, j=(z[it].se%2), len=z[it].fi;
        g[j].update(i,-1);
        ans+=g[j].get(min(n, i+len*2 ))-g[j].get(max(0ll, i-len*2-1 ));
    }
    cout << ans;
    return 0;
}
