#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define x first
#define y second

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
const int N = 5e5 + 10;
const int Nn = 750010;
const ll mod = 1e9 + 13;

const ll pp = 31;
int n;
char a[N];
ll f[N], s[N], p[N];


int getf(int l, int r)
{
    return (f[r] - f[l - 1] * p[(r - l + 1)] % mod + mod) % mod;
}

int getsec(int l, int r)
{
    return (s[l] - s[r + 1] * p[r - l + 1] % mod + mod) % mod;
}
ll ans = 0;
int d[N];


struct node
{
    int x;
    node* L;
    node* R;
    int l;
    int r;
    node(int f, int s)
    {
        L = nullptr;
        R = nullptr;
        l = f;
        r = s;
    }
};

void build(node* v)
{
    v->x = 0;
    if (v->l == v->r - 1)
    {
        return;
    }
    int m = (v->l + v->r) / 2;
    if (v->L == nullptr) v->L = new node(v->l, m);
    if (v->R == nullptr) v->R = new node(m, v->r);
    build(v->L);
    build(v->R);
}
node* upd(node* v, int p)
{
    if (v->l + 1 == v->r)
    {
        node* b = new node(v->l, v->r);
        b->x = v->x + 1;
        return b;
    }
    int m = (v->l + v->r) / 2;
    node* b = new node(v->l, v->r);
    b->L = v->L;
    b->R = v->R;
    b->x = v->x;
    ++b->x;
    if (p >= m) b->R = upd(v->R, p);
    else b->L = upd(v->L, p);
    return b;
}

ll get(node* v, int l)
{
    if (v->l >= l) return v->x;
    else if (v->r <= l) return 0;
    return get(v->L, l) + get(v->R, l);
}
node* t[N];

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];

    p[0] = 1;
    for (int i = 1; i <= n; ++i) p[i] = p[i - 1] * pp % mod;
    for (int i = 1; i <= n; ++i)
    {
        f[i] = (f[i - 1] * pp % mod + a[i] - 'a') % mod;
    }

    for (int i = n; i >= 1; --i)
    {
        s[i] = (s[i + 1] * pp % mod + a[i] - 'a') % mod;
    }

    for (int i = 1; i <= n; ++i)
    {
        int l = 0, r = min(i - 1, n - i) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (getf(i - m, i - 1) == getsec(i + 1, i + m)) l = m;
            else r = m;
        }
        d[i] = l;
    }

    t[0] = new node(1, Nn);
    t[1] = new node(1, Nn);
    build(t[0]);
    build(t[1]);
    t[1] = upd(t[1], 1 + 2 * d[1] + 1);

    for (int i = 2; i <= n; ++i)
    {
        int st = i - 2 * d[i] - 1;
        if (st <= 0)
        {
            if (st % 2 == 0) st = 2;
            else st = 1;
        }
        if (st <= 2)
        {
            ans += get(t[i - 1], i);
        } else
        {
            ans += get(t[i - 1], i) - get(t[st - 2], i);
        }
        t[i] = upd(t[i - 2], i + 2 * d[i] + 1);
    }

    for (int i = 1; i <= n; ++i)
    {
        int l = 0, r = min(i, n - i) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (getf(i - m + 1, i) == getsec(i + 1, i + m)) l = m;
            else r = m;
        }
        d[i] = l;
    }
    build(t[0]);
    build(t[1]);
    t[1] = upd(t[1], 1 + 2 * d[1]);
    for (int i = 2; i <= n; ++i)
    {
        int st = i - 2 * d[i];
        if (st <= 0)
        {
            if (st % 2 == 0) st = 2;
            else st = 1;
        }
        if (st <= 2)
        {
            ans += get(t[i - 2], i);
        } else
        {
            ans += get(t[i - 2], i) - get(t[st - 2], i);
        }
        /*for (int j = st; j < i; j += 2)
        {
            if (j + 2 * d[j] >= i) ++ans;//, cout << i << ' ' << j << "E1" << endl;
        }*/
        t[i] = upd(t[i - 2], i + 2 * d[i]);
    }
    cout << ans;

    return 0;
}

