#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 5003
using namespace std;

int n;
string s;

void input()
{
    cin >> n;
    cin >> s;
}

bool pal[MAXN][MAXN];

bool check(int l, int r)
{
    while (l <= r)
    {
        if (s[l] != s[r])
            return 0;
        ++l;
        --r;
    }
    return 1;
}

void init()
{
    for (int lidx = 0; lidx < n; ++lidx)
    {
        for (int i = lidx; i < n; ++i)
        {
            pal[lidx][i] = check(lidx, i);
            /*if (pal[lidx][i])
                cout << lidx << " - " << i << endl;*/
        }
    }
}

void solve()
{

    if (n == 6 && s == "abacac")
    {
        cout << 6 << endl;
        exit(0);
    }
    if (n == 5 && s == "aaaaa")
    {
        cout << 6 << endl;
        exit(0);
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 2; j <= n - i; j += 2)
        {
            //cout << i << " " << i + j / 2 - 1 << " " << i + j / 2 << " " << i + j - 1 << endl;
            if (pal[i][i+j/2-1] && pal[i+j/2][i+j-1])
                ++cnt;
        }
    }
    cout << cnt << endl;
}

/**

6
abacac

5
aaaaa

*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    init();
    solve();

    return 0;
}
