#include <bits/stdc++.h>

using namespace std;

#define int long long
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i,n,m) for(int i = n; i<m; ++i)
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define sc second
#define fr first

struct pol_has
{
    const int P1 = 31, P2 = 53, MOD1 = 1e9 + 7, MOD2 = 1e9 + 53;
    vector <int> st1, st2, has1, has2;
    pol_has(string s)
    {
        int n = s.size();
        st1.resize(n + 1, 1), st2.resize(n + 1, 1), has1.resize(n + 1, 0), has2.resize(n + 1, 0);
        FOR(i, 1, n + 1) st1[i] = (st1[i - 1] * P1) % MOD1;
        FOR(i, 1, n + 1) st2[i] = (st2[i - 1] * P2) % MOD2;

        FOR(i, 1, n + 1) has1[i] = ((has1[i - 1] * P1) % MOD1 + s[i-1] - 'a' + 1 + MOD1) %MOD1;
        FOR(i, 1, n + 1) has2[i] = ((has2[i - 1] * P2) % MOD2 + s[i-1] - 'a' + 1 + MOD2) %MOD2;
    }
    int get_has(int l, int r)
    {
        int a = (has1[r + 1] - (has1[l] * st1[r - l + 1]) % MOD1 + 10 * MOD1)%MOD1;
        int b = (has2[r + 1] - (has2[l] * st2[r - l + 1]) % MOD2 + 10 * MOD2)%MOD2;
        return a * MOD2 + b;
    }
};

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    string s, s2;
    cin >> s;
    pol_has norm = pol_has(s);
    s2 = s;
    reverse(all(s2));
    pol_has rev = pol_has(s2);
    int ans = n - 1;
    for(int sz = 4; sz <= n; sz += 2)
    {
        int p_sz = sz/2;
        for(int i = 0; i < n - sz + 1; ++i)
        {
            int a,b,c,d;
            int ch = p_sz/2, mn = p_sz % 2;
            --ch;
            a = norm.get_has(i, i + ch);
            b = rev.get_has(n - i - p_sz, n - i - p_sz + ch);
            c = norm.get_has(i + p_sz + ch, i + p_sz + ch);
            d = rev.get_has(n - i - sz, n - i - sz + ch);
            if (a == b && c == d) ++ans;
            //cout << i << ' ' << ans << endl;
        }
        //cout << sz << ' ' << ans << endl;
    }
    cout << ans;
}
