#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define ld long double
#define F first
#define S second
#define int ll
#define endl '\n'
#define _ <<' '<<

using namespace std;

mt19937 gen(time(0));

const int N = 5e5 + 1007;
const int M = 1e9 + 7;
const int M1 = 1e9 + 9;
const int P = 31;
const int P1 = 39;
const int sz = 2*N + 9;

struct fenwik{
    int t[sz];

    fenwik(){memset(t, 0, sizeof(t));}

    void upd(int p, int x){p += N;
        for (; p < sz; p += p&-p) t[p] += x;
    }

    int q(int p){p += N;
        int res = 0;
        for (; p; p -= p&-p) res += t[p];
        return res;
    }

    int q(int l, int r){
//    cerr << l << ' ' << r << endl;
        return q(r) - q(l - 1);
    }

    int Q(int x){
        return q(x, N + 2);
    }
}t[2], T[2];

int n;
string s;
vector<pair<int,int> > add[N], del[N];
vector<pair<int,int> > add2[N], del2[N];

struct HASH{
    vector<pair<int,int> > h, p;

    HASH(string s){
        p.pb( {1, 1} );
        h.pb( {s[0] - 'a' + 1, s[0] - 'a' + 1} );
        for (int i = 1; i < s.size(); i++){
            p.pb( {(1ll*p[i - 1].F*P)%M, (1ll*p[i - 1].S*P1)%M1} );
            h.pb( {(1ll*h[i - 1].F*P + s[i] - 'a' + 1)%M, (1ll*h[i - 1].S*P1 + s[i] - 'a' + 1)%M1} );
        }
    }

    pair<int,int> get(int l, int r){
        if (l < 0 || r >= h.size()) return {gen(), gen()};
        pair<int,int> ret = h[r];
        if (l) ret.F = (ret.F - 1ll*h[l - 1].F*p[r - l + 1].F)%M;
        if (l) ret.S = (ret.S - 1ll*h[l - 1].S*p[r - l + 1].S)%M1;
        if (ret.F < 0) ret.F += M;
        if (ret.S < 0) ret.S += M1;
        return ret;
    }
};

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    cin >> s;
    string tt = s;
    reverse(tt.begin(), tt.end());
    HASH a(s);
    HASH b(tt);

    vector<int> len1(n, 1), len2(n);

    int c = 0, r = 0;
    for (int i = 1; i < n; i++){
        int L = i + 1;
        int R = n - i;
        int l2 = r - i + 1;
        if (i <= r && c - (i - c) >= 0) len1[i] = max(len1[i], min(l2, len1[c - (i - c)]));
        len1[i] = min(len1[i], min(R, L));
        while (i - len1[i] >= 0 && i + len1[i] < n && s[i - len1[i]] == s[i + len1[i]]) len1[i]++;
        if (i + len1[i] - 1 > r) r = i + len1[i] - 1, c = i;
    }
    c = -1, r = -1;
    for (int i = 0; i < n; i++){
        int L = i + 1;
        int R = n - (i + 1);
        int l2 = r - i;
        if (i <= r && c - (i - (c + 1)) - 1 >= 0) len2[i] = max(len2[i], min(l2, len2[c - (i - (c + 1)) - 1]));
        len2[i] = min(len2[i], min(R, L));
        while (i - len2[i] >= 0 && i + 1 + len2[i] < n && s[i - len2[i]] == s[i + 1 + len2[i]]) len2[i]++;
        if ((i + 1) + len2[i] - 1 > r) r = (i + 1) + len2[i] - 1, c = i;
    }

    vector<int> dp1 = len1;
    vector<int> dp2 = len2;
    for (int i = 0; i < n; i++) dp1[i] -= (i/2);
    for (int i = 0; i < n; i++) dp2[i] -= (i/2);
    int res = 0;
    for (int i = 0; i < n; i++){
        del[i].pb( {(i + 1)%2, 1 - (i + 1)/2} );
        add[min(n - 1, i + len1[i]*2 - 1)].pb( {(i + 1)%2, 1 - (i + 1)/2} );
    }

    for (int i = 0; i < n; i++){
        t[i%2].upd(dp1[i], 1);
        for (auto it : del[i]) res -= t[it.F].Q(it.S);
        for (auto it : add[i]) res += t[it.F].Q(it.S);
    }

    for (int i = 0; i < n; i++){
        del2[min(n - 1, i)].pb( {i%2, 1 - (i + 2)/2} );
        add2[min(n - 1, i + len2[i]*2)].pb( {i%2, 1 - (i + 2)/2} );
    }

    for (int i = 0; i < n; i++){
        T[i%2].upd(dp2[i], 1);
        for (auto it : del2[i]) res -= T[it.F].Q(it.S);
        for (auto it : add2[i]) res += T[it.F].Q(it.S);
    }

    cout << res;
    return 0;
}
