#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC("avx2")


#define ll long long
#define pb push_back
#define fi first
#define se second
#define pii pair < int , int >
#define ld long double


using namespace std;
using namespace __gnu_pbds;

template < typename T >
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 5e5 + 1;
int h[N], hr[N], pw[N], len1[N], len2[N];

int M = 1e9 + 107;
int p = 29;

void H(string &s){
    int n = s.size();
    h[0] = s[0] - 'a' + 1;
    for (int i = 1; i < n; ++i){
        h[i] = (s[i] - 'a' + 1 + 1ll * h[i - 1] * p) % M;
    }
}

void Hr(string &s){
    int n = s.size();
    hr[0] = s[0] - 'a' + 1;
    for (int i = 1; i < n; ++i){
        hr[i] = (s[i] - 'a' + 1 + 1ll * hr[i - 1] * p) % M;
    }
}

inline int otr(int l, int r){
    if (!l) return h[r];
    return (h[r] - (h[l - 1] * 1ll * pw[r - l + 1]) % M + M)% M;
}

inline int otrR(int l, int r){
    if (!l) return hr[r];
    return (hr[r] - (hr[l - 1] * 1ll * pw[r - l + 1]) % M + M) % M;
}

void precalc(int n){
    for (int i = 0; i < n; ++i){
            int l = 0, r = min(n - i - 1, i);
            while(l < r){
                int mid = ((l + r) >> 1) + 1;
                int Pl = i, Pr = i + mid;
                Pl = n - Pl - 1;
                Pr = n - Pr - 1;
                int h1 = otr(i - mid, i);
                int h2 = otrR(Pr, Pl);
                if (h1 == h2)
                    l = mid; else r = mid - 1;
            }
            len1[i] = l;
        }
        len2[0] = -1;
        len2[n - 1] = -1;

        for (int i = 1; i < n; ++i){
            int l = -1, r = min(n - i - 1, i - 1);
            while(l < r){
                int mid = ((l + r) >> 1) + 1;
                int Pl = i, Pr = i + mid;
                Pl = n - Pl - 1;
                Pr = n - Pr - 1;
                int h1 = otr(i - mid - 1, i - 1);
                int h2 = otrR(Pr, Pl);
                if (h1 == h2)
                    l = mid; else r = mid - 1;
            }
            len2[i] = l;
        }

}

ll brute(int n){
    unordered_set < int > mp1[n], mp2[n];
    ll ans = 0;
    int cnt = 0;
    for (int i = 0; i < n; ++i){
         int byl = 0;
         for (int j = 0; j <= len1[i]; ++j){
            if (mp1[i - j].count(j)){
                ans++;
                ++byl;
            if (j + 1 != byl) cout<<"BUG "<<i<<" "<<j<<endl;
            }

            ++cnt;
            if (i + j + 1 < n)
                mp1[i + j + 1].insert(j);
         }
//         cout<<endl;
         if (len2[i] > -1){
            for (int j = 0; j <= len2[i]; ++j){
                if (mp2[i - j - 1].count(j)) ++ans;
                ++cnt;
                if (i + j + 1 < n)
                    mp2[i + j + 1].insert(j);
            }
         }
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    #ifdef Estb_probitie
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    #endif

    int n;
    cin >> n;
    string s;
    cin >> s;
    H(s);
    string q = s;
    reverse(q.begin(), q.end());
    Hr(q);
    pw[0] = 1;
    for (int i = 1; i < s.size() + 1; ++i)
        pw[i] = (1ll * pw[i - 1] * p) % M;

    precalc(n);
    cout<<brute(n)<<endl;


//    while()

}

