#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

void build_z1(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i - 1, z[left - (i - left) - 1]), 0);
        while (i + z[i] < n && i - z[i] - 1 >= 0 && s[i - z[i] - 1] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

void build_z2(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i, z[left - (i - left)]), 1);
        while (i + z[i] < n && i - z[i] >= 0 && s[i - z[i]] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    string s; cin >> s;

    vector<int> z1(n);
    vector<int> z2(n, 1);
    build_z1(s, z1);
    build_z2(s, z2);

//    for (int el : z1)
//        cout << el << " ";
//    cout << endl;
//    for (int el : z2)
//        cout << el << " ";

    ll ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j <= n; j++){
            if ((j - i) % 2 != 0)
                continue;
            int len = (j - i) / 2;
            if (len % 2 == 0){
                if (z1[i + len / 2] >= len / 2 && z1[i + len + len / 2] >= len / 2)
                    ans++;
            }
            else{
                if (z2[i + len / 2] >= len / 2 + 1 && z2[i + len + len / 2] >= len / 2 + 1)
                    ans++;
            }
        }
    cout << ans;
    return 0;
}