#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<string>

using namespace std;

#define int long long

const int mod = 1e9 + 9;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	string s = "&";
	string s1;
	cin >> s1;
	s += s1;
	vector<int> hash(n + 2);
	vector<int> p(n + 2);
	vector<int> hash1(n + 2);
	p[0] = 1;
	for (int i = 1; i <= n; i++) {
		p[i] = p[i - 1] * 29;
		p[i] %= mod;
	}
	hash[0] = int(s[0] - 'a');
	for (int i = 1; i <= n; i++) {
		hash[i] = hash[i - 1] + int(s[i] - 'a') * p[i];
		hash[i] %= mod;
	}
	hash1[n] = int(s[n] - 'a') * p[0];
	for (int i = n - 1; i >= 0; i--) {
		hash1[i] = hash1[i + 1] + p[n - i] * int(s[i] - 'a');
		hash1[i] %= mod;
	}
	vector<vector<int>> ifp(n + 1, vector<int>(n + 1));
	for (int i = 1; i <= n; i++) {
		for (int j = i; j <= n; j++) {
			int h1 = (hash[j] + mod - hash[i - 1]) % mod;
			int h2 = (hash1[i] - hash1[j + 1] + mod) % mod;
			if (i > n - j) {
				h2 *= p[i - n + j];
				h2 %= mod;
			}
			else {
				h1 *= p[n - j - i];
				h1 %= mod;
			}
			if (h1 == h2) {
				ifp[i][j] = 1;
			}
		}
	}
	int ans = 0;
	for (int i = 1; i < n; i++) {
		int r1 = i;
		int l2 = i + 1;
		int r2 = i + 1;
		int l1 = i;
		while (l1 >= 0 && r2 <= n) {
			if (ifp[l1][r1] && ifp[l2][r2]) {
				ans++;
			}
			l1--;
			r2++;
		}
	}
	cout << ans;
}