#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(228);
#define rall(x) (x).begin(), (x).end()
#define all(x) (x).begin(), (x).end()
#define pNN pair <Node *, Node *>
#define SZ(x) (int)(x).size()
#define pii pair <int, int>
#define pb push_back
#define ins insert
#define ers erase
#define S second
#define F first
const int N = 1e6 + 10, INF = 1e9 + 10;

int len1[N], len2[N];

struct FenTree {
	int t[N];

	void clear() {
		fill(t, t + N, 0);
	}

	FenTree () {
		clear();
	}

	void modify(int ind, int delta) {
		for (; ind < N; ind |= ind + 1) {
			t[ind] += delta;
		}
	}

	int sum(int p) {
		int res = 0;
		for (; p >= 0; p = (p & (p + 1)) - 1) {
			res += t[p];
		}
		return res;
	}

	int query(int l, int r) { 
		return sum(r) - (l > 0 ? sum(l - 1) : 0);
	}
};

FenTree t1, t2;

void f(int n, string s) {
	len1[0] = 1;
	int ind = 0, len = 1; 
	for (int i = 1; i < n; ++i) {
		len1[i] = max(0, min(ind + len - i, len1[ind * 2 - i]));
		while (i + len1[i] < n && i - len1[i] >= 0 && s[i + len1[i]] == s[i - len1[i]]) {
			++len1[i];
		}
		if (i + len1[i] > ind + len) {
			ind = i;
			len = len1[i];
		}
	}
	for (int i = 0; i < n; ++i) {
		--len1[i];
	}
}

bool cmp(pii a, pii b) {
	return a > b;
}

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	if (n == 1) {
		cout << 0;
		exit(0);
	}	
	f(n, s);
	ll ans = 0;


	vector <pii> vec;
	for (int i = 0; i < n; ++i) {
		vec.pb(make_pair(len1[i], i));
	}
	sort(all(vec), cmp);
	for (auto x : vec) {
		int i = x.S;
		int len = x.F;
		if (i % 2 == 0) {
			ans += (ll)(t2.query(max(0,i - len * 2 - 1), min(n - 1, i + len * 2 + 1)));
			t1.modify(i, 1);
		} else {
			ans += (ll)(t1.query(max(0, i - len * 2 - 1), min(n - 1, i + len * 2 + 1)));
			t2.modify(i, 1);
		}
	}
	vec.clear();
	t1.clear();
	t2.clear();

	string ss = "#";
	for (auto x : s) {
		ss += x;
		ss += '#';
	}
	n = SZ(ss);
	f(n, ss);
	for (int i = 0; i < n; i += 2) {
		vec.pb(make_pair(len1[i], i));
	}
	sort(all(vec), cmp);
	for (auto x : vec) {	
		int i = x.S;
		int len = x.F;
		if ((i / 2) % 2 == 0) {
			ans += (ll)(t1.query(max(0, i - 2 * len - 2), min(n - 1, i + 2 * len + 2)));
			t1.modify(i, 1);
		} else {
			ans += (ll)(t2.query(max(0, i - 2 * len - 2), min(n - 1, i + 2 * len + 2)));
			t2.modify(i, 1);
		}
	} 
	cout << ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef Solenoid555
		freopen("input.txt", "r", stdin);
	#endif
	solve();
	return 0;
}