#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 6e5 + 10;
int d1[N], d2[N];

struct nd {
    int l, r;
    int s;

    nd() : l(-1), r(-1), s(0) {}
};

nd t[N * 15];
int tt[N];
int n;
string s;
int num = 0;

int upd(int v, int tl, int tr, int i) {
    if (tl > i || tr < i) return v;
    int nv = num++;
    t[nv] = nd();
    int ls = -1, rs = -1;
    if (v != -1) {
        ls = t[v].l;
        rs = t[v].r;
        t[nv].s = t[v].s;
    }
    if (tl == tr) {
        t[nv].s++;
        return nv;
    }
    int tm = (tl + tr) / 2;
    t[nv].l = upd(ls, tl, tm, i);
    t[nv].r = upd(rs, tm + 1, tr, i);
    t[nv].s = 0;
    if (t[nv].l != -1) t[nv].s += t[t[nv].l].s;
    if (t[nv].r != -1) t[nv].s += t[t[nv].r].s;
    return nv;
}

int get(int v, int tl, int tr, int l) {
    if (v == -1) return 0;
    if (tr < l) return 0;
    if (tl >= l) return t[v].s;
    int tm = (tl + tr) / 2;
    return get(t[v].l, tl, tm, l) + get(t[v].r, tm + 1, tr, l);
}

void solve() {
    int prv = -1, r = -1;
    for (int i = 0; i < n; i++) {
        if (r >= i) {
            d1[i] = min(r - i + 1, d1[2 * prv - i]);
        }
        while (d1[i] <= i && i + d1[i] < n && s[i - d1[i]] == s[i + d1[i]]) d1[i]++;
        if (i + d1[i] - 1 > r) {
            r = i + d1[i] - 1;
            prv = i;
        }
    }
    prv = -1, r = -1;
    for (int i = 0; i < n; i++) {
        if (r > i) {
            d2[i] = min(r - i, d2[2 * prv - i]);
        }
        while (d2[i] <= i && i + d2[i] + 1 < n && s[i - d2[i]] == s[i + d2[i] + 1]) d2[i]++;
        if (i + d2[i] > r) {
            r = i + d2[i];
            prv = i;
        }
    }
}

signed main() {
    fast();
    cin >> n;
    cin >> s;
    solve();
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        tt[i] = -1;
        if (i > 0) tt[i] = tt[i - 1];
        if (i & 1) {
            tt[i] = upd(tt[i], 0, n, min(n - 1, 2 * d1[i] - 1 + i));
        } else {
            int l = max(0, i - 2 * d1[i] + 1);
            int d = 0;
            if (l > 0) d = get(tt[l - 1], 0, n, i);
            ans += get(tt[i], 0, n, i) - d;
        }
    }
    num = 0;
    for (int i = 0; i < n; i++) {
        tt[i] = -1;
        if (i > 0) tt[i] = tt[i - 1];
        if (i % 2 == 0) {
            tt[i] = upd(tt[i], 0, n, min(n - 1, 2 * d1[i] - 1 + i));
        } else {
            int l = max(0, i - 2 * d1[i] + 1);
            int d = 0;
            if (l > 0) d = get(tt[l - 1], 0, n, i);
            ans += get(tt[i], 0, n, i) - d;
        }
    }
    num = 0;
    for (int i = 0; i < n; i += 2) {
        tt[i] = -1;
        if (i >= 2) tt[i] = tt[i - 2];
        int l = max(0, i - 2 * d2[i]);
        int d = 0;
        if (l >= 2) d = get(tt[l - 2], 0, n, i);
        ans += get(tt[i], 0, n, i) - d;
        tt[i] = upd(tt[i], 0, n, min(n - 1, i + 2 * d2[i]));
    }
    num = 0;
    for (int i = 1; i < n; i += 2) {
        tt[i] = -1;
        if (i >= 2) tt[i] = tt[i - 2];
        int l = max(0, i - 2 * d2[i]);
        int d = 0;
        if (l >= 2) d = get(tt[l - 2], 0, n, i);
        ans += get(tt[i], 0, n, i) - d;
        tt[i] = upd(tt[i], 0, n, min(n - 1, i + 2 * d2[i]));
    }
    cout << ans;
    return 0;
}