#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()

const int N = 5e5 + 10;
const int MX = 5e5;
const int P = 239017;
const int MOD = 998244353;
int t[2][N / 2], max_pal[N], n, sz;
int hs[N], p_pow[N], hs2[N];

void update(int id, int v, int delta) {
  for (; v <= sz; v += v & (-v)) {
    t[id][v] += delta;
  }
}

void update(int v, int delta) {
  int id = v & 1;
  v = (v + 1) / 2;
  update(id, v, delta);
}

int get(int id, int v) {
  int res = 0;
  for (; v > 0; v -= v & (-v)) {
    res += t[id][v];
  }
  return res;
}

int get_sum(int l, int r) {
  if (r > n) {
    r = n;
    if (r % 2 != l % 2) {
      r--;
    }
  }
  int id = l & 1;
  l = (l + 1) / 2, r = (r + 1) / 2;
  return get(id, r) - get(id, l - 1);
}

int mult(int a, int b) {
  return (a * 1ll * b) % MOD;
}

int sum(int a, int b) {
  a += b;
  if (a >= MOD) {
    a -= MOD;
  }
  return a;
}

int raz(int a, int b) {
  a -= b;
  if (a < 0) {
    a += MOD;
  }
  return a;
}

inline int get_hash(int l, int r) {
  return mult(raz(hs[r], hs[l - 1]), p_pow[MX - r]);
}

inline int get_rev_hash(int l, int r) {
  int tl = n - l + 1, tr = n - r + 1;
  return mult(raz(hs2[tl], hs2[tr - 1]), p_pow[MX - tl]);
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  p_pow[0] = 1;
  for (int i = 1; i <= MX; i++) {
    p_pow[i] = mult(p_pow[i - 1], P);
  }
  cin >> n;
  sz = (n + 1) / 2;
  string s;
  cin >> s;
  s.insert(s.begin(), '$');
  for (int i = 1; i <= n; i++) {
    hs[i] = sum(hs[i - 1], mult(p_pow[i], s[i]));
  }
  int ptr = 1;
  for (int i = n; i >= 1; i--) {
    hs2[ptr] = sum(hs2[ptr - 1], mult(s[i], p_pow[ptr]));
    ptr++;
  }
  ll ans = 0;
  set<pair<int, int>> st;
  for (int i = 1; i <= n; i++) {
    int l = 0, r = min(i, n - i) + 1;
    while (r - l > 1) {
      int mid = (l + r) / 2;
      if (get_hash(i - mid + 1, i + mid) == get_rev_hash(i - mid + 1, i + mid)) {
        l = mid;
      }
      else {
        r = mid;
      }
    }
    max_pal[i] = l;
    st.insert({i + 1 - 2 * max_pal[i], i});
  }
  for (int i = 1; i <= n; i++) {
    update(i, 1);
  }
  for (int i = n; i >= 1; i--) {
    while (!st.empty() && i < (--st.end())->F) {
      update((--st.end())->S, -1);
      st.erase(--st.end());
    }
    ans += get_sum(i + 1, i + 2 * max_pal[i - 1] - 1);
  }
  st = {};
  for (int i = 0; i < 2; i++) {
    for (int j = 1; j <= sz; j++) {
      t[i][j] = 0;
    }
  }
  for (int i = 1; i <= n; i++) {
    update(i, 1);
    /*max_pal[i] = 1;
    while (i - max_pal[i] >= 1 && i + max_pal[i] <= n && s[i - max_pal[i]] == s[i + max_pal[i]]) {
      max_pal[i]++;
    }*/
    int l = 1, r = min(i, n - i + 1) + 1;
    while (r - l > 1) {
      int mid = (l + r) / 2;
      if (get_hash(i - mid + 1, i + mid - 1) == get_rev_hash(i - mid + 1, i + mid - 1)) {
        l = mid;
      }
      else {
        r = mid;
      }
    }
    max_pal[i] = l;
    st.insert({i + 1 - 2 * max_pal[i], i});
  }
  for (int i = n; i >= 1; i--) {
    while (!st.empty() && i < (--st.end())->F) {
      update((--st.end())->S, -1);
      st.erase(--st.end());
    }
    ans += get_sum(i + 1, i + 2 * max_pal[i] - 1);
  }
  cout << ans << '\n';
}