#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 7, base = 27;

const int MAX_N = 5e5 + 10;
ll k[MAX_N], m[MAX_N];
int n;
string in;

ll fast() {
    for(int i = 0; i < n; i ++) {
        k[i] = m[i] = 0;
        while(true) {
            if(i >= k[i] && i + k[i] < n && in[i - k[i]] == in[i + k[i]]) {k[i] ++;} else {break;}
        }
        while(true) {
            if(i >= m[i] && i + m[i] + 1 < n && in[i - m[i]] == in[i + m[i] + 1]) {m[i] ++;} else {break;}
        }
        m[i] ++;
    }
    ll ans = 0;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((i - j + 1) & 1) {continue;}
            //cout << i << " " << j << " " << k[i] << " " << k[j] << endl;
            if(k[i] * 2 >= (j - i + 1) && k[j] * 2 >= (j - i + 1)) {
                ans ++;
                //cout << i << " " << j << " " << k[i] << " " << k[j] << endl;
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((i - j + 2) & 1) {continue;}
            if(m[i] * 2 >= (j - i + 2) && m[j] * 2 >= (j - i + 2)) {
                ans ++;
                //cout << i << "! " << j << endl;
            }
        }
    }
    return ans;
}

bool palin(int l, int r) {
    if((r - l + 1) & 1) {
        int m = (l + r) / 2;
        int sz = 0;
        while(m + sz <= r && in[m + sz] == in[m - sz]) {sz ++;}
        return m + sz > r;
    } else {
        int m = (l + r) / 2;
        int sz = 0;
        while(m + sz + 1 <= r && in[m + sz + 1] == in[m - sz]) {sz ++;}
        return m + sz + 1 > r;
    }
}

ll slow() {
    ll ans = 0;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((j - i + 1) & 1) {continue;}
            int m = (i + j) / 2;
            if(palin(i, m) && palin(m + 1, j)) {ans ++;}
        }
    }
    return ans;
}

void verify() {
    for(n = 1; n < 50; n ++) {
        for(int i = 0; i < 1000; i ++) {
            in.resize(n);
            for(int i = 0; i < n; i ++) {
                in[i] = 'a' + (rand() % 2);
            }
            if(slow() != fast()) {
                cout << n << " " << in << endl;
                cout << slow() << " " << fast() << endl;
                return;
            }
        }
    }
}

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n >> in;
    cout << fast() << endl;
}
