#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)

const int N = 5001;
bool pal[N][N];
bool ans[N][N];
void run() {
  int n;
  cin >> n;
  string s;
  cin >> s;
  for(int i = 0; i < n; i++) {
    pal[i][i] = 1;
  }
  for(int i = 0; i + 1 < n; i++) {
    pal[i][i + 1] = (s[i] == s[i + 1]);
  }
  for(int i = n - 1; i >= 0; i--) {
    for(int j = i + 1; j < n; j++) {
      if (s[i] == s[j]) {
        pal[i][j] |= (pal[i + 1][j - 1]);
      }
    }
  }
  int res = 0;
  for(int i = 0; i <= n; i++) {
    for(int j = 0; j + i * 2 + 1 < n; j++) {
      res += (pal[j][j + i] && pal[j + i + 1][j + i + 1 + i]);
    }
  }
  cout << res;
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
// gene();

  run();
}
