#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
#define cerr if (false) cerr
int n;
string s, t;
const int MAXN = 5e5 + 7;
const int BASE = 997;
const int MOD = 1791791791;
int h[MAXN], bases[MAXN];
int h1[MAXN];
int d[MAXN];
int have[MAXN];
void build(){
	bases[0] = 1;
	for (int i = 0; i < n; i++){
		bases[i + 1] = (bases[i] * BASE) % MOD;
		h[i + 1] = (s[i] + (h[i] * BASE) % MOD) % MOD;
	}
	reverse(ALL(s));
	for (int i = 0; i < n; i++)
		h1[i + 1] =  ((h1[i] * BASE) % MOD + s[i]) % MOD;
	reverse(ALL(s));
}
int get_hash(int l, int r){
	return (h[r] + MOD - (h[l] * bases[r - l]) % MOD) % MOD;
}
int get_hash1(int l, int r){
	return (h1[r] + MOD - (h1[l] * bases[r - l]) % MOD) % MOD;
}
int solve(){
	if (!(cin >> n >> t))
		return 1;
	s = t;
	n = SZ(s);

	build();
	int ans = 0;
	for (int i = 0; i < n; i++){
		int l = 0, r = i + 1;
		while (r - l > 1){
			int m = (l + r) / 2;
			if (i < m){
				r = m;
				continue;
			}
			int l1 = i - m, r1 = i + m + 1;
			if (r1 > n){
				r = m;
				continue;
			}
			if (get_hash(l1, r1) == get_hash1(n - r1, n - l1))
				l = m;
			else
				r = m;
		}
		d[i] = 2 * l + 1;
	}
	// for (int i = 0; i < n; i++)
	// 	cerr << d[i] << " \n"[i + 1 == n];
	set<pair<int, int>> have1;
	for (int i = 0; i < n; i++){
		while (SZ(have1) && have1.begin()->first < i){
			have[have1.begin()->second]--;
			have1.erase(*have1.begin());
		}
		int tmp = 0;
		for (int j = max(0LL, i - d[i]); j <= i; j++){
			if ((i - j) % 2 == 0)
				continue;
			ans += have[j];
			tmp += have[j];
		}
		have[i]++;
		have1.insert({d[i] + i, i});
	}
	have1.clear();
	for (int i = 0; i < n; i++)
		have[i] = 0;
	for (int i = 0; i < n; i++){
		if (get_hash(i, i + 1) != get_hash1(n - (i + 1), n - i)){
			d[i] = 0;
			continue;
		}
		int l = 0, r = i + 2;
		while (r - l > 1){
			int m = (l + r) / 2;
			int l1 = i - m + 1, r1 = i + m + 1;
			cerr << i << ' ' << m << '\n';
			if (l1 < 0 || r1 > n){
				r = m;
				continue;
			}
			if (get_hash(l1, r1) == get_hash1(n - r1, n - l1))
				l = m;
			else
				r = m;
		}
		d[i] = l * 2;
	}
	for (int i = 0; i < n; i++)
		cerr << d[i] << " \n"[i + 1 == n];
	for (int i = 0; i < n; i++){
		while (SZ(have1) && have1.begin()->first < i){
			// cerr << '\t' << have1.begin()->first << ' ' << have1.begin()->second << ' ' << i << ' ' << SZ(have1) << '\n';
			have[have1.begin()->second]--;
			have1.erase(*have1.begin());
		}
		cerr << s[i] << ' ' << i << ' ' << d[i] << ' ' << SZ(have1) << '\n';
		int tmp = 0;
		for (int j = max(0LL, i - d[i]); j <= i; j++){
			if ((i - j) % 2 == 1)
				continue;
			ans += have[j];
			if (have[j])
				cerr << "!\t" << s[j] << ' ' << j << '\n';
			tmp += have[j];
		}
		cerr << tmp << '\n';
		cerr << '\t';
		for (auto [x, y] : have1)
			cerr << "{" << x << ", " << y << "} ";
		cerr << '\n';
		have[i]++;
		have1.insert({d[i] + i, i});
	}
	cout << ans << '\n';
	return 0;
}
signed main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}