#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAXN = 5e5;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> odd(n), even(n);
    for (int i = 0; i < n; i++) {
        int cur = 1;
        while (i - cur + 1 >= 0 && i + cur - 1 < n && s[i - cur + 1] == s[i + cur - 1]) {
            cur++;
        }
        odd[i] = cur * 2 - 2;
        cur = 0;
        while (i - cur >= 0 && i + cur + 1 < n && s[i - cur] == s[i + cur + 1]) {
            cur++;
        }
        even[i] = cur * 2;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((i - j) % 2 == 0) {
                int l = j - i;
                if (even[i] >= l && even[j] >= l) {
                    ans++;
                }
            } else {
                int l = (j - i);
                if (odd[i] >= l && odd[j] >= l) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}