#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int int64_t
#define pii pair<int, int>
#define double long double
#define S second
#define F first
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> orset;
// RRR() < exp(-(big - small) / t)

const int M = 1e9 + 7;
const int p = 137;

int n, ans;
int suff[5050];
string s;
vector<int> h1, h2;

int bin_pow(int a, int b){
    if(b == 0) return 1;
    if(b % 2){
        return (bin_pow(a, b-1) * a) % M;
    }else{
        int t = bin_pow(a, b / 2);
        return (t * t) % M;
    }
}

int get_hash1(int l, int r){
//    cout << l << " " << r << endl;
    int ret;
    if(l-1 < 0)
        ret = (h1[r] % M);
    else ret = (h1[r] - ((h1[l-1] * bin_pow(p, r - l + 1)) % M) + M) % M;
//    ret *= bin_pow(p, n - r);
    return ret % M;
}

int get_hash2(int ll, int rr){
//    cout << ll << " " << rr  << endl;
    int l = n - rr - 1;
    int r = n - ll - 1;
//    cout << l << " " << r;
//    cout << endl;
    int ret;
    if(l-1 < 0)
        ret = (h2[r] % M);
    else ret = (h2[r] - ((h2[l-1] * bin_pow(p, r - l + 1)) % M) + M) % M;
//    ret *= bin_pow(p, n - r);
    return ret % M;
}

bool palindrom(int l, int r){
    if(l < 0 || r >= n) return false;
    if(l == r) return true;
    int lng = (r-l+1) / 2 + (r-l+1) % 2;
//    cout << "lng = " << lng << endl;
    int hash1 = get_hash1(l, l+lng-1);
//    cout << "2l  " << l+lng - (r-l+1) % 2 << endl;
    int hash2 = get_hash2(l+lng - (r-l+1) % 2, r);
//    cout << l << " " << hash2 << endl;
//    cout << hash1 << " " << hash2 << endl;
    if(hash1 == hash2){
//        cout << "palindrom " << l << " " << r << endl;
    }
    return (hash1 == hash2);
}

int32_t main(){
    ios_base :: sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> s;
    h1.resize(n);
    h2.resize(n);
    for(int i = 0; i < n; i ++){
        if(i) h1[i] = (h1[i-1] * p + (s[i] - 'a' + 1)) % M;
        else h1[i] = s[i] - 'a' + 1;
    }
    reverse(s.begin(), s.end());
    for(int i = 0; i < n; i ++){
        if(i) h2[i] = (h2[i-1] * p + (s[i] - 'a' + 1)) % M;
        else h2[i] = s[i] - 'a' + 1;
    }
//    get_hash2(0, 2);
    reverse(s.begin(), s.end());
//    cout << palindrom(1, 3);
    for(int i = 0; i < n; i ++){
        for(int lng = 0; i + 2*lng+1 < n; lng ++){
//            cout << lng << endl;
            if(palindrom(i, i + lng)) ans += palindrom(i+lng+1, i+lng+1+lng);
        }
    }
    cout << ans;
}
