#include <bits/stdc++.h>
#define maxn 500005
#define pb push_back
#define mod 1000000007

using namespace std;
typedef long long ll;
const ll p = 101;

int n;
string x;

ll add(ll x, ll y){
    return (x + y) % mod;
}
ll mul(ll x, ll y){
    return (x * y) % mod;
}
ll power(ll x, ll y){
    if(y == 0)return 1;
    ll pola = power(x, y / 2);
    pola = mul(pola, pola);
    if(y % 2 == 1)pola = mul(pola, x);
    return pola;
}
ll hes[maxn][2];
ll inverz[maxn];
ll get(int l, int r, int idx){
    if(idx == 0){
        ll sta = hes[r][0] - hes[l - 1][0];
        sta %= mod;
        sta += mod;
        sta %= mod;
        sta = mul(sta, inverz[l - 1]);
        return sta;
    }
    else if(idx == 1){
        ll sta = hes[l][1] - hes[r + 1][1];
        sta %= mod;
        sta += mod;
        sta %= mod;
        sta = mul(sta, inverz[n - r]);
        return sta;
    }
    return 0;
}






vector<int> mgs[3 * maxn];
int niz[maxn];
int nep[maxn];
int par[maxn];
int resi(int node, int val){
    int l = 0;
    int r = mgs[node].size();
    while(l < r){
        int mid = (l + r + 1) / 2;
        if(mid == 0){
            l = mid;
            continue;
        }
        if(mgs[node][mid - 1] < val)l = mid;
        else r = mid - 1;
    }
    int vel = mgs[node].size();
    return vel - l;
}
void init(int node, int l, int r){
    if(l == r){
        mgs[node].pb(niz[l]);
        return;
    }
    int mid = (l + r) / 2;
    init(node * 2, l, mid);
    init(node * 2 + 1, mid + 1, r);
    int br1 = 0;
    int br2 = 0;
    int p1 = mgs[node * 2].size();
    int p2 = mgs[node * 2 + 1].size();
    while(br1 < p1 || br2 < p2){
        if(br1 == p1){
            mgs[node].pb(mgs[node * 2 + 1][br2]);
            br2++;
            continue;
        }
        if(br2 == p2){
            mgs[node].pb(mgs[node * 2][br1]);
            br1++;
            continue;
        }
        int prvi = mgs[node * 2][br1];
        int drugi = mgs[node * 2 + 1][br2];
        if(prvi < drugi){
            mgs[node].pb(prvi);
            br1++;
        }
        else{
            mgs[node].pb(drugi);
            br2++;
        }
    }
}
int query(int node, int l, int r, int levo, int desno, int val){
    if(l > desno || r < levo)return 0;
    if(l >= levo && r <= desno)return resi(node, val);
    int mid = (l + r) / 2;
    return query(node * 2, l, mid, levo, desno, val)
    + query(node * 2 + 1, mid + 1, r, levo, desno, val);

}
void ocisti(){
    for(int i=0; i<=n; i++)mgs[i].clear();
}
int aa[maxn];
int bb[maxn];
int res;
bool moze[5005][5005];
/// brut
int brut(){
    for(int i=0; i<n; i++){
            moze[i][i] = 1;
            int br = 0;
            while(1){
                int dokle1 = i - br;
                int dokle2 = i + br;
                if(dokle1 < 0 || dokle2 >= n)break;
                if(x[dokle1] == x[dokle2]){
                    moze[dokle1][dokle2] = 1;
                    br++;
                }
                else break;
            }
            if(i != n && x[i] == x[i + 1]){
                br = 0;
                while(1){
                    int dokle1 = i - br;
                    int dokle2 = i + 1 + br;
                    if(dokle1 < 0 || dokle2 >= n)break;
                    if(x[dokle1] == x[dokle2]){
                        moze[dokle1][dokle2] = 1;
                        br++;
                    }
                    else break;
                }

            }
        }
        int res = 0;
        for(int i=0; i<n; i++){
            for(int j=i+1; j<n; j+=2){
                int mid = (i + j) / 2;
                if(moze[i][mid] && moze[mid + 1][j])res++;
            }
        }
        return res;
}

///
int main()
{
    //ios_base::sync_with_stdio(false);
    cin >> n >> x;
    if(n == 1){
        cout << 0 << endl;
        return 0;
    }
    if(n == 2){
        cout << 1 << endl;
        return 0;
    }
    inverz[500001] = power(power(p,500001), mod - 2);
    //cout << power(p,500001) << endl;
    //return 0;
    for(int i=500000; i>=0; i--)inverz[i] = mul(inverz[i + 1], p);
    ll tr = 0;
    ll st = 1;
    for(int i=0; i<n; i++){
        hes[i + 1][0] = add(hes[i][0], mul(st, (x[i] - 'a' + 1)));
        st = mul(st, p);
    }
    tr = 0;
    st = 1;
    for(int i=n-1; i>=0; i--){
        hes[i + 1][1] = add(hes[i + 2][1], mul(st, (x[i] - 'a' + 1)));
        st = mul(st, p);
    }

    for(int i=1; i<=n; i++){
        ///NEPARNE
        int l = 0;
        int r = n;
        while(l < r){
            int mid = (l + r + 1) / 2;
            int levi = i - mid;
            int desni = i + mid;
            if(levi <= 0 || desni > n){
                r = mid - 1;
                continue;
            }
            if(mid == 0){
                l = mid;
                continue;
            }
            ll prvi = get(i+1, i+mid, 0);
            ll drugi = get(i-mid, i-1, 1);
            if(prvi == drugi){
                l = mid;
            }
            else r = mid - 1;
        }
        nep[i] = l;
    }

    for(int i=1; i<=n - 1; i++){
        /// PARNE
        if(x[i - 1] != x[i])continue;
        int l = 0;
        int r = n;
        while(l < r){
            int mid = (l + r + 1) / 2;
            int levi = i - mid;
            int desni = i + mid + 1;
            if(levi <= 0 || desni > n){
                r = mid - 1;
                continue;
            }
            if(mid == 0){
                l = mid;
                continue;
            }
            ll prvi = get(i+2, i+mid+1, 0);
            ll drugi = get(i-mid, i-1, 1);
            if(prvi == drugi){
                l = mid;
            }
            else r = mid - 1;
        }
        par[i] = (l+1);
    }

    int aabr = 1;
    int bbbr = 1;
    for(int i=1; i<=n; i++){
        if(i%2 == 1){
            aa[aabr++] = nep[i];
        }
        else{
            bb[bbbr++] = nep[i];
        }
    }
    aabr--;
    bbbr--;
    for(int i=1; i<=aabr; i++){
        aa[i] = aa[i] - i;
    }
    for(int i=1; i<=bbbr; i++){
        bb[i] = bb[i] - i;
    }
    for(int i=1; i<=bbbr; i++)niz[i] = bb[i];
    init(1,1,bbbr);
    for(int i=1; i<=aabr; i++){
        int dokle = (nep[2*i - 1] + 1) / 2;

        //dokle /= 2;
        dokle = min(i + dokle, bbbr);
        res += query(1,1,bbbr,i,dokle, -i-1);
    }
    for(int i=1; i<=aabr; i++)niz[i] = aa[i];
    ocisti();
    init(1,1,aabr);
    for(int i=1; i<=bbbr; i++){
        int dokle = (2*i) + nep[2 * i]+1;
        if(dokle%2 == 0)dokle++;
        dokle = dokle / 2 + 1;
        dokle = min(dokle, aabr);
        res += query(1,1,aabr,i+1,dokle, -i-1);
    }
    //cout << res << endl;
    //return 0;


    int br = 1;
    for(int i=1; i<=n-1; i++){
        if(i%2 == 1)niz[br++] = par[i];
    }
    br--;
    for(int i=1; i<=br; i++)niz[i] = niz[i] - i;
    ocisti();
    init(1,1,br);
    for(int i=1; i<=br-1; i++){
        int dokle = par[i*2 - 1];
        if(dokle == 0)continue;
        dokle /= 2;
        dokle++;
        if(dokle <= 0)continue;
        dokle = min(i + dokle, br);
        ll sta = query(1,1,br,i+1,dokle,-i);
        res += sta;
    }


    br = 1;
    for(int i=1; i<=n-1; i++){
        if(i%2 == 0)niz[br++] = par[i];
    }
    br--;
    for(int i=1; i<=br; i++)niz[i] = niz[i] - i;

    ocisti();
    init(1,1,br);

    for(int i=1; i<=br-1; i++){
        int dokle = par[i*2];
        if(dokle == 0)continue;
        dokle /= 2;
        dokle++;
        if(dokle <= 0)continue;
        int ddokle = min(i + dokle, br);
        ll sta = query(1,1,br,i+1,ddokle,-i);
        //cout << sta << endl;
        res += sta;
    }
    cout << res  <<  endl;
    return 0;
}
