#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <type_traits>
using namespace std;
typedef long long ll;
typedef long double ld;
template<class T>
using pt = pair<T, T>;
string s;

pt<int> nec(int i)
{
	int l = i, r = i;
	while (l >= 0 && r <= s.size() - 1)
	{
		if (s[l] == s[r])
		{
			l--;
			r++;
		}
		else
			break;
	}
	l++;
	r--;
	if (l == i+1 && r == i-1)
		return { -1,-1 };
	else
		return { l,r };
}

pt<int> chet(int i)
{
	int l = i, r = i + 1;
	while (l >= 0 && r <= s.size() - 1)
	{
		if (s[l] == s[r])
		{
			l--;
			r++;
		}
		else
			break;
	}
	l++;
	r--;
	if (l == i + 1 && r == i)
		return { -1,-1 };
	else
		return { l,r };
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	cin >> s;
	vector<vector<int>> tabl(n, vector<int>(n));
	pt<int> nul{ -1,-1 };
	for (int i = 0; i < s.size(); i++)
	{
		auto pr = nec(i);
		if (pr != nul)
		{
			tabl[pr.first][pr.second - pr.first]++;
		}
		tabl[i][0] = min(1,tabl[i][0] + 1);

	}
	for (int i = 0; i < s.size(); i++)
	{
		auto pr = chet(i);
		if (pr != nul)
			tabl[pr.first][pr.second - pr.first]++;
	}
	int sum = 0;
	for (int i = 0; i < tabl.size(); i++)
	{
		for (int j = 0; j < tabl.size(); j++)
		{
			if (tabl[i][j] > 0)
			{
				if (i + tabl[i][j] < tabl.size() && tabl[i + j][j] > 0)
					sum++;
			}
		}
	}
	cout << sum;
	return 0;
}