import sun.reflect.generics.tree.Tree;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

import static java.lang.Math.*;

public class D {
    static BufferedReader in;
    static StringTokenizer st;

    static class pr implements Comparable<pr> {
        int r, tp;

        pr(int x, int y) {
            r = x;
            tp = y;
        }

        @Override
        public int compareTo(pr o) {
            if (o.r < r) return 1;
            if (o.r > r) return -1;
            if (o.tp < tp) return 1;
            if (o.tp > tp) return -1;
            return 0;
        }
    }

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int n = nextInt();
        fn();
        String s = st.nextToken();
        int np[] = fk(s, n);
        int cp[] = fs(s, n);
        long ans = 0;
        TreeSet<pr> a = new TreeSet<>();
        int tr[] = new int[n];
        for (int i = 0; i < n; i++) {
            tr[i] = 1;
            a.add(new pr(i + np[i] * 2 - 1, i));
            for (int j = max(0, i - 2 * np[i] + 1); j < i; j += 2) {
                ans += tr[j];
            }
            while (!a.isEmpty() && a.first().r <= i) {
                tr[a.first().tp] = 0;
                a.remove(a.first());
            }
        }
        for (int i = 0; i < n - 1; i++) {
            for (int j = i + 2; j < n - 1; j += 2) {
                if (cp[i] < (j - i) / 2) break;
                if (cp[j] >= (j - i) / 2) ans++;
            }
        }
        System.out.println(ans);
    }

    private static int[] fs(String s, int n) {
        int pp[] = new int[n - 1];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n - 1; i++) {
            if (i < r) {
                pp[i] = min(pp[2 * tp - i], r - i);
            }
            while (i - pp[i] >= 0 && i + pp[i] + 1 < n) {
                if (s.charAt(i - pp[i]) == s.charAt(i + pp[i] + 1)) pp[i]++;
                else break;
            }
            if (pp[i] + i > r) {
                r = pp[i] + i;
                tp = i;
            }
        }
        return pp;
    }

    private static int[] fk(String s, int n) {
        int np[] = new int[n];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n; i++) {
            np[i] = 1;
            if (i <= r) {
                np[i] = min(np[2 * tp - i], r - i + 1);
            }
            while (i - np[i] >= 0 && i + np[i] < n) {
                if (s.charAt(i - np[i]) == s.charAt(i + np[i])) np[i]++;
                else break;
            }
            if (np[i] + i - 1 > r) {
                r = np[i] + i - 1;
                tp = i;
            }
        }
        return np;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
