#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 7, base = 27;

void fix(ll &x) {
    if(x >= mod || x <= -mod) {x %= mod;}
    if(x < 0) {x += mod;}
}

const int MAX_N = 5e5 + 10;
ll pref1[MAX_N], pref2[MAX_N];
ll pw[MAX_N];
int n;
string in;

ll query1(int l, int r) {ll ans = pref1[r]; if(l > 0) {ans -= pref1[l - 1];} fix(ans); return ans;}
ll query2(int l, int r) {ll ans = pref2[r]; if(l > 0) {ans -= pref2[l - 1];} fix(ans); return ans;}

bool palin(int l, int r) {
    ll hash1 = query1(l, r) * pw[n - 1 - r]; fix(hash1);
    ll hash2 = query2(l, r) * pw[l]; fix(hash2);
    return hash1 == hash2;
}

ll slow() {
    ll ans = 0;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((j - i + 1) & 1) {continue;}
            int m = (i + j) / 2;
            if(palin(i, m) && palin(m + 1, j)) {ans ++;}
        }
    }
    return ans;
}

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n >> in;
    pw[0] = 1;
    for(int i = 1; i < MAX_N; i ++) {
        pw[i] = pw[i - 1] * base;
        fix(pw[i]);
    }
    pref1[0] = in[0] - 'a';
    pref2[0] = pw[n - 1] * (in[0] - 'a'); fix(pref2[0]);
    for(int i = 1; i < n; i ++) {
        pref1[i] = pref1[i - 1] + (pw[i] * (in[i] - 'a')); fix(pref1[i]);
        pref2[i] = pref2[i - 1] + (pw[n - 1 - i] * (in[i] - 'a')); fix(pref2[i]);
    }
    cout << slow();
    return 0;
}
