#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb emplace_back
#define ff first
#define ss second
#define pii pair<int, int>
#define ld long double
#define mp make_pair
#define all(x) x.begin(), x.end()
#define uniq(x) sort(all(x)), x.resize(unique(all(x)) - x.begin())

const int maxn = 1e6 + 9;
int dp[maxn];
int n;
int f[maxn];

void add(int i, int x)
{
    for (; i < maxn; i = (i | (i + 1)))
        f[i] += x;
}

int get(int i)
{
    int ans = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1)
        ans += f[i];
    return ans;
}

int solve1(string& s)
{
    int l = 0, m = 0, r = 0;
    for (int i = 0; i < n; i++)
    {
        if (i <= r)
            dp[i] = min(dp[m - (i - m)], r - i + 1);
        else
            dp[i] = 1;
        while (i + dp[i] < n && i - dp[i] >= 0
               && s[i - dp[i]] == s[i + dp[i]])
            dp[i]++;
        if (i + dp[i] - 1 > r)
        {
            r = i + dp[i] - 1;
            l = i - dp[i] + 1;
            m = i;
        }
//        cout << i << ": " << dp[i] << "\n";
    }
    priority_queue<pii> q;
    int ans = 0;
    for (int j = 1; j <= 4; j++)
    {
        int ans1 = 0;
        for (int i = n - j; i >= 1; i -= 4)
        {
            int e;
            if (j == 1 || j == 3)
                e = i + 4;
            else
                e = i + 2;
            if (e < n - 1)
            {
                add(e - dp[e] + 2, 1);
                q.emplace(e - 2 * dp[e], e - dp[e] + 2);
            }
            while (!q.empty() && q.top().ff == i)
            {
                e = q.top().ss;
                add(e, -1);
                q.pop();
            }
            ans1 += get(i + dp[i]);
        }
        for (int i = 0; i < maxn; i++)
            f[i] = 0;
        while (!q.empty())
            q.pop();
//        cout << ans1 << "\n";
        ans += ans1;
    }
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    string ss;
    cin >> n >> ss;
    string s = "#";
    for (int i = 0; i < n; i++)
    {
        s += ss[i];
        s += "#";
    }
//    cout << s << "\n";
    n = s.size();
    cout << solve1(s);
}
