#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>

//#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

const int MOD = 1e9 + 7;
const int P = 27;

veci pw, a, b;
int n;

bool check(int l, int r) {
	if (l >= n - r - 1) {
		int p1 = (a[r] - (l > 0 ? a[l - 1] : 0) + MOD) % MOD;
		int p2 = (((b[l] - (r < n - 1 ? b[r + 1] : 0)) * (ll)pw[l - (n - r - 1)]) % MOD + MOD) % MOD;
		return p1 == p2;
	}
	int p1 = (((a[r] - (l > 0 ? a[l - 1] : 0))* (ll)pw[n - r - 1 - l]) % MOD + MOD) % MOD;
	int p2 = ((b[l] - (r < n - 1 ? b[r + 1] : 0)) + MOD) % MOD;
	return p1 == p2;

}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	string str;
	cin >> str;

	pw.assign(n, 0);
	a.assign(n, 0);
	b.assign(n, 0);
	pw[0] = 1;
	for (int i = 1; i < n; i++)
		pw[i] = ((ll)pw[i - 1] * P) % MOD;

	a[0] = str[0] - 'a';
	b[n - 1] = str[n - 1] - 'a';

	for (int i = 1; i < n; i++)
		a[i] = ((ll)a[i - 1] + ((str[i] - 'a') * (ll)pw[i]) % MOD) % MOD;

	for (int i = n - 2; i >= 0; i--)
		b[i] = ((ll)b[i + 1] + ((str[i] - 'a') * (ll)pw[n - i - 1]) % MOD) % MOD;

	int cnt = 0;
	for (int i = 4; i <= n; i += 2) {
		for (int j = 0; j <= n - i; j++)
			if (check(j, j + i / 2 - 1) && check(j + i / 2, j + i - 1))
				cnt++;
	}
	cout << n - 1 + cnt << "\n";

	return 0;
}
