#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <type_traits>
using namespace std;
typedef long long ll;
typedef long double ld;
template<class T>
using pt = pair<T, T>;
string s;
vector<vector<int>> tabl;

void nec(int i)
{
	int l = i, r = i;
	//tabl[i][0]++;
	while (l >= 0 && r <= s.size() - 1)
	{
		if (s[l] == s[r] && r - l >= 0)
		{
			tabl[l][r - l]++;
			l--;
			r++;
		}
		else
			break;
	}
}

void chet(int i)
{
	int l = i, r = i + 1;
	while (l >= 0 && r <= s.size() - 1)
	{
		if (s[l] == s[r] && r - l >= 0)
		{
			tabl[l][r - l]++;
			l--;
			r++;
		}
		else
			break;
	}
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	cin >> s;
	tabl.resize(n+1, vector<int>(n+1));
	pt<int> nul{ -1,-1 };
	for (int i = 0; i < s.size(); i++)
	{
		nec(i);
	}
	for (int i = 0; i < s.size(); i++)
	{
		chet(i);
	}
	int sum = 0;
	for (int i = 0; i < tabl.size(); i++)
	{
		for (int j = 0; j < tabl.size(); j++)
		{
			if (tabl[i][j] > 0)
			{
				if (i + j + 1 < tabl.size() && tabl[i + j + 1][j] > 0)
					sum++;
			}
		}
	}
	cout << sum;
	return 0;
}