#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(x) (x).begin() , (x).end()
const ll P = 179 , mod = 1e9 + 7;
vector <ll> deg , h1 , h2;
ll get1(ll l , ll r) {
    ll ans = h1[r] - h1[l] * deg[r - l] % mod;
    if(ans < 0) {
        ans += mod;
    }
    return ans;
}
ll get2(ll l , ll r) {
    ll ans = h2[r] - h2[l] * deg[r - l] % mod;
    if(ans < 0) {
        ans += mod;
    }
    return ans;
}
void solve() {
    ll n;
    cin >> n;
    deg.resize(n + 1 , 1) , h1.resize(n + 1) , h2.resize(n + 1);
    string s , p;
    cin >> s;
    p = s;
    reverse(all(p));
    for(int i = 0; i < n; i++) {
        h1[i + 1] = (h1[i] * P + s[i] - 'a' + 1) % mod;
        h2[i + 1] = (h2[i] * P + p[i] - 'a' + 1) % mod;
        deg[i + 1] = deg[i] * P % mod;
    }
    ll ans = 0;
    for(int i = 0; i < n; i++) {
        for(int k = 1; i - 1 + 2 * k < n; k++) {
            if(get1(i , i + k) == get2(n - i - k , n - i) && get1(i + k , i + 2 * k) == get2(n - i - 2 * k , n - i - k)) {
                ans++;
            }
        }
    }
    cout << ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}