#include <bits/stdc++.h>
using namespace std;
int n;
string s;
const long long mod = 1000000007, b = 6661;
long long step [1000006], hsh [1000006][20], hsh_rev [1000006][20];
int len [1000006], len_center [1000006];
vector <pair <int, int> > updates [1000006];
int BIT [1000006][2];
void upd (int x, int k){
    x = 1000000 - x;
    while (x < 1000005){
        BIT [x][k] ++;
        x += x & -x;
    }
}
long long query (int x, int k){
    x = 1000000 - x;
    long long ans = 0;
    while (x > 0){
        ans += BIT [x][k];
        x -= x & -x;
    }
    return ans;
}
long long ans = 0;
int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);
    cout.tie (0);

    step [0] = 1;
    for (int i = 1; i < 1000005; i ++) step [i] = step [i - 1] * b % mod;
    cin >> n >> s;
    for (int i = 0; i < n; i ++){
        hsh [i][0] = s [i] - 'a' + 1;
        hsh_rev [i][0] = hsh [i][0];
    }
    int br = 0;
    for (int k = 1; k < 20; k ++){
        for (int i = 0; i <= n - (1 << k); i ++){
            hsh [i][k] = (hsh [i][k - 1] * step [1 << k - 1] + hsh [i + (1 << k - 1)][k - 1]) % mod;
        }
        for (int i = max (0, n - (1 << k) + 1); i < n; i ++) hsh [i][k] = --br;
        for (int i = (1 << k) - 1; i < n; i ++){
            hsh_rev [i][k] = (hsh_rev [i][k - 1] * step [1 << k - 1] + hsh_rev [i - (1 << k - 1)][k - 1]) % mod;
        }
        for (int i = 0; i < (1 << k) - 1; i ++) hsh_rev [i][k] = --br;
    }

    for (int i = 1; i < n; i ++){
        int x = 0;
        while (x < 20 && hsh [i][x] == hsh_rev [i - 1][x]) x ++;
        x --;
        len [i] = 1 << x;
        if (x == -1) len [i] = 0;
        if (x == -1 || (1 << x) == i || i + (1 << x) == n) continue;
        int j = (1 << x);
        while (x >= 0 && j < i && i + j < n){
            if (hsh [i + j][x] == hsh_rev [i - 1 - j][x]) j += (1 << x);
            else x --;
        }
        len [i] = j;
    }
    for (int i = 1; i < n - 1; i ++){
        int x = 0;
        while (x < 20 && hsh [i + 1][x] == hsh_rev [i - 1][x]) x ++;
        x --;
        len_center [i] = 1 << x;
        if (x == -1) len_center [i] = 0;
        if (x == -1 || (1 << x) == i || i + 1 + (1 << x) == n) continue;
        int j = (1 << x);
        while (x >= 0 && j < i && i + j + 1 < n){
            if (hsh [i + 1 + j][x] == hsh_rev [i - 1 - j][x]) j += (1 << x);
            else x --;
        }
        len_center [i] = j;
    }
/*
    for (int i = n - 1; i >= 0; i --) updates [i + 2 * len [i]].push_back ({i % 2, i + len [i]});
    for (int i = n; i < 1000005; i ++){
        for (auto j : updates [i]) upd (j.second, j.first);
        updates [i].clear ();
    }
    for (int i = n - 1; i >= 0; i --){
        for (auto j : updates [i]) upd (j.second, j.first);
        updates [i].clear ();
        ans += query (i - len [i], i % 2) - (n - i + 1) / 2;
        cout << ans << '\n';
    }
    for (int i = 0; i < 1000006; i ++) BIT [i][0] = BIT [i][1] = 0;

    for (int i = n - 1; i >= 0; i --) updates [i + 2 * len_center [i] + 1].push_back ({i % 2, i + len_center [i] + 1});
    for (int i = n; i < 1000005; i ++){
        for (auto j : updates [i]) upd (j.second, j.first);
        updates [i].clear ();
    }
    for (int i = n - 1; i >= 0; i --){
        for (auto j : updates [i]) upd (j.second, j.first);
        updates [i].clear ();
        ans += query (i - len_center [i], i % 2 ^ 1) - (n - i) / 2;
    }
*/

    for (int i = 0; i < n; i ++){
        for (int j = i + 2; j < n; j += 2){
            if (j - 2 * len [j] <= i && i + 2 * len [i] >= j && i + len [i] >= j - len [j]) ans ++;
        }
    }
    for (int i = 0; i < n; i ++){
        for (int j = i + 1; j < n; j += 2){
            if (j - 2 * len_center [j] <= i + 1 && i + 2 * len_center [i] >= j - 1 && i + len_center [i] + 1 >= j - len_center [j]) ans ++;
        }
    }

    cout << ans << '\n';
}
