#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>

using namespace std;
const int max_n = 5e5 + 1;
int n;
string s;
int len1[max_n], len2[max_n];

int has[max_n], rev_hash[max_n], st[max_n];
int p = 37, mod = 1e9 + 7;

bool check(int l1, int r1, int l2, int r2) {
    int num1 = has[r1];
    if (l1 != 0) num1 = (num1 - has[l1 - 1] * st[r1 - l1 + 1] % mod + mod) % mod;

    int num2 = rev_hash[l2];
    if (r2 != n - 1) num2 = (num2 - rev_hash[r2 + 1] * st[r2 - l2 + 1] % mod + mod) % mod;

    return num1 == num2;
}

void scan() {
    st[0] = 1;
    for(int i  = 1;i < max_n;i++) st[i] = (st[i - 1] * p) % mod;

    cin >> n >> s;

    for(int i = 0;i < n;i++) {
        has[i] = s[i] - 'a';
        if (i != 0) has[i] = (has[i] + has[i - 1] * p) % mod;
    }

    for(int i = n - 1;i >= 0;i--) {
        rev_hash[i] = s[i] - 'a';
        if (i != n - 1) rev_hash[i] = (rev_hash[i] + rev_hash[i + 1] * p) % mod;
    }

    //cout << check(0, 0, 2, 2) << '\n';
    //for(int i = 0;i < n;i++) cout << has[i] << " ";
    //cout << '\n';
    //for(int i = 0;i < n;i++) cout << rev_hash[i] << " ";
    //cout << '\n';

    for(int i = 0;i < n;i++) {
        int l = 0;
        int r = n + 1;
        while(r - l > 1) {
            int mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid - 1 >= n || !check(i - mid, i - 1, i, i + mid - 1)) {
                r = mid;
            }else l = mid;
        }
        len1[i] = l;

        l = 0;
        r = n + 1;
        while(r - l > 1) {
            int mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid >= n || !check(i - mid, i - 1, i + 1, i + mid)) {
                r = mid;
            }else l = mid;
        }

        len2[i] = l;
    }
}

void solve() {
    scan();

    int ans = 0;
    for(int i = 0;i < n;i++) {
        for(int j = i + 1;j < n;j++) {
            if ((j - i) % 2 == 0 && (j - i) / 2 <= min(len1[i], len1[j])) ans++;
            if ((j - i) % 2 == 1 && (j - i) / 2 <= min(len2[i], len2[j])) ans++;
        }
    }
    cout << ans;
}




signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    solve();
}