import sun.reflect.generics.tree.Tree;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

import static java.lang.Math.*;

public class D {
    static BufferedReader in;
    static StringTokenizer st;

    static class pr implements Comparable<pr> {
        int r, tp;

        pr(int x, int y) {
            r = x;
            tp = y;
        }

        @Override
        public int compareTo(pr o) {
            if (o.r < r) return 1;
            if (o.r > r) return -1;
            if (o.tp < tp) return 1;
            if (o.tp > tp) return -1;
            return 0;
        }
    }

    static class fact {
        int tr[];
        TreeSet<pr> a;
        int n;

        fact(int x) {
            n = x;
            tr = new int[n * 4];
            a = new TreeSet<>();
        }

        void add(int x, int l, int r, int v, int to) {
            if (to >= l && to < r) tr[v] += x;
            else return;
            if (l + 1 == r) return;
            int m = (l + r) >> 1;
            add(x, l, m, v * 2, to);
            add(x, m, r, v * 2 + 1, to);
        }

        int sum(int x, int y, int l, int r, int v) {
            if (x >= r || y <= l) return 0;
            if (l >= x && r <= y) return tr[v];
            int m = (l + r) >> 1;
            return sum(x, y, l, m, v * 2) + sum(x, y, m, r, v * 2 + 1);
        }
    }

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int n = nextInt();
        fn();
        String s = st.nextToken();
        int np[] = fk(s, n);
        int cp[] = fs(s, n);
        long ans = 0;
        fact c = new fact(n);
        fact nc = new fact(n);
        for (int i = 0; i < n; i++) {
            if (i % 2 == 0) {
                c.add(1, 0, n, 1, i);
                c.a.add(new pr(i + np[i] * 2 - 1, i));
                int l = max(1, i - 2 * np[i] + 1);
                ans += nc.sum(l, i, 0, n, 1);
                while (!nc.a.isEmpty() && nc.a.first().r <= i) {
                    nc.add(-1, 0, n, 1, nc.a.first().tp);
                    nc.a.remove(nc.a.first());
                }
            } else {
                nc.add(1, 0, n, 1, i);
                nc.a.add(new pr(i + np[i] * 2 - 1, i));
                int l = max(0, i - 2 * np[i] + 1);
                ans += c.sum(l, i, 0, n, 1);
                while (!c.a.isEmpty() && c.a.first().r <= i) {
                    c.add(-1, 0, n, 1, c.a.first().tp);
                    c.a.remove(c.a.first());
                }
            }
        }
        c = new fact(n);
        nc = new fact(n);
        for (int i = 0; i < n - 1; i++) {
            if (i % 2 == 0) {
                c.add(1, 0, n, 1, i);
                c.a.add(new pr(i + 2 * cp[i], i));
                int l = max(0, i - 2 * cp[i]);
                ans += c.sum(l, i, 0, n, 1);
                while (!c.a.isEmpty() && c.a.first().r <= i) {
                    c.add(-1, 0, n, 1, c.a.first().tp);
                    c.a.remove(c.a.first());
                }
            } else {
                nc.add(1, 0, n, 1, i);
                nc.a.add(new pr(i + 2 * cp[i], i));
                int l = max(1, i - 2 * cp[i]);
                ans += nc.sum(l, i, 0, n, 1);
                while (!nc.a.isEmpty() && nc.a.first().r <= i) {
                    nc.add(-1, 0, n, 1, nc.a.first().tp);
                    nc.a.remove(nc.a.first());
                }
            }
        }
        System.out.println(ans);
    }

    private static int[] fs(String s, int n) {
        int pp[] = new int[n - 1];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n - 1; i++) {
            if (i < r) {
                pp[i] = min(pp[2 * tp - i], r - i);
            }
            while (i - pp[i] >= 0 && i + pp[i] + 1 < n) {
                if (s.charAt(i - pp[i]) == s.charAt(i + pp[i] + 1)) pp[i]++;
                else break;
            }
            if (pp[i] + i > r) {
                r = pp[i] + i;
                tp = i;
            }
        }
        return pp;
    }

    private static int[] fk(String s, int n) {
        int np[] = new int[n];
        int r = 0;
        int tp = 0;
        for (int i = 0; i < n; i++) {
            np[i] = 1;
            if (i <= r) {
                np[i] = min(np[2 * tp - i], r - i + 1);
            }
            while (i - np[i] >= 0 && i + np[i] < n) {
                if (s.charAt(i - np[i]) == s.charAt(i + np[i])) np[i]++;
                else break;
            }
            if (np[i] + i - 1 > r) {
                r = np[i] + i - 1;
                tp = i;
            }
        }
        return np;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
