#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <unordered_set>
#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;
const int N = 1000001;
const ll mod = 111111113;
const ll pp = 31;
ll bp(ll x, ll st) {
	if (st == 0) return 1;
	if (st == 1) return x;
	ll xx = bp(x, st >> 1ll);
	xx *= xx;
	xx %= mod;
	return xx * bp(x, st & 1ll) % mod;
}
ll ps[N];

void seth(string str, vll &hs) {
	int n = str.size();
	for (int i = 0; i < n; ++i) hs[i + 1] = (hs[i] * pp + str[i] - 'a' + 1) % mod;

}
ll gt(int l, int r, vll &hs) {
	if (l > r) return 0;
	++r;
	return (((hs[r] - (hs[l] * ps[r - l])) % mod) + mod) % mod;
}
ll d1[N];
ll d2[N];
void solve() {
	int n; cin >> n;
	string str; cin >> str;
	vll h1(N); seth(str, h1);
	reverse(all(str));
	vll h2(N); seth(str, h2);
	reverse(all(str));
	for (int i = 0; i < n; ++i) {
		int l = 1; int r = min(n - i, i + 1) + 1;
		while (l + 1 < r) {
			int mid = l + r >> 1;
			if (gt(i - mid + 1, i + mid - 1, h1) == gt(n - i - 1 - mid + 1, n - i - 1 + mid - 1, h2)) l = mid;
			else r = mid;
		}
		d1[i] = l;
	}
	for (int i = 0; i < n - 1; ++i) {
		int l = 0; int r = min(n - i - 1, i + 1) + 1;
		while (l + 1 < r) {
			int mid = l + r >> 1;
			if (gt(i - mid + 1, i + mid, h1) == gt(n - i - 2 - mid + 1, n - i - 2 + mid, h2)) l = mid;
			else r = mid;
		}
		d2[i] = l;
	}
	ll cc = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; j += 2) {
			if (d1[i] >= (j - i + 1) / 2 && d1[j] >= (j - i + 1) / 2) ++cc;
		}
	}
	for (int i = 0; i < n - 1; ++i) {
		for (int j = i + 2; j < n - 1; j += 2) {
			if (d2[i] >= (j - i) / 2 && d2[j] >= (j - i) / 2) ++cc;
		}
	}
	cout << cc;
}
void pre_calc() {
	ps[0] = 1;
	for (int i = 1; i < N; ++i) {
		ps[i] = ps[i - 1] * pp % mod;
	}
}
bool check(int x) {
	for (int i = 2; i * i <= x; ++i) if (x % i) continue;
	else return false;
	return true;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	pre_calc();
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);


	solve();
	
}