#include <bits/stdc++.h>
#define int long long
#define double long double
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse2,sse3,ssse3")
using namespace std;

const int mod = 1e9 + 7;
const int base = 239;
int n;
string s;
int to[5000][5000];
int fro[5000][5000];

bool palin(int l, int r) {
    int k = (l + r) >> 1;
    if ((r - l + 1) % 2 == 0) {
        return to[l][k] == fro[k + 1][r];
    } else {
        return to[l][k] == fro[k][r];
    }
}

vector<int> z(string s) {
    int n = s.length();
    vector<int> kek(n);
    kek[0] = n;
    int l = 0;
    int r = 0;
    for (int i = 1; i < n; i++) {
        if (i <= r) {
            kek[i] = min(kek[i - l], r - i + 1);
        }
        while (i + kek[i] < n && s[kek[i]] == s[i + kek[i]]) {
            kek[i]++;
        }
        if (i > r) {
            l = i;
            r = i + kek[i] - 1;
        }
    }
    return kek;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> s;
    for (int i = 0; i < n; i++) {
        to[i][i] = s[i];
        for (int j = i + 1; j < n; j++) {
            to[i][j] = to[i][j - 1] * base + s[j];
            to[i][j] %= mod;
        }
    }
    for (int j = 0; j < n; j++) {
        fro[j][j] = s[j];
        for (int i = j - 1; i >= 0; i--) {
            fro[i][j] = fro[i + 1][j] * base + s[i];
            fro[i][j] %= mod;
        }
    }
    int ans = 0;
    for (int l = 0; l < n; l++) {
        for (int k = 1; l + 2 * k <= n; k++) {
            if (palin(l, l + k - 1) && palin(l + k, l + 2 * k - 1)) {
                ans++;
            }
        }
    }
    cout << ans << '\n';
    fflush(stdout);
    return 0;
}
