#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll p = 31;
ll mod = 1e9 + 7;
vector<ll> power;

void calcp(int n) {
    power.resize(n + 1);
    power[0] = 1;
    for (int i = 0; i < n; ++i) {
        power[i + 1] = power[i] * p % mod;
    }
}

void calc(string &s, int n, vector<ll> &hash) {
    for (int i = 0; i < n; ++i) {
        hash[i + 1] = hash[i] * p + (s[i] - 'a' + 1) % mod;
    }
}

ll get_hash(int l, int r, vector<ll> &hash) {
    return (hash[r + 1] - hash[l] * power[r - l + 1] % mod + mod) % mod;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    calcp(n);
    vector<ll> pref(n + 1), suf(n + 1);
    calc(s, n, pref);
    reverse(s.begin(), s.end());
    calc(s, n, suf);
    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 1; j <= min(i + 1, n - i - 1); ++j) {
            if (get_hash(i - j + 1, i, pref) ==
            get_hash(n - i - 1, n - (i - j + 1) - 1, suf) &&
            get_hash(i + 1, i + j, pref) == get_hash(n - (i + j) - 1, n - (i + 1) - 1, suf)) {
                ans++;
            }
        }
    }
    cout << ans << endl;
}