#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define ll long long
#define ld long double
#pragma warning(disable : 4996)
using namespace std;

const ll p = 73;
const ll mod = 1e9 + 7;
vector <ll> p_pow;
vector <ll> h;
vector <ll> hr;

ll get_hash(int l, int r, vector <ll> &v)
{
	ll ret = 0;
	int n = v.size();
	l != 0 ? ret = ((v[r] - v[l - 1] + mod) * p_pow[n - l]) % mod : ret = (v[r] * p_pow[n]) % mod;
	return ret;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	speed;
	int n;
	string s;
	cin >> n >> s;
	string sr = s;
	reverse(sr.begin(), sr.end());
	p_pow.resize(n + 1);
	h.resize(n);
	hr.resize(n);

	p_pow[0] = 1;

	for (int i = 1; i < p_pow.size(); i++)
		p_pow[i] = (p_pow[i - 1] * p) % mod;

	for (int i = 0; i < n; i++)
	{
		h[i] = (p_pow[i] * (s[i] - 'a')) % mod;
		if (i)
			h[i] = (h[i] + h[i - 1]) % mod;

		hr[i] = (p_pow[i] * (sr[i] - 'a')) % mod;
		if (i)
			hr[i] = (hr[i] + hr[i - 1]) % mod;
	}
	vector <pair <int, int>> d(n);
	for (int i = 0; i < n; i++)
	{
		int l = 0, r = min(i, n - i - 1) + 1;
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (get_hash(i - m, i + m , h) == get_hash(n - i - 1 - m , n - i - 1 + m, hr))
				l = m;
			else
				r = m;
		}
		d[i].first = l + 1;

		if (i < n - 1 && s[i] == s[i + 1])
		{
			l = 0, r = min(i, n - 1 - i - 1) + 1;
			while (r - l > 1)
			{
				int m = (l + r) / 2;
				if (get_hash(i - m, i + 1 + m, h) == get_hash(n - i - 1 - 1 - m, n - i - 1 + m, hr))
					l = m;
				else
					r = m;
			}
			d[i].second = l + 1;
		}

	}

	ll ans = 0;
	for (int i = 0; i < n - 1; i++)
		for (int j = i + 1; j < n; j++)
			if ((j - i + 1) & 1)
			{
				if (min(d[i].second, d[j].second) >= (j - i + 1) / 2)
					ans++;
			}
			else
				if (min(d[i].first, d[j].first) >= (j - i + 1) / 2)
					ans++;
	cout << ans;
	return 0;
}