#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const unsigned long long m = 239, m2 = 1'000'000'007, m3 = 517;
unsigned long long h1[5003], h2[5003], h11[5003], h22[5003], h111[5003], h222[5003];
unsigned long long p[5003], p2[5003], p3[5003];
int n;

unsigned long long get1(int l, int r) {
	return (h1[r] - h1[l - 1] * p[r - l + 1]);
}

unsigned long long get11(int l, int r) {
	return (h11[r] - h11[l - 1] * p2[r - l + 1]);
}

unsigned long long get111(int l, int r) {
	return (h111[r] - h111[l - 1] * p3[r - l + 1]);
}

unsigned long long get2(int l, int r) {
	l = n - l + 1;
	r = n - r + 1;
	swap(l, r);
	return (h2[r] - h2[l - 1] * p[r - l + 1]);
}

unsigned long long get22(int l, int r) {
	l = n - l + 1;
	r = n - r + 1;
	swap(l, r);
	return (h22[r] - h22[l - 1] * p2[r - l + 1]);
}

unsigned long long get222(int l, int r) {
	l = n - l + 1;
	r = n - r + 1;
	swap(l, r);
	return (h222[r] - h222[l - 1] * p3[r - l + 1]);
}

int main() {
	cin >> n;
	string s;
	cin >> s;
	h1[0] = 0;
	p[0] = 1;
	p2[0] = 1;
	p3[0] = 1;
	h11[0] = 0;
	h111[0] = 0;
	for (int i = 0; i < n; ++i) {
		h1[i + 1] = h1[i] * m + s[i];
		h11[i + 1] = h11[i] * m2 + s[i];
		h111[i + 1] = h111[i] * m3 + s[i];
		p[i + 1] = p[i] * m;
		p2[i + 1] = p2[i] * m2;
		p3[i + 1] = p3[i] * m3;
	}
	h2[0] = 0;
	h22[0] = 0;
	h222[0] = 0;
	for (int i = 0; i < n; ++i) {
		h2[i + 1] = h2[i] * m + s[n - i - 1];
		h22[i + 1] = h22[i] * m2 + s[n - i - 1];
		h222[i + 1] = h222[i] * m3 + s[n - i - 1];
	}

	long long sum = 0;
	for (int i = 1; i < n; ++i) {
		int l, r;
		l = i;
		r = i + 1;
		while (l > 0 && r <= n) {
			if (get1(l, i) == get2(l, i) && get1(i + 1, r) == get2(i + 1, r))
				if (get11(l, i) == get22(l, i) && get11(i + 1, r) == get22(i + 1, r))
					if (get111(l, i) == get222(l, i) && get111(i + 1, r) == get222(i + 1, r))
						++sum;
			//cerr << l << ' ' << r << '\n';
			--l;
			++r;
		}
	}
	cout << sum;
	return 0;
}
