#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

vector <int> getc(string s) {
	int n = s.size();
	vector <int> c(n);
	for (int i = 0; i < n; ++i) {
		while (i - c[i] >= 0 && i + c[i] < n && s[i - c[i]] == s[i + c[i]]) {
			++c[i];
		}
	}
	return c;
}

bool pal(string& s, int l, int r) {
	for (int i = l; i <= r; ++i) {
		if (s[i] != s[r - (i - l)]) return false;
	}
	return true;
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	int ans = 0;
	for (int len = 1; len <= n; ++len) {
		if (len % 2 == 1) continue;
		for (int i = 0; i + 2 * len - 1 < n; ++i) {
			if (pal(s, i, i + len - 1) && pal(s, i + len, i + 2 * len - 1)) {
				++ans;
			}
		}
	}
	auto c = getc(s);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (j > i&& j <= 2 * c[i] + i - 1 && 2 * c[j] - j - 1 >= -i && (j - i) % 2 == 1) {
				++ans;
				//cout << i << " " << j << "\n";
			}
		}
	}
	cout << ans << "\n";
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}