#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define fs first
#define sc second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

const int N = 1e6 + 1000;
int f[N];

void inc(int k, int add) {
    k++;
    for (; k < N; k+= k&-k)
        f[k] += add;
}

int sum(int k) {
    k++;
    int ret = 0;
    for (; k; k -= k& -k)
        ret += f[k];
    return ret;
}

int sum(int l, int r) {
    return sum(r) - sum(l - 1);
}

int ans = 0;

void go(vector<int> &a, vector<int> &b, int add) {
//    while(sz(a) < sz(b))
//        b.pop_back();
    int n = sz(a);
    int m = sz(b);
    set<pair<int, int>, greater<pair<int, int>>> s;
    for(int i = 0; i < n; i++)
        s.insert(MP(a[i], i));

    for (int i = 0; i < m; i++) {
        auto it = s.begin();
        while(it != s.end() && (*it).fs + i >= 0) {
            inc((*it).sc, 1);
            it = s.erase(it);
        }
        int ql = i;
        int qr = ql + b[i] - add;
        assert(sum(ql, qr) >= 0);
        ans += sum(ql, qr);
    }

    for (int i = 0; i < N; i++)
        f[i] = 0;
}


signed main() {
    fastio;
    #ifdef FlameDragon
        freopen("in.txt", "r", stdin);
    #endif // FlameDragon

    int n;
    cin >> n;
    string s;
    cin >> s;

    string ts;
    ts.pb('#');
    for (auto i:s) {
        ts.pb(i);
        ts.pb('#');
    }
    s = ts;
    int k = sz(s);
    vector<int> d(k);
    for (int i = 0, l = 0, r = 0; i < k; i++) {
        if (i <= r) {
            d[i] = min(r - i, d[l + r - i]);
        }
        while(i - d[i] >= 0 && i + d[i] < k && s[i - d[i]] == s[i + d[i]])
            d[i]++;
        if (i + d[i] - 1 > r)
                r = i + d[i] - 1, l = i - d[i] + 1;
    }
    for (auto &i:d)
        i/=2;
    vector<int> odd, even;
    for (int i = 1; i < k - 1; i++)
        if (i & 1)
            odd.pb(d[i] - 1);
        else even.pb(d[i]);


    vector<int> x, y;

    int uk = 0;
    for (int i = 1; i < sz(odd); i+=2) {
        x.pb(odd[i] - uk);
        uk++;
    }
    for (int i = 0; i < sz(odd); i += 2) {
        y.pb(odd[i]);
    }
    go(x, y, 0);
    x.clear();
    y.clear();


    uk = 0;
    for (int i = 2; i < sz(odd); i+=2) {
        x.pb(odd[i] - uk);
        uk++;
    }
    for (int i = 1; i < sz(odd); i += 2) {
        y.pb(odd[i]);
    }
    go(x, y, 0);
    x.clear();
    y.clear();


   //cout << ans << '\n';





    uk = 1;
    for (int i = 2; i < sz(even); i += 2) {
        x.pb(even[i] - uk);
        uk++;
    }
    for (int i = 0; i < sz(even); i += 2) {
        y.pb(even[i]);
    }
    go(x, y, 1);
    x.clear();
    y.clear();


    uk = 1;
    for (int i = 3; i < sz(even); i += 2) {
        x.pb(even[i] - uk);
        uk++;
    }
    for (int i = 1; i < sz(even); i += 2) {
        y.pb(even[i]);
    }
    go(x, y, 1);
    x.clear();
    y.clear();

    int rr = 0
;
    for (int i = 0; i < sz(odd); i++) {
        for (int j = 0; j <= odd[i] && i + 2 * j + 1 < sz(odd); j++)
            rr += odd[i + 2 * j + 1] >= j;
    }
    ////cout << rr << endl;
    for (int i = 0; i < sz(even); i++) {
        for (int j = 1; j <= even[i] && i + 2 * j < sz(even); j++)
            rr += even[i + 2 * j] >= j;
    }
//cout << rr << '\n';
    cout << ans << '\n';
}


