#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

void build_z1(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i - 1, z[left - (i - left)]), 0);
        while (i + z[i] < n && i - z[i] - 1 >= 0 && s[i - z[i] - 1] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

void build_z2(string &s, vector<int> &z){
    int n = s.size();
    int left = 0, right = 0;
    for (int i = 1; i < n; i++){
        z[i] = max(min(right - i, z[left - (i - left)]), 1);
        while (i + z[i] < n && i - z[i] >= 0 && s[i - z[i]] == s[i + z[i]])
            z[i]++;
        if (i + z[i] > right){
            left = i;
            right = i + z[i];
        }
    }
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    string s; cin >> s;

    vector<int> z1(n);
    vector<int> z2(n, 1);
    build_z1(s, z1);
    build_z2(s, z2);

    ll ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = 1; j <= z1[i]; j++)
            if (i + j * 2 < n && z1[i + j * 2] >= j)
                ans++;
        for (int j = 1; j <= z2[i]; j++)
            if (i + j * 2 - 1 < n && z2[i + j * 2 - 1] >= j)
                ans++;
    }
    cout << ans;
    return 0;
}