#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define FOR(i,n) for (int i=0;i<(n);++i)
#define FORT(i,a,b) for (int i=(a);i<=(b);++i)
#define FORD(i,n) for (int i=(n)-1;i>=0;--i)
#define FORTD(i,a,b) for (int i=(a);i>=(b);--i)
#define trav(to,v) for (auto to : v)
#define pir pair<int,int>
#define mpr make_pair
#define fr first
#define sc second
#define all(v) v.begin(),v.end()
#define fastio ios_base::sync_with_stdio(false);
#define srng mt19937 rng(65649841);
#define ad push_back

const int N=1e6+6;
const ll MOD=1e9+7;
const ll P=356747617;


ll pw[N];
struct hosh{
	ll h;
	int d,sz;
	hosh(){
		sz=h=d=0;
	}
	hosh(ll _h,int _d,int _sz){
		h=_h;
		d=_d;
		sz=_sz;
	}
	static void pre(){
		pw[0]=1;
		FORT(i,1,N-1){
			pw[i]=pw[i-1]*P;
			pw[i]%=MOD;
		}		
	};
	bool operator == (hosh other){
		if (other.sz!=sz)return false;
		if (other.d>d){
			return ((pw[other.d-d]*h)%MOD==other.h);
		}
		return ((pw[d-other.d]*other.h)%MOD==h);
	};
	void operator =(hosh other){
		h=other.h;
		d=other.d;
		sz=other.sz;
	}
	void operator += (char c){
		h+=(c-'a')*pw[sz];
		sz++;
		h%=MOD;
	}
	//hosh opertor +()
	hosh operator -(hosh other){
		hosh ans;
		ans.sz=sz-other.sz;
		ans.h=(h-other.h+MOD)%MOD;
		ans.d=other.d+other.sz;
		return ans;
	};
} pr[N],sf[N];


void update(int v,int tl,int tr,int ind,int val,int sg[]){
	if (tl==tr){
		sg[v]=val;
		return;
	}
	int tm=(tl+tr)/2;
	if (ind<=tm)update(v+v,tl,tm,ind,val,sg);
	else update(v+v+1,tm+1,tr,ind,val,sg);
	sg[v]=sg[v+v]+sg[v+v+1];
}

int query(int v,int tl,int tr,int l,int r,int sg[]){
	if (l>r)return 0;
	if (tl==l && tr==r)return sg[v];
	int tm=(tl+tr)/2;
	return query(v+v,tl,tm,l,min(r,tm),sg)+query(v+v+1,tm+1,tr,max(tm+1,l),r,sg);
}


int sg[2][4*N];

vector<int> en[N];

int main(){
	fastio;
	hosh::pre();
	int n;
	string s;
	cin>>n>>s;

	FORT(i,1,n){
		pr[i]=pr[i-1];
		pr[i]+=s[i-1];
	}
	FORTD(i,n,1){
		sf[i]=sf[i+1];
		sf[i]+=s[i-1];
	}
	ll ans=0;
	FORT(i,1,n){
		int l=1,r=min(i,n-i+1)+1;
		//cout<<i<<endl;
		while(l<r){
			int md=(l+r)/2;
			//cout<<i<<" "<<i-md<<" "<<i+md<<" "<<pr[i].h<<" "<<pr[i-md].h<<" "<<sf[i].h<<" "<<sf[i+md].h<<endl;
			if (pr[i]-pr[i-md]==sf[i]-sf[i+md]){
				l=md+1;
			}
			else{
				r=md;
			}
		}
		l--;
		ans+=query(1,0,n,max(0,i-2*l+1),i,sg[1-i%2]);
		trav(tv,en[i]){
		//	cout<<tv<<endl;
			update(1,0,n,tv,0,sg[1-i%2]);
		}
		en[i].clear();
		//cout<<i<<" "<<ans<<" "<<l<<endl;
		update(1,0,n,i,1,sg[i%2]);
		en[i+2*l-1].ad(i);
		//cout<<l<<endl;
	}
	//cout<<ans<<endl;
	memset(sg[0],0,sizeof(sg[0]));
	memset(sg[1],0,sizeof(sg[1]));
	FORT(i,1,n-1){
		int l=1,r=min(i,n-i)+1;
		//cout<<i<<endl;
		while(l<r){
			int md=(l+r)/2;
			//cout<<i<<" "<<i-md<<" "<<i+md<<" "<<pr[i].h<<" "<<pr[i-md].h<<" "<<sf[i].h<<" "<<sf[i+md].h<<endl;
			if (pr[i]-pr[i-md]==sf[i+1]-sf[i+md+1]){
				l=md+1;
			}
			else{
				r=md;
			}
		}
		l--;
		ans+=query(1,0,n,max(0,i-2*l),i,sg[i%2]);
		trav(tv,en[i]){
			update(1,0,n,tv,0,sg[i%2]);
		}
		update(1,0,n,i,1,sg[i%2]);
		en[i+2*l].ad(i);
	}
	cout<<ans<<endl;
	return 0;
}