#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

vector <int> getc(string s) {
	int n = s.size();
	vector <int> c(n);
	for (int i = 0; i < n; ++i) {
		while (i - c[i] >= 0 && i + c[i] < n && s[i - c[i]] == s[i + c[i]]) {
			++c[i];
		}
	}
	return c;
}

vector <int> getoddc(string s) {
	string s2 = "";
	for (int i = 0; i < s.size(); ++i) {
		s2.push_back(s[i]);
		s2.push_back('#');
	}
	auto c = getc(s2);
	vector <int> mc;
	for (int i = 1; i < c.size(); i += 2) {
		mc.push_back(c[i] / 2);
	}
	return mc;
}

bool pal(string& s, int l, int r) {
	for (int i = l; i <= r; ++i) {
		if (s[i] != s[r - (i - l)]) return false;
	}
	return true;
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	int ans = 0;
	auto c = getc(s);
	vector <int> val(n);
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 1) val[i] = 2 * c[i] - i - 1;
		else val[i] = -1000000;
	}
	for (int i = 0; i < n; i += 2) {
		for (int j = 0; j < n; ++j) {
			if (j > i && j <= 2 * c[i] + i - 1 && val[j] >= -i) {
				++ans;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) val[i] = 2 * c[i] - i - 1;
		else val[i] = -1000000;
	}
	for (int i = 1; i < n; i += 2) {
		for (int j = 0; j < n; ++j) {
			if (j > i && j <= 2 * c[i] + i - 1 && val[j] >= -i) {
				++ans;
			}
		}
	}

	c = getoddc(s);

	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) val[i] = 2 * c[i] - i;
		else val[i] = -1000000;
	}
	for (int i = 0; i < n; i += 2) {
		for (int j = 0; j < n; ++j) {
			if (j > i && j <= 2 * c[i] + i && val[j] >= -i) {
				++ans;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 1) val[i] = 2 * c[i] - i;
		else val[i] = -1000000;
	}
	for (int i = 1; i < n; i += 2) {
		for (int j = 0; j < n; ++j) {
			if (j > i&& j <= 2 * c[i] + i && val[j] >= -i) {
				++ans;
			}
		}
	}
	cout << ans << "\n";
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}