//#define _GLIBCXX_DEBUG 1
#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
//    n = 1000000;
//    s = string(1000000, 'a');
    vector<int> odd(n), even(n);
    int r = -1;
    int c = 0;
    for (int i = 0; i < n; ++i) {
        odd[i] = min(odd[c - (i - c)], r - i);
        if (odd[i] == r - i) {
            c = i;
            while(r + 1 < n and c - ((r + 1) - c) >= 0 and s[r + 1] == s[c - ((r + 1) - c)])
            {
                odd[i]++;
                r++;
            }
        }
    }
    r = 0;
    c = 0;
    for (int i = 0; i < n; ++i) {
        even[i] = ((c - (i - c) >= 0 and c != -1) ? min(even[c - (i - c)], r - i) : r - i);
        if (even[i] == r - i) {
            c = i;
            while(r < n and c - (r - c) - 1 >= 0 and s[r] == s[c - (r - c) - 1])
            {
                even[i]++;
                r++;
            }
        }
        if (even[i] < 0) even[i] = 0;
    }
    ll cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= odd[i]; ++j) {
            int ni = i + j * 2 + 1;
            if (ni >= n) break;
            if (odd[ni] >= j) cnt++;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j <= even[i]; ++j) {
            int ni = i + j * 2;
            if (ni >= n) break;
            if (even[ni] >= j) cnt++;
        }
    }
    cout << cnt;
}