#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAXN = 5e5;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    string s(n, 'a');
    vector<int> odd(n), even(n);
    vector<int> alive_odd(n, 1), alive_even(n, 1);
    vector<int> del_odd[n * 4], del_even[n * 4];
    for (int i = 0; i < n; i++) {
        int cur = 1;
        while (i - cur + 1 >= 0 && i + cur - 1 < n && s[i - cur + 1] == s[i + cur - 1]) {
            cur++;
        }
        odd[i] = cur * 2 - 2;
        del_odd[cur * 2 - 1].emplace_back(i);
        cur = 0;
        while (i - cur >= 0 && i + cur + 1 < n && s[i - cur] == s[i + cur + 1]) {
            cur++;
        }
        even[i] = cur * 2;
        del_even[cur * 2 + 2].emplace_back(i);

    }
    long long ans = 0;
    for (int l = 1; l < n; l++) {
        ans += n - l;
        for (auto &x : del_odd[l]) {
            for (int i = x + l; i < n; i += 2) {
                ans -= alive_odd[i];
            }
            for (int i = x - l; i >= 0; i -= 2) {
                ans -= alive_odd[i];
            }
            alive_odd[x] = 0;
        }
        for (auto &x : del_even[l]) {
            for (int i = x + l; i < n; i += 2) {
                ans -= alive_even[i];
            }
            for (int i = x - l; i >= 0; i -= 2) {
                ans -= alive_even[i];
            }
            alive_even[x] = 0;
        }
    }
    cout << ans;
    return 0;
}