#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

const int BASE = 257;
const int MOD = 1000000007;
#ifdef LOCAL
const int MX = 1001;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 500010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);


ull pw[MX];
ull h[MX];
ull rh[MX];
int pw2[MX];
int h2[MX];
int rh2[MX];
const int BASE2 = 239;
int n;
ull sub(int l, int r) {
    return (h[r + 1] - h[l] * pw[r - l + 1]);
}

int sub2(int l, int r) {
    int res = h2[r + 1] - h2[l]  * pw2[r - l + 1] % MOD;
    if (res < 0)
        res += MOD;
    return res;
}

ull subr(int l, int r) {
    return (rh[r + 1] - rh[l] * pw[r - l + 1]);
}

int sub2r(int l, int r) {
    int res =  (rh2[r + 1] - rh2[l] * pw2[r - l + 1] % MOD);
    if (res < 0)
        res += MOD;
    return res;
}

bool is_pal(int l, int r) {
    int l1 = n - 1 - r;
    int r1 = n - 1 - l;
    return (sub(l, r) == subr(l1, r1) && sub2(l, r) == sub2r(l1, r1));
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    str s;
    cin >> s;
    pw[0] = 1;
    pw2[0] = 1;
    fi(1, n + 1) {
        pw[i] = pw[i - 1] * BASE;
        pw2[i] = pw2[i - 1] * BASE2 % MOD;
        h[i] = h[i - 1] * BASE + s[i - 1];
        h2[i] = (h2[i - 1] * BASE2 + s[i - 1]) % MOD;
        rh[i] = rh[i - 1] * BASE + s[n - i];
        rh2[i] = (rh2[i - 1] * BASE2 + s[n - i]) % MOD;
    }
    ll cnt = 0;
    fi(0, n) {
        for (int len = 2; len <= n - i; len += 2) {
            int m = i + (len / 2) - 1;
            int r = i + len - 1;
            if (is_pal(i, m) && is_pal(m + 1, r))
                ++cnt;
        }
    }
    cout << cnt;
}