#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

#define ll long long
#define S second
#define F fist

using namespace std;

ll a, b, c, d, e;
vector <ll> ar, pp;
vector <vector <ll> > arr;
vector <ll> hash1, hash2;

ll q = 1e9 + 7;
ll p = 17253;

ll get_hash1(ll l, ll r)
{
    if (l == 0)
        return hash1[r];
    return (hash1[r] - (hash1[l - 1] * pp[r - l + 1]) % q + q) % q;
}

ll get_hash2(ll l, ll r)
{
    if (l == 0)
        return hash2[r];
    return (hash2[r] - (hash2[l - 1] * pp[r - l + 1]) % q + q) % q;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a;
    pp.resize(a + 3);
    pp[0] = 1;
    for (ll i = 1; i <= a; ++i)
        pp[i] = (pp[i - 1] * p) % q;
    string s = "";
    //for (ll i = 0; i < 500000; ++i)
    //    s += 'a';
    cin >> s;
    hash1.resize(a);
    hash2.resize(a);
    string s1 = s;
    reverse(s1.begin(), s1.end());
    for (ll i = 0; i < a; ++i)
    {
        if (i == 0)
        {
            hash1[i] = s[i] - 'a' + 1;
            hash2[i] = s1[i] - 'a' + 1;
        }
        else
        {
            hash1[i] = ((hash1[i - 1] * p) % q + s[i] - 'a' + 1) % q;
            hash2[i] = ((hash2[i - 1] * p) % q + s1[i] - 'a' + 1) % q;
        }
    }
    //reverse(hash2.begin(), hash2.end());
    ll ot = 0;
    ll l = 0;
    ll del = 1;
    for (ll i = 1; i < a; ++i)
    {
        if (s[i] == s[i - 1])
        {
            ++del;
            continue;
        }
        if (del % 2 == 0)
        {
            ll k = 1;
            for (ll j = 1; j <= del / 2; ++j)
            {
                ot += k;
                k += 2;
            }
        }
        else
        {
            ll k = 2;
            for (ll j = 1; j <= del / 2; ++j)
            {
                ot += k;
                k += 2;
            }
        }
        for (ll j = l; j < i; ++j)
        {
            ll dl = min(j - l + 1, i - j + 1);
            while (j - dl >= 0 && j + dl - 1 < a && dl <= 1000)
            {
                //cout << i - dl << " " << i - 1 << " " << a - i << " " << a - i + dl - 1 << endl;
                //cout << i << " " << i + dl - 1 << " " << a - i - dl << " " << a - i - 1 << endl;
                if (get_hash1(j - dl, j - 1) == get_hash2(a - j, a - j + dl - 1) && get_hash1(j, j + dl - 1) == get_hash2(a - j - dl, a - j - 1))
                    ++ot;
                ++dl;
            }
        }
        l = i;
        del = 1;
        //cout << ot << " " << i << endl;
    }
    if (del % 2 == 0)
    {
        ll k = 1;
        for (ll j = 1; j <= del / 2; ++j)
        {
            ot += k;
            k += 2;
        }
    }
    else
    {
        ll k = 2;
        for (ll j = 1; j <= del / 2; ++j)
        {
            ot += k;
            k += 2;
        }
    }
    for (ll j = l; j < a; ++j)
    {
        ll dl = min(j - l + 1, a - j + 1);
        //cout << j << " " << dl << endl;
        while (j - dl >= 0 && j + dl - 1 < a && dl <= 1000)
        {
            //cout << i - dl << " " << i - 1 << " " << a - i << " " << a - i + dl - 1 << endl;
            //cout << i << " " << i + dl - 1 << " " << a - i - dl << " " << a - i - 1 << endl;
            if (get_hash1(j - dl, j - 1) == get_hash2(a - j, a - j + dl - 1) && get_hash1(j, j + dl - 1) == get_hash2(a - j - dl, a - j - 1))
                ++ot;
            ++dl;
        }
        //cout << ot << endl;
    }
    cout << ot << endl;
}
