#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
#include<map>
#include<cmath>
#include<time.h>

using namespace std;
typedef long long ll;

void solve() {
	int n; cin >> n;
	vector<char>mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}
	int L = 0, R = 0;
	vector<int>z(n - 1, 0);
	for (int i = 0; i < n - 1; i++) {
		if (i >= R)z[i] = 0;
		else {
			z[i] = min(R - i, z[L + R - i]);
		}
		while (0 <= i - z[i] && i + z[i] + 1 < n
			&& mas[i + z[i] + 1] == mas[i - z[i]]) {
			z[i]++;
		}
		if (i + z[i] > R)R = i + z[i], L = i - z[i];
	}
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		for (int j = i+1; j < n - 1; j++) {
			if ((j - i) % 2)continue;
			if (z[i] >= (j - i) / 2 && z[j] >= (j - i) / 2)ans++;
		}
	}
	L = 0, R = 0;
	z.resize(n);
	fill(z.begin(), z.end(), 0);
	z[0] = 1;
	for (int i = 1; i < n; i++) {
		if (i >= R)z[i] = 1;
		else {
			z[i] = min(R - i, z[L + R - i]);
		}
		while (0 <= i - z[i] && i + z[i] < n && mas[i + z[i]] == mas[i - z[i]])z[i]++;
		if (i + z[i] > R)R = i + z[i], L = i - z[i];
	}
	
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((j - i) % 2 == 0)continue;
			if (z[i] >= (j - i+1) / 2 && z[j] >= (j - i+1) / 2)ans++;
		}
	}
	cout << ans;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);	
	solve();
}