#include <bits/stdc++.h>

using namespace std;
typedef pair<int64_t, uint64_t> H;

const int N = 500500;
const int mod = 1e9 + 7;
const int p = 37;
const int k = 47;
H myhash[N];
H pows[N];
H rmyhash[N];
H rpows[N];
H zero = make_pair(0, 0);
int n;

H getH(int l, int r) {
    H L = l == 0 ? zero : myhash[l - 1];
    L.first = L.first * pows[r - l + 1].first % mod;
    L.second *= pows[r - l + 1].second;
    H R = myhash[r];
    R.first = (R.first - L.first + mod) % mod;
    R.second -= L.second;
    return R;
}
H rgetH(int l, int r) {
    H L = r == n - 1 ? zero : rmyhash[r + 1];
    L.first = L.first * pows[r - l + 1].first % mod;
    L.second *= pows[r - l + 1].second;
    H R = rmyhash[l];
    R.first = (R.first - L.first + mod) % mod;
    R.second -= L.second;
    return R;
}

signed main() {
    cin >> n;
    string s;
    cin >> s;
    vector<int> ss(n);
    for (int i = 0; i < n; ++i) {
        ss[i] = s[i] - 'a' + 1;
    }
    for (int i = 0; i < n; ++i) {
        pows[i].first = i == 0 ? 1 : pows[i - 1].first * p % mod;
        pows[i].second = i == 0 ? 1 : pows[i - 1].second * k;
        myhash[i].first = i == 0 ? ss[i] : (myhash[i - 1].first * p + ss[i]) % mod;
        myhash[i].second = i == 0 ? ss[i] : myhash[i - 1].second * k + ss[i];
    }
    for (int i = n - 1; i >= 0; --i) {
        rmyhash[i].first = i == n - 1 ? ss[i] : (rmyhash[i + 1].first * p + ss[i]) % mod;
        rmyhash[i].second = i == n - 1 ? ss[i] : rmyhash[i + 1].second * k + ss[i];
    }
    vector<pair<int, int>> pals1[2];
    for (int i = 0; i < n; ++i) {
        int l = 0;
        int r = min(i + 1, n - i);
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getH(i - m, i + m) == rgetH(i - m, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l > 0) {
            pals1[i % 2].push_back(make_pair(i, l));
        }

    }
    vector<pair<int, int>> pals2[2];
    for (int i = 0; i < n - 1; ++i) {
        int l = 0;
        int r = min(i + 2, n - i);
        //cout << r << endl;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getH(i - m + 1, i + m) == rgetH(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l > 0) {
            pals2[i % 2].push_back(make_pair(i, l));
        }
    }
    int64_t ans = n - 1;
    for (int i = 0; i < pals1[0].size(); ++i) {
        for (int j = 0; j < pals1[1].size(); ++j) {
            int x = abs(pals1[0][i].first - pals1[1][j].first);
            if (1 < x && x <= min(2 * pals1[0][i].second + 1, 2 * pals1[1][j].second + 1)) {
                ans += 1;
            }
        }
    }
    for (int i = 0; i < pals2[0].size(); ++i) {
        for (int j = i + 1; j < pals2[0].size(); ++j) {
            int x = abs(pals2[0][i].first - pals2[0][j].first);
            if (1 < x && x <= min(2 * pals2[0][i].second, 2 * pals2[0][j].second)) {
                ans += 1;
            }
        }
    }
    for (int i = 0; i < pals2[1].size(); ++i) {
        for (int j = i + 1; j < pals2[1].size(); ++j) {
            int x = abs(pals2[1][i].first - pals2[1][j].first);
            if (1 < x && x <= min(2 * pals2[1][i].second, 2 * pals2[1][j].second)) {
                ans += 1;
            }
        }
    }
    cout << ans << endl;
    /*
    for (auto i : pals1[0]) {
        cout << i.first << ' ' << i.second << endl;
    }
    for (auto i : pals1[1]) {
        cout << i.first << ' ' << i.second << endl;
    }
    for (auto i : pals2[0]) {
        cout << i.first << ' ' << i.second << endl;
    }
    for (auto i : pals2[1]) {
        cout << i.first << ' ' << i.second << endl;
    }
    */
}

