#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mod = 1e9 + 7;
const ll p = 228 + 239 + 57;
const int maxn = (1 << 19);

string s;
ll h1[maxn], h2[maxn];
ll ppow[maxn];
int a[maxn];

inline bool ispal(int l, int r) {
    ll t1 = h1[r] - h1[l - 1] * ppow[r - l + 1];
    ll t2 = h2[l] - h2[r + 1] * ppow[r - l + 1];
    return (t1 - t2) % mod == 0;
}

struct dosum {
    int a[2 * maxn + 3];
    void add(int p, int t, int x = 1, int L = 0, int R = maxn) {
        if (p < L || p >= R)
            return;
        a[x] += t;
        if (R == L + 1)
            return;
        add(p, t, x << 1, L, (L + R) >> 1);
        add(p, t, (x << 1) + 1, (L + R) >> 1, R);
    }
    int gett(int l, int r, int x = 1, int L = 0, int R = maxn) {
        if (r <= L || R <= l)
            return 0;
        if (l <= L && R <= r)
            return a[x];
        return gett(l, r, x << 1, L, (L + R) >> 1) + gett(l, r, (x << 1) + 1, (L + R) >> 1, R);
    }
};

dosum mdo[2], mdo2[2];
vector <pair <int, int> > v;

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int n;
    cin >> n;
    ppow[0] = 1;
    for (int i = 1; i <= n + 2; i++) {
        ppow[i] = (ppow[i - 1] * p) % mod;
    }
    cin >> s;
    s = " " + s;
    for (int i = 1; i <= n; i++) {
        h1[i] = (h1[i - 1] * p + s[i]) % mod;
    }
    for (int i = n; i >= 1; i--) {
        h2[i] = (h2[i + 1] * p + s[i]) % mod;
    }
    for (int i = 1; i <= n; i++) {
        int l = 0, r = min(n - i, i - 1) + 1;
        while (r - l > 1) {
            int med = (l + r) / 2;
            if (ispal(i - med, i + med))
                l = med;
            else
                r = med;
        }
        a[i] = l;
        //cerr << "a[" << i << "] = " << a[i] << "\n";
        v.push_back({i - 2 * a[i] - 1, i});
    }
    sort(v.begin(), v.end());
    int pos = -1;
    ll res = 0;
    for (int i = 1; i <= n; i++) {
        while (pos + 1 < (int)v.size() && v[pos + 1].first <= i) {
            pos++;
            mdo[v[pos].second % 2].add(v[pos].second, 1);
            //cerr << "go add " << v[pos].second << "\n";
        }
        //cerr << "go get " << i + 1 << " " <<  min(n, 2 * a[i] + i + 1) + 1 << "[)\n";
        int cres = mdo[(i + 1) % 2].gett(i + 1, min(n, 2 * a[i] + i + 1) + 1);
        //cerr << i << " " << cres << "\n";
        res += cres;
    }
    v.clear();
    for (int i = 2; i <= n; i++) {
        int l = 0, r = min(i - 1, n - i + 1) + 1; /// [)
        while (r - l > 1) {
            int med = (l + r) / 2;
            if (ispal(i - med, i + med - 1))
                l = med;
            else
                r = med;
        }
        a[i] = l;
        v.push_back({i - 2 * a[i], i});
    }
    pos = -1;
    sort(v.begin(), v.end());
    for (int i = 1; i <= n; i++) {
        while (pos + 1 < v.size() && v[pos + 1].first <= i) {
            pos++;
            mdo2[v[pos].second % 2].add(v[pos].second, 1);
        }
        int cres = mdo2[i % 2].gett(i + 1, min(n, 2 * a[i] + i) + 1);
        res += cres;
    }
    cout << res;
    return 0;
}
