#include <iostream>
#include <vector>
#include <map>

std::map<std::pair<int, int>, bool> cache;

bool check_poly(std::string& s, int i, int j){
    if (cache.count({i, j})){
        return cache[{i, j}];
    }
    while (i <= j){
        if (s[i] != s[j]){
            cache[{i, j}] = false;
            return false;
        }
        i++;
        j--;
    }
    cache[{i, j}] = true;
    return true;
}

int main() {
    int n;
    std::string s;
    std::cin >> n >> s;
    int k = n - 1;
    for (int i = 0; i < n; i++){
        for (int l = 4; i + l - 1 < n; l+=2){
            k += check_poly(s, i, i + l / 2 - 1) and check_poly(s, i + l / 2, i + l - 1);
        }
    }
    std::cout << k << std::endl;
    return 0;
}