#include <bits/stdc++.h>
using namespace std;
typedef long long ull;
typedef unsigned long long uull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ull mod = 1e9 + 9, base = 27;

const ull MAX_N = 5e5 + 10;
uull pref1[MAX_N], pref2[MAX_N];
uull pw[MAX_N];
ull n;
string in;

uull query1(ull l, ull r) {ull ans = pref1[r]; if(l > 0) {ans -= pref1[l - 1];} return ans;}
uull query2(ull l, ull r) {ull ans = pref2[r]; if(l > 0) {ans -= pref2[l - 1];} return ans;}

bool palin(ull l, ull r) {
    if(l < 0 || r >= n) {return false;}
    ull hash1 = query1(l, r) * pw[n - 1 - r];
    ull hash2 = query2(l, r) * pw[l];
    return hash1 == hash2;
}

ull k[MAX_N], m[MAX_N];

struct SegTree {
    ull tree[2 * MAX_N];
    SegTree() {fill_n(tree, 2 * MAX_N, 0);}
    void upd(ull ind, ull val) {
        ind += MAX_N; tree[ind] = val; ind /= 2;
        while(ind > 0) {
            tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
            ind /= 2;
        }
    }
    ull ans(ull l, ull r) {
        l += MAX_N; r += MAX_N + 1;
        ull ret = 0;
        while(l < r) {
            if(l & 1) {ret += tree[l]; l ++;}
            if(r & 1) {r --; ret += tree[r];}
            l /= 2; r /= 2;
        }
        return ret;
    }
};
SegTree st1, st2;

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(NUull);
    for(int i = 0; i < n; i ++) {in[i] = 'a';}
    cin >> n >> in;
    pw[0] = 1;
    for(ull i = 1; i < MAX_N; i ++) {
        pw[i] = pw[i - 1] * base;
    }
    pref1[0] = in[0] - 'a' + 1ull;
    pref2[0] = pw[n - 1] * (ull)(in[0] - 'a' + 1ull);
    for(ull i = 1; i < n; i ++) {
        pref1[i] = pref1[i - 1] + (pw[i] * (ull)(in[i] - 'a' + 1ull));
        pref2[i] = pref2[i - 1] + (pw[n - 1 - i] * (ull)(in[i] - 'a' + 1ull));
    }
    for(ull i = 0; i < n; i ++) {
        ull l = 1, r = n;
        while(l < r - 1) {
            ull m = (l + r) / 2ull;
            if(palin(i - m + 1, i + m - 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        k[i] = l;
    }
    for(ull i = 0; i < n; i ++) {
        ull l = 0, r = n;
        while(l < r - 1ull) {
            ull m = (l + r) / 2ull;
            if(palin(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        m[i] = l + 1;
    }
    priority_queue<pair<ull, ull> > pq;
    ull ret = 0;
    for(ull i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        int nw;
        if(i & 1) {
            nw = st2.ans(i + 1 - 2 * k[i], i);
        } else {
            nw = st1.ans(i + 1 - 2 * k[i], i);
        }
        ret += nw;
        pq.push({-2 * k[i] - i + 1, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    while(!pq.empty()) {
        if(pq.top().second & 1) {
            st1.upd(pq.top().second, 0);
        } else {
            st2.upd(pq.top().second, 0);
        }
        pq.pop();
    }
    for(ull i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        ull nw;
        if(i & 1) {
            nw = st1.ans(i + 2 - 2 * m[i], i);
        } else {
            nw = st2.ans(i + 2 - 2 * m[i], i);
        }
        ret += nw;
        pq.push({-2 * m[i] - i + 2, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    cout << ret << endl;
    return 0;

}
