#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    string s;
    cin >> n >> s;
    vector<char> tmp(n + n + 3);
    tmp[0] = '!';
    for (int i = 0; i < n; ++i) {
        tmp[i + i + 1] = '*';
        tmp[i + i + 2] = s[i];
    }
    tmp[n + n + 1] = '*';
    tmp[n + n + 2] = '#';
    vector<int> pole(n + n + 3);
    int L = 0, M = 0;
    for (int i = 2; i <= n + n; ++i) {
        if (i < M + L)
            pole[i] = min(M + L - i, pole[M + M - i]);
        while (tmp[i + pole[i]] == tmp[i - pole[i]])
            ++pole[i];
        --pole[i];
        if (i + pole[i] > L + M) {
            M = i;
            L = pole[i];
        }
    }
    long long ans = 0;
    vector<pair<int, int>> events;
    for (int i = 1; i < n + n + 3; i+=2) {
        if (pole[i] != 0) {
            events.push_back({i - pole[i], 1});
            events.push_back({i + pole[i], -1});
        }
    }
    vector<pair<int, int>> events1;
    for (int i = 0; i < n + n + 3; i+=2) {
        if (pole[i] != 0) {
            events1.push_back({i - pole[i], 1});
            events1.push_back({i + pole[i], -1});
        }
    }
    sort(events.begin(), events.end());
    sort(events1.begin(), events1.end());
    long long op = 0;
    for (auto x : events) {
        if (x.second < 0)
            --op;
        else {
            ans += op;
            ++op;
        }
    }
    for (auto x : events1) {
        if (x.second < 0)
            --op;
        else {
            ans += op;
            ++op;
        }
    }
    cout << ans << endl;
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
