#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T> 
bool uin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 20;
const LL LINF = 1e18;
const int N = (int)1e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

int n;
string s;

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> s;
	int ans = 0, ind = 0;
	while (ind < n) {
		int st = ind, bal = 0, mbal = 0, len = 0;
		while (ind < n && (bal != 0 || st == ind)) {
			if (s[ind] == '(')
				bal++;
			else
				bal--;
			len++;
			uin(mbal, bal);
			ind++;
		}
		if (bal != 0) {
			cout << -1;
			return 0;
		}
		if (mbal != 0)
			ans += len;
	}
	cout << ans;
}