#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;


int n;
string s;

bool check_good(string t) {
	int bal = 0;
	for (auto it : t) {
		if (it == '(')
			bal++;
		else
			bal--;
		if (bal < 0)
			return false;
	}
	return true;
}              

int main() {
	fastIO();
	cin >> n >> s;
	int cnt_open = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '(')
			cnt_open++;
	}
	if (n % 2 != 0 || n / 2 != cnt_open) {
		cout << -1;
		return 0;
	}
	string cur;
	int bal = 0, ans = 0;
	for (int i = 0; i < n; i++) {
		cur.pb(s[i]);
		if (s[i] == '(')
			bal++;
		else
			bal--;
		if (bal == 0) {
			if (!check_good(cur))
				ans += cur.size();
			cur.clear();
		}
	}
	cout << ans;
	
	
	
	
	return 0;

}