#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	string s;
	cin >> s;
	int cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == ')')cnt1++;
		else cnt2++;
	}
	if (cnt1 != cnt2) {
		cout << -1;
		return 0;
	}
	stack<pair<char, int>> st;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == ')' && !st.empty()) {
			st.pop();
		}
		else if (s[i] == ')') {
			int bal = -1;
			int start = i;
			while (bal != 0) {
				i++;
				if (s[i] == '(')bal++;
				else bal--;
			}
			ans += i - start + 1;
		}
		else {
			st.push({ '(', i });
		}
	}
	cout << ans;
}