#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}
signed main() {
	fast_io();
	int n;
	cin >> n;
	string s;
	cin >> s;

	vector<int> arr(n);

	int now = 0;

	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '(') {
			now++;
		} else {
			now--;
		}
		arr[i] = now;
	}

	if (now != 0) {
		cout << -1;
		return 0;
	}

	int cnt = 0;
	int cnt1 = 0;

	for (int i = 0; i < n; i++) {
		if (arr[i] < 0) {
			if (i == 0 || arr[i - 1] >= 0) {
				cnt1++;
			}
			cnt++;
		}
	}

	cout << cnt + cnt1 << endl;
    return 0;
}
