#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> balance(n);
    int cur_balance = 0;
    for (int i = 0; i < n; ++i) {
        cur_balance += 2 * (s[i] == '(') - 1;
        balance[i] = cur_balance;
    }
    if (balance[n - 1] != 0) {
        cout << -1;
        return 0;
    }
    int cur = 0;
    bool flag = true;
    int len = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '(') {
            cur++;
        } else {
            cur--;
        }
        if (cur < 0) {
            flag = false;
            cur = 0;
        }
        len++;
        if (balance[i] == 0) {
            if (!(flag && cur == 0)) {
                ans += len;
            }
            len = 0;
            flag = true;
            cur = 0;
        }
    }
    cout << ans;
    return 0;
}