//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "  ";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    ll n;
    cin >> n;
    vector<ll> A(n);
    ll s = 0;
    for (int i = 0; i < n; i++)
    {
        char x;
        cin >> x;
        if (x == '(')
            A[i] = 1;
        else
            A[i] = -1;
        s += A[i];
    }
    if (s != 0)
    {
        cout << "-1";
        return 0;
    }

    ll ans = 0;
    ll L = 0, R = n - 1;
    while (true)
    {
        if (L > R)
            break;
        if (A[L] == 1 && A[R] == -1)
        {
            L++;
            R--;
            continue;
        }
        if (A[L] == -1)
        {
            ll ps = -1;
            ll l1 = L;
            while (l1 + 1 <= R && ps != 0)
            {
                l1++;
                ps += A[l1];
            }
            ans += l1 - L + 1;
            L = l1 + 1;
            continue;
        }
        if (A[R] == 1)
        {
            ll ps = 1;
            ll r1 = R;
            while (r1 - 1 >= L && ps != 0)
            {
                r1--;
                ps += A[r1];
            }
            ans += R - r1 + 1;
            R = r1 - 1;
            continue;
        }
    }
    cout << ans;
}
