#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 17);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

void Solve() {
	string s;
	cin >> s >> s;
	int balance = 0;
	int ans = 0;
	int len = 0;
	bool correct = true;
	for (int i = 0; i < s.size(); i++) {
		len++;
		if (s[i] == ')') {
			balance++;
			if (balance > 0)
				correct = false;
		}
		else {
			balance--;
		}
		if (balance == 0) {
			ans += (correct ? 0 : len);
			len = 0;
			correct = true;
		}
	}
	if (correct)
		cout << ans;
	else cout << -1;
}

int main() {
	IOOptimize();
	Solve();
}