#include <bits/stdc++.h>
#define int long long
using namespace std;

struct Solver {
    vector<int> a;
    int n;

    Solver(vector<int> a): a(a) {
        n = a.size();
    }

    int not_right() {
        int sum = 0;
        for(int i : a)
            sum += i;

        if(sum != 0) return 1;
        return 0;
    }

    int solve() {
        if(not_right()) return -1;

        int res = 0;
        int sum = 0;

        int l = -1;
        for(int i = 0; i < n; ++i) {
            sum += a[i];

            if((sum < 0) && (l == -1)) {
                l = i;
            }

            if(sum >= 0) {
                if(l != -1) {
                    res += i-l+1;
                }

                l = -1;
            }
        }

        return res;
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int tests = 1;
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n;
            cin >> n;

            string s;
            cin >> s;

            vector<int> a(n, 0);
            for(int i = 0; i < n; ++i)
                a[i] = (s[i] == '(' ? 1 : -1);

            Solver solver(a);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
