#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

bool check(string& s) {
	return count(s.begin(), s.end(), '(') != s.size() / 2 || (s.size() & 1);
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	string s;
	cin >> s >> s;
	if (check(s)) {
		cout << "-1\n";
	}
	else {
		int stack = 0, ans = 0;
		for (int i = 0; i < s.size(); ++i) {
			if (s[i] == '(') {
				++stack;
			}
			else {
				--stack;
				++ans;
				bool flag = false;
				while (stack < 0) {
					++i;
					++ans;
					flag = true;
					if (s[i] == '(') {
						++stack;
					}
					else {
						--stack;
					}
				}
				i -= flag;
			}
		}
		cout << ans << '\n';
	}
	return 0;
}