#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 10;

char s[MAX_N];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n >> s;
	int cnt = 0;
	for (int i = 0; i < n; ++i)
		cnt += s[i] == '(';
	if (n % 2 || cnt != n / 2)
		return cout << "-1\n", 0;
	vector<pair<int, bool>> blocks;
	int balance = 0;
	for (int i = 0; i < n; ++i) {
		if (balance == 0)
			blocks.push_back({i, 0});
		if (balance < 0)
			blocks.back().y = 1;
		if (s[i] == '(')
			++balance;
		else
			--balance;
	}
	blocks.push_back({n, 0});
	int ans = 0;
	for (size_t i = 1; i < blocks.size(); ++i) {
		if (blocks[i - 1].y)
			ans += blocks[i].x - blocks[i - 1].x;
	}
	cout << ans << "\n";
	return 0;
}