#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;
	
mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

struct T {
	vector<int> a, t, u;
	T() {}
	T(vector<int> a) : a(a) {
		t.resize(4 * a.size());
		u.resize(4 * a.size());
		build(0, 0, a.size());
	}
	void build(int v, int l, int r) {
		if (r - l == 1) {
			t[v] = a[l];
			return;
		}
		build(2 * v + 1, l, l + r >> 1);
		build(2 * v + 2, l + r >> 1, r);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}
	void push(int v, int l, int r) {
		if (!u[v]) return;
		if (r - l == 1) {
			t[v] += u[v];
			u[v] = 0;
			return;
		}
		t[v] += u[v];
		u[2 * v + 1] += u[v];
		u[2 * v + 2] += u[v];
		u[v] = 0;
	}
	void upd(int v, int l, int r, int vl, int vr, int d) {
		push(v, l, r);
		if (l >= vr || vl >= r) return;
		if (vl <= l && r <= vr) {
			u[v] += d;
			push(v, l, r);
			return;
		}
		upd(2 * v + 1, l, l + r >> 1, vl, vr, d);
		upd(2 * v + 2, l + r >> 1, r, vl, vr, d);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}
	int get(int v, int l, int r, int vl, int vr) {
		push(v, l, r);
		if (l >= vr || vl >= r) return -inf0;
		if (vl <= l && r <= vr) {
			return t[v];
		}
		return max(get(2 * v + 1, l, l + r >> 1, vl, vr), get(2 * v + 2, l + r >> 1, r, vl, vr));
	}
};

void solve() {
	int n; cin >> n;
	string s; cin >> s;
	int bal = 0;
	int ans = 0;
	int cnt1 = 0, cnt2 = 0;
	for (char c : s) {
		if (c == '(') cnt1++;
		else cnt2++;
	}
	if (cnt1 != cnt2) {
		cout << -1 << endl;
		return;
	}
	vector<int> p(n);

	for (int i = 0; i < n; i++) {
		if (s[i] == '(') bal++;
		else bal--;
		p[i] = bal;
	}
	for (int i = 0; i < n; i++) {
		//cout << i << " " << p[i] << endl;
		if (p[i] < 0) {
			for (int j = i; j < n; j++) {
				if (p[j] == 0) {
					ans += j - i + 1;
					//cout << i << " " << j << endl;
					i = j;
					break;
				}
			}
		}
	}
	cout << ans << endl;
}