#include <bits/stdc++.h>
#define int long long
#define double long double
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse2,sse3,ssse3")
using namespace std;

int pairs(int x) {
    return (x * (x - 1)) >> 1;
}

vector<int> z(string s) {
    int n = s.length();
    vector<int> kek(n);
    kek[0] = n;
    int l = 0;
    int r = 0;
    for (int i = 1; i < n; i++) {
        if (i <= r) {
            kek[i] = min(kek[i - l], r - i + 1);
        }
        while (i + kek[i] < n && s[kek[i]] == s[i + kek[i]]) {
            kek[i]++;
        }
        if (i > r) {
            l = i;
            r = i + kek[i] - 1;
        }
    }
    return kek;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    string s;
    cin >> n >> s;
    int l = 0;
    int r = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '(') {
            l++;
        } else {
            r++;
        }
    }
    if (l != r) {
        cout << -1 << '\n';
    } else {
        int cnt = 0;
        int now = 0;
        int bal = 0;
        bool ok = true;
        for (int i = 0; i < n; i++) {
            if (s[i] == '(') {
                bal++;
            } else {
                bal--;
            }
            if (bal < 0) {
                ok = false;
            }
            now++;
            if (bal == 0) {
                if (!ok) {
                    cnt += now;
                }
                now = 0;
                ok = true;
            }
        }
        cout << cnt << '\n';
    }
    return 0;
}
