#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;

int main() {
	cin >> n;
	string s;
	cin >> s;
	if (n % 2) {
		cout << -1;
		return 0;
	}
	ll a = 0, b = 0;
	for (auto& x : s) {
		if (x == '(') ++a;
		else ++b;
	}
	if (a != b) {
		cout << -1;
		return 0;
	}
	ll ans = 0;
	ll bal = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '(') {
			++bal;
		}
		else if (s[i] == ')') {
			--bal;
		}
//		cout << i << ' ' << bal << '\n';
		if (bal < 0) {
			ll ptr = i + 1;
			ll cbal = bal;
			while (ptr < n && cbal != 0) {
				if (s[ptr] == '(') ++cbal;
				else --cbal;
				++ptr;
			}
			ans += ptr - i;
			i = ptr - 1;
			bal = 0;
		}
	}
	cout << ans;
	return 0;
}
/*
8
))((())(
*/