#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> bal(n);
    bal[0] = (s[0] == '(' ? 1 : -1);
    rep(i, 1, n) bal[i] = bal[i - 1] + (s[i] == '(' ? 1 : -1);
    if (bal.back() != 0) return cout << "-1\n", 0;
    int ans = 0;
    int left = 0;
    rep(i, 0, n) {
        if (left == -1 && bal[i] == -1) left = i;
        else if (bal[i] == 0 && left != -1) ans += i - left + 1, left = -1;
    }
    cout << ans << '\n';
}
