#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long


void solve() {
	int n;
	string s;
	cin >> n >> s;
	int bal = 0;
	for (auto& i : s) {
		if (i == '(') ++bal;
		else --bal;
	}
	if (bal != 0) {
		cout << -1;
		return;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		bal += (s[i] == '(' ? 1 : -1);
		if (bal < 0) {
			++i;
			++ans;
			while (bal < 0) {
				++ans;
				bal += (s[i] == '(' ? 1 : -1);
				++i;
			}
			--i;
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}