#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	string a;
	cin >> a;
	int cnt1 = 0;
	int cnt2 = 0;
	for (auto& i : a) {
		if (i == '(') cnt1++;
		else cnt2++;
	}
	if (cnt1 != cnt2) {
		cout << -1;
		return 0;
	}

	int ans = 0;
	for (int i = 0; i < n;) {
		int j = i + 1;
		cnt1 = 0;
		cnt2 = 0;
		stack<int> st;
		st.push(a[i]);
		if (a[i] == '(') cnt1++;
		else cnt2++;
		bool ok = 1;
		while (j < n && cnt1 != cnt2) {
			if (a[j] == '(') {
				st.push(a[j]);
				cnt1++;
			}
			else {
				if (st.top() == '(') st.pop();
				cnt2++;
			}
			j++;
			if (st.empty()) {
				ok = 0;
				break;
			}
		}
		if (ok)
			ans += (j - i);
		i = j;
	}
	cout << ans << endl;
}