#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto start = chrono::high_resolution_clock::now();
#define end chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(end - start).count()

void solve() {
    int n;
    cin >> n;
    int ans = 0;
    int cnto = 0, cnte = 0;
    stack<char> st;
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        if (c == ')') {
            if (!st.empty() && st.top() == '(') {
                st.pop();
                cnto--;
            } else {
                st.push(c);
                cnte++;
            }
        } else {
            st.push(c);
            cnto++;
        }
        if (cnto == cnte) {
            ans += st.size();
            while (!st.empty()) {
                st.pop();
            }
            cnte = cnto = 0;
        }
    }
    cout << (st.empty() ? ans : -1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}