#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

bool correct(string s)
{
    int opened = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (s[i] == '(')
                opened++;
        else
            opened--;
        if (opened < 0)
            return(false);
    }
    return(true);
}

int main()
{
    int n;
    cin >> n;
    string s;
    cin >> s;
    int couOp, couCl, i;
    couOp = couCl = 0;
    for (i = 0; i < s.size(); i++)
    {
        couOp = couOp + (s[i] == '(');
        couCl = couCl + (s[i] == ')');
    }
    if (couCl != couOp)
    {
        cout << "-1";
        return 0;
    }
    couOp = couCl = 0;
    int ans = 0, last = 0;
    for (i = 0; i < n; i++)
    {
        couOp = couOp + (s[i] == '(');
        couCl = couCl + (s[i] == ')');
        if (couOp == couCl)
        {
            if (!correct(s.substr(last, couOp + couCl)))
            {
                ans = ans + couCl + couOp;
            }
            last = i + 1;
            couOp = couCl = 0;
        }
    }
    cout << ans;
    return 0;
}
