#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
typedef pair<vector<ull>, vector<ull> > pvv;
ull q = 157;
ull mod = 1e9 + 7;
vector <ull> qp1, qp2;
pvv calc_hash(string& s) {
    s = '-' + s;
    if (s.size() > qp1.size()) {
        qp1.assign(s.size(), 1);
        qp2.assign(s.size(), 1);
    }
    vector<ull>h1(s.size(), 0), h2(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        h1[i] = h1[i - 1] * q + s[i] - 'a';
        h2[i] = ((h2[i - 1] * q) % mod + s[i] - 'a') % mod;
        qp1[i] = qp1[i - 1] * q;
        qp2[i] = (qp2[i - 1] * q) % mod;
    }
    return { h1, h2 };
}
pair<ull, ull> get_hash(int l, int r, vector<ull>& h1, vector<ull>&h2) {
    ull ha = h1[r] - h1[l - 1] * qp1[r - l + 1];
    ull hb = (h2[r] + mod - (h2[l - 1] * qp2[r - l + 1]) % mod) % mod;
    return { ha, hb };
}
bool palindrom(int l, int r, pvv& h, pvv& rh) {
    auto h1 = get_hash(l, r, h.first, h.second);
    auto h2 = get_hash(h.first.size() - r, h.first.size() - l , rh.first, rh.second);
    return h1 == h2;
}
int main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        bal += (s[i] == ')' ? -1 : 1);
    }
    if (bal != 0) {
        cout << -1;
        exit(0);
    }
    bal = 0;
    int ans = 0;
    for (int i = 0; i < s.size(); ++i) {
        bal += (s[i] == '(' ? 1 : -1);
        if (s[i] == '(' || bal >= 0)continue;//? >=0
        int r = i + 1;
        while (r < n && bal != 0) {
            bal += (s[r] == '(' ? 1 : -1);
            ++r;
        }
       // cout << "in pos " << i << " " << r << "\n";
        ans += (r - i );
        i = max(i, r - 1);
    }
    cout << ans;
    return 0;
}
/*
4
())(
abacac


*/