#include <iostream>
#include <stack>
#define endl '\n'

using namespace std;

const int MAXN = 1e6;
int n;
bool brackets[MAXN+10];
struct templ
{
    bool val;
    int add;
};
bool pos;
int cnt = 0;

void input()
{
    char brac;
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>brac;
        if (brac =='(') brackets[i] = 0;
        else brackets[i] = 1;
    }
}

void output()
{
    if (pos) cout<<cnt<<endl;
    else cout<<-1<<endl;
}

void solve()
{
    pos = 1;
    int curr = 0;
    stack<templ> s;

    s.push({brackets[0], 0});
    for (int i=1; i<n; i++)
    {
        if (s.empty())
        {
            curr = 0;
            s.push({brackets[i], 0});
            continue;
        }
        if (s.top().val != brackets[i])
        {
            if (brackets[i] == 0) cnt += curr - s.top().add + 2; //
            else curr += 2;
            s.pop();
        }
        else
        {
            s.push({brackets[i], curr});
        }
    }
    if (!s.empty()) pos = 0;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
8
))((())(


*/
