#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1007;
const int inf = 1e9 + 7;

int cnt[N][2];

int get(int l, int r, int t) {
  if (!l) return cnt[r][t];
  return cnt[r][t] - cnt[l - 1][t];
}

int get_t(char c) {
  if (c == ')') return 1;
  else return 0;
}

int cnv(char c) {
  if (c == ')') return -1;
  else return 1;
}

int dp[N];
int bal[N];
bool bad[N][N];

int get_bal(int l, int r) {
  return bal[r] - bal[l - 1];
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  string s;
  cin >> s;
  int x = 0, y = 0;
  for (int i = 0; i < n; i++) {
    if (s[i] == ')') y++;
    else x++;
  }
  if (x != y) {
    cout << -1 << endl;
    return 0;
  }
  s = '#' + s;
  n++;
  for (int i = 1; i <= n; i++) {
    for (int t = 0; t < 2; t++) cnt[i][t] = cnt[i - 1][t];
    cnt[i][get_t(s[i])]++;
    bal[i] = bal[i - 1];
    bal[i] += cnv(s[i]);
  }
  for (int i = 1; i <= n; i++) {
    int cur = 0;
    cur += cnv(s[i]);
    if (cur == -1) bad[i][i] = true;
    for (int j = i + 1; j <= n; j++) {
      bad[i][j] |= bad[i][j - 1];
      cur += cnv(s[j]);
      if (cur < 0) bad[i][j] = true;
    }
  }
  dp[0] = 0;
  for (int i = 1; i <= n; i++) dp[i] = inf;
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j <= n; j++) {
      int a = get(i + 1, j, 0), b = get(i + 1, j, 1);
      int wrs = a - b;
      if (bal[i] + wrs >= 0) {
        dp[j] = min(dp[j], dp[i] + j - i);
      }
      if (!bad[i + 1][j]) {
        dp[j] = min(dp[j], dp[i]);
      }
    }
  }
  cout << dp[n] << endl;
  return 0;
}
