//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, ans = 0;
vector<char> a;

int x = 0, y = 0;

bool check(vector<char> &b) {
    int bal = 0;
    for (auto &i: b) {
        bal += (i == '(' ? 1 : -1);
        if (bal < 0) return false;
    }
    return (bal == 0);
}

void solve() {
    cin >> n;
    a.resize(n);
    for (auto &i: a) (cin >> i), x += (i == '('), y += (i == ')');

    if (x != y) {
        cout << -1 nl;
        return;
    }

    int i = 0;
    int j = 0;
    x = 0, y = 0;

    vector<char> b;

    while (i < n) {
        (a[i] == '(' ? x += 1 : y += 1);
        b.push_back(a[i]);

        if (x == y) {
            ans += (check(b) ? 0 : i - j + 1);
            j = i + 1;
            b.clear();
        }

        i += 1;
    }

    cout << ans nl;
}
