#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e6 + 5;

int n;
string s;

int pref[N];

signed main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> s;
    int cnt_open = 0, cnt_close = 0;
    for (int i = 0; i < n; ++i) {
        cnt_open += s[i] == '(';
        cnt_close += s[i] == ')';
    }
    if (cnt_open != cnt_close) {
        cout << "-1\n";
        return 0;
    }
    set<int> open, close;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '(') {
            open.insert(i);
        } else {
            close.insert(i);
        }
    }
    vector<pii> swaps;
    int balance = 0;
    for (int i = 0; i < n; ++i) {
        if (balance == 0 && s[i] == ')') {
            assert(s[i] == ')');
            close.erase(i);
            int swap_with = *open.begin();
            open.erase(swap_with);
            open.insert(i);
            close.insert(swap_with);
            swap(s[i], s[swap_with]);
            swaps.pb(mp(i, swap_with));
        }
        balance += (s[i] == '(') - (s[i] == ')');
        if (s[i] == '(') {
            open.erase(i);
        } else {
            close.erase(i);
        }
    }
    for (pii &sw : swaps) {
        pref[sw.x]++;
        pref[sw.y + 1]--;
    }
    balance = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        balance += pref[i];
        ans += balance > 0;
    }
    cout << ans << "\n";

    return 0;
}
