#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 2e9 + 109;

string s;
int n;

void check1() {
int bal = 0;
    for (int i = 0; i < n; i++) {
        bal += (s[i] == '(');
        bal -= (s[i] == ')');
    }
    if (bal != 0) {
        cout << "-1\n";
        exit(0);
    }
}

int dp[1000][1000];

signed main() {
    cin >> n >> s;
    check1();

    for (int i = 0; i < 1000; i++) {
        for (int j = 0; j < 1000; j++) {
            dp[i][j] = INF;
        }
    }
    for (int i = 0; i < 1000; i++) {
        dp[0][i] = 0;
    }

    for (int i = 0; i < n - 1; i++) {
        if (s[i] == ')' && s[i + 1] == '(') {
            dp[1][i] = 2;
        } else if (s[i] == '(' && s[i + 1] == ')') {
            dp[1][i] = 0;
        }
    }

    for (int len = 4; len <= n; len += 2) {
        for (int st = 0; st <= n - len; st++) {
            dp[len / 2][st] = len;
            int ok = 1, bal = 0;
            for (int i = st; i < st + len; i++) {
                bal += (s[i] == '(');
                bal -= (s[i] == ')');

                if (bal < 0) {
                    ok = 0;
                    break;
                }
            }
            if (bal != 0) {
                ok = 0;
            }

            if (ok) {
                dp[len / 2][st] = 0;
                continue;
            }

            for (int i = 0; i <= len; i += 2) {
                dp[len / 2][st] = min(dp[len / 2][st], dp[i / 2][st] + dp[(len - i) / 2][st + i]);
            }
        }
    }

    /* cout << "dp = \n";
    for (int i = 0;  i< 10; i++) {
        for (int j = 0;  j< 10; j++) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    } */

    cout << dp[n / 2][0] << "\n";
    return 0;
}

