#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 1000007;

int bal[MAXN];
int sgs[MAXN];

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        sgs[i] = ((s[i] == '(') ? (1) : (-1));
    }
    bal[0] = sgs[0];
    for (int i = 1; i < n; ++i) {
        bal[i] = bal[i - 1] + sgs[i];
    }
    if (bal[n - 1] != 0) {
        cout << -1;
        return 0;
    }
    int ans = 0;
    int last_z = -1;
    for (int i = 0; i + 1 < n; ++i) {
        if (bal[i] == 0 && bal[i + 1] == -1) {
            last_z = i;
        }
        if (bal[i] == -1 && bal[i + 1] == 0) {
            ans += i - last_z + 1;
        }
    }
    cout << ans;
    return 0;
}