//#define _GLIBCXX_DEBUG 1
#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int cnt = 0;
    for (auto i : s) cnt += (i == '(' ? 1 : -1);
    if (cnt != 0) {
        cout << -1;
        return 0;
    }
    int cn2 = 0;
    for (int i = 0; i < n; ++i) {
        cnt += (s[i] == '(' ? 1 : -1);
        int j = i + 1;
        for (; j < n and cnt < 0; ++j) {
            cnt += (s[j] == '(' ? 1 : -1);
        }
        if (j != i + 1) cn2 += j - i;
        i = j - 1;
    }
    cout << cn2;
}