#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

int Next(string& s, int start, int &pos) {
	int cur = 0; bool key = false;
	for (int i = start; i < s.length(); i++) {
		if (s[i] == '(') cur++;
		else cur--;
		if (cur < 0) key = true;
		if (!cur) {
			pos = i + 1;
			break;
		}
	}
	if (key) return pos - start;
	return 0;
}

bool Check(string& s) {
	int cur = 0;
	for (int i = 0; i < s.length(); i++)
		if (s[i] == '(') cur++;
		else cur--;

	return cur == 0;

}

int main() {
	
	fstream cin("input.txt");
	ofstream cout("output.txt");

	int n, pos = 0, ans = 0; cin >> n;
	string s; cin >> s;

	if (!Check(s)) {
		cout << -1;
		return 0;
	}

	while (pos < s.length()) 
		ans += Next(s, pos, pos);
	
	cout << ans;
}

