//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n;
	cin >> n;
	string s, t;
	cin >> s;
	int o = 0, c = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '(') ++o;
		else ++c;
	}
	if (o != c) {
		cout << -1;
		return 0;
	}
	t = s;
	sort(t.begin(), t.end());
	int ans = n;
	do {
		vector<char> check;
		bool flag = true;
		for (int i = 0; i < n; ++i) {
			if (t[i] == '(') {
				check.pb(t[i]);
			} else {
				if (!check.empty() && check.back() == '(') check.pop_back();
				else {
					flag = false;
					break;
				}
			}
		}
		if (flag && check.empty()) {
			int ot, os, ct, cs;
			ot = os = ct = cs = 0;
			int cnt = 0;
			for (int i = 0; i < n; ++i) {
				if (s[i] == '(') ++os;
				else ++cs;
				if (t[i] == '(') ++ot;
				else ++ct;
				if (os == cs && ot == ct && ot == os) {
					if (s.substr(i - os - cs + 1, os + cs) != t.substr(i - os - cs + 1, os + cs)) {
						cnt += os + cs;
					}
					os = cs = ot = ct = 0;
				}
			}
			ans = min(ans, cnt);
		}
	} while (next_permutation(t.begin(), t.end()));
	cout << ans;
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}