#pragma GCC target("avx2")
#pragma GCC optimize("O3") 

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x)) 
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
//#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 123;
const ll inf = (ll)1e18 + 123;

const double pi = acos(-1.0);
const double eps = 1e-7;
const int dx[] = {0, 0, 0, -1, 1};
const int dy[] = {0, 1, -1, 0, 0};

int n, dp[5005], cl[5005], o[5005];
char s[N];
bool is[5005][5005];
bool can[5005][5005];
map <int, int> cnt;

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}

inline void Solve () {
	boost ();
	cin >> n;
	cin >> s + 1;
	for (int i = 1; i <= n; i ++) dp[i] = mod;
	for (int i = 1; i <= n; i ++) {
		o[i] = o[i - 1] + (s[i] == '(');
		cl[i] = cl[i - 1] + (s[i] == ')');
	}
	for (int l = 1; l <= n; l ++)
		for (int r = l; r <= n; r ++)
			can[l][r] = (o[r] - o[l - 1] == cl[r] - cl[l - 1]);
	for (int i = 1; i <= n; i ++) {
		int bal = 0, mn = mod;
		for (int j = i; j <= n; j ++) {
			if (s[j] == '(') bal ++;
			else bal --;
			mn = min (mn, bal);
			if (mn < 0) break;
			if (bal == 0) is[i][j] = 1;
	   }
	}
	for (int j = 1; j <= n; j ++) {
		if (cnt.count (o[j] - cl[j])) dp[j] = min (dp[j], dp[cnt[o[j] - cl[j]]] + j - cnt[o[j] - cl[j]]);
		cnt[o[j - 1] - cl[j - 1]] = j - 1;
		for (int i = j - 1; i >= 1; i --) {
			if (is[i][j]) dp[j] = min (dp[j], dp[i - 1]);
			if (can[i][j]) dp[j] = min (dp[j], dp[i - 1] + j - (i - 1));
			if (dp[j] != mod) break;
		}
	}
	if (dp[n] == mod) dp[n] = -1;
	cout << dp[n];
}

int main () {
   int tt = 1;
   //cin >> tt;
   while (tt --) Solve (); 
	return 0;
}