#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/
#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 1010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

int dp[MX][MX];
int bal[MX];
int32_t main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    str s;
    cin >> s;
    fi(1, n + 1) {
        bal[i] = bal[i - 1];
        if (s[i - 1] == '(')
            ++bal[i];
        else
            --bal[i];
    }
    fi(0, MX) {
        fill(dp[i], dp[i] + MX, INF);
        if (i > 0)
            dp[i][i - 1] = 0;
    }
    for (int len = 2; len <= n; len += 2) {
        fi(0, n) {
            int j = i + len - 1;
            if (bal[j + 1] == bal[i])
                dp[i][j] = len;
            else
                continue;
            if (s[i] == '(' && s[j] == ')') {
                dp[i][j] = min(dp[i][j], dp[i + 1][j - 1]);
            }
            for (int k = i + 1; k < j; k += 2) {
                dp[i][j] = min(dp[i][k] + dp[k + 1][j], dp[i][j]);
            }
        }
    }
    cout << (dp[0][n - 1] != INF ? dp[0][n - 1] : -1);
}