#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << ' ' << x << endl

using namespace std;

int n;
string s;

vector<int> dp;

bool isProper(int l, int r) {
    stack<char> st;
    for (int i = l; i <= r; i++) {
        if (s[i] == '(') {
            st.emplace('(');
        } else if (st.empty()) {
            return false;
        } else {
            st.pop();
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    cin >> s;

    dp.resize(n, -1);
    for (int i = 1; i < n; i++) {
        int degree = 0;
        for (int j = i; j >= 0; j--) {
            if (s[j] == '(') {
                degree++;
            } else {
                degree--;
            }

            if (degree == 0) {
                int cost = isProper(j, i) ? 0 : (i - j + 1);
                int prevDp = (j > 0) ? dp[j - 1] : 0;
                if (prevDp == -1) {
                    continue;
                } else {
                    if (dp[i] == -1) {
                        dp[i] = cost + prevDp;
                    } else {
                        dp[i] = min(dp[i], cost + prevDp);
                    }
                }
            }
        }
    }

    cout << dp.back() << endl;

    return EXIT_SUCCESS;
}
