#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, t;
vector<int> a;

inline int median(int a, int b, int c);

signed main() {
    boot_up();

    while (cin >> n >> t) {
        solve();
    }
}

void solve() {
    init(a, n);
    for (auto & it : a) {
        cin >> it;
    }

    int c = 0;
    while (true) {
        vector<int> b = a;

        for (int i = 1; i < n - 1; ++i) {
            b[i] = median(a[i - 1], a[i], a[i + 1]);
        }

        if (b == a) {
            break;
        }

        a = b;
        ++c;
    }

    cout << c << '\n';
    if (t) {
        info(a);
    }
}

inline int median(int a, int b, int c) {
    vector<int> chto = {a, b, c};
    sort(all(chto));

    return chto[1];
}