#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;

int n;
vector<vector<int>> g;
vector<int> c;

vector<int> path;

bool dfs(int v, int tar, int p = -1) {
	path.push_back(v);
	if (v == tar) {
		return true;
	}
	for (int u : g[v]) {
		if (u != p) {
			if (dfs(u, tar, v)) {
				return true;
			}
		}
	}
	path.pop_back();
	return false;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int m, t;
	cin >> n;
	cin >> m >> t;
	g.resize(n);
	c.resize(n, 1);
	for (int i = 1; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<pair<int, int>> arr(m);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		arr[i] = {a, b};
		path.clear();
		dfs(a, b);
		for (int i = 1; i < path.size(); i++) {
			c[path[i]] = max(c[path[i]], c[path[i - 1]] + 1);
		}
	}
	for (int i = 0; i < m; i++) {
		int a = arr[i].first;
		int b = arr[i].second;
		path.clear();
		dfs(a, b);
		for (int i = 1; i < path.size(); i++) {
			if (c[path[i]] < c[path[i - 1]]) {
				cout << -1 << endl;
				return 0;
			}
		}
	}
	cout << *max_element(c.begin(), c.end()) << endl;
	for (int i = 0; i < n; i++) {
		cout << c[i] << " ";
	}
	cout << endl;
}

