#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
//#define int long long
vector<bool> used, covered;
vector<int> matched, path;
vector<vector<int>> g;
int n, m, start, nd, f = false;
void dfs(int v, int p = -1) {
	path.push_back(v);
	if (v == nd) {
		f = true;
		return;
	}
	for (auto x : g[v]) {
		if (x == p) continue;
		dfs(x,v);
		if (f) return;
	}
	path.pop_back();
}
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n,0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int q, w;
		cin >> q >> w;
		--q, --w;
		g[q].push_back(w);
		g[w].push_back(q);
	}
	vector<int> ans(n);
	for (int i = 0; i < m; ++i) {
		cin >> start >> nd;
		--start, --nd;
		f = false;
		path.clear();
		dfs(start);
		for (int j = 0; j < path.size(); ++j) {
			ans[path[j]] = j + 1;
		}
	}
	int ma = 0;
	for (auto x : ans) ma = max(ma, x);
	cout << ma << '\n';
	for (auto x : ans) cout << x << ' ';
}