#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define eb emplace_back
#define ff first
#define ss second

using itn = int;

const int MAXN = 500000;
//#define int long long
const int INF = 1e9;

vector<int> g[MAXN];

struct tun {
    int a, b;
    tun() {}
    tun(int aa, int bb){
        a = min(aa, bb);
        b = max(aa, bb);
    }

    bool operator< (const tun& oth) const {
        return a < oth.a || (a == oth.a && b < oth.b);
    }
};

int col[MAXN];

void dfs(int v, int p, int c){
    col[v] = c;
    for (int i : g[v]){
        if (i == p) continue;
        dfs(i, v, c+1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;

    int a, b;
    for (int i = 0; i < n-1; i++){
        cin >> a >> b;
        a--;
        b--;

        g[a].eb(b);
        g[b].eb(a);
    }

    vector<tun> v;
    int x=-1, y=-1;
    for (int i =0 ; i < m; i++){
        cin >> a >> b;
        a--;
        b--;
        v.eb(a, b);

        if (x == -1)
            x = a;
        else {
            if (x != a && x != b){
                x = y;
            }
        }
        if (y == -1)
            y = b;
    }

    stable_sort(v.begin(), v.end());

    dfs(x, -1, 1);

    itn mx = 0;
    for(itn i = 0; i < n; i++) mx = max(col[i], mx);
    cout << mx << '\n';
    for (itn i = 0; i < n; i++) cout << col[i] << ' ';

    return 0;
}