#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 2e5;

ll n, m, t;
ve<ll> g[maxn];
ve<ll> order;
ve<ll> dep;

void dfs_prep(ll v, ll par, ll deep) {
    dep[v] = deep;
    fe(to, g[v]) {
        if(to == par) {
            continue;
        }
        dfs_prep(to, v, deep + 1);
    }
    order.pb(v);
}

ve<pair<ll, ll>> q;
ve<ll> c;
ve<ll> st;
ve<ll> path;
ll to, from;
bool ok;

void dfs(ll v, ll par) {
    if(v == from) {
        path = st;
        ok = 1;
        return;
    }
    if(ok) {
        return;
    }
    fe(to, g[v]) {
        if(to == par) {
            continue;
        }
        st.pb(to);
        dfs(to, v);
        st.pop_back();
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> t;
    c.resize(n);
    dep.resize(n);
    fr(i, 1, n - 1) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        g[from].pb(to);
        g[to].pb(from);
    }
    dfs_prep(0, 0, 0);
    fr(i, 1, m) {
        ll from, to;
        cin >> from >> to;
        from--;
        to--;
        q.pb({from, to});
    }
    fr(i, 0, n - 1) c[i] = 1;
    fe(x, q) {
        tie(from, to) = x;
        if(dep[from] > dep[to]) {
            swap(from, to);
        }
        ok = 0;
        st.clear();
        st.pb(to);
        dfs(to, to);
        fr(i, 1, sz(path) - 1) {
            if(c[path[i]] <= c[path[i - 1]]) {
                c[path[i]] = c[path[i - 1]] + 1;
            }
        }
    }
    fe(x, q) {
        tie(from, to) = x;
        if(dep[from] > dep[to]) {
            swap(from, to);
        }
        ok = 0;
        st.clear();
        st.pb(to);
        dfs(to, to);
        fr(i, 1, sz(path) - 1) {
            if(c[path[i]] <= c[path[i - 1]]) {
                cout << "-1\n";
                return 0;
            }
        }
    }
    cout << *max_element(all(c)) << "\n";
    fr(i, 0, n - 1) {
        cout << c[i] << " ";
    }
    cout << "\n";
    return 0;
}
