#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define PB push_back
#define MP make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define pli pair<ll, int>
#define pil pair<int, ll>
#define ft first
#define sd second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
using namespace std;
using namespace __gnu_pbds;
template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int N = 500100;
const int oo = 2e9;
const ll OO = 1e18;
const int PW = 233;
const int md = 998244353;
vector<int> g[N];
int n, m, t, mx = 1, tin[N], tout[N], up[N][PW], tt = 0, h[N], ans[N];

void dfs(int v, int p){

    tin[v] = tt++;
    up[v][0] = p;

    for (int po = 1; po < PW; po++)
        up[v][po] = up[up[v][po - 1]][po - 1];

    for (int u : g[v]){

        if (u == p) continue;

        h[u] = h[v] + 1;

        dfs(u, v);
    }

    tout[v] = tt++;

}

bool upper(int a, int b){
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int lca(int a, int b){
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;

    for (int po = PW - 1; po >= 0; po--)
        if (!upper(up[a][po], b))
            a = up[a][po];

    return up[a][0];
}

int main(){

//    ifdef

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif // _LOCAL

    cin >> n >> m >> t;

    for (int i = 1; i < n; i++){

        int x, y; cin >> x >> y;

        x--; y--;

        g[x].PB(y);
        g[y].PB(x);
    }

    for (int i = 0; i < n; i++)
        ans[i] = 1;

    dfs(0, 0);

    for (int i = 0; i < m; i++){

        int x, y; cin >> x >> y;

        x--; y--;

        int lc = lca(x, y);

        int len = h[x] + h[y] - 2 * h[lc];

        mx = max(mx, len + 1);

        int cur = 1, v = x;

        while (1){
            ans[v] = cur;
            cur++;

            if (v == lc) break;

            v = up[v][0];
        }

        cur = len + 1, v = y;

        while (1){
            ans[v] = cur;
            cur--;

            if (v == lc) break;

            v = up[v][0];
        }

    }

    cout << mx << '\n';

    for (int i = 0; i < n; i++)
        cout << ans[i] << " " ;

    return 0;
}
