#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
#define endl '\n'
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ldb;
typedef double db;

pii e[500000];
vector<int> g[500000];
int cols[500000];

void dfs(int u, int col = 1) {
    cols[u] = col;
    for (auto &v : g[u]) {
        if (!cols[v]) {
            dfs(v, col ^ 3);
        } else {
            if (cols[v] != (col ^ 3)) {
                cout << -1 << endl;
                exit(0);
            }
        }
    }
}

signed main() {
    fastream;
    int n, m, t;
    cin >> n >> m >> t;
    int u, v;
    for (int i = 0; i < n - 1; i++) {
        cin >> e[i].first >> e[i].second;
    }
    int root = e[0].first;
    bool good = 1;
    for (int i = 0; i < n; i++) {
        if (e[i].first != root && e[i].second != root) {
            good = 0;
        }
    }
    if (!good) {
        root = e[0].second;
    }
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        u--, v--;
        if (u == root || v == root) {
            continue;
        }
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        if (!cols[i]) {
            dfs(i);
        }
    }
    cout << 2 << endl;
    for (int i = 0; i < n; i++) {
        cout << cols[i] << ' ';
    }
}