#include<bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define all(a) (a).begin(), (a).end()

#define int long long

int n, m, t;
vector<pair<int, int>> g[500000];
vector<int> gg[500000];
pair<int, int> ed[500000];

int a[500000], b[500000];
int pr[500000], id[500000];
bool f1[500000], f2[500000];
int dp[500000], ans[500000];
int up[500000][25];
int tin[500000], tout[500000], timer;
vector<pair<int, int>> G[500000];
int cl[500000];
bool us[500000];

void paint(int v) {
    us[v] = 1;
    for (auto e : G[v]) {
        if (!us[e.x]) {
            cl[e.x] = cl[v] ^ e.y;
            paint(e.x);
        }
    }
}

int get(int v) {
    if (dp[v] == -1) {
        dp[v] = 1;
        for (auto u : gg[v]) dp[v] = max(dp[v], get(u) + 1);
    }
    return dp[v];
}

void DFS(int v) {
    for (int i = 1; i < 25; i++) up[v][i] = up[up[v][i - 1]][i - 1];
    tin[v] = timer++;
    for (auto e : g[v]) {
        if (e.x != up[v][0]) {
            up[e.x][0] = v;
            id[e.x] = e.y;
            DFS(e.x);
        }
    }
    tout[v] = timer;
}

bool anc(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int LCA(int v, int u) {
    if (anc(v, u)) return v;
    if (anc(u, v)) return u;
    for (int i = 24; i > -1; i--) {
        if (!anc(up[v][i], u)) v = up[v][i];
    }
    return up[v][0];
}

void dfs(int v) {
    for (auto e : g[v]) {
        if (e.x != pr[v]) {
            pr[e.x] = v;
            id[e.x] = e.y;
            dfs(e.x);
        }
    }
}

void add(int v, int u, int w) {
    G[v].pb({u, w});
    G[u].pb({v, w});
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        cin >> ed[i].x >> ed[i].y;
        ed[i].x--;
        ed[i].y--;
        if (ed[i].x > ed[i].y) swap(ed[i].x, ed[i].y);
        g[ed[i].x].pb({ed[i].y, i});
        g[ed[i].y].pb({ed[i].x, i});
    }
    for (int i = 0; i < m; i++) {
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }
    if (t == 0 && (n > 15 || m > 15)) {
        up[0][0] = 0;
        timer = 0;
        DFS(0);
        for (int i = 0; i < n - 1; i++) {
            if (tin[ed[i].x] > tin[ed[i].y]) swap(ed[i].x, ed[i].y);
        }
        for (int i = 0; i < m; i++) {
            int w = LCA(a[i], b[i]);
            if (a[i] == w) {
                int cur = b[i];
                vector<int> ids;
                while (cur != w) {
                    ids.pb(id[cur]);
                    cur = up[cur][0];
                }
                for (int j = 0; j + 1 < ids.size(); j++) add(ids[j], ids[j + 1], 0);
            }
            if (b[i] == w) {
                int cur = a[i];
                vector<int> ids;
                while (cur != w) {
                    ids.pb(id[cur]);
                    cur = up[cur][0];
                }
                for (int j = 0; j + 1 < ids.size(); j++) add(ids[j], ids[j + 1], 0);
            }
            if (a[i] != w && b[i] != w) {
                vector<int> wa, wb;
                int cur = a[i];
                while (cur != w) {
                    wa.pb(id[cur]);
                    cur = up[cur][0];
                }
                cur = b[i];
                while (cur != w) {
                    wb.pb(id[cur]);
                    cur = up[cur][0];
                }
                for (int j = 0; j + 1 < wa.size(); j++) add(wa[j], wa[j + 1], 0);
                for (int j = 0; j + 1 < wb.size(); j++) add(wb[j], wb[j + 1], 0);
                add(wa.back(), wb.back(), 1);
            }
        }
        for (int i = 0; i < n - 1; i++) {
            if (!us[i]) {
                cl[i] = 0;
                paint(i);
            }
        }
        for (int i = 0; i < n - 1; i++) {
            for (auto e : G[i]) {
                if ((cl[i] ^ cl[e.x]) != e.y) {
                    cout << -1 << '\n';
                    return 0;
                }
            }
        }
        for (int i = 0; i < n - 1; i++) {
            if (cl[i]) gg[ed[i].x].pb(ed[i].y); else gg[ed[i].y].pb(ed[i].x);
        }
        memset(dp, 255, sizeof(dp));
        int mx = 0;
        for (int i = 0; i < n; i++) mx = max(mx, get(i));
        cout << mx << '\n';
        for (int i = 0; i < n; i++) cout << get(i) << " ";
        return 0;
    }
    int ansmx = -1;
    for (int mask = 0; mask < (1 << m); mask++) {
        memset(f1, 0, sizeof(f1));
        memset(f2, 0, sizeof(f2));
        for (int i = 0; i < m; i++) {
            memset(pr, 255, sizeof(pr));
            memset(id, 255, sizeof(id));
            dfs(a[i]);
            int cur = b[i];
            while (pr[cur] != -1) {
                if ((mask >> i) & 1) {
                    if (cur > pr[cur]) f1[id[cur]] = 1; else f2[id[cur]] = 1;
                } else {
                    if (cur < pr[cur]) f1[id[cur]] = 1; else f2[id[cur]] = 1;
                }
                cur = pr[cur];
            }
        }
        bool ok = 1;
        for (int i = 0; i < n - 1; i++) {
            if (f1[i] && f2[i]) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            for (int i = 0; i < n; i++) gg[i].clear();
            for (int i = 0; i < n - 1; i++) {
                if (f1[i]) gg[ed[i].y].pb(ed[i].x);
                if (f2[i]) gg[ed[i].x].pb(ed[i].y);
            }
            memset(dp, 255, sizeof(dp));
            int mx = 0;
            for (int i = 0; i < n; i++) mx = max(mx, get(i));
            if (ansmx == -1 || mx < ansmx) {
                ansmx = mx;
                for (int i = 0; i < n; i++) ans[i] = get(i);
            }
        }
    }
    cout << ansmx << '\n';
    if (ansmx != -1) for (int i = 0; i < n; i++) cout << ans[i] << " ";
    return 0;
}
