#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

/*
vector<int> t;
vector<int> tree2;

void push(int v)
{
    tree2[2 * v + 1] = tree2[v];
    tree2[2 * v + 2] = tree2[v];
    //tree[v] = tree2[v];
}

int get(int v, int tl, int tr, int l, int r)
{
    if (l >= r)
    {
        return 0;
    }
    if (l == tl && r == tr)
    {
        return t[v];
    }
    if (l >= tr)
    {
        return 0;
    }
    if (r <= tl)
    {
        return 0;
    }
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, l, min(tm, r)) + get(2 * v + 2, tm, tr, max(l, tm), r);
}

void upd(int v, int tl, int tr, int pos, int val)
{
    if (pos < tl)
    {
        return;
    }
    if (pos >= tr)
    {
        return;
    }
    if (tl == tr - 1)
    {
        t[v] = val;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v + 1, tl, tm, pos, val);
    upd(2 * v + 2, tm, tr, pos, val);
}

vector<vector<int> > graph;
vector<int> used;


void dfs(int v, int p)
{
    if (used[v])
    {
        return;
    }
    used[v] = 1;
    for (int i = 0; i < graph[v].size(); ++i)
    {
        dfs(graph[v][i], v);
    }
}

vector<int> z_func(string s)
{
    int n = s.size();
    vector<int> z;
    for (int i = 1, l = 0, r = 0; i < n; ++i)
    {
        if (i <= r)
        {
            z[i] = min(r - i + 1, z[i - l]);
        }
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
        {
            z[i]++;
        }
        if (i + z[i] > r)
        {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}


void mask()
{
    int gg = 30;
    for (int i = 0; i < ((long long)1 << gg); ++i)
    {
        vector<int> used(gg);
        int tmp = i;
        for (int h = gg - 1; h >= 0; --h)
        {
            if (tmp >= ((long long)1 << h))
            {
                tmp -= ((long long)1 << h);
                used[h] = 1;
            }
        }
    }
}
*/

vector<int> hash_func(string s)
{
    int n = s.size();
    int p = 179;
    vector<int> hf(n);
    vector<int> p_pow(n);
    p_pow[0] = 1;
    for (int i = 1; i < n; ++i)
    {
        p_pow[i] = p_pow[i - 1] * p;
        p_pow[i] %= MOD;
    }
    hf[0] = (p_pow[0] * s[0]) % MOD;
    for (int i = 1; i < n; ++i)
    {
        hf[i] = (p_pow[i] * s[i] + hf[i - 1]) % MOD;
    }
    return hf;
}





signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int p = 179;
    vector<int> p_pow(n);
    p_pow[0] = 1;
    for (int i = 1; i < n; ++i)
    {
        p_pow[i] = p_pow[i - 1] * p;
        p_pow[i] %= MOD;
    }
    vector<int> hf1 = hash_func(s);
    reverse(s.begin(), s.end());
    vector<int> hf2 = hash_func(s);
    int cnt = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; j += 2)
        {
            int m = (i + j) / 2;
            int g = hf2[m] + MOD;
            if (i > 0)
            {
                g -= hf2[i - 1];
            }
            g %= MOD;
            int g2 = hf1[n - i - 1] + MOD;
            g2 -= hf1[n - m - 2];
            g2 %= MOD;
            int g3 = hf2[j] + MOD;
            g3 -= hf2[m];
            g3 %= MOD;
            int g4 = hf1[n - m - 2] + MOD;
            if (j < n - 1)
            {
                g4 -= hf1[n - j - 2];
            }
            g4 %= MOD;
            if ((((g * p_pow[n - m - 1]) % MOD) == ((g2 * p_pow[i]) % MOD)) && (((g3 * p_pow[n - j - 1]) % MOD) == ((g4 * p_pow[m + 1]) % MOD)))
            {
                //cout << i << ' ' << j << endl;
                cnt++;
            }

        }
    }
    cout << cnt;
    return 0;
}
