#include <bits/stdc++.h>
#define int long long
#define all(x) (x).begin(), (x).end()
#define F first
#define pb push_back
#define S second
#define len(x) (int)(x).size()
using namespace std;
const int maxn = 5e5 + 5;
const int lg = 21;
const int mod = 1e9 + 7;
const int INF = 1e18 + 1;
int n, m, t;
vector<int>g[maxn];
int ans[maxn];
int d[maxn];
vector<pair<int, int> >z;
int up[maxn][lg];
int par[maxn];
vector<vector<int> >paths;
void dfs(int v, int p = 0, int dp = 0) {
    up[v][0] = p;
    par[v] = p;
    for (int i = 1; i < lg; i++) up[v][i] = up[up[v][i - 1]][i - 1];
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v, dp + 1);
    }
}
int lca(int a, int b) {
    if (d[a] < d[b]) swap(a, b);
    for (int i = lg - 1; i >= 0; i--) {
        if (d[a] - (1 << i) >= d[b]) a = up[a][i];
    }
    if (a == b) return a;
    for (int i = lg - 1; i >= 0; i--) {
        if (up[a][i] != up[b][i]) {
            a = up[a][i];
            b = up[b][i];
        }
    }
    return up[a][0];
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].pb(v - 1);
        g[v - 1].pb(u - 1);
    }
    for (int i = 0; i < n; i++) ans[i] = 1;
    dfs(0);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        int lc = lca(a, b);
        int nw = a;
        vector<int>aa, bb;
        while (nw != lc) {
            aa.pb(nw);
            nw = par[nw];
        }
        aa.pb(lc);
        nw = b;
        while (nw != lc) {
            bb.pb(nw);
            nw = par[nw];
        }
        reverse(all(bb));
        for (auto ii : bb) aa.pb(ii);
        paths.pb(aa);
        int nz = 0;
        for (auto ii : aa) ans[ii] = ++nz;
    }
    int mx = 0;
    for (int i = 0; i < n; i++) mx = max(mx, ans[i]);
    cout << mx << '\n';
    if (t) for (int i = 0; i < n; i++) cout << ans[i] << ' ';
    return 0;
}
