#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 105, M = 105, C = 105;

int n, m;
vector<int> g[N];
pii lines[M];

int from[N], tin[N], tout[N], timer = 0;

void dfs0(int v, int pr) {
    tin[v] = timer++;
    for (int &u : g[v]) if (u != pr) {
        from[u] = v;
        dfs0(u, v);
    }
    tout[v] = timer++;
}

bool is_anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

vector<int> get_path(int v, int u, int i) {
    vector<int> path = {v};
    while (!is_anc(v, u)) {
        v = from[v];
        path.pb(v);
    }
    vector<int> up;
    while (v != u) {
        up.pb(u);
        u = from[u];
    }
    for (int i = sz(up) - 1; i > -1; --i) {
        path.pb(up[i]);
    }
    return path;
}

vector<int> path[M];

int c[N], mx_color = C, ans[N];

void rec(int v) {
    if (v == n + 1) {
        bool flag1 = true, flag2 = true;
        for (int i = 1; i <= m; ++i) {
            for (int j = 1; j < sz(path[i]); ++j) {
                if (c[path[i][j]] <= c[path[i][j - 1]]) {
                    flag1 = false;
                }
                if (c[path[i][j]] >= c[path[i][j - 1]]) {
                    flag2 = false;
                }
            }
            if (!flag1 && !flag2) {
                return;
            }
        }
        int curr_mx = *max_element(c + 1, c + n + 1);
        if (curr_mx < mx_color) {
            mx_color = curr_mx;
            for (int i = 1; i <= n; ++i) {
                ans[i] = c[i];
            }
        }
        return;
    }
    for (int i = 1; i < min(n + 2, mx_color); ++i) {
        c[v] = i;
        rec(v + 1);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int type;
    cin >> n >> m >> type;
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        g[v].pb(u);
        g[u].pb(v);
    }
    dfs0(1, 1);
    for (int i = 1; i <= m; ++i) {
        cin >> lines[i].x >> lines[i].y;
        path[i] = get_path(lines[i].x, lines[i].y, i);
    }
    rec(1);
    if (mx_color == C) {
        cout << "-1\n";
        return 0;
    }
    cout << mx_color << "\n";
    if (type == 1) {
        for (int v = 1; v <= n; ++v) {
            cout << ans[v] << " ";
        }
        cout << "\n";
    }

    return 0;
}
