#include <bits/stdc++.h>
using namespace std;
vector<vector<int> > g(1000000, vector<int>());
set<int> q;
int tin[1000000], tout[1000000], times = 0;
int p[1000000][30];
void dfs(int v, int pr)
{
    tin[v] = times++;
    p[v][0] = pr;
    for (auto u: g[v])
    {
        if (u != pr) dfs(u, v);
    }
    tout[v] = times++;
}
bool is_ansector(int a, int b)
{
    return (tin[a] <= tin[b] && tout[b] <= tout[a]);
}
int lca(int a, int b)
{
    if (is_ansector(a, b)) return a;
    if (is_ansector(b, a)) return b;
    int K = 29;
    while (K >= 0)
    {
        int w = p[a][K];
        if (!is_ansector(w, b))
        {
            a = w;
        }
        K--;
    }
    return p[a][0];
}
int min_ans = 1000000000;
vector<pair<int, int> > puty;
int ans[1000000];
void f1()
{
    for (int i = 0; i < puty.size(); ++i)
    {
        int a = puty[i].first;
        int b = puty[i].second;
        int w = lca(a, b);
        int start = 1;
        while (a != w)
        {
            ans[a] = start++;
            a = p[a][0];
        }
        ans[w] = start++;
        vector<int> por;
        while (b != w)
        {
            por.push_back(b);
            b = p[b][0];
        }
        reverse(por.begin(), por.end());
        for (int j = 0; j < por.size(); ++j)
        {
            ans[por[j]] = start++;
        }
        min_ans = min(min_ans, start - 1);
    }
}
int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    bool group45 = true;
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1);
    p[0][0] = 0;
    for (int i = 1; i < 30; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            p[j][i] = p[p[j][i - 1]][i - 1];
        }
    }
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        int w = lca(a, b);
        puty.push_back({a, b});
        //cout << a + 1 << ' ' << b + 1 << ' ' << w + 1 << endl;
        while (a != w)
        {
            if (q.find(a) != q.end()) group45 = false;
            q.insert(a);
            a = p[a][0];
        }
        while (b != w)
        {
            if (q.find(b) != q.end()) group45 = false;
            q.insert(b);
            b = p[b][0];
        }
    }
    if (group45)
    {
        cout << 7 / 0;
        f1();
    }
    cout << min_ans << endl;
    for (int i = 0; i < n; ++i) cout << ans[i] << ' ';
    return 0;
}

