#include <bits/stdc++.h>

using namespace std;

const int N = 1000;

int root = -1;

vector<int> c(N, 1);
vector<int> g[N];
bool dfs(int v, int p, int finish, int depth) {
    if (v == finish) {
        c[v] = depth;
        return true;
    }

    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }

        bool cur = dfs(u, v, finish, depth + 1);
        if (cur) {
            c[v] = depth;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m, t;

    cin >> n >> m >> t;

    vector<int> cnt(n, 0);

    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    vector<pair<int, int>> tunn;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        cnt[v]++;
        cnt[u]++;
        tunn.emplace_back(v, u);
        if (cnt[v] == m) {
            root = v;
        } else if (cnt[u] == m) {
            root = u;
        }
    }

    if (root == -1) {
        cout << -1;
    } else {
        for (auto cur : tunn) {
            int v = cur.first;
            int u = cur.second;

            if (v == root) {
                dfs(v, -1, u, 1);
            } else {
                dfs(u, -1, v, 1);
            }
        }
    }

    int res = 1;
    for (int i = 0; i < n; ++i) {
        res = max(c[i], res);
    }

    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << c[i] << ' ';
    }

}