#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
/*
int get(int i) {
	int ans = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		ans += f[i];
	return ans;
}
void add(int i, int x) {
	for (; i < MAXN; i |= (i + 1))
		f[i] += x;
}
*/
const int MAXN = 5e5 + 7, LOG = 20;
int par[MAXN], rnk[MAXN], root[MAXN], h[MAXN];
int get(int v) {
	if (par[v] == v)
		return v;
	return par[v] = get(par[v]);
}
void merge(int a, int b) {
	a = get(a), b = get(b);
	if (a == b)
		return;
	if (rnk[a] > rnk[b])
		swap(a, b);
	par[a] = b;
	if (h[root[a]] < h[root[b]])
		root[b] = root[a];
	if (rnk[a] == rnk[b])
		++rnk[b];
}
vector<int> g[MAXN], gt[MAXN], g2[MAXN], g2t[MAXN];
int cmp[MAXN], p[MAXN], tin[MAXN], tout[MAXN], tim = 0;
void dfs(int v, int pr) {
	h[v] = (pr == v ? 0 : h[pr] + 1);
	p[v] = pr;
	tin[v] = tim++;
	for (int u : g[v])
		if (u != pr)
			dfs(u, v);
	tout[v] = tim++;
}
int up(int v, int u) {
	return tin[v] <= tin[u] && tout[u] <= tout[v];
}
int clr[MAXN];
bool half;
void dfsc(int v, int c) {
	clr[v] = c;
	for (int u : gt[v])
		if (clr[u] == -1)
			dfsc(u, c ^ 1);
		else if (clr[u] == clr[v])
			half = 0;
}
int d[MAXN], vis[MAXN];
vector<int> topsort;
void dfst(int v) {
	vis[v] = 1;
	for (int u : g2[v])
		if (!vis[u])
			dfst(u);
	topsort.push_back(v);
}
void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dfs(0, 0);
	iota(par, par + n, 0);
	vector<pair<int, int>> elist;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		for (int it = 0; it < 2; ++it) {
			int v = a;
			while (!up(p[v], b)) {
				merge(p[v], a);
				v = p[v];
			}
			swap(a, b);
		}
		if (!up(a, b) && !up(b, a))
			elist.push_back({ a, b });
	}
	for (auto e : elist)
		gt[get(e.x)].push_back(get(e.y)),
		gt[get(e.y)].push_back(get(e.x));
	fill(clr, clr + n, -1);
	half = 1;
	for (int i = 0; i < n; ++i)
		if (clr[i] == -1)
			dfsc(i, 0);
	for (int i = 1; i < n; ++i)
		clr[i] = clr[get(i)];
	if (!half) {
		cout << "-1\n";
		return;
	}
	for (int i = 1; i < n; ++i) {
		int a = i, b = p[i];
		if (clr[get(i)])
			swap(a, b);
		g2[a].push_back(b);
		g2t[b].push_back(a);
	}
	for (int i = 0; i < n; ++i)
		if (!vis[i])
			dfst(i);
	reverse(topsort.begin(), topsort.end());
	for (int v : topsort)
		for (int u : g2t[v])
			d[v] = max(d[v], d[u] + 1);
	cout << *max_element(d, d + n) + 1 << "\n";
	for (int i = 0; i < n; ++i)
		cout << d[i] + 1 << " ";
	return;
}
/*
3 1 1 
1 2 
2 3 
1 3


4 3 0
1 2
1 3 
1 4 
2 3
2 4 
3 4
*/
signed main() {
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}