#ifdef DEBUG
    //#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long

int n, m, t;

vector<vector<int>> newv, revv, v;
vector<int> ans;

bool dfs_build(int u, int pr, int to) {
    if (u == to) {
        return 1;
    }
    for (int i : v[u]) {
        if (i != pr) {
            if (dfs_build(i, u, to)) {
                newv[u].emplace_back(i);
                return 1;
            }
        }
    }
    return 0;
}

void dfs_update(int u, int deep = 1, int pr = -1) {
    ans[u] = max(ans[u], deep);
    for (int i : revv[u]) {
        if (i != pr)
            dfs_update(i, deep + 1, u);
    }
}

bool dfs_check(int u, int pr, int to) {
    if (u == to)
        return 1;
    for (int i : newv[u]) {
        if (ans[u] > ans[i]) {
            if (dfs_check(i, u, to))
                return 1;
        }
    }
    return 0;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    cin >> n >> m >> t;
    v.resize(n);
    newv.resize(n);
    revv.resize(n);
    ans.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int fr, to;
        cin >> fr >> to;
        fr--, to--;
        v[fr].emplace_back(to);
        v[to].emplace_back(fr);
    }

    vector<pair<int, int>> q(m);
    for (int i = 0; i < m; ++i) {
        int fr, to;
        cin >> fr >> to;
        fr--, to--;
        q[i] = {fr, to};
        dfs_build(fr, -1, to);
    }

    vector<int> stocks;
    for (int i = 0; i < n; ++i) {
        if (newv[i].size() == 0)
            stocks.emplace_back(i);
        for (int j : newv[i]) {
            //cout << i << " to " << j << endl;
            revv[j].emplace_back(i);
        }
    }

    for (int i : stocks) {
        dfs_update(i);
    }

    for (auto i : q) {
        if (!dfs_check(i.first, -1, i.second)) {
            cout << -1;
            return 0;
        }
    }

    int res = 0;
    for (int i = 0; i < n; ++i)
        res = max(res, ans[i]);
    cout << res << '\n';
    for (int i : ans)
        cout << res - i + 1 << ' ';
    return 0;
}
