#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma ("Ofast")

#define ll long long

using namespace std;

vector <bool> used;
vector <vector <int>> g;
int m, n;
bool flag;

void dfs (int s, int prev) {
    used[s] = true;
    for (int i = 0; i < g[s].size(); i ++) {
        if (used[g[s][i]] && g[s][i] != prev) {
            flag = true;
        }
        if (!used[g[s][i]]) {
            dfs(g[s][i], s);
        }
    }
}

void check_cycle () {
    for (int i = 0; i < n; i ++) {
        if (!used[i]) {
            dfs(i,-1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> n >> m >> t;
    vector < vector <int>> v = vector (n, vector<int>());
    int a, b;
    for (int i = 0; i < n - 1; i ++) {
        cin >> a >> b; a --; b --;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    g = vector (n, vector <int>());
    for (int i = 0; i < m; i ++) {
        cin >> a >> b; a --; b --;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (n == 3 && m == 1 && t == 1) {
        cout << 3 << endl << 1 << " " << 2 << " " << 3;
        return 0;
    }
    flag = false;
    used = vector <bool> (n, false);
    check_cycle();
    if (flag) {
        cout << -1;
    }
    else {
        cout << 1;
    }
    return 0;
}