// lolkekstl.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <sstream>
#include <queue>
#include <deque>
#include <iomanip>
#include <fstream>
#include <bitset>
#include <stack>

using namespace std;
//ifstream fin("lol.txt");
//ofstream fout("kek.txt");
bool DEBUG = false;

vector<vector<int> > graph;
vector<vector<int> > paths;
vector<int> path;
vector<int> used;

vector<int> ans;
vector<int> n_ans;

bool find_path(int u, int t) {
    used[u] = 1;
    
    if (u == t) {
        path.push_back(u);
        return true;
    }
    for (auto i : graph[u]) {
        if (!used[i]) {
            if (find_path(i, t)) {
                path.push_back(u);
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n = 0, m = 0, t = 0, l = 0, r = 0, a = 0, b = 0;
    cin >> n >> m >> t;
    if (n <= 15 and m <= 15) {
        graph = vector<vector<int> >(n);
        for (int i = 0; i < n - 1; i++) {
            cin >> l >> r;
            l--;
            r--;
            graph[l].push_back(r);
            graph[r].push_back(l);
        }
        paths = vector< vector<int> > (m);
        ans = vector<int>(n, -1);
        n_ans = vector<int>(n, -1);
        int maxc = n * n+100;
        int nmaxc = 0;
        for (int i = 0; i < m; i++) {
            cin >> a >> b;
            a--, b--;
            path.clear();
            used = vector<int>(n, 0);
            find_path(a, b);
            paths[i] = path;
        }
        sort(paths.begin(), paths.end(), [](vector<int>& a, vector<int>& b) {
            return a.size() < b.size();
            });
        bitset<20> b;
        bool kl = false;
        for (int w = 0; w < (1 << m); w++) {
            b = w;
            bool kekjk = true;
            n_ans = vector<int>(n, -1);
            nmaxc = 0;
            for (int hhh = 0; hhh < n + 1 and kekjk; hhh++) {
                for (int j = 0; j < m; j++) {
                    if (b[j]) {
                        for (int hj = 0; hj < paths[j].size(); hj++) {
                            if (hj == 0) {
                                if (n_ans[paths[j][hj]] == -1) {
                                    n_ans[paths[j][hj]] = 1;
                                }
                            }
                            else {
                                n_ans[paths[j][hj]] = max(n_ans[paths[j][hj]], n_ans[paths[j][hj - 1]] + 1);
                            }
                        }
                    }
                    else {
                        for (int hj = paths[j].size() - 1; hj >= 0; hj--) {
                            if (hj == paths[j].size() - 1) {
                                if (n_ans[paths[j][hj]] == -1) {
                                    n_ans[paths[j][hj]] = 1;
                                }
                            }
                            else {
                                n_ans[paths[j][hj]] = max(n_ans[paths[j][hj]], n_ans[paths[j][hj + 1]] + 1);
                            }
                        }
                    }
                }
            }
            for (int j = 0; j < m and kekjk; j++) {
                if (b[j]) {
                    for (int hj = 1; hj < paths[j].size() and kekjk; hj++) {
                        if (n_ans[paths[j][hj]] <= n_ans[paths[j][hj - 1]]) {
                            kekjk = false;
                        }
                    }
                }
                else {
                    for (int hj = paths[j].size() - 2; hj >= 0 and kekjk; hj--) {
                        if (n_ans[paths[j][hj]] <= n_ans[paths[j][hj + 1]]) {
                            kekjk = false;
                        }
                    }
                }
            }
            kl |= kekjk;
            for (int i = 0; i < n; i++) {
                nmaxc = max(nmaxc, n_ans[i]);
            }
            if (kekjk and nmaxc < maxc) {
                maxc = nmaxc;
                swap(ans, n_ans);
            }
        }
        if (kl) {
            cout << maxc << "\n";
            for (int i = 0; i < n; i++) {
                if (ans[i] == -1) {
                    cout << 1 << " ";
                }
                else {
                    cout << ans[i] << " ";
                }
            }
        }
        else {
            cout << -1;
        }
    }
    else {
        return 0;
    }
}