#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;

int n;
vector<vector<int>> g;
vector<int> c;

vector<int> d;

void dfs2(int v, int p = -1) {
	for (int u : g[v]) {
		if (u != p) {
			d[u] = d[v] + 1;
			dfs2(u, v);
		}
	}
}

vector<int> path;

bool dfs(int v, int tar, int p = -1) {
	path.push_back(v);
	if (v == tar) {
		return true;
	}
	for (int u : g[v]) {
		if (u != p) {
			if (dfs(u, tar, v)) {
				return true;
			}
		}
	}
	path.pop_back();
	return false;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int m, t;
	cin >> n;
	cin >> m >> t;
	g.resize(n);
	c.resize(n, 1);
	for (int i = 1; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<pair<int, int>> arr(m);
	for (int i = 0; i < m; i++) {
		cin >> arr[i].first >> arr[i].second;
		arr[i].first--;
		arr[i].second--;
	}
	set<int> possible;
	if (m) {
		possible.insert(arr[0].first);
		possible.insert(arr[0].second);
	}
	for (int i = 1; i < m; i++) {
		int a = arr[i].first;
		int b = arr[i].second;
		set<int> newp;
		for (int el : possible) {
			if (el == a || el == b) {
				newp.insert(el);
			}
		}
		possible = newp;
	}
	if (!possible.empty()) {
		int v = *possible.begin();
		d.resize(n);
		dfs2(v);
		int ans = 1;
		for (int i = 0; i < m; i++) {
			int c = arr[i].first + arr[i].second - v;
			ans = max(ans, d[c] + 1);
		}
		cout << ans << endl;
		for (int i = 0; i < n; i++) {
			cout << min(ans, d[i] + 1) << " ";
		}
		cout << endl;
		return 0;
	}
	if (m <= 15 && n <= 15) {
		vector<int> best_c(n, -1);
		for (int mask = 0; mask < (1 << m); mask++) {
			c.assign(n, 1);
			for (int kek = 0; kek < n; kek++) {
				for (int i = 0; i < m; i++) {
					int a, b;
					a = arr[i].first;
					b = arr[i].second;
					if (mask & (1 << i)) {
						swap(a, b);
					}
					path.clear();
					assert(dfs(a, b));
					for (int i = 1; i < path.size(); i++) {
						c[path[i]] = max(c[path[i]], c[path[i - 1]] + 1);
					}
				}
			}
			for (int i = 0; i < m; i++) {
				int a = arr[i].first;
				int b = arr[i].second;
				if (mask & (1 << i)) {
					swap(a, b);
				}
				path.clear();
				assert(dfs(a, b));
				for (int i = 1; i < path.size(); i++) {
					if (c[path[i]] <= c[path[i - 1]]) {
						c.assign(n, -1);
						break;
					}
				}
				if (c[0] == -1) {
					break;
				}
			}
			if (best_c[0] == -1) {
				best_c = c;
			} else if (c[0] != -1 && *max_element(c.begin(), c.end()) <= *max_element(best_c.begin(), best_c.end())) {
				best_c = c;
			}
		}
		c = best_c;
		cout << *max_element(c.begin(), c.end()) << endl;
		if (c[0] == -1) {
			return 0;
		}
		for (int i = 0; i < n; i++) {
			cout << c[i] << " ";
		}
		cout << endl;
		return 0;
	}
	vector<int> best_c(n, -1);

	c.assign(n, 1);
	vector<int> cnt_in(n);
	vector<vector<int>> g2(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		a = arr[i].first;
		b = arr[i].second;
		path.clear();
		assert(dfs(a, b));
		for (int i = 1; i < path.size(); i++) {
			g2[path[i - 1]].push_back(path[i]);
			used[path[i]] = 1;
			cnt_in[path[i]]++;
		}
	}

	queue<int> q;
	for (int i = 0; i < n; i++) {


	for (int i = 0; i < m; i++) {
		int a = arr[i].first;
		int b = arr[i].second;
		path.clear();
		assert(dfs(a, b));
		for (int i = 1; i < path.size(); i++) {
			if (c[path[i]] <= c[path[i - 1]]) {
				c.assign(n, -1);
				break;
			}
		}
		if (c[0] == -1) {
			break;
		}
	}
	if (best_c[0] == -1) {
		best_c = c;
	} else if (c[0] != -1 && *max_element(c.begin(), c.end()) <= *max_element(best_c.begin(), best_c.end())) {
		best_c = c;
	}
	c = best_c;
	cout << *max_element(c.begin(), c.end()) << endl;
	if (c[0] == -1) {
		return 0;
	}
	for (int i = 0; i < n; i++) {
		cout << c[i] << " ";
	}
	cout << endl;
	return 0;

}

