#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define MAXN 500005
int br, lines, t;
vector<int> tree[MAXN];
vector<int> graph[MAXN];
int depth[MAXN], parent[MAXN], result[MAXN], maximum;
void calcd(int vertex, int dep, int p){
	parent[vertex] = p; depth[vertex] = dep;
	for(int i : tree[vertex]){
		if(i != p){
			calcd(i, dep + 1, vertex);
		}
	}
}
vector<int>* one, *two;
inline void operation(int from, int to){
	one = new vector<int>(); two = new vector<int>();
	while(depth[from] > depth[to]){
		one->push_back(from); from = parent[from];
	}
	while(depth[to] > depth[from]){
		two->push_back(to); to = parent[to];
	}
	while(from != to){
		one->push_back(from); from = parent[from];
		two->push_back(to); to = parent[to];
	}
    one->push_back(to);
    int cnt = 1;
	for(int i = 0; i < one->size(); ++i){
		maximum = max(maximum, cnt);
		result[(*one)[i]] = cnt; ++cnt;
	}
	for(int i = two->size() - 1; i >= 0; --i){
		maximum = max(maximum, cnt);
		result[(*two)[i]] = cnt; ++cnt;
	}
}
int main(){
	cin.tie(0); ios::sync_with_stdio(false);
	maximum = 1;
	cin >> br >> lines >> t;
	for(int i = 0; i < br - 1; ++i){
		int from, to; cin >> from >> to;
		tree[from].push_back(to); tree[to].push_back(from);
	}
	calcd(1, 1, 0);
	for(int i = 0; i < lines; ++i){
		int from, to; cin >> from >> to;
		operation(from, to);
	}
	cout << maximum << endl;
	for(int i = 1; i <= br; ++i){
		if(result[i] == 0) cout << 1 << ' ';
		else cout << result[i] << ' ';
	}
	cout << endl;
	return 0;
}
