#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

struct remem
{
    int line;
    int num;
};

vector <vector <int> > edges;
vector <vector <int> > lines;
vector <bool> used;
vector <int> p;
vector <int> ans;

void dfs(int v, int f, int s, int num)
{
    used[v] = true;
    if (v == f)
    {
        for (int i = f; i != s; i = p[i])
        {
            lines[num].push_back(i);
        }
        lines[num].push_back(s);
        return;
    }
    for (int i = 0; i < edges[v].size(); i++)
    {
        if  (!used[edges[v][i]])
        {
            p[edges[v][i]] = v;
            dfs(edges[v][i], f, s, num);
        }
    }
}


int main()
{
    int n, m, t, i, j, a, b;
    cin >> n >> m >> t;
    vector <bool> used2(n, false);
    vector <int> p2(n, -1);
    edges.resize(n);
    for (i = 0; i < n - 1; i++)
    {
        cin >> a >> b;
        a--; b--;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    lines.resize(m);
    for (i = 0; i < m; i++)
    {
        cin >> a >> b;
        a--; b--;
        if (a < b)
            swap(a, b);
        used = used2;
        p = p2;
        dfs(a, b, a, i);
    }
    ans.resize(n, 1);
    ans[lines[0][0]] = 1;
    int maxi = 0;
    for (i = 0; i < lines.size(); i++)
    {
        for (j = 1; j < lines[i].size(); j++)
        {
            ans[lines[i][j]] = ans[lines[i][j - 1]] + 1;
            maxi = max(maxi, ans[lines[i][j]]);
        }
    }
    cout << maxi << endl;
    for (i = 0; i < ans.size(); i++)
    {
        cout << ans[i] << " ";
    }
    return 0;
}
