#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
#define fst first
#define snd second
#define sz(X) (int)(X.size())
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MOD = 1e9 + 7;
const int N = 15;

int n, m, t;
vi path[N];

inline void gen(vi a, int mx) {
    if (sz(a) == n) {
        bool ok = true;
        forn(i, m) {
            int d = a[path[i][1]] - a[path[i][0]];
            forab(j, 1, sz(path[i])) {
                if (d * (a[path[i][j]] - a[path[i][j - 1]]) <= 0) {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
        }
        if (ok) {
            cout << mx + 1 << "\n";
            for (int x : a) cout << x + 1 << " ";
            exit(0);
        }
    } else {
        forn(i, n) {
            a.pb(i);
            gen(a, max(mx, i));
            a.pop_back();
        }
    }
}

vi g[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    int u, v;
    forn(i, n - 1) {
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    forn(i, m) {
        cin >> u >> v;
        u--, v--;
        vi p(n, -1);
        queue<int> q;
        q.push(u);
        p[u] = u;
        while (p[v] == -1) {
            int x = q.front();
            q.pop();
            for (int y : g[x]) {
                if (p[y] != -1) continue;
                p[y] = x;
                q.push(y);
            }
        }
        while (v != p[v]) {
            path[i].pb(v);
            v = p[v];
        }
        path[i].pb(u);
    }
    gen(vi(), -1);
    cout << "-1\n";
    return 0;
}