#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

int n, m, t;
vector <vector <int> > gr;
vector <int> c;

void bfs(int s, int f) {
    vector <int> par(n, -1);
    queue <int> q;
    q.push(s);
    par[s] = s;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int to : gr[x]) {
            if (par[to] == -1) {
                par[to] = x;
                q.push(to);
            }
        }
    }
    vector <int> road;
    int now = f;
    while (par[now] != now) {
        road.push_back(now);
        now = par[now];
    }
    road.push_back(s);
    reverse(road.begin(), road.end());
    for (int i = 0; i < (int)road.size(); i++)
        c[road[i]] = i + 1;
   /* if (!c[road[0]])
        c[road[0]] = 1;
    for (int i = 1; i < (int)road.size(); i++) {
        if (!c[road[i]])
            c[road[i]] = c[road[i - 1]] + 1;
        else {
            if ()
        }
    }*/
}

int32_t main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> t;
    gr.resize(n);
    c.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector <pair <int, int> > all;
    vector <int> used(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        all.push_back({a, b});
        used[a]++;
        used[b]++;
    }
    int st = -1;
    for (int i = 0; i < n; i++) {
        if (used[i] == m)
            st = i;
    }
    for (auto el : all) {
        int a = el.first, b = el.second;
        if (used[b] == m)
            swap(a, b);
        bfs(a, b);
    }
    int max_el = 0;
    for (int i = 0; i < n; i++) {
        if (!c[i])
            c[i] = 1;
        max_el = max(max_el, c[i]);
    }
    cout << max_el << "\n";
    for (auto el : c)
        cout << el << " ";
    cout << "\n";
    return 0;
}
