#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N = 20;
int n, m, tp;
vector<int> g[N];
int a[N], b[N], cur[N], ans[N];

vector<int> t[N], pth;
bool dfs(int v, int p, int to) {
    pth.push_back(v);
    if (v == to) {
        return true;
    }
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        if (dfs(u, v, to)) {
            return true;
        }
    }
    pth.pop_back();
    return false;
}
void path(int v, int u) {
    pth.clear();
    assert(dfs(v, -1, u));
    for (int i = 0; i + 1 < (int)pth.size(); ++i) {
        t[pth[i + 1]].push_back(pth[i]);
    }
}
int used[N];
bool topsort(int v) {
    used[v] = 1;
    cur[v] = 1;
    for (int u : t[v]) {
        if (used[u] == 1) {
            return false;
        }
        if (!used[u] && !topsort(u)) {
            return false;
        }
        cur[v] = max(cur[v], cur[u] + 1);
    }
    used[v] = 2;
    return true;
}

void solve(int msk) {
    fill_n(t, N, vector<int>());
    for (int i = 0; i < m; ++i) {
        if ((msk >> i) & 1) {
            path(a[i], b[i]);
        } else {
            path(b[i], a[i]);
        }
    }
    fill_n(used, N, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i] && !topsort(i)) {
            return;
        }
    }
    if (!ans[0] || *max_element(ans, ans + n) > *max_element(cur, cur + n)) {
        copy_n(cur, n, ans);
    }
}

main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> tp;
    for (int v, u, i = 0; i < n - 1; ++i) {
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i];
        --a[i];
        --b[i];
    }
    for (int msk = 0; msk < (1 << m); ++msk) {
        solve(msk);
    }
    if (!ans[0]) {
        cout << "-1\n";
    } else {
        cout << *max_element(ans, ans + n) << endl;
        for (int i = 0; i < n; ++i) {
            cout << ans[i] << " ";
        }
        cout << endl;
    }
}
