#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

const int N = 15;
vector<int> g[N], g2[N];
int pt[N], ord[N], used[N], num[N], res[N], bg[N], en[N];
int len = 0, ord_len = 0;

void dfs(int node, int anc, int fin) {
	pt[len++] = node;
	if (node == fin) {
		for (int i = 0; i < len - 1; i++) {
			g2[pt[i]].push_back(pt[i + 1]);
		}
	}
	for (int to : g[node]) {
		if (to != anc) {
			dfs(to, node, fin);
		}
	}
	len--;
}

bool walk(int node) {
	used[node] = 1;
	for (int to : g2[node]) {
		if (!used[to]) {
			if (walk(to))
				return true;
		}
		else if (used[to] == 1) {
			return true;
		}
	}
	ord[ord_len++] = node;
	used[node] = 2;
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, t;
	cin >> n >> m >> t;

	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	for (int i = 0; i < m; i++) {
		cin >> bg[i] >> en[i];
		bg[i]--;
		en[i]--;
	}

	int mx = n + 1;

	for (int i = 0; i < (1 << m); i++) {
		for (int j = 0; j < n; j++)
			g2[j].clear();

		for (int j = 0; j < m; j++) {
			if ((i >> j) & 1) {
				swap(bg[j], en[j]);
			}
			dfs(bg[j], -1, en[j]);
			if ((i >> j) & 1) {
				swap(bg[j], en[j]);
			}
		}

		ord_len = 0;
		fill(used, used + n, 0);
		bool impos = false;
		for (int j = 0; j < n; j++) {
			if (!used[j] && walk(j)) {
				impos = true;
				break;
			}
		}

		if (!impos) {
			// reverse(ord, ord + n);
			// for (int j = 0; j < n; j++) {
			// 	for (int to : g2[j]) {
			// 		cout <<  j + 1 << " " << to + 1 <<"\n";
			// 	}
			// }
			// for (int j = 0; j < n; j++) {
			// 	cout << ord[j] + 1 << " ";
			// }
			// cout << "\n";
			// cout << "\n";
			for (int j = 0; j < ord_len; j++) {
				num[ord[j]] = 0;
				for (int to : g2[ord[j]]) {
					num[ord[j]] = max(num[ord[j]], num[to]);
 				}
 				num[ord[j]]++;
			}
			int cur = 0;
			for (int j = 0; j < n; j++) {
				cur = max(cur, num[j]);
			}
			if (cur < mx) {
				mx = cur;
				for (int j = 0; j < n; j++)
					res[j] = num[j];
			}
		}
	}

	if (mx == n + 1) {
		cout << -1;
	}
	else {
		cout << mx << "\n";
		for (int i = 0; i < n; i++) {
			cout << res[i] << " ";
		}
	}

	return 0;
}