#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
//#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

bool dfs(int v, int f, vector<vii>& a, vii& e, int p = -1) {
	if (v == f)
		return 1;
	for (auto x : a[v]) {
		if (x.first == p)
			continue;
		e.pb({ x.second, x.first < v });
		if (dfs(x.first, f, a, e, v))
			return 1;
		e.pop_back();
	}
	return 0;
}

void dfs1(int v, vector<vii>& a, vector<int>& c, vector<int>& res) {
	res[v] = 1;
	for (auto x : a[v]) {
		if ((x.first < v) != c[x.second])
			continue;
		if (res[x.first] == -1)
			dfs1(x.first, a, c, res);
		res[v] = max(res[v], res[x.first] + 1);
	}
	return;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, t;
	cin >> n >> m >> t;
	vector<vii> a(n);
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		a[u].pb({ v , i });
		a[v].pb({ u, i });
	}
	vector<vii> e(m);
	fi(m) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		dfs(u, v, a, e[i]);
	}
	int minn = INF;
	vector<int> ans(n);
	for (int mask = 0; mask < (1 << m); ++mask) {
		vector<int> c(n - 1, -1);
		bool flag = 1;
		for (int i = 0; i < m; ++i) {
			for (auto x : e[i]) {
				int c1 = x.second;
				if (mask & (1 << i))
					c1 = 1 - c1;
				if (c[x.first] != -1 && c[x.first] != c1) {
					flag = 0;
					break;
				}
				c[x.first] = c1;
			}
			if (!flag)
				break;
		}
		if (!flag)
			continue;
		vector<int> res(n, -1);
		fi(n) {
			if (res[i] == -1)
				dfs1(i, a, c, res);
		}
		int maxx = 0;
		fi(n)
			maxx = max(maxx, res[i]);
		if (maxx < minn) {
			minn = maxx;
			ans = res;
		}
	}
	if (minn == INF)
		cout << -1;
	else {
		cout << minn << endl;
		for (int i = 0; i < n; ++i)
			cout << ans[i] << ' ';
	}

	return 0;
}