#ifdef DEBUG
    //#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long
const int inf = 1e9;

int n, m, t;
int Mans = inf;

vector<vector<int>> newv, revv, v;
vector<pair<int, int>> q;
vector<int> ans;
vector<int> res;

bool dfs_build(int u, int pr, int to) {
    if (u == to) {
        return 1;
    }
    for (int i : v[u]) {
        if (i != pr) {
            if (dfs_build(i, u, to)) {
                newv[u].emplace_back(i);
                return 1;
            }
        }
    }
    return 0;
}

void dfs_update(int u, int deep = 1, int pr = -1) {
    ans[u] = max(ans[u], deep);
    for (int i : revv[u]) {
        if (i != pr)
            dfs_update(i, deep + 1, u);
    }
}

bool dfs_check(int u, int pr, int to) {
    if (u == to)
        return 1;
    for (int i : v[u]) {
        if (res[u] > res[i] && i != pr) {
            if (dfs_check(i, u, to))
                return 1;
        }
    }
    return 0;
}

void solve(int len) {
    if (len == n) {
        for (auto i : q) {
            if (!dfs_check(i.first, -1, i.second))
                return;
        }
        int Max = 0;
        for (int i : res)
            Max = max(Max, i);
        if (Max < Mans) {
            Mans = Max;
            ans = res;
        }
        return;
    }
    for (int i = 1; i <= n + 1; ++i) {
        res.emplace_back(i);
        solve(len + 1);
        res.pop_back();
    }
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    cin >> n >> m >> t;
    v.resize(n);
    newv.resize(n);
    revv.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int fr, to;
        cin >> fr >> to;
        fr--, to--;
        v[fr].emplace_back(to);
        v[to].emplace_back(fr);
    }

    q.resize(m);
    for (int i = 0; i < m; ++i) {
        int fr, to;
        cin >> fr >> to;
        fr--, to--;
        q[i] = {fr, to};
        //dfs_build(fr, -1, to);
    }

    solve(0);
    if (Mans == inf) {
        cout << -1;
    } else {
        cout << Mans << '\n';
        for (int i : ans)
            cout << Mans - i + 1 << ' ';
    }
    return 0;
}
