#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, 10);

const int N = 500003;
int n, m, t, col[N];
vector <int> q[N], g[N];

stack <int> st;
bool found = false;

void go(int v, int p, int f) {
    st.push(v);
//    cerr << "go " << v << ' ' << p << '\n';
    if (v == f) {
        int last = -1;
//        cerr << "found\n";
        found = true;
        while (!st.empty()) {
            if (last != -1) {
                g[st.top()].pb(last);
            }
//            cerr << "st top " << st.top() << '\n';
            last = st.top();
            st.pop();
        }
        return;
    }
    for (auto to : q[v]) {
        if (to == p) {
            continue;
        }
        go(to, v, f);
    }
    if (!found) {
        st.pop();
    }
}

int used[N];
vector <int> ord;

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (used[to] == 1) {
//            cerr << "v to " << v << ' ' << to << '\n';
            cout << -1;
            exit(0);
        }
        if (used[to] == 0) {
            dfs(to);
        }
    }
    used[v] = 2;
    ord.pb(v);
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    cin >> n >> m >> t;
    int x, y;
    for (int i = 1; i <= n - 1; i++) {
        cin >> x >> y;
        q[x].pb(y);
        q[y].pb(x);
    }
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        found = false;
        go(x, x, y);
        while (!st.empty()) {
            st.pop();
        }
    }
    for (int i = 1; i <= n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    reverse(all(ord));
    for (auto i : ord) {
//        cerr << i << '\n';
        for (auto to : g[i]) {
            col[to] = max(col[to], col[i] + 1);
        }
    }
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        cnt = max(cnt, col[i] + 1);
    }
    cout << cnt << '\n';
    for (int i = 1; i <= n; i++) {
        cout << col[i] + 1 << ' ';
    }
}
