#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, INF = 1e9;

mt19937 rnd(time(0));

int n, m, t, a, b;
int64_t d[N];
vector<pair<int,int>> vth;
vector<vector<int>> g;

inline void read(){
    cin >> n >> m >> t;
    g.resize(n+1);
    vth.resize(m);
    for(int i = 0; i < n-1; ++i){
        cin >> a >> b;
        g[a].pb(b);
        g[b].pb(a);
    }
    for(auto& i: vth)
        cin >> i.F >> i.S;

}

bool finder(int v, int fin, int len = 1, int p = 0){
    if(v==fin){
        d[v] = len;
        return true;
    }
    for(int to: g[v]){
        if(to==p) continue;
        if(finder(to,fin,len+1,v)){
            if(find(ALL(g[to]),v)!=g[to].end()) g[to].erase(find(ALL(g[to]),v));
            d[v] = len;
            return true;
        }
    }
    return false;
}

inline void gg(){
    cout << -1;
    exit(0);

}
inline void solve_nm100(){
    for(const auto& i: vth){
        if(!finder(i.F,i.S)){
            gg();
        }
    }

}

inline void print(){
    cout << *max_element(d+1,d+1+n) << "\n";
    for(int i = 1; i <= n; ++i)
        cout << d[i] << " " ;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    if(n<=100 && m <=100){
        solve_nm100();
    }
    print();

    return 0;
}
