#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define add push_back
#define pw(x) (1ll << (x))
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
const ll INF = (ll)1e9 + 'b' + 'l' + 'i' + 'n' + 'k' + '-' + '1' + '8' + '2';

const int N = 16;
vector <int> gr[N], gr2[N], rgr2[N], order;
int pr[N], tin[N], tout[N], T, used[N], dp[N];
pair <int, int> q[N];

void dfs1(int v, int p) {
	tin[v] = T++;
	for (int u : gr[v]) {
		if (u != p) {
			pr[u] = v;
			dfs1(u, v);
		}
	}
	tout[v] = T++;
}

bool anc(int u, int v) {
	return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void paint(int a, int b) {
	while (!anc(a, b)) {
		gr2[a].add(pr[a]); rgr2[pr[a]].add(a); a = pr[a];
	}
	while (a != b) {
		gr2[pr[b]].add(b); rgr2[b].add(pr[b]); b = pr[b];
	}
}

bool dfs2(int v) {
	used[v] = 1;
	bool f = 0;
	for (int u : gr2[v]) {
		if (!used[u]) {
			f |= dfs2(u);
		} else {
			f |= (used[u] == 1);
		}
	}
	order.add(v);
	used[v] = 2;
	return f;
}

int calc(int n, int m, int mask) {
	for (int i = 0; i < n; i++) {
		gr2[i].clear(); rgr2[i].clear();
	}
	order.clear();
	memset(used, 0, sizeof(used));
	for (int i = 0; i < m; i++) {
		int a = q[i].f, b = q[i].s;
		if (mask & pw(i)) {
			swap(a, b);
		}
		paint(a, b);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i] && dfs2(i)) {
			return INF;
		}
	}
	reverse(all(order));
	int mx = 0;
	for (int v : order) {
		dp[v] = 1;
		for (int u : rgr2[v]) {
			dp[v] = max(dp[v], dp[u] + 1);
		}
		mx = max(mx, dp[v]);
	}
	return mx;
}

void mane() {
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].add(v); gr[v].add(u);
	}
	for (int i = 0; i < m; i++) {
		cin >> q[i].f >> q[i].s;
		q[i].f--; q[i].s--;
	}
	dfs1(0, -1);
	int ans = INF, bmask = -1;
	for (int mask = 0; mask < pw(m); mask++) {
		int res = calc(n, m, mask);
		if (res < ans) {
			ans = res; bmask = mask;
		}
	}
	if (ans == INF) {
		cout << -1;
		return;
	}
	cout << calc(n, m, bmask) << endl;
	for (int i = 0; i < n; i++) {
		cout << dp[i] << " ";
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	mane();
#ifdef osss
	cout << endl; cerr << endl << "\t max is the best" << endl;
#endif
}