#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

vector <vector <int>> g;
map <pair <int, int>, int> to;
int target;
vector <int> way;
vector <int> color;

bool dfs(int u, int p = -1) {
	bool fl = (u == target);
	for (auto v : g[u]) {
		if (p == v)
			continue;
		fl |= dfs(v, u);
	}
	if (fl) way.push_back(u);
	return fl;
}

bool color_edge(vector <int> &wayt) {
	for (int i = 1; i < len(wayt); i++) {
		int u = wayt[i - 1];
		int v = wayt[i];
		if (to[{min(u, v), max(u, v)}] == u)
			return false;
		to[{min(u, v), max(u, v)}] = v;
	}
	return true;
}

void recolor(vector <int> &wayt) {
	int par = 0;
	for (int i = 0; i < len(wayt); i++) {
		if (color[wayt[i]] <= par)
			color[wayt[i]] = par + 1;
		par = color[wayt[i]];
	}
}

bool tryway(vector <int> &wayt) {
	for (int i = 1; i < len(wayt); i++)
		if (color[wayt[i]] <= color[wayt[i - 1]])
			return false;
	return true;
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n, m, t;
	cin >> n >> m >> t;
	g.resize(n);
	color.resize(n, 1);

	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
		to[{min(u, v), max(u, v)}] = -1;
	}

	vector <pair <int, int>> ws(m);
	for (int i = 0; i < m; i++) {
		cin >> ws[i].f >> ws[i].s;
		ws[i].f--; ws[i].s--;
	}

	vector <vector <int>> waysg(m);
	for (int i = 0; i < m; i++) {
		way.clear();
		target = ws[i].s;
		dfs(ws[i].f);
		reverse(all(way));
		waysg[i] = way;
	}

	int ans = 0;
	vector <int> res;

	for (int mask = 0; mask < (1 << m); mask++) {
		auto ways = waysg;
		for (int i = 0; i < m; i++)
			if (mask & (1 << i))
				reverse(all(ways[i]));

		bool let_or_not = 0;
		for (auto &el : to)
			el.s = -1;

		for (int i = 0; i < m; i++) {
			bool fl = color_edge(ways[i]);
			if (!fl) let_or_not = 1;
		}
		if (let_or_not) continue;

		function <bool()> check = [&]() {
			for (int i = 0; i < m; i++)
				if (!tryway(ways[i]))
					return false;
			return true;
		};

		vector <int> id(m);
		iota(all(id), 0);

		do/*for (int iter = 0; iter < 100000; iter++)*/ {
			color.assign(n, 1);
			//for (int z = 0; z < 2 * m; z++)
				for (int i = 0; i < m; i++)
					recolor(ways[id[i]]);
			if (check()) {
				if (ans == 0 || *max_element(all(color)) < ans) {
					ans = *max_element(all(color));
					res = color;
				}
			}
			//shuffle(all(id), rnd);
		} while(next_permutation(all(id)));
	}

	if (ans == 0)
		return cout << -1, 0;

	cout << ans << '\n' << res;

	return 0;
}