#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e5 + 5, M = 5e5 + 5;

int n, m;
vector<int> g[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int type;
    cin >> n >> m >> type;
    vector<int> cnt(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].pb(u);
        g[u].pb(v);
        cnt[v]++;
        cnt[u]++;
    }
    int root = 0;
    for (int i = 1; i < n; ++i) {
        if (cnt[i] == n - 1) {
            root = i;
            break;
        }
    }
    assert(cnt[root] == n - 1);
    fill(all(cnt), 0);
    vector<int> go(n, -1);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        if (v != root && u != root) {
            if (go[v] != -1 || go[u] != -1) {
                cout << "-1\n";
                return 0;
            }
            go[v] = u;
            go[u] = v;
        }
    }
    vector<int> c(n, 1);
    c[root] = 2;
    for (int v = 0; v < n; ++v) {
        if (go[v] > -1) {
            if (go[v] > v) {
                c[go[v]] = 3;
            }
        }
    }
    cout << *max_element(all(c)) << "\n";
    if (type) {
        for (int i = 0; i < n; ++i) {
            cout << c[i] << " ";
        }
        cout << "\n";
    }

    return 0;
}
