#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second 

#define mp make_pair 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()

#define TIME (ld)clock() / CLOCKS_PER_SEC
#define debug(x) cout << #x << ": " << x << endl; 

using namespace std; 
mt19937 rnd(2007); 
typedef long long ll; 
typedef long double ld;
typedef pair<int, int> pii; 
const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7; 
const ll inf = 1e18; 
int n, m, t;        
vector<int> gr[maxn]; 
int U[maxn], V[maxn]; 
vector<int> vertex; 

bool dfs(int u, int pr, int lst) {
    vertex.pb(u); 
    if (lst == u) return true; 
    for (auto v : gr[u]) {
        if (v == pr) continue; 
        bool ok = dfs(v, u, lst); 
        if (ok) return true; 
    }               
    vertex.pop_back(); 
    return false; 
}

vector<int> gr1[maxn]; 
vector<int> path[maxn];

bool dfs1(int u, int pr, int lst) {
    if (lst == u) return true; 
    for (auto v : gr1[u]) {
        if (v == pr) continue; 
        bool ok = dfs1(v, u, lst); 
        if (ok) return true; 
    }
    return false;           
}

int ans = inf; 
int deg[maxn]; 
int mx[maxn]; 
int used[maxn];
vector<int> cl1; 
int color[maxn]; 

void get() {
    cl1.assign(n, 0); 
    for (int i = 0; i < m; ++i) {
        if (!dfs1(U[i], U[i], V[i]) && !dfs1(V[i], V[i], U[i])) return;  
    }
    for (int i = 0; i < n; ++i) {
        used[i] = 0; 
        deg[i] = 0; 
        mx[i] = 0; 
    }
    for (int i = 0; i < n; ++i) {
        for (auto v : gr1[i]) {
            deg[v]++;
        }
    }        
    int cur = 0; 
    for (int i = 0; i < n; ++i) {
        int ver = -1; 
        for (int j = 0; j < n; ++j) {
            if (!used[j] && deg[j] == 0) {
                ver = j; 
                used[j] = 1; 
                break; 
            }
        }
        cl1[ver] = mx[ver] + 1; 
        cur = max(cur, cl1[ver]); 
        for (auto v : gr1[ver]) {
            --deg[v]; 
            mx[v] = max(mx[v], cl1[ver]); 
        }                
    }                    
    if (cur < ans) {
        ans = cur;
        for (int i = 0; i < n; ++i) color[i] = cl1[i]; 
    }
}

void solve() {
    cin >> n >> m >> t; 
    for (int i = 0; i < n - 1; ++i) {
        int a, b; cin >> a >> b, --a, --b; 
        gr[a].pb(b); 
        gr[b].pb(a); 
    }   
    set<pii> EE; 
    for (int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b, --a, --b; 
        U[i] = a;
        V[i] = b; 
        vertex.clear(); 
        dfs(a, a, b); 
        path[i] = vertex; 
        for (int j = 1; j < vertex.size(); ++j) {
            int aa = vertex[j - 1], bb = vertex[j]; 
            EE.insert(mp(min(aa, bb), max(aa, bb))); 
        }
    }
    vector<pii> E; 
    for (auto v : EE) E.pb(v); 
    int N = E.size(); 
    for (int mask = 0; mask < (1 << N); ++mask) {
        for (int i = 0; i < n; ++i) {
            gr1[i].clear(); 
        }
        for (int i = 0; i < N; ++i) {
            if ((mask >> i) & 1) {
                gr1[E[i].ss].pb(E[i].ff);                 
            } else {
                gr1[E[i].ff].pb(E[i].ss); 
            }
        }
        get(); 
    }
    if (ans == inf) {
        cout << -1; 
        return; 
    }
    cout << ans << '\n'; 
    for (int i = 0; i < n; ++i) cout << color[i] << " ";
}                                   

signed main() {
#ifdef LOCAL 
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout); 
#endif 
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    int t = 1; 
    for (int i = 0; i < t; ++i) solve(); 
    return 0; 
}
