#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
const int MAXN = 5e5 + 7, LOG = 20;
int par[MAXN], rnk[MAXN], root[MAXN], h[MAXN], used[MAXN];
int get(int v) {
	if (par[v] == v)
		return v;
	return par[v] = get(par[v]);
}
void merge(int a, int b) {
	a = get(a), b = get(b);
	if (a == b)
		return;
	if (rnk[a] > rnk[b])
		swap(a, b);
	par[a] = b;
	used[b] |= used[a];
	if (h[root[a]] < h[root[b]])
		root[b] = root[a];
	if (rnk[a] == rnk[b])
		++rnk[b];
}
vector<int> g[MAXN], gt[MAXN], g2[MAXN], g2t[MAXN];
int cmp[MAXN], p[MAXN], tin[MAXN], tout[MAXN], tim = 0;
void dfs(int v, int pr) {
	h[v] = (pr == v ? 0 : h[pr] + 1);
	p[v] = pr;
	tin[v] = tim++;
	for (int u : g[v])
		if (u != pr)
			dfs(u, v);
	tout[v] = tim++;
}
int up(int v, int u) {
	return tin[v] <= tin[u] && tout[u] <= tout[v];
}
int clr[MAXN];
bool half;
void dfsc(int v, int c) {
	clr[v] = c;
	for (int u : gt[v])
		if (clr[u] == -1)
			dfsc(u, c ^ 1);
		else if (clr[u] == clr[v])
			half = 0;
}
int d[MAXN], vis[MAXN];
vector<int> topsort;
void dfst(int v) {
	vis[v] = 1;
	for (int u : g2[v])
		if (!vis[u])
			dfst(u);
	topsort.push_back(v);
}
pair<int, int> qq[MAXN];
int dir[MAXN];
int rootfix[MAXN], rootxr[MAXN];
int getxor(int v) {
	return rootxr[get(v)];
}
int getfixed(int v) {
	return rootfix[get(v)];
}
int fl(int a, int b) {
	int xr = 0;
	int c = a;
	if (up(c, b))
		c = b, xr ^= 1;
	return dir[c] ^ xr ^ getxor(c);
}
int lower(int a, int b) {
	if (h[a] > h[b])
		return a;
	else
		return b;
}
int f(int a, int b) {
	return fl(a, b) && getfixed(lower(a, b));
}
void fix(int a, int b) {
	int c = lower(a, b);
	c = get(c);
	rootfix[c] = 1;
}
int inv(int a, int b) {
	int c = lower(a, b);
	if (getfixed(c))
		exit(1);
	rootxr[c] ^= 1;
}
void dfsx(int v, int p = -1) {
	vector<int> sh;
	for (int u : g[v]) 
		if (dir[lower(u, v)] != -1)
			sh.push_back(u);
	int in = 0, out = 0;
	for (int u : sh) {
		if (f(v, u))
			out = 1;
		if (f(u, v))
			in = 1;
	}
	if (out && in)
		exit(1);
	if (!in && !out)
		in = 1;
	if (in) {
		for (int u : sh)
			if (fl(v, u))
				inv(v, u);
	}
	if (out) {
		for (int u : sh)
			if (fl(u, v))
				inv(v, u);
	}
	for (int u : sh)
		fix(u, v);
	for (int u : g[v])
		if (u != p) 
			dfsx(u, v);
}
int solve1(int n, int m) {
	dfs(0, 0);
	iota(par, par + n, 0);
	iota(root, root + n, 0);
	vector<pair<int, int>> elist;
	for (int i = 0; i < m; ++i) {
		int a = qq[i].x, b = qq[i].y;
		for (int it = 0; it < 2; ++it) {
			int v = a;
			if (!up(a, b))
				used[get(a)] = 1;
			while (!up(p[v], b)) {
				merge(p[v], a);
				v = root[get(p[v])];
			}
			swap(a, b);
		}
		if (!up(a, b) && !up(b, a))
			elist.push_back({ a, b });
	}
	for (auto e : elist)
		gt[get(e.x)].push_back(get(e.y)),
		gt[get(e.y)].push_back(get(e.x));
	fill(clr, clr + n, -1);
	half = 1;
	for (int i = 0; i < n; ++i)
		if (clr[i] == -1) 
			dfsc(i, 0);
	for (int i = 1; i < n; ++i)
		clr[i] = clr[get(i)];
	if (!half) 
		return -1;
	for (int i = 1; i < n; ++i) {
		if (!used[get(i)]) {
			dir[i] = -1;
			continue;
		}
		dir[i] = clr[get(i)];
	}
	for (auto e : elist)
		merge(e.x, e.y);
	dfsx(0);
	for (int i = 1; i < n; ++i) {
		if (dir[i] == -1)
			continue;
		int a = i, b = p[i];
		if (dir[i] ^ getxor(i))
			swap(a, b);
		g2[a].push_back(b);
		g2t[b].push_back(a);
	}
	for (int i = 0; i < n; ++i)
		if (!vis[i])
			dfst(i);
	reverse(topsort.begin(), topsort.end());
	for (int v : topsort)
		for (int u : g2t[v])
			d[v] = max(d[v], d[u] + 1);
	return *max_element(d, d + n) + 1;
}
/*
6 4 0
1 2 
2 3 
3 4 
3 5 
5 6

1 2 
3 4 
5 6 
5 3
*/
signed main() {
	ios_base::sync_with_stdio(false);
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		qq[i] = { a, b };
	}
	int ans1 = solve1(n, m);
	cout << ans1 << "\n";
	if (ans1 == -1)
		return 0;
	for (int i = 0; i < n; ++i)
		cout << d[i] + 1 << " ";
	return 0;
}