#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

vector<vector<int> > graph;
vector<int> pred;
vector<int> tin;
vector<int> tout;
vector<int> used;
vector<int> result;
vector<vector<int> > paths;
int cnt = 0;

void dfs(int v, int p)
{
    pred[v] = p;
    tin[v] = cnt;
    cnt++;
    for (int i = 0; i < graph[v].size(); ++i)
    {
        if (graph[v][i] != p)
        {
            dfs(graph[v][i], v);
        }
    }
    tout[v] = cnt;
    cnt++;
}

vector<vector<int> > graph2;

void path(int v, int y, int num)
{
    //cout << v << endl;
    paths[num].push_back(v);
    if (v == y)
    {
        return;
    }
    if (tin[v] < tin[y] && tout[y] < tout[v])
    {
        for (int i = 0; i < graph[v].size(); ++i)
        {
            if (graph[v][i] != pred[v])
            {
                if (tin[graph[v][i]] <= tin[y] && tout[graph[v][i]] >= tout[y])
                {
                    graph2[graph[v][i]].push_back(v);
                    path(graph[v][i], y, num);
                }
            }
        }
    }
    else
    {
        graph2[pred[v]].push_back(v);
        path(pred[v], y, num);
    }
}

void dfs2(int v)
{
    if (used[v])
    {
        return;
    }
    used[v] = 1;
    for (int i = 0; i < graph2[v].size(); ++i)
    {
        dfs2(graph2[v][i]);
        result[v] = max(result[graph2[v][i]] + 1, result[v]);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    int t;
    cin >> t;
    graph.resize(n);
    result.assign(n, 1);
    tin.resize(n);
    tout.resize(n);
    graph2.resize(n);
    used.resize(n);
    pred.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    dfs(0, -1);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        paths.push_back(vector<int>(0));
        path(x, y, paths.size() - 1);
    }
    for (int i = 0; i < n; ++i)
    {
        dfs2(i);
    }
    for (int i = 0; i < paths.size(); ++i)
    {
        for (int j = 0; j < paths[i].size(); ++j)
        {
            for (int h = j + 1; h < paths[i].size(); ++h)
            {
                if (result[j] >= result[h])
                {
                    cout << -1 << endl;
                    return 0;
                }
            }
        }
    }
    int max1 = 1;
    for (int i = 0; i < n; ++i)
    {
        max1 = max(max1, result[i]);
    }
    cout << max1 << endl;
    for (int i = 0; i < n; ++i)
    {
        cout << result[i] << endl;
    }
    return 0;
}
