#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<int> g[500009];
int h[500009];
int tin[500009];
int met[500009];
vector<int> eiler;
int mn[21][1000009];
int timer = 0;
int par[500009];

void dfs(int v, int p) {
    if (p != -1) h[v] = h[p] + 1;
    par[v] = p;
    tin[v] = timer++;
    met[v] = eiler.size();
    eiler.push_back(v);

    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        eiler.push_back(v);
    }
}

int relax(int a, int b) {
    if (tin[a] < tin[b]) return a;
    return b;
}

int lenfor[1000009];
int color[500009];

int lca(int a, int b) {
    a = met[a], b = met[b];
    if (a > b) swap(a, b);
    int ln = lenfor[b - a + 1];
    //cout << mn[ln][a] << ' ' << mn[ln][b - (1 << ln) + 1] << ' ' << ln << endl;
    return relax(mn[ln][a], mn[ln][b - (1 << ln) + 1]);
}

vector<int> topsg[500009];
int dist[500009];
int ingo[500009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs(0, -1);
    for (int i = 0; i <= 20; i ++) {
        for (int j = 0; j <= (int)eiler.size() - (1 << i); j++) {
            if (i == 0) mn[i][j] = eiler[j];
            else mn[i][j] = relax(mn[i - 1][j], mn[i - 1][j + (1 << (i - 1))]);
        }
    }

    for (int j = 2; j <= eiler.size(); j++) lenfor[j] = lenfor[j >> 1] + 1;

    vector<pii> path(m);

    for (int i = 0; i  < m; i ++) {
        cin >> path[i].x >> path[i].y;
        path[i].x--;
        path[i].y--;

        int v = path[i].x, u = path[i].y;
        int lc = lca(v, u);
        int ln = h[v] + h[u] - 2 * h[lc];

        ln++;
        int num = 1;

        while (v != lc) {
            topsg[v].push_back(par[v]);
            ingo[par[v]]++;
            v = par[v];
            num++;
        }

        num = ln;
        while (u != lc) {
            topsg[par[u]].push_back(u);
            ingo[u]++;
            u = par[u];
            num--;
        }
    }

    queue<int> q;
    const int inf = 1e9;
    for (int i = 0; i < n; i ++) {
        if (ingo[i] == 0) {
            q.push(i);
        }

        else {
            dist[i] = inf;
        }
    }

    int mx = 0;
    while (q.size()) {
        auto v = q.front();
        q.pop();
        mx = max(mx, dist[v]);

        for (auto u : topsg[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }

    cout << mx + 1 << "\n";
    for (int i = 0; i < n; i ++) {
        if (dist[i] == inf) dist[i] = 0;
        cout << dist[i] + 1 << ' ';
    }

    return 0;
}


