#include <bits/stdc++.h>

#define loop(i, n) for(int i  = 0; i < n; ++i)
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define vec vector
#define paii pair<int, int>
#define fr first
#define sc second
#define all(x) x.begin(), x.end()
#define Unique(x) x.erase(unique(all(x)), x.end())
#define SZ(x) (int) x.size()
#define pb push_back

#define int long long

using namespace std;

mt19937 rnd(time(0));

const int MAXN = 1e3 + 47;

int n, q, op;
vec<int> color;
vec<paii> quer(MAXN);
vec<vec<int> > graf(MAXN), en(MAXN);

int need = -1;
vec<int> T;

bool fnd(int p1, int pr) {
    T.pb(p1);
    if(p1 == need) return true;
    for(int p2 : graf[p1]) {
        if(p2 == pr) continue;
        if(fnd(p2, p1)) {
            return true;
        }
    }

    T.pop_back();
    return false;
}

bool f() {
    loop(i, q) {
        vec<int> t = en[i];
        bool fl = true;
        FOR(i, 1, SZ(t)) {
            if(color[t[i]] >= color[t[i - 1]]) fl = false;
        }
        if(fl) continue;
        fl = true;
        FOR(i, 1, SZ(t)) {
            if(color[t[i]] <= color[t[i - 1]]) fl = false;
        }
        if(!fl) return false;
    }
    return true;
}

void solve1() {
    loop(i, q) {
        int a = quer[i].fr, b = quer[i].sc;
        need = b;
        fnd(a, -1);
        en[i] = T;
        T.resize(0);
    }
    int st = 1;
    FOR(i, 1, n + 1) st *= n;
    int ind = -1, ans = 1e9;
    loop(msk, st) {
        int t = msk, kok = 0;
        loop(i, n) {
            color[i] = (t % n) + 1;
            t /= n;
            kok = max(kok, color[i]);
        }
        if(kok > ans) continue;
        /*
        for(int c : color) cout << c << " ";
        cout << endl;*/
        if(f()) {
            if(kok < ans) {
                ans = kok;
                ind = msk;
            }
        }
    }
    if(ind == -1) {
        cout << -1 << endl;
        return ;
    }
    cout << ans << endl;
    //if(op == 0) return;
    loop(i, n) {
        color[i] = (ind % n) + 1;
        ind /= n;
        cout << color[i] << " ";
    }
    cout << endl;
    exit(0);
}

void solve() {
    cin >> n >> q >> op;
    vec<int> cnt(n, 0);
    color.resize(n);
    loop(i, n - 1) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graf[a].pb(b);
        graf[b].pb(a);
    }
    loop(i, q) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        quer[i] = {a, b};
    }
    if(n <= 8) solve1();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef COFFEE_MACHINE
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif // COFFEE_MACHINE

    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}
