#include<bits/stdc++.h>

using namespace std;

int const maxn = 5e5 + 5;
vector < int > g[maxn], G[maxn], rev_G[maxn];
int tin[maxn], tout[maxn], ans[maxn], sz[maxn], cur, lst[maxn];

void dfs(int v, int p) {
    tin[v] = cur++;
    lst[v] = p;
    for (auto u : g[v]) if (u != p) dfs(u, v);
    tout[v] = cur++;
}

main() {
#ifdef HOME
    //freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, t, u, v;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0);
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v;
        vector < int > go, T;
        while (1) {
            go.push_back(u);
            if (tin[u] <= tin[v] && tout[v] <= tout[u]) break;
            u = lst[u];
        }
        while (1) {
            if (tin[v] <= tin[u] && tout[u] <= tout[v]) break;
            T.push_back(v);
            v = lst[v];
        }
        reverse(T.begin(), T.end());
        for (auto key : T) go.push_back(key);
        for (int j = 0; j < (int)go.size() - 1; ++j) {
            G[go[j]].push_back(go[j + 1]);
            rev_G[go[j + 1]].push_back(go[j]);
        }
    }
    set < pair < int, int > > Q;
    for (int i = 1; i <= n; ++i) Q.insert({(int)G[i].size(), i}), sz[i] = (int)G[i].size();
    int out = 0;
    while ((int)Q.size() > 0) {
        int mx = 0;
        auto p = (*Q.begin());
        Q.erase(p);
        for (auto key : G[p.second]) mx = max(mx, ans[key]);
        ans[p.second] = mx + 1;
        out = max(out, mx + 1);
        for (auto key : rev_G[p.second]) {
            Q.erase({sz[key], key});
            sz[key]--;
            Q.insert({sz[key], key});
        }
    }
    cout << out << '\n';
    for (int i = 1; i <= n; ++i) cout << ans[i] << " ";
    cout << '\n';
    return 0;
}

