#include <bits/stdc++.h>

#define ll long long
#define ld double
#define pb push_back
#define ft first
#define sd second

using namespace std;

const ll mod = (ll)1e9+7;
const ll inf = (ll)1e17;

vector <ll> g[500010],gn[500010];
vector <pair<ll,ll>> met;
vector <ll> tin(500010),tout(500010),p(500010),d(500010);
vector <bool> u(500010);
ll tt = 0;

void dfs(ll v) {
    u[v] = 1;
    tin[v] = tt++;

    for (auto to: g[v]) {
        if (!u[to]) {
            p[to] = v;
            dfs(to);
        }
    }

    tout[v] = tt++;
}

void dfs1(ll v, vector <ll> &c,ll cur = 1) {
    c[v] = max(c[v],cur);
    u[v] = 1;

    for (auto to: gn[v]) {
        if (!u[to]) {
            dfs1(to,c,cur+1);
        }
    }
}

void dfs2(ll v,vector <bool> &col) {
    u[v] = 1;

    for (auto to: g[v]) {
        if (!u[to]) {
            d[to] = d[v] + 1;
            dfs2(to,col);
            col[v] = col[v] || col[to];
        }
    }
}

int main() {

    ll n , m , t;

    cin >> n >> m >> t;
    vector <ll> kol(n+1);
    vector <bool> col(n+1);

    for (ll i = 1; i < n; i++) {
        ll x, y;

        cin >> x >> y;

        g[x].pb(y);

        g[y].pb(x);
    }

    for (ll i = 0; i < m; i++) {
        ll x , y;

        cin >> x >> y;
        kol[x]++;
        kol[y]++;
        col[x] = 1;
        col[y] = 1;

        met.pb({x,y});
    }

    ll ind = 0;

    for (ll i = 1; i <= n; i++) {
        if (kol[i] == m) {
            ind = i;
            break;
        }
    }

    if (ind) {

        d[ind] = 1;

        dfs2(ind,col);
        ll an = 1;

        for (ll i = 1; i <= n; i++) {
            if (!col[i]) {
                d[i] = 1;
            }
            else {
                an = max(an,d[i]);
            }
        }

        cout << an << '\n';

        for (ll i = 1; i <= n; i++) {
            cout << d[i] << ' ';
        }


        return 0;
    }

    p[1] = 1;
    dfs(1);

    ll all = (1<<m);

    ll ansk = inf;
    vector <ll> ansc(n+1);
    bool mp[n+1][n+1];

    for (ll msk = 0; msk < all; msk++) {
        vector <ll> c(n+1,1);

        for (ll i = 1; i <= n; i++) {
            gn[i].clear();
            for (ll j = 1; j <= n; j++) {
                mp[i][j] = 0;
            }
        }

        bool gd = 1;
        for (ll i = 0; i < m; i++) {
            ll x = met[i].ft;
            ll y = met[i].sd;
            if (msk&(1<<i)) {
                swap(x,y);
            }

            while (!(tin[x] <= tin[y] && tout[y] <= tout[x])) {
                gn[x].pb(p[x]);
                mp[x][p[x]] = 1;
                if (mp[p[x]][x]) {
                    gd = 0;
                }
                x = p[x];
            }

            while (x != y) {
                gn[p[y]].pb(y);
                mp[p[y]][y] = 1;
                if (mp[y][p[y]]) {
                    gd = 0;
                }
                y = p[y];
            }
        }

        if (!gd)
            continue;

        for (ll i = 0; i < m; i++) {
            fill(u.begin(),u.begin()+n+1,0);

            if (msk&(1<<i))
                dfs1(met[i].sd,c);
            else
                dfs1(met[i].ft,c);
        }

        ll mx = 0;
        for (ll i = 1; i <= n; i++) {
            mx = max(mx,c[i]);
        }

        if (ansk > mx) {
            ansk = mx;
            ansc = c;
            if (!t)
                break;
        }
    }

    if (ansk == inf) {
        cout << -1;
    }
    else {
        cout << ansk << '\n';

        for (ll i = 1; i <= n; i++) {
            cout << ansc[i] << ' ';
        }
    }
    return 0;
}
