#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

const int INF = 1e9 + 1;

vector <vector<int>> g;

vector <vector<int>> gs;

void dfs1(int v, vector <int> &tmp) {
    int MX = 0;
    for (auto &to : gs[v]) {
        if (tmp[to] == 0) {
            dfs1(to, tmp);
        }
        MX = max(MX, tmp[to]);
    }
    tmp[v] = MX + 1;
}

void dfs(int v, int need, vector <int> &now, int p) {
    if (now.size() != 0 && now.back() == need) {
        return;
    }
    now.push_back(v);
    for (auto &to : g[v]) {
        if (to != p) {
            dfs(to, need, now, v);
        }
    }
    if (now.size() && now.back() == need) {
        return;
    }
    now.pop_back();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector <pair<int, int>> way(m);
    for (auto &c : way) {
        cin >> c.first >> c.second;
        c.first--;
        c.second--;
    }
    vector <vector<int>> path;
    for (auto &c : way) {
        vector <int> now;
        dfs(c.first, c.second, now, -1);
        path.push_back(now);
    }
    vector <int> ans;
    int best = INF;
    for (int mask = 0; mask < (1 << m); mask++) {
        vector <vector<int>> now = path;
        for (int i = 0; i < m; i++) {
            if (mask & (1 << i)) {
                reverse(now[i].begin(), now[i].end());
            }
        }
        gs.assign(n, vector<int>(0));
        vector <vector<int>> connect(n, vector<int>(n));
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < now[i].size() - 1; j++) {
                gs[now[i][j + 1]].push_back(now[i][j]);
                connect[now[i][j + 1]][now[i][j]] = 1;
            }
        }
        bool f = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (connect[i][j] == 1 && connect[j][i] == 1) {
                    f = true;
                }
            }
        }
        if (f) {
            continue;
        }
        vector <int> tmp(n);
        for (int i = 0; i < n; i++) {
            if (tmp[i] == 0) {
                dfs1(i, tmp);
            }
        }
        int now_ans = 0;
        for (auto &c : tmp) {
            now_ans = max(now_ans, c);
        }
        if (best > now_ans) {
            best = now_ans;
            ans = tmp;
        }
    }
    if (best == INF) {
        cout << -1;
        return 0;
    }
    cout << best << "\n";
    for (auto &c : ans) {
        cout << c << " ";
    }
    return 0;
}
