#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define eb emplace_back
#define ff first
#define ss second

using itn = int;

const int MAXN = 500000;
//#define int long  long
const int INF = 1e9;

vector<int> g[MAXN];
vector<int> gg[MAXN];

struct tun {
    int a, b;
    tun() {}
    tun(int aa, int bb){
        a = min(aa, bb);
        b = max(aa, bb);
    }

    bool operator< (const tun& oth) const {
        return a < oth.a || (a == oth.a && b < oth.b);
    }
};

int col[MAXN];

void dfs(int v, int p, int c){
    col[v] = c;
    for (int i : g[v]){
        if (i == p) continue;
        dfs(i, v, c+1);
    }
}

int used[MAXN];
int cool = -1;
int dfs2(itn v, int c){
    used[v] = c;
    int r = 1;
    for (int i : gg[v]){
        if (i == cool) continue;
        if (!used[i]) r = dfs2(i, ((c-1)^1) + 1);
        else if (used[i] == used[v]) return 0;

        if (!r) return 0;
    }
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;



    int a, b;
    for (int i = 0; i < n-1; i++){
        cin >> a >> b;
        a--;
        b--;

        g[a].eb(b);
        g[b].eb(a);
    }


    for (int i = 0; i < n; i++){
        if ((int)g[i].size() == n-1) {
            cool = i;
            break;
        }
    }
    //cerr << cool << '\n';

    vector<tun> v;
    memset(col, 0, sizeof col);
    for (int i =0 ; i < m; i++){
        cin >> a >> b;
        a--;
        b--;
        v.eb(a, b);
        gg[a].eb(b);
        gg[b].eb(a);
    }

    memset(used, 0, sizeof used);
    int res = 0;

    for (int i = 0; i < m; i++)
    {
        if (v[i].a == cool || v[i].b == cool) continue;


        if (v[i].a != cool && !used[v[i].a])
        res = dfs2(v[i].a, 1);

        if (!res){
            cout << "-1\n";
            return 0;
        }

        if (v[i].b != cool && !used[v[i].b]) res = dfs2(v[i].b, 1);

        if (!res){
            cout << "-1\n";
            return 0;
        }
    }

    for (int i = 0; i < n; i++){
        if (i == cool) col[i] = 2;
        else if (!used[i]) col[i] = 1;
        else if (used[i] == 1) col[i] = 1;
        else col[i] = 3;
    }

    //stable_sort(v.begin(), v.end());

    //dfs(x, -1, 1);

    itn mx = 0;
    for(itn i = 0; i < n; i++) mx = max(col[i], mx);
    cout << mx << '\n';
    for (itn i = 0; i < n; i++) cout << col[i] << ' ';

    return 0;
}