#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;
#define x first
#define y second

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<int> g[500009];
int h[500009];
int term[500009];

void dfs(int v, int p) {
    if (p != -1) h[v] = h[p] + 1;
    else h[v] = 1;

    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);

        term[v] += term[u];
    }
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 0;  i< n - 1; i ++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    vector<pii> path(m);
    unordered_set<int> root;

    for (int i = 0; i < m; i ++) {
        cin >> path[i].x >> path[i].y;
        path[i].x--;
        path[i].y--;

        term[path[i].x] = 1;
        term[path[i].y] = 1;

        if (i == 0) {
            root.insert(path[i].x);
            root.insert(path[i].y);
        }

        else {
            unordered_set<int> ss = root;
            for (auto u : ss) {
                if (u != path[i].x && u != path[i].y) {
                    root.erase(u);
                }
            }
        }
    }

    dfs(*root.begin(), -1);

    int mx = 1;
    vector<int> answ(n, 1);
    for (int i = 0; i < n; i ++) {
        if (term[i] != 0) {
            answ[i] = h[i];
        }

        mx = max(mx, answ[i]);
    }

    cout << mx << "\n";
    for (auto u : answ) {
        cout << u << ' ';
    }

    return 0;
}


