#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

int n, m, t;
vector <vector <int> > gr;
vector <int> c;

void bfs(int s, int f) {
    vector <int> par(n, -1);
    queue <int> q;
    q.push(s);
    par[s] = s;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int to : gr[x]) {
            if (par[to] == -1) {
                par[to] = x;
                q.push(to);
            }
        }
    }
    vector <int> road;
    int now = f;
    while (par[now] != now) {
        road.push_back(now);
        now = par[now];
    }
    road.push_back(s);
    reverse(road.begin(), road.end());
    for (int i = 0; i < (int)road.size(); i++)
        c[road[i]] = i + 1;
   /* if (!c[road[0]])
        c[road[0]] = 1;
    for (int i = 1; i < (int)road.size(); i++) {
        if (!c[road[i]])
            c[road[i]] = c[road[i - 1]] + 1;
        else {
            if ()
        }
    }*/
}

int32_t main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> t;
    gr.resize(n);
    c.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    int v = -1;
    for (int i = 0; i < n; i++) {
        if ((int)gr[i].size() == n - 1)
            v = i;
    }
    bool fl = true;
    vector <pair <int, int> > all;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (a != v && b != v)
            fl = false;
        all.push_back({a, b});
    }
    if (fl) {
        assert(false);
        cout << 2 << "\n";
        for (int i = 0; i < n; i++) {
            if (i == v)
                cout << 2 << " ";
            else
                cout << 1 << " ";
        }
        return 0;
    }
    vector <vector <int> > graph(n);
    for (auto el : all) {
        int a = el.first, b = el.second;
        if (a == v || b == v)
            continue;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    vector <int> used(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            for (auto to : graph[i])
                used[to] = 2;
        }
        else {
            for (auto to : graph[i]) {
                if (!used[to] && to > i) {
                    if (used[i] == 1)
                        used[to] = 2;
                    else
                        used[to] = 1;
                }
            }
        }
    }
    for (auto el : all) {
        int a = el.first, b = el.second;
        if (a == v || b == v)
            continue;
        if (used[a] == used[b]) {
            cout << "-1\n";
            return 0;
        }
    }
    cout << "3\n";
    //for (auto el : used)
      //  cout << el << " ";
    //cout << " bjoii\n";
    for (int i = 0; i < n; i++) {
        if (i == v)
            cout << "2 ";
        else {
            if (used[i] == 1)
                cout << "1 ";
            else
                cout << "3 ";
        }
    }
    /**vector <int> used(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        all.push_back({a, b});
        used[a]++;
        used[b]++;
    }
    int st = -1;
    for (int i = 0; i < n; i++) {
        if (used[i] == m)
            st = i;
    }
    for (auto el : all) {
        int a = el.first, b = el.second;
        if (used[b] == m)
            swap(a, b);
        bfs(a, b);
    }
    int max_el = 0;
    for (int i = 0; i < n; i++) {
        if (!c[i])
            c[i] = 1;
        max_el = max(max_el, c[i]);
    }
    cout << max_el << "\n";
    for (auto el : c)
        cout << el << " ";
    cout << "\n";**/
    return 0;
}
