#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 5e5 + 5;
const int INF = 1e18;

vector<int> g[N];
set<int> finish[N];
int c[N];
vector<vector<int>> path;
int n, m, t;

vector<int> opa;
bool dfs(int v, int p, int nx) {
	if (v == nx) {
		opa.pb(v);
		return 1;
	}
	for (auto& to : g[v]) {
		if (to == p) continue;
		bool res = dfs(to, v, nx);
		if (res) {
			opa.pb(v);
			return 1;
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	fill(c, c + N, -INF);
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		dfs(x, 0, y);
		path.pb(opa);
		opa.clear();
	}
	for (auto& it : path) {
		int l = -1, r = -1;
		for (int i = 0; i < it.size(); ++i) {
			if (c[it[i]] != -INF) {
				r = i;
				if (l == -1) l = i;
				break;
			}
		}
		if (l != -1) {
			for (int i = l - 1; i >= 0; --i) {
				c[it[i]] = c[it[i + 1]] - 1;
			}
		}
		if (r != -1) {
			for (int i = r + 1; i < it.size(); ++i) {
				c[it[i]] = c[it[i - 1]] + 1;
			}
		}
		if (l == -1 && r == -1) {
			c[it[0]] = 1;
			for (int i = 1; i < it.size(); ++i) {
				c[it[i]] = c[it[i - 1]] + 1;
			}
		}
	}
	for (int i = 0; i <= n; ++i) {
		if (c[i] == -INF) c[i] = 1;
	}
	int add = *min_element(c, c + 1 + n);
	for (int i = 1; i <= n; ++i) {
		c[i] += (-(add - 1));
	}
	cout << *max_element(c, c + N) << endl;
	for (int i = 1; i <= n; ++i) {
		cout << c[i] << ' ';
	}
}