//#pragma GCC optimize("O3")
//#pragma optimize("fast-math")

#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define s second
#define f first
#define all(a) a.begin(), a.end()
#define srt(a) sort(a.begin(), a.end())
#define point pair<int, int>
#define io cin.sync_with_stdio(false);cout.sync_with_stdio(false);cin.tie(0);cout.tie(0);
#define DEBUG

using namespace std;

vector<vector<int>> g;
vector<int> p, ans, c, dir;
vector<pair<int, int>> w;
vector<set<int>> s;

void dfs1(int v) {
    for(int to: g[v]) {
        if(to != p[v]) {
            p[to] = v;
            dfs1(to);
        }
    }
}

void dfs(int v) {
    map<int, int> ways;
    for(int to: g[v]) {
        if(to != p[v]) {
            dfs(to);
            ans[v] = max(ans[v], ans[to]);
            if(!s[to].empty())
                c[v] = max(c[v], c[to] + 1);
            for(int num: s[to]) {
                if(!ways[num]) {
                    if(s[v].find(num) != s[v].end()) {
                        s[v].erase(num);
                    } else {
                        s[v].insert(num);
                        ways[num] = to;
                    }
                } else {
                    s[v].erase(num);
                    int x = ways[num];
                    if(dir[to] == 0) {
                        if(dir[x] == 0) {
                            dir[x] = 1;
                            dir[to] = -1;
                        } else {
                            dir[to] = -dir[x];
                        }
                    } else {
                        if(dir[x] == 0) {
                            dir[x] = -dir[to];
                        } else {
                            if(dir[x] != -dir[to]) {
                                cout << -1;
                                exit(1);
                            }
                        }
                    }
                    ans[v] = max(ans[v], c[to] + c[x] + 2);
                }
            }
        }
    }
}

signed main() {
    io;
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    w.resize(m);
    p.resize(n);
    c.resize(n);
    s.resize(n);
    ans.resize(n);
    dir.resize(n);
    for(int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        w[i] = {a, b};
        s[a].insert(i);
        s[b].insert(i);
    }
    p[0] = -1;
    dfs1(0);
    dfs(0);
    cout << max(c[0], ans[0]) + 1;
    if(t == 1)
        return 1;
    return 0;
}