#include<iostream>
#include<algorithm>
#include<vector>
#include<cmath>
#include<set>
#include<map>
#include<ctime>
#include<assert.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#define speed ios_base::sync_with_stdio(false); cout.tie(nullptr); cout.tie(nullptr);
#define ll long long

using namespace std;

vector<int> ans;

int maxx = 0;

void dfs(int v, int pred, int h, const vector<vector<int>> g, bool &flag, int v1) {
	if (v == v1) {
		ans[v] = h + 1;
		maxx = max(maxx, h + 1);
		flag = true;
	}
	else {
		for (auto u : g[v]) {
			if (u != pred) {
				dfs(u, v, h + 1, g, flag, v1);
			}
		}
		if (flag)
			ans[v] = h + 1;
	}
}

int main() {
	speed;
	int n, m, t;
	cin >> n >> m >> t;
	ans.assign(n + 1, 1);
	vector<vector<int>> g(n + 1, vector<int>());
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	vector<pair<int, int>> metro(m);
	for (int i = 0; i < m; ++i) {
		cin >> metro[i].first >> metro[i].second;
	}
	for (int i = 0; i < m; ++i) {
		bool flag = false;
		dfs(metro[i].first, metro[i].first, 0, g, flag, metro[i].second);
	}
	cout << maxx << endl;
	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << " ";
	}
	return 0;
}