#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 5e5 + 47;

vector<int> g[N], gr[N];
vector<int> gg[N], ggr[N];

int n, m, t, s[N], f[N], color[N], used[N];

vector<int> topsort;

vector<int> get_patch(int u, int pr, int ss, int ff) {
    vector<int> res;
    if (u == ff) return {ff};
    for (auto v : g[u]) {
        if (v != pr) {
            vector<int> kek = get_patch(v, u, ss, ff);
            if (kek.size()) {
                res = kek;
                res.push_back(u);
                return res;
            }
        }
    }
    return res;
}

void dfs(int u) {
    used[u] = 1;
    for (auto v : gg[u]) {
        if (used[v] == 1) {
            cout << -1;
            exit(0);
        }
        if (!used[v]) {
            dfs(v);
        }
    }
    used[u] = 2;
    topsort.push_back(u);
}

int dp[N];

map<pair<int, int>, set<int>> mapa;

void PUNKS_NOT_DEAD() {
    cin >> n >> m >> t;
    for (int i = 2; i <= n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= m; i++) {
        cin >> s[i] >> f[i];
        vector<int> path = get_patch(s[i], -1, s[i], f[i]);
        for (int j = 1; j < path.size(); j++) {
            mapa[{path[j - 1], path[j]}].insert(+i);
            mapa[{path[j], path[j - 1]}].insert(-i);
        }
    }
    for (int i = 1; i <= m; i++) {
        if (color[i] == 0) {
            color[i] = 1;
            vector<int> path = get_patch(s[i], -1, s[i], f[i]);
            for (int i = 1; i < path.size(); i++) {
                int a = path[i - 1];
                int b = path[i];
                while (mapa[{a, b}].size()) {
                    int j = *mapa[{a, b}].begin();
                    if (j > 0) color[j] = 1;
                    else color[-j] = -1;
                    mapa[{a, b}].erase(j);
                }
                while (mapa[{b, a}].size()) {
                    int j = *mapa[{b, a}].begin();
                    if (j > 0) color[j] = -1;
                    else color[-j] = +1;
                    mapa[{b, a}].erase(j);
                }
            }
        }
    }
    for (int j = 1; j <= m; j++) {
        vector<int> path = get_patch(s[j], -1, s[j], f[j]);
        if (color[j] == 1) {
            for (int i = 1; i < path.size(); i++) {
                gg[path[i - 1]].push_back(path[i]);
                ggr[path[i]].push_back(path[i - 1]);
            }
        } else {
            reverse(all(path));
            for (int i = 1; i < path.size(); i++) {
                gg[path[i - 1]].push_back(path[i]);
                ggr[path[i]].push_back(path[i - 1]);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    int cnt = 0;
    for (auto i : topsort) {
        int mx = 0;
        for (auto v : gg[i]) {
            mx = max(mx, dp[v] + 1);
        }
        dp[i] = mx;
        cnt = max(cnt, dp[i]);
    }
    cout << cnt << '\n';
    for (int i = 1; i <= n; i++) cout << dp[i] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    PUNKS_NOT_DEAD();
}