#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 500010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

vi g[MX];
int up[MX][20];
int pr[MX];
int t = 0;
int tin[MX], tout[MX];
void dfs(int v, int p) {
    tin[v] = t++;
    pr[v] = p;
    up[v][0] = p;
    fi(1, 20)
        up[v][i] = up[up[v][i - 1]][i - 1];
    fx(to, g[v]) {
        if (to == p) continue;
        dfs(to, v);
    }
    tout[v] = t;
}

bool is_anc(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int lca(int a, int b) {
    if (is_anc(a, b))
         return a;
    if (is_anc(b, a))
        return b;
    fi1(20, 0) {
        if (!is_anc(up[a][i], b))
            a = up[a][i];
    }
    return pr[a];
}

int ans[MX];

int main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, type;
    cin >> n >> m >> type;
    fill(ans, ans + n, 1);
    fi(0, n - 1) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    int mx = 0;
    vch used(n, 0);
    fi(0, m) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        int c = lca(a, b);
        vi p2;
        int cur = 1;
        while (a != c) {
            assert(!used[a]);
            used[a]  =1;
            ans[a] = cur++;
            a = pr[a];
        }
        ans[c] = cur++;
        assert(!used[c]);
        used[c] = 1;
        while (b != c) {
            assert(!used[b]);
            used[b] = 1;
            p2.push_back(b);
            b = pr[b];
        }
        reverse(all(p2));
        fx(x, p2)
            ans[x] = cur++;
        mx = max(mx, cur - 1);
    }
    cout << mx << '\n';
    if (type) {
        fi(0, n)cout << ans[i] << ' ';
    }
}