#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &a, const T2 &b) {if (a > b) a = b;}
template<class T1, class T2> inline void chkmax(T1 &a, const T2 &b) {if (a < b) a = b;}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";
const int MAXN = 500228;


int n, m, t;
vector<pair<int, int> > g[MAXN];
int in[MAXN], out[MAXN];
int jump[20][MAXN];
int up[MAXN];
int deep[MAXN];
int timer = 0;
int kek[MAXN];


void dfs(int u, int pr = -1) {
	timer++;
	in[u] = timer;
	for (auto h: g[u]) {
		if (h.first != pr) {
			up[h.first] = h.second;
			kek[h.second] = h.first;
			deep[h.first] = deep[u] + 1;
			jump[0][h.first] = u;
			dfs(h.first, u);
		}
	}
	out[u] = timer;
}


bool ispr(int a, int b) {
	return in[a] <= in[b] && out[b] <= out[a];
}



int lca(int a, int b) {
	if (ispr(a, b)) {
		return a;
	}
	if (ispr(b, a)) {
		return b;
	}
	for (int k = 19; k >= 0; k--) {
		if (!ispr(jump[k][a], b)) {
			a = jump[k][a];
		} 
	}
	return jump[0][a];
}

int lcaf(int a, int b) {
	for (int k = 19; k >= 0; k--) {
		if (!ispr(jump[k][a], b)) {
			a = jump[k][a];
		} 
	}
	return a;
}


int st[MAXN];


void addvert(int a, int b) {
	chkmin(st[b], deep[a]);
}


vector<int> v[MAXN];


void addedge(int a, int b) {
	v[a].pb(b);
}

void add(int a, int b) {
	if (deep[a] > deep[b]) {
		swap(a, b);
	}
	if (ispr(a, b)) {
		addvert(a, b);
		return;
	}
	int c = lca(a, b);
	addvert(c, a);
	addvert(c, b);
	addedge(up[lcaf(a, c)], up[lcaf(b, c)]);
}


int parent[MAXN];


int findset(int a) {
	if (a == parent[a]) {
		return a;
	}
	return parent[a] = findset(parent[a]);
}

void addedgeeq(int a, int b) {
	a = findset(a);
	b = findset(b);
	if (a != b) {
		parent[a] = b;
	}
}

int dfs1(int u, int pr = -1) {
	int ret = 1e9;
	for (auto h: g[u]) {
		if (h.first != pr) {
			int k = dfs1(h.first, u);
			chkmin(k, st[h.first]);
			if (pr != -1) {
				if (k <= deep[pr]) {
					addedgeeq(up[u], up[h.first]);
				}
			}
			chkmin(ret, k);
		}
	}
	return ret;
}


vector<int> gg[MAXN];
bool used[MAXN];
int col[MAXN];
vector<int> sttt;


void dfs2(int u) {
	sttt.pb(u);
	used[u] = true;
	for (auto h: gg[u]) {
		if (!used[h]) {
			col[h] = 3 - col[u];
			dfs2(h);
		} else {
			if (col[u] == col[h]) {
				cout << -1 << '\n';
				exit(0);
			}
		}
	}
}


vector<int> sf[MAXN];
int cf[MAXN];
vector<int> order;

void dfs3(int u) {
	used[u] = true;
	for (auto h: sf[u]) {
		if (!used[h]) {
			dfs3(h);
		}
	}
	order.pb(u);
}
 
int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].pb(mp(b, i));
		g[b].pb(mp(a, i));
	}	
	dfs(0);
	for (int k = 1; k <= 19; k++) {
		for (int i = 0; i < n; i++) {
			jump[k][i] = jump[k - 1][jump[k - 1][i]];
		}
	}
	for (int i = 0; i < n; i++) {
		st[i] = 1e9;
	}
	for (int i = 0; i < n - 1; i++) {
		parent[i] = i;
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		add(a, b);
	}
	dfs1(0);
	for (int i = 0; i < n - 1; i++) {
		for (auto x: v[i]) {
			if (findset(i) == findset(x)) {
				cout << -1 << '\n';
				return 0;
			}
			gg[findset(i)].pb(findset(x));
			gg[findset(x)].pb(findset(i));
		}
	}
	if (n <= 15) {
		int opt = 1e9;
		int cs[30];
		for (int t = 0; t < (1 << 15); t++) {
			memset(used, 0, sizeof(used));
			for (int i = 0; i < n; i++) {
				sf[i].clear();
			}
			for (int i = 0; i < n - 1; i++) {
				if (!used[i] && i == findset(i)) {
					col[i] = (t & (1 << i)) ? 1: 2;
					sttt.clear();
					dfs2(i);
				}
			}
			for (int i = 0; i < n - 1; i++) {
				int j = findset(i);
				//cout << col[j] << endl;
				if (col[j] == 1) {
					sf[kek[i]].pb(jump[0][kek[i]]);
				} else {
					sf[jump[0][kek[i]]].pb(kek[i]);
				}
			}
			memset(used, 0, sizeof(used));
			order.clear();
			for (int i = 0; i < n; i++) {
				if (!used[i]) {
					dfs3(i);
				}
			}
			int tk = 0;
			for (auto x: order) {
				cf[x] = 1;
				for (auto y: sf[x]) {
					chkmax(cf[x], cf[y] + 1);
				}
				chkmax(tk, cf[x]);
			}
			if (tk < opt) {
				opt = tk;
				for (int i = 0; i < n; i++) {
					cs[i] = cf[i];
				}
			}
		}
		cout << opt << '\n';
		for (int i = 0; i < n; i++) {
			cout << cs[i] << ' ';
		}
		cout << '\n';
		return 0;
	}
	for (int i = 0; i < n - 1; i++) {
		if (!used[i] && i == findset(i)) {
			col[i] = 1;
			sttt.clear();
			dfs2(i);
			vector<int> st1, st2;
			for (auto x: sttt) {
				if (col[x] == 1) {
					st1.pb(x);
				} else {
					st2.pb(x);
				}
			}
			for (auto x: st1) {
				addedgeeq(x, st1[0]);
			}
			for (auto x: st2) {
				addedgeeq(x, st2[0]);
			}
		}
	}
	for (int i = 0; i < n - 1; i++) {
		int j = findset(i);
		//cout << col[j] << endl;
		if (col[j] == 1) {
			sf[kek[i]].pb(jump[0][kek[i]]);
		} else {
			sf[jump[0][kek[i]]].pb(kek[i]);
		}
	}
	memset(used, 0, sizeof(used));
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs3(i);
		}
	}
	int tk = 0;
	for (auto x: order) {
		cf[x] = 1;
		for (auto y: sf[x]) {
			chkmax(cf[x], cf[y] + 1);
		}
		chkmax(tk, cf[x]);
	}
	cout << tk << '\n';
	for (int i = 0; i < n; i++) {
		cout << cf[i] << ' ';
	}
	cout << '\n';
	return 0; 
}