#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<queue>
#include<string>
#include<assert.h>

using namespace std;

vector<vector<int>> g;

map<pair<int, int>, int> mp;

vector<int> ans;


void dfs(int v) {
	for (auto u : g[v]) {
		ans[u] = max(ans[u], ans[v] + 1);
		dfs(u);
	}
}

signed main() {
	int n, m, t;
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int root = 1;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == n - 1) {
			root = i;
		}
	}
	vector<int> ans(n);
	ans[root] = 2;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		if (a == root) {
			ans[b] = 3;
			mp[{a, b}] = 1;
		}
		else if (b == root) {
			ans[a] = 1;
			mp[{b, a}] = 1;
		}
		else {
			mp[{a, root}] = 1;
			mp[{b, root}] = 1;
			ans[a] = 1;
			ans[b] = 3;
		}
		
	}
	for (int i = 0; i < n; i++) {
		if (mp[{i, root}] && mp[{root, i}]) {
			cout << -1;
			return 0;
		}
	}
	vector<int> cnt(4);
	for (int i = 0; i < n; i++) {
		cnt[ans[i]]++;
	}
	int r = 0;
	if (cnt[1] == 0) {
		r = -1;
	}
	for (int i = 0; i < n; i++) {
		ans[i] += r;
	}
	int answ = 0;
	for (int i = 0; i < n; i++) {
		answ = max(answ, ans[i]);
	}
	cout << answ << "\n";
	for (int i = 0; i < n; i++) {
		if (ans[i] == 0) {
			ans[i] = 1;
		}
		cout << ans[i] << " ";
	}
} 