#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
mt19937 rnd(228);
vector<ll> used, tin, tout, h, pr;
vector<vector<pair<ll, ll>>> g;
vector<vector<ll>> up;
ll t = 0, L = 21;
void dfs(ll v, ll p = 0) {
    tin[v] = t++;
    pr[v] = p;
    up[0][v] = p;
    used[v] = 1;
    for (int i = 1; i < L; i++)
        up[i][v] = up[i - 1][up[i - 1][v]];
    for (auto i : g[v])
        if (!used[i.first])
            dfs(i.first, v), h[i.first] = h[v] + 1;
    tout[v] = t;
}
bool is_p(ll a, ll b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

vector<ll> answ, ord;
vector<vector<ll>> g2;
void get_ans(ll v) {
    used[v] = 1;
    for (auto i : g2[v])
        if (!used[i])
            get_ans(i);
    ord.push_back(v);
}
bool col(ll v) {
    used[v] = 1;
    for (auto i : g2[v])
        if (!answ[i]) {
            answ[i] = 3 - answ[v];
            if (col(i))
                return 1;
        } else if (answ[i] == answ[v])
            return 1;
    return 0;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, q;
    cin >> n >> m >> q;
    tin.resize(n);
    pr.resize(n);
    tout.resize(n);
    used.resize(n);
    h.resize(n);
    g.resize(n);
    map<ll, ll> kek;
    up.resize(L, vector<ll>(n));
    for (int i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        kek[x]++;
        kek[y]++;
        g[x].push_back({y, i});
        g[y].push_back({x, i});
    }
    ll w = 0;
    for (auto i : kek)
        if (i.second > kek[w])
            w = i.first;
    dfs(0);
    answ.resize(n, 1);

    vector<pair<ll, ll>> a(m);
    bool fl = 0;
    for (int i = 0; i < m; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
        if (a[i].first != w && a[i].second != w)
            fl = 1;
    }
//    if (kek[w] == n - 1) {
//        if (!fl) {
//            answ[w] = 2;
//        } else {
//            g2.resize(n);
//            for (int i = 0; i < m; i++) {
//                if (a[i].first == w || a[i].second == w)
//                    continue;
//                g2[a[i].first].push_back(a[i].second);
//                g2[a[i].second].push_back(a[i].first);
//            }
//            used.assign(n, 0);
//            answ.assign(n, 0);
//            answ[w] = 0;
//            for (int i = 0; i < n; i++) {
//                if (answ[i] == 2)
//                    answ[i]++;
//                if (!answ[i] && i != w) {
//                    answ[i] = 1;
//                    if (col(i)) {
//                        cout << -1;
//                        return 0;
//                    }
//                }
//            }
//            answ[w] = 2;
//
//        }
//        cout << *max_element(answ.begin(), answ.end()) << endl;
//        for (auto i : answ)
//            cout << i << ' ';
//        return 0;
//    }
    vector<ll> best(n, 1e18);
    for (int i = 0; i < (1 << (n - 1)); i++) {

        g2.assign(n, {});
        answ.assign(n, 0);
        for (int j = 0; j < m; j++) {
            bool fl = 1;
            vector<ll> d(n, 1e18);
            d[a[j].first] = 0;
            queue<ll> q;
            pr.assign(n, -1);
            q.push(a[j].first);
            while (!q.empty()) {
                ll v = q.front();
                q.pop();
                for (auto u : g[v])
                    if (((1 << u.second) & i) == (u.first < v) && d[u.first] == 1e18) {
                        d[u.first] = d[v] + 1;
                        pr[u.first] = v;
                        q.push(u.first);
                    }
            }
            if (d[a[j].second] == 1e18) {
                d.assign(n, 1e18);
                d[a[j].second] = 0;
                queue<ll> q;
                pr.assign(n, -1);
                q.push(a[j].second);
                while (!q.empty()) {
                    ll v = q.front();
                    q.pop();
                    for (auto u : g[v])
                        if ((1 << u.second) & i == (u.first < v) && d[u.first] == 1e18) {
                            d[u.first] = d[v] + 1;
                            pr[u.first] = v;
                            q.push(u.first);
                        }
                }
                if (d[a[j].first] == 1e18) {
                    fl = 0;
                }
                swap(a[j].first, a[j].second);
            }
            if (!fl)
                continue;
            vector<vector<ll>> g2r(n);
            ll x = a[j].second;
            while (x != a[j].first) {
                g2[pr[x]].push_back(x);
                g2r[x].push_back(pr[x]);
                x = pr[x];
            }
            used.assign(n, 0);
            ord.clear();
            for (int i = 0; i < n; i++)
                if (!used[i])
                    get_ans(i);
                reverse(ord.begin(), ord.end());
            for (int i : ord)
            {
                if (g2r[i].size() == 0)
                    answ[i] = 1;
                else
                    for (auto v : g2r[i])
                        answ[i] = max(answ[i], answ[v] + 1);
            }
            if (*max_element(best.begin(), best.end()) > *max_element(answ.begin(), answ.end()))
                best = answ;
        }
    }
    if (*max_element(best.begin(), best.end()) == 1e18) {
        cout << -1;
        return 0;
    }
    cout << *max_element(best.begin(), best.end()) << endl;
    for (auto i : best)
        cout << i << ' ';
    return 0;
    return 0;
}
/*
7 3 1
1 2 1 3
2 4 2 5
3 6 3 7
1 2
2 6
2 3
 */