#include<bits/stdc++.h>

using namespace std;

int const maxn = 5e5 + 5;
vector < int > g[maxn], G[maxn], rev_G[maxn];
int tin[maxn], tout[maxn], lst[maxn], cur, sz[maxn];
vector < int > Q[maxn];
int out[maxn], ans[maxn];
int inf = 1e7 + 7;

void dfs(int v, int p) {
    lst[v] = p;
    tin[v] = cur++;
    for (auto u : g[v]) if (u != p) dfs(u, v);
    tout[v] = cur++;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, t, u, v;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0);
    if (n <= 15 && m <= 15) {
        for (int i = 1; i <= n; ++i) out[i] = -1;
        int best = inf;
        for (int i = 0; i < m; ++i) {
            cin >> u >> v;
            vector < int > T;
            while (1) {
                Q[i].push_back(u);
                if (tin[u] <= tin[v] && tout[v] <= tout[u]) break;
                u = lst[u];
            }
            while (1) {
                if (tin[v] <= tin[u] && tout[u] <= tout[v]) break;
                T.push_back(v);
                v = lst[v];
            }
            reverse(T.begin(), T.end());
            for (auto key : T) Q[i].push_back(key);
        }
        for (int mask = 0; mask < (1 << m); ++mask) {
            for (int i = 1; i <= n; ++i) G[i] = {}, rev_G[i] = {};
            for (int i = 0; i < m; ++i) {
                if ((mask&(1 << i)) > 0) {
                    for (int j = 0; j < (int)Q[i].size() - 1; ++j) G[Q[i][j]].push_back(Q[i][j + 1]), rev_G[Q[i][j + 1]].push_back(Q[i][j]);
                }
                else {
                    for (int j = (int)Q[i].size() - 1; j > 0; --j) G[Q[i][j]].push_back(Q[i][j - 1]), rev_G[Q[i][j - 1]].push_back(Q[i][j]);
                }
            }
            set < pair < int, int > > Q;
            for (int i = 1; i <= n; ++i) {
                sz[i] = (int)G[i].size();
                //cout << sz[i] << " ";
                Q.insert({sz[i], i});
            }
            //cout << endl;
            int mx = 0;
            while ((int)Q.size() > 0) {
                auto p = (*Q.begin());
                if (p.first != 0) {
                    mx = inf;
                    break;
                }
                ans[p.second] = 1;
                Q.erase(p);
                //cout << mask << " " << p.second << " " << p.first << endl;
                for (auto to : G[p.second]) ans[p.second] = max(ans[p.second], ans[to] + 1);
                mx = max(mx, ans[p.second]);
                for (auto to : rev_G[p.second]) {
                    Q.erase({sz[to], to});
                    sz[to]--;
                    Q.insert({sz[to], to});
                }
            }
            if (mx < best) {
                best = mx;
                for (int i = 1; i <= n; ++i) out[i] = ans[i];
            }
        }
        if (best == inf) cout << -1 << '\n';
        else {
            cout << best << '\n';
            for (int i = 1; i <= n; ++i) cout << out[i] << ' ';
        }
        return 0;
    }
    return 0;
}

