#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

vector <vector <int>> g, up;
vector <int> deep;
vector <int> c;
vector <int> par;
map <pair <int, int>, pair <int, int>> f;

void dfs(int v, int d = 0, int p = -1) {
	deep[v] = d;
	par[v] = p;
	if (p != -1) {
		up[0][v] = p;
		for (int i = 1; i < 25; i++)
			up[i][v] = up[i - 1][up[i - 1][v]];
	}

	for (auto & i : g[v])
		if (i != p)
			dfs(i, d + 1, v);
}

int dfs1(int v, int p = -1) {
	for (auto & i : g[v]) {
		if (i == p)
			continue;

		int tk = dfs1(i, v);
		if (f[mp(v, i)].f == 1)
			c[v] = max(c[v], tk + 1);
	}

	return c[v];
}

void dfs2(int v, int x, int p = -1) {
	c[v] = max(c[v], x);
	for (auto & i : g[v]) {
		if (i == p)
			continue;
		if (f[mp(v, i)].s == 1)
			dfs2(i, c[v] + 1, v);
		else
			dfs2(i, 1, v);
	}
}

int get_lca(int v, int u) {
	if (deep[v] < deep[u])
		swap(v, u);
	
	int d = deep[v] - deep[u];
	for (int i = 24; i >= 0; i--)
		if (d >= (1 << i))
			d -= (1 << i), v = up[i][v];

	for (int i = 24; i >= 0; i--) {
		if (up[i][v] == up[i][u])
			continue;

		v = up[i][v];
		u = up[i][u];
	}

	if (v == u)
		return v;
	return up[0][v];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	int n, m, t;
	cin >> n >> m >> t;

	g.resize(n);
	par.resize(n);
	deep.resize(n);
	up.resize(25, vector <int>(n));

	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;

		g[v].pb(u);
		g[u].pb(v);
	} 

	dfs(0);

	c.resize(n, 1);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;

		int lca = get_lca(v, u);
		int len = deep[v] + deep[u] - deep[lca] + 1;
		//cerr << lca << endl;
		//continue;
		while (v != lca) {
			f[mp(v, par[v])].f = f[mp(par[v], v)].f = 1;
			v = par[v];
		}  	
		
		while (u != lca) {
			f[mp(u, par[u])].s = f[mp(par[u], u)].s = 1;
			u = par[u];
		} 
	}

	for (auto & i : f)
		if (i.s.f == 1 && i.s.s == 1)
			return cout << -1, 0;

	dfs1(0);
	dfs2(0, c[0]);

	cout << *max_element(all(c)) << endl;
	for (auto & i : c)
		cout << i << " ";
	return 0;
}