#include <bits/stdc++.h>

#define ft first
#define sc second
#define int ll
#define len(v) (int)v.size()
#define pb push_back

using namespace std;
typedef long long ll;

int inf = 1e9 + 100;
vector<int> color;
vector<vector<int>> g;

bool dfs(int v, int cl = 1) {
	color[v] = cl;
	for (auto x : g[v]) {
		if(color[x] != -1) {
			if(color[x] == 3 - cl) 
				continue;
			return 0;
		}
		if(!dfs(x, 3 - cl))
			return 0;
	}
	return 1;
}

signed main() {
	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, t;
	cin >> n >> m >> t;
	if(n == 2) {
		cout << 2 << endl;
		cout << 1 << " " << 2 << endl;
		return 0;
	}
	g = vector<vector<int>> (n);

	vector<pair<int, int>> have(n - 1);
	vector<int> p(n);
	vector<int> cnt(n, 0);
	vector<pair<int, int>> need(m);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		have[i] = {a, b};
		cnt[a]++, cnt[b]++;
	}	
	int centr = -1;
	for (int i = 0; i < n; i++) {
		if(cnt[i] == n - 1) {
			centr = i;
			break;
		}
	}

	for (int i = 0; i < n - 1; i++) {
		if(have[i].sc == centr) 
			swap(have[i].ft, have[i].sc);
		p[have[i].sc] = i;
	}
	vector<int> used(n, 0);
	color = vector<int> (n + 1, -1);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if(a != centr) 
			used[p[a]] = 1;
		if(b != centr) 
			used[p[b]] = 1;
		if(a != centr && b != centr) {
			g[p[a]].pb(p[b]);
			g[p[b]].pb(p[a]);
		}
	}

	for (int i = 0; i < n; i++) {
		if(!used[i]) 
			continue;
		if(color[i] != -1) 
			continue;
		if(!dfs(i)) {
			cout << -1;
			return 0;
		}
	}
	int k = 1;
	vector<int> ans(n, 1);
	bool flag = 0;
	for (int i = 0; i < n - 1; i++) {
		if(color[i] != 1) 
			continue;
		ans[have[i].sc] = 1;
	}
	ans[centr] = 2;
	for (int i = 0; i < n - 1; i++) {
		if(color[i] != 2) 
			continue;
		flag = 1;
		ans[have[i].sc] = 3;
	}
	if(flag) 
		cout << 3 << endl;
	else
		cout << 2 << endl;
	for (auto x : ans) 
		cout << x << " ";
}