#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<string>

using namespace std;

vector<vector<int>> g;
vector<bool> used, intr;
long long ans = 0;
vector<int> c;

void dfs1(int v, long long l) {
	used[v] = false;
	if (intr[v]) {
		ans = max(ans, l);
	}
	for (auto i : g[v]) {
		if (used[i]) {
			dfs1(i, l + 1);
		}
	}
	c[v] = min(l, ans);
}

int main() {
	int n, m,t;
	cin >> n >> m >> t;
	g.resize(n);
	c.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		g[x - 1].push_back(y - 1);
		g[y - 1].push_back(x - 1);
	}
	vector<pair<int, int>> ve;
	map<int,int> mp;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		mp[x - 1]++;
		mp[y - 1]++;
		ve.push_back({ x - 1,y - 1 });
	}
	long long be = 0, ber = 0;
	for (auto i : mp) {
		if (i.second > ber) {
			ber = i.second;
			be = i.first;
		}
	}
	if (ber == m) {
		used.resize(n, true);
		intr.resize(n, false);
		for (auto i : ve) {
			intr[i.first] = true;
			intr[i.second] = true;
		}
		dfs1(be, 1);
	}
	cout << ans << '\n';
	if (t==1) {
		for (auto i : c) {
			cout << i << ' ';
		}
	}
}