#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
const int MAXN = (1 << 20), MAXM = (1 << 20);

struct path
{
    int from, to;
} p[MAXM];

set < pair < int, int > > s;

vector < int > t[MAXN];
int n, m, T, used[MAXN], best, b[MAXN];
bool ans;

bool dfs(int beg, int d, int p = -1, int cnt = 1)
{
    if (beg == d)
    {
        used[beg] = max(used[beg], cnt);
        return true;
    }
    int sz = t[beg].size();
    for (int i = 0; i < sz; i ++)
    {
        int nb = t[beg][i];
        if (nb == p)
            continue;

        if (s.find(make_pair(nb, beg)) != s.end())
        {
            ans = false;
            return true;
        }
        s.insert(make_pair(beg, nb));

        if (dfs(nb, d, beg, cnt + 1))
        {
            used[beg] = max(used[beg], cnt);
            return true;
        }
    }
    return false;
}
void check()
{
    ans = true;
    memset(used, 0, sizeof(used));
    bool done = true;

    for (int i = 1; i <= m; i ++)
        dfs(p[i].from, p[i].to);

    if (!ans)
        return;

    int maxx = 0;
    for (int i = 1; i <= n; i ++)
        maxx = max(maxx, used[i]);

    for (int i = 1; i <= n; i ++)
        if (maxx < best)
        {
            best = maxx;
            for (int j = 1; j <= n; j ++)
                b[j] = used[j];
        }
}

void test(int pos)
{
    if (pos == m + 1)
    {
        s.clear();
        check();
    }
    else
    {
        swap(p[pos].from, p[pos].to);
        test(pos + 1);
        swap(p[pos].from, p[pos].to);
        test(pos + 1);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> T;

    for (int i = 1; i < n; i ++)
    {
        int v1, v2;
        cin >> v1 >> v2;
        t[v1].push_back(v2);
        t[v2].push_back(v1);
    }

    for (int i = 1; i <= m; i ++)
        cin >> p[i].from >> p[i].to;

    best = n + 1;
    test(1);

    if (best == n + 1)
    cout << "-1" << endl;
    else
    {
        cout << best << endl;
        for (int i = 1; i <= n; i ++)
        {
            if (used[i] == 0)
                cout << 1 << " ";
            else
                cout << used[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
/**
3 2 1
1 2
2 3
2 1
1 3

3 1 1
1 2
2 3
1 3
*/
