#include<iostream>
#include<vector>
#include<cstdlib>
#include<unordered_map>

using namespace std;

vector<vector<int> > d;

int l[1000000+5];

int r[1000000+5];

int ans[1000000+5];

int c[1000000+5];

int fans=1e9;

int n,m,type;

int cost[1000000+5];

bool used[1000000+5];

vector<int> way;

vector<vector<int> > ways;

unordered_map<int, int> mp;

void dfs(int v, int pr, int f)
{
    used[v]=true;
    way.push_back(v);
    if (v==f) return;
    for (auto i:d[v])
    {
        if (i!=pr)
        {
            dfs(i,v,f);
        }
        if (used[f]) return;
    }
    if (used[f]) return;
    way.pop_back();
}

void check()
{
    int mx=0;
    ways.clear();
    for (int i=0; i<n; i++)
    {
        cost[i]=1;
    }
    for (int i=0; i<m; i++)
    {
        way.clear();
        for (int j=0; j<n; j++)
        {
            used[j]=false;
        }
        if (c[i]==0) dfs(l[i],-1,r[i]);
        else dfs(r[i],-1,l[i]);
        int cnt=0;
        for (auto j:way)
        {
            cnt++;
            cost[j]=max(cost[j],cnt);
            cnt=cost[j];
        }
        mx=max(mx,cnt);
        ways.push_back(way);
    }
    for (int i=0; i<m; i++)
    {
        for (int j=1; j<(int)ways[i].size(); j++)
        {
            if (cost[ways[i][j-1]]>=cost[ways[i][j]]) return;
        }
    }
    if (fans>mx)
    {
        for (int i=0; i<n; i++)
        {
            ans[i]=cost[i];
        }
        fans=mx;
    }
}

void pereb(int step)
{
    if (step>=m)
    {
        check();
        return;
    }
    for (int i=0; i<2; i++)
    {
        c[step]=i;
        pereb(step+1);
    }
}

int g[1000000+5];

void dfs_order(int v, int pr)
{
    int mx=g[v];
    for (auto i:d[v])
    {
        if (i!=pr)
        {
            dfs_order(i,v);
            //cout<<v<<" "<<i<<" "<<cost[i]<<endl;
            if (cost[i]>0) mx=max(mx,cost[i]+1);
        }
    }
    cost[v]=mx;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin>>n>>m>>type;
    d.resize(n);
    for (int i=0; i<n-1; i++)
    {
        int l,r;
        cin>>l>>r;
        l--;
        r--;
        d[l].push_back(r);
        d[r].push_back(l);
    }
    for (int i=0; i<m; i++)
    {
        cin>>l[i]>>r[i];
        l[i]--;
        r[i]--;
        mp[l[i]]++;
        mp[r[i]]++;
    }
    if (n<=15&&m<=15)
    {
        pereb(0);
        if (fans==1e9)
        {
            cout<<-1;
        }
        else
        {
            cout<<fans<<'\n';
            for (int i=0; i<n; i++)
            {
                cout<<ans[i]<<" ";
            }
        }
        return 0;
    }
    int v=l[0];
    for (auto i:mp)
    {
        if (i.second==m)
        {
            v=i.first;
            break;
        }
    }
    //if (v==-1) return 42;
    for (int i=0; i<m; i++)
    {
        if (l[i]==v) g[r[i]]=1;
        else g[l[i]]=1;
        //cout<<l[i]<<" "<<r[i]<<" "<<g[6]<<" "<<v<<endl;
    }
    dfs_order(v,-1);
    cout<<cost[v]<<'\n';
    for (int i=0; i<n; i++)
    {
        cout<<max(cost[i],1)<<" ";
    }
}
