#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define fi first
#define se second
using namespace std;
float __starttime;
vector<vector<int>> g;
vector<int> used;
vector<int> pr;
vector<int> solve_vec;
vector<vector<int>> paths;
void dfs(int v, int prr = -1) {
    used[v] = 1;
    pr[v] = prr;
    for (auto &to : g[v]) {
        if (used[to] == -1)
            dfs(to, v);
    }
}
bool ok() {
    bool f = true;
    for (int i = 0; i < paths.size(); ++i) {
        bool incr = true, decr = true;
        for (int j = 1; j < paths[i].size(); ++j) {
            int cv = paths[i][j], pv = paths[i][j - 1];
            if (solve_vec[cv] >= solve_vec[pv]) decr = false;
            if (solve_vec[cv] <= solve_vec[pv]) incr = false;
        }
        f &= (decr | incr);
    }
    return f;
}
vector<int> ans;
int cans = 1e9;
void solve(int n, int len = 0) {
    if (n == len) {
        if (!ok()) return;
        int cmax = 0;
        for (auto &c : solve_vec) {
            cmax = max(cmax, c);
        }
        if (cmax < cans) {
            cans = cmax;
            ans = solve_vec;
        }
        //cout << c << " ";
        //cout << endl;
        return;
    }
    for (int i = 1; i <= 8; ++i) {
        solve_vec.push_back(i);
        solve(n, len + 1);
        solve_vec.pop_back();
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    __starttime = clock();
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    used.resize(n, -1);
    for (int i = 0; i + 1 < n; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    pr.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        used.assign(n, -1);
        dfs(x - 1);
        vector<int> pth;
        int t = y - 1;
        while (true) {
            pth.emplace_back(t);
            t = pr[t];
            if (t == -1)
                break;
        }
        paths.push_back(pth);
    }
    solve(n);
    if (cans == 1e9) {
        cout << -1;
        return 0;
    }
    cout << cans << endl;
    for (auto &c : ans)
        cout << c << " ";
    cerr << endl << (clock() - __starttime) / CLOCKS_PER_SEC << endl;
    return 0;
}
