#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long
#define maxn 600000
#define INF 1000
#define logn 30
int n, m, t;
vector<vector<int>> lst;
vector<vector<int>> gg;
vector<int> tin, tout;
int up[maxn][logn];
vector<int> col, d;
vector<int> prv;
int tt = 0;

void dfs(int v, int pr = -1) {
    prv[v] = pr;
    for (int l = 1; l < logn; l++) {
        up[v][l] = up[up[v][l - 1]][l - 1];
    }
    tin[v] = tt++;
    for (int to :lst[v]) {
        if (to != pr) {
            d[to] = d[v] + 1;
            up[to][0] = v;
            dfs(to, v);
        }
    }
    tout[v] = tt;
}

bool a(int v, int u) {
    return tin[v] < tin[u] && tin[u] < tout[v];
}

int lca(int v, int u) {
    if (a(v, u)) return v;
    if (a(u, v)) return u;
    for (int l = logn - 1; l >= 0; l--) {
        if (!a(up[v][l], u)) {
            v = up[v][l];
        }
    }
    return up[v][0];
}
vector<int> ccur;
void gen(){
    if (ccur.size() == n){
        gg.push_back(ccur);
        return;
    }
    for(int i = 1; i <= n; i++){
        ccur.push_back(i);
        gen();
        ccur.pop_back();
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    lst.assign(n, {});
    if (n >= 7) cout << -1;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        lst[u].push_back(v);
        lst[v].push_back(u);
    }
    prv.assign(n, -1);
    tin.assign(n, 0);
    tout.assign(n, 0);
    d.assign(n, 0);
    dfs(0);
    //cerr << 1;
    gen();
    //cerr << gg.size();
    int ans = INF, ind = -1;
    vector<pair<int , pair<int, int>>>q;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        q.push_back({a, {b, lca(a, b)}});
    }
    for (int cc =0 ; cc < gg.size(); cc++){
        vector<int> cur = gg[cc];
        int bbb = 1;
        //cerr << cc << '\n';
        for (int i = 0; i < m; i++){
            int a = q[i].first, b = q[i].second.first;
            int x = q[i].second.second;
            int bl = 0;
            if (a != x){
                if (cur[prv[a]] > cur[a])
                    bl = 1;
                else bl = 0;
            }
            else if (b != x){
                if (cur[prv[b]] <  cur[b])
                    bl = 1;
                else bl = 0;
            }
            while (a != x){
                if (bl && cur[prv[a]] <= cur[a]){
                    bbb = 0;
                    break;
                }
                if (!bl && cur[prv[a]] >= cur[a]){
                    bbb = 0;
                    break;
                }
                a = prv[a];
            }
            while (b != x){
                if (bl && cur[prv[b]] >= cur[b]){
                    bbb = 0;
                    break;
                }
                if (!bl && cur[prv[b]] <= cur[b]){
                    bbb = 0;
                    break;
                }
                b = prv[b];
            }
            if(!bbb) break;
        }
        if (bbb){
            int mx = 0;
            for (int i = 0; i < n; i++){
                mx = max(mx, cur[i]);
            }
            if (mx < ans){
                ans= mx;
                ind = cc;
            }
        }
    }
    if (ind == -1){
        cout << -1;
        return 0;
    }
    cout << ans << "\n";
    for (int i:gg[ind]){
        cout << i << " ";
    }
    return 0;
}