#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(228);
#define rall(x) (x).begin(), (x).end()
#define all(x) (x).begin(), (x).end()
#define pNN pair <Node *, Node *>
#define SZ(x) (int)(x).size()
#define pii pair <int, int>
#define pb push_back
#define ins insert
#define ers erase
#define S second
#define F first
const int N = 5e5 + 10, Q = 20, INF = 1e9 + 10;

int n, m, t;
vector <int> g[N];
pii p[N];
int gg[Q][Q];
vector <int> order;
bool used[N];
int ans[N];
vector <int> vec;

void dfs_sort(int v) {
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to] && gg[v][to] == 1) {
			dfs_sort(to);
		}
	}
	order.pb(v);
}

void TopSort(int n) {
	fill(used, used + n + 1, false);
	order.clear();
	for (int i = 1; i <= n; ++i) {
		if (!used[i]) {
			dfs_sort(i);
		}
	}
}

bool dfs(int u, int v, int p) {
	vec.pb(u);
	if (u == v) {
		for (int i = 0; i < SZ(vec) - 1; ++i) {
			int x = vec[i];
			int y = vec[i + 1];
			if (gg[x][y] == -1) {
				gg[x][y] = 1;
				gg[y][x] = 0;
			}
			if (gg[x][y] == 0) {
				vec.pop_back();
				return false;
			}
		}
		vec.pop_back();
		return true;
	}

	for (auto to : g[u]) {
		if (to == p) continue;
		if (dfs(to, v, u)) {
			vec.pop_back();
			return true;
		}
	}

	vec.pop_back();
	return false;
}

int get(int mask) {
	for (int i = 0; i < Q; ++i) {
		for (int j = 0; j < Q; ++j) {
			gg[i][j] = -1;
		}
	}
	for (int i = 0; i < m; ++i) {
		if (mask & (1 << i)) {
			if (!dfs(p[i].F, p[i].S, -1)) {
				return -1;
			}
		} else {
			if (!dfs(p[i].S, p[i].F, -1)) {
				return -1;
			}
		}
	}
	TopSort(n);
	reverse(all(order));
	assert(SZ(order) == n);
	int res = 0;
	fill(ans, ans + n + 1, 0);
	for (auto x : order) {
		int mx = 0;
		for (auto to : g[x]) {
			if (gg[x][to] == 0) {
				mx = max(mx, ans[to]);
			}
		}
		ans[x] = mx + 1;
		res = max(res, ans[x]);
 	}
 	return res;
}

void small_solve() {
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
		g[v].pb(u);
	}
	for (int i = 0; i < m; ++i) {
		cin >> p[i].F >> p[i].S;
	}
	int aans = INF, ans_mask = 0;
	for (int mask = 0; mask < (1 << m); ++mask) {
		int x = get(mask);
		if (x != -1 && x < aans) {
			aans = x;
			ans_mask = mask;
		}
	}
	if (aans == INF) {
		cout << -1;
	} else {
		cout << aans << endl;
		if (t == 1) {
			get(ans_mask);
			for (int i = 1; i <= n; ++i) {
				cout << ans[i] << ' ';
			}
		}
	}
}

void big_solve() {

}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef Solenoid555
		freopen("input.txt", "r", stdin);
	#endif
	cin >> n >> m >> t;
	if (m <= 15 && n <= 15) {
		small_solve();
	} else {
		big_solve();
	}
	return 0;
}