#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

vector<vector<int> >g;
vector<pair<int, int> >metro;
vector<int>c;
vector<bool>used;
vector<int>path;

int n, m, t;

void print(vector<int>&v, int x){
    for(int i = 0; i < int(v.size()); i++){
        cout << v[i] + x << ' ';
    }
    cout << endl;
}

bool find_path(int v, int f, int p = -1){
    if(v == f){
        return 1;
    }
    for(int i = 0; i < g[v].size(); i++){
        if(p == g[v][i]) continue;
        bool found = find_path(g[v][i], f, v);
        if(found){
            path.push_back(g[v][i]);
            return 1;
        }
    }
    return 0;
}

void solve1(){
    set<pair<int, int> >lower;
    int ans_mx = 1e8;
    vector<int>ans_c;
    for(int mask = 0; mask < (1 << m); mask++){
        bool ok = 1;
        lower.clear();
        c.assign(n, 1);
        vector<vector<int> >global_path;
        for(int i = 0; i < m; i++){
            bool rev = 0;
            if(mask & (1 << i)){
                swap(metro[i].first, metro[i].second);
                rev = 1;
            }
            int s = metro[i].first, f = metro[i].second;
            find_path(s, f);
            path.push_back(s);
            reverse(path.begin(), path.end());
            for(int j = 1; j < path.size(); j++){
                c[path[j]] = max(c[path[j]], c[path[j - 1]] + 1);
            }
            for(int j = 0; j < path.size(); j++){
                for(int k = j + 1; k < path.size(); k++){
                    if(lower.count({path[k], path[j]})){
                        ok = 0;
                    }
                    lower.insert({path[j], path[k]});
                }
            }
            global_path.push_back(path);
            path.clear();
            if(rev){
                swap(metro[i].first, metro[i].second);
            }
        }
        if(!ok) continue;
        for(int i = 0; i < global_path.size(); i++){
            for(int j = 1; j < global_path[i].size(); j++){
                c[global_path[i][j]] = max(c[global_path[i][j]], c[global_path[i][j - 1]] + 1);
            }
        }
        int mx = -1;
        for(int i = 0; i < n; i++){
            mx = max(mx, c[i]);
        }
        if(ans_mx > mx){
            ans_mx = mx;
            ans_c = c;
        }
    }
    if(ans_mx == 1e8){
        cout << -1 << endl;
        exit(0);
    }
    assert(ans_c.size() == n);
    cout << ans_mx << endl;
    for(int i = 0; i < n; i++){
        cout << ans_c[i] << ' ';
    }
    cout << endl;
}

int main()
{
    QuickStart();
    cin >> n >> m >> t;
    g.resize(n);
    c.resize(n, 1);
    for(int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    metro.resize(m);
    for(int i = 0; i < m; i++){
        cin >> metro[i].first >> metro[i].second;
        metro[i].first--, metro[i].second--;
    }
    if(n <= 15 && m <= 15){
        solve1();
    }
    return 0;
}
