#include<bits/stdc++.h>
using namespace std;
const int MAXN = 128;
int n,m,t,level[MAXN],par[MAXN];
vector<int>v[MAXN];
map< pair<int,int>,int >mp;
vector< pair<int,int> >e;
void Weigh(int x)
{
    for(auto nb:v[x])
    {
        if(!level[nb])
        {
            level[nb]=level[x]+1;
            par[nb]=x;
            Weigh(nb);
        }
    }
}

int LCA(int x,int y)
{
    int i,j;
    while(x!=y)
    {
        if(level[x]>level[y])
            x=par[x];
            else y=par[y];
    }
    return x;
}
void Route(int x,int y,int r)
{
    while(x!=r)
    {
        if(!mp[ {x,par[x]}])
        {
            e.push_back({x,par[x]});
            mp[ {x,par[x]}]=true;
        }
        x=par[x];
    }
    while(y!=r)
    {
        if(!mp[ {par[y],y}])
        {
            e.push_back({par[y],y});
            mp[ {par[y],y}]=true;
        }
        y=par[y];
    }
}

int used[MAXN];
void read()
{
    int x,y,i,j,mx=0,k;
    cin>>n>>m>>t;
    for(i=0; i<n-1; i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    level[1]=1;
    Weigh(1);
    for(i=0; i<m; i++)
    {
        cin>>x>>y;
        k=LCA(x,y);
        Route(x,y,k);
    }
    for(auto nb:e)
    {
        if(mp[ {nb.second,nb.first}])
        {
            if(t==1)x/=0;
            cout<<-1<<endl;
            exit(0);
        }
    }
    for (i=1;i<=n;i++)used[i]=1;
    for(j=0;j<128;j++)
    {
        for(auto nb:e)
        {
            if(used[nb.first]>=used[nb.second])used[nb.second]=used[nb.first]+1;
        }
    }
    for(i=1;i<=n;i++)mx=max(mx,used[i]);
    cout<<mx<<endl;
    for(i=1;i<=n;i++)cout<<used[i]<<" ";cout<<endl;

}
int main()
{
    read();
    return 0;
}
/*8 2 1
1 4
1 3
3 8
3 7
1 2
2 6
2 5
4 5
7 6
*/
