#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>


#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define int long long
#define ld long double

using namespace std;
using namespace __gnu_pbds;

template < typename firstType = null_type, typename secondType = null_type, class compare = less < firstType > >
struct sett {
    typedef tree <
        firstType,
        secondType,
        compare,
        rb_tree_tag,
        tree_order_statistics_node_update
    > _ ;
};




const int INF = 1e18 + 7;
const int P = 31;

vector < vector < int > > v(500000);
vector < set < int > > v1(500000);
pair < int, int > a[500000];
int mx = INF;
int ans[500000];
int n;
int b[500000];
bool u[500000];
bool y = true;

inline void dfs (int ver, int x){
    u[ver] = true;
    for (auto i: v[ver]){
        if (!u[i]){
            if (x < 0 && b[i] < b[ver])
                dfs(i, x);
            else if (x > 0 && b[i] > b[ver])
                dfs(i, x);
        }

    }

}

inline void rec (int ver){
    if (ver == n){
        int mx1 = 0;
        for (int i = 0; i < n; i++)
            mx1 = max(mx1, b[i]);
        if (mx1 >= mx)
            return;
        bool z = true;
        for (int i = 0; i < n && z; i++){
            for (int i = 0; i < n; i++)
                u[i] = false;
            for (auto j: v[i]){
                if (b[j] > b[i])
                    dfs(j, 1);
                else if (b[j] < b[i])
                    dfs(j, -1);
            }
            for (auto j: v1[i]){
                if (!u[j]) {
                    z = false;
                    break;
                }
            }
        }
        if (!z)
            return;
        if (z){
            mx = mx1;
            for (int i = 0; i < n; i++)
                ans[i] = b[i];
        }
        return;
    }
    for (b[ver] = 1; b[ver] <= 8; b[ver]++)
        rec(ver + 1);
}

void dfs1 (int ver) {
    u[ver] = true;
    for (auto i: v1[ver]){
        if (!u[i]){
            ans[i] = (ans[ver] == 1 ? 3 : 1);
            dfs1(i);
        }
        else {
            int x = (ans[ver] == 1 ? 3 : 1);
            if (ans[i] != 2 && ans[i] != x)
                y = false;
        }
    }
}

signed main()
{
    int m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        v[x].eb(y);
        v[y].eb(x);
    }

    for (int i = 0; i < m; i++){
        cin >> a[i].f >> a[i].s;
        a[i].f--;
        a[i].s--;
        v1[a[i].f].insert(a[i].s);
        v1[a[i].s].insert(a[i].f);
    }

    if (n <= 8){
        rec(0);
        cout << mx << '\n';
        for (int i = 0; i < n; i++)
            cout << ans[i] << ' ';
        cout << '\n';
    }
    else {
        for (int i = 0; i < n; i++)
            ans[i] = 0;
        int root = 0;
        for (int i = 0; i < n; i++)
            if (v[i].size() != 1)
                root = i;
        ans[root] = 2;
        for (int i = 0; i < n; i++)
            u[i] = false;
        u[root] = true;
        for (int i = 0; i < n; i++){
            if (i == root)
                continue;
            if (!u[i]){
                ans[i] = 1;
                dfs1(i);
            }
        }
        if (!y)
            return cout << -1, 0;
        mx = 0;
        for (int i = 0; i < n; i++)
            mx = max(mx, ans[i]);
        cout << mx << '\n';
        for (int i = 0; i < n; i++)
            cout << ans[i] << ' ';
        return 0;
    }
    if (mx == INF)
        return cout << -1, 0;
    cout << mx << '\n';
    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
    return 0;
}
