#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define ll long long

vector <int> t;
vector <int> mod;
void build_tree (int v, int tl, int tr, vector <int> & a)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr)/2;
        build_tree(v*2, tl, tm, a);
        build_tree(v*2 + 1, tm + 1, tr, a);
        t[v] = t[v*2] + t[v*2 + 1];
    }
}

void push(int v, int tl, int tr)
{
    if (mod[v]!= 0 && v*2 + 1 < t.size())
    {

        mod[v*2] = mod[v*2 + 1] = mod[v];
        mod[v] = 0;
        int tm = (tl + tr)/2;
        t[v*2] = mod[v*2]*(tm - tl + 1);
        t[v*2 + 1] = mod[v*2 + 1]*(tr - tm);
    }
}

int get_sum (int l, int r, int v, int tl, int tr)
{
    if (tl >= l && tr <= r)
        return t[v];
    if (tl > r || tr < l)
        return 0;
    push(v, tl, tr);
    int tm = (tl + tr)/2;
    return get_sum(l, r, v*2, tl, tm) + get_sum(l, r, v*2 + 1, tm + 1, tr);


}

void ass (int l, int r, int v, int tl, int tr, int val)
{
    if (tl >= l && tr <= r)
    {
        mod[v] = val;
        t[v] = (tr - tl + 1)*val;

        return;
    }
    if (tl > r || tr < l)
        return;
    push(v, tl, tr);
    int tm = (tl + tr)/2;

    ass(l, r, v*2, tl, tm, val);
    ass(l, r, v*2 + 1, tm + 1, tr, val);
    t[v] = t[v*2] + t[v*2 + 1];


}

void bfs(vector <vector <int>> & g, int st, int end, vector <int> & p, vector <vector <int>> & path, vector <bool> & used, int num)
{

    used.assign(g.size(), false);
    queue <int> q;
    p[st] = -1;
    used[st] = true;
    q.push(st);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); ++i)
        {
            if (used[g[v][i]])
                continue;
            q.push(g[v][i]);
            used[g[v][i]] = true;
            p[g[v][i]] = v;

        }
    }
    int u = end;
    while (1)
    {
        path[num].push_back(u);
        u = p[u];
        if (u == -1)
            break;
    }


}

void dfs(vector <vector <int>> & g,  int v, vector <int> & c)
{
    for (int i = 0; i < g[v].size(); ++i)
    {
        if (g[v][i] != 1)
            continue;
        if (c[v] >= c[i])
            c[i] = c[v] + 1;
        dfs(g, i, c);
    }


}


int main() {
    int n, m, td;
    cin >> n >> m >> td;
    vector <vector <int>> g(n);
    vector <vector <int>> path(m);
    int l, r;
    for (int i = 0; i < n - 1; ++i)
    {
        cin >> l >> r;
        l--;
        r--;
        g[l].push_back(r);
        g[r].push_back(l);
    }
    vector <bool> used(n);
    vector <int> p(n);

    for (int i = 0; i < m; ++i)
    {
        cin >> l >> r;
        l--;
        r--;
        p.assign(n, -1);
        bfs(g, r, l, p, path, used, i);
    }

    vector <vector <int>> g1(n);
    for (int i = 0; i < n; ++i)
        g1[i].resize(n, 0);

    for (int i = 0; i < m; ++i)
    {
        for (int j = 0; j < path[i].size() - 1; ++j)
        {
            g1[path[i][j]][path[i][j + 1]] = 1;

        }
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
            if (g1[i][j] == 1 && g1[j][i] == 1)
            {
                cout << -1;
                return 0;
            }
    }
    int ee = 0;
    vector <int> c(n, 1);
    for (int i = 0; i < n; ++i)
    {
        ee = 0;
        for (int j = 0; j < n; ++j)
        {
            if (g1[j][i])
            {
                ee = 1;
                break;
            }
        }
        if (ee)
            continue;
        dfs(g1, i, c);
    }
    int max = -1;
    for (int i = 0; i < n; ++i)
        if (c[i] > max)
            max = c[i];

    cout << max << endl;
    for (int i = 0; i < n; ++i)
        cout << c[i] << ' ';

}
