/*
 *   cCreated by Kazalika     for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define all(x) x.begin(), x.end()
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define sz(x) int(x.size())
const ll UNDEF = -1e15, INF = 1e9;
const int N = 5e5 + 10;
const ll MOD = 228228227, base = 257;

int n, m, t;
vector <int> g[N];
vector <pii> v;
int c[N], out[N];
int ans = INF;
bool ansExist = false;
bool ok = true;
bool ex = false;

void dfs(int v, int end, int p = -1, bool OK = true) {
    if (v == end)
        ex = true;
    if (ex && !OK) ok = false;
    if (ex) return;
    for (int i : g[v]) {
        if (ex) return;
        if (i != p) {
            int val = c[i];
            if (c[i] <= c[v]) OK = false;
            else OK = true;
            c[i] = max(c[i], c[v] + 1);
            dfs(i, end, v, OK);
            if (ex) return;
            c[i] = val;
        }
    }
}

void do_it(int a, int b) {
    ex = false;
    dfs(a, b);
}

bool check(int a, int b) {
    ok = true;
    ex = false;
    dfs(a, b);
    return ok;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m >> t;
    v.resize(m);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        v[i] = {a, b};
    }
    for (int mask = 0; mask < (1 << m); ++mask) {
        fill(c, c + n, 1);
        vector <pii> vn(m);
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1)
                vn[i] = { v[i].second, v[i].first };
            else
                vn[i] = v[i];
        }
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < m; ++j) {
                do_it(vn[i].first, vn[i].second);
            }
        }
        bool cont = false;
        for (int i = 0; i < m; ++i)
            if (!check(vn[i].first, vn[i].second))
                cont = true;
        if (cont) continue;
        int maxc = *max_element(c, c + n);
        if (maxc < ans) {
            ans = maxc;
            for (int i = 0; i < n; ++i)
                out[i] = c[i];
            ansExist = true;
        }
    }

    if (!ansExist) {
        cout << -1;
        return 0;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) cout << out[i] << ' ';

}