#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T> 
bool uin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 20;
const LL LINF = 1e18;
const int N = (int)5e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

bool used[10][10];
int c[N], mx = INF, ans[N];
int n, m, t, a[N], b[N];
vector <int> gr[N];

void dfs(int u, bool* used) {
	used[u] = true;
	for (int v : gr[u]) {
		if (!used[v] && c[u] < c[v])
			dfs(v, used);
	}
}

bool bit(int x, int pos) {
	return (x & (1 << pos)) > 0;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}
	for (int i = 0; i < m; i++) {
		cin >> a[i] >> b[i];
		a[i]--, b[i]--;
	}
	fill(ans, ans + n, INF);
	vector <int> perm;
	for (int i = 0; i < n; i++)
		perm.push_back(i);
	do {
		c[perm[0]] = 1;
		for (int i = 0; i < (1 << (n - 1)); i++) {
			for (int j = 1; j < n; j++) {
				c[perm[j]] = c[perm[j - 1]];
				if (bit(i, j - 1))
					c[perm[j]]++;
			}
			int curmax = c[perm[n - 1]];
			for (int i = 0; i < n; i++) {
				fill(used[i], used[i] + n, false);
				dfs(i, used[i]);
			}
			bool fl = true;
			for (int i = 0; i < m; i++) {
				if (!used[a[i]][b[i]] && !used[b[i]][a[i]]) {
					fl = false;
					break;
				}
			}
			if (fl && uin(mx, curmax)) {
				for (int i = 0; i < n; i++)
					ans[i] = c[i];
			}
		}
	} while (next_permutation(all(perm)));
	if (mx == INF)
		cout << -1;
	else {
		cout << mx << endl;
		for (int i = 0; i < n; i++)
			cout << ans[i] << ' ';
	}
}