#include<bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define TEST ""
//#define int long long
//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma target (sse1,sse2,sse3,sse4)

typedef long long ll;
typedef long double ld;

using namespace std;

vector<vector<int> > g, pt;

vector<pair<int, int> > pathes;

int n, m;

vector<int> path;

vector<int> value;

void dfs(int v, int u){
    value[v] = 1;
    path.push_back(v);
    if(v == u) return;
    for(auto to : g[v]){
        if(value[to] == 0){
            dfs(to, u);
            if(path.back() == u) return;
        }
    }
    path.pop_back();
}

bool dfs1(int v, vector<vector<int> > &gr){
    value[v] = 1;
    for(auto to : gr[v]){
        if(value[to] == 1 || !dfs1(to, gr)) return 0;
    }
    value[v] = 2;
    return 1;
}

void bfs(int start, vector<vector<int> > &gr){
    deque<int> q;
    q.push_back(start);
    value[start] = 1;
    while(q.size() > 0){
        int v = q.back();
        q.pop_back();
        for(auto to : gr[v]){
            q.push_front(to);
            value[to] = max(value[v] + 1, value[to]);
        }
    }
}

bool check(vector<vector<int> > &gr){
    for(int i = 0; i < n; i++)
        if(value[i] == 0 && !dfs1(i, gr)) return 0;
    return 1;
}

int get_ans(int mask){
    for(int i = 0; i < m; i++)
        if(mask & (1 >> i)) reverse(pt[i].begin(), pt[i].end());
    //cout << "OK" << endl;
    vector<vector<int> > new_g(n);
    for(int i = 0; i < m; i++){
        for(int j = 1; j < pt[i].size(); j++)
            new_g[pt[i][j]].push_back(pt[i][j - 1]);
    }
    //cout << "OK1" << endl;
    value.assign(n, 0);
    if(!check(new_g)){
        for(int i = 0; i < m; i++)
            if(mask & (1 >> i)) reverse(pt[i].begin(), pt[i].end());
        return -1;
    }
    //cout << "OK2" << endl;
    vector<int> deq(n, 0);
    for(int i = 0; i < n; i++){
        for(auto to : new_g[i])
            deq[to]++;
    }
    //cout << "OK3" << endl;
    vector<int> tmp;
    for(int i = 0; i < n; i++)
        if(deq[i] == 0) tmp.push_back(i);
    int ans = 0;
    for(auto x : tmp){
        value.assign(n, 0);
        bfs(x, new_g);
        ans = max(ans, *max_element(value.begin(), value.end()));
    }
    for(int i = 0; i < m; i++)
        if(mask & (1 >> i)) reverse(pt[i].begin(), pt[i].end());
    return ans;
}

void solve(){
    int t;
    cin >> n >> m >> t;
    value.resize(n);
    g.resize(n);
    pt.resize(m);
    int v, to;
    for(int i = 0; i < n -1; i++){
        cin >> v >> to;
        g[--v].push_back(--to);
        g[to].push_back(v);
    }
    pathes.resize(m);
    for(int i = 0; i < m; i++){
        cin >> pathes[i].f >> pathes[i].s;
        pathes[i].f--;
        pathes[i].s--;
        value.assign(n, 0);
        dfs(pathes[i].f, pathes[i].s);
        pt[i] = path;
        path.clear();
    }
    //cout << "OK" << endl;
    vector<int> value_ans(n);
    int mask = 0, ans = 1e9;
    do{
        int t = get_ans(mask);
        //cout << "OK" << endl;
        if(t == -1) continue;
        if(t < ans){
            ans = t;
            value_ans = value;
        }
        //cout << mask << endl;
    } while(++mask < (1 << m));
    if(ans == 1e9){
        cout << -1;
        return;
    }
    for(int i = 0; i < n; i++){
        if(value_ans[i] == 0) value_ans[i] = 1;
    }
    cout << ans << '\n';
    for(auto x : value_ans)
        cout << x << ' ';
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}

