#include <bits/stdc++.h>
#define int long long
#define prev previ
using namespace std;

vector <int> tin, tout, prev, tryans;
vector <vector <int>> g;
vector <vector <bool>> conn;
int timer=0, mx=0;

void dfs(int v, int p)
{
    prev[v] = p;
    tin[v] = ++timer;
    for (int i=0; i < g[v].size(); ++i)
        if (g[v][i] != p)
            dfs(g[v][i], v);
    tout[v] = ++timer;
}

void dfstry(int v, int p)
{
    if (p != -1)
    {
        if (conn[v][p])
            tryans[v] = tryans[p] + 1;
        else
            tryans[v] = 1;
    }
    mx = max(mx, tryans[v]);
    for (int i=0; i < g[v].size(); ++i)
        if (g[v][i] != p)
            dfstry(g[v][i], v);
}

bool anc(int a, int b)
{
    return (tin[a] < tin[b] && tout[a] > tout[b]) || (tin[b] < tin[a] && tout[b] > tout[a]);
}

signed main()
{
    int n, m, t, i, j, u, v;
    cin >> n >> m >> t;
    tin.resize(n);
    tout.resize(n);
    g.resize(n);
    prev.resize(n);
    tryans.resize(n);
    vector <pair <int, int>> vet(m);
    for (i=0; i < n - 1; ++i)
    {
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    for (i=0; i < m; ++i)
    {
        cin >> u >> v;
        vet[i].first = u - 1;
        vet[i].second = v - 1;
    }
    conn.resize(n);
    for (i=0; i < n; ++i)
        conn[i].resize(n);
    for (i=0; i < m; ++i)
    {
        dfs(vet[i].first, -1);
        int p = vet[i].second;
        while (prev[p] >= 0)
        {
            conn[p][prev[p]] = true;
            conn[prev[p]][p] = true;
            p = prev[p];
        }
        prev.clear();
        tin.clear();
        tout.clear();
    }
    /*cout << "\nconn\n";
    for (i=0; i < n; ++i)
    {
        for (j=0; j < n; ++j) cout << conn[i][j] << " ";
        cout << "\n";
    }
    cout << "\n\n";*/
    int minans = 1e9, allflag=0;
    vector <int> ans(n);
    for (i=0; i < n; ++i)
    {
        dfs(i, -1);
        int flag=0;
        for (j=0; j < m; ++j)
        {
            if (!(anc(vet[j].first, vet[j].second)))
            {
                flag = 1;
                break;
            }
        }
        if (flag == 0)
        {
            tryans.clear();
            allflag = 1;
            mx = 0;
            tryans[i] = 1;
            dfstry(i, -1);
            if (mx < minans)
            {
                /*if (mx == 2)
                {
                    cout << "here " << i << " here" << "\n";
                    for (j=0; j < n; ++j) cout << tryans[j] << " ";
                    cout << "\n";
                }*/
                minans = mx;
                for (j=0; j < n; ++j)
                    ans[j] = tryans[j];
            }
        }
        tin.clear();
        tout.clear();
        prev.clear();
    }
    if (allflag == 0)
        cout << -1;
    else
    {
        cout << minans << "\n";
        for (i=0; i < n; ++i)
            cout << ans[i] << " ";
    }
    return 0;
}
