#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <queue>
#include <deque>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string.h>
#include <time.h>
#include <random>
#include <assert.h>

using namespace std;

typedef long long ll;
#define ff first
#define ss second
#define mp make_pair
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define vpii vector<pii>
#define make_unique(x) sort(x.begin(),x.end()); x.resize(unique(x.begin(),x.end()) - x.begin());
#define sz(x) ((int)x.size())
#define pb push_back
#define eb emplace_back

inline int nxt() {
	static int buf_nxt;
	cin >> buf_nxt;
	return buf_nxt;
}

inline ll nxtll() {
	static ll buf_nxt_ll;
	cin >> buf_nxt_ll;
	return buf_nxt_ll;
}


#define N (30)
#define MAXN (500000 + 19)

vi g[MAXN];
vi og[MAXN];
int h[MAXN];
int p[MAXN];
bool used[MAXN];
pii path[MAXN];
int n, m;

void calc_h(int v) {
	for (auto u : g[v]) {
		if (u == p[v]) {
			continue;
		}
		h[u] = h[v] + 1;
		p[u] = v;
		calc_h(u);
	}
}

void get_path(int a, int b) {
	bool f = false;
	if (h[a] < h[b]) {
		swap(a, b);
		f = true;
	}
	while (h[a] != h[b]) {
		if (!f) og[a].push_back(p[a]);
		else og[p[a]].push_back(a);
		a = p[a];
	}
	while (a != b) {
		if (!f) og[a].push_back(p[a]);
		else og[p[a]].push_back(a);
		if (f) og[b].push_back(p[b]);
		else og[p[b]].push_back(b);
		a = p[a];
		b = p[b];
	}
}

bool cyc = false;
int c[MAXN];
int ansc[MAXN];

void dfs(int v) {
	used[v] = true;
	for (auto u : og[v]) {
		if (used[u]) {
			cyc = true;
			break;
		}
		dfs(u);
	}
	c[v] = 1;
	for (auto u : og[v]) {
		c[v] = max(c[v], c[u] + 1);
	}
}

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	srand(239);
	n = nxt();
	m = nxt();
	int t = nxt();
	for (int i = 0; i < n - 1; i++) {
		int a = nxt(), b = nxt();
		g[a].pb(b);
		g[b].pb(a);
	}

	for (int i = 0; i < m; i++) {
		int a = nxt(), b = nxt();
		path[i] = { a,b };
	}
	calc_h(1);
	int k = inf;
	if (m <= 15) {
		for (int mask = 0; mask < (1 << m); mask++) {
			for (int i = 0; i <= n; i++) {
				og[i].clear();
			}
			for (int i = 0; i < m; i++) {
				if (mask & (1 << i)) {
					get_path(path[i].ff, path[i].ss);
				}
				else {
					get_path(path[i].ss, path[i].ff);
				}
			}
			memset(used, 0, sizeof(bool) * (n + 1));
			memset(c, 0, sizeof(int) * (n + 1));
			cyc = false;
			for (int i = 1; i <= n; i++) {
				if (!used[i]) {
					dfs(i);
				}
			}
			if (cyc) {
				continue;
			}
			if (*max_element(c, c + n + 1) < k) {
				k = *max_element(c, c + n + 1);
				memcpy(ansc, c, sizeof(int) * (n + 1));
			}
		}
		if (k == inf) {
			cout << -1;
		}
		else {
			cout << k << endl;
			for (int i = 1; i <= n; i++) {
				cout << ansc[i] << " ";
			}
		}
	}

	return 0;
}