#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second
#define pb emplace_back
#pragma GCC optimize("Ofast")

using namespace std;

const ll INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, vi &a) {
	for (auto &i : a) in >> i;
	return in;
}

ve<ve<int>> g;
ve<bool> used;
int n, m;

bool dfs(int u, int fin) {
	used[u] = true;
	bool flag = false;
	for (auto v : g[u]) {
		if (!used[v]) flag |= dfs(v, fin);
	}
	return ((u == fin) | flag);
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int t, u, v;
	cin >> n >> m >> t;
	ve<pii> edges(n - 1);
	for (auto &i : edges) cin >> i, i.fi--, i.se--;
	ve<pii> ways(m);
	for (auto &i : ways) {
		cin >> i;
		i.fi--, i.se--;
	}
	int curmx = INF;
	vi curans = {};
	used.resize(n);
	for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
		g.resize(0);
		g.resize(n);
		for (int i = 0; i < n - 1; ++i) {
			if (((1 << i) | mask) == mask) g[edges[i].fi].pb(edges[i].se);
			else g[edges[i].se].pb(edges[i].fi);
		}
		used.assign(n, false);
		bool flag = true;
		for (auto [u, v] : ways) {
			if (!dfs(u, v)) {
				flag = false;
				break;
			}
		}
		if (!flag) continue;
		vvi ng = g;
		vvi tng(n);
		vi cnt(n);
		for (int u = 0; u < n; ++u) for (auto v : g[u]) tng[v].pb(u);
		for (int u = 0; u < n; ++u) cnt[u] = sz(tng[u]);
		set<pii> least;
		for (int u = 0; u < n; ++u) {
			least.insert({cnt[u], u});
		}
		vi ans(n, 1);
		while (!least.empty()) {
			pii vv = *least.begin();
			assert(vv.fi == 0);
			least.erase(vv);
			int v = vv.se;
			for (auto u : tng[v]) ans[v] = max(ans[v], ans[u] + 1);
			for (auto u : ng[v]) {
				auto it = least.find({cnt[u], u});
				cnt[u]--;
				least.erase(it);
				least.insert({cnt[u], u});
			}
		}
		int mx = 0;
		for (auto i : ans) mx = max(mx, i);
		if (mx < curmx) curmx = mx, curans = ans;
	}
	if (curmx == INF) return cout << -1 << endl, 0;
	cout << curmx << endl;
	for (auto i : curans) cout << i << ' ';
	cout << endl;
	return 0;
}
