#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int f[1000000];
int ans[1000000];
int h[1000000];
set <pair <int, int>> all;
vector <int> nx[1000000];
vector <int> NX[1000000];
int n, m, t;
int a[1000000], b[1000000];
int P[1000000];

void dfs_h(int v, int p, int H) {
	P[v] = p;
	h[v] = H;
	for (auto i : nx[v]) {
		if (i == p) continue;
		dfs_h(i, v, H+1);
	}
}

bool mark[100000];

void dfs_top(int v) {
	mark[v] = true;
	f[v] = 1;
    for (auto i : NX[v]) {
		if (!mark[i]) dfs_top(i);
        f[v] = max(f[v], f[i]+1);
    }
}

void check() {
	for (int i = 1; i <= n; i++) NX[i].clear();
	for (int i = 0; i < m; i++) {
        int v = a[i];
        int u = b[i];
        while (h[v] > h[u]) {
            NX[v].push_back(P[v]);
            v = P[v];
        }
        while (h[u] > h[v]) {
            NX[P[u]].push_back(u);
            u = P[u];
        }
        while (v != u) {
            NX[v].push_back(P[v]);
            v = P[v];
            NX[P[u]].push_back(u);
            u = P[u];
        }
	}
    for (int i = 1; i <= n; i++) mark[i] = false, f[i] = 0;
    for (int i = 1; i <= n; i++) if (!mark[i]) dfs_top(i);
    f[0] = 0;
    for (int i = 1; i <= n; i++) {
		for (auto u : NX[i]) {
            if (f[i] <= f[u]) return ;
		}
		f[0] = max(f[0], f[i]);
    }
    if (f[0] < ans[0]) {
        for (int i = 0; i <= n; i++) ans[i] = f[i];
    }
}

void rec(int i) {
	if (i == m) {
        check();
        return ;
	}
    rec(i+1);
    swap(a[i], b[i]);
    rec(i+1);
}

void dfs(int v, int c) {
	f[v] = c;
    for (auto i : NX[v]) {
        if (f[i] == 0) dfs(i, c^2);
        if (f[i] == f[v]) {
            cout << -1 << endl;
            exit(0);
        }
    }
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	cin >> n >> m >> t;
	for (int i = 0; i < n-1; i++) {
		int x, y;
		cin >> x >> y;
		nx[x].push_back(y);
		nx[y].push_back(x);
	}
	int A, B;
	for (int i = 0; i < m; i++) {
		cin >> a[i] >> b[i];
		if (i == 0) A = a[i], B = b[i]; else {
			if (A == a[i] || A == b[i]) ; A = -1;
			if (B == a[i] || B == b[i]) ; B = -1;
		}
	}
	if (n <= 15 && m <= 15) {
		ans[0] = 1e9;
        dfs_h(1, -1, 0);
        rec(0);
		if (ans[0] == 1e9) {
			cout << -1 << endl;
            return 0;
		}
		cout << ans[0] << endl;
		for (int i = 1; i <= n; i++) cout << ans[i] << " ";
        cout << endl;
        return 0;
	}
    bool sub6 = false;
    int V;
    for (int i = 1; i <= n; i++) {
		if (nx[i].size() == n-1) sub6 = true, V = i;
    }
    if (sub6) {
		for (int i = 1; i <= n; i++) f[i] = 0;
		f[V] = 2;
        for (int i = 0; i < m; i++) {
            if (a[i] == V || b[i] == V) continue;
			NX[a[i]].push_back(b[i]);
			NX[b[i]].push_back(a[i]);
        }
		for (int i = 1; i <= n; i++) {
            if (i == V) continue;
            if (f[i] == 0) dfs(i, 1);
		}
        for (int i = 1; i <= n; i++) {
            if (f[i] == 0) f[i] = 1;
        }
        for (int i = 0; i < m; i++) {
			if (f[a[i]] == f[b[i]]) {
                cout << -1 << endl;
                return 0;
			}
        }
        int mx = 0;
		for (int i = 1; i <= n; i++) mx = max(mx, f[i]);
        cout << mx << endl;
        for (int i = 1; i <= n; i++) cout << f[i] << " ";
        cout << endl;
    }
    while (true) ;

	return 0;
}
