#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

int n, m;
vector <vector <int>> g;
vector <pii> t;
vector <int> tin, tout, par;
int tim = 0;
void dfs(int v = 0, int p = -1)
{
    tin[v] = tim++;
    for (auto &to : g[v])
        if (to != p)
            par[to] = v, dfs(to, v);
    tout[v] = tim++;
}

int check(int p, int v)
{
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}

signed main()
{
    Start();
    int type;
    cin >> n >> m >> type;
    g.resize(n);
    par.resize(n);
    tin.resize(n), tout.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v, --u, --v;
        g[u].pb(v), g[v].pb(u);
    }
    t.resize(m);
    for (auto &i : t)
        cin >> i, --i.first, --i.second;
    dfs();
    vector <int> c(n);
    for (auto &[a, b] : t)
    {
        int cur = 1;
        while (!check(a, b))
            c[a] = cur++, a = par[a];
        vector <int> pth;
        while (a != b)
            pth.pb(b), b = par[b];
        pth.pb(a);
        reverse(all(pth));
        for (auto v : pth)
            c[v] = cur++;
    }
    for (int &i : c)
        if (!i)
            i = 1;
    cout << *max_element(all(c)) << endl;
    if (type)
        cout << c;
    return 0;
}

