#include<bits/stdc++.h>

using namespace std;

int const maxn = 5e5 + 5;
vector < int > g[maxn], G[maxn], rev_G[maxn];
int tin[maxn], tout[maxn], lst[maxn], cur, sz[maxn];
vector < int > Q[maxn];
int out[maxn], ans[maxn];
int inf = 1e7 + 7;
int dp[maxn][2], STOP;
vector < pair < int, int > > F[maxn];

inline void add1(int u, int v) {
    if (tin[u] <= tin[v]) F[u].push_back({v, 0});
    else F[v].push_back({u, 0});
}

inline void add2(int v, int u, int x) {
    F[x].push_back({v, u});
}

void dfs(int v, int p) {
    lst[v] = p;
    tin[v] = cur++;
    for (auto u : g[v]) if (u != p) dfs(u, v);
    tout[v] = cur++;
}

void dfs1(int v, int p) {
    int child = 0;
    for (auto u : g[v]) {
        if (u == p) continue;
        child++;
        dfs1(u, v);
    }
    dp[v][0] = 1, dp[v][1] = STOP;
    if (child != 0) {
        for (auto u : F[v]) {
            if (u.second == 0) {
                dp[v][0] = max(dp[v][0], dp[u.first][0] + 1);
                dp[v][1] = min(dp[v][1], dp[u.first][1] - 1);
            }
            else {
                int L1 = dp[u.first][0] + 1, R1 = dp[u.second][1] - 1;
                int L2 = dp[u.second][0] + 1, R2 = dp[u.first][1] - 1;
                if (L1 > R1 && L2 > R2) {
                    dp[v][0] = inf;
                    dp[v][1] = -inf;
                }
                else {
                    int L, R;
                    if (L1 <= R1 && L2 <= R2) {
                        L = min(L1, L2), R = max(R1, R2);
                    }
                    else if (L1 <= R1) L = L1, R = R1;
                    else L = L2, R = R2;
                    dp[v][0] = max(dp[v][0], L);
                    dp[v][1] = min(dp[v][1], R);
                }
            }
        }
    }
}

void dfs2(int v, int p, int j) {
    //cout << v << " " << p << " " << j << endl;
    ans[v] = dp[v][j];
    for (auto u : F[v]) {
        if (u.second == 0) {
            dfs2(u.first, v, j);
        }
        else {
            int L1 = dp[u.first][0] + 1, R1 = dp[u.second][1] - 1;
            int L2 = dp[u.second][0] + 1, R2 = dp[u.first][1] - 1;
            if (L1 <= R1 && L2 <= R2) {
                if ((j == 0 && L1 <= L2) || (j == 1 && R1 <= R2)) {
                    dfs2(u.first, v, 0);
                    dfs2(u.second, v, 1);
                }
                else {
                    dfs2(u.second, v, 0);
                    dfs2(u.first, v, 1);
                }
            }
            else if (L1 <= R1) {
                dfs2(u.first, v, 0);
                dfs2(u.second, v, 1);
            }
            else {
                dfs2(u.first, v, 1);
                dfs2(u.second, v, 0);
            }
        }
    }
    for (auto u : g[v]) {
        if (ans[u] == 0) {
            if (dp[u][1] > 0) dfs2(u, v, 1);
            else dfs2(u, v, 0);
        }
    }
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, t, u, v;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0);
    if (n <= 15 && m <= 15) {
        for (int i = 1; i <= n; ++i) out[i] = -1;
        int best = inf;
        for (int i = 0; i < m; ++i) {
            cin >> u >> v;
            vector < int > T;
            while (1) {
                Q[i].push_back(u);
                if (tin[u] <= tin[v] && tout[v] <= tout[u]) break;
                u = lst[u];
            }
            while (1) {
                if (tin[v] <= tin[u] && tout[u] <= tout[v]) break;
                T.push_back(v);
                v = lst[v];
            }
            reverse(T.begin(), T.end());
            for (auto key : T) Q[i].push_back(key);
        }
        for (int mask = 0; mask < (1 << m); ++mask) {
            for (int i = 1; i <= n; ++i) G[i] = {}, rev_G[i] = {};
            for (int i = 0; i < m; ++i) {
                if ((mask&(1 << i)) > 0) {
                    for (int j = 0; j < (int)Q[i].size() - 1; ++j) G[Q[i][j]].push_back(Q[i][j + 1]), rev_G[Q[i][j + 1]].push_back(Q[i][j]);
                }
                else {
                    for (int j = (int)Q[i].size() - 1; j > 0; --j) G[Q[i][j]].push_back(Q[i][j - 1]), rev_G[Q[i][j - 1]].push_back(Q[i][j]);
                }
            }
            set < pair < int, int > > Q;
            for (int i = 1; i <= n; ++i) {
                sz[i] = (int)G[i].size();
                //cout << sz[i] << " ";
                Q.insert({sz[i], i});
            }
            //cout << endl;
            int mx = 0;
            while ((int)Q.size() > 0) {
                auto p = (*Q.begin());
                if (p.first != 0) {
                    mx = inf;
                    break;
                }
                ans[p.second] = 1;
                Q.erase(p);
                //cout << mask << " " << p.second << " " << p.first << endl;
                for (auto to : G[p.second]) ans[p.second] = max(ans[p.second], ans[to] + 1);
                mx = max(mx, ans[p.second]);
                for (auto to : rev_G[p.second]) {
                    Q.erase({sz[to], to});
                    sz[to]--;
                    Q.insert({sz[to], to});
                }
            }
            if (mx < best) {
                best = mx;
                for (int i = 1; i <= n; ++i) out[i] = ans[i];
            }
        }
        if (best == inf) cout << -1 << '\n';
        else {
            cout << best << '\n';
            for (int i = 1; i <= n; ++i) cout << out[i] << ' ';
        }
        return 0;
    }
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v;
        vector < int > T;
        int lca;
        while (1) {
            Q[i].push_back(u);
            if (tin[u] <= tin[v] && tout[v] <= tout[u]) break;
            u = lst[u];
        }
        lca = u;
        while (1) {
            if (tin[v] <= tin[u] && tout[u] <= tout[v]) break;
            T.push_back(v);
            v = lst[v];
        }
        reverse(T.begin(), T.end());
        for (auto key : T) Q[i].push_back(key);
        for (int j = 1; j < (int)Q[i].size(); ++j) {
            if (Q[i][j] != lca || j == (int)Q[i].size() - 1) {
                add1(Q[i][j - 1], Q[i][j]);
            }
            else {
                add2(Q[i][j - 1], Q[i][j + 1], Q[i][j]);
                ++j;
            }
        }
    }
    int lef = 0, righ = inf;
    while (righ - lef > 1) {
        int mid = (righ + lef) / 2;
        STOP = mid;
        for (int i = 1; i <= n; ++i) dp[i][0] = inf, dp[i][1] = -inf;
        dfs1(1, 0);
        int ok = 1;
        for (int i = 1; i <= n; ++i) {
            if (dp[i][0] > STOP && dp[i][1] <= 0) ok = 0;
        }
        if (ok) righ = mid;
        else lef = mid;
    }
    if (righ == inf) {
        cout << -1 << '\n';
        exit(0);
    }
    cout << righ << '\n';
    STOP = righ;
    dfs1(1, 0);
    if (dp[1][0] <= STOP) dfs2(1, 0, 0);
    else dfs2(1, 0, 1);
    for (int i = 1; i <= n; ++i) cout << ans[i] << " ";
    cout << '\n';
    return 0;
}

