#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

const int INF = 1e9;


vector<vector<int>> g;
std::map<pair<int, int>, bool> ord;
vector<int> w;
std::set<int> end;

void calc (int v, int p = -1) {
	if (p == -1)
		w[v] = 0;
	for (int u : g[v])
		if (u != p) {
			w[u] = w[v] + (1 - (int)ord[{u, v}] * 2);
			calc(u, v);
		}
}

bool calc1 (int v, int dist = 1, int last = 0, int p = -1) {
	if (p == -1)
		w[v] = 1;
	if (end.find(v) != end.end())
		last = dist;
	bool f = false;
	for (int u : g[v])
		if (u != p) {
			w[u] = dist + 1;
			if (!calc1(u, dist + 1, last, v) && last != dist)
				f  = true;
			
		}
	if (f && last != 0)
		w[v] = last - (dist - last) % 2;
	if (f && last == 0)
		w[v] = last + (dist - last) % 2;
}

vector<int> path (int v, int e, int p = -1) {
	if (v == e)
		return  {v};
	for (int u : g[v])
		if (u != p) {
			vector<int> pt = path(u, e, v);
			if (!pt.empty()) {
				pt.push_back(v);
				return pt;
			}
		}
	return {};
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int n, m, t;
	cin >> n >> m >> t;

	g.resize(n);
	w.resize(n);
	vector<pair<int, int>> edges;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
		edges.push_back({u, v});
	}
	vector<vector<int>> tunnels;
	vector<pair<int, int>> t1;
	bool f1 = true, f2 = true;
	int last1, last2;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		if (u > v)
			std::swap(u, v);
		t1.push_back({u, v});
		if (i == 0) {
			last1 = u, last2 = v;
		} else {
			if (last1 != u)
				f1 = false;
			if (last2 != v)
				f2 = false;
		}
		//tunnels.push_back(path(u, v));
	}
	
	if (n <= 15) {
		for (int i = 0; i < m; ++i)
			tunnels.push_back(path(t1[i].first, t1[i].second));
		vector<int> ans = {};
		int max = INF;
		for (int i = 0; i < (1 << n); ++i) {
			for (int j = 0; j < n; ++j) {
				ord[edges[j]] = (i & (1 << j));
				ord[{edges[j].second, edges[j].first}] = !ord[edges[j]];
			}
			bool f = false;
			for (auto& tunnel : tunnels) {
				for (int j = 2; j < tunnel.size(); ++j)
					if (ord[{tunnel[j], tunnel[j - 1]}] != ord[{tunnel[j - 1], tunnel[j - 2]}])
						f = true;
			}
			if (f)
				continue;
			calc(0);
			int d = INF;
			for (int i : w)
				d = std::min(d, i);
			int mx = 0;
			for (int &i : w) {
				i -= d - 1;
				mx = std::max(mx, i);
			}
			if (max > mx) {
				max = mx;
				ans = w;
			}
		}
		if (ans.empty()) {
			cout << -1;
			return 0;
		}

		cout << max << '\n';
		for (int i : ans)
			cout << i << ' ';
		return 0;
	}
	

	if (f2 = true)
		std::swap(last1, last2);

	for (int i = 0; i < m; ++i) {
		if (t1[i].first != last1)
			end.insert(t1[i].first);
		else
			end.insert(t1[i].second);
		
	}
	vector<int> ans = {};
	int max = INF;
	calc1(last1);
	int mx = 0;
	for (int i : w)
		mx = std::max(mx, i);
	cout << mx;
	for (int i : w)
		cout << i;

	return 0;
}