#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii pair<int, int>
#define int ll
#define vi vector<int>
#define pb push_back
using namespace std;
int n, t;
const int maxn = 16;

vi r[maxn];
vector<int> be[maxn];
map<pii, int> mp;
int used[maxn];

vi top;
void dfs(int v, bool tp = 0) {
    used[v] = 1;
    for (auto &u : r[v]) {
        if (!used[u] && mp[{v, u}]) {
            dfs(u, tp);
        }
    }
    if (tp)
        top.pb(v);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int n, m, t;
    cin >> n >> m >> t;
    vector<pii> edge;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        r[a].pb(b);
        r[b].pb(a);
        edge.pb({a, b});
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        be[a].pb(b);
        be[b].pb(a);
    }
    int k = 1e9;
    int ans[n];
    for (int mask = 0; mask < (1 << n - 1); mask++) {
        top.clear();
        for (int i = 0; i < n - 1; ++i) {
            if ((1 << i) & mask) {
                mp[edge[i]] = 1;
                mp[{edge[i].s, edge[i].f}] = 0;
            } else {
                mp[edge[i]] = 0;
                mp[{edge[i].s, edge[i].f}] = 1;
            }
        }
        int kek = 0;
        for (int i = 0; i < n; ++i) {
            memset(used, 0, sizeof(used));
            dfs(i);
            for (auto &u : be[i]) {
                kek += used[u];
            }
        }
        if (kek != m)
            continue;
        memset(used, 0, sizeof(used));
        for (int i = 0; i < n; ++i) {
            if (!used[i])
                dfs(i, 1);
        }
        int col[n];
        kek = 0;
        for (auto &i : top) {
            int max = 1;
            for (auto &u : r[i]) {
                if (mp[{i, u}])
                    max = std::max(max, col[u] + 1);
            }
            kek = std::max(max, kek);
            col[i] = max;
        }
        if (kek < k) {
            k = kek;
            for (int i = 0; i < n; ++i)
                ans[i] = col[i];
        }
    }
    if (k > 1e7) {
        cout << -1 << endl;
        exit(0);
    }
    cout << k << endl;
    for (auto &i : ans)
        cout << i << ' ';
    cout << endl;
    return 0;
}
