#include <bits/stdc++.h>

using namespace std;

#define int long long
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i,n,m) for(int i = n; i<m; ++i)
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define sc second
#define fr first

vector <vector <int> > g;
vector <int> d;
vector <int> tin, tout;
int timer = 0;

void dfs(int v, int p = -1)
{
    tin[v] = timer++;
    d[v] = p;
    for(auto u:g[v])
        if (u != p) dfs(u, v);
    tout[v] = timer++;
}

bool pr_check(int v, int u)
{
    if (v == -1) return false;
    return (tin[v] <= tin[u] && tout[v] >= tout[u]);
}

vector <int> ans;
set <pair<int,int> > rib;

void dfs2(int v, int p = -1)
{
    for(auto u:g[v])
    {
        if (rib.find({u,v}) != rib.end())
                ans[u] = max(ans[u], ans[v] + 1);
        if (u != p)
        {
            dfs2(u, v);
        }
    }
}

signed main()
{
    int n,m, k;
    cin >> n >> m >> k;
    g.resize(n);
    tin.resize(n), tout.resize(n);
    d.resize(n);
    ans.resize(n, 1);
    loop(i, n - 1)
    {
        int a,b;
        cin >> a >> b;
        --a,--b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0);
    loop(i, m)
    {
        int a,b;
        cin >> a >> b;
        --a,--b;
        if (pr_check(a, b))
        {
            int k = -1;
            while(b != a)
            {
                k = d[b];
                rib.insert({b, k});
                b = k;
            }
        } else if (pr_check(b, a))
        {
            int k = -1;
            while(a != b)
            {
                k = d[a];
                rib.insert({a, k});
                a = k;
            }
        } else
        {
            int k = -1;
            while(!pr_check(b, a))
            {
                k = d[b];
                rib.insert({b, k});
                b = k;
            }
            k = -1;
            while(a != b)
            {
                k = d[a];
                rib.insert({k, a});
                a = k;
            }
        }
    }
    /*for(auto u : rib)
        cout << u.first << ' ' << u.second << endl;*/
    dfs2(0);
    int mx = 0;
    loop(i, n) mx = max(mx, ans[i]);
    cout << mx << endl;
    loop(i, n) cout << ans[i] << ' ';
    /*
    3 1 1
    1 2
    2 3
    1 3
    */
}
