#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <random>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#pragma GCC optimize("no-stack-protector")
#define int long long
#define all(v) v.begin(),v.end()
using namespace std;
mt19937 rnd(time(nullptr));
int MAXN = 4e5;
vector<int>t(MAXN);
vector<vector<int>>g2;
vector<vector<int>>g1;
vector<int>used, c, dist;
int x;
void dfs(int v) {
    used[v] = 1;
    for (auto u : g2[v]) {
        if (!used[u]) {
            if (x % 2 == 0) {
                g1[v].push_back(u);
                c[u] = c[v] - 1;
            }
            else {
                g1[u].push_back(v);
                c[u] = c[v] + 1;
            }
            x /= 2;
            dfs(u);
        }
    }
}
void find(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (!used[u]) {
            find(u);
        }
    }
}
void anan(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (!used[u]) {
            anan(u);
        }
    }
}
void dfs2(int v) {
    for (auto u : g1[v]) {
        if (dist[u] == -1) {
            dist[u] = dist[v] + 1;
            dfs2(u);
        }
    }
}
signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n, m, t;
    cin >> n >> m >> t;
    if (n <= 15) {
        used.resize(n);
        g2.resize(n);
        c.resize(n);
        g1.resize(n);
        dist.resize(n);
        for (int i = 0; i < n - 1; i++) {
            int x, y;
            cin >> x >> y;
            x--; y--;
            g2[x].push_back(y);
            g2[y].push_back(x);
        }
        vector<pair<int, int>>a(m);
        for (int i = 0; i < m; i++) {
            cin >> a[i].first >> a[i].second;
            a[i].first--;
            a[i].second--;
        }
        vector<int>ans(n);
        int col = 1e9;
        // NO
        for (int q = 0; q < 40000; q++) {
            x = q;
            for (int i = 0; i < n; i++) {
                g1[i].clear();
            }
            for (int i = 0; i < n; i++) {
                used[i] = 0;
            }
            dfs(0);
            int ch = 0;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    used[i] = 0;
                }
                find(a[j].first);
                if (!used[a[j].second]) {
                    for (int i = 0; i < n; i++) {
                        used[i] = 0;
                    }
                    find(a[j].second);
                    if (!used[a[j].first]) {
                        ch = 1;
                    }
                }
                if (ch == 1) {
                    break;
                }
            }

            if (ch == 0) {
                int lma = 0;
                for (int j = 0; j < n; j++) {
                    for (int i = 0; i < n; i++) {
                        dist[i] = -1;
                    }
                    dist[j] = 1;
                    dfs2(j);
                    int z = 0;
                    for (int i = 0; i < n; i++) {
                        z = max(dist[i], z);
                    }
                    c[j] = z;
                    lma = max(lma, z);
                }
                if (lma < col) {
                    col = lma;
                    ans = c;
                }
            }
        }
        if (col == 1e9) {
            cout << -1;
            return 0;
        }
        cout << col << '\n';

        for (int i = 0; i < n; i++) {
            cout << ans[i] << " ";
        }

        return 0;
    }
    else {
        used.resize(n);
        g2.resize(n);
        c.resize(n);
        g1.resize(n);
        dist.resize(n);
        vector<int>asd(n);
        for (int i = 0; i < n - 1; i++) {
            int x, y;
            cin >> x >> y;
            x--; y--;
            g2[x].push_back(y);
            g2[y].push_back(x);
            asd[x]++;
            asd[y]++;
        }
        vector<pair<int, int>>a(m);
        vector<vector<int>>it(n);
        for (int i = 0; i < m; i++) {
            cin >> a[i].first >> a[i].second;
            a[i].first--;
            a[i].second--;
        }
        vector<int>ans(n);
        int col = 1e9;
        int num = 0;
        for (int i = 0; i < n; i++) {
            if (asd[i] == n - 1) {
                num = i;
            }
        }
        int cntcnt = 0;
        for (int i = 0; i < m; i++) {
            if (a[i].first != num && a[i].second != num) {
                it[a[i].first].push_back(a[i].second);
                it[a[i].second].push_back(a[i].first);
                cntcnt++;
            }
        }
        vector<int>how(n);
        vector<int>wh;
        for (int i = 0; i < n; i++) {
            if (how[i] == 0 && i != num) {
                how[i] = 1;
                wh.push_back(i);
                while (!wh.empty()) {
                    int v = wh.back();
                    wh.pop_back();
                    for (auto u : it[v]) {
                        if (how[u] != 0 && how[u] != -how[v]) {
                            cout << -1;
                            return 0;
                        }
                        if (how[u] == 0) {
                            how[u] = -how[v];
                            wh.push_back(u);
                        }
                    }
                }
            }
        }
        if (cntcnt == 0) {
            cout << 2 << '\n';
            for (int i = 0; i < n; i++) {
                if (i != num) {
                    cout << 1 << " ";
                } else {
                    cout << 2 << " ";
                }
            }
        } else {
            cout << 3 << '\n';
            for (int i = 0; i < n; i++) {
                cout << how[i] + 2 << " ";
            }
        }
        return 0;
    }
}
