#include <bits/stdc++.h>
#define int long long
#define double long double
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse2,sse3,ssse3")
using namespace std;

int n, m, t, lol;
vector<int> depth;
vector<int> polina[20];
vector<int> cnt;
vector<vector<int>> adj;
vector<pair<int, int>> ways;
vector<int> nastya;
vector<int> leaves;

void dfs(int x, int p, int d) {
    depth[x] = d;
    nastya[x] = d + 1;
    bool leaf = true;
    for (int i : adj[x]) {
        if (i != p) {
            leaf = false;
            polina[0][i] = x;
            dfs(i, x, d + 1);
        }
    }
    if (leaf) {
        leaves.push_back(x);
    }
}

int get(int v, int u) {
    if (depth[v] > depth[u]) {
        swap(v, u);
    }
    for (int i = 19; i >= 0; i--) {
        int k = polina[i][u];
        if (k == -1) continue;
        if (depth[k] >= depth[v]) {
            u = k;
        }
    }
    for (int i = 19; i >= 0; i--) {
        int a = polina[i][u];
        int b = polina[i][v];
        if (a != b) {
            u = a;
            v = b;
        }
    }
    if (u == v) {
        return u;
    } else {
        return polina[0][u];
    }
}

void go(int x) {
    if (x == -1) {
        return;
    }
    if (cnt[x] != 0) {
        return;
    }
    nastya[x] = 1;
    go(polina[0][x]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    adj.resize(n + 1);
    depth.resize(n + 1);
    cnt.resize(n + 1);
    nastya.resize(n + 1);
    for (int i = 0; i < 20; i++) {
        polina[i].resize(n + 1, -1);
    }
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    int target;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        ways.push_back({a, b});
        cnt[a]++;
        cnt[b]++;
    }
    for (target = 0; target < m; target++) {
        if (cnt[target] == m) {
            break;
        }
    }
    dfs(target, -1, 0);
    for (int i = 1; i < 20; i++) {
        for (int j = 1; j <= n; j++) {
            if (polina[i - 1][j] != -1) {
                polina[i][j] = polina[i - 1][polina[i - 1][j]];
            }
        }
    }
    for (int v : leaves) {
        go(v);
    }
    int lol = 0;
    for (int i = 1; i <= n; i++) {
        lol = max(lol, nastya[i]);
    }
    cout << lol << '\n';
    for (int i = 1; i <= n; i++) {
        cout << nastya[i] << ' ';
    }
    cout << '\n';
    fflush(stdout);
    return 0;
}
