#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())

using namespace std;

vector<int> tin, tout, p;
vector<vector<int>> up;
vector<vector<int>> gr;
vector<vector<int>> orgr;
int timer = 0;
void dfsbin(int u, int par){
    tin[u] = timer++;
    up[u][0] = u;
    up[u][1] = par;
    p[u] = par;
    for(int l = 1; l < 39; ++l){
        if(up[u][l] != -1) up[u][l + 1] = up[up[u][l]][l];
    }
    for(int v : gr[u]){
        if(v != par)
            dfsbin(v, u);
    }
    tout[u] = timer++;
}

bool upper(int a, int b){
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b){
    if(upper(a, b)) return a;
    if(upper(b, a)) return b;
    for(int l = 39; l >= 0; --l){
        if(up[a][l] != -1 && !upper(up[a][l], b)){
            a = up[a][l];
        }
    }
    return up[a][1];
}
vector<int> ans;


void increase(int u, int v){
    while(!upper(u, v)){
        orgr[p[u]].push_back(u);
        u = p[u];
    }
    while(u != v){
        int glw;
        for(int w : gr[u]){
            if(upper(w, v) && w != p[u]){
                glw = w;
                break;
            }
        }
        orgr[glw].push_back(u);
        u = glw;
    }
}

bool fl = true;
vector<bool> used;
vector<int> topsort;


void ordfs(int u){
    used[u] = 1;
    ans[u] = 0;
    for(int v : orgr[u]){
        if(used[v] == 1) fl = false;
        if(used[v]){
            ordfs(v);
            ans[u] = max(ans[v], ans[u]);
        }
    }
    ans[u]++;
}

void justplace(int u){
    used[u] = 2;
    for(int v : orgr[u]){
        if(used[v] == 1){
            ordfs(v);
        }
    }
}

void solve(){
    int n, m, t;
    cin >> n >> m >> t;
    tin.assign(n, 0);
    tout.assign(n , 0);
    p.assign(n, -1);
    gr.resize(n);
    orgr.resize(n);
    ans.assign(n, 1);
    up.assign(n, vector<int>(40, -1));
    for(int i = 1; i < n; ++i){
        int a, b;
        cin >> a >> b;
        --a; --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    dfsbin(0, -1);
    vector<pii> quar(m);
    for(int i = 0; i < m; ++i){
        cin >> quar[i].first >> quar[i].second;
        --quar[i].first;
        --quar[i].second;
        increase(quar[i].first, quar[i].second);
    }
    used.resize(n);
    for(int i = 0; i < n; ++i){
        if(!used[i]) ordfs(i);
        if(fl) justplace(i);
    }
    if(fl){
        cout << -1;
        return;
    }
    int k = 0ll;
    for(int i = 0; i < n; ++i) k = max(ans[i], k);
    cout << k << endl;
    for(int i : ans) cout << i << ' ';

}
signed main(){
    //ios::sync_with_stdio(0); cin.tie(0);
    solve();
}
