
#include<bits/stdc++.h>

#define int long long
#define all(x) begin(x), end(x)
#define x first
#define y second

using namespace std;

void fast() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

const int MAXN = 5e5 + 10;
const int MAXLOG = 20;

vector<vector<int>> g;
vector<int> ans, par, d;
int n, m, t;
int up[MAXLOG][MAXN];

void dfs(int u, int p, int dep) {
    ans[u] = 1;
    par[u] = p;
    d[u] = dep;
    for(auto v : g[u]) {
        if(v != p) {
            dfs(v, u, dep + 1);
        }
    }
}

void build() {
    for(int i = 0; i < n; i++) {
        up[0][i] = par[i];
    }
    for(int i = 1; i < MAXLOG; i++) {
        for(int j = 0; j < n; j++) {
            up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
}

pair<int, int> lca(int a, int b) {
    if(d[a] < d[b]) {
        swap(a, b);
    }
    int len = 0;
    for(int i = MAXLOG - 1; i >= 0; i--) {
        if(d[a] - (1 << i) >= d[b]) {
            len += (1 << i);
            a = up[i][a];
        }
    }
    if(a == b) {
        return {a, len};
    }
    for(int i = MAXLOG - 1; i >= 0; i--) {
        if(up[i][a] != up[i][b]) {
            a = up[i][a];
            b = up[i][b];
            len += (1 << (i + 1));
        }
    }
    return {par[a], len + 2};
}

vector<vector<int>> g2;
vector<int> lol;
vector<bool> used;
bool flag = 0;

void dfs2(int u, int p, int dep) {
    used[u] = 1;
    if(dep % 2) {
        lol[u] = 3;
    }
    else {
        lol[u] = 1;
    }
    for(auto v : g2[u]) {
        if(!used[v]) {
            dfs2(v, u, dep + 1);
        }
        else if(v != p) {
            flag = 1;
        }
    }
}

signed main() {
    fast();
    cin >> n >> m >> t;
    g.resize(n);
    par.resize(n);
    d.resize(n);
    ans.resize(n);
    g2.resize(n);
    lol.resize(n, 1);
    used.resize(n);
    int root;
    for(int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if(g[u].size() == n - 1) {
            root = u;
        }
        else if(g[v].size() == n - 1) {
            root = v;
        }
    }
//    cerr << root << '\n';
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if(u == root || v == root) {
            continue;
        }
        else {
            g2[u].push_back(v);
            g2[v].push_back(u);
        }
    }
    lol[root] = 2;
    for(int i = 0; i < n; i++) {
        if(i != root && !used[i]) {
            dfs2(i, -1, 0);
            break;
        }
    }
    if(flag) {
        cout << -1;
    }
    else {
        cout << *max_element(all(lol)) << '\n';
        if(t != 0) {
            for(auto i : lol) {
                cout << i << " ";
            }
        }
    }
//    dfs(0, -1, 0);
//    build();
//    vector<pair<int, int>> kek(m);
//    for(int i = 0; i < m; i++) {
//        int a, b;
//        cin >> a >> b;
//        a--;
//        b--;
//        if(d[a] < d[b]) {
//            swap(a, b);
//        }
//        kek[i] = {a, b};
//    }
//    sort(all(kek), [&](pair<int, int> a, pair<int, int> b) {
//        return lca(a.x, a.y).y > lca(b.x, b.y).y;
//    });
//    for(auto i : kek) {
//        int a = i.x;
//        int b = i.y;
//        int cur = ans[a];
//        while(a != par[lca(a, b).x]) {
//            ans[a] = max(cur, ans[a]);
//            cur = ans[a] + 1;
//            a = par[a];
//        }
//    }
//    cout << *max_element(all(ans)) << '\n';
//    for(auto i : ans) {
//        cout << i << " ";
//    }
    return 0;
}
