#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"
#define x first
#define y second 
#define vec vector
#define pii pair<int, int>
#define pb push_back

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	srand(time(0));
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}

const int MAXN = 500000 + 10, INF = 1e9;
vec<int> g[MAXN];
int n, m, t;
vec<int> prefix;
int ansc = INF;
vec<int> c;
int cnt1 = 0, cnt2 = 0;
vec<int> path;
vec<pii> dt;
int len = 0;

void dfs(int v, int p, int b, vec<int> &cur) {
	path.pb(v);
	if (v == b) {
		for (int i = 0; i < path.size() - 1; ++i) {
			if (cur[path[i]] < cur[path[i + 1]]) {
				cnt1++;
			}
			if (cur[path[i]] > cur[path[i + 1]]) {
				cnt2++;
			}
		}
		len = path.size() - 1;
		return;
	}	
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v, b, cur);
		}
	}
	path.pop_back();
}

void gen(int i) {
	if (i == n) {
		int mx = *max_element(prefix.begin(), prefix.end());
		if (mx >= ansc) return;
		vec<int> cur(n + 1);
		for (int i = 1; i <= n; ++i) {
			cur[i] = prefix[i - 1];
		}
		bool flag = true;
		for (auto it : dt) {
			cnt1 = 0, cnt2 = 0;
			path.clear();
			dfs(it.x, 0, it.y, cur);
			if (cnt1 != len && cnt2 != len) {
				flag = false;
				break;
			}
		}	
		if (flag) {
			ansc = mx;
			c = cur;
		}
		return;
	}

	for (int d = 1; d <= 9; ++d) {
		prefix.pb(d);
		gen(i + 1);
		prefix.pop_back();
	}
}

void solve() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
		g[v].pb(u);
	}

	dt.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> dt[i].x >> dt[i].y;
	}

	gen(0);

	// vec<int> cur = {0, 1, 2, 3};
	// for (auto it : dt) {
	// 	dfs(it.x, 0, it.y, cur);
	// 	cout << cnt1 << " " << cnt2 << " " << len << endl;
	// }

	if (ansc == INF) {
		cout << -1 << endl;
	}
	else {
		cout << ansc << endl;
		for (int i = 1; i <= n; ++i) {
			cout << c[i] << " ";
		}
	}
}