#pragma GCC target("avx2")
#pragma GCC optimize("O3") 

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x)) 
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
//#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)5e5 + 123;
const ll inf = (ll)1e18 + 123;

const double pi = acos(-1.0);
const double eps = 1e-7;
const int dx[] = {0, 0, 0, -1, 1};
const int dy[] = {0, 1, -1, 0, 0};

int n, m, t, up[21][N], tin[N], tout[N], timer, c[N], ans[N], res = mod;
vector <int> g[N];
int used[N];
bool cycle;
int A[N], B[N];
vector <int> w[N];
queue <int> qwe;
pii q[N];
int p[N], cl[N];

void build (int v = 1, int pr = 0) {
	tin[v] = ++ timer;
	up[0][v] = pr;
	for (int i = 1; i <= 20; i ++)
		up[i][v] = up[i - 1][up[i - 1][v]];
	for (auto to : g[v])
		if (to != pr)	
			build (to, v);
	tout[v] = timer;
}

inline bool is_parent (int a, int b) {
	return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

inline int lca (int a, int b) {
	if (is_parent (a, b)) return a;
	if (is_parent (b, a)) return b;
	for (int i = 20; i >= 0; i --)
		if (up[i][a] && !is_parent (up[i][a], b)) 
			a = up[i][a];
	return up[0][a];
}

void precalc (int v) {
	used[v] = 1;
	for (auto to : w[v]) {
		if (used[to] == 1)
			cycle = 0;
		if (used[to] == 0)
			precalc (to);
	}
	used[v] = 2;
}

int cnt[N];

void sub (int v = 1, int par = 0) {
	int cur = 0;
	for (auto to : g[v]) {
		if (to == par) continue;
		sub (to, v);
		if (!q[to].F) continue;
		if (q[to].F != v) {
		   if (q[v].F) assert (0);
			q[v] = q[to], cur ++;
		}
		if (!q[to].S) w[to].pb (v), cnt[v] ++;//, cout << "edge: " << to << ' ' << v << endl;
		else w[v].pb (to), cnt[to] ++;//, cout << "edge: " << v << ' ' << to << endl;
	}	
	if (cur > 1) assert (0);
}

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}

inline void Solve () {
	boost ();
	cin >> n >> m >> t;
	for (int i = 1; i < n; i ++) {
		int x, y;
		cin >> x >> y;
		g[x].pb (y);
		g[y].pb (x);
	}
	build ();
	if (n <= 15 && m <= 15) {
		for (int i = 0; i < m; i ++) cin >> A[i] >> B[i];
		for (int mask = 0; mask < (1 << m); mask ++) {
		   cycle = 1;
			for (int i = 1; i <= n; i ++) w[i].clear (), cnt[i] = c[i] = used[i] = 0;
			for (int i = 0; i < m; i ++) {
				int _lca = lca (A[i], B[i]);
				bool prior = ((mask & (1 << i)) > 0);
				int x = A[i];
				while (x != _lca) {
					if (prior) w[up[0][x]].pb (x), cnt[x] ++;
					else w[x].pb (up[0][x]), cnt[up[0][x]] ++;
					x = up[0][x];
				}
				x = B[i];
				while (x != _lca) {
					if (!prior) w[up[0][x]].pb (x), cnt[x] ++;
					else w[x].pb (up[0][x]), cnt[up[0][x]] ++;
					x = up[0][x];
				}
			}		
      	cycle = 1;
      	for (int i = 1; i <= n; i ++)
      		if (!used[i])
      			precalc (i);
			if (!cycle) continue;
      	for (int i = 1; i <= n; i ++)
      		if (!cnt[i])
      			c[i] = 1, qwe.push (i);
      	while (sz (qwe)) {
      		int v = qwe.front ();
      		qwe.pop ();
      		for (auto to : w[v]) {
      			if (c[to] > c[v]) continue;
      			c[to] = c[v] + 1;
      			qwe.push (to);
      		}
      	}
      	if (res > *max_element (c + 1, c + n + 1)) {
      		res = *max_element (c + 1, c + n + 1);
      		for (int i = 1; i <= n; i ++) ans[i] = c[i];
      	}
		}
		if (res == mod) cout << -1, exit (0);
		cout << res << endl;
		for (int i = 1; i <= n; i ++) cout << ans[i] << ' ';
		exit (0);
	}
	for (int i = 1; i <= m; i ++) {
		int x, y;
		cin >> x >> y;
		int _lca = lca (x, y);
		if (x != _lca) q[x] = {_lca, 0};
		if (y != _lca) q[y] = {_lca, 1};
	}
	sub ();
	cycle = 1;
	for (int i = 1; i <= n; i ++)
		if (!used[i])
			precalc (i);
	for (int i = 1; i <= n; i ++)
		if (!cnt[i])
			c[i] = 1, qwe.push (i);
	if (!sz (qwe)) assert (0);
	while (sz (qwe)) {
		int v = qwe.front ();
		qwe.pop ();
		for (auto to : w[v]) {
			if (c[to] > c[v]) continue;
			c[to] = c[v] + 1;
			qwe.push (to);
		}
	}
	if (*min_element (c + 1, c + n + 1) == 0) assert (0);
	cout << *max_element (c + 1, c + n + 1) << endl;
	for (int i = 1; i <= n; i ++) cout << c[i] << ' ';
	
}

int main () {
   int tt = 1;
   //cin >> tt;
   while (tt --) Solve (); 
	return 0;
}