#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, 10);
typedef pair <int, int> pii;

const int N = 500007;
int n, m, t, deg[N], col[N], used[N];
vector <int> q[N], g[N];

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!col[to]) {
            if (col[v] == 1) {
                col[to] = 3;
            }   else {
                col[to] = 1;
            }
        }   else {
            if (col[v] == col[to]) {
                cout << -1;
                exit(0);
            }
        }
        if (!used[to]) {
            dfs(to);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    cin >> n >> m >> t;
    int x, y;
    for (int i = 1; i <= n - 1; i++) {
        cin >> x >> y;
        q[x].pb(y);
        q[y].pb(x);
        deg[x]++;
        deg[y]++;
    }
    int root = 1;
    for (int i = 1; i <= n; i++) {
        if (deg[i] > 1) {
            root = i;
        }
    }
    vector <pii> path;
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        path.pb({x, y});
        if (x == root) {
            col[x] = 2;
        }   else if (y == root) {
            col[y] = 2;
        }   else {
            g[x].pb(y);
            g[y].pb(x);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            col[i] = 1;
            dfs(i);
        }
    }
    int cnt = 1;
    for (int i = 1; i <= n; i++) {
        cnt = max(cnt, col[i]);
    }
    if (cnt != 1) {
        col[root] = 2;
    }
    cout << cnt << '\n';
    for (int i = 1; i <= n; i++) {
        cout << col[i] << ' ';
    }
}
