#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <queue>
#include <deque>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string.h>
#include <time.h>
#include <random>
#include <assert.h>

using namespace std;

typedef long long ll;
#define ff first
#define ss second
#define mp make_pair
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define vpii vector<pii>
#define make_unique(x) sort(x.begin(),x.end()); x.resize(unique(x.begin(),x.end()) - x.begin());
#define sz(x) ((int)x.size())
#define pb push_back
#define eb emplace_back

inline int nxt() {
	static int buf_nxt;
	cin >> buf_nxt;
	return buf_nxt;
}

inline ll nxtll() {
	static ll buf_nxt_ll;
	cin >> buf_nxt_ll;
	return buf_nxt_ll;
}


#define N (20)

vi g[N];
vi og[N];
pii p[N];
int par[N];
bool used[N];

int h[N];
int parent[N];

void calc_h(int v) {
	for (auto u : g[v]) {
		if (u == parent[v]) continue;
		h[u] = h[v] + 1;
		parent[u] = v;
		calc_h(u);
	}
}

void bfs(int a, int b) {

	//memset(par, 255, sizeof(par));
	//memset(used, 0, sizeof(used));
	//queue<int>q;
	//q.push(a);
	//while (q.size()) {
	//	int v = q.front();
	//	q.pop();
	//	used[v] = true;
	//	for (auto u : g[v]) {
	//		if (!used[u]) {
	//			q.push(u);
	//			par[u] = v;
	//		}
	//	}
	//}
	//while (b != a) {
	//	og[b].push_back(par[b]);
	//	b = par[b];
	//}
	if (h[a] < h[b]) {
		swap(a, b);
	}
	while (h[a] != h[b]) {
		og[a].push_back(parent[a]);
		a = parent[a];
	}
	while (a != b) {
		og[a].push_back(parent[a]);
		a = parent[a];
		og[parent[b]].push_back(b);
		b = parent[b];
	}
}

int c[N];
int ansc[N];

int col[N];
bool cyc = false;

void cycle(int v) {
	col[v] = 1;
	for (auto u : og[v]) {
		if (col[u] == 1) {
			cyc = true;
		}
		if (col[u] == 0) {
			cycle(u);
		}
	}
	col[v] = 2;
}

void dfs(int v) {
	for (auto u : og[v]) {
		if (!used[u]) dfs(u);
		dfs(u);
	}
	c[v] = 1;
	for (auto u : og[v]) {
		c[v] = max(c[v], c[u] + 1);
	}
}

const int inf = 1e9;

void solution() {
	int n = nxt();
	int m = nxt();
	int t = nxt();
	for (int i = 0; i < n - 1; i++) {
		int a = nxt(), b = nxt();
		g[a].pb(b);
		g[b].pb(a);
	}
	for (int i = 0; i < m; i++) {
		int a = nxt(), b = nxt();
		p[i] = { a,b };
	}
	int k = inf;
	calc_h(1);
	if (m <= 15) {
		for (int mask = 0; mask < (1 << m); mask++) {
			for (int i = 0; i < N; i++) og[i].clear();
			for (int i = 0; i < m; i++) {
				if (mask & (1 << i)) {
					bfs(p[i].ff, p[i].ss);
				}
				else {
					bfs(p[i].ss, p[i].ff);
				}
			}
			memset(col, 0, sizeof(col));
			cyc = false;
			for (int i = 1; i <= n; i++) {
				if (!col[i]) {
					cycle(i);
				}
			}
			if (cyc) {
				continue;
			}
			memset(used, 0, sizeof(used));
			for (int i = 1; i <= n; i++) {
				if (!used[i]) {
					dfs(i);
				}
			}
			if (*max_element(c + 1, c + n + 1) < k) {
				k = *max_element(c + 1, c + n + 1);
				memcpy(ansc, c, sizeof(c));
			}
		}
	}
	else {
		assert(false);
	}
	if (k == inf) {
		cout << -1;
	}
	else {
		cout << k << endl;
		for (int i = 1; i <= n; i++) {
			cout << ansc[i] << " ";
		}
	}
}


int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	srand(239);
	solution();
	return 0;
}