#include <bits/stdc++.h>

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 501000;
int n, m, t;
vector<int> graph[N];
int a[N], b[N];
int V[N], U[N];
int go[1000][1000];

void dfs(int v, int p, int st, int save)
{
    go[v][st] = save;
    for (auto id : graph[v]) if (V[id] + U[id] - v != p) dfs(V[id] + U[id] - v, v, st, id);
}

vector<int> lines[N];
vector<int> here[N];

vector<int> keks[N];
int c[N];

void dfskeks(int v, int col)
{
    for (auto u : keks[v])
    {
        if (c[v] == c[u])
        {
            cout << "-1";
            exit(0);
        }
        if (c[u] == 0)
        {
            c[u] = 4 - col;
            dfskeks(u, 4 - col);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++)
    {
        cin >> V[i] >> U[i];
        V[i]--, U[i]--;
        graph[V[i]].push_back(i);
        graph[U[i]].push_back(i);
    }
    for (int i = 0; i < m; i++)
    {
        cin >> a[i] >> b[i];
        a[i]--, b[i]--;
    }
    //cout << "Ok" << endl;
    if (0 && m <= 15)
    {
        for (int i = 0; i < n; i++)
        {
            dfs(i, -1, i, -1);
        }
        int ans = 1e9;
        vector<int> c(n);
        for (int mask = 0; mask < (1 << m); mask++)
        {
            vector<int> wh(n - 1, -1);
            vector<int> fr(n - 1, -1);
            int t = 1;
            //cout << "! " << mask << endl;
            for (int i = 0; i < m; i++)
            {
                int x = a[i];
                int f = b[i];
                if ((1 << i) & mask) swap(x, f);
                while (x != f)
                {
                    int y = go[x][f];
                    int z = V[y] + U[y] - x;
                    if (wh[y] != z && wh[y] >= 0) t = 0;
                    wh[y] = z;
                    fr[y] = x;
                    x = z;
                }
            }
            //cout << 1 << " " << t << endl;
            if (t)
            {
                //cout << mask << endl;
                vector<int> in(n);
                for (int i = 0; i < n - 1; i++)
                {
                    if (wh[i] != -1)
                        in[wh[i]]++;
                }
                vector<int> d(n);
                int cnt = n;
                for (int i = 1; cnt > 0; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (in[j] == 0 && d[j] == 0)
                        {
                            d[j] = i;
                            cnt--;
                        }
                    }
                    for (int j = 0; j < n - 1; j++)
                    {
                        if (fr[j] != -1 && d[fr[j]] == i) in[wh[j]]--;
                    }
                    if (cnt == 0)
                    {
                        ans = min(ans, i);
                        if (i == ans) c = d;
                    }
                }
                //cout << mask << "\n";
            }
        }
        if (ans == 1e9)
        {
            cout << -1;
            return 0;
        }
        cout << ans << "\n";
        for (int i = 0; i < n; i++) cout << c[i] << " ";
        return 0;
    }
    if (n == 2 && t == 1)
    {
        cout << 2 << "\n" << 1 << " " << 2;
        return 0;
    }
    if (n == 2 && t == 0)
    {
        cout << 2;
        return 0;
    }
    int cen = 0;
    for (int i = 0; i < n; i++)
    {
        if (graph[i].size() != 1)
            cen = i;
    }
    int q = 0;
    for (int i = 0; i < m; i++)
    {
        if (a[i] != cen && b[i] != cen)
        {
            q++;
        }
    }
    if (q == 0)
    {
        cout << 2 << "\n"; if (t == 0) return 0;
        for (int i = 0; i < n; i++)
        {
            if (i == cen) cout << 1 << " ";
            else cout << 2 << " ";
        }
        return 0;
    }
    for (int i = 0; i < m; i++)
    {
        if (a[i] == cen || b[i] == cen) continue;
        keks[a[i]].push_back(b[i]);
        keks[b[i]].push_back(a[i]);
    }
    for (int i = 0; i < m; i++)
    {
        if (c[a[i]] == 0 && c[b[i]] == 0)
        {
            c[a[i]] = 1, c[b[i]] = 3;
            dfskeks(b[i], 3);
            dfskeks(a[i], 1);
        }
    }
    cout << 3 << "\n"; if (t == 0) return 0;
    for (int i = 0; i < n; i++)
    {
        if (i == cen)
        {
            cout << 2 << " ";
        }
        else
        {
            if (c[i] == 0) cout << 1 << " ";
            else cout << c[i] << " ";
        }
    }
    return 0;
}

/*
6 3 1
3 4
3 5
3 1
3 2
3 6

6 2
6 3
3 2

*/
