// ConsoleApplication3.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include<vector>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<algorithm>
#include<string>

typedef long long lli;
typedef long double ld;
using namespace std;
#define int long long
#define forn(i, s, f) for(int i = s; i < f; i++)
#define fora(i, n) for(auto i : n)
#define sz(a) (int)a.size()
#define ft first
#define sec second
#define pb push_back
#define fast_  ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
vector<vector<int>> lca(1e5 +5, vector<int>(25));
vector<int> tin, tout;
int timer = 0;

pair<bool, bool> dfs(int v, int u, int pr, vector<vector<int>> & g, vector<vector<int>> & nap) {
    if (v == u) {
        return { true, true };
    }
    fora(i, g[v]) {
        if (i != pr) {
            pair<bool, bool> res = dfs(i, u, v, g, nap);
            if (res.ft == true) {
                if (res.sec == true) {
                    if (nap[v][i] != -1) {
                        nap[v][i] = 1;
                        nap[i][v] = -1;
                        return { true, true };
                    }
                    else {
                        return { true, false };
                    }
                }
                return { true, false };
            }
        }
    }
    return { false, false };
}

int dfs2(int v, int pr, vector<vector<int>>& g, vector<int>& an) {
    if (an[v] != -1) {
        return an[v];
    }
    int k = 0;
    fora(i, g[v]) {
        if (i != pr) {
            k = max(k, dfs2(i, v, g, an));
        }
    }
    an[v] = k + 1;
    return k + 1;
}

void dfs(int v, int pr, vector<vector<int>>& g, vector<int>& pre) {
    tin[v] = timer;
    timer++;
    pre[v] = pr;
    fora(u, g[v]) {
        if (u != pr) {
            dfs(u, v, g, pre);
        }
    }
    tout[v] = timer;
    timer++;
}

bool pred(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int get(int v, int u) {
    if (pred(v, u)) {
        return v;
    }
    if (pred(u, v)) {
        return u;
    }
    for (int i = 24; i >= 0; i--) {
        if (!pred(lca[v][i], u)) {
            v = lca[v][i];
        }
    }
    return lca[v][0];
}

bool dfs3(int v, vector<vector<int>>& g, vector<int>& col, int fl) {
    //cout << "v " << v << endl;
    col[v] = fl;
    fora(i, g[v]) {
        if (col[i] == 0) {
            if (!dfs3(i, g, col, -fl)) {
                return false;
            }
        }
        else {
            if (col[i] == fl) {
                return false;
            }
        }

    }
    return true;
}

signed main()
{
    fast_;
   // cout << (1LL << 15) * 15 * 15;
    int n, m, t;
    cin >> n >> m >> t;
    if (n <= 15 && m <= 15) {
        vector<pair<int, int>> reb(n - 1);
        vector<vector<int>> g(n);

        forn(i, 0, n - 1) {
            cin >> reb[i].ft >> reb[i].second;
            reb[i].ft--;
            reb[i].second--;
            g[reb[i].ft].pb(reb[i].sec);
            g[reb[i].sec].pb(reb[i].ft);
        }
        vector<pair<int, int>> reb2(m);
        forn(i, 0, m) {
            cin >> reb2[i].ft >> reb2[i].second;
            reb2[i].ft--;
            reb2[i].second--;
        }
        int mask = (1LL << m);
        int ma = 1e9;
        vector<int> ans(n);
        forn(i, 0, mask) {
            vector<vector<int>> nap(n, vector<int>(n, 0));
            int fl = 0;
            forn(j, 0, m) {
                if ((i | (1LL << j)) == i) {
                    pair<bool, bool> res = dfs(reb2[j].ft, reb2[j].second, -1, g, nap);
                    if (!res.second) {
                        fl = 1;
                        break;
                    }
                }
                else {
                    pair<bool, bool> res = dfs(reb2[j].sec, reb2[j].ft, -1, g, nap);
                    if (!res.second) {
                        fl = 1;
                        break;
                    }
                }
            }
            if (fl == 0) {
                // cout << "A\n";
                vector<vector<int>> g2(n);
                vector<int> an(n, -1);
                forn(i, 0, n) {
                    forn(j, 0, n) {
                        if (nap[i][j] == 1) {
                            g2[j].pb(i);
                            // cout << j << " " << i << endl;
                        }
                    }
                }
                int cu = 0;
                forn(i, 0, n) {
                    dfs2(i, -1, g2, an);
                    cu = max(cu, an[i]);
                }
                if (cu < ma) {
                    ma = cu;
                    forn(i, 0, n) {
                        ans[i] = an[i];
                    }
                }
            }
        }
        if (ma == 1e9) {
            cout << -1;
        }
        else {
            cout << ma << "\n";
            forn(i, 0, n) {
                cout << ans[i] << " ";
            }
        }
    }
    else {
        vector<vector<int>> g(n);
        vector<int> pre(n);
        vector<pair<int, int>> reb;
        map<pair<int, int>, int> M;
        forn(i, 0, n - 1) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[a].pb(b);
            g[b].pb(a);
            M[{a, b}] = i;
            M[{b, a}] = i;
            reb.pb({ a, b });
        }
        tin.resize(n);
        tout.resize(n);
        dfs(0, -1, g, pre);
        pre[0] = 0;
        //cout << "A\n";
        forn(i, 0, n) {
            lca[i][0] = pre[i];
        }
        forn(i, 1, sz(lca[0])) {
            forn(j, 0, n) {
                lca[j][i] = lca[lca[j][i - 1]][i - 1];
            }
        }
      //  cout << "B\n";
        vector<vector<int>> g2((1e6) * 3);
        int ind = 0;
        forn(i, 0, m) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            int lc = get(a, b);
          //  cout << lc << endl;
            int cu = a;
            while (cu != lc) {
                g2[M[{cu, pre[cu]}]].pb(ind + n);
                g2[ind + n].pb(M[{cu, pre[cu]}]);
                cu = pre[cu];
            }
          //  cout << "C\n";
            cu = b;
            while (cu != lc) {
               // cout << cu << " " << M[{cu, pre[cu]}] << endl;
                
                g2[M[{cu, pre[cu]}]].pb(ind + n + 1);
                g2[ind + n + 1].pb(M[{cu, pre[cu]}]);
                cu = pre[cu];
            }
            g2[ind + n].pb(ind + n + 1);
            g2[ind + n + 1].pb(ind + n);
            ind += 2;
        }
      //  cout << "D\n";
        vector<int> col(ind + n, 0);
        forn(i, 0, sz(col)) {
            //cout << "i " << i << endl;
            if (col[i] == 0) {
                if (!dfs3(i, g2, col, 1)) {
                    cout << -1;
                    return 0;
                }
            }
        }
       // cout << "E\n";
        vector<vector<int>> g3(n);
        forn(i, 0, n - 1) {
            int a = reb[i].ft, b = reb[i].second;
            if (pre[a] == b) {
                swap(a, b);
            }
            if (col[i] == 1) {
                g3[a].pb(b);
               // cout << a << " " << b << endl;
            }
            else {
                g3[b].pb(a);
                //cout << b << " " << a << endl;
            }
        }
        vector<int> an(n, -1);
        int cu = 0;
        forn(i, 0, n) {
            dfs2(i, -1, g3, an);
            cu = max(cu, an[i]);
        }
        cout << cu << "\n";
        fora(i, an) {
            cout << i << " ";
        }

    }
    return 0;
}
/*
7 3 1
1 4
1 2
2 3
3 5
3 6
6 7
7 4
5 2
7 6
*/
// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
