#include <bits/stdc++.h>

using namespace std;
using ll = long long;
// #define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
int n, m, k;
const int MAXN = 105;
vector<int> g[MAXN];
bool g1[MAXN][MAXN];
pair<int, int> lines[MAXN];
int tin[MAXN], tout[MAXN], p[MAXN], in_degree[MAXN];
int timer = 1;
void dfs(int v, int pp){
	tin[v] = timer++;
	p[v] = pp;
	for (int u : g[v])
		if (u != pp)
			dfs(u, v);
	tout[v] = timer++;
}
inline bool is_anc(int a, int b){
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int solve(){
	if (!(cin >> n >> m >> k))
		return 1;
	for (int i = 1; i < n; i++){
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0, -1);
	int pnt = 0;
	for (int i = 0; i < m; i++){
		int a, b;
		cin >> a >> b;
		--a, --b;
		lines[i] = {a, b};
	}
	vector<int> best(n, 1e7);
	int mx = 1e7;
	for (int mask = 0; mask < (1 << m); mask++){
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				g1[i][j] = 0;
		bool good = 1;
		vector<int> now(n, 0);
		for (int i = 0; i < m; i++){
			if ((1 << i) & mask)
				swap(lines[i].first, lines[i].second);
			auto [a, b] = lines[i];
			while (p[a] != -1 && !is_anc(a, b)){
				if (g1[p[a]][a]){
					good = 0;
					break;
				}
				// cerr << a << "->" << p[a] << '\n';
				g1[a][p[a]] = 1;
				a = p[a];
			}
			while (p[b] != -1 && b != a){
				if (g1[b][p[b]]){
					good = 0;
					break;
				}
				g1[p[b]][b] = 1;
				// cerr << p[b] << "->" << b << '\n';
				b = p[b];
			}
			// cerr << mask << ' ' << good << '\n';
			if (!good){
				break;
			}
		}
		if (good){
			for (int i = 0; i < n; i++)
				in_degree[i] = 0;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++)
					if (g1[i][j])
						in_degree[j]++;
			deque<int> q;
			for (int i = 0; i < n; i++)
				if (in_degree[i] == 0){
					cerr << "!" << i << '\n';
					q.push_back(i);
					now[i] = 1;
				}
			while (SZ(q)){
				int v = q.front();
				q.pop_front();
				for (int i = 0; i < n; i++)
					if (g1[v][i]){
						now[i] = max(now[i], now[v] + 1);
						in_degree[i]--;
						if (in_degree[i] == 0)
							q.push_back(i);
					}
			}
			int t = *max_element(ALL(now));
			if (t < mx){
				mx = t;
				best = now;
			}
		}
		for (int i = 0; i < m; i++)
			if ((1 << i) & mask)
				swap(lines[i].first, lines[i].second);
	}
	if (mx > n){
		cout << "-1\n";
		return 0;
	}
	cout << mx << '\n';
	for (int i : best)
		cout << i << ' ';
	cout << '\n';
	return 0;
}
int main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}