#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <tuple>
#include <set>
#include <map>
#include <iomanip>
#include <assert.h>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#pragma optimize(Ofast)
#define pii pair<ll, ll>
#define endl '\n'
#define ff first
#define ss second
#define pb push_back
#define optimize1 ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define all(x) (x).begin(),(x).end()
#define sz(x) ((ll)size((x)))
#define rall(x) ((x).rbegin(), (x.rend()))
typedef long long ll;
typedef long double ld;

using namespace std;
const ll INF = 1e18;
ll n, m, t, ans = 0, x, y;
vector<ll> a, mxa, col;
vector<vector<int>> g;
map<pii, pii> kek;
void bfs(ll st, ll f, vector<ll>& ans, ll tp = 0) {
    vector<ll> d(n, INF), pred(n, - 1);
    d[st] = 0;
    queue<ll> q;
    q.push(st);
    while (!q.empty()) {
        
        auto tmp = q.front();
        //cout << "*" << tmp << ' ' << endl;
        if (tmp == f)
            break;
        q.pop();
        for (auto c : g[tmp]) {
           // cout << c << ' ' << d[c] << endl;
            if (d[c] == INF) {
                d[c] = d[tmp] + 1;
                pred[c] = tmp;
                q.push(c);
            }
        }
    }
    if (tp == 1) {
        cout << sz(mxa) << endl;
        for (auto c : d)
            cout << c + 1 << ' ';
        cout << endl;
    }
    //return;
    while (f >= 0) {
        //cout << f << endl;
        ans.pb(f);
        f = pred[f];
    }
    return;
}


signed main()
{
    optimize1;
    cin >> n >> m >> t;
    g.resize(n);
    col.resize(n);

    for (int i = 0; i < n - 1; ++i) {
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }

    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        x--;
        y--;
        a.clear();
        bfs(x, y, a);
        if (sz(a) > sz(mxa)) {
            mxa = a;
        }
        ans = max(ans, sz(a));
        for (int i = 0; i < sz(a) - 1; ++i) {
            x = a[i], y = a[i + 1];
            pii t = { min(x, y), max(x, y) }, r = {x, y};
            if (kek.count(t) == 0)
                kek[t] = r;
            else {
                if (kek[t] != r) {
                    cout << -1 << endl;
                    return 0;
                }
            }
        }
    }
    for (int i = 0; i < sz(mxa); ++i) {
        col[mxa[i]] = i + 1;
    }
    a.clear();
    bfs(mxa.back(), mxa[0], a, 1);
    return 0;
}
