#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define pb push_back
#define eb emplace_back
#define xmax(x,y) x = max(x, y)
#define xmin(x,y) x = min(x, y)
#define mp make_pair
#define output(a) cout << #a << ' '; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) sort(all(a)); a.resize(unique(all(a)) - a.begin());

using namespace std;

const int N = 16;
vector<int> g[N];

vector<int> d[N];

int n;
void bfs(int w) {
    d[w] = vector<int>(n + 1, -1);
    d[w][w] = 0;
    queue<int> q;
    q.emplace(w);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : g[v]) {
            if (d[w][u] == -1) {
                d[w][u] = d[w][v] + 1;
                q.emplace(u);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, t;
    cin >> n >> m >> t;

    vector<pii> es(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        es[i] = {u, v};
    }

    vector<pii> pt(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        pt[i] = {u, v};
    }

    for (int i = 0; i < (1 << (n - 1)); ++i) {
        for (int v = 1; v <= n; ++v) {
            g[v].clear();
        }

        for (int j = 0; j < n - 1; ++j) {
            if (i & (1 << j)) {
                g[es[j].f].eb(es[j].s);
            } else {
                g[es[j].s].eb(es[j].f);
            }
        }

        for (int v = 1; v <= n; ++v) {
            bfs(v);
        }

        bool ok = 1;
        for (pii& el : pt) {
            if (d[el.f][el.s] == -1 && d[el.s][el.f] == -1) {
                ok = 0;
                break;
            }
        }
        if (!ok) {
            continue;
        }
        vector<int> ans(n, 1);
        for (int v = 1; v <= n; ++v) {
            for (int u = 1; u <= n; ++u) {
                xmax(ans[u - 1], d[v][u] + 1);
            }
        }

        cout << *max_element(all(ans)) << '\n';
        for (int el : ans) {
            cout << el << ' ';
        }
        return 0;
    }
    cout << -1;
    return 0;
}
