#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()

const int N = 20;
const int INF = 1e9 + 10; 
vector<int> path[N][N], g[N];
vector<int> cpath;
void dfs(int root, int v, int p = 0) {
  cpath.pb(v);
  path[root][v] = cpath;
  for (auto u : g[v]) {
    if (u != p) {
      dfs(root, u, v);
    }
  }
  cpath.pop_back();
}

int a[N], b[N], cur[N];
int orient[N][N]; 

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, m, t;
  cin >> n >> m >> t;
  for (int i = 1; i < n; i++) {
    int u, v;
    cin >> u >> v;
    g[u].pb(v);
    g[v].pb(u);
  }
  for (int i = 1; i <= n; i++) {
    dfs(i, i, 0);
  } 
  for (int i = 0; i < m; i++) {
    cin >> a[i] >> b[i];
  }
  int ans = INF;
  int best_mask;
  for (int mask = 0; mask < (1 << m); mask++) {
    bool ok = true;
    for (int i = 1; i <= n; i++) {
      for (int j = 1; j <= n; j++) {
        orient[i][j] = 0;
      }
    }
    for (int i = 1; i <= n; i++) {
      cur[i] = 1;
    }
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; i++) {
      int u, v;
      if ((mask >> i) & 1) {
        u = a[i], v = b[i];
      }
      else {
        u = b[i], v = a[i];
      }
      for (int j = 0; j + 1 < SZ(path[u][v]); j++) {
        int ff = path[u][v][j], ss = path[u][v][j + 1];
        if (!orient[ff][ss]) {
          orient[ff][ss] = 1;
          orient[ff][ss] = -1;
          edges.pb({ff, ss}); 
        }
        else if (orient[ff][ss] != 1) {
          ok = false;
          break;
        }
      }
    }
    if (!ok) {
      continue;
    }
    for (int i = 1; i <= n * n; i++) {
      for (auto it : edges) {
        cur[it.S] = max(cur[it.S], cur[it.F] + 1);
      }
    }
    int mx = 0;
    for (int i = 1; i <= n; i++) {
      mx = max(mx, cur[i]);
    }
    if (mx > n) {
      continue;
    }
    if (mx < ans) {
      ans = mx;
      best_mask = mask;
    }
  }
  if (ans == INF) {
    cout << -1 << '\n';
  }
  else {
    cout << ans << '\n';
    int mask = best_mask;
    for (int i = 1; i <= n; i++) {
      for (int j = 1; j <= n; j++) {
        orient[i][j] = 0;
      }
    }
    for (int i = 1; i <= n; i++) {
      cur[i] = 1;
    }
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; i++) {
      int u, v;
      if ((mask >> i) & 1) {
        u = a[i], v = b[i];
      }
      else {
        u = b[i], v = a[i];
      }
      for (int j = 0; j + 1 < SZ(path[u][v]); j++) {
        int ff = path[u][v][j], ss = path[u][v][j + 1];
        if (!orient[ff][ss]) {
          orient[ff][ss] = 1;
          orient[ff][ss] = -1;
          edges.pb({ff, ss});
        }
      }
    }
    for (int i = 1; i <= n; i++) {
      for (auto it : edges) {
        cur[it.S] = max(cur[it.S], cur[it.F] + 1);
      }
    }
    for (int i = 1; i <= n; i++) {
      cout << cur[i] << ' ';
    }
    cout << '\n';
  }
}