#include <bits/stdc++.h>

using namespace std;

const int N = 500000 + 7;

//int root = -1;

vector<int> c(16, 1);
vector<int> col(N, -1);
vector<int> g[N];
unordered_set<int> gg[N];
//vector<int> gg[N];


bool dfs1(int v, int cur_col) {
    if (col[v] != -1) {
        return col[v] == cur_col;
    }
    col[v] = cur_col;

    for (auto u : gg[v]) {
        bool cur = dfs1(u, 4 - cur_col);
        if (!cur) {
            return false;
        }
    }
    return true;
}

bool dfs2(int v, int p, int finish, int depth) {
    if (v == finish) {
        c[v] = max(c[v], depth);
        return true;
    }

    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }

        bool cur = dfs2(u, v, finish, max(c[v], depth) + 1);
        if (cur) {
            c[v] = max(c[v], depth);

            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m, t;

    cin >> n >> m >> t;

    vector<int> cnt(n, 0);

    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        cnt[v]++;
        cnt[u]++;

        if (n <= 16) {
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }

    vector<pair<int, int>> branches;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        branches.emplace_back(v, u);
    }

    if (n <= 16) {

        int ans = -1;
        vector<int> ans_c;

        for (int mask = 0; mask < (1 << m); ++mask) {
            fill(c.begin(), c.end(), 1);

            for (int j = 0; j < m + 2; ++j) {
                int tmp = mask;
                for (int i = 0; i < m; ++i) {
                    if (tmp % 2) {
                        dfs2(branches[i].first, -1, branches[i].second, 1);
                    } else {
                        dfs2(branches[i].second, -1, branches[i].first, 1);
                    }

                    tmp /= 2;
                }
            }


            vector<int> prev_c = c;

            int tmp = mask;
            for (int i = 0; i < m; ++i) {
                if (tmp % 2) {
                    dfs2(branches[i].first, -1, branches[i].second, 1);
                } else {
                    dfs2(branches[i].second, -1, branches[i].first, 1);
                }

                tmp /= 2;
            }
            if (prev_c != c) {
                continue;
//            cout << -1 << '\n';
            } else {
                int res = 1;
                for (int i = 0; i < n; ++i) {
                    res = max(res, c[i]);
                }

                if (ans == -1 || res < ans) {
                    ans = res;
                    ans_c = c;
                }
//            cout << res << '\n';
//            for (int i = 0; i < n; ++i) {
//                cout << c[i] << ' ';
//            }
//            cout << '\n';
            }
        }
        cout << ans << '\n';
        if (ans != -1) {
            for (int i = 0; i < n; ++i) {
                cout << ans_c[i] << ' ';
            }
        }
    } else {
        int root = -1;

        for (int i = 0; i < n; ++i) {
            if (cnt[i] == n - 1) {
                root = i;
            }
        }

        vector<int> direction(n, -1);
        for (int i = 0; i < m; ++i) {
            int a = branches[i].first;
            int b = branches[i].second;
            if (a != root && b != root) {
                gg[a].insert(b);
                gg[b].insert(a);
            }
        }
        bool poss = true;
        for (int i = 0; i < n; ++i) {
            if (i == root) {
                continue;
            }
            if (col[i] == -1) {
                poss = dfs1(i, 1);
            }
            if (!poss) {
                break;
            }
        }

        col[root] = 2;

        if (!poss) {
            cout << -1;
        } else {
            int res_c = 1;
            for (int i = 0; i < n; ++i) {
                res_c = max(res_c, col[i]);
            }

            cout << res_c << '\n';
            for (int i = 0; i < n; ++i) {
                cout << col[i] << ' ';
            }
        }
    }

}