#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n, m, t;
int timer;
vector <vector <int> > g;
vector <int> par;
vector <int> tin, tout;

void dfs(int x, int pr) {
    par[x] = pr;
    tin[x] = timer++;

    for (int to: g[x])
        if (to != pr)
            dfs(to, x);

    tout[x] = timer++;
}

bool isAnc(int x, int y) {
    return tin[x] <= tin[y] && tin[y] <= tout[x];
}

int ans = 1e9;
vector <int> best;

void rec(vector <vector <int> >& thru, vector <int>& made, int sum) {
    if ((int)made.size() == n) {
        bool fl = true;

        for (int i = 0; i < m; i++) {
            for (int j = 1; j < (int)thru[i].size(); j++)
                if (made[thru[i][j]] == made[thru[i][j - 1]]) {
                    fl = false;
                    break;
                }

            for (int j = 1; j < (int)thru[i].size() - 1; j++) {
                if ((made[thru[i][j]] - made[thru[i][j - 1]] > 0) !=
                (made[thru[i][j + 1]] - made[thru[i][j]] > 0)) {
                    fl = false;
                    break;
                }
            }
            if (!fl)
                break;
        }
        if (!fl)
            return;
        if (ans > sum) {
            ans = sum;
            best = made;
        }
    }
    else {
        for (int i = 1; i < 9; i++) {
            made.push_back(i);
            rec(thru, made, max(sum, i));
            made.pop_back();
        }
    }
}

void solve() {
    vector <vector <int> > thru1(m), thru2(m), thru(m);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;

        while (!isAnc(from, to)) {
            thru1[i].push_back(from);
            from = par[from];
        }
        while (!isAnc(to, from)) {
            thru2[i].push_back(to);
            to = par[to];
        }

        reverse(thru2[i].begin(), thru2[i].end());
        thru[i] = thru1[i];
        thru[i].push_back(from);
        for (int x: thru2[i])
            thru[i].push_back(x);

    }
    vector <int> temp;
    rec(thru, temp, 0);

    if (ans == 1e9)
        cout << -1;
    else {
        cout << ans << '\n';
        for (int x: best)
            cout << x << ' ';

    }

}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> m >> t;
    g.assign(n, vector <int>());

    int pre1 = -1, pre2 = -1;
//    bool fl6 = true;

    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].push_back(to);
        g[to].push_back(from);
        if (pre1 == -1) {
            pre1 = from;
            pre2 = to;
        }
        else {
            if (pre1 == from || pre1 == to)
                pre2 = -2;
            else if (pre2 == from || pre2 == to)
                pre1 = -2;
  //          else
//                fl6 = false;
        }
    }

    par.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    dfs(0, -1);

    solve();



    return 0;
}
