#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 5e5 + 47;

vector<int> g[N], gg[N];

int color[N], n, m, t, best_t = -1;

vector<int> get_patch(int u, int pr, int ss, int ff) {
    vector<int> res;
    if (u == ff) return {ff};
    for (auto v : g[u]) {
        if (v != pr) {
            vector<int> kek = get_patch(v, u, ss, ff);
            if (kek.size()) {
                res = kek;
                res.push_back(u);
                return res;
            }
        }
    }
    return res;
}

int s[N], f[N], c[N], ans[N], keep[N];

vector<int> p[N];

void ff(int i, int cur) {
    if (best_t != -1 && cur >= best_t) {
        return;
    }
    if (i == n + 1) {
        bool ok = true;
        for (int ii = 1; ii <= m; ii++) {
            bool ok1 = true;
            bool ok2 = true;
            for (int j = 1; j < p[ii].size(); j++) {
                if (c[p[ii][j - 1]] >= c[p[ii][j]]) {
                    ok1 = false;
                    break;
                }
            }
            for (int j = 1; j < p[ii].size(); j++) {
                if (c[p[ii][j - 1]] <= c[p[ii][j]]) {
                    ok2 = false;
                    break;
                }
            }
            if (!ok1 && !ok2) {
                ok = false;
                break;
            }
        }
        if (ok) {
            best_t = cur;
            for (int i = 1; i <= n; i++) ans[i] = c[i];
        }
        return;
    }
    for (int v = 1; v <= n; v++) {
        c[i] = v;
        ff(i + 1, max(cur, c[i]));
    }
}

void solve0() {
    for (int i = 1; i <= m; i++) p[i] = get_patch(s[i], -1, s[i], f[i]);
    ff(1, 0);
    cout << best_t << '\n';
    if (best_t != -1) for (int i = 0; i < n; i++) cout << ans[i + 1] << ' ';
}

void dfs(int u, int cl) {
    int cc = (cl == 1 ? 3 : 1);
    ans[u] = cl;
    for (auto v : gg[u]) {
        if (!ans[v]) {
            dfs(v, cc);
        }
        if (ans[v] == ans[u]) {
            cout << -1;
            exit(0);
        }
    }
}

void PUNKS_NOT_DEAD() {
    cin >> n >> m >> t;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= m; i++) {
        cin >> s[i] >> f[i];
    }
    if (n <= 8 && m <= 8) solve0();
    else {
        int root = 1;
        for (int i = 1; i <= n; i++) {
            if (g[i].size() != 1) {
                root = i;
            }
        }
        int mx = 2;
        ans[root] = 2;
        for (int i = 1; i <= m; i++) {
            if (s[i] != root && f[i] != root) {
                gg[s[i]].push_back(f[i]);
                gg[f[i]].push_back(s[i]);
            }
        }
        for (int i = 1; i <= n; i++) {
            if (ans[i] == 0) {
                dfs(i, 1);
            }
        }
        for (int i = 1; i <= n; i++)
            mx = max(mx, ans[i]);
        cout << mx << '\n';
        for (int i = 1; i <= n; i++) cout << ans[i] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    PUNKS_NOT_DEAD();
}