#include <bits/stdc++.h>

#define loop(i, n) for(int i  = 0; i < n; ++i)
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define vec vector
#define paii pair<int, int>
#define fr first
#define sc second
#define all(x) x.begin(), x.end()
#define Unique(x) x.erase(unique(all(x)), x.end())
#define SZ(x) (int) x.size()
#define pb push_back

#define int long long

using namespace std;

mt19937 rnd(time(0));

const int MAXN = 5e5 + 47;

int n, q, op;
vec<int> color;
vec<paii> quer;
vec<vec<int> > graf(MAXN), en(MAXN);

int need = -1;
vec<int> T;

bool fnd(int p1, int pr) {
    T.pb(p1);
    if(p1 == need) return true;
    for(int p2 : graf[p1]) {
        if(p2 == pr) continue;
        if(fnd(p2, p1)) {
            return true;
        }
    }

    T.pop_back();
    return false;
}

bool f() {
    loop(i, q) {
        vec<int> t = en[i];
        bool fl = true;
        FOR(i, 1, SZ(t)) {
            if(color[t[i]] >= color[t[i - 1]]) fl = false;
        }
        if(fl) continue;
        fl = true;
        FOR(i, 1, SZ(t)) {
            if(color[t[i]] <= color[t[i - 1]]) fl = false;
        }
        if(!fl) return false;
    }
    return true;
}

void solve1() {
    loop(i, q) {
        int a = quer[i].fr, b = quer[i].sc;
        need = b;
        fnd(a, -1);
        en[i] = T;
        T.resize(0);
    }
    int st = 1;
    FOR(i, 1, n + 1) st *= n;
    int ind = -1, ans = 1e9;
    loop(msk, st) {
        int t = msk, kok = 0;
        loop(i, n) {
            color[i] = (t % n) + 1;
            t /= n;
            kok = max(kok, color[i]);
        }
        if(kok > ans) continue;
        /*
        for(int c : color) cout << c << " ";
        cout << endl;*/
        if(f()) {
            if(kok < ans) {
                ans = kok;
                ind = msk;
            }
        }
    }
    if(ind == -1) {
        cout << -1 << endl;
        return ;
    }
    cout << ans << endl;
    //if(op == 0) return;
    loop(i, n) {
        color[i] = (ind % n) + 1;
        ind /= n;
        cout << color[i] << " ";
    }
    cout << endl;
    exit(0);
}

vec<int> deep(MAXN, 0);

void cnt_deep(int p1, int pr, int h) {
    deep[p1] = h;
    for(int p2 : graf[p1]) {
        if(p2 == pr) continue;
        cnt_deep(p2, p1, h + 1);
    }
}

void get_ans(int p1, int pr, int h, int mx) {
    color[p1] = h;
    if(h == mx) return ;
    for(int p2 : graf[p1]) {
        if(p2 == pr) continue;
        get_ans(p2, p1, h + 1, mx);
    }
}

vec<vec<int> > ng(MAXN);

bool paint(int p1, int cl) {
    color[p1] = cl;
    if(cl == 1) cl = 3;
    else cl = 1;
    for(int p2 : ng[p1]) {
        if(color[p2] == 0) {
            if(!paint(p2, cl)) {
                return false;
            }
        } else if(color[p2] != cl) {
            return false;
        } else {
            continue;
        }
    }
    return true;
}

void solve6(int root) {
    color.resize(0), color.resize(n, 0);
    if(q == 0) {
        cout << 1 << endl;
        for(int c : color) cout << 1 << " ";
        cout << endl;
        return ;
    }
    int ans = 2;
    color[root] = 2;
    loop(i, q) if(quer[i].fr > quer[i].sc) swap(quer[i].fr, quer[i].sc);
    sort(all(quer));

    loop(i, q) {
        if(quer[i].fr != root && quer[i].sc != root) {
            int a = quer[i].fr, b = quer[i].sc;
            ng[a].pb(b);
            ng[b].pb(a);
            ans = 3;
        }
    }
    loop(i, n) {
        if(color[i] == 0) {
            if(paint(i, 1)) continue;
            cout << -1 << endl;
            return ;
            exit(0);
        }
    }
    cout << ans << endl;
    for(int c : color) {
        if(c == 0) cout << 1 << " ";
        else cout << c << " ";
    }
    exit(0);
}

void solve() {
    cin >> n >> q >> op;
    vec<int> cnt(n, 0);
    color.resize(n, 1);
    quer.resize(q);
    loop(i, n - 1) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graf[a].pb(b);
        graf[b].pb(a);
        cnt[a]++, cnt[b]++;
    }
    loop(i, q) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        quer[i] = {a, b};
    }
    if(n <= 8) {
        solve1();
        return ;
    }
    loop(i, n) {
        if(cnt[i] == n - 1) {
            solve6(i);
            return ;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef COFFEE_MACHINE
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif // COFFEE_MACHINE

    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}
