#include <bits/stdc++.h>
using namespace std;
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(vv) vv.begin(), vv.end()
#define sh cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define print1(a) cout << "{ " << #a << ' ' << a << " }" << endl;
#define print2(a, b) cout << "{ " << #a << ' ' << a << ", " << #b << ' ' << b << " }" << endl;
#define int long long
const int MAXN = 5e5 + 228;
const int INF = 1e9 + 228;
    int n, m, t;
vector<int> g[MAXN];
vector<pair<int, int>> paths;

string to2(int x) {
    string res = "";
    while (x > 0) {
        res += (x % 2);
        x /= 2;
    }
    char z = 0;
    while (res.size() < m) {
        res += z;
    }
    return res;
}
int opt[MAXN];
int tmp[MAXN];
int tin[MAXN], tout[MAXN], tim = 1;
int pred[MAXN];
bool used[MAXN];
int mn = INF;
void dfs(int v, int par = -1) {
    pred[v] = par;
    used[v] = 1;
    tin[v] = tim++;
    for (auto to : g[v]) {
        if (!used[to])
            dfs(to, v);
    }
    tout[v] = tim++;
}

bool parent(int x, int y) {
    return tin[x] <= tin[y] && tout[x] >= tout[y];
}

void very_slow_solve() {
    for (int i = 0; i < n; i++)
        opt[i] = -1;
    dfs(0);
    for (int mask = 0; mask < (1 << m); mask++) {
        string str = to2(mask);
        //print1(mask);
        for (int i = 0; i < n; i++) {
            tmp[i] = 1;
        }
        for (int i = 0; i < m; i++) {
            int from = paths[i].F;
            int to = paths[i].S;
            if (str[i])
                swap(from, to);
            //print2(to, from);
            int last = 0;
            while (!parent(from, to)) {
                //print1(from);
                tmp[from] = max(last + 1, tmp[from]);
                last = tmp[from];
                from = pred[from];
            }
            tmp[from] = max(last + 1, tmp[from]);
            last = tmp[from];
            vector<int> temp;
            while (to != from) {
                temp.pb(to);
                to = pred[to];
            }
            reverse(all(temp));
            for (auto x : temp) {
                //print1(x)
                tmp[x] = max(last + 1, tmp[x]);
                last = tmp[x];
            }
        }
        bool good = 1;
        for (int i = 0; i < m; i++) {
            int from = paths[i].F;
            int to = paths[i].S;
            if (str[i])
                swap(from, to);
            int last = 0;
            while (!parent(from, to)) {
                if (tmp[from] >= tmp[pred[from]])
                    good = 0;
                from = pred[from];
            }
            vector<int> temp;
            while (to != from) {
                temp.pb(to);
                to = pred[to];
            }
            reverse(all(temp));
            last = from;
            for (auto x : temp) {
                if (tmp[last] >= tmp[x]) {
                    good = 0;
                }
                last = x;
            }
        }
        if (!good)
            continue;
        int wtf = -INF;
        for (int i = 0; i < n; i++) {
            wtf = max(wtf, tmp[i]);
        }
        if (wtf < mn) {
            for (int i = 0; i < n; i++) {
                opt[i] = tmp[i];
            }
            mn = wtf;
        }
    }
    if (mn != INF) {
        cout << mn << endl;
        for (int i = 0; i < n; i++) {
            cout << opt[i] << ' ';
        }
        cout << endl;
        exit(0);
    }
    cout << -1 << endl;
}

void solve_root(int root) {
    //print1("solve_root");
    for (int i = 0; i < n; i++)
        opt[i] = -1;
    dfs(0);
    for (int mask = 0; mask <= 0; mask++) {
        string str = to2(mask);
        //print1(mask);
        for (int i = 0; i < n; i++) {
            tmp[i] = 1;
        }
        for (int i = 0; i < m; i++) {
            int from = paths[i].F;
            int to = paths[i].S;
            int to1 = to;
            int from1 = from;
            vector<int> path;
            while (!parent(from1, to1)) {
                path.pb(from1);
                from1 = pred[from1];
            }
            path.pb(from1);

            vector<int> temp;
            while (!parent(to1, from1)) {
                temp.pb(to1);
                to1 = pred[to1];
            }
            reverse(all(temp));
            for (auto to2 : temp) {
                path.pb(to2);
            }
            for (int i = 1; i < path.size(); i++) {
                if (tmp[path[i]] < tmp[path[i - 1]]) {
                    swap(to, from);
                    str[i] = 1;
                    break;
                }
            }
            //print2(to, from);
            int last = 0;
            while (!parent(from, to)) {
                //print1(from);
                tmp[from] = max(last + 1, tmp[from]);
                last = tmp[from];
                from = pred[from];
            }
            tmp[from] = max(last + 1, tmp[from]);
            last = tmp[from];
            temp.clear();
            while (to != from) {
                temp.pb(to);
                to = pred[to];
            }
            reverse(all(temp));
            for (auto x : temp) {
                //print1(x)
                tmp[x] = max(last + 1, tmp[x]);
                last = tmp[x];
            }
        }

        bool good = 1;
        for (int i = 0; i < m; i++) {
            int from = paths[i].F;
            int to = paths[i].S;
            if (str[i])
                swap(from, to);
            int last = 0;
            while (!parent(from, to)) {
                if (tmp[from] >= tmp[pred[from]])
                    good = 0;
                from = pred[from];
            }
            vector<int> temp;
            while (to != from) {
                temp.pb(to);
                to = pred[to];
            }
            reverse(all(temp));
            last = from;
            for (auto x : temp) {
                if (tmp[last] >= tmp[x]) {
                    good = 0;
                }
                last = x;
            }
        }
        //print1(good);
        if (!good)
            continue;
        int wtf = -INF;
        for (int i = 0; i < n; i++) {
            wtf = max(wtf, tmp[i]);
        }
        if (wtf < mn) {
            for (int i = 0; i < n; i++) {
                opt[i] = tmp[i];
            }
            mn = wtf;
        }
    }
    if (mn != INF) {
        cout << mn << endl;
        for (int i = 0; i < n; i++) {
            cout << opt[i] << ' ';
        }
        cout << endl;
        exit(0);
    }
    cout << -1 << endl;
}

signed main() {
    sh;
    #ifdef LOCAL
    freopen("test.in" , "r", stdin);
    #endif // LOCAL
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int aa, bb;
        cin >> aa >> bb;
        aa--;
        bb--;
        g[aa].pb(bb);
        g[bb].pb(aa);
    }
    int root = 0;
    int count_kek = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].size() > 1) {
            root = i;
            count_kek++;
        }
    }
    for (int i = 0; i < m; i++) {
        int aa, bb;
        cin >> aa >> bb;
        aa--;
        bb--;
        paths.pb({aa, bb});
    }
    if (count_kek <= 1) {
        solve_root(root);
        return 0;
    }
    very_slow_solve();
    return 0;
}
