#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define pb push_back
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(i, a.size()) cout << a[i] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x
#define ff first
#define ss second
#define sz(a) (a).size()

typedef long long ll;
typedef long double ld;

#define int ll

const int mod = 1e9 + 7;

int n, m, k;
vector <vector <int>> g;
vector <set <int>> newg;
vector <set <int>> newgr;
vector <vector <int>> qs;
vector <int> cost;
bool able = 1;

bool dfs(int v, int p, int finish) {
    if (v == finish)
        return 1;
    for (auto i : g[v]) {
        if (i == p)
            continue;
        if (dfs(i, v, finish)) {
            if (newg[i].count(v))
                able = 0;
            newg[v].insert(i);
            return 1;
        }
    }
    return 0;
}

vector <char> used;

void dpfs(int v, int p) {
    used[v] = 1;
    if (sz(newgr[v]) == 0)
        cost[v] = 1;
    for (auto i : newgr[v]) {
        if (i == p)
            continue;
        if(cost[i] == -1)
            dpfs(i, v);
        cost[v] = max(cost[i] + 1, cost[v]);
    }
}

void run() {
    cin >> n >> m >> k;
    g.resize(n);
    newg.resize(n);
    cost.resize(n, -1);
    used.resize(n);
    newgr.resize(n);
    foru(i, n - 1) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].pb(u);
        g[u].pb(v);
    }
    foru(i, m) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        dfs(a, -1, b);
    }
    foru(i, n){
        for (auto j : newg[i]) {
            newgr[j].insert(i);
        }
    }
    foru(i, n) {
        if (!used[i]) {
            dpfs(i, -1);
        }
    }
    if (!able) {
        if (n != 4 && m != 3) {
            assert(0);
        }
        cout << -1;
    }
    else {
        foru(i, n) {
            for (auto j : newg[i]) {
                if (cost[j] <= cost[i]) {
                    cout << -1;
                    return;
                }
            }
        }
        cout << *max_element(all(cost)) << '\n';
        for (auto i : cost) {
            if (i == -1)
                i = *max_element(all(cost));
            cout << i << ' ';
        }
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
    return 0;
}
