#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, 10);
typedef pair <int, int> pii;

const int N = 20, K = 500007;
int n, m, t, col[K], used[K], deg[K];
vector <int> q[K], g[K], ord;
stack <int> st;

void go(int v, int p, int f) {
    st.push(v);
    if (v == f) {
        int last = -1;
        while (!st.empty()) {
            if (last != -1) {
                g[st.top()].pb(last);
            }
            last = st.top();
            st.pop();
        }
        return;
    }
    for (auto to : q[v]) {
        if (to == p) {
            continue;
        }
        go(to, v, f);
    }
    if (!st.empty()) {
        st.pop();
    }
}

bool bad = false;

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (used[to] == 1) {
            bad = true;
            return;
        }
        if (used[to] == 0) {
            dfs(to);
        }
    }
    used[v] = 2;
    ord.pb(v);
}

vector <pii> edge;

int get(int mask) {
    bad = false;
    ord = {};
    for (int i = 0; i < N; i++) {
        g[i] = {};
        used[i] = 0;
        col[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int x = edge[i].fi, y = edge[i].se;
        if (mask >> i & 1) {
            go(x, -1, y);
        }   else {
            go(y, -1, x);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
        col[i] = 1;
    }
    if (bad) {
        return N;
    }
    reverse(all(ord));
    for (auto i : ord) {
        for (auto to : g[i]) {
            col[to] = max(col[to], col[i] + 1);
        }
    }
    int cnt = 1;
    for (int i = 1; i <= n; i++) {
        cnt = max(cnt, col[i]);
    }
    return cnt;
}

void go(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!col[to]) {
            if (col[v] == 1) {
                col[to] = 3;
            }   else {
                col[to] = 1;
            }
        }   else {
            if (col[v] == col[to]) {
                cout << -1;
                exit(0);
            }
        }
        if (!used[to]) {
            go(to);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    cin >> n >> m >> t;
    int x, y;
    for (int i = 1; i <= n - 1; i++) {
        cin >> x >> y;
        q[x].pb(y);
        q[y].pb(x);
        deg[x]++;
        deg[y]++;
    }
    if (n <= 15 && m <= 15) {
        for (int i = 1; i <= m; i++) {
            cin >> x >> y;
            edge.pb({x, y});
        }
        int ans = N, tmp = -1;
        for (int mask = 0; mask < (1 << m); mask++) {
            int val = get(mask);
            if (val < ans) {
                ans = val;
                tmp = mask;
            }
        }
        if (tmp == -1) {
            cout << -1;
            return 0;
        }
        cout << get(tmp) << '\n';
        for (int i = 1; i <= n; i++) {
            cout << col[i] << ' ';
        }
    }   else {
        int root = 1;
        for (int i = 1; i <= n; i++) {
            if (deg[i] > 1) {
                root = i;
            }
        }
        for (int i = 1; i <= m; i++) {
            cin >> x >> y;
            if (x == root) {
                col[x] = 2;
            }   else if (y == root) {
                col[y] = 2;
            }   else {
                g[x].pb(y);
                g[y].pb(x);
            }
        }
        for (int i = 1; i <= n; i++) {
            if (i == root) {
                continue;
            }
            if (!used[i]) {
                col[i] = 1;
                dfs(i);
            }
        }
        int cnt = 1;
        for (int i = 1; i <= n; i++) {
            cnt = max(cnt, col[i]);
        }
        if (cnt != 1) {
            col[root] = 2;
        }
        cout << cnt << '\n';
        for (int i = 1; i <= n; i++) {
            cout << col[i] << ' ';
        }
    }
}

