#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<queue>
#include<string>
#include<assert.h>

using namespace std;

int n, m, t;
vector<vector<int>> g;

vector<vector<int>> g1;

int val = 1;
vector<int> ans;

void dfs(int v) {
	for (auto u : g1[v]) {
		if (ans[u] == 4 - ans[v]) {
			continue;
		}
		else if (ans[u] == ans[v]) {
			val = 0;
		}
		else {
			ans[u] = 4 - ans[v];
			dfs(u);
		}
	}
}



vector<vector<int>> vec;

vector<vector<int>> mp;
vector<int> used;

void count(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u]) {
			continue;
		}
		else {
			if (mp[u][v]) {
				ans[u] = ans[v] - 1;
				dfs(u);
			}
			else if (mp[v][u]) {
				ans[u] = ans[v] + 1;
				dfs(u);
			}
			else {
				ans[u] = 0;
				dfs(u);
			}
		}
	}
}

int solve(int mask) {
	vector<vector<int>> vec1;
	ans.clear();
	ans.resize(n + 1);
	for (int i = 0; i < vec.size(); i++) {

		vec1.push_back(vec[i]);
		if ((mask >> i) & 1) {
			reverse(vec.back().begin(), vec.back().end());
		}
	}
	mp.clear();
	mp.resize(n, vector<int>(n));
	used.clear();
	used.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < vec[i].size() - 1; j++) {
			mp[i][j] = 1;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (mp[i][j] && mp[j][i]) {
				return 1e9;
			}
		}
	}
	ans[0] = 0;
	count(0);
	int mn = 0;
	for (int i = 0; i < ans.size(); i++) {
		mn = min(mn, ans[i]);
	}
	for (int i = 0; i < n; i++) {
		ans[i] += (1 - mn);
	}
	int answ = 0;
	for (int i = 0; i < n; i++) {
		answ = max(answ, ans[i]);
	}
	return answ;
}

signed main() {
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int root = -1;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == n - 1) {
			root = i;
		}
	} 
	if (root != -1) {
		vector<pair<int, int>> vec;
		vector<int> v;
		g1.resize(n);
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			if (a - 1 == root) {
				v.push_back(b - 1);
			}
			else if (b - 1 == root) {
				v.push_back(a - 1);
			}
			else {
				vec.push_back({ a - 1, b - 1 });
				g1[a - 1].push_back(b - 1);
				g1[b - 1].push_back(a - 1);
			}
		}
		ans.resize(n);
		ans[root] = 2;
		for (int i = 0; i < n; i++) {
			if (i == root) {
				continue;
			}
			if (ans[i] != 0) {
				continue;
			}
			ans[i] = 1;
			dfs(i);
		}
		if (val == 0) {
			cout << -1;
		}
		else {
			int answ = 0;
			for (int i = 0; i < n; i++) {
				answ = max(answ, ans[i]);
			}
			cout << answ << "\n";
			for (int i = 0; i < n; i++) {
				cout << ans[i] << " ";
			}
		}
		return 0;
	}
	
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		vector<int> dist(n, 1e9);
		vector<int> p(n);
		queue<int> q;
		q.push(a);
		dist[a] = 0;
		while (q.size()) {
			int v = q.front();
			q.pop();
			for (auto u : g[v]) {
				if (dist[u] > dist[v] + 1) {
					dist[u] = dist[v] + 1;
					p[u] = v;
					q.push(u);
				}
			}
		}
		int v = b;
		vector<int> path;
		while (v != a) {
			path.push_back(v);
			v = p[v];
		}
		path.push_back(a);
		vec.push_back(path);
	}
	int ansm = 0;
	int anss = 1e9;
	for (int mask = 0; mask < (1 << m); mask++) {
		int c = solve(mask);
		if (c < anss) {
			anss = c;
			ansm = mask;
		}
	}
	if (anss == 1e9) {
		cout << -1;
	}
	else {
		cout << solve(ansm) << "\n";
		for (int i = 0; i < n; i++) {
			cout << ans[i] << ' ';
		}
	}
} 