#include<bits/stdc++.h>

using namespace std;

const int N = 5e1 + 7;
const int INF = N;
const int K = 20;

vector<int> g[N];

int timer = 0;
int h[N];
int p[N];
int tin[N];
int tout[N];                                   
int up[K][N];

void dfs(int cur, int pr, int ch) {
	h[cur] = ch;
	p[cur] = pr;
	tin[cur] = timer++;
	for (auto t : g[cur]) {
		if (t != pr) dfs(t, cur, ch + 1);
	}
	tout[cur] = timer++;
}

int n;

void init() {
 	dfs(0, -1, 0);
 	for (int i = 0; i < n; i++) {
 		up[0][i] = p[i];
 	}
 	for (int i = 0; i + 1 < K; i++) {
 		for (int j = 0; j < n; j++) {
 			int mid = up[i][j];
 			if (mid == -1) {
 				up[i + 1][j] = -1;
 			} else {
 				up[i + 1][j] = up[i][mid];
 			} 
 		}
 	}
}

int anc(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
	if (anc(a, b)) return a;
	if (anc(b, a)) return b;
	for (int i = K - 1; i >= 0; i--) {
		if (up[i][a] != -1 && !anc(up[i][a], b)) {
			a = up[i][a];
		}
	}
	return p[a];
}

int used[N];

int term[N];
vector<int> ng[N];

void appl(int v, int d, int sw) {
	for (int i = 0; i < d; i++) {
		int f = v;
		int s = p[v];
		if (sw) {
			swap(f, s);
		}
		//cout << "f s " << f << ' ' << s << endl;
		ng[f].push_back(s);
		v = p[v];
	}
}

void go(int u, int v) {
	int l = lca(u, v);
	//cout << "go " << u << ' ' << v << endl;
	//cout << "lca " << l << endl; 
	appl(u, h[u] - h[l], 0);
	appl(v, h[v] - h[l], 1);	
}

int fl = 0;
int dp[N];

void cc(int cur) {
	used[cur] = 1;
	for (auto t : ng[cur]) {
		if (used[t] == 1) fl = 1;
		if (used[t] == 0) cc(t);
	}		
	used[cur] = 2;
}

int dfs2(int cur) {
	if (dp[cur] != -1) return dp[cur];
	dp[cur] = 1;
	for (auto t : ng[cur]) {
		dp[cur] = max(dp[cur], dfs2(t) + 1); 
	}
	return dp[cur];
}

int res = INF;
int best[N];

void solve() {
	fill(used, used + n, 0);
	fl = 0;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) cc(i);
	}
	//cout << "fl " << fl << endl;
	if (fl) return;
	fill(dp, dp + n, -1);
	for (int i = 0; i < n; i++) {
		dfs2(i);
	}
	int c = *max_element(dp, dp + n);
	if (res <= c) return;
	if (c == 0) {
		cout << "wow " << endl;
		for (int i = 0; i < n; i++) {
			for (auto j : ng[i]) {
				cout << "ed " << i  << ' ' << j << endl;
			}
		}
	}                        
	res = c;
	for (int i = 0; i < n; i++) {
		best[i] = dp[i];
	}	
}
                         
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	 
	int m, lol;       
	cin >> n >> m >> lol;
	for (int i = 0; i + 1 < n; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	init();
	vector<int> f(m);
	vector<int> s(m);
	for (int i = 0; i < m; i++) {
		cin >> f[i] >> s[i];
		f[i]--;
		s[i]--;
	}               
	if (n > 15) {
		map<int, int> ends;
		vector<int> sel(n);
		for (int i = 0; i < m; i++) {
			ends[f[i]]++;
			ends[s[i]]++;
			sel[f[i]] = 1;
			sel[s[i]] = 1;
		}
		int root = -1;
		for (auto t : ends) {
			if (t.second == m) root = t.first;
		}
		int rans = 1;
		vector<int> tans(n);
		function<void(int, int, int)> kek = [&](int v, int p, int ch) {
			tans[v] = ch;
			if (sel[v]) rans = max(rans, ch);
			for (auto t : g[v]) {
				if (t != p) kek(t, v, ch + 1);
			}
		};
		kek(root, -1, 1);
		cout << rans << endl;
		for (int i = 0; i < n; i++) {
			cout << min(rans, tans[i]) << ' ';
		}
		cout << endl;
		exit(0);
	}
	for (int mask = 0; mask < (1 << m); mask++) {
		for (int i = 0; i < n; i++) {
			ng[i].clear();
		}
		for (int i = 0; i < m; i++) {
			if ((mask >> i) & 1) {
				go(f[i], s[i]);
			} else {
				go(s[i], f[i]);
			}
		}
		//cout << "mask " << mask << endl;
		solve();
	}
	//go(f[0], s[0]);
	//solve();
	if (res == INF) {
		cout << -1 << endl;
		return 0;
	}
	cout << res << endl;
	for (int i = 0; i < n; i++) {
		cout << best[i] << ' ';
	}
	cout << endl;
}                        