#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

int n, m;
vector <vector <int>> g;
vector <pii> t;
vector <int> tin, tout, par;
int tim = 0;
void dfs(int v = 0, int p = -1)
{
    tin[v] = tim++;
    for (auto &to : g[v])
        if (to != p)
            par[to] = v, dfs(to, v);
    tout[v] = tim++;
}

int check(int p, int v)
{
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}

vector <int> ts, tspos, used;
int hvcyc = 0;
void dts(int v, vector <vector <int>> &f)
{
    if (used[v])
    {
        if (used[v] == 1)
            hvcyc = 1;
        return;
    }
    used[v] = true;
    for (auto &i : f[v])
        dts(i, f);
    tspos[v] = ts.size();
    ts.pb(v);
    used[v] = 2;
}
int mex(vector <int> kek)
{
    if (kek.empty())
        return 0;
    return *max_element(all(kek)) + 1;
}

signed main()
{
    Start();
    int type;
    cin >> n >> m >> type;
    g.resize(n);
    par.resize(n);
    tin.resize(n), tout.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v, --u, --v;
        g[u].pb(v), g[v].pb(u);
    }
    t.resize(m);
    for (auto &i : t)
        cin >> i, --i.first, --i.second;
    dfs();
    vector <int> bst(n, n + 1);
    for (int mask = 0; mask < 1 << m; ++mask)
    {
        vector <vector <int>> f(n);
        for (int i = 0; i < m; ++i)
        {
            vector <int> pth;
            if (mask >> i & 1)
            {
                int a = t[i].first, b = t[i].second;
                while (!check(a, b))
                    pth.pb(a), a = par[a];
                vector <int> pth2;
                while (a != b)
                    pth2.pb(b), b = par[b];
                pth2.pb(a);
                reverse(all(pth2));
                for (auto i : pth2)
                    pth.pb(i);
                for (int i = 1; i < pth.size(); ++i)
                    f[pth[i]].pb(pth[i - 1]);
            }
            else
            {
                int a = t[i].first, b = t[i].second;
                swap(a, b);
                while (!check(a, b))
                    pth.pb(a), a = par[a];
                vector <int> pth2;
                while (a != b)
                    pth2.pb(b), b = par[b];
                pth2.pb(a);
                reverse(all(pth2));
                for (auto i : pth2)
                    pth.pb(i);
                for (int i = 1; i < pth.size(); ++i)
                    f[pth[i]].pb(pth[i - 1]);
            }
        }
        ts = {};
        tspos.assign(n, -1);
        used.assign(n, 0);
        hvcyc = 0;
        for (int i = 0; i < n; ++i)
        {
            if (!used[i])
                dts(i, f);
        }
        if (hvcyc)
            continue;
        vector <int> c(n);
        for (auto &v : ts)
        {
            vector <int> go;
            for (auto &to : f[v])
            {
                go.pb(c[to]);
            }
            c[v] = mex(go);
        }
        if (*max_element(all(c)) < *max_element(all(bst)))
            bst = c;
    }
    if (bst == vector <int> (n, n + 1))
        return cout << -1, 0;
    for (auto &i : bst)
        ++i;
    cout << *max_element(all(bst)) << endl;
    if (type)
        cout << bst;
    return 0;
}

