#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int mod = 1e9 + 7;
const int pri = 997;
const ld PI = acos(-1);

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}

const int N = 5e5 + 5;
const int MAXN = 1e6 + 5;

int n, m, cs;
int a[N], b[N];
vector < int > g[N];
int qa[N], qb[N];

struct Data {
	int d[N];
	int tin[N], tout[N];
	int timer; 
	int up[20][N];

	void zfs (int v, int pr = 0) {
		up[0][v] = pr;
		for (int i = 1; i < 20; ++i) {
			up[i][v] = up[i-1][up[i-1][v]];
		} 

		d[v] = d[pr] + 1;
		tin[v] = ++timer;
		for (auto e : g[v]) {
			int to = v ^ a[e] ^ b[e];
			if (to != pr) {
				zfs(to, v);
			}
		}
		tout[v] = timer;
	}

	bool upper (int a, int b) {
		return tin[a] <= tin[b] && tout[b] <= tout[a];
	}

	int plca (int a, int b) {
		//if (upper(a, b)) swap(a, b);
		//if (upper(b, a)) return b;

		for (int i = 19; i >= 0; --i) if (!upper(up[i][a], b)) {
			a = up[i][a];
		}

		return a;
	}
	
	int lca (int a, int b) {
		if (upper(a, b)) return a;
		if (upper(b, a)) return b;

		for (int i = 19; i >= 0; --i) if (!upper(up[i][a], b)) {
			a = up[i][a];
		}

		return up[0][a];
	}
	int dist (int a, int b) {
		return d[a] + d[b] - 2 * d[lca(a, b)];
	}
} A;

int c[N];
int up[N], dw[N];
vector < int > gr[MAXN];
int in[N], out[N];

void dfs (int v, int pr = 0) {
	
	for (auto e : g[v]) {
		int to = v ^ a[e] ^ b[e];
		if (to != pr) {
			dfs(to, v);
			if (dw[to]) {
				c[e] |= 1;
			}
			if (up[to]) {
				c[e] |= 2;
			}
			up[v] ^= up[to];
			dw[v] ^= dw[to];
		}
	}
}
int u[N];
int ans[N];

void two (int v) {
	u[v] = 1;
	//ans[v] = 1;
	for (auto e : g[v]) {
		int to = (a[e] ^ b[e] ^ v);
		if (!u[to]) {
			ans[to] = 3 - ans[v];
			two(to);
		}
	}
}

void go (int v) {
	if (u[v]) return;
	u[v] = ans[v] = 1;

	for (auto to : gr[v]) {
		go(to);
		ans[v] = max(ans[v], ans[to] + 1);
	}
}

map < pair < int, int >, int > e;

vector < int > ed;
int was[N];
void col (int v) {
	c[v] = 1;
	for (auto to : gr[v]) {
	    if(e.count({v, to}))
			ed.pb(e[{v, to}]);
		if(!c[to])
			col(to);
	}
}

inline void add (int a, int b, int id) {
	gr[a].pb(b);
//	gr[b].pb(a);
	e[{a, b}] = id;
//	e[{b, a}] = id;
}

vector < int > ord;
void paint (int v) {
	//cerr << v << ' ' << c[v] << '\n';
	for (auto to : gr[v]) if (!c[to]) {
	//	cerr << to << '\n';
		c[to] = c[v];
		paint(to);
	}
	ord.pb(v);
}

inline bool check () {
	for (int i = 1; i <= 2 * n; ++i) gr[i].clear();
	
	for (int i = 1; i < n; i ++) {
		int x = a[i], y = b[i];
		if (!A.upper(x, y)) swap(x, y);
		gr[2*x].pb(2*y);
		gr[2*y-1].pb(2*x-1);
	//	swap(x, y);
	//	gr[2*x].pb(2*y);
	//	gr[2*x-1].pb(2*y-1);		
	}

	for (int i = 1; i <= m; ++i) {
		int x = qa[i], y = qb[i];
		int z = A.plca(x, y);
		//cout << x << ' ' << y << ' ' << z << '\n';
		//exit(0);
		if (!A.upper(z, y)) {
			add(2 * z - 1, 2 * x, 2 * i);
		}
		z = A.plca(y, x);
		if (!A.upper(z, x)) {
			add (2 * y - 1, 2 * z, 2 * i);
		}
		swap(x, y);
		if (!A.upper(z, y)) {
			add(2 * z - 1, 2 * x, 2 * i);
		}
		z = A.plca(y, x);
		if (!A.upper(z, x)) {
			add (2 * y - 1, 2 * z, 2 * i);
		}

	}

	ord.clear();
	int color = 0;
	memset(c, 0, sizeof c);
	for (int i = 1; i <= 2 * n; i ++) if (!c[i]) {
		++color;
		c[i] = color;
		paint(i);
	}
	//exit(0);
	memset(c, 0, sizeof c);
	color = 0;
	reverse(every(ord));
	
//	cout << ord.size();
//	exit(0);
	vector < int > dd = ord;
	ord.clear();
	for (int i : dd) if (!c[i]) {
		++color;
		c[i] = color;
		//cerr << i << '\n';
		paint(i);
	}
	memset(c, 0, sizeof c);
	color = 0;
	reverse(every(ord));
	
	dd = ord;
	for (int i : dd) if (!c[i]) {
		++color;
		c[i] = color;
		//cerr << i << '\n';
		paint(i);
	}          

	for (int i = 1; i <= 2 * n; i += 2) if (c[i] == c[i+1]){	
		return 0;
	}

	return 1;
}

int main () {
	randomizer3000 ();
	scanf("%d %d %d", &n, &m, &cs);
	For(i, 1, n - 1) {
		scanf("%d %d", &a[i], &b[i]);
		g[a[i]].pb(i);
		g[b[i]].pb(i);
	}

	A.zfs(1);
	for (int i = 1; i <= m; ++i) {
		int aa, bb;
		scanf("%d %d", &aa, &bb);
		int lc = A.lca(aa, bb);
		qa[i] = aa, qb[i] = bb;
	}
	if (!check()) {
		puts("-1");
		exit(0);
	}
	memset(c, 0, sizeof c);
	for (int i = 1; i <= 2 * n; i ++) if (!c[i]) {
		ed.clear();
		col(i);
		bool bad = 0;
		for (auto it : ed) if (was[(it + 1)/ 2]) {
			bad = 1;
			break;
		}
		if(bad) continue;
		for (auto it : ed) {
			was[(it + 1) / 2] = (it % 2) + 1;
		}
	}

	for (int i = 1; i <= m; ++i) {
		if (was[i] == 2) swap(qa[i], qb[i]);
		int aa = qa[i], bb = qb[i];
		int lc = A.lca(aa, bb);
		int x = rand();
		up[aa] ^= x;
		dw[bb] ^= x;
		up[lc] ^= x;
		dw[lc] ^= x;
	}
	memset(c, 0, sizeof c);
	dfs(1);
	for (int i = 1; i <= n; i ++) gr[i].clear();
	for (int i = 1; i <= n; i ++) if (c[i]) {
		if (c[i] == 3) {
			cout << "-1\n";
			exit(0);
		}
		if (c[i] == 2) {
			in[b[i]]++; out[a[i]]++;
			gr[a[i]].pb(b[i]);
		} else {
			in[a[i]]++; out[b[i]]++;
			gr[b[i]].pb(a[i]);
		}

	}
	
	for (int i = 1; i <= n; i ++) if (!u[i] && !in[i]) {
		go(i);
	}

	for (int i = 1; i <= n; i ++) if (!u[i]) {
		ans[i] = 1;
		two(i);	
	}

	int k = *max_element(ans + 1, ans + 1 + n);
	printf("%d\n", k);
	for (int i = 1; i <= n; i ++)
		printf("%d ", ans[i]);
	puts("");
}
