#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define pb emplace_back

using namespace std;
const int inf = 1e10;

bool f = false;

void path(int v, int pred, vector<vector<int>> &sl, int a, int b, vector<int> &p){
    if(v == b){
        f = true;
        p.pb(v);
        return;
    }
    for(int u: sl[v]){
        if(u == pred)continue;
        path(u, v, sl, a, b, p);
        if(f){
            p.pb(v);
            return;
        }
    }
}

vector<int> ans(vector<vector<int>> br, int msk, int n){
    vector<int> res(n), fk(n, inf);
    int m = br.size();
    for(int i = 0; i < m; ++i){
        if((1 << i) & msk)reverse(br[i].begin(), br[i].end());
    }
    for(auto &e: br){
        for(int i = 0; i < e.size(); ++i){
            res[e[i]] = max(res[e[i]], i + 1);
        }
    }
    for(int j = 0; j <= m * m * m; ++j){
        for(auto &e: br){
            int cur = 1;
            for(int i = 0; i < e.size(); ++i){
                cur = max(cur, res[e[i]]);
                res[e[i]] = cur;
                ++cur;
            }
        }
    }
    for(auto &e: br){
        int cur = 1;
        for(int i = 1; i < e.size(); ++i){
            if(res[e[i]] <= res[e[i - 1]])return fk;
        }
    }
    return res;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> sl(n);
    for(int i = 1; i < n; ++i){
        int u, v;
        cin >> u >> v;
        sl[--u].pb(--v);
        sl[v].pb(u);
    }
    vector<vector<int>> br(m);
    for(auto &e: br){
        int u, v;
        cin >> u >> v;
        path(u - 1, -1, sl, u - 1, v - 1, e);
        f = false;
        /*for(int h: e)cout << h << " ";
        cout << endl;*/
    }
    vector<int> res(n, inf);
    for(int mask = 0; mask < (1 << m); ++mask){
        auto r = ans(br, mask, n);
        if(*max_element(r.begin(), r.end()) <= *max_element(res.begin(), res.end()))swap(res, r);
    }
    if(*max_element(res.begin(), res.end()) == inf){
        cout << -1;
        return 0;
    }
    cout << *max_element(res.begin(), res.end()) << endl;
    for(int e: res)cout << e << " ";
    return 0;
}
/*8 2 1
1 2
2 3
3 4
4 5
6 3
7 8
3 7
8 6
1 5*/
