#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 1e5 + 5;
vector<int> g[N];
const int INF = 1e7;
int c[N];

int n, m, t;
vector<int> opa;
vector<vector<int>> path;

bool dfs(int v, int p, int nx) {
	if (v == nx) {
		opa.pb(v);
		return 1;
	}

	for (auto& to : g[v]) {
		if (to == p) continue;
		if (dfs(to, v, nx)) {
			opa.pb(v);
			return 1;
		}
	}
	return 0;
}
vector<int> cur;
void make(int il, int ir, int l, int r) {
	if (il > ir) return;

	int mi = (il + ir) / 2;
	int m = (l + r) / 2;
	if (!cur[mi]) cur[mi] = m;
	make(il, mi - 1, l, m - 1);
	make(mi + 1, ir, m + 1, r);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	fill(c, c + N, -INF);
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		dfs(x, 0, y);
		path.pb(opa);
		opa.clear();
	}
	int l1 = 1;
	int r1 = INF;
	for (auto& a : path) {
		int l = max(l1, c[a[0]]);
		int r = max(r1, c[a.back()]);
		cur.clear();
		cur.resize(a.size());
		make(0, a.size() - 1, l, r);
		for (int i = 0; i < a.size(); ++i) {
			c[a[i]] = cur[i];
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (c[i] == -INF) c[i] = 1;
	}
	cout << *max_element(c + 1, c + 1 + n) << endl;
	for (int i = 1; i <= n; ++i) {
		cout << c[i] << ' ';
	}
}