#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

const int MAXN = 10;
vector<int> g[MAXN];
vector<pair<int, int>> lines;

vector<int> get_path(int u, int v) {
    vector<int> pred(10, -1);
    deque<int> q = {u};
    while (!q.empty()) {
        int v1 = q.front();
        q.pop_front();
        for (int u1 : g[v1]) {
            if (pred[u1] == -1) {
                pred[u1] = v1;
                q.push_back(u1);
            }
        }
    }
    vector<int> path;
    while (v != u) {
        path.push_back(v);
        v = pred[v];
    }
    path.push_back(u);
    return path;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, t;
    cin >> n >> m >> t;
    int u1, v1;
    for (int i = 0; i < n - 1; i++) {
        cin >> u1 >> v1;
        g[u1].push_back(v1);
        g[v1].push_back(u1);
    }
    vector<vector<int>> paths;
    int mxl = 0;
    for (int i = 0; i < m; i++) {
        cin >> u1 >> v1;
        paths.push_back(get_path(u1, v1));
        lines.emplace_back(u1, v1);
        mxl = max(mxl, (int) paths.back().size());
    }
//    cout << 1 << '\n';
    set<tuple<int, int, int>> kuku;
    set<pair<int, int>> rar;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < paths[i].size() - 1; j++) {
            rar.insert({min(paths[i][j], paths[i][j + 1]), max(paths[i][j], paths[i][j + 1])});
        }
        for (int j = 1; j < paths[i].size() - 1; j++) {
            int a = paths[i][j - 1], b = paths[i][j], c = paths[i][j + 1];
            if (a > c) {
                swap(a, c);
            }
            kuku.insert({a, b, c});
        }
    }
    vector<tuple<int, int, int>> kuku1;
    vector<pair<int, int>> rar1;
    for (auto x : kuku) {
        kuku1.push_back(x);
    }
    for (auto x : rar) {
        rar1.push_back(x);
    }
//    cout << 2 << '\n';
    int mn = (int) 1e9;
    vector<int> ans;
    for (int i = 0; i < (int) pow(n, n); i++) {
        int k = i;
        vector<int> now;
        int now_m = (int) -1e9;
        for (int j = 0; j < n; j++) {
            now.push_back(k % n + 1);
            now_m = max(now_m, now.back());
            k /= n;
        }
        if (now_m < mxl) {
            continue;
        }
        bool flag = true;
        for (auto x : rar1) {
            if (now[x.first] == now[x.second]) {
                flag = false;
                break;
            }
        }
        for (auto x : kuku1) {
            int a = get<0>(x), b = get<1>(x), c = get<2>(x);
            if ((now[b] < now[a] && now[b] < now[c]) || (now[b] > now[a] && now[b] > now[c])) {
                flag = false;
                break;
            }
        }
        if (flag) {
            if (now_m < mn) {
                mn = now_m;
                ans = now;
            }
            if (now_m == mxl) {
                break;
            }
        }
    }
    if (mn == (int) 1e9) {
        cout << -1 << endl;
        return 0;
    }
    cout << mn << endl;
    for (auto x : ans) {
        cout << x << " ";
    }
    cout << endl;
}