#include<bits/stdc++.h>
using namespace std;
const int nmax=5e5+42;
int n,m,t;
vector<int> adj[nmax],diff[nmax];

int c[nmax];
vector<int> to[nmax];
int deg[nmax];

queue<int> to_remove,idle;

int output[nmax],out_costs=-1;

int make_costs()
{
    to_remove=idle;
    for(int i=1;i<=n;i++)c[i]=1;

    for(int i=1;i<=n;i++)deg[i]=0;

    for(int i=1;i<=n;i++)
        for(auto k:to[i])
            deg[k]++;

    for(int i=1;i<=n;i++)
        if(deg[i]==0)to_remove.push(i);

    for(int i=1;i<=n;i++)
    {
        //cout<<"i= "<<i<<" to_remove "<<to_remove.size()<<endl;

        if(to_remove.size()==0)return -1;
        int current=to_remove.front();
        to_remove.pop();

        //cout<<"current= "<<current<<endl;

        for(auto k:to[current])
        {
            c[k]=max(c[k],c[current]+1);
            deg[k]--;
            if(deg[k]==0)to_remove.push(k);
        }
    }
    int MX=0;
    for(int i=1;i<=n;i++)
        MX=max(MX,c[i]);

    if(out_costs==-1||out_costs>MX)
    {
        out_costs=MX;
        for(int i=1;i<=n;i++)
            output[i]=c[i];
    }
    return MX;
}

pair<int,int> lines[nmax];

int height[nmax];
int up[20][nmax];
int lca(int a,int b)
{
    if(height[a]>height[b])swap(a,b);
    for(int i=19;i>=0;i--)
        if(height[a]<=height[b]-(1<<i))b=up[i][b];
    if(a==b)return a;
    for(int i=19;i>=0;i--)
        if(up[i][a]!=up[i][b])a=up[i][a],b=up[i][b];
    return up[0][a];
}

int parent[nmax];
void dfs(int node,int p,int h)
{
    height[node]=h;
    up[0][node]=p;
    parent[node]=p;

    for(auto k:adj[node])
        if(k!=p)
        dfs(k,node,h+1);
}

void path(int start,int en,int add/*1-> add, -1->destroy*/)
{
    int mid=lca(start,en);
    while(start!=mid)
    {
        if(add==1)to[start].push_back(parent[start]);
        else to[start].pop_back();
        start=parent[start];
    }

    while(en!=mid)
    {
        if(add==1)to[parent[en]].push_back(en);
        else to[parent[en]].pop_back();
        en=parent[en];
    }
}
void rec(int pos)
{
    if(pos>m)
    {
        make_costs();
        return;
    }

    path(lines[pos].first,lines[pos].second,1);
    rec(pos+1);
    path(lines[pos].first,lines[pos].second,-1);

    path(lines[pos].second,lines[pos].first,1);
    rec(pos+1);
    path(lines[pos].second,lines[pos].first,-1);
}

bool THERE[nmax];
void dfs_go(int node,int p)
{
    for(auto k:adj[node])
        if(k!=p)
        {
            dfs_go(k,node);
            THERE[node]=THERE[node]||THERE[k];
        }
    if(THERE[node])
    {
        to[node].push_back(p);
        //cout<<"to "<<node<<" "<<p<<endl;
    }
}

bool PROPER;
int col[nmax];

void df(int node,int c)
{
    if(col[node]==-1)col[node]=c;
    else if(col[node]!=c)
    {
        PROPER=0;
        return;
    }
    else return;

    for(auto k:diff[node])
        df(k,!c);
}
void go(int common)
{
    for(int i=1;i<=m;i++)
    {
        if(lines[i].first==common||lines[i].second==common)
        {
            continue;
            //not_eq[lines[i].first+lines[i].second-common]=1;
        }
        diff[lines[i].first].push_back(lines[i].second);
        diff[lines[i].second].push_back(lines[i].first);
    }
    for(int i=1;i<=n;i++)col[i]=-1;

    PROPER=1;
    for(int i=1;i<=n;i++)
        if(col[i]==-1&&diff[i].size())
        {
            df(i,0);
        }

    for(int i=1;i<=n;i++)
        if(i!=common)
        {
            if(col[i]==0)to[i].push_back(common);
            else if(col[i]==1)to[common].push_back(i);
            else to[i].push_back(common);
        }
    if(PROPER)make_costs();
}
bool test_common()
{
    map<int,int> seen={};
    for(int i=1;i<=n;i++)
        if(adj[i].size()==n-1)
        {
            go(i);
            return 1;
        }
    return 0;
}
int main()
{
    scanf("%i%i%i",&n,&m,&t);

    int u,v;
    for(int i=1;i<n;i++)
    {
        scanf("%i%i",&u,&v);
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=m;i++)
        scanf("%i%i",&lines[i].first,&lines[i].second);

    if(n<=15)
    {
        dfs(1,1,0);
        for(int st=1;st<20;st++)
            for(int i=1;i<=n;i++)
                up[st][i]=up[st-1][up[st-1][i]];
        rec(1);
    }
    else
    {
        test_common();
    }

    printf("%i\n",out_costs);

    if(out_costs!=-1)
    {
        for(int i=1;i<=n;i++)
        {
            printf("%i",output[i]);
            if(i==n)printf("\n");
            else printf(" ");
        }
    }
    return 0;
}
/*
3 1 1
1 2
2 3
1 3

3 1 1
1 2
2 3
1 2

3 1 0
1 2
2 3
1 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4

4 2 0
1 2
1 3
1 4
2 3
2 4

4 3 0
1 2
1 3
1 4
1 2
1 3
1 4
*/