#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC("avx2")


#define ll long long
#define pb push_back
#define fi first
#define se second
#define pii pair < int , int >
#define ld long double


using namespace std;
using namespace __gnu_pbds;

template < typename T >
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
const int N = 5e5 + 5;
vector < int > g[N], way[N];
int tin[N], tout[N], up[N][20], X[N], Y[N], c[N], timer, Par[N], h[N];

void prec(int v, int pr = 0){
    h[v] = h[pr] + 1;
    tin[v] = ++timer;
    up[v][0] = pr;
    Par[v] = pr;

    for (int i = 1; i < 20; ++i)
        up[v][i] = up[up[v][i - 1]][i - 1];
    for (int to : g[v])
        if (to != pr)
          prec(to, v);
    tout[v] = ++timer;
}

bool upper(int x, int y){
    return (tin[x] <= tin[y] && tout[x] >= tout[y]);
}


int lca(int x, int y){
    if (upper(x, y)) return x;
    if (upper(y, x)) return y;
    for (int len = 19; len >= 0; --len)
        if (!upper(up[x][len], y)) x = up[x][len];
    return up[x][0];
}

int used[N];
vector < int > vis;

int solve(int v, int now, int pr = -1){
    vis.pb(v);
    c[v] = now;
    used[v] = 1;
    int ans = now;
    bool bad = 0;
    for (int w : way[v]){
            int f = h[X[w]];
            int s = h[Y[w]];
            if (f > s) swap(f, s);
            if (f <= h[v] && s >= h[v]) bad = 1; else continue;
            break;
        }
//    cout<<v<<" "<<bad<<endl;
    int st;
    if (!bad) st = 1; else st = now + 1;

    for (int to : g[v])
        if (to != pr && !used[to]){
            ans = max(ans, solve(to, st));
        }
    return ans;
}
int cv[N], otv[N], LC[N];

void mark(int v, int kol, int pr = -1){
    cv[v] = kol;
    for (int to : g[v])
        if (to != pr && !used[to])
           mark(to, kol, v);
}
vector < int > comp[N];

bool good(int f, int s, int lc){
    if (f == lc){
        int last = c[s];
        while(s != f){
            s = Par[s];
//    cout<<s<<" "<<c[s]<<" "<<last<<endl;
            if (last <= c[s]) return 0;
            last = c[s];
        }
    } else {
        int last = c[f];
//        cout<<f<<" "<<s<<" "<<last<<endl;
        while(s != f){
            f = Par[f];
            if (last >= c[f]) return 0;
            last = c[f];
        }
    }
    return 1;
}

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    #ifdef Estb_probitie
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    #endif

    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i){
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].pb(y);
        g[y].pb(x);
    }
    prec(0);
    for (int i = 0; i < m; ++i){
        cin >> X[i] >> Y[i];
        --X[i], --Y[i];
        int x = X[i];
        int y = Y[i];
        int lc = lca(x, y);
        LC[i] = lc;
        while(lc != x){
            way[x].pb(i);
            x = Par[x];
        }
        while(lc != y){
            way[y].pb(i);
            y = Par[y];
        }
        way[lc].pb(i);
    }

    int gl = 1;
    int C[n];
    for (int i = 0; i < n; ++i)
    if (!way[i].size()){
        C[i] = 1;
        used[i] = 1;
        cv[i] = -1;
    }

    for (int i = 0; i < n; ++i)
        if (!cv[i]){
            mark(i, gl, i);
            ++gl;
        }
    for (int i = 0; i < m; ++i)
        comp[cv[X[i]]].pb(i);
    int ans = 1e9;
    fill(otv, otv + gl, 1e9);

    for (int i = 0; i < n; ++i)
        if (!used[i]){
            int clc = solve(i, 1);
            int Cp = cv[i];
//            cout<<otv[Cp]<<endl;
            if (otv[Cp] > clc){
                bool bad = 0;
                for (int ind : comp[Cp])
                {
//                    good(LC[ind], Y[ind], LC[ind]);
//                    exit(0);;
//                    cout<<X[ind]<<" "<<Y[ind]<<endl;
                    if (good(X[ind], LC[ind], LC[ind]) && good(LC[ind], Y[ind], LC[ind])) continue;
                    if (good(Y[ind], LC[ind], LC[ind]) && good(LC[ind], X[ind], LC[ind])) continue;
                    bad = 1;
                    break;
                }
//                exit(0);
//                cout<<Cp<<" "<<bad<<endl;
                if (!bad){
                    otv[Cp] = clc;
                    for (int i : vis)
                        C[i] = c[i];
                }
            }
            for (int i : vis) used[i] = 0;
            vis = {};
        }

    ll sum = 0;
    for (int i = 1; i < gl; ++i){
        sum += otv[i];
//        cout<<i<<" "<<sum<<endl;
        otv[i] = 0;
    }

    if (sum >= 1e9) cout << -1; else {
            cout<<sum<<endl;
        for (int i = 0; i < n; ++i)
            cout << C[i]<<" ";
    }
}
