#include <bits/stdc++.h>
using namespace std;

#define int long long
int n;
vector<vector<int> > adj;
vector<vector<int> > roots;
vector<int> been, pred;
vector<int> ans, best_ans;
int maxx = 1e9;

void dfs(int u, int p) {
    pred[u] = p;
    for (auto v : adj[u]) {
        if (been[v] != been[u]) {
            been[v] = been[u];
            dfs(v, u);
        }
    }
}

void gen(int x) {
    if (x == n) {
        bool ok = true;
        int curr_m = 0;
        for (int j = 0; j < roots.size(); ++j) {
            for (int i = 1; i < roots[j].size(); ++i) {
                if ((ans[roots[j][i]] - ans[roots[j][i - 1]]) * (ans[roots[j][1]] - ans[roots[j][0]]) <= 0) {
                    ok = false;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            curr_m = max(curr_m, ans[i]);
        }
        if (ok && curr_m < maxx) {
            maxx = curr_m;
            best_ans.resize(n);
            for (int i = 0; i < n; ++i) {
                best_ans[i] = ans[i];
            }
        }
        return;
    }
    for (int i = 1; i <= n; ++i) {
        ans.push_back(i);
        gen(x + 1);
        ans.pop_back();
    }
}


int32_t main() {
    int m, t;
    cin >> n >> m >> t;
    adj.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    roots.resize(m);
    been.resize(n, -1);
    pred.resize(n);
    for (int j = 0; j < m; ++j) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        been[a] = a;
        dfs(a, a);
        int curr = b;
        while (curr != a) {
            roots[j].push_back(curr);
            curr = pred[curr];
        }
        roots[j].push_back(curr);
    }
    gen(0);
    if (maxx < n + 1) {
        cout << maxx << "\n";
        for (auto u : best_ans) {
            cout << u << " ";
        }
    }
    else {
        cout << -1;
    }
    return 0;
}
