#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

vector<vector<int> > g;
vector<int> cur;
bool fl = false;

void dfs1 (int v, int e, int p = -1) {
    if (v == e) {
        fl = true;
        cur.push_back(v);
        return;
    }
    for (auto to : g[v]) {
        if (to != p) {
            dfs1(to, e, v);
            if (fl) {
                cur.push_back(v);
                return;
            }
        }
    }
}

vector<unordered_map<int, int> > gr;
vector<int> ans;
vector<int> used;

void dfs2 (int v, int t = 1, int p = -1) {
    ans[v] = t;
    used[v] = 1;
    for (auto to : gr[v]) {
        if (to.fi != p) {
            dfs2(to.fi, t + to.se, v);
        }
    }
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    gr.resize(n);
    ans.resize(n, -INT_MAX);
    used.resize(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int> > path(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        path[i] = {a - 1, b - 1};
    }

    for (int i = 0; i < m; i++) {
        cur.clear();
        fl = false;
        dfs1(path[i].fi, path[i].se);
        reverse(all(cur));
      for (int j = 1; j < cur.size(); j++) {
            if (gr[cur[j - 1]][cur[j]] == -1 || gr[cur[j]][cur[j - 1]] == 1) {
                cout << -1;
                return 0;
            }
            gr[cur[j - 1]][cur[j]] = 1;
            gr[cur[j]][cur[j - 1]] = -1;
        }
    }

    vector<int> res(n);

    for (int i = 0; i < n; i++) {
        ans.assign(n, -INT_MAX);
        if (!used[i]) {
            dfs2(i);
            int mi = INT_MAX;
            for (int j = 0; j < n; j++)
                if (ans[j] != -INT_MAX)
                    mi = min(mi, ans[j]);
            for (int j = 0; j < n; j++) {
                if (ans[j] != -INT_MAX) {
                    res[j] = ans[j] - mi + 1;
                }
            }
        }
    }

    int ma = -INT_MAX;
    for (int i = 0; i < n; i++) {
        ma = max(ma, res[i]);
    }
    cout << ma << '\n';
    for (int i = 0; i < n; i++) {
        cout << res[i] << " ";
    }
    return 0;
}

/*
8 2 0
1 2
1 3
3 4
3 5
1 6
6 7
6 8
5 2
8 7
 */