#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<fstream>
///#pragma GCC optimize("Ofast")
#define int long long
#define all(a) a.begin(), a.end()
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e9;
const int K = 20;

int n, m, type;
vector<vector<int>> g;
vector<pair<int, int>> a;
vector<int> h;
vector<int> used;
vector<vector<int>> p;
vector<vector<int>> way;
vector<int> c;

void init() {
    ///ifstream cin(""); ofstream cin("");
    fast_IO();
    cin >> n >> m >> type;
    used.resize(n, 0);
    g.resize(n);
    h.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m; ++i) {
        int ai, bi;
        cin >> ai >> bi;
        ai--; bi--;
        a.push_back({ai, bi});
    }
    way.resize(m);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        p[i].resize(K, -1);
    }
    c.resize(n);
    ///cin.close(); cout.close();
}

void clr() {
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
}

void dfs(int v) {
    p[v][0] = v;
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            h[u] = h[v] + 1;
            p[u][1] = v;
            dfs(u);
        }
    }
}

int get(int u, int v) {
    if (h[u] < h[v]) {
        swap(u, v); /// h[u] > h[v]
    }
    int j;
    for (j = K - 1; j >= 0; --j) {
        if (p[u][j] != -1 && h[p[u][j]] >= h[v]) {
            u = p[u][j];
        }
    }
    for (j = K - 1; j >= 0; --j) {
        if (p[u][j] != -1 && p[v][j] != -1 && p[u][j] != p[v][j]) {
            break;
        }
    }
    j++;
    if (u == v) {
        return u;
    }
    return p[u][j];
}

bool dfs1(int v, int f, int i) {
    used[v] = 1;
    if (v == f) {
        way[i].push_back(v);
        return 1;
    }
    for (int u: g[v]) {
        if (!used[u]) {
            if (dfs1(u, f, i)) {
                way[i].push_back(v);
                return 1;
            }
        }
    }
    return 0;
}

void makeway(int u, int v, int i) {
    bool trash = dfs1(u, v, i);
}

vector<int> ansc;
int ans;

void gen2() {
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                for (int j = 1; j < way[i].size(); ++j) {
                    if (c[way[i][j - 1]] >= c[way[i][j]]) {
                        return;
                    }
                }
            }
            else {
                for (int j = way[i].size() - 1; j > 0; --j) {
                    if (c[way[i][j]] >= c[way[i][j - 1]]) {
                        return;
                    }
                }
            }
        }
        int mc = 0;
        for (int i = 0; i < n; ++i) {
            mc = max(mc, c[i]);
        }
        if (mc < ans) {
            ans = mc;
            for (int i = 0; i < n; ++i) {
                ansc[i] = c[i];
            }
        }
    }
}

void gen1(int i = 0) {
    if (i == n) {
        gen2();
        return;
    }
    for (c[i] = 1; c[i] <= 8; ++c[i]) {
        gen1(i + 1);
    }
}

signed main() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    init();
    ansc.resize(n);
    h[0] = 0;
    dfs(0);
    for (int j = 2; j < K; ++j) {
        for (int i = 0; i < n; ++i) {
            if (p[i][j-1] != -1) {
                p[i][j] = p[p[i][j-1]][j-1];
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        clr();
        makeway(a[i].ft, a[i].sd, i);
        /*
        for (int v: way[i]) {
            cout << v + 1 << " ";
        }
        cout << endl;
        */
    }

    ans = INF;
    gen1();

/*
    for (int i = 0; i < n; ++i) {
        c[i] = ansc[i];
    }
    gen2();
*/

    if (ans == INF) {
        cout << -1;
        return 0;
    }
    cout << ans << endl;
    if (type) {
        for (int i = 0; i < n; ++i) {
            cout << ansc[i] << " ";
        }
    }

    ///cin.close(); cout.close();
    return 0;
}

/*
8 0 0
1 2
2 3
2 5
1 4
4 6
6 7
6 8

4 3 1
1 2
1 3
1 4
2 3
2 4
3 4

*/
