#include <bits/stdc++.h>
//#define int long long
#define double long double
#define l first
#define r second
#define pb push_back
#define pi pair<int, int>
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 2e6 + 3;

vector<int> g[maxn];
pi pth[maxn];
int p[maxn], sp[maxn], sz[maxn], tin[maxn], tout[maxn];
int rvd[maxn];
int ct = 0;

bool cmp(int x, int y) {
    return sz[x] > sz[y];
}

void dfs(int x, int pr = -1) {
    sz[x] = 1; tin[x] = ct++;
    for (auto to : g[x]) {
        if (to == pr) continue;
        dfs(to, x); p[to] = x;
        sz[x] += sz[to];
    }
    tout[x] = ct++;
}

vector<vector<int> > hld;
int cp = 0;

void dfs2(int x) {
    hld[cp].pb(x);
    if (g[x].size() == 1 && g[x][0] == p[x]) {
        ++cp; hld.pb(vector<int>()); return;
    }
    for (auto to : g[x])
        if (to != p[x]) dfs(to);
}

int mx = 0;/*
int sz[4 * maxn], sp[4 * maxn];

int getp(int x) {
    if (sp[x] == -1) return x;
    return (sp[x] = getp(sp[x]));
}

void unions(int x, int y) {
    x = getp(x); y = getp(y);
    if (x == y) return;
    if (sz[x] < sz[y]) swap(x, y);
    if (sz[x] == sz[y]) ++sz[x];
    sp[y] = x;
}

void build(int i, int cl, int cr) {
    int x = mx++;
    if (cr - cl > 1) {
        build(i, cl, (cl + cr) / 2);
    }
}*/

bool isp(int x, int y) {
    return (tin[x] <= tin[y] && tout[y] <= tout[x]);
}

int dp[maxn];

void dfs1(int x, int pr = -1) {
    dp[x] = 1;
    for (auto to : g[x]) {
        if (to == pr) continue;
        if (rvd[x] == 1 && to == p[x] ||
            rvd[to] == 2 && to != p[x]) {
                dfs1(to, x);
                dp[x] = max(dp[x], dp[to] + 1);
        }
    }
}

signed main() {
    int n, m, f; cin >> n >> m >> f;
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        --u; --v; g[u].pb(v); g[v].pb(u);
    }
    for (int i = 0; i < m; i++) {
        cin >> pth[i].l >> pth[i].r;
        --pth[i].l; --pth[i].r;
    }
    dfs(0); int ans = 148814881, am = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
        for (int i = 0; i < n; i++)
            rvd[i] = dp[i] = 0;
        bool bd = 0;
        for (int x = mask, i = 0; i < m; i++, x >>= 1) {
            for (int y = pth[i].l; !isp(y, pth[i].r); y = p[y]) {
                if (rvd[y] != 0 &&
                    rvd[y] != (x % 2) + 1) {
                    bd = 1; break;
                }
                rvd[y] = x % 2 + 1;
            }
            for (int y = pth[i].r; !isp(y, pth[i].l); y = p[y]) {
                if (rvd[y] != 0 &&
                    rvd[y] != (x + 1) % 2 + 1) {
                        bd = 1;
                        break;
                    }
                rvd[y] = (x + 1) % 2 + 1;
            }
        }
        if (bd) continue;
        for (int i = 0; i < n; i++)
            if (dp[i] == 0)
                dfs1(i);
        int mx = 0;
        for (int i = 0; i < n; i++)
            mx = max(mx, dp[i]);
        if (ans > mx) {
            ans = mx;
            am = mask;
        }
    }
    if (ans == 148814881) {
        cout << -1;
        return 0;
    }
    cout << ans << '\n';
    int mask = am;
    for (int i = 0; i < n; i++)
            rvd[i] = dp[i] = 0;
    bool bd = 0;
    for (int x = mask, i = 0; i < m; i++, x >>= 1) {
        for (int y = pth[i].l; !isp(y, pth[i].r); y = p[y]) {
            if (rvd[y] != 0 &&
                rvd[y] != (x % 2) + 1) {
                bd = 1; break;
            }
            rvd[y] = x % 2 + 1;
        }
        for (int y = pth[i].r; !isp(y, pth[i].l); y = p[y]) {
            if (rvd[y] != 0 &&
                rvd[y] != (x + 1) % 2 + 1) {
                    bd = 1;
                    break;
                }
            rvd[y] = (x + 1) % 2 + 1;
        }
    }
    for (int i = 0; i < n; i++)
        if (dp[i] == 0) dfs1(i);
    for (int i = 0; i < n; i++)
        cout << dp[i] << ' ';
    return 0;/*
    for (int i = 0; i < m; i++) {
        int x, y;
        if (!isp(pth[i].l, pth[i].r)) {
            for (x = pth[i].l; !isp(p[x], pth[i].r); x = p[x]) {
                unions(x, p[x]); unions(n + x, n + p[x]);
            }
        }
        if (!isp(pth[i].r, pth[i].l)) {
            for (y = pth[i].r; !isp(p[y], pth[i].l); y = p[y]) {
                unions(y, p[y]); unions(n + y, n + p[y]);
            }
        }
        if (!isp(pth[i].l, pth[i].r) &&
            !isp(pth[i].r, pth[i].l)) {
                unions(x, n + y);
                unions(n + x, y);
            }
    }
    for (int i = 1; i < n; i++)
        if (getp(i) == getp(i + n)) {
            cout << -1;
            return 0;
        }
    for (int i = 1; i < n; i++) {
        if (p[i] == 0 ||
            getp(p[i]) != getp(i)) {

        }
    }*/
    return 0;
}
