#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 20;
int perm[MAX_N], ans[MAX_N], ansmx, mx;
int l[MAX_N], r[MAX_N];
int d[MAX_N], par[MAX_N];
vector<int> g[MAX_N];

void dfs(int x, int p) {
    d[x] = d[p] + 1;
    par[x] = p;
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x);
    }
}

int n, m, t;

void verify() {
    for(int i = 0; i < n; i ++) {chkmax(mx, perm[i]);}
    bool flag = true;
    if(mx >= ansmx) {return;}
    for(int i = 0; i < m; i ++) {
        bool flag1, flag2, flag3, flag4;
        flag1 = flag2 = flag3 = flag4 = true;
        int a = l[i], b = r[i];
        while(a != b) {
            while(d[a] > d[b] || (a != b && d[a] == d[b])) {
                if(perm[par[a] - 1] - perm[a - 1] <= 0) {flag1 = false;}
                if(perm[par[a] - 1] - perm[a - 1] >= 0) {flag2 = false;}
                a = par[a];
            }
            while(d[a] < d[b]) {
                if(perm[par[b] - 1] - perm[b - 1] <= 0) {flag3 = false;}
                if(perm[par[b] - 1] - perm[b - 1] >= 0) {flag4 = false;}
                b = par[b];
            }
        }
        if((flag1 && flag4) || (flag2 && flag3)) {
        } else {
            flag = false;
            break;
        }
    }
    if(flag) {
        if(!t || mx < ansmx) {
            ansmx = mx;
            for(int i = 0; i < n; i ++) {ans[i] = perm[i];}
        }
    }
}

void brute(int j) {
    if(j == n) {
        verify();
        return;
    }
    for(int i = 1; i <= ansmx; i ++) {
        perm[j] = i;
        brute(j + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n >> m >> t;
    ansmx = n;
    for(int i = 0; i < n; i ++) {perm[i] = i + 1;}
    dfs(1, 0);
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 0);
    for(int i = 0; i < m; i ++) {
        cin >> l[i] >> r[i];
    }
    brute(0);
    if(ans[0] == 0) {
        cout << -1 << endl;
    } else {
        cout << ansmx << endl;
        for(int i = 0; i < n; i ++) {
            cout << ans[i] << " ";
        }
    }
    return 0;
}
