#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

int n, m, t;
vector<vector<int>> g;
vector<vector<int>> aaa;

vector<int> create_way(int a, int b) {
	deque<int> buf(1, a);
	vector<int>p(n + 1, -1);
	p[a] = 0;

	while (1) {
		int v = buf.front();
		buf.pop_front();

		for (auto u : g[v]) {
			if (p[u] == -1) {
				p[u] = v;
				buf.push_back(u);
			}
		}

		if (p[b] != -1) break;
	}

	vector<int> kek;
	int now = b;
	while (now) {
		kek.push_back(now);
		now = p[now];
	}
	reverse(kek.begin(), kek.end());
	return kek;
}

vector<unordered_multiset<int>> g1;

bool check(int z) {
	for (int i = 1; i < aaa[z].size(); i++) {
		if (g1[aaa[z][i]].count(aaa[z][i - 1])) {
			return false;
		}
	}

	for (int i = 1; i < aaa[z].size(); i++) {
		g1[aaa[z][i - 1]].insert(aaa[z][i]);
	}

	return true;
}

const int inf = 1e9;
int gaa = inf;
vector<int> ga;

void rec(int z) {
	if (z == m) {
		vector<int> zxc(m);
		iota(zxc.begin(), zxc.end(), 0);

		do {
			bool f = true;
			vector<int> c(n + 1, -1);
			int ans = 0;
			for (auto i : zxc) {
				int st = 1;
				for (int j = 0; j < aaa[i].size(); j++) {
					if (c[aaa[i][j]] != -1) {
						st = c[aaa[i][j]] - j;
					}
				}

				if (st < 1) {
					f = false;
					break;
				}

				for (int j = 0; j < aaa[i].size(); j++) {
					if (c[aaa[i][j]] == -1) {
						c[aaa[i][j]] = st++;
						ans = max(ans, c[aaa[i][j]]);
					}
					else {
						if (c[aaa[i][j]] < st) {
							f = false;
							break;
						}
						else {
							st = c[aaa[i][j]] + 1;
						}
					}
				}
			}

			if (ans < gaa) {
				gaa = ans;
				ga = c;
			}

		} while (next_permutation(zxc.begin(), zxc.end()));

		return;
	}

	if (check(z)) {
		rec(z + 1);
		for (int i = 1; i < aaa[z].size(); i++) {
			g1[aaa[z][i - 1]].erase(aaa[z][i]);
		}
	}

	reverse(aaa[z].begin(), aaa[z].end());
	if (check(z)) {
		rec(z + 1);
		for (int i = 1; i < aaa[z].size(); i++) {
			g1[aaa[z][i - 1]].erase(aaa[z][i]);
		}
	}
	reverse(aaa[z].begin(), aaa[z].end());
}

signed main() {
	kekek;
	cin >> n >> m >> t;
	g.resize(n + 1);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	aaa.resize(m);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		aaa[i] = create_way(a, b);
	}

	g1.resize(n + 1);
	rec(0);

	if (gaa == inf) {
		cout << -1;
	}
	else {
		cout << gaa;
		if (t) {
			cout << '\n';
			for (int i = 1; i <= n; i++) {
				cout << (ga[i] == -1 ? 1 : ga[i]) << " ";
			}
		}
	}

	//system("pause");
	return 0;
}