#include <bits/stdc++.h>
#define fst first
#define snd second
#define pb push_back
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
using namespace std; typedef long long ll; typedef long double ld;

vector<vector<int>> g;
vector<pair<int, int>> ms;
vector<int> c;
vector<vector<int>> getq;
int n, m, t;
mt19937 rnd(time(0));

void dfs(int v, int last, int val){
    c[v] = max(c[v], val);
    if (v == last)
        return;
    dfs(getq[v][last], last, c[v] + 1);
}

bool dfsc(int v, int last, int val = 0){
    if (c[v] <= val)
        return 0;
    if (v == last)
        return 1;
    return dfsc(getq[v][last], last, c[v]);
}

const int inf = 1e9 + 7;

int pred(int v, int last, int p){
    if (last == v)
        return inf;
    for (auto u : g[v]){
        if (u != p){
            if (pred(u, last, v) == inf){
                if (p == -1)
                    return u;
                else
                    return inf;
            }
        }
    }
    return 0;
}

void solve_small(){
    int mask1 = -1;
    int mn = inf;
    getq.resize(n);
    for (int i = 0; i < n; i++)
        getq[i].resize(n);
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++)
            getq[i][j] = pred(i, j, -1);
    }
    for (int mask = 0; mask < (1 << m); mask++){
        for (int i = 0; i < n; i++)
            c[i] = 1;
        for (int i = 0; i < m; i++){
            if ((1 << i) & mask){
                dfs(ms[i].snd, ms[i].fst, 1);
            }else{
                dfs(ms[i].fst, ms[i].snd, 1);
            }
        }
        bool bl = 1;
        for (int i = 0; i < m; i++){
            if ((1 << i) & mask){
                if (!dfsc(ms[i].snd, ms[i].fst)){
                    bl = 0;
                }
            }else{
                if (!dfsc(ms[i].fst, ms[i].snd)){
                    bl = 0;
                }
            }
        }
        if (bl){
            int now = 0;
            for (int i = 0; i < n; i++)
                now = max(now, c[i]);
            if (now < mn){
                mask1 = mask;
                mn = now;
            }
        }
    }
    if (mask1 == -1){
        cout << -1 << endl;
    }else{
        int mask = mask1;
        for (int i = 0; i < n; i++)
            c[i] = 1;
        for (int i = 0; i < m; i++){
            if ((1 << i) & mask){
                dfs(ms[i].snd, ms[i].fst, 1);
            }else{
                dfs(ms[i].fst, ms[i].snd, 1);
            }
        }
        bool bl = 1;
        for (int i = 0; i < m; i++){
            if ((1 << i) & mask){
                if (!dfsc(ms[i].snd, ms[i].fst, 1)){
                    bl = 0;
                }
            }else{
                if (!dfsc(ms[i].fst, ms[i].snd, 1)){
                    bl = 0;
                }
            }
        }
        cout << mn << endl;
        for (int i = 0; i < n; i++)
            cout << c[i] << ' ';
        cout << endl;
    }
}

void solve_big(){
    string mask1 = "-1";
    int mn = inf;
    getq.resize(n);
    for (int i = 0; i < n; i++)
        getq[i].resize(n);
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++)
            getq[i][j] = pred(i, j, -1);
    }
    for (int k = 0; k < 3000; k++){
        string mask = "";
        for (int i = 0; i < n; i++){
            mask.pb(char(rnd() % 2 + (int) '0'));
        }
        for (int i = 0; i < n; i++)
            c[i] = 1;
        for (int i = 0; i < m; i++){
            if (mask[i] == '1'){
                dfs(ms[i].snd, ms[i].fst, 1);
            }else{
                dfs(ms[i].fst, ms[i].snd, 1);
            }
        }
        bool bl = 1;
        for (int i = 0; i < m; i++){
            if (mask[i] == '1'){
                if (!dfsc(ms[i].snd, ms[i].fst)){
                    bl = 0;
                }
            }else{
                if (!dfsc(ms[i].fst, ms[i].snd)){
                    bl = 0;
                }
            }
        }
        if (bl){
            int now = 0;
            for (int i = 0; i < n; i++)
                now = max(now, c[i]);
            if (now < mn){
                mask1 = mask;
                mn = now;
            }
        }
    }
    if (mask1 == "-1"){
        cout << -1 << endl;
    }else{
        string mask = mask1;
        for (int i = 0; i < n; i++)
            c[i] = 1;
        for (int i = 0; i < m; i++){
            if (mask[i] == '1'){
                dfs(ms[i].snd, ms[i].fst, 1);
            }else{
                dfs(ms[i].fst, ms[i].snd, 1);
            }
        }
        bool bl = 1;
        for (int i = 0; i < m; i++){
            if (mask[i] == '1'){
                if (!dfsc(ms[i].snd, ms[i].fst, 1)){
                    bl = 0;
                }
            }else{
                if (!dfsc(ms[i].fst, ms[i].snd, 1)){
                    bl = 0;
                }
            }
        }
        cout << mn << endl;
        for (int i = 0; i < n; i++)
            cout << c[i] << ' ';
        cout << endl;
    }
}

void solve(){
    int a, b;
    cin >> n >> m >> t;
    g.resize(n);
    c.resize(n);
    ms.resize(m);
    for (int i = 0; i < n - 1; i++){
        cin >> a >> b; a--; b--;
        g[a].pb(b); g[b].pb(a);
    }
    for (int i = 0; i < m; i++){
        cin >> ms[i].fst >> ms[i].snd; ms[i].fst--; ms[i].snd--;
    }
    if (n <= 15 && m <= 15){
       solve_small();
    }else{
        solve_big();
    }
}

signed main() {
    ios;
    int t = 1;
    while(t--)
        solve();
    return 0;
}
