#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > g;
//vector<vector<int> > gn;
vector<vector<int> > r;
int n, m, t;
vector<int> used;
vector<int> time_in;
vector<int> time_out;
vector<pair<int, int>> checker;
vector<int> price;
int tim;
int chch = 0;

void dfs(int v){
    time_in[v] = tim;
    tim++;
    used[v] = 1;
    for (auto to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    time_out[v] = tim;
    tim++;
}

void dfs_new(int v){
    used[v] = 1;
    //cout << v << endl;
    for (int i = 1; i < n + 1; ++i) {
        if (r[v][i] == 1 && !used[i]) {
            price[i] = price[v] + 1;
            dfs_new(i);
        }
        if (r[i][v] == 1 && !used[i]) {
            price[i] = price[v] - 1;
            dfs_new(i);
        }
    }
}

int check(int v1, int v2) {
    if (time_in[v1] <= time_in[v2] && time_out[v1] >= time_out[v2]) {
        return 1;
    }
    return 0;
}

void put(int v, int a, int b) {
    if (a == 0) {
        if (b != v) {
            for (auto to: g[v]) {
                if (check(to, b) && !check(to, v)) {
                    checker.push_back(make_pair(v, to));
                    put(to, a, b);
                }
            }
        }
    }
    if (b == 0) {
        if (a != v) {
            for (auto to: g[v]) {
                if (check(to, a) && !check(to, v)) {
                    checker.push_back(make_pair(to, v));
                    put(to, a, b);
                }
            }
        }
    }
    if (a != 0 && b != 0) {
        for (auto to: g[v]) {
            if (check(to, a) && check(to, b) && !check(to, v)) {
                put(to, a, b);
            }
            if (check(to, a) && !check(to, b) && !check(to, v)) {
                checker.push_back(make_pair(to, v));
                put(to, a, 0);
            }
            if (!check(to, a) && check(to, b) && !check(to, v)) {
                checker.push_back(make_pair(v, to));
                put(to, 0, b);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> t;
    g.resize(n + 1);
    //vector<pair<int, int>> reb;
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
        //reb.push_back(make_pair(u, v));
    }
    used.resize(n + 1);
    time_in.resize(n + 1);
    time_out.resize(n + 1);
    dfs(1);
    //vector<pair<int, int> > vet;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if (check(a, b)) {
            put(a, 0, b);
        }
        if (check(b, a)) {
            put(b, a, 0);
        }
        if (!check(a, b) && !check(b, a)) {
            put(1, a, b);
        }
    }
    //for (auto i: checker) {
        //cout << i.first << " " << i.second << endl;
    //}
    r.resize(n+1);
    for (int i = 0; i < n + 1; ++i) {
        r[i].resize(n + 1);
    }
    for (auto i: checker) {
        r[i.first][i.second] = 1;
        if (r[i.second][i.first] == 1) {
            chch = 1;
            break;
        }
    }
    //for (auto vec: r) {
        //for (auto to: vec) {
            //cout << to << " ";
        //}
        //cout << endl;
    //}
    if (chch == 1) {
        cout << -1;
    }
    else {
        //gn.resize(n + 1);
        //for (auto i: checker) {
            //gn[i.first].push_back(i.second);
        //}
        for (int i = 0; i < n + 1; ++i) {
            used[i] = 0;
        }
        price.resize(n + 1);
        for (int i = 1; i < n + 1; ++i) {
            if (!used[i]) {
                price[i] = 10000 * i;
                dfs_new(i);
            }
        }
        //for (auto p: price) {
            //cout << p << " ";
        //}
        for (int i = 1; i < n + 1; ++i) {
            int maxx = 0;
            for (int j = 1; j < n + 1; ++j) {
                if (price[j] >= 10000 * i - 1000 && price[j] <= 10000 * i + 1000) {
                    maxx = max(maxx, 10000 * i - price[j]);
                }
            }
            for (int j = 1; j < n + 1; ++j) {
                if (price[j] >= 10000 * i - 1000 && price[j] <= 10000 * i + 1000) {
                    price[j] = price[j] + maxx - 10000 * i + 1;
                }
            }
        }
        int maxxx = 0;
        for (auto p: price) {
            maxxx = max(p, maxxx);
        }
        cout << maxxx << endl;
        if (t == 1) {
            for (int i = 1; i < n + 1; ++i) {
                cout << price[i] << " ";
            }
        }
    }
}
