#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, m, ga = 1e9;
vector <pair <ll, ll>> gr;
vector <vector <ll>> ap;
vector <ll> p, otv, ans, oi;
vector <bool> u;
vector <pair <ll, ll>> am;

bool dfs(ll v, ll f) {
    u[v] = true;
    for (ll i = 0; i < n - 1; i++) {
        if (!u[gr[i].second] && oi[i] == 1 && gr[i].first == v) {
            if (gr[i].second == f)
                return true;
            return dfs(gr[i].second, f);
        } else if (!u[gr[i].first] && oi[i] == 2 && gr[i].second == v) {
            if (gr[i].first == f)
                return true;
            return dfs(gr[i].first, f);
        }
    }
    return false;
}

bool check() {
    for (ll i = 0; i < m; i++) {
        ll a = am[i].first, b = am[i].second;
        u.assign(n, false);
        if (!dfs(a, b) && !dfs(b, a))
            return false;
    }
    return true;
}

ll solve(ll i) {
    if (i == n - 1) {
        if (check()) {
            ans[0] = 1;
            for (ll i = 0; i < n; i++) {
                for (ll j = 0; j < n - 1; j++) {
                    if (oi[j] == 1 && gr[j].first <= i)
                        ans[gr[j].second] = ans[i] + 1;
                    else if (oi[j] == 2 && gr[j].first <= i)
                        ans[gr[j].second] = ans[i] - 1;
                    else if (oi[j] == 1 && gr[j].second <= i)
                        ans[gr[j].first] = ans[i] - 1;
                    else if (oi[j] == 2 && gr[j].second <= i)
                        ans[gr[j].first] = ans[i] + 1;
                }
            }
            ll mi = 1e7;
            for (ll i = 0; i < n; i++)
                if (ans[i] <= 0 && ans[i] < mi)
                    mi = ans[i];
            return abs(mi) + 1 + *max_element(ans.begin(), ans.end());
        }
        else return 1e9;
    }
    oi[i] = 1;
    ll t1 = solve(i + 1);
    if (t1 < ga) {
        ga = t1;
        otv = ans;
    }
    oi[i] = 2;
    solve(i + 1);
    if (t1 < ga) {
        ga = t1;
        otv = ans;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t;
    cin >> n >> m >> t;
    gr.resize(n - 1);
    u.resize(n);
    oi.resize(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        gr.push_back({ a, b });
    }
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        am.push_back({ a, b });
    }
    solve(0);
    if (ga == 1e9) {
        cout << -1;
        return 0;
    }
    cout << ga << '\n';
    if (t == 1) {
        ll mi = 1e7;
        for (ll i = 0; i < n; i++)
            if (ans[i] <= 0 && ans[i] < mi)
                mi = ans[i];
        for (ll i = 0; i < n; i++)
            cout << ma + otv[i] + 1 << " ";
    }
    return 0;
}