#include<bits/stdc++.h>
using namespace std;
#define int long long
#define app push_back
#define all(a) a.begin(), a.end()
#define f first
#define s second
#define bp builtin_popcount
#define ll long long
#define ii pair <int, int>
#define mp make_pair
const int N = 107, LG = 20;
int n, m, t;
vector <int> g[N];
int tin[N], tout[N], timer = 0;
int to[N][LG];
void dfs(int u, int p) {
    to[u][0] = p;
    for (int i = 1; i < LG; ++i)
        to[u][i] = to[to[u][i - 1]][i - 1];
    tin[u] = timer++;
    for (int v : g[u])
        if (v != p)
            dfs(v, u);
    tout[u] = timer++;                        
}   
bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}   
int lca(int u, int v) {
    if (anc(u, v))
        return u;
    for (int i = LG - 1; i >= 0; --i)
        if (!anc(to[u][i], v))  
            u = to[u][i];
    return to[u][0];
}   
int a[N], b[N], l[N];
bool type[N], used[N];

int h[N];
vector <int> dag[N];
bool dag_used[N];
void jfs(int u) {
    dag_used[u] = 1;
    h[u] = 1;
    for (int v : dag[u]) {
        if (!dag_used[v])
            jfs(v);
        h[u] = max(h[u], h[v] + 1);
    }   
}   

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].app(v);
        g[v].app(u);
    }
    dfs(1, 1);   
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i];
        l[i] = lca(a[i], b[i]);
        int u = a[i];
        while (u != l[i]) {
            type[u] = 0;
            used[u] = 1;
            u = to[u][0];
        }   
        u = b[i];
        while (u != l[i]) {
            type[u] = 1;
            used[u] = 1;
            u = to[u][0];
        }   
    }   
    int ans = N;
    vector <int> ar;
        for (int i = 0; i < N; ++i)
            dag[i].clear();
        for (int u = 2; u <= n; ++u) {
            if (used[u]) {
                if (type[u])
                    dag[to[u][0]].app(u);
                else
                    dag[u].app(to[u][0]);
            }   
        }
        memset(dag_used, 0, sizeof dag_used);
        for (int u = 1; u <= n; ++u)
            if (!dag_used[u])
                jfs(u);   
    int mx = 0;
    for (int i = 1; i <= n; ++i)
        mx = max(mx, h[i]);
    cout << mx << endl;
    for (int i = 1; i <= n; ++i)
        cout << h[i] << ' ';
    cout << endl;
}   